<?php
// +----------------------------------------------------------------------+
// | survey pilot                                                         |
// +----------------------------------------------------------------------+
// | Copyright (c) 2002 serie a - Digitale Medien und Systeme GmbH        |
// +----------------------------------------------------------------------+
// | Authors: 	Daniel Peer <peer@serie-a.de>                             |
// +----------------------------------------------------------------------+
//
// $Id: lang.output.php,v 1.1.1.1 2004/07/15 13:25:31 opensurveypilot Exp $

// start session
@session_start();

// require all configuration files and libraries
require_once("./../config/config.inc.php"); // common config file
require_once($cfgPathToConf."/file.inc.php"); // project files
require_once($cfgPathToLib."/common.inc.php"); // common functions
require_once($cfgPathToAuthFiles."/lib/user.inc.php"); // auth user functions
require_once($cfgPathToLangFiles."/config/lang.file.inc.php"); // language files
require_once($cfgPathToLangFiles."/lib/languagefunctions.inc.php"); 
require_once($cfgPathToAuthFiles."/config/auth.file.inc.php"); // auth user functions
require_once("HTML/Template/IT.php"); // PEAR::HTML_TEMPLATE_IT

$lf = new languageFunctions();

// create new userFunctions object
$client = &new userFunctions;

//login check
if ($client->getAuthentication($_SESSION["sessionId"], session_id()) ==  false)
{
    //redirect to login page
    ?>
    <script type="text/javascript">
    <!--
    window.location.href="<?php echo $cfgUrlToProject."/".$fileAuthLogin; ?>";
    -->
    </script>
    <?php
    exit;
}

if($_SERVER["REQUEST_METHOD"] == "POST")
{
	$pieces = explode (".", $_POST["installedlangs"]);

	$file = $pieces[0];
	$type = $pieces[1];

	$lf->delInstalledLanguage($type, $file);
}

// create Template IT object
$tpl = new HTML_Template_IT($cfgPathToLangTemplates);

// load template
$tpl->loadTemplatefile($templateLangOutput, true, true);

$installedLanguages = $lf->getInstalledLanguages();
$installedFiles = $lf->getInstalledLanguageFiles();

$tpl->setVariable( "headline", $lang_script["lang.output.php"]["languageStatus"] );

for ($i=0;$i<count($installedFiles);$i++)
{
	$tpl->setCurrentBlock("installedfiles") ;
	$tpl->setVariable( "installedfiles_selected", "" );
	$tpl->setVariable( "installedfiles_name", $installedFiles[$i]);
	$tpl->setVariable( "installedfiles_value", $installedFiles[$i]);
	$tpl->parseCurrentBlock("installedfiles");
}


for ($i=0;$i<count($installedLanguages);$i++)
{
	$tpl->setCurrentBlock("installedlangs") ;
	$tpl->setVariable( "installedlangs_selected", "" );
	$tpl->setVariable( "installedlangs_name", $installedLanguages[$i][LANGUAGE_FILE]." (".$installedLanguages[$i][LANGUAGE_TYPE].")");
	$tpl->setVariable( "installedlangs_value", $installedLanguages[$i][LANGUAGE_FILE].".".$installedLanguages[$i][LANGUAGE_TYPE]);
	$tpl->parseCurrentBlock("installedlangs");
}

// set title
$tpl->setVariable( "applicationtitle", $cfgApplicationType.$cfgApplicationVersion);

// get the parsed template and print it
$tpl->get();
$tpl->show();


?>
