<?php
// +----------------------------------------------------------------------+
// | survey pilot                                                         |
// +----------------------------------------------------------------------+
// | Copyright (c) 2004 serie a - Digitale Medien und Systeme GmbH        |
// +----------------------------------------------------------------------+
// | Authors: Daniel Peer <peer@serie-a.de>                               |
// +----------------------------------------------------------------------+
// | Description:                                                         |
// +----------------------------------------------------------------------+
//
// $Id: languagefunctions.inc.php,v 1.1.1.1 2004/07/15 13:25:34 opensurveypilot Exp $

// start session
@session_start();

// require all configuration files and libraries
require_once($cfgPathToProjectAdmin."/config/config.inc.php"); // common config file // common config file
require_once ("DB.php"); // PEAR::DB

/**
* languageFunctions class
*
* @author  Daniel Peer <peer@serie-a.de>
* @access  public
*/

class languageFunctions
{
    /**
    *	handle for db connection
    *	@var    string  $db
    */
    var $db = "";
    
    /**
    *	handle for logging
    *	@var    string  $this->log
    */
    var $log = array();
    
    /**
    *	error message
    *	@var    string  $errorMessage
    */
    var $errorMessage;
    

    var $comlete_lang_file;
    var $script_lang_file;
    var $template_lang_file;
    
    var $language_full;
    var $language_short;
    
    
    /**
    *	constructor 
    *
    *	@access	private
    */
    function languageFunctions()
    {
        $this->errorMessage = "";
        // connect to db
        $this->db = DB::connect(DSN, true);
        if (DB::isError($this->db)) 
        {    
           $this->setErrorMessage($db->getMessage());
        }
    }
    
    /**
    *	sets error message
    *
    *	@access	private
    *	@param	string	$err
    */
    function setErrorMessage($err)
    {
        $this->errorMessage = $err;
    }
    
    function parseModule ($modules, $subdir, $includefile)
    {
	global $lang_script;
	global $globalCfgPathToProject;
	
	include $includefile;
	
	for ($i=0; $i<count ($modules);$i++)
	{
		$temp = $globalCfgPathToProject."/".$modules[$i]."/templates";
		
		array_push ($this->log, $lang_script["languagefunctions.inc.php"]["checkExistanceOf"]." ".$temp."/".$subdir);
		
		if (!is_dir($temp."/".$subdir))
		{
			array_push ($this->log, $lang_script["languagefunctions.inc.php"]["creatingDirectory"]." ".$temp."/".$subdir);
			mkdir ($temp."/".$subdir);
			
		}
		
		array_push ($this->log, $lang_script["languagefunctions.inc.php"]["openTemplateDirectory"].": ".$temp);
		
		$dir= opendir($temp);
		
		    while($file = readdir($dir))
		    {     
			if ($file != "." && $file != ".." && $file != "CVS" && !is_dir($temp."/".$file))
			{			
				array_push ($this->log, $lang_script["languagefunctions.inc.php"]["readingFile"].": ".$file);
				
				$handle = fopen ($temp."/".$file, "r");
				$contents = fread ($handle, filesize ($temp."/".$file));
				fclose ($handle);
				
				if (is_array($lang_tmpl[$file]))
				{			
					foreach ($lang_tmpl[$file] as $key => $value)
					{
						array_push ($this->log, $lang_script["languagefunctions.inc.php"]["parsingVariable"]." <span style='color:green'>$key</span> ".$lang_script["languagefunctions.inc.php"]["to"]." <span style='color:blue'>$value</span> ".$lang_script["languagefunctions.inc.php"]["inFile"]." ".$file);						
						$contents = str_replace ( "||".$key."||", $value, $contents);
					}
				}
				else
				{
					array_push ($this->log, $lang_script["languagefunctions.inc.php"]["warning"].": <span style='color:red'>".$lang_script["languagefunctions.inc.php"]["noValuesFor"]." ".$file."</span>");
				}
				
				$handle = fopen ($temp."/".$subdir."/".$file, "w+");
				
				if (!fwrite($handle, $contents)) 
				{
					array_push ($this->log, $lang_script["languagefunctions.inc.php"]["error"].": <span style='color:red'>".$lang_script["languagefunctions.inc.php"]["cannotWriteFile"]." ".$temp."/".$subdir."/".$file."</span><hr>");
				}
				else
				{
					array_push ($this->log, $lang_script["languagefunctions.inc.php"]["writingFile"].": <span style='color:gray'>".$temp."/".$subdir."/".$file."</span><hr>");
				}
				
				fclose ($handle);
				
			}
		    }
		closedir($dir); 
	}
    }
    
    function printLog()
    {
	return implode("<br>", $this->log);
    }
    
    function getInstalledLanguages()
    {
	global $cfgTabAuthLanguage;

       	$sql = "select * from $cfgTabAuthLanguage";
	$result = $this->db->query($sql);
	
       	if (DB::isError($result)) 
       	{
          	    $this->setErrorMessage($sql."  ".$result->getMessage());
          	    return false;
      	}
	// get rows
       	while ($row = $result->fetchRow(DB_FETCHMODE_ASSOC))
        {
               $getData[] = $row;
        }
        
		return $getData;
    }
    
    function addInstalledLanguage($type, $file)
    {
	global $lang_script;
	global $cfgTabAuthLanguage;

	$sql = "select * from $cfgTabAuthLanguage where LANGUAGE_TYPE='$type'";
	$result = $this->db->query($sql);
	$num = $result->numRows();
	if ($num<1)
	{
		$sql = "insert into $cfgTabAuthLanguage (LANGUAGE_TYPE, LANGUAGE_FILE) values ('$type','$file')";
		$result = $this->db->query($sql);

		if (DB::isError($result))
		{
			    array_push ($this->log,$sql."  ".$result->getMessage());
			    return false;
		}
	}
	array_push ($this->log, $lang_script["languagefunctions.inc.php"]["langSaveSuccessMessage"].": ".$file );

	return true;
    }

	function delInstalledLanguage($type, $file)
    {
		global $cfgPathToConf;
		global $lang_script;
		global $cfgTabAuthLanguage;

		$todelete1 = $cfgPathToConf."/lang/global/".$file.".".$type.".lang.php";
		$todelete2 = $cfgPathToConf."/lang/".$file.".script.inc.php";
		$todelete3 = $cfgPathToConf."/lang/".$file.".tmpl.inc.php";

		$sql = "delete from $cfgTabAuthLanguage where LANGUAGE_TYPE='$type' and LANGUAGE_FILE='$file'";
		$result = $this->db->query($sql);
		if (DB::isError($result))
		{
				array_push ($this->log,$sql."  ".$result->getMessage());
				return false;
		}

		if (!unlink($todelete1)) {
			array_push ($this->log, "deletion of $todelete1 failed!");
			return false;
			}
		if (!unlink($todelete2)){
			array_push ($this->log, "deletion of $todelete2 failed!");
			return false;
			}
		if (!unlink($todelete3)){
			array_push ($this->log, "deletion of $todelete3 failed!");
			return false;
			}

		return true;
    }

    
    function getInstalledLanguageFiles()
    {
	global $cfgPathToConf;
	$dir= opendir($cfgPathToConf."/lang/global");
	$i=0;	
	while($file = readdir($dir)) 
	{     
		if ($file != "." && $file != ".." && $file != "CVS" && !is_dir($temp."/".$file))
		{			
			$files[$i] = $file;
			$i++;
		}
	}   

	return $files;
    }
    
    function uploadLangfile()
    {
	global $lang_script;
	global $cfgPathToConf;
	
	$uploaddir = $cfgPathToConf."/lang/global/";

	$uploadfile = $uploaddir.$_FILES['langfile']['name'];

	if (move_uploaded_file($_FILES['langfile']['tmp_name'], $uploadfile)) 
	{
		array_push ($this->log, $lang_script["languagefunctions.inc.php"]["uploadSuccessMessage"] );
		return true;
	} 
	else 
	{
		array_push ($this->log, $lang_script["languagefunctions.inc.php"]["uploadErrorMessage"] );
		return false;
	}
    }
    
    function validateLangfile()
    {
	$file = $_FILES['langfile']['name'];
	$pieces = explode (".", $file);	

	if (count ($pieces) == 4 && $pieces[2]=="lang" && $pieces[3]=="php") 
	{
		return true;
	} 
	else 
	{
		array_push ($this->log, $lang_script["languagefunctions.inc.php"]["file"]." ".$file," ".$lang_script["languagefunctions.inc.php"]["isNotNamedProperly"] );
		return false;
	}
    }
    
    function splitLangfile ($globalfile)
    {
	global $lang_script;
	global $cfgPathToConf;
	
	$pieces = explode (".", $globalfile);
	
	$splitfile = $cfgPathToConf."/lang/global/".$globalfile;
	
	$handle = fopen ($splitfile, "r");
	$contents = fread ($handle, filesize ($splitfile));
	fclose ($handle);
	
	$contentArray = explode ( "||||||||||||||||||||", $contents);
	
	$handle = fopen ($cfgPathToConf."/lang/".$pieces[0].".script.inc.php", "w+");
					
	if (!fwrite($handle, $contentArray[0])) 
	{
		array_push ($this->log, $lang_script["languagefunctions.inc.php"]["error"].": <span style='color:red'>".$lang_script["languagefunctions.inc.php"]["cannotWriteFile"]." ".$cfgPathToConf."/lang/".$pieces[0].".script.inc.php</span>");
		return false;
	}
	else
	{
		array_push ($this->log, $lang_script["languagefunctions.inc.php"]["writingFile"].": <span style='color:gray'>".$cfgPathToConf."/lang/".$pieces[0].".script.inc.php</span>");
	}
	
	fclose ($handle);
	
	$handle = fopen ($cfgPathToConf."/lang/".$pieces[0].".tmpl.inc.php", "w+");
					
	if (!fwrite($handle, $contentArray[1])) 
	{
		array_push ($this->log, $lang_script["languagefunctions.inc.php"]["error"].": <span style='color:red'>".$lang_script["languagefunctions.inc.php"]["cannotWriteFile"]." ".$cfgPathToConf."/lang/".$pieces[0].".tmpl.inc.php</span>");
		return false;
	}
	else
	{
		array_push ($this->log, $lang_script["languagefunctions.inc.php"]["writingFile"].": <span style='color:gray'>".$cfgPathToConf."/lang/".$pieces[0].".tmpl.inc.php</span>");
	}
	
	fclose ($handle);
	
	return true;
	
    }
}
