<?php
// +----------------------------------------------------------------------+
// | sa project pilot- common functions                                   |
// +----------------------------------------------------------------------+
// | Copyright (c) 2002 serie a - Digitale Medien und Systeme GmbH        |
// +----------------------------------------------------------------------+
// | Authors: Jrn Allert <allert@serie-a.de>                             |
// |          Rene Renk <renk@serie-a.de>                                 |
// +----------------------------------------------------------------------+
//
// $Id: common.inc.php,v 1.2 2007/01/03 10:06:06 easy_israel Exp $

function cleanHtml($string)
{
    // trim whitespace at beginning an end of string
    $clean_string = trim($string);
    // delete all tags inclusive content
    $clean_string =	stripslashes(ereg_replace("<[^>]+>", "", $clean_string));
    // delete "
	$clean_string =	(ereg_replace('"','', $clean_string));
    // delete '
	$clean_string =	(ereg_replace("'","", $clean_string));
	return $clean_string;
}

function checkValidSession($php_session_id)
{
    $passes = true;
    
    // saved session id must be uqual to session_id()
	if ($php_session_id != session_id())
	{
		$passed=false;
	}
    // saved ip must be equal to user ip
    if ($_SESSION["REMOTE_ADDR"] != $_SERVER["REMOTE_ADDR"]) 
    {
       $passed=false;
    }
    
    // Eine Session kann nur 'legal' durch uns verlinkt worden sein,
    // daher muss der Referrer unseren Servernamen beinhalten
    if (strpos($_SERVER["HTTP_REFERER"],$_SERVER["HTTP_HOST"]) === false) 
    {
       $passed=false;
    }
    
	if (!$passed)
	{
		return false;
	}
    
    return true;
}

/**
*
*	procedural function
*
*	returns a array with values for second, minute, hour, day, month, year and timestamp.
*   Format can be 'dd.mm.yy' or 'dd.mm.yy hh:mm'.
*
*	@access	  public
*	@param	 string 	$date       date
* 	@return  array      returns array with second, minute, hour, day, month, year and timestamp.
*/
function getTimestamp($dateTime)
{
    global $lang_script;
    if(preg_match("/^[0-9]{2}\.[0-9]{2}\.[0-9]{2} [0-9]{2}:[0-9]{2}$/", $dateTime))
    {
        $datetimeArray = explode(" ",$dateTime);
        $dateArray = explode(".",$datetimeArray[0]);
        $timeArray = explode(":",$datetimeArray[1]);
    }
    elseif(preg_match("/^[0-9]{1,2}\.[0-9]{1,2}\.[0-9]{2,4}$/", $dateTime))
    {
        $dateArray = explode(".",$dateTime);
		if(!checkdate( $dateArray[1], $dateArray[0], $dateArray[2]))
		{
			return $lang_script["common.inc.php"]["dateError"];
		}
    }
    else
    {
        return $lang_script["common.inc.php"]["formatError"];
    }

    //build return array
    $returnArray["year"] = $dateArray[2];
    $returnArray["month"] = $dateArray[1];
    $returnArray["day"] = $dateArray[0];
    $returnArray["hour"] = $timeArray[0];
    $returnArray["minute"] = $timeArray[1];
    $returnArray["timestamp"] = mktime($timeArray[0],$timeArray[1],0,$dateArray[1],$dateArray[0],$dateArray[2]);
    return $returnArray;
}

function getInstalledLanguages()
{
	$db = DB::connect(DSN, true);
	if(PEAR::isError($db))
	  { 
		return $db; 
	    }
	

	global $cfgTabAuthLanguage;

	$sql = "SELECT * FROM $cfgTabAuthLanguage ";

	$result = $db->query($sql);

	if (DB::isError($result)) 
    {
       	return new PEAR_Error("DB ERROR in createUsermask(): ".$result->getMessage()."in".__FILE__." on line ".__LINE__."with-------------$sql------------- ");
    }
    
    
    $i = 0;
    while ($row = $result->fetchRow(DB_FETCHMODE_ASSOC))
    {
           $getData[$i] = $row['LANGUAGE_FILE'];
	   $i++;
    }
    
	return $getData;
}

function phpnum() {
$version = explode('.', phpversion());
return (int) $version[0];
}
function is_php5() { return phpnum() == 5; }
function is_php4() { return phpnum() == 4; }
?>
