<?php
// +----------------------------------------------------------------------+
// | mediafile module - upload functions		                          |
// +----------------------------------------------------------------------+
// | Copyright (c) 2002 serie a - Digitale Medien und Systeme GmbH        |
// +----------------------------------------------------------------------+
// | Authors: Jrn Allert <allert@serie-a.de>                             |
// |          Rene Renk <renk@serie-a.de>                                 |
// +----------------------------------------------------------------------+
// | Description: specific functions for upload / using pear upload       |
// +----------------------------------------------------------------------+
//
// $Id: mediafile.upload.inc.php,v 1.1.1.1 2004/07/15 13:29:34 opensurveypilot Exp $

// required configuration files and libraries
require_once($cfgPathToProjectAdmin."/config/config.inc.php"); // common config file // common config file
require_once("HTTP/Upload.php"); //Pear Uploadclass to be extended

/**
*  Upload Functions class
*
* @author  Jrn Allert <allert@serie-a.de>
* @author  Rene Renk <renk@serie-a.de>
* @access  public
*/
class mediafileUploadFunctions
{
    /**
    *	error message
    *	@var    string  $errorMessage
    */
    var $errorMessage;

    /**
    *	HTTP_Upload object
    *	@object object  $upload
    */
    var $upload;

    /**
    *	basic uploaddir
    *	@var string   $pathToOutputTmpl
    */
    var $pathToMediafileOutput;

	/**
    *	sets error message
    *
    *	@access	private
    *	@param	string	$err
    */
    function setErrorMessage($err)
    {
        $this->errorMessage = $err;
    }
	
    /**
    *	Constructor
	*
	*	Creates new Upload Functions Object
    *
    *	@access	public
    */
    function mediafileUploadFunctions()
    {
		// upload object errors in german
		$this->upload = &new HTTP_Upload('de');
		// set basic uploaddir
	}
	
    /**
    *	uploads files by array of references
	*
	*	Creates new Upload Functions Object
    *
    *	@access	public
    */
    function mediafileUploadFiles($uploadDir, $fileToUpload)
    {
		// get file to upload
		$file = $this->upload->getFiles($fileToUpload); // return a file object or error
		// set valid extension
		$file->_extensions_mode = "deny"; 
        
        $fileExtensions = array('avi', 'bmp', 'xls', 'swf', 'gif', 'jpg', 'jpeg', 'pdf', 'ppt', 
                            'png', 'tif', 'doc', 'mov', 'rm', 'waf', 'txt', 'xml', 'html', 'wmf', 
                            'gzip', 'zip', 'rar', 'hqx', 'psd');
        
        $file->setValidExtensions($fileExtensions, 'accept');
        
        if (PEAR::isError($file)) 
		{    
			$uploadData	 			= $file->getProp();
			$uploadData["error"]	= $file_name->getMessage();
			return $uploadData;
		}
		// Check if the file is a valid upload
		if ($file->isValid()) 
		{    
			$file->setName('safe');
			$properties = $file->getProp();
			$file_name = $file->moveTo($uploadDir);
			if (PEAR::isError($file_name)) 
            {
            	$uploadData	 			= $file->getProp();
            	$uploadData["error"]	= $file_name->getMessage();
            	return $uploadData;
            }
		}
		$uploadData	 =	$file->getProp();
		//
		return $uploadData;
	}
}
?>