<?php
// +----------------------------------------------------------------------+
// | survey pilot                                                         |
// +----------------------------------------------------------------------+
// | Copyright (c) 2002 serie a - Digitale Medien und Systeme GmbH        |
// +----------------------------------------------------------------------+
// | Authors: 	Jrn Allert <allert@serie-a.de>                           |
// |          	Rene Renk   <renk@serie-a.de>                             |
// +----------------------------------------------------------------------+
//
// $Id: mediafile.add.php,v 1.1.1.1 2004/07/15 13:29:28 opensurveypilot Exp $

// start session
@session_start();

// require all configuration files and libraries
require_once("./../config/config.inc.php"); // common config file
require_once ("Validate.php"); // PEAR::Validate (must be included before common config file)
require_once($cfgPathToConf."/file.inc.php"); // project files
require_once($cfgPathToLib."/common.inc.php"); // common functions
require_once($cfgPathToAuthFiles."/config/auth.file.inc.php"); // auth files
require_once($cfgPathToAuthFiles."/lib/user.inc.php"); // auth user functions
require_once($cfgPathToAuthFiles."/lib/permission.inc.php"); // permission functions
require_once($cfgPathToMediafileFiles."/config/mediafile.file.inc.php"); // mediafile files
require_once($cfgPathToMediafileFiles."/lib/mediafile.inc.php"); // mediafile category functions
require_once("HTML/Template/IT.php"); // PEAR::HTML_TEMPLATE_IT
 
// create new userFunctions object
$client = &new userFunctions;

//login check
if ($client->getAuthentication($_SESSION["sessionId"], session_id()) ==  false)
{
    //redirect to login page
    ?>
    <script type="text/javascript">
    <!--
    window.location.href="<?php echo $cfgUrlToProject."/".$fileAuthLogin; ?>";
    -->
    </script>
    <?php
    exit;
}

// function permission check
if($_SESSION["sessionUserStatusId"] < $permMediafileAdd)
{
    ?>
    <script type="text/javascript">
    <!--
    window.location.href="<?php echo $cfgUrlToProject."/".$fileNoPermission."?messageCode=2"; ?>";
    -->
    </script>
    <?php
    exit;
}

$mediafile = &new mediafileFunctions;

if($_GET["parentId"])
{
	$groupId = $_GET["parentId"];
}
elseif($_POST["groupId"])
{
	$groupId = $_POST["groupId"];
}
else
{
    ?>
    <script type="text/javascript">
    <!--
    self.close();
    -->
    </script>
    <?php
}

$tpl = new HTML_Template_IT($cfgPathToMediafileTemplates);
$tpl->loadTemplatefile($templateMediafileAdd, true, true);

// set title
$tpl->setVariable( "applicationtitle", $cfgApplicationType.$cfgApplicationVersion);

if($_SERVER["REQUEST_METHOD"] == "POST")
{
	$step = $_POST["step"];
	
	if($step == 1)
	{
		$amount = intval($_POST["amount"]);
		if($amount < 1)
		{
			$tpl->setCurrentBlock("error_message");
			$tpl->setVariable("errors", $lang_script["mediafile.add.php"]["errors"]);
			$tpl->parseCurrentBlock("error_message");
			$tpl->touchBlock ("ask_amount");
			$tpl->setVariable("step", 1);
			$tpl->setVariable("groupId", $groupId);
			$tpl->show();
			exit;
		}
		// create input for every file
		for($i=0; $i < $amount; $i++)
		{
			$tpl->setCurrentBlock("template_add");
			$tpl->setVariable("filename", "userfiles".$i);
			$tpl->parseCurrentBlock("template_add");
		}
		$tpl->setVariable("amount", $amount);
		$tpl->setVariable("step", 2);
		$tpl->setVariable("groupId", $groupId);
		$tpl->parse();
		$tpl->show();
	}
	elseif($step == 2)
	{
		$groupId = $_POST["groupId"];
		$filesNameUpload = 'userfiles';
		$filesNumber = $_POST["totalamount"];
		$uploadData = $mediafile->addContentToCategory($filesNameUpload,$filesNumber,$groupId);
		
		// success message for every file
		$tpl->loadTemplatefile($templateMediafileSuccess, true, true);
		
		// set title
		$tpl->setVariable( "applicationtitle", $cfgApplicationType.$cfgApplicationVersion);

		//
		for($i=0; $i < count($uploadData); $i++)
		{	
			if($uploadData[$i]["error"])
			{
				$tpl->setCurrentBlock("error_message");
				$tpl->setVariable("filename", $uploadData[$i]["real"]);
				$tpl->setVariable("fileerror", $uploadData[$i]["error"]);
				$tpl->parseCurrentBlock("error_message");
				continue;	
			}
			$tpl->setCurrentBlock("upload_info");
			$tpl->setVariable("filename", $uploadData[$i]["real"]);
			$tpl->setVariable("folder", $uploadData[$i]["path"]);
			$tpl->setVariable("filesavename", $uploadData[$i]["name"]);
			$tpl->setVariable("fileending", $uploadData[$i]["ext"]);
			$tpl->setVariable("filetype", $uploadData[$i]["type"]);
			$tpl->setVariable("filesize", $uploadData[$i]["size"]);
			$tpl->setVariable("uploadtime", $uploadData[$i]["time"]);
			$tpl->parseCurrentBlock("upload_info");	
		}
		$tpl->parse();
		$tpl->show();
		exit;
	}
}
else
{
	$tpl->touchBlock ("ask_amount");
	$tpl->setVariable("step", 1);
	$tpl->setVariable("groupId", $groupId);
	$tpl->parse();
	$tpl->show();
}
?>
