<?php
// +----------------------------------------------------------------------+
// | survey pilot                                                         |
// +----------------------------------------------------------------------+
// | Copyright (c) 2002 serie a - Digitale Medien und Systeme GmbH        |
// +----------------------------------------------------------------------+
// | Authors: 	Jrn Allert <allert@serie-a.de>                           |
// |          	Rene Renk <renk@serie-a.de>                               |
// +----------------------------------------------------------------------+
//
// $Id: mediafile.content.overview.php,v 1.1.1.1 2004/07/15 13:29:28 opensurveypilot Exp $

// start session
@session_start();

// require all configuration files and libraries
require_once("./../config/config.inc.php"); // common config file
require_once ("Validate.php"); // PEAR::Validate (must be included before common config file)
require_once($cfgPathToConf."/file.inc.php"); // project files
require_once($cfgPathToLib."/common.inc.php"); // common functions
require_once($cfgPathToAuthFiles."/config/auth.file.inc.php"); // auth files
require_once($cfgPathToAuthFiles."/lib/user.inc.php"); // auth user functions
require_once($cfgPathToMediafileFiles."/config/mediafile.file.inc.php"); // mediafile files
require_once($cfgPathToMediafileFiles."/lib/mediafile.inc.php"); // mediafile category functions
require_once("HTML/Template/IT.php"); // PEAR::HTML_TEMPLATE_IT

// create new userFunctions object
$client = &new userFunctions;

//login check
if ($client->getAuthentication($_SESSION["sessionId"], session_id()) == false)
{
    //redirect to login page
    ?>
    <script type="text/javascript">
    <!--
    window.location.href="<?php echo $cfgUrlToProject."/".$fileAuthLogin; ?>";
    -->
    </script>
    <?php
    exit;
}

// function permission check
if($_SESSION["sessionUserStatusId"] < $permMediafileContentOverview)
{
    ?>
    <script type="text/javascript">
    <!--
    window.location.href="<?php echo $cfgUrlToProject."/".$fileNoPermission."?messageCode=2"; ?>";
    -->
    </script>
    <?php
    exit;
}

// create Template IT object
$tpl = new HTML_Template_IT($cfgPathToMediafileTemplates);

// get contentId
if(isset($_GET["contentId"]))
{
    $contentId = $_GET["contentId"];
}

// create new categoryFunctions object
$mediafile = &new mediafileFunctions;

// load template
$tpl->loadTemplatefile($templateMediafileContentOverview, true, true);

// set title
$tpl->setVariable( "applicationtitle", $cfgApplicationType.$cfgApplicationVersion);

// get group id as get variable
if(isset($_GET["groupId"]))
{
    $groupId = $_GET["groupId"];
}

// get actual num as get variable
if(isset($_GET["actualNum"]))
{
    $actualNum = $_GET["actualNum"];
}
// get orderBy as get variable
if(isset($_GET["orderBy"]))
{
    $orderBy = $_GET["orderBy"];
}
else
{
    $orderBy = "CONTENT_NAME";
}
// get direction as get variable
if(isset($_GET["direction"]))
{
    $direction = $_GET["direction"];
}

// maximum rows
$maxRow = $cfgMaxRowInOverviews;

//total rows 
$totalNum = $mediafile->getContentNum($groupId);

// actual rows
if (!isset($actualNum))
{
    $actualNum = 0;
}
// get the Number of pages
$numPages = intval($totalNum/$maxRow);
if ($numPages < ($totalNum/$maxRow))
{ 
    $numPages++;
}

// prev button
if ($actualNum > 0) 
{
    $y = $actualNum - $maxRow;
    
    $tpl->setVariable( "prev_button", "<a class=\"navigation\" href=\"$fileMediafileContentOverview?groupId=$groupId&actualNum=$y&orderBy=$orderBy&direction=$direction\">&laquo;</a>" );
}
// display pages
for ($i = 1; $i <= $numPages; $i++)
{
    $y = ($i * $maxRow) - $maxRow;
    
    $tpl->setCurrentBlock( "num_buttons" );
    $tpl->setVariable( "num_button", "[<a class=\"navigation\" href=\"$fileMediafileContentOverview?groupId=$groupId&actualNum=$y&orderBy=$orderBy&direction=$direction\">$i</a>]" );
    $tpl->parseCurrentBlock();
}
//  next button
if ($actualNum < ($totalNum - $maxRow)) 
{
    $y = $actualNum  + $maxRow;
    
    $tpl->setVariable( "next_button", "<a class=\"navigation\" href=\"$fileMediafileContentOverview?groupId=$groupId&actualNum=$y&orderBy=$orderBy&direction=$direction\">&raquo;</a>" );
}

if(($actualNum + $maxRow) < $totalNum)
{
    $entryTo = $actualNum + $maxRow;
}
else
{
    $entryTo = $totalNum;
    
}

// entry from
$entryFrom = $entryTo < 1 ? "0" : $actualNum +1;

$tpl->setVariable( "entry_from", $entryFrom );
$tpl->setVariable( "entry_to", $entryTo );
$tpl->setVariable( "entry_total", $totalNum );

// content / group switch
$tpl->setVariable( "grouplink", $fileMediafileGroupOverview."?projectId=$projectId&groupId=$groupId" );
$tpl->setVariable( "grouptarget", $fileFrameContentName );
$tpl->setVariable( "groupoptionlink", $fileMediafileToplevel."?projectId=$projectId&parentId=$groupId&fromGroup=no");
$tpl->setVariable( "groupoptiontarget", $fileFrameToplevelName );

// orderby butons
$tpl->setVariable( "order_link_typ_up", "$fileMediafileContentOverview?groupId=$groupId&actualNum=$actualNum&orderBy=CONTENT_ENDING&direction=ASC" );
$tpl->setVariable( "order_link_typ_down", "$fileMediafileContentOverview?groupId=$groupId&actualNum=$actualNum&orderBy=CONTENT_ENDING&direction=DESC" );
$tpl->setVariable( "order_link_name_up", "$fileMediafileContentOverview?groupId=$groupId&actualNum=$actualNum&orderBy=CONTENT_NAME&direction=ASC" );
$tpl->setVariable( "order_link_name_down", "$fileMediafileContentOverview?groupId=$groupId&actualNum=$actualNum&orderBy=CONTENT_NAME&direction=DESC" );
$tpl->setVariable( "order_link_insert_date_up", "$fileMediafileContentOverview?groupId=$groupId&actualNum=$actualNum&orderBy=CONTENT_TIME&direction=ASC" );
$tpl->setVariable( "order_link_insert_date_down", "$fileMediafileContentOverview?groupId=$groupId&actualNum=$actualNum&orderBy=CONTENT_TIME&direction=DESC" );

// get headline
$headlineArray =  $mediafile->getGroupInfo($groupId);
if($surveyQuestionsGroup->errorMessage)
{
    echo $surveyQuestionsGroup->errorMessage;
}
$tpl->setCurrentBlock( "headline" );
$tpl->setVariable( "headline_group", $headlineArray["CATEGORY_NAME"] );
$tpl->parseCurrentBlock();	

// get user
$contentArray = $mediafile->getContentForOverview($groupId, $actualNum, $maxRow, $orderBy, $direction, $contentId);

if ($mediafile->errorMessage)
{
    $userError = $mediafile->errorMessage;
    echo $userError;
}

for($j=0;$j<count($contentArray);$j++)
{
    $tpl->setCurrentBlock( "group_overview" );
    $tpl->setVariable( "image", $mediafile->getMimeTypeImage($contentArray[$j]["CONTENT_ENDING"]) );
    $tpl->setVariable( "mimetype", $contentArray[$j]["CONTENT_MIMETYPE"] );
    $tpl->setVariable( "id", $contentArray[$j]["CONTENT_ID_PK"] );
    $tpl->setVariable( "name", $contentArray[$j]["CONTENT_NAME"] );
    $tpl->setVariable( "insertdate", $contentArray[$j]["CONTENT_TIME"] );
    $tpl->setVariable( "detailview_link", $fileMediafileDetailView."?contentId=".$contentArray[$j]["CONTENT_ID_PK"] );
    $tpl->setVariable( "preview_link", $fileMediafilepreView."?contentId=".$contentArray[$j]["CONTENT_ID_PK"] );
	$tpl->setVariable( "delete_link", $fileMediafileDelete."?contentId=".$contentArray[$j]["CONTENT_ID_PK"] );
    $tpl->parseCurrentBlock();
}

// parse template
$tpl->parse();

// get the parsed template and print it
$tpl->get();
$tpl->show();
?>
