<?php
// +----------------------------------------------------------------------+
// | survey pilot                                                         |
// +----------------------------------------------------------------------+
// | Copyright (c) 2002 serie a - Digitale Medien und Systeme GmbH        |
// +----------------------------------------------------------------------+
// | Authors: 	Jrn Allert <allert@serie-a.de>                           |
// |          	Rene Renk <renk@serie-a.de>                               |
// +----------------------------------------------------------------------+
//
// $Id: mediafile.group.add.php,v 1.1.1.1 2004/07/15 13:29:29 opensurveypilot Exp $

// start session
session_start();

// require all configuration files and libraries
require_once("./../config/config.inc.php"); // common config file
require_once ("Validate.php"); // PEAR::Validate (must be included before common config file)
require_once($cfgPathToConf."/file.inc.php"); // project files
require_once($cfgPathToLib."/common.inc.php"); // common functions
require_once($cfgPathToAuthFiles."/config/auth.file.inc.php"); // auth files
require_once($cfgPathToAuthFiles."/lib/user.inc.php"); // auth user functions
require_once($cfgPathToMediafileFiles."/config/mediafile.file.inc.php"); // mediafile files
require_once($cfgPathToMediafileFiles."/lib/mediafile.inc.php"); // mediafile category functions
require_once("HTML/Template/IT.php"); // PEAR::HTML_TEMPLATE_IT

// create new userFunctions object
$client = &new userFunctions;

//login check
if ($client->getAuthentication($_SESSION["sessionId"], session_id()) == false)
{
    //redirect to login page
    ?>
    <script type="text/javascript">
    <!--
    window.location.href="<?php echo $cfgUrlToProject."/".$fileAuthLogin; ?>";
    -->
    </script>
    <?php
    exit;
}

// function permission check
if($_SESSION["sessionUserStatusId"] < $permMediafileGroupAdd)
{
    ?>
    <script type="text/javascript">
    <!--
    window.location.href="<?php echo $cfgUrlToProject."/".$fileNoPermission."?messageCode=2"; ?>";
    -->
    </script>
    <?php
    exit;
}

// check for parentId
if($_GET["parentId"] != "")
{
	$parentId	=	$_GET["parentId"];
}
else
{
	$parentId	=	"0";
}

// check if form was submitted
if($_SERVER["REQUEST_METHOD"] == "POST")
{
    $parentId = $_POST["parentId"];
    
    // get and check name and make small
    $groupName 	= strtolower(cleanHtml($_POST["groupName"]));
    
    $groupName 	= str_replace ( " ", "_", $groupName);
	
    if($groupName != "")
    {
        // check format
        if(!validate::string($groupName, VAL_ALPHA_NUM_, 1, 25))
        {
            $errors["groupName"] = $lang_script["mediafile.group.add.php"]["errorsChars"];
        }
    }
    else
    {
        $errors["groupName"] = $lang_script["mediafile.group.add.php"]["errorsNameField"];
    }
    
    // put error Array in String
    if($errors)
    {
        foreach($errors as $error)
        {
            $userError .= "$error<br>";
        }
    }
    // no errors, so we can insert new group
    else
    {
        $groupArray["name"] 	= $groupName;
        $groupArray["parentId"] = $parentId;
        
        $mediafile = &new mediafileFunctions;
		
        // make dir and giving the permission to write
        if($mediafile->makemediafileCategoryDir($groupArray))
		{
            // add category to database
            $mediafile->addCategory($groupArray);
		}
        // check for error
        if ($mediafile->errorMessage)
        {
            $userError = $mediafile->errorMessage;
        }
        // redirect to success page
        else
        {
            ?>
            <script type="text/javascript">
            <!--
            window.location.href="<?php echo $cfgUrlToProject."/".$fileCommonSuccessMessage; ?>";
            -->
            </script>
            <?php
        }
    }
}

// create Template IT object
$tpl = new HTML_Template_IT($cfgPathToMediafileTemplates);

// load template
$tpl->loadTemplatefile($templateMediafileGroupAdd, true, true);

// set title
$tpl->setVariable( "applicationtitle", $cfgApplicationType.$cfgApplicationVersion);

$tpl->setVariable( "formaction", $fileMediafileGroupAdd );

$tpl->setVariable( "errors", $userError );

$tpl->setVariable( "name", $groupName );
$tpl->setVariable( "parentid", $parentId );

// parse template
$tpl->parse();

// get the parsed template and print it
$tpl->get();
$tpl->show();
?>
