<?php
// +----------------------------------------------------------------------+
// | survey pilot                                                         |
// +----------------------------------------------------------------------+
// | Copyright (c) 2002 serie a - Digitale Medien und Systeme GmbH        |
// +----------------------------------------------------------------------+
// | Authors: 	Jrn Allert <allert@serie-a.de>                           |
// |          	Rene Renk <renk@serie-a.de>                               |
// +----------------------------------------------------------------------+
//
// $Id: mediafile.group.delete.php,v 1.1.1.1 2004/07/15 13:29:29 opensurveypilot Exp $

// start session
session_start();

// require all configuration files and libraries
require_once("./../config/config.inc.php"); // common config file
require_once ("Validate.php"); // PEAR::Validate (must be included before common config file)
require_once($cfgPathToConf."/file.inc.php"); // project files
require_once($cfgPathToLib."/common.inc.php"); // common functions
require_once($cfgPathToAuthFiles."/config/auth.file.inc.php"); // auth files
require_once($cfgPathToAuthFiles."/lib/user.inc.php"); // auth user functions
require_once($cfgPathToMediafileFiles."/config/mediafile.file.inc.php"); // mediafile files
require_once($cfgPathToMediafileFiles."/lib/mediafile.inc.php"); // mediafile category functions
require_once("HTML/Template/IT.php"); // PEAR::HTML_TEMPLATE_IT

// create new userFunctions object
$client = &new userFunctions;

//login check
if ($client->getAuthentication($_SESSION["sessionId"], session_id()) == false)
{
    //redirect to login page
    ?>
    <script type="text/javascript">
    <!--
    window.location.href="<?php echo $cfgUrlToProject."/".$fileAuthLogin; ?>";
    -->
    </script>
    <?php
    exit;
}

// function permission check
if($_SESSION["sessionUserStatusId"] < $permMediafileGroupDelete)
{
    ?>
    <script type="text/javascript">
    <!--
    window.location.href="<?php echo $cfgUrlToProject."/".$fileNoPermission."?messageCode=2"; ?>";
    -->
    </script>
    <?php
    exit;
}

// get category id for detailview
if(isset($_GET["groupId"]))
{
    $categoryId = $_GET["groupId"];
}

// create new mediafileFunctions object
$mediafile = &new mediafileFunctions;

// check if form was submitted
if($_SERVER["REQUEST_METHOD"] == "POST")
{
    $groupId = $_POST["groupId"];
	// delete Category
    $mediafile->deleteCategory($categoryId);
    if($mediafile->errorMessage)
    {
        $groupError =  $mediafile->errorMessage;
    }
    // redirect to success page
    if(!isset($userError))
    {
      ?>
        <script type="text/javascript">
        <!--
        window.location.href="<?php echo $cfgUrlToProject."/".$fileDeleteSuccessMessage; ?>";
        -->
        </script>
        <?php
    }
}

// fetch categorydata
$groupData = $mediafile->getGroupInfo($groupId);
if($mediafile->errorMessage)
{
    $groupError .= $mediafile->$errorMessage;
}

// create Template IT object
$tpl = new HTML_Template_IT($cfgPathToMediafileTemplates);

// load template
$tpl->loadTemplatefile($templateMediafileGroupDelete, true, true);

// set title
$tpl->setVariable( "applicationtitle", $cfgApplicationType.$cfgApplicationVersion);

$tpl->setVariable( "errors", $groupError );
$tpl->setVariable( "groupid", $groupId );
$tpl->setVariable( "name", $groupData["CATEGORY_NAME"] );

// parse template
$tpl->parse();

// get the parsed template and print it
$tpl->get();
$tpl->show();   
?>