<?php
// +----------------------------------------------------------------------+
// | survey pilot                                                         |
// +----------------------------------------------------------------------+
// | Copyright (c) 2002 serie a - Digitale Medien und Systeme GmbH        |
// +----------------------------------------------------------------------+
// | Authors: 	J?rn Allert <allert@serie-a.de>                           |
// |          	Rene Renk <renk@serie-a.de>                               |
// +----------------------------------------------------------------------+
//
// $Id: mediafile.overview.php,v 1.1.1.1 2004/07/15 13:29:32 opensurveypilot Exp $

// start session
@session_start();

// require all configuration files and libraries
require_once("./../config/config.inc.php"); // common config file
require_once($cfgPathToConf."/file.inc.php"); // project files
require_once($cfgPathToLib."/common.inc.php"); // common functions
require_once($cfgPathToAuthFiles."/config/auth.file.inc.php"); // auth files
require_once($cfgPathToAuthFiles."/lib/user.inc.php"); // auth user functions
require_once($cfgPathToMediafileFiles."/config/mediafile.file.inc.php"); // mediafile files
require_once($cfgPathToMediafileFiles."/lib/mediafile.inc.php"); // mediafile category functions
require_once("HTML/Template/IT.php"); // PEAR::HTML_TEMPLATE_IT

// create new userFunctions object
$client = &new userFunctions;

//login check
if ($client->getAuthentication($_SESSION["sessionId"], session_id()) == false)
{
    //redirect to login page
    ?>
    <script type="text/javascript">
    <!--
    window.location.href="<?php echo $cfgUrlToProject."/".$fileAuthLogin; ?>";
    -->
    </script>
    <?php
    exit;
}

// function permission check
if($_SESSION["sessionUserStatusId"] < $permMediafileOverview)
{
    ?>
    <script type="text/javascript">
    <!--
    window.location.href="<?php echo $cfgUrlToProject."/".$fileNoPermission."?messageCode=2"; ?>";
    -->
    </script>
    <?php
    exit;
}

// create Template IT object
$tpl = new HTML_Template_IT($cfgPathToMediafileTemplates);

// create new categoryFunctions object
$mediafile = &new mediafileFunctions;

// load template
$tpl->loadTemplatefile($templateMediafileOverview, true, true);

// set title
$tpl->setVariable( "applicationtitle", $cfgApplicationType.$cfgApplicationVersion);

// get group id as get variable
if(isset($_GET["groupId"]))
{
    $groupId = $_GET["groupId"];
}

// get actual num as get variable
if(isset($_GET["actualNum"]))
{
    $actualNum = $_GET["actualNum"];
}
// get orderBy as get variable
if(isset($_GET["orderBy"]))
{
    $orderBy = $_GET["orderBy"];
}
else
{
    $orderBy = "CATEGORY_NAME";
}
// get direction as get variable
if(isset($_GET["direction"]))
{
    $direction = $_GET["direction"];
}

// maximum rows
$maxRow = $cfgMaxRowInOverviews;
//total rows 

$totalNum = $mediafile->getGroupsNum($groupId);

if($groupId == "")
{
	$tpl->setVariable( "groupname", $lang_script["mediafile.overview.php"]["mainCategories"]);
}
else
{
	$tpl->setVariable( "groupname", $lang_script["mediafile.overview.php"]["Category"]);
}

// actual rows
if (!isset($actualNum))
{
    $actualNum = 0;
}
// get the Number of pages
$numPages = intval($totalNum/$maxRow);
if ($numPages < ($totalNum/$maxRow))
{ 
    $numPages++;
}

// prev button
if ($actualNum > 0) 
{
    $y = $actualNum - $maxRow;
    
    $tpl->setVariable( "prev_button", "<a class=\"navigation\" href=\"$fileTmplOverview?groupId=$groupId&actualNum=$y&orderBy=$orderBy&direction=$direction\">&laquo;</a>" );
}
// display pages
for ($i = 1; $i <= $numPages; $i++)
{
    $y = ($i * $maxRow) - $maxRow;
    
    $tpl->setCurrentBlock( "num_buttons" );
    $tpl->setVariable( "num_button", "[<a class=\"navigation\" href=\"$fileTmplOverview?groupId=$groupId&actualNum=$y&orderBy=$orderBy&direction=$direction\">$i</a>]" );
    $tpl->parseCurrentBlock();
}
//  next button
if ($actualNum < ($totalNum - $maxRow)) 
{
    $y = $actualNum  + $maxRow;
    
    $tpl->setVariable( "next_button", "<a class=\"navigation\" href=\"$fileTmplOverview?groupId=$groupId&actualNum=$y&orderBy=$orderBy&direction=$direction\">&raquo;</a>" );
}

if(($actualNum + $maxRow) < $totalNum)
{
    $entryTo = $actualNum + $maxRow;
}
else
{
    $entryTo = $totalNum;
}

// entry from
$entryFrom = $entryTo < 1 ? "0" : $actualNum +1;

$tpl->setVariable( "entry_from", $entryFrom );
$tpl->setVariable( "entry_to", $entryTo );
$tpl->setVariable( "entry_total", $totalNum );

// orderby butons
$tpl->setVariable( "order_link_name_up", "$fileMediafileOverview?groupId=$groupId&actualNum=$actualNum&orderBy=CATEGORY_NAME&direction=ASC" );
$tpl->setVariable( "order_link_name_down", "$fileMediafileOverview?groupId=$groupId&actualNum=$actualNum&orderBy=CATEGORY_NAME&direction=DESC" );
$tpl->setVariable( "order_link_insert_date_up", "$fileMediafileOverview?groupId=$groupId&actualNum=$actualNum&orderBy=CATEGORY_TIME&direction=ASC" );
$tpl->setVariable( "order_link_insert_date_down", "$fileMediafileOverview?groupId=$groupId&actualNum=$actualNum&orderBy=CATEGORY_TIME&direction=DESC" );

$tpl->setCurrentBlock( "headline" );
$tpl->setVariable( "headline_group", $lang_script["mediafile.overview.php"]["mainCategories"] );
$tpl->parseCurrentBlock();	


// get content
$groupArray = $mediafile->getGroupsForOverview($groupId, $actualNum, $maxRow, $orderBy, $direction);
if ($mediafile->errorMessage)
{
    $userError = $mediafile->errorMessage;
}

for($j=0;$j<count($groupArray);$j++)
{
    $tpl->setCurrentBlock( "group_overview" );
    $tpl->setVariable( "id", $groupArray[$j]["CATEGORY_ID_PK"] );
    $tpl->setVariable( "name", $groupArray[$j]["CATEGORY_NAME"] );
    $tpl->setVariable( "insertdate", $groupArray[$j]["CATEGORY_TIME"] );
    $tpl->setVariable( "delete_link", $fileMediafileGroupDelete."?groupId=".$groupArray[$j]["CATEGORY_ID_PK"] );
    $tpl->parseCurrentBlock();
}

// parse template
$tpl->parse();

// get the parsed template and print it
$tpl->get();
$tpl->show();
?>
