<?php
// +----------------------------------------------------------------------+
// | sa project pilot - files                                             |
// +----------------------------------------------------------------------+
// | Copyright (c) 2002 serie a - Digitale Medien und Systeme GmbH        |
// +----------------------------------------------------------------------+
// | Authors: Jrn Allert <allert@serie-a.de>                             |
// |          Rene Renk <renk@serie-a.de>                                 |
// +----------------------------------------------------------------------+
//
// $Id: options.testgroups.php,v 1.1.1.1 2004/07/15 13:24:10 opensurveypilot Exp $

// start session
session_start();

// require all configuration files and libraries
require_once("./config/config.inc.php"); // common config file
require_once($cfgPathToConf."/file.inc.php"); // project files
require_once($cfgPathToLib."/common.inc.php"); // common functions
require_once($cfgPathToAuthFiles."/lib/user.inc.php"); // auth user functions
require_once($cfgPathToAuthFiles."/config/auth.file.inc.php"); // auth user functions
require_once($cfgPathToSurveyFiles."/config/survey.file.inc.php"); // survey user functions
require_once($cfgPathToStatisticFiles."/config/statistic.file.inc.php"); // statistic user functions
require_once($cfgPathToTestgroupFiles."/config/testgroup.file.inc.php"); // testgroup files
require_once("HTML/Template/IT.php"); // PEAR::HTML_TEMPLATE_IT

// create Template IT object
$tpl = new HTML_Template_IT($cfgPathToTemplates);

// load template
$tpl->loadTemplatefile($templateCommonOptionsTestgroups, true, true);

// set title
$tpl->setVariable( "applicationtitle", $cfgApplicationType.$cfgApplicationVersion);

// set common names
$tpl->setVariable( "fileframeoptionsname", $fileFrameOptionsName );
$tpl->setVariable( "fileframetoplevelname", $fileFrameToplevelName );
$tpl->setVariable( "fileframeheadlinename", $fileFrameHeadlineName );
$tpl->setVariable( "fileframeprojecttreename", $fileFrameProjectTreeName );
$tpl->setVariable( "fileframecontentname", $fileFrameContentName );
$tpl->setVariable( "fileframechangeprojecttreename", $fileFrameChangeProjectTreeName );

// set variables for buttons
$tpl->setVariable( "filecommonoptions", $fileCommonOptions );
$tpl->setVariable( "fileoverviewoptions", $fileCommonOptionsOverview );
$tpl->setVariable( "fileprojecttoplevel", $cfgPathToSurveyModule."/".$fileSurveyToplevel );
$tpl->setVariable( "fileprojectheadline", $cfgPathToSurveyModule."/".$fileSurveyHeadline );
$tpl->setVariable( "fileprojectprojecttree", $cfgPathToSurveyModule."/".$fileSurveyProjectTree );
$tpl->setVariable( "fileprojectempty", $cfgPathToSurveyModule."/".$fileSurveyEmpty );
$tpl->setVariable( "fileprojectoverview", $cfgPathToSurveyModule."/".$fileSurveyOverview );
$tpl->setVariable( "fileprojectoverviewtoplevel", $cfgPathToSurveyModule."/".$fileSurveyOverviewToplevel );

$tpl->setVariable( "filecommonoptionsstatistics", $fileCommonOptionsStatistics );
$tpl->setVariable( "filestatisticstoplevel", $cfgPathToStatisticModule."/".$fileStatisticToplevel );
$tpl->setVariable( "filestatisticsheadline", $cfgPathToStatisticModule."/".$fileStatisticHeadline );
$tpl->setVariable( "filestatisticsoverview", $cfgPathToStatisticModule."/".$fileStatisticOverview );
$tpl->setVariable( "filestatisticsempty", $cfgPathToStatisticModule."/".$fileStatisticEmpty );
$tpl->setVariable( "filestatisticsprojecttree", $cfgPathToStatisticModule."/".$fileStatisticProjectTree );

$tpl->setVariable( "filecommonoptionstestgroups", $fileCommonOptionsTestgroups );
$tpl->setVariable( "filetestgroupstoplevel", $cfgPathToTestgroupModule."/".$fileTestgroupToplevel );
$tpl->setVariable( "filetestgroupsheadline", $cfgPathToTestgroupModule."/".$fileTestgroupHeadline );
$tpl->setVariable( "filetestgroupsoverview", $cfgPathToTestgroupModule."/".$fileTestgroupOverview );
$tpl->setVariable( "filetestgroupsempty", $cfgPathToSurveyModule."/".$fileSurveyEmpty );
$tpl->setVariable( "filetestgroupsprojecttree", $cfgPathToTestgroupModule."/".$fileTestgroupTree );

// set language variables
$tpl->setVariable( "langprojectmanagement", $lang_script["options.testgroups.php"]["ProjectManagement"] );
$tpl->setVariable( "langsurveyprojects", $lang_script["options.testgroups.php"]["SurveyProjects"] );
$tpl->setVariable( "langsurveystatistsics", $lang_script["options.testgroups.php"]["SurveyStatistics"] );
$tpl->setVariable( "langsurveytestgroups", $lang_script["options.testgroups.php"]["Panel"] );

// parse template
$tpl->parse();

// get the parsed template and print it
$tpl->get();
$tpl->show();
?>
