<?php
// +----------------------------------------------------------------------+
// | sm survey module - html_quickform_functions                          |
// +----------------------------------------------------------------------+
// | Copyright (c) 2002 serie a - Digitale Medien und Systeme GmbH        |
// +----------------------------------------------------------------------+
// | Authors: Jrn Allert <allert@serie-a.de>                             |
// |          Rene Renk <renk@serie-a.de>                                 |
// +----------------------------------------------------------------------+
// | Description: Basic functions to convert data to XML and vice versa   |
// |         								                              |
// +----------------------------------------------------------------------+
//
// $Id: createcss.inc.php,v 1.1.1.1 2004/07/15 13:30:07 opensurveypilot Exp $

//session_Start
@session_start();

// require all configuration files and libraries
require_once($cfgPathToProbFiles."/config/prob.config.inc.php"); // proband config file
require_once($cfgPathToProbFiles."/config/prob.file.inc.php"); // proband files

/**
* createCSS class
*
*
* creates 
*
* @author  Jrn Allert <allert@serie-a.de>
* @author  Rene Renk <renk@serie-a.de>
* @access  public
*/
class createCSS
{

    /**
    *	handle for db connection
    *	@var  object  $dbclass
    */
    var $dbclass;

	/**
	*	CONSTRUCTOR
    *	opens database
    *
    *	@access	private
    *	@param	string	$err						error message
    */
    function createCSS()
    {
		// global Tabs
		global $cfgTabCss;

		// set vars
		$this->cfgTabCss		=	$cfgTabCss;
		
		$this->dbclass = &new DB;
		$this->dbclass = DB::connect(DSN, true);
		if (DB::isError($this->dbclass)) 
        {    
			$err = "Could not connect to Database in function createCSS:createCSS";
            $this->getErrorMessage($err);
            $status = "error";
			return $status;
        }
    }

	/**
    *	gets error message
    *
    *	@access	private
    *	@param	string	$err						error message
    */
    function getErrorMessage($err)
    {
        echo "<br><br>--------------ERROR!!!------------------<br><b>".$this->errorMessage = $err. "</b><br>--------------ERROR!!!------------------<br><br>";
    }

    /**
	*	
	*	creates basic.css file
    *
    *	@access	public
	*
    *	@param	int		$maskId				options to insert
    */
	function createCssFileFromDatabase($maskId)
	{
		global $cfgTabUsermask;
		global $cfgPathToAssessmentOutput;
		
		$sql = "SELECT USERMASK_CSSSTYLE_ID_FK FROM $cfgTabUsermask WHERE USERMASK_ID_PK=$maskId";
		$dbResult = $this->dbclass->query($sql);
		if (DB::isError($dbResult))
		{	
			$err = "Could not get CSS_ID in createCSS:createCssFileFromDatabase with Arguments: ".$sql;
            $this->getErrorMessage($err);
            $status = "error";
		}
		
		while ($row = $dbResult->fetchRow(DB_FETCHMODE_ASSOC))
	    {
	            $cssId = $row["USERMASK_CSSSTYLE_ID_FK"];
	    }
		
		// get css values
		$mySqlStatement = "select * 
			from ".$this->cfgTabCss." 
			where CSSSTYLE_ID_PK = '$cssId'";
		//
		$dbResult = $this->dbclass->query($mySqlStatement);
		if (DB::isError($dbResult))
		{	
			$err = "Could not select in createCSS:createCssFileFromDatabase with Arguments: ".$mySqlStatement;
            $this->getErrorMessage($err);
            $status = "error";
		}
		// if data does not exists get default values
		if(!$resultData = $dbResult->fetchRow(DB_FETCHMODE_ASSOC))
		{
			$mySqlStatement = "select * 
				from ".$this->cfgTabCss." 
				where CSSSTYLE_ID_PK = '0'";
			//
			$dbResult = $this->dbclass->query($mySqlStatement);
			if (DB::isError($dbResult))
			{	
				$err = "Could not select in createCSS:createCssFileFromDatabase with Arguments: ".$mySqlStatement;
	            $this->getErrorMessage($err);
	            return $status = "error1";
			}
			// no Data found
			if(!$resultData = $dbResult->fetchRow(DB_FETCHMODE_ASSOC))
			{
				return $status = "error2";
			}
		}
		// get css data
		$cssData = $resultData;
		//
		// get outputdir
		$mySqlStatement = "select * 
			from ".$cfgTabUsermask." 
			where USERMASK_ID_PK = '$maskId'";
		//
		$dbResult = $this->dbclass->query($mySqlStatement);
		if (DB::isError($dbResult))
		{	
			$err = "Could not select in createCSS:createCssFileFromDatabase with Arguments: ".$mySqlStatement;
            $this->getErrorMessage($err);
            $status = "error";
		}
		if(!$resultData = $dbResult->fetchRow(DB_FETCHMODE_ASSOC))
		{
			return $status = "error3";
		}
		// get survey data
		$surveyData = $resultData;
		// outputdir
		$outputDir = $surveyData["USERMASK_OUTPUTDIR"];
		
		// assign cssdata
		$cssFontcolor			=		"#".$cssData["CSSSTYLE_FONTCOLOR"];
		$cssHeadercolor			=		"#".$cssData["CSSSTYLE_FONTCOLORHEADER"];
		$cssBgForm				=		"#".$cssData["CSSSTYLE_BGFORM"];
		$cssBgHeader			=		"#".$cssData["CSSSTYLE_BGHEADER"];
		$cssHeaderHeight		=		$cssData["CSSSTYLE_HEADERHEIGHT"];
		$cssBgInput				=		"#".$cssData["CSSSTYLE_BGINPUT"];
		$cssInputWidth			=		$cssData["CSSSTYLE_FIELDWIDTH"];
		$cssInputHeight			=		$cssData["CSSSTYLE_AREAHEIGHT"];
		$cssLinecolor			=		"#".$cssData["CSSSTYLE_LINECOLOR"];
		$cssRequiredcolor		=		"#".$cssData["CSSSTYLE_REQUIREDCOLOR"];
		$cssNumericcolor		=		"#".$cssData["CSSSTYLE_NUMERICCOLOR"];
		// fonttype
		switch($cssData["CSSSTYLE_FONTTYPE"])
		{
			case "arial":
			{
				$cssFontfamily = "arial,verdana,sans-serif";break;
			}
			case "verdana":
			{
				$cssFontfamily = "verdana,arial,sans-serif";break;
			}
			case "times":
			{
				$cssFontfamily = "Times New Roman,garamond,arial";break;
			}
			default:
			{
				$cssFontfamily = "arial,verdana,sans-serif";break;
			}
		}
		// fontsize
		$cssFontsizeHead		=	$cssData["CSSSTYLE_FONTSIZE"];
		$cssFontsizeQuestion	=	round($cssData["CSSSTYLE_FONTSIZE"]/100*80);
		$cssFontsizeLabel		=	round($cssData["CSSSTYLE_FONTSIZE"]/100*70);
		$cssFontsizeRequired	=	round($cssData["CSSSTYLE_FONTSIZE"]/100*60);
		
		// create file
		$cssFile="
		/*<!--//Define body styles-->*/\n																		
		\n
		\n
		body.basic				{background-color:".$cssBgForm.";}\n
		\n
		p.basic					{color:".$cssFontcolor.";font-family:arial,verdana,sans-serif;font-size:11px;}\n
		\n
		h1.basic				{color:".$cssHeadercolor.";font-family:arial,verdana,sans-serif;font-size:14px;}\n
		/*<!--//Define table styles-->*/\n																		
		\n
		table.basic				{align:left;width:100%;valign:top;}\n
		table.border			{background-color:#000000;}\n
		\n
		/*<!--//Define common table styles-->*/\n																
		\n
		td.basic				{background-color:".$cssBgForm.";}\n
		td.cssheader			{color:".$cssHeadercolor.";background-color:".$cssBgHeader.";font-family:".$cssFontfamily.";font-size:".$cssFontsizeHead."px;font-weight:bold;text-align:left;width:100%;height:".$cssHeaderHeight."px;}\n
		td.cssline				{width:100%;height:1px;}\n
		td.cssrequired			{color:".$cssFontcolor.";font-family:".$cssFontfamily.";font-size:".$cssFontsizeRequired."px;}\n
		td.csselement			{color:".$cssFontcolor.";font-family:".$cssFontfamily.";font-size:".$cssFontsizeLabel."px;align:left;}\n
		td.cssoption			{color:".$cssFontcolor.";font-family:".$cssFontfamily.";font-size:".$cssFontsizeLabel."px;align:left;text-align:left;}\n
		td.csstableoption		{color:".$cssFontcolor.";font-family:".$cssFontfamily.";font-size:".$cssFontsizeLabel."px;align:left;text-align:center;vertical-align:middle;}\n
		td.csslogin				{color:".$cssFontcolor.";font-family:".$cssFontfamily.";font-size:".$cssFontsizeQuestion."px;}\n
		td.csselementlabel		{color:".$cssFontcolor.";font-family:".$cssFontfamily.";font-size:".$cssFontsizeQuestion."px;font-weight:bold;align:left;width:50%;}\n
		\n
		/*<!--//Define common form styles-->*/\n															
		\n
		textarea.basic			{color:".$cssFontcolor.";background-color:".$cssBgInput.";font-family:".$cssFontfamily.";font-size:".$cssFontsizeLabel."px;width:".$cssInputWidth."px;height:".$cssInputHeight."px;}\n
		input.basic				{color:".$cssFontcolor.";background-color:".$cssBgInput.";font-family:".$cssFontfamily.";font-size:".$cssFontsizeLabel."px;width:".$cssInputWidth."px;vertical-align:middle;}\n
		input.radio				{color:".$cssFontcolor.";background-color:".$cssBgForm.";font-family:".$cssFontfamily.";font-size:".$cssFontsizeLabel."px;vertical-align:middle;}\n
		input.checkbox			{color:".$cssFontcolor.";background-color:".$cssBgForm.";font-family:".$cssFontfamily.";font-size:".$cssFontsizeLabel."px;vertical-align:middle;}\n
		select.basic			{color:".$cssFontcolor.";background-color:".$cssBgInput.";font-family:".$cssFontfamily.";font-size:".$cssFontsizeLabel."px;}\n
		select.basic2s			{color:".$cssFontcolor.";background-color:".$cssBgInput.";font-family:".$cssFontfamily.";font-size:".$cssFontsizeLabel."px;width:50px;}\n
		select.basic4s			{color:".$cssFontcolor.";background-color:".$cssBgInput.";font-family:".$cssFontfamily.";font-size:".$cssFontsizeLabel."px;width:82px;}\n
		\n
		/*<!--//Define div form styles-->*/\n																
		\n
		span.csserror			{color:".$cssRequiredcolor.";background-color:".$cssBgForm.";font-family:".$cssFontfamily.";font-size:".$cssFontsizeRequired."px;align:left;vertical-align:top;}\n
		span.cssnumericerror	{color:".$cssNumericcolor.";background-color:".$cssBgForm.";font-family:".$cssFontfamily.";font-size:".$cssFontsizeRequired."px;align:left;vertical-align:top;}\n
		span.cssrequired		{color:".$cssFontcolor.";font-family:".$cssFontfamily.";font-size:".$cssFontsizeRequired."px;vertical-align:top;}\n
		\n
		/*<!--//Define hr styles-->*/\n																
		\n
		.error 				{color:red;font-family:tahoma,arial,helvetica,sans-serif;font-size:11px;}\n
		hr.csshr				{color:".$cssLinecolor.";size:1;}\n
		";
		// write css
		$cssOldFile = fopen ($cfgPathToAssessmentOutput."/".$outputDir."/basic.css", "w");
	    if(!$cssOldFile)
        {   
            $this->getErrorMessage("copyAssessmentStartFiles: can't create basic.css");
            return $status="error";
        }
        if(!fwrite($cssOldFile,$cssFile))
        {   
            $this->getErrorMessage("copyAssessmentStartFiles: can't write into basic.css");
            return false;
        }
        fclose($cssOldFile);
	}
	
    /**
	*	
	*	inserts css data into Database
    *
    *	@access	public
	*
    *	@param	int		$maskId				maskId
    *   @param	array	$cssOptions				Attributes to Change
    */
	function insertCssDataIntoDatabase($cssOptions,$maskId=1)
	{		
		global $cfgTabUsermask;
		
		// create mysqlStatementArguments
		foreach ($cssOptions as $key => $value)
		{	
			if($value)
			{
			$mySqlStatementArgs .= " $key = '$value',";
			}
		}
		// cut comma from end
		$mySqlStatementArgs = substr($mySqlStatementArgs,0,(strlen($mySqlStatementArgs)-1));
		
		$sql = "SELECT USERMASK_CSSSTYLE_ID_FK FROM $cfgTabUsermask WHERE USERMASK_ID_PK=$maskId";
		$dbResult = $this->dbclass->query($sql);
		
		while ($row = $dbResult->fetchRow(DB_FETCHMODE_ASSOC))
	    {
	            $selectId = $row["USERMASK_CSSSTYLE_ID_FK"];
	    }		
		
		// check if entry already exists
		$mySqlStatement = "select 1 
			from ".$this->cfgTabCss." 
			where CSSSTYLE_ID_PK = '$selectId'";
		//
		$dbResult = $this->dbclass->query($mySqlStatement);
		if (DB::isError($dbResult))
		{	
			$err = "Could not select createCSS:insertCssDataIntoDatabase with Arguments: ".$mySqlStatement;
            $this->getErrorMessage($err);
            $status = "error";
		}
		// if entry update
		if($dbResult->fetchRow())
		{
			// sql
	        $mySqlStatement = "update 
				$this->cfgTabCss 
				set 
				".$mySqlStatementArgs." 
				where CSSSTYLE_ID_PK = '$selectId'";
			//
			$dbResult = $this->dbclass->query($mySqlStatement);
			if (DB::isError($dbResult))
			{	
				$err = "DBerror with update in createCSS:insertCssDataIntoDatabase with Arguments: ".$mySqlStatement;
	            $this->getErrorMessage($err);
	            $status = "error";
			}
		}
		// else insert
		else
		{
			// get next free id
	        $nextId = $this->dbclass->nextId($this->cfgTabCss);
			if (DB::isError($nextId)) 
	        {
				$err = "Could not get next_ID from ".$this->cfgTabCss." in function createCSS:insertCssDataIntoDatabase";
	            $this->getErrorMessage($err);
	            $status = "error";
				return $status;
	        }
			// statement
			$mySqlStatementArgs = "CSSSTYLE_USERMASK_ID_FK = '$maskId', CSSSTYLE_ID_PK = '$nextId', ".$mySqlStatementArgs;
			$mySqlStatement = "insert 
				into ".$this->cfgTabCss." 
				set 
				".$mySqlStatementArgs;
			//
			$dbResult = $this->dbclass->query($mySqlStatement);
			if (DB::isError($dbResult))
			{	
				$err = "DBerror with insert in createCSS:insertCssDataIntoDatabase with Arguments: ".$mySqlStatement;
	            $this->getErrorMessage($err);
	            $status = "error";
				return $status;
	        }
		}
	return $status="ok";
	}
	
	/**
	*	
	*	get css-Data for survey
    *
    *	@access	public
	*
    *	@param	int		$maskId				maskId
    *   @param	int		$copyFromId				Id of survey zo copy styles from
    */
	function getCssDataFromDatabase($maskId)
	{
		global $cfgTabUsermask;
		
		$sql = "SELECT USERMASK_EXTRA_NAMES_ID_FK FROM $cfgTabUsermask WHERE USERMASK_ID_PK=$maskId";
		$dbResult = $this->dbclass->query($sql);
		
		while ($row = $dbResult->fetchRow(DB_FETCHMODE_ASSOC))
	    {
	            $selectId = $row["USERMASK_EXTRA_NAMES_ID_FK"];
	    }		
		
		// check if entry already exists
		$mySqlStatement = "select * 
			from ".$this->cfgTabCss." 
			where CSSSTYLE_ID_PK = '$selectId'";
		//
		$dbResult = $this->dbclass->query($mySqlStatement);
		if (DB::isError($dbResult))
		{	
			$err = "Could not select in createCSS:copyCssFromDatabase with Arguments: ".$mySqlStatement;
            $this->getErrorMessage($err);
            $status = "error";
		}
		// if row exists
		if($resultData = $dbResult->fetchRow(DB_FETCHMODE_ASSOC))
		{
			return $resultData;
		}
		// if row does not exist
		$mySqlStatement = "select * 
			from ".$this->cfgTabCss." 
			where CSSSTYLE_ID_PK = '0'";
		//
		$dbResult = $this->dbclass->query($mySqlStatement);
		if (DB::isError($dbResult))
		{	
			$err = "Could not select in createCSS:copyCssFromDatabase with Arguments: ".$mySqlStatement;
            $this->getErrorMessage($err);
            $status = "error";
		}
		// if row exists
		if($resultData = $dbResult->fetchRow(DB_FETCHMODE_ASSOC))
		{
			return $resultData;
		}
		// else error
		$err = "Could not get data in createCSS:copyCssFromDatabase with Arguments: ".$mySqlStatement;
        $this->getErrorMessage($err);
        $status = "error";
		return $status;
	}
	
	function insertDefaultCss ($nextId)
	{		
		$sql = "insert into ".$this->cfgTabCss." (CSSSTYLE_ID_PK) values (".$nextId.") ";

		$dbResult = $this->dbclass->query($sql);
		if (DB::isError($dbResult))
		{	
			$err = "Could insert in createCSS: ".$mySqlStatement;
            $this->getErrorMessage($err);
            $status = "error";
		}
		return $status;
	}

}
?>