<?php
// +----------------------------------------------------------------------+
// | sm survey module -	dbFunctions                                       |
// +----------------------------------------------------------------------+
// | Copyright (c) 2002 serie a - Digitale Medien und Systeme GmbH        |
// +----------------------------------------------------------------------+
// | Authors: Jrn Allert <allert@serie-a.de>                             |
// |          Rene Renk <renk@serie-a.de>                                 |
// +----------------------------------------------------------------------+
// | Description: Basic database functions				  |
// |         								  |
// +----------------------------------------------------------------------+
//
// $Id: dbfunctions.assess.inc.php,v 1.1.1.1 2004/07/15 13:30:12 opensurveypilot Exp $

//session
@session_start();

// require all configuration files and libraries
require_once($cfgPathToProjectAdmin."/config/config.inc.php"); // common config file // common config file
require_once($cfgPathToConf."/file.inc.php"); // project files
require_once($cfgPathToProbFiles."/config/prob.config.inc.php"); // auth config file
require_once($cfgPathToProbFiles."/config/prob.file.inc.php"); // modules files
require_once("DB.php"); // PEAR::DB


/**
* basic db-functions class
*
* @author  Jrn Allert <allert@serie-a.de>
* @author  Rene Renk <renk@serie-a.de>
* @access  public
*/
class dbFunctions
{
    /**
    *	global counter for xmlFunctions
    *	@var    int  $dbFctCounter
    */
	var $dbFctCounter					  = 0;

    /**
    *	global store variable
    *	@var    int  $dbFctCounter
    */
	var $dbDataArray;
	/**

    /**
    *	global store variable
    *	@var    int  $dbFctCounter
    */
	var $db = "";
	/**

	/**
    *	constructor
    *
    *	@access	private
    *	@param	string	$err
    */
    function dbFunctions()
    {
        $this->errorMessage = "";
        // connect to db
        $this->db = DB::connect(DSN, true);
        if (DB::isError($this->db)) 
        {    
           $this->errorMessage($this->db->getMessage());
        }
    }
	
	/**
    *	gets error message
    *
    *	@access	private
    *	@param	string	$err
    */
    function getErrorMessage($err)
    {
        echo "<br><br>--------------ERROR!!!------------------<br><b>".$this->errorMessage = $err. "</b><br>--------------ERROR!!!------------------<br><br>";
	//end function
    }

    /**
    *	checks if node has childs
    *
    *	@access	public
     *	@param	int     $id   
    *   @return string  true/false
    */
    function isNode($id,$table,$arg)
    {
        $sql = "select 1 from ".$table." where ".$arg." = '".$id."'";
        $result = $this->db->query($sql);
        if (DB::isError($result)) 
        {
            return "Error. ".$this->db->getMessage();
        }
        
        if ($result->numRows()  > 0)
        {
            return true;
        }
                
        return  false;
    }
	
    /**
    *	merges two tables by argument
    *   puts all data in a xmlfilestring.
    *
    *	@access	private
    *	@param	string	$dbFctTableOne
    *	@param	string	$dbFctTableTwo
    *	@param	array	$dbFctTabArgument    key=>value pairs
    *	@param	array	$dbFctTabArgumentTwo key=>value pairs
	*	@param	string	$dbFctOrderby
    *	@param	int		$dbDisconnect 0/1 disconnect database optional
    *	@return	string  merged table data as Xml_file_string
    */
	function joinTabByArgtoArray ($dbFctTableOne,$dbFctTableTwo,$dbFctTabArgument="NO",$dbFctTabArgumentTwo="NO",$dbFctOrderby="NO",$dbDisconnect=0)
	{
		$mySqlStatement = "select * from $dbFctTableOne left join $dbFctTableTwo";
		if (($dbFctTabArgument!="NO")AND($dbFctTabArgument!=""))
		{
			$i=0;
			foreach($dbFctTabArgument as $key => $value)
			{
				$TabCol[$i] 		= $key;
				$TabColVal[$i]		= $value;
				$i++;
			}
			$j=0;
			foreach($dbFctTabArgumentTwo as $key => $value)
			{
				$TabColTwo[$j] 		= $key;
				$TabColValTwo[$j]	= $value;
				$j++;
			}
			$mySqlStatement .= " on $dbFctTableOne.$TabCol[0] = $dbFctTableTwo.$TabColTwo[0] where $dbFctTableOne.$TabCol[0] = $TabColVal[0]";
			// second argument for table one
			if($i > 1)
			{
				for( $k=1; $k < $i; $k++ )
				{
					$mySqlStatement .= " and $dbFctTableOne.$TabCol[$k] = $TabColVal[$k]";
				}
			}
			// second argument for table two
			if($j > 1)
			{
				for( $k=1; $k < $j; $k++ )
				{
					$mySqlStatement .= " and $dbFctTableTwo.$TabColTwo[$k] = $TabColValTwo[$k]";
				}
			}
		}
		if (($dbFctOrderby!="NO")AND($dbFctOrderby!=""))
		{
			$mySqlStatement .= " order by $dbFctOrderby";
		}
		//echo $mySqlStatement;
		// process query
		//echo $mySqlStatement."<br>";
		$dbResult = $this->db->query($mySqlStatement);
		// if error
		if (DB::isError($dbResult)) 
        {    
			/*$err = "No result for query in function dbFunctions::joinTabByArgtoArray:".$mySqlStatement;
            $errorhandlingClass= new dbFunctions();
			$errorhandlingClass->getErrorMessage($err);
			unset($errorhandlingClass);*/
            return "error by joining<br>";
        }
		// get rows
		while($row = $dbResult->fetchRow(DB_FETCHMODE_ASSOC))
		{
			$dbFctTabjoinTabArray[] = $row;
		}
		// close connection if not needed
		if ($dbDisconnect!=0)
		{
			DB::disconnect();
		}
		// return
		return $dbFctTabjoinTabArray;
	//end function
	}
	
	
	/**
    *	gets all table data by optional number
	*	of Arguments.
	*	optional Methods AND/OR --Default = AND
    *
    *	@access	private
    *	@param	string	$dbFctTable
    *	@param	array	$dbFctTabArguments
    *	@param	string	$dbFctMethod
    *	@param	string	$dbFctOrderby
    *	@param	int		$dbDisconnect 0/1 disconnect database optional
    *	@return	array  table data as array
    */
	function tabToArrayWhithArg ($dbFctTable,$dbFctTabArguments=0,$dbFctMethod="AND",$dbFctOrderby="NO",$dbDisconnect=0)
	{
		// reset counter
		$tabFctCounter=0;
		// proceed statement
		$mySqlStatement = "select * from $dbFctTable";
		if ($dbFctTabArguments!=0)
		{
			foreach($dbFctTabArguments as $key => $value)
			{
				if ($tabFctCounter==0)
				{
					$mySqlStatement .=" where ".$key." = '".$value."'";
				}
				else
				{
					//check for AND/OR statement
					$dbFctMethod = strtoupper($dbFctMethod);
					if ($dbFctMethod=="OR")
					{
						$mySqlStatement .=" or ".$key." = '".$value."'";
					}
					else
					{
						$mySqlStatement .=" and ".$key." = '".$value."'";
					}
				}
			$tabFctCounter=1;
			}
		$tabFctCounter=0;
		}
		// check for order by statement
		$dbFctOrderby = strtoupper($dbFctOrderby);
		if (($dbFctOrderby!="NO")AND($dbFctOrderby!=""))
		{
			$mySqlStatement .= " order by $dbFctOrderby";
		}
		//get results from Database
		$dbResult = $this->db->query($mySqlStatement);
		if (DB::isError($dbResult)) 
        {    
			$err = "No result for query in function dbFunctions::tabToArrayWhithArg :".$mySqlStatement;
            $errorhandlingClass= new dbFunctions();
			$errorhandlingClass->getErrorMessage($err);
			unset($errorhandlingClass);
            return false;
        }
		// get rows
		while($row = $dbResult->fetchRow(DB_FETCHMODE_ASSOC))
		{
			$dbFctTabArray[] = $row;
		}
		// close connection if not needed
		if ($dbDisconnect!=0)
		{
			DB::disconnect();
		}
		// return
		return $dbFctTabArray;
	//end function
	}
	

	/**
    *	update table
	*	optional Methods AND/OR --Default = AND
    *
    *	@access	private
    *	@param	string	$dbFctTable
	*	@param	array	$dbFctTabValues
    *	@param	array	$dbFctTabArguments
    *	@param	string	$dbFctMethod
    *	@param	int		$dbDisconnect 0/1 disconnect database optional
    *	@return	string  $status
    */
	function updateTable ($dbFctTable,$dbFctTabValues=0,$dbFctTabArguments=0,$dbFctMethod="AND",$dbDisconnect=0)
	{
		// set default for statu
		$status = "ok";
		// reset counter
		$tabFctCounter=0;
		// proceed statement
		$mySqlStatement = "update $dbFctTable";
		if ($dbFctTabValues!=0)
		{
			foreach($dbFctTabValues as $key => $value)
			{
				if ($tabFctCounter==0)
				{
					$mySqlStatement .=" set ".$key." = '".$value."'";
				}
				else
				{
					$mySqlStatement .=", ".$key." = '".$value."'";
				}
			$tabFctCounter=1;
			}
		$tabFctCounter=0;
		}
		// check for Where   $dbFctTabArguments
		if ($dbFctTabArguments!=0)
		{
			foreach($dbFctTabArguments as $key => $value)
			{
				if ($tabFctCounter==0)
				{
					$mySqlStatement .=" where ".$key." = '".$value."'";
				}
				else
				{
					//check for AND/OR statement
					$dbFctMethod = strtoupper($dbFctMethod);
					if ($dbFctMethod=="OR")
					{
						$mySqlStatement .=" or ".$key." = '".$value."'";
					}
					else
					{
						$mySqlStatement .=" and ".$key." = '".$value."'";
					}
				}
			$tabFctCounter=1;
			}
		$tabFctCounter=0;
		}
		//get results from Database
		$dbResult = $this->db->query($mySqlStatement);
		if (DB::isError($dbResult)) 
        {    
			$err = "Updatestatement wrong dbFunctions::updateTable :".$mySqlStatement;
            $errorhandlingClass= new dbFunctions();
			$errorhandlingClass->getErrorMessage($err);
			unset($errorhandlingClass);
			$status = "error";
            return $status;
        }
		// close connection if not needed
		if ($dbDisconnect!=0)
		{
			DB::disconnect();
		}
		// return
		return $status;
	//end function
	}

    /**
    *	check for default rule messages
    *
    *	@access	public
    *	@param	int     projectId  index
    *   @return array   default messages
    */
	function checkForDefaultRuleMessages($projectId)
	{
		global  $cfgTabError;
		
		// check for default messages
		//
		// get defaultRulesMessages if set for project
        $sql = "select ERROR_LANG, ERROR_TYPE, ERROR_MESSAGE 
			from $cfgTabError 
			where ERROR_PROJECT_ID = '$projectId'";
		//
		$result = $this->db->query($sql);
		if (DB::isError($result)) 
		{
			$this->errorMessage = $result->getMessage()."SQL: $sql";
			return false;
		}
		if($result->numRows() > 0)
		{
			while ($row = $result->fetchRow(DB_FETCHMODE_ASSOC))
	        {
				$existingRules[$row["ERROR_LANG"]][$row["ERROR_TYPE"]] = $row["ERROR_MESSAGE"];
			}
		}
		// else get global defaultRulesMessages
		else
		{
			// sql
	        $sql = "select ERROR_LANG, ERROR_TYPE, ERROR_MESSAGE 
				from $cfgTabError 
				where ERROR_PROJECT_ID = '0'";
			//
			$result = $this->db->query($sql);
			if (DB::isError($result)) 
			{
				$this->errorMessage = $result->getMessage()."SQL: $sql";
				return false;
			}
			while ($row = $result->fetchRow(DB_FETCHMODE_ASSOC))
	        {
				$existingRules[$row["ERROR_LANG"]][$row["ERROR_TYPE"]] = $row["ERROR_MESSAGE"];
			}
		}
		
		// return default messages
		return $existingRules;
	}
	
	
// end class
}


/**
* basic output functions class
*
* inits global variables
*
* @author  Jrn Allert <allert@serie-a.de>
* @author  Rene Renk <renk@serie-a.de>
* @access  public
*/
class outputFunctions
{

	/**
    *	gets error message
    *
    *	@access	private
    *	@param	string	$err
    */
    function getErrorMessage($err)
    {
        echo "<br><br>--------------ERROR!!!------------------<br><b>".$this->errorMessage = $err. "</b><br>--------------ERROR!!!------------------<br><br>";
	//end function
    }

	/**
    *	constructor
    *
    *	@access	private
    *	@param	string	$err
    */
    function outputFunctions()
    {
		// global variables
		
		// global tabs
		global 	$cfgTabResult;
		
		//global templates
		global	$cfgAssessmentSingleOptionPreviewHtml;
		global  $cfgAssessmentMultipleOptionPreviewHtml;
		global	$cfgAssessmentHeaderPreviewHtml;
		global	$cfgAssessmentFooterPreviewHtml;
		global  $cfgAssessmentTableGroupPreviewHtml;
		global	$cfgAssessmentSpacerPreviewHtml;
		
		// set variables (convert to setter methods if needed)
		
		// set tabs
		$this->srvyTabResult						=		$cfgTabResult;
		// set templates
		$this->srvySingleOptionPreviewHtml				=		$cfgAssessmentSingleOptionPreviewHtml;
		$this->srvyMultipleOptionPreviewHtml				=		$cfgAssessmentMultipleOptionPreviewHtml;
		$this->srvyHeaderPreviewHtml					=		$cfgAssessmentHeaderPreviewHtml;
		$this->srvyFooterPreviewHtml					=		$cfgAssessmentFooterPreviewHtml;
		$this->srvyTableGroupPreviewHtml				=		$cfgAssessmentTableGroupPreviewHtml;
		$this->srvySpacerPreviewHtml					=		$cfgAssessmentSpacerPreviewHtml;
    }
	
	/**
    *	removes not needed result values
    *
    *	@access	private
    *	@param	string	$err
    */
    function removeObsolete($resultDataArray)
    {
		return $resultDataArray;
		/*/ function to filter result from not needed values // seems to be obsolete // 030327-rr
		function checkObsolete($myKey)
		{
			if ($myKey=="0")
			{
				return "ok";
			}
			If ($myKey=="currentProcessedForm")
			{
				return "error";
			}
			If ($myKey=="surveySize")
			{
				return "error";
			}
			If ($myKey=="surveyPath")
			{
				return "error";
			}
			If ($myKey=="dummy")
			{
				return "error";
			}
			If ($myKey=="currentProcessedForm")
			{
			return "error";
			}
			If (ereg("form_X0y0Z_nmb_",$myKey))// remove submit,reset element 
			{
				return "error";
			}
		return "ok";
		}
		// end function
		//
		//check for not needed variables
		if(!is_array($resultDataArray))
		{
			return false;
		}
		foreach($resultDataArray as $key => $value)
		{	
			if (!is_array($resultDataArray[$key]))
			{
				$err = "Result array corrupted or already filled in dbFunctions::insertSurveyResults 1";
            	$this->getErrorMessage($err);
	            $status = "ok";
				return $status;
			}
			foreach($resultDataArray[$key] as $key2 => $value2)
			{
				if(!is_array($resultDataArray[$key][$key2]))
				{
					if(checkObsolete($key2)=="ok")
					{
						// transfer data in temporary array
						$newResultDataArray[$key][$key2] = $resultDataArray[$key][$key2];
					}
				}
				else 
				{
					foreach($resultDataArray[$key][$key2] as $key3 => $value3)
					{
						if (is_array($newResultDataArray[$key][$key2][$key3]))
						{
							$err = "Array too big to handle dbFunctions::insertSurveyResults 2";
            				$this->getErrorMessage($err);
				            $status = "ok"; // This error is fatal data can't be inserted !!!!!!!!!!!!////////////!!!!!!!!!!!
							return $status;
						}
						if(checkObsolete($key3)=="ok")
						{
							// transfer data in temporary array
							$newResultDataArray[$key][$key2][$key3] = $resultDataArray[$key][$key2][$key3];
						}
					}
				}
			}
		}
		return $newResultDataArray;
	/*/// end function
    }
// end class
}

/**
* output to batabase functions class
*
* @author  Jrn Allert <allert@serie-a.de>
* @author  Rene Renk <renk@serie-a.de>
* @access  public
*/
class surveyFunctionsDB extends outputFunctions
{

	/**
    *	constructor
    *
    *	@access	public
    */
	function surveyFunctionsDB()
	{	
		// init globals
		parent::outputFunctions();
	}
	
	/**
    *	Creates Resulttables
    *
    *	@access	public
	*	@param	int		$surveyId
    *	@return string  $status 
    */
	function createResultTab($maskId)
	{	
		// default for status
		$status = "ok";
		// open database
		$dbclass = &new DB;
		$dbclass = DB::connect(DSN, true);
		if (DB::isError($dbclass)) 
        {    
			$err = "Could not connect to Database in function dbFunctions::createResultTab";
            $this->getErrorMessage($err);
			$status = "error";
			return $status;
        }
		//
		// Create result tab
		//
		// define create statement for result
        $mySqlStatement = "create table T_PROB_RESULT_".$maskId."(
						RESULT_ID_PK int(11) not null,
						RESULT_USER_ID_FK int(11) not null,
						RESULT_MASK_ID_FK int(11) not null,
						RESULT_FORM_ID int(11) not null,
						RESULT_FORMTYPE_ID int(11) not null,
						RESULT_FORMELEMENT_ID int(11) not null,
						RESULT_MULTIPLEVALUE text,
						foreign key (RESULT_USER_ID_FK) references T_PROB_USERDATA (USERDATA_ID_PK),
						foreign key (RESULT_MASK_ID_FK) references T_PROB_USERMASK (MASK_ID_PK),
						primary key (RESULT_ID_PK))";
		
		//get results from Database
		$dbResult = $dbclass->query($mySqlStatement);
		if (DB::isError($dbResult))
		{	
			//check errorcode
			$errorType = $dbResult->message;
			switch ($errorType)
			{
				case "DB Error: already exists":
				{
				$err = "Database T_PROB_RESULT_".$maskId." already exists in function dbFunctions::createResultTab with maskId :".$maskId." and statement:".$mySqlStatement;
           		$this->getErrorMessage($err);
				$status = "exists";
				break;
				}
				default:
				{
				$err = "Database could not be created in function dbFunctions::createResultTab with maskId :".$maskId." and statement:".$mySqlStatement;
			$this->getErrorMessage($err);
				$status = "syntax";
				return $status;
				}
			}
		}
		// get next free id
        $nextId = $dbclass->nextId("T_PROB_RESULT_".$maskId);
		if (DB::isError($nextId)) 
        {
			$err = "Database ID-sequel-table could not be created in function dbFunctions::createResultTab with maskId :".$maskId;
            $this->getErrorMessage($err);
            $status = "error";
			return $status;
        }

	return $status;
	//end function
	}

	
	
		/**
    *	get Results
    *
    *	@access	public
	*	@param	int		$maskId
    *	@return string  $status
    */	
	function getDBResults($userId, $maskId)
	{	
	
	global $lang_script;
		
		$_SESSION["qffValuePool"]["allFormValues"][0][0][dummy]=123456789;		
		
		$_POST[dummy]=123456789;

		// open database
		$dbclass = &new DB;
		$dbclass = DB::connect(DSN, true);
		if (DB::isError($dbclass)) 
        {    
			$err = "Could not connect to Database in function dbFunctions::insertSurveyResults";
            $this->getErrorMessage($err);
            $status = "error";
			return $status;
        }
		
		$mySql = "Select * from ".$this->srvyTabResult.$maskId. 
				" WHERE RESULT_USER_ID_FK = $userId and RESULT_MASK_ID_FK = $maskId ORDER BY RESULT_ID_PK ASC";
		
		// proceed statement
        $result = $dbclass->query($mySql);
        if (DB::isError($result)) 
        {
			$err = "Database ".$this->srvyTabResult.$maskId." could not be selected :".$mySql;
         			$this->getErrorMessage($err);

            $status = "dberror";
        }
		
		
		while($row = $result->fetchRow(DB_FETCHMODE_ASSOC))
		{
			$resultArray[] = $row;
			
			$_SESSION["qffValuePool"]["allFormValues"][0][0][$row["RESULT_FORMTYPE_ID"]] = $row["RESULT_MULTIPLEVALUE"];
			
			$_POST[$row["RESULT_FORMTYPE_ID"]] = $row["RESULT_MULTIPLEVALUE"];
			
			if (! $row["RESULT_MULTIPLEVALUE"]) {
				$_POST[$row["RESULT_FORMTYPE_ID"]] = $row["RESULT_FORMELEMENT_ID"];
				$_SESSION["qffValuePool"]["allFormValues"][0][0][$row["RESULT_FORMTYPE_ID"]] = $row["RESULT_FORMELEMENT_ID"];
			}
			
			
		}
		
		
		
		$_SESSION["qffValuePool"]["allFormValues"][0][0][currentProcessedForm]=1;
		$_SESSION["qffValuePool"]["allFormValues"][0][0][surveySize]=1;
		$_SESSION["qffValuePool"]["allFormValues"][0][0][surveyPath]=0;
		$_SESSION["qffValuePool"]["allFormValues"][0][0][form_X0y0Z_nmb_9]=$lang_script["dbfunctions.assess.inc.php"]["send"]; 		
		
		$_POST[currentProcessedForm]=1;
		$_POST[surveySize]=1;
		$_POST[surveyPath]=0;
		$_POST[form_X0y0Z_nmb_9]=$lang_script["dbfunctions.assess.inc.php"]["continue"];		

	}
	
	
		/**
    *	get Results
    *
    *	@access	public
	*	@param	int		$maskId
    *	@return string  $status
    */	
	function deleteDBResults($userId, $maskId)
	{	
		// open database
		$dbclass = &new DB;
		$dbclass = DB::connect(DSN, true);
		if (DB::isError($dbclass)) 
        {    
			$err = "Could not connect to Database in function dbFunctions::insertSurveyResults";
            $this->getErrorMessage($err);
            $status = "error";
			return $status;
        }
		
		$mySql = "Delete from ".$this->srvyTabResult.$maskId. 
				" WHERE RESULT_USER_ID_FK = $userId and RESULT_MASK_ID_FK = $maskId";
		
		// proceed statement
        $result = $dbclass->query($mySql);
        if (DB::isError($result)) 
        {
			$err = "Database ".$this->srvyTabResult.$maskId." could not be selected :".$mySql;
         			$this->getErrorMessage($err);

            $status = "dberror";
        }
		
		return true;
	}
	

	/**
    *	Inserts Results
    *
    *	@access	public
	*	@param	int		$maskId
    *	@return string  $status
    */	
	function insertSurveyResults($sessionDataArray,$resultDataArray=0, $userId, $maskId)
	{	
		// default for status
		$status = "ok";
		//
		// split session array
		$SessionSurveyArray	= $sessionDataArray["qffValuePool"]["qffSessionSurveyArray"];
		$sessionTypeArray	= $sessionDataArray["qffValuePool"]["qffSessionTypeArray"];
		$resultDataArray	= $sessionDataArray["qffValuePool"]["allFormValues"];

		// delete not needed data
		unset($sessionDataArray["qffValuePool"]);

		// delete not needed data
		unset($SessionSurveyArray);
		//
		//check for not needed variables
		$resultDataArray = $this->removeObsolete($resultDataArray);
		//	
		
		// open database
		$dbclass = &new DB;
		$dbclass = DB::connect(DSN, true);
		if (DB::isError($dbclass)) 
        {    
			$err = "Could not connect to Database in function dbFunctions::insertSurveyResults";
            $this->getErrorMessage($err);
            $status = "error";
			return $status;
        }

		if(!is_array($resultDataArray))
		{
			return;
		}
		
		
		
		// parse results
		foreach ($resultDataArray as $resultArrayKey => $resultArrayValues)
		{
			if(!is_array($resultArrayValues))
			{
				continue;
			}
			//
			foreach($sessionTypeArray[$resultArrayKey] as $typeKey => $typeValue)
			{
				if(!is_array($resultArrayValues[$typeKey]))
				{
					continue;
				}
				
				
				//
				foreach ($resultArrayValues[$typeKey] as $idKey => $inputValue)
				{
					for ($j=0; $j<count($typeValue);$j++)
					{
						// ... check referring Formdataelements
						if ($typeValue[$j][0]["FORMTYPE_ID_PK"] == $idKey)
						{
							$toInsertData = $typeValue[$j];
							//
							if (($toInsertData[0]["FORMTYPE_TYPE"]=="text")OR($toInsertData[0]["FORMTYPE_TYPE"]=="textarea")OR($toInsertData[0]["FORMTYPE_TYPE"]=="password"))
							{
								// make insert into resulttab
								//
								if (!$inputValue)
								{
									continue;
								}
								// define values
								$toFillFilledId			= $filledFormId;
								$toFillFormsId			= $toInsertData[0]["FORMTYPE_FORM_ID_FK"];
								$toFillFormtypeId		= $toInsertData[0]["FORMTYPE_ID_PK"];
								$toFillFormelementId		= $toInsertData[0]["FORMELEMENT_ID_PK"];
								$toFillValue			= $inputValue;
								// get next free id
								//
								//define masterId If statement fails user can try to send the form again
								//
						        $masterId[] = $nextId = $dbclass->nextId($this->srvyTabResult.$maskId);
								//
								if (DB::isError($nextId)) 
						        {
									$err = "Database ID-sequel-table could not be incremented in function dbFunctions::insertSurveyResults with maskId :".$maskId;
			            			$this->getErrorMessage($err);
						            $status = "dberror";
						        }
								//
								// create statement
								$mySql = "insert into ".$this->srvyTabResult.$maskId. 
										"(RESULT_ID_PK, RESULT_USER_ID_FK, RESULT_MASK_ID_FK, RESULT_FORM_ID, RESULT_FORMTYPE_ID, RESULT_FORMELEMENT_ID, RESULT_MULTIPLEVALUE) 
										values 
										('$nextId', '$userId', '$maskId', '$toFillFormsId', '$toFillFormtypeId', '$toFillFormelementId', '$toFillValue')";
								//
								// proceed statement
						        $result = $dbclass->query($mySql);
						        if (DB::isError($result)) 
						        {
									$err = "Database ".$this->srvyTabResult.$maskId." could not be inserted in in function dbFunctions::insertSurveyResults with statement :".$mySql;
			            			$this->getErrorMessage($err);
									$waste = array_pop($masterId);// this id has not been inserted and cant be deleted
						            $status = "dberror";
						        }
							}
							//
							// check for matching Formtype radio checkbox select
							else
							{
								//switch for checkbox radio or select
								switch ($toInsertData[0]["FORMTYPE_TYPE"])
								{
									// if is radio
									case "radio":
									{
										// find matching Element
										for ($k=0;$k<count($toInsertData);$k++)
										{
											if ($toInsertData[$k]["FORMELEMENT_ID_PK"]== $inputValue)
											{
												$radioIndex = $k;
											}
										}
										// define values
										$toFillFilledId			= $filledFormId;
										$toFillFormsId			= $toInsertData[$radioIndex]["FORMTYPE_FORM_ID_FK"];
										$toFillFormtypeId		= $toInsertData[$radioIndex]["FORMTYPE_ID_PK"];
										$toFillFormelementId		= $toInsertData[$radioIndex]["FORMELEMENT_ID_PK"];
										$toFillValue			= $toInsertData[$radioIndex]["FORMELEMENT_MULTIPLEVALUE"];
										// get next free id
								        $masterId[] = $nextId = $dbclass->nextId($this->srvyTabResult.$maskId);
										if (DB::isError($nextId)) 
								        {
											$err = $err = "Database ID-sequel-table could not be incremented in function dbFunctions::insertSurveyResults with maskId :".$maskId;
			            					$this->getErrorMessage($err);
								            $status = "dberror";
								        }
										//
										// create statement
										$mySql = "insert into ".$this->srvyTabResult.$maskId. 
												"(RESULT_ID_PK, RESULT_USER_ID_FK, RESULT_MASK_ID_FK, RESULT_FORM_ID, RESULT_FORMTYPE_ID, RESULT_FORMELEMENT_ID, RESULT_MULTIPLEVALUE) 
												values 
												('$nextId', '$userId', '$maskId', '$toFillFormsId', '$toFillFormtypeId', '$toFillFormelementId', '$toFillValue')";
										//
										// proceed statement
								        $result = $dbclass->query($mySql);
								        if (DB::isError($result)) 
								        {
											$err = "Database ".$this->srvyTabResult.$maskId." could not be inserted in in function dbFunctions::insertSurveyResults with statement :".$mySql;
			            					$this->getErrorMessage($err);
											$waste = array_pop($masterId);// this id has not been inserted and cant be deleted
								            $status = "dberror";
								        }
										break;
										//
									}
									// end case radio
									//
									// if is radiotable
									case "radiotable":
									{
										//
										// find matching Element
										for ($radioIndex=0;$radioIndex<count($toInsertData);$radioIndex++)
										{	
											foreach($inputValue as $key => $value)
											{
												if ($toInsertData[$radioIndex]["FORMELEMENT_ID_PK"] ==  $value)
												{
													// define values
													$toFillFilledId			= $filledFormId;
													$toFillFormsId			= $toInsertData[$radioIndex]["FORMTYPE_FORM_ID_FK"];
													$toFillFormtypeId		= $toInsertData[$radioIndex]["FORMTYPE_ID_PK"];
													$toFillFormelementId		= $toInsertData[$radioIndex]["FORMELEMENT_ID_PK"];
													$toFillValue			= $toInsertData[$radioIndex]["FORMELEMENT_MULTIPLEVALUE"];
													// get next free id
											        $masterId[] = $nextId = $dbclass->nextId($this->srvyTabResult.$maskId);
													if (DB::isError($nextId)) 
											        {
														$err = $err = "Database ID-sequel-table could not be incremented in function dbFunctions::insertSurveyResults with maskId :".$maskId;
						            					$this->getErrorMessage($err);
											            $status = "dberror";
											        }
													//
													// create statement
													$mySql = "insert into ".$this->srvyTabResult.$maskId. 
															"(RESULT_ID_PK, RESULT_USER_ID_FK, RESULT_MASK_ID_FK, RESULT_FORM_ID, RESULT_FORMTYPE_ID, RESULT_FORMELEMENT_ID, RESULT_MULTIPLEVALUE) 
															values 
															('$nextId', '$userId', '$maskId', '$toFillFormsId', '$toFillFormtypeId', '$toFillFormelementId', '$toFillValue')";
													//
													// proceed statement
											        $result = $dbclass->query($mySql);
											        if (DB::isError($result)) 
											        {
														$err = "Database ".$this->srvyTabResult.$maskId." could not be inserted in in function dbFunctions::insertSurveyResults with statement :".$mySql;
						            					$this->getErrorMessage($err);
														$waste = array_pop($masterId);// this id has not been inserted and cant be deleted
											            $status = "dberror";
											        }
												}
											}
										}
										unset($radioIndex);
										break;
										//
									}
									// end case radiotable
									//
									// if is groupedtext
									case "groupedtext":
									{	
										// filter empty value
										if(!is_array($inputValue))
										{
											break;
										}
										foreach($inputValue as $key => $value)
										{
											for ($groupedTextIndex=0;$groupedTextIndex<count($toInsertData);$groupedTextIndex++)
											{
												if($toInsertData[$groupedTextIndex]["FORMELEMENT_ID_PK"] == $key)
												{
													// no value
													if($value == "")
													{
														continue;
													}
													//define data
													$toFillFilledId			= $filledFormId;
													$toFillFormsId			= $toInsertData[$groupedTextIndex]["FORMTYPE_FORM_ID_FK"];
													$toFillFormtypeId		= $toInsertData[$groupedTextIndex]["FORMTYPE_ID_PK"];
													$toFillFormelementId		= $toInsertData[$groupedTextIndex]["FORMELEMENT_ID_PK"];
													$toFillValue			= $value;
													// get next free id
											        $masterId[] = $nextId = $dbclass->nextId($this->srvyTabResult.$maskId);
													if (DB::isError($nextId)) 
											        {
														$err = $err = "Database ID-sequel-table could not be incremented in function dbFunctions::insertSurveyResults with maskId :".$maskId;
			            								$this->getErrorMessage($err);
											            $status = "dberror";
											        }
													//
													// create statement
													$mySql = "insert into ".$this->srvyTabResult.$maskId. 
															"(RESULT_ID_PK, RESULT_USER_ID_FK, RESULT_MASK_ID_FK, RESULT_FORM_ID, RESULT_FORMTYPE_ID, RESULT_FORMELEMENT_ID, RESULT_MULTIPLEVALUE) 
															values 
															('$nextId', '$userId', '$maskId', '$toFillFormsId', '$toFillFormtypeId', '$toFillFormelementId', '$toFillValue')";
													//
													// proceed statement
											        $result = $dbclass->query($mySql);
											        if (DB::isError($result)) 
											        {
														$err = "Database ".$this->srvyTabResult.$maskId." could not be inserted in in function dbFunctions::insertSurveyResults with statement :".$mySql;
			            								$this->getErrorMessage($err);
														$waste = array_pop($masterId);// this id has not been inserted and cant be deleted
											            $status = "dberror";
											        }
												}
											}
										// increment counter for insertdata
										}
										unset($groupedTextIndex);
										break;
										//
									}
									// end case groupedtext
									//
									// if is texttable
									case "texttable":
									{	
										// filter empty value
										if(!is_array($inputValue))
										{
											break;
										}
										foreach($inputValue as $key => $value)
										{
											for ($groupedTextIndex=0;$groupedTextIndex<count($toInsertData);$groupedTextIndex++)
											{
												if($toInsertData[$groupedTextIndex]["FORMELEMENT_ID_PK"] == $key)
												{
													// no value
													if($value == "")
													{
														continue;
													}
													//define data
													$toFillFilledId			= $filledFormId;
													$toFillFormsId			= $toInsertData[$groupedTextIndex]["FORMTYPE_FORM_ID_FK"];
													$toFillFormtypeId		= $toInsertData[$groupedTextIndex]["FORMTYPE_ID_PK"];
													$toFillFormelementId		= $toInsertData[$groupedTextIndex]["FORMELEMENT_ID_PK"];
													$toFillValue			= $value;
													// get next free id
											        $masterId[] = $nextId = $dbclass->nextId($this->srvyTabResult.$maskId);
													if (DB::isError($nextId)) 
											        {
														$err = $err = "Database ID-sequel-table could not be incremented in function dbFunctions::insertSurveyResults with maskId :".$maskId;
			            								$this->getErrorMessage($err);
											            $status = "dberror";
											        }
													//
													// create statement
													$mySql = "insert into ".$this->srvyTabResult.$maskId. 
															"(RESULT_ID_PK, RESULT_USER_ID_FK, RESULT_MASK_ID_FK, RESULT_FORM_ID, RESULT_FORMTYPE_ID, RESULT_FORMELEMENT_ID, RESULT_MULTIPLEVALUE) 
															values 
															('$nextId', '$userId', '$maskId', '$toFillFormsId', '$toFillFormtypeId', '$toFillFormelementId', '$toFillValue')";
													//
													// proceed statement
											        $result = $dbclass->query($mySql);
											        if (DB::isError($result)) 
											        {
														$err = "Database ".$this->srvyTabResult.$maskId." could not be inserted in in function dbFunctions::insertSurveyResults with statement :".$mySql;
			            								$this->getErrorMessage($err);
														$waste = array_pop($masterId);// this id has not been inserted and cant be deleted
											            $status = "dberror";
											        }
												}
											}
										// increment counter for insertdata
										}
										unset($groupedTextIndex);
										break;
										//
									}
									// end case texttable
									//
									// if is switchtext
									case "switchtext":
									{	
										// filter empty value
										if(!is_array($inputValue))
										{
											break;
										}
										
										$key   = key($inputValue);
										$value = $inputValue[$key];
										
										if($value == "")
										{
											break;
										}
										//define data
										$toFillFilledId			= $filledFormId;
										$toFillFormsId			= $toInsertData[0]["FORMTYPE_FORM_ID_FK"];
										$toFillFormtypeId		= $toInsertData[0]["FORMTYPE_ID_PK"];
										$toFillFormelementId		= $toInsertData[0]["FORMELEMENT_ID_PK"];
										$toFillValue			= $value;
										// get next free id
								        $masterId[] = $nextId = $dbclass->nextId($this->srvyTabResult.$maskId);
										if (DB::isError($nextId)) 
								        {
											$err = $err = "Database ID-sequel-table could not be incremented in function dbFunctions::insertSurveyResults with maskId :".$maskId;
	           								$this->getErrorMessage($err);
								            $status = "dberror";
								        }
										//
										// create statement
										$mySql = "insert into ".$this->srvyTabResult.$maskId. 
												"(RESULT_ID_PK, RESULT_USER_ID_FK, RESULT_MASK_ID_FK, RESULT_FORM_ID, RESULT_FORMTYPE_ID, RESULT_FORMELEMENT_ID, RESULT_MULTIPLEVALUE) 
												values 
												('$nextId', '$userId', '$maskId', '$toFillFormsId', '$toFillFormtypeId', '$toFillFormelementId', '$toFillValue')";
										//
										// proceed statement
								        $result = $dbclass->query($mySql);
								        if (DB::isError($result)) 
								        {
											$err = "Database ".$this->srvyTabResult.$maskId." could not be inserted in in function dbFunctions::insertSurveyResults with statement :".$mySql;
	           								$this->getErrorMessage($err);
											$waste = array_pop($masterId);// this id has not been inserted and cant be deleted
								            $status = "dberror";
								        }
										break;
										//
									}
									// end case switchtext
									//
									// if is checkbox
									case "checkbox":
									{	
										// filter empty value
										if(!is_array($inputValue))
										{
											break;
										}
										
										foreach($inputValue as $key => $value)
										{
											for ($checkIndex=0;$checkIndex<count($toInsertData);$checkIndex++)
											{
												if($toInsertData[$checkIndex]["FORMELEMENT_ID_PK"] == $key)
												{
													$toFillFilledId			= $filledFormId;
													$toFillFormsId			= $toInsertData[$checkIndex]["FORMTYPE_FORM_ID_FK"];
													$toFillFormtypeId		= $toInsertData[$checkIndex]["FORMTYPE_ID_PK"];
													$toFillFormelementId		= $toInsertData[$checkIndex]["FORMELEMENT_ID_PK"];
													$toFillValue			= $toInsertData[$checkIndex]["FORMELEMENT_MULTIPLEVALUE"];
													// get next free id
											        $masterId[] = $nextId = $dbclass->nextId($this->srvyTabResult.$maskId);
													if (DB::isError($nextId)) 
											        {
														$err = $err = "Database ID-sequel-table could not be incremented in function dbFunctions::insertSurveyResults with maskId :".$maskId;
			            								$this->getErrorMessage($err);
											            $status = "dberror";
											        }
													//
													// create statement
													$mySql = "insert into ".$this->srvyTabResult.$maskId. 
															"(RESULT_ID_PK, RESULT_USER_ID_FK, RESULT_MASK_ID_FK, RESULT_FORM_ID, RESULT_FORMTYPE_ID, RESULT_FORMELEMENT_ID, RESULT_MULTIPLEVALUE) 
															values 
															('$nextId', '$userId', '$maskId', '$toFillFormsId', '$toFillFormtypeId', '$toFillFormelementId', '$toFillValue')";
													//
													// proceed statement
											        $result = $dbclass->query($mySql);
											        if (DB::isError($result)) 
											        {
														$err = "Database ".$this->srvyTabResult.$maskId." could not be inserted in in function dbFunctions::insertSurveyResults with statement :".$mySql;
			            								$this->getErrorMessage($err);
														$waste = array_pop($masterId);// this id has not been inserted and cant be deleted
											            $status = "dberror";
											        }
												}
											}
										// increment counter for insertdata
										}
										unset($checkIndex);
										break;
										//
									}
									// end case checkbox
									//
									// if is checkboxtable
									case "checkboxtable":
									{	
										// filter empty value
										if(!is_array($inputValue))
										{
											break;
										}
										
										foreach($inputValue as $key => $value)
										{
											for ($checkIndex=0;$checkIndex<count($toInsertData);$checkIndex++)
											{
												if($toInsertData[$checkIndex]["FORMELEMENT_ID_PK"] == $key)
												{
													$toFillFilledId			= $filledFormId;
													$toFillFormsId			= $toInsertData[$checkIndex]["FORMTYPE_FORM_ID_FK"];
													$toFillFormtypeId		= $toInsertData[$checkIndex]["FORMTYPE_ID_PK"];
													$toFillFormelementId		= $toInsertData[$checkIndex]["FORMELEMENT_ID_PK"];
													$toFillValue			= $toInsertData[$checkIndex]["FORMELEMENT_MULTIPLEVALUE"];
													// get next free id
											        $masterId[] = $nextId = $dbclass->nextId($this->srvyTabResult.$maskId);
													if (DB::isError($nextId)) 
											        {
														$err = $err = "Database ID-sequel-table could not be incremented in function dbFunctions::insertSurveyResults with maskId :".$maskId;
			            								$this->getErrorMessage($err);
											            $status = "dberror";
											        }
													//
													// create statement
													$mySql = "insert into ".$this->srvyTabResult.$maskId. 
															"(RESULT_ID_PK, RESULT_USER_ID_FK, RESULT_MASK_ID_FK, RESULT_FORM_ID, RESULT_FORMTYPE_ID, RESULT_FORMELEMENT_ID, RESULT_MULTIPLEVALUE) 
															values 
															('$nextId', '$userId', '$maskId', '$toFillFormsId', '$toFillFormtypeId', '$toFillFormelementId', '$toFillValue')";
													//
													// proceed statement
											        $result = $dbclass->query($mySql);
											        if (DB::isError($result)) 
											        {
														$err = "Database ".$this->srvyTabResult.$maskId." could not be inserted in in function dbFunctions::insertSurveyResults with statement :".$mySql;
			            								$this->getErrorMessage($err);
														$waste = array_pop($masterId);// this id has not been inserted and cant be deleted
											            $status = "dberror";
											        }
												}
											}
										// increment counter for insertdata
										}
										unset($checkIndex);
										break;
										//
									}
									// end case checkboxtable
									//
									// if is select
									case "select":
									{
										/* predefined method to check multiple selects, deactivated cause not needed yet // 030306-rr
										//
										$selectIndex=0;
										if(is_array($inputValue))
										{
											// multiple results
											foreach($inputValue as $key => $value)
											{
												if($toInsertData[$selectIndex]["FORMELEMENT_ID_PK"] == $value)
												{
													$toFillFilledId			= $filledFormId;
													$toFillFormsId			= $toInsertData[$selectIndex]["FORMTYPE_FORM_ID_FK"];
													$toFillFormtypeId		= $toInsertData[$selectIndex]["FORMTYPE_ID_PK"];
													$toFillFormelementId		= $toInsertData[$selectIndex]["FORMELEMENT_ID_PK"];
													$toFillValue			= $toInsertData[$selectIndex]["FORMELEMENT_ADDHEADER"];
													// get next free id
											        $masterId[] = $nextId = $dbclass->nextId($this->srvyTabResult.$maskId);
													if (DB::isError($nextId)) 
											        {
														$err = $err = "Database ID-sequel-table could not be incremented in function dbFunctions::insertSurveyResults with maskId :".$maskId;
											            $errorhandlingClass= new dbFunctions();
														$errorhandlingClass->getErrorMessage($err);
														unset($errorhandlingClass);
											            $status = "dberror";
												    }
													//
													// create statement
													$mySql = "insert into ".$this->srvyTabResult.$maskId. 
															"(RESULT_ID_PK, RESULT_FILLED_ID_FK, RESULT_FORM_ID, RESULT_FORMTYPE_ID, RESULT_FORMELEMENT_ID, RESULT_MULTIPLEVALUE) 
															values 
															('$nextId', '$toFillFilledId', '$toFillFormsId', '$toFillFormtypeId', '$toFillFormelementId', '$toFillValue')";
													//
													// proceed statement
											        $result = $dbclass->query($mySql);
											        if (DB::isError($result)) 
											        {
														$err = "Database ".$this->srvyTabResult.$maskId." could not be inserted in in function dbFunctions::insertSurveyResults with statement :".$mySql;
		            									$this->getErrorMessage($err);
														$waste = array_pop($masterId);// this id has not been inserted and cant be deleted
											            $status = "dberror";
													}
												}
											// end if
											$selectIndex++;
											}
											unset($selectIndex);
											break;
										}*/
										if($inputValue)
										{
											//only one result
											$key	=	$idKey;
											$value	=	$inputValue;
											for ($selectIndex=0;$selectIndex<count($toInsertData);$selectIndex++)
											{
												if($toInsertData[$selectIndex]["FORMELEMENT_ID_PK"] == $value)
												{
													$toFillFilledId			= $filledFormId;
													$toFillFormsId			= $toInsertData[$selectIndex]["FORMTYPE_FORM_ID_FK"];
													$toFillFormtypeId		= $toInsertData[$selectIndex]["FORMTYPE_ID_PK"];
													$toFillFormelementId		= $toInsertData[$selectIndex]["FORMELEMENT_ID_PK"];
													$toFillValue			= $toInsertData[$selectIndex]["FORMELEMENT_MULTIPLEVALUE"];
													// get next free id
											        $masterId[] = $nextId = $dbclass->nextId($this->srvyTabResult.$maskId);
													if (DB::isError($nextId)) 
											        {
														$err = "Database ID-sequel-table could not be incremented in function dbFunctions::insertSurveyResults with maskId :".$maskId;
											            $errorhandlingClass= new dbFunctions();
														$errorhandlingClass->getErrorMessage($err);
														unset($errorhandlingClass);
											            $status = "dberror";
												    }
													//
													// create statement
													$mySql = "insert into ".$this->srvyTabResult.$maskId. 
															"(RESULT_ID_PK, RESULT_USER_ID_FK, RESULT_MASK_ID_FK, RESULT_FORM_ID, RESULT_FORMTYPE_ID, RESULT_FORMELEMENT_ID, RESULT_MULTIPLEVALUE) 
															values 
															('$nextId', '$userId', '$maskId', '$toFillFormsId', '$toFillFormtypeId', '$toFillFormelementId', '$toFillValue')";
													//
													// proceed statement
											        $result = $dbclass->query($mySql);
											        if (DB::isError($result)) 
											        {
														$err = "Database ".$this->srvyTabResult.$maskId." could not be inserted in in function dbFunctions::insertSurveyResults with statement :".$mySql;
		            									$this->getErrorMessage($err);
														$waste = array_pop($masterId);// this id has not been inserted and cant be deleted
											            $status = "dberror";
													}
												}
												// end if
											}										
											unset($selectIndex);
											break;
										}
										//
									}
									// end case select
								}
								// end switch ($toInsertData[0]["FORMTYPE_TYPE"])
							}
							// endif (($toInsertData[0]["FORMTYPE_TYPE"]=="text")OR...
						}
						//end if ($typeArrayValues[$j][0]["FORMTYPE_ID_PK"] == $idKey)
					}
					// end for ($j=0; $j<count($typeValue);$j++)
				}
				//foreach ($resultArrayValues[$typeKey] as $idKey => $inputValue)
			}
			// end foreach($sessionTypeArray[$resultArrayKey] as $typeKey => $typeValue)
		}
		// end foreach ($resultDataArray as $resultArrayKey => $resultArrayValues)
		//
		// check if dberror occurred and delete current inserted data to avoid incomplete inserts
		// insert can be retried
		//
		if ($status=="dberror")
		{
			for($k=0;$k<count($masterId);$k++)
			{
				// delete alredy filled values
				$mySql = "delete 
					from ".$this->srvyTabResult.$maskId." 
					where RESULT_ID_PK = '".$masterId[$k]."'";
				//
				echo $mySql."<br><br>";
				// proceed statement
				$result = $dbclass->query($mySql);
				if (DB::isError($result)) 
				{
					$err = "Serious Error. Database ".$this->srvyTabResult.$maskId." could not be freed from incomplete inserts in in function dbFunctions::insertSurveyResults with data_id :".$masterId[$k]." and Statement: ".$mySql;
					$this->getErrorMessage($err);
					$status = "ok"; // if this fails end insertion. Very fatal error !!!!
					return $status;
				}
			$status = "error";
			}
		$status = "error";
		}
		//echo $status;
		//print_r($masterId);
		//print_r($resultDataArray);
		return $status;
	}
// end class
}

/**
* output to screen functions class
*
* @author  Jrn Allert <allert@serie-a.de>
* @author  Rene Renk <renk@serie-a.de>
* @access  public
*/
class previewSurvey extends outputFunctions
{
	
	/**
    *	show Results
    *
    *	@access	public
	*	@param	int		$maskId
    *	@return string  $status
    */
	function previewSurvey($sessionDataArray,$resultDataArray=0)
	{
		global $lang_script;
		
		// init globals
		parent::outputFunctions();
		//
		// default for status
		$status = "ok";
		//
		// split session array
		$SessionSurveyArray	= $sessionDataArray["qffValuePool"]["qffSessionSurveyArray"];
		$sessionTypeArray	= $sessionDataArray["qffValuePool"]["qffSessionTypeArray"];
		$resultDataArray	= $sessionDataArray["qffValuePool"]["allFormValues"];
		// delete not needed data
		unset($sessionDataArray["qffValuePool"]);
		// get Survey_ID
		$maskId 	= $SessionSurveyArray[0]["PROJECT_ID_PK"];
		// delete not needed data
		unset($SessionSurveyArray);
		//
		//check for not needed variables
		$resultDataArray = $this->removeObsolete($resultDataArray);
		//
		//
		// show Form
		//
		// add header tags
		echo $this->srvyHeaderPreviewHtml;
		//
		if(!is_array($resultDataArray))
		{
			return;
		}
		// parse results
		foreach ($resultDataArray as $resultArrayKey => $resultArrayValues)
		{
			if(!is_array($resultArrayValues))
			{
				continue;
			}
			//
			foreach($sessionTypeArray[$resultArrayKey] as $typeKey => $typeValue)
			{
				if(!is_array($resultArrayValues[$typeKey]))
				{
					continue;
				}
				//
				foreach ($resultArrayValues[$typeKey] as $idKey => $inputValue)
				{
					for ($j=0; $j<count($typeValue);$j++)
					{
						// ... check referring Formdataelements
						if ($typeValue[$j][0]["FORMTYPE_ID_PK"] == $idKey)
						{
							$toInsertData = $typeValue[$j];
							//
							// check for matching Formtype text textarea password
							if (($toInsertData[0]["FORMTYPE_TYPE"]=="text")OR($toInsertData[0]["FORMTYPE_TYPE"]=="textarea")OR($toInsertData[0]["FORMTYPE_TYPE"]=="password"))
							{
								// make insert into resulttab
								//
								//check if value or default
								if (!$inputValue)
								{
									continue;
								}
								// define values
								$toFillFilledId			= $filledFormId;
								$toFillFormsId			= $toInsertData[0]["FORMTYPE_FORM_ID_FK"];
								$toFillFormtypeId		= $toInsertData[0]["FORMTYPE_ID_PK"];
								$toFillFormelementId		= $toInsertData[0]["FORMELEMENT_ID_PK"];
								$toFillValue			= $inputValue;
								//
								// insert resultline
								$question	=	nl2br($toInsertData[0]["FORMTYPE_QUESTION"]);
								$inputValue	=	nl2br($inputValue);
								$previewHtml = $this->srvySingleOptionPreviewHtml;
								$previewHtml = str_replace('{question}',$question , $previewHtml);
								$previewHtml = str_replace('{inputValue}', $inputValue, $previewHtml);
								$outputHTML[$toInsertData[0]["FORMTYPE_ID_PK"]] = $previewHtml;
								
							}
							//
							// check for matching Formtype radio checkbox select
							else
							{
								//echo $toInsertData[0]["FORMTYPE_TYPE"]."<br>";
								//switch for checkbox radio or select
								switch ($toInsertData[0]["FORMTYPE_TYPE"])
								{
									//
									// if is switchtext
									case "switchtext":
									{	
										// free HTMLpool
										$previewHTMLPool = "";
										//
										if(!is_array($inputValue))
										{
											break;
										}
										
										$key   = key($inputValue);
										$value = $inputValue[$key];
										
										if($value == "")
										{
											break;
										}
										//define data
										$toFillFilledId			= $filledFormId;
										$toFillFormsId			= $toInsertData[0]["FORMTYPE_FORM_ID_FK"];
										$toFillFormtypeId		= $toInsertData[0]["FORMTYPE_ID_PK"];
										$toFillFormelementId		= $toInsertData[0]["FORMELEMENT_ID_PK"];
										$toFillValue			= $value;
										//
										// insert resultline
										$question	=	nl2br($toInsertData[0]["FORMTYPE_QUESTION"]);
										$previewHtml = $this->srvyMultipleOptionPreviewHtml;
										$previewHtml = str_replace('{question}', $question, $previewHtml);
										$previewHtml = str_replace('{option}', "Switchtext", $previewHtml);
										$previewHtml = str_replace('{inputValue}', $toFillValue, $previewHtml);
										$outputHTML[$toInsertData[0]["FORMTYPE_ID_PK"]] = $previewHtml;
										break;
										//
									}
									// end case switchtext
									//
									// if is radio
									case "radio":
									{
										// find matching Element
										for ($k=0;$k<count($toInsertData);$k++)
										{
											if ($toInsertData[$k]["FORMELEMENT_ID_PK"]== $inputValue)
											{
												$radioIndex = $k;
											}
										}
										// no value
										if(!$toInsertData[$radioIndex]["FORMELEMENT_MULTIPLEVALUE"])
										{
											$toInsertData[$radioIndex]["FORMELEMENT_MULTIPLEVALUE"] = $lang_script["dbfunctions.assess.inc.php"]["noValue"];
										}
										//define data
										$toFillFilledId			= $filledFormId;
										$toFillFormsId			= $toInsertData[$radioIndex]["FORMTYPE_FORM_ID_FK"];
										$toFillFormtypeId		= $toInsertData[$radioIndex]["FORMTYPE_ID_PK"];
										$toFillFormelementId		= $toInsertData[$radioIndex]["FORMELEMENT_ID_PK"];
										$toFillValue			= $toInsertData[$radioIndex]["FORMELEMENT_MULTIPLEVALUE"];
										//
										// insert resultline
										$question	=	nl2br($toInsertData[0]["FORMTYPE_QUESTION"]);
										$previewHtml = $this->srvyMultipleOptionPreviewHtml;
										$previewHtml = str_replace('{question}', $question, $previewHtml);
										$previewHtml = str_replace('{option}', $toInsertData[$radioIndex]["FORMELEMENT_HEADER"], $previewHtml);
										$previewHtml = str_replace('{inputValue}', $toFillValue, $previewHtml);
										$outputHTML[$toInsertData[$radioIndex]["FORMTYPE_ID_PK"]] = $previewHtml;
										
										unset($radioIndex);
										break;
										//
									}
									// end case radio
									//
									// if is radiotable
									case "radiotable":
									{
										// free HTMLpool
										$previewHTMLPool = "";
										// find matching Element
										for ($radioIndex=0;$radioIndex<count($toInsertData);$radioIndex++)
										{	
											foreach($inputValue as $key => $value)
											{
												if ($toInsertData[$radioIndex]["FORMELEMENT_ID_PK"] ==  $value)
												{
													// no value
													if(!$toInsertData[$radioIndex]["FORMELEMENT_MULTIPLEVALUE"])
													{
														$toInsertData[$radioIndex]["FORMELEMENT_MULTIPLEVALUE"] = $lang_script["dbfunctions.assess.inc.php"]["noValue"];
													}
													//define data
													$toFillFilledId			= $filledFormId;
													$toFillFormsId			= $toInsertData[$radioIndex]["FORMTYPE_FORM_ID_FK"];
													$toFillFormtypeId		= $toInsertData[$radioIndex]["FORMTYPE_ID_PK"];
													$toFillFormelementId		= $toInsertData[$radioIndex]["FORMELEMENT_ID_PK"];
													$toFillValue			= $toInsertData[$radioIndex]["FORMELEMENT_MULTIPLEVALUE"];
													//
													// insert resultline
													$question	=	nl2br($toInsertData[0]["FORMTYPE_QUESTION"]);
													$previewHtml = $this->srvyTableGroupPreviewHtml;
													$previewHtml = str_replace('{question}', $question, $previewHtml);
													$previewHtml = str_replace('{option}', $toInsertData[$radioIndex]["FORMELEMENT_HEADER"], $previewHtml);
													$previewHtml = str_replace('{row}', $toInsertData[$radioIndex]["FORMELEMENT_ADDHEADER"], $previewHtml);
													$previewHtml = str_replace('{inputValue}', $toFillValue, $previewHtml);
													$previewHTMLPool .= $previewHtml;
												}
											}
										}
										$outputHTML[$toInsertData[0]["FORMTYPE_ID_PK"]] = $previewHTMLPool;
										unset($radioIndex);
										break;
										//
									}
									// end case radiotable
									//
									// if is tabletext
									case "texttable":
									{	
										// free HTMLpool
										$previewHTMLPool = "";
										//
										if(!is_array($inputValue))
										{
											break;
										}
										foreach($inputValue as $key => $value)
										{
											for ($groupedTextIndex=0;$groupedTextIndex<count($toInsertData);$groupedTextIndex++)
											{
												if($toInsertData[$groupedTextIndex]["FORMELEMENT_ID_PK"] == $key)
												{
													// no value
													if($value == "")
													{
														continue;
													}
													//define data
													$toFillFilledId			= $filledFormId;
													$toFillFormsId			= $toInsertData[$groupedTextIndex]["FORMTYPE_FORM_ID_FK"];
													$toFillFormtypeId		= $toInsertData[$groupedTextIndex]["FORMTYPE_ID_PK"];
													$toFillFormelementId		= $toInsertData[$groupedTextIndex]["FORMELEMENT_ID_PK"];
													$toFillValue			= $value;
													//
													// insert resultline
													$question	=	nl2br($toInsertData[0]["FORMTYPE_QUESTION"]);
													$previewHtml = $this->srvyTableGroupPreviewHtml;
													$previewHtml = str_replace('{question}', $question, $previewHtml);
													$previewHtml = str_replace('{option}', $toInsertData[$groupedTextIndex]["FORMELEMENT_HEADER"], $previewHtml);
													$previewHtml = str_replace('{row}', $toInsertData[$groupedTextIndex]["FORMELEMENT_ADDHEADER"], $previewHtml);
													$previewHtml = str_replace('{inputValue}', $toFillValue, $previewHtml);
													$previewHTMLPool .= $previewHtml;
												}
											}
										// increment counter for insertdata
										}
										$outputHTML[$toInsertData[0]["FORMTYPE_ID_PK"]] = $previewHTMLPool;
										unset($groupedTextIndex);
										break;
										//
									}
									// end case tabletext
									//
									// if is groupedtext
									case "groupedtext":
									{	
										// free HTMLpool
										$previewHTMLPool = "";
										//
										if(!is_array($inputValue))
										{
											break;
										}
										foreach($inputValue as $key => $value)
										{
											for ($groupedTextIndex=0;$groupedTextIndex<count($toInsertData);$groupedTextIndex++)
											{
												if($toInsertData[$groupedTextIndex]["FORMELEMENT_ID_PK"] == $key)
												{
													// no value
													if($value == "")
													{
														continue;
													}
													//define data
													$toFillFilledId			= $filledFormId;
													$toFillFormsId			= $toInsertData[$groupedTextIndex]["FORMTYPE_FORM_ID_FK"];
													$toFillFormtypeId		= $toInsertData[$groupedTextIndex]["FORMTYPE_ID_PK"];
													$toFillFormelementId		= $toInsertData[$groupedTextIndex]["FORMELEMENT_ID_PK"];
													$toFillValue			= $value;
													//
													// insert resultline
													$question	=	nl2br($toInsertData[0]["FORMTYPE_QUESTION"]);
													$previewHtml = $this->srvyMultipleOptionPreviewHtml;
													$previewHtml = str_replace('{question}', $question, $previewHtml);
													$previewHtml = str_replace('{option}', $toInsertData[$groupedTextIndex]["FORMELEMENT_HEADER"], $previewHtml);
													$previewHtml = str_replace('{inputValue}', $toFillValue, $previewHtml);
													$previewHTMLPool .= $previewHtml;
												}
											}
										// increment counter for insertdata
										}
										$outputHTML[$toInsertData[0]["FORMTYPE_ID_PK"]] = $previewHTMLPool;
										unset($groupedTextIndex);
										break;
										//
									}
									// end case groupedtext
									//
									// if is checkbox
									case "checkbox":
									{	
										// free HTMLpool
										$previewHTMLPool = "";
										//
										if(!is_array($inputValue))
										{
											break;
										}
										foreach($inputValue as $key => $value)
										{
											for ($checkIndex=0;$checkIndex<count($toInsertData);$checkIndex++)
											{
												if($toInsertData[$checkIndex]["FORMELEMENT_ID_PK"] == $key)
												{
													// no value
													if(!$toInsertData[$checkIndex]["FORMELEMENT_MULTIPLEVALUE"])
													{
														$toInsertData[$checkIndex]["FORMELEMENT_MULTIPLEVALUE"] = $lang_script["dbfunctions.assess.inc.php"]["noValue"];
													}
													//define data
													$toFillFilledId			= $filledFormId;
													$toFillFormsId			= $toInsertData[$checkIndex]["FORMTYPE_FORM_ID_FK"];
													$toFillFormtypeId		= $toInsertData[$checkIndex]["FORMTYPE_ID_PK"];
													$toFillFormelementId		= $toInsertData[$checkIndex]["FORMELEMENT_ID_PK"];
													$toFillValue			= $toInsertData[$checkIndex]["FORMELEMENT_MULTIPLEVALUE"];
													//
													// insert resultline
													$question	=	nl2br($toInsertData[0]["FORMTYPE_QUESTION"]);
													$previewHtml = $this->srvyMultipleOptionPreviewHtml;
													$previewHtml = str_replace('{question}', $question, $previewHtml);
													$previewHtml = str_replace('{option}', $toInsertData[$checkIndex]["FORMELEMENT_HEADER"], $previewHtml);
													$previewHtml = str_replace('{inputValue}', $toFillValue, $previewHtml);
													$previewHTMLPool .= $previewHtml;
												}
											}
										// increment counter for insertdata
										}
										$outputHTML[$toInsertData[0]["FORMTYPE_ID_PK"]] = $previewHTMLPool;
										unset($checkIndex);
										break;
										//
									}
									// end case checkbox
									//
									// if is checkboxtable
									case "checkboxtable":
									{	
										// free HTMLpool
										$previewHTMLPool = "";
										//
										if(!is_array($inputValue))
										{
											break;
										}
										foreach($inputValue as $key => $value)
										{
											for ($checkIndex=0;$checkIndex<count($toInsertData);$checkIndex++)
											{
												if($toInsertData[$checkIndex]["FORMELEMENT_ID_PK"] == $key)
												{
													// no value
													if(!$toInsertData[$checkIndex]["FORMELEMENT_MULTIPLEVALUE"])
													{
														$toInsertData[$checkIndex]["FORMELEMENT_MULTIPLEVALUE"] = $lang_script["dbfunctions.assess.inc.php"]["noValue"];
													}
													//define data
													$toFillFilledId			= $filledFormId;
													$toFillFormsId			= $toInsertData[$checkIndex]["FORMTYPE_FORM_ID_FK"];
													$toFillFormtypeId		= $toInsertData[$checkIndex]["FORMTYPE_ID_PK"];
													$toFillFormelementId		= $toInsertData[$checkIndex]["FORMELEMENT_ID_PK"];
													$toFillValue			= $toInsertData[$checkIndex]["FORMELEMENT_MULTIPLEVALUE"];
													//
													// insert resultline
													$question	=	nl2br($toInsertData[0]["FORMTYPE_QUESTION"]);
													$previewHtml = $this->srvyTableGroupPreviewHtml;
													$previewHtml = str_replace('{question}', $question, $previewHtml);
													$previewHtml = str_replace('{option}', $toInsertData[$checkIndex]["FORMELEMENT_HEADER"], $previewHtml);
													$previewHtml = str_replace('{row}', $toInsertData[$checkIndex]["FORMELEMENT_ADDHEADER"], $previewHtml);
													$previewHtml = str_replace('{inputValue}', $toFillValue, $previewHtml);
													$previewHTMLPool .= $previewHtml;
												}
											}
										// increment counter for insertdata
										}
										$outputHTML[$toInsertData[0]["FORMTYPE_ID_PK"]] = $previewHTMLPool;
										unset($checkIndex);
										break;
										//
									}
									// end case checkboxtable
									//
									// if is select
									case "select":
									{
										/* predefined method to check multiple selects, deactivated cause not needed // 030306-rr
										// 
										$selectIndex=0;
										if(is_array($inputValue))
										{
											foreach($inputValue as $key => $value)
											{
												if($toInsertData[$selectIndex]["FORMELEMENT_ID_PK"] == $value)
												{
													// no value
													if(!$toInsertData[$selectIndex]["FORMELEMENT_ADDHEADER"])
													{
														$toInsertData[$selectIndex]["FORMELEMENT_ADDHEADER"] = $lang_script["dbfunctions.assess.inc.php"]["noValue"];
													}
													//define data
													$toFillFilledId			= $filledFormId;
													$toFillFormsId			= $toInsertData[$selectIndex]["FORMTYPE_FORM_ID_FK"];
													$toFillFormtypeId		= $toInsertData[$selectIndex]["FORMTYPE_ID_PK"];
													$toFillFormelementId	= $toInsertData[$selectIndex]["FORMELEMENT_ID_PK"];
													$toFillValue			= $toInsertData[$selectIndex]["FORMELEMENT_MULTIPLEVALUE"];
													//
													// insert resultline
													$question	=	nl2br($toInsertData[0]["FORMTYPE_QUESTION"]);
													$previewHtml = $this->srvyMultipleOptionPreviewHtml;
													$previewHtml = str_replace('{question}', $question, $previewHtml);
													$previewHtml = str_replace('{option}', $toInsertData[$selectIndex]["FORMELEMENT_HEADER"], $previewHtml);
													$previewHtml = str_replace('{inputValue}', $toFillValue, $previewHtml);
													$previewHTMLPool .= $previewHtml;
												}
												// end if
											$selectIndex++;
											}
											$outputHTML[$toInsertData[0]["FORMTYPE_ID_PK"]] = $previewHTMLPool;
											unset($selectIndex);
											break;
										}*/
										
										// free HTMLpool
										$previewHTMLPool = "";
										// check selectvalues, if only one select chooseable
										if($inputValue)
										{
											$key	=	$idKey;
											$value	=	$inputValue;
											for ($selectIndex=0;$selectIndex<count($toInsertData);$selectIndex++)
											{
												if($toInsertData[$selectIndex]["FORMELEMENT_ID_PK"] == $value)
												{	
													// no value
													if(!$toInsertData[$selectIndex]["FORMELEMENT_MULTIPLEVALUE"])
													{
														$toInsertData[$selectIndex]["FORMELEMENT_MULTIPLEVALUE"] = $lang_script["dbfunctions.assess.inc.php"]["noValue"];
													}
													//define data
													$toFillFilledId			= $filledFormId;
													$toFillFormsId			= $toInsertData[$selectIndex]["FORMTYPE_FORM_ID_FK"];
													$toFillFormtypeId		= $toInsertData[$selectIndex]["FORMTYPE_ID_PK"];
													$toFillFormelementId	= $toInsertData[$selectIndex]["FORMELEMENT_ID_PK"];
													$toFillValue			= $toInsertData[$selectIndex]["FORMELEMENT_MULTIPLEVALUE"];
													//
													// insert resultline
													$question	=	nl2br($toInsertData[0]["FORMTYPE_QUESTION"]);
													$previewHtml = $this->srvyMultipleOptionPreviewHtml;
													$previewHtml = str_replace('{question}', $question, $previewHtml);
													$previewHtml = str_replace('{option}', $toInsertData[$selectIndex]["FORMELEMENT_HEADER"], $previewHtml);
													$previewHtml = str_replace('{inputValue}', $toFillValue, $previewHtml);
													$previewHTMLPool .= $previewHtml;
												}
												// end if
											}	
											$outputHTML[$toInsertData[0]["FORMTYPE_ID_PK"]] = $previewHTMLPool;
											unset($selectIndex);
											break;
										}
										//
									}
									// end case select
								}
								// end switch ($toInsertData[0]["FORMTYPE_TYPE"])
							}
							// endif (($toInsertData[0]["FORMTYPE_TYPE"]=="text")OR...
						}
						//end if ($typeArrayValues[$j][0]["FORMTYPE_ID_PK"] == $idKey)
					}
					// end for ($j=0; $j<count($typeValue);$j++)
				}
				//foreach ($resultArrayValues[$typeKey] as $idKey => $inputValue)
			}
			// end foreach($sessionTypeArray[$resultArrayKey] as $typeKey => $typeValue)
		}
		// end foreach ($resultDataArray as $resultArrayKey => $resultArrayValues)
		$showData = true;
		// create output in order of input
		if(is_array($_SESSION["qffValuePool"]["filledOrder"]))
		{
			while (list($key, $value) = each($_SESSION["qffValuePool"]["filledOrder"]))
			{
				// check if data already proceeded
				for($i = 0; $i < count($dataReadyPool); $i++)
				{
					if ($dataReadyPool[$i] == $value)
					{
						$showData = false;
						break;
					}
					$showData = true;
				}
				//
				if ($showData == true)
				{
					// if is html data
					if($outputHTML[$value])
					{
						//echo "neue Fragegruppe: ".$value; could be extended by proper headline 0301-rr
						echo $this->srvySpacerPreviewHtml;
					}
					// echo referring html
					echo $outputHTML[$value];
					// save procceded index to avoid doubles
					$dataReadyPool[] = $value;
				}
			}
		}
		// insert table end
		echo $this->srvyFooterPreviewHtml;
		return;
	}
// end class
}
?>
