<?php
// +----------------------------------------------------------------------+
// | assessment pilot                                                     |
// +----------------------------------------------------------------------+
// | Copyright (c) 2002 serie a - Digitale Medien und Systeme GmbH        |
// +----------------------------------------------------------------------+
// | Authors: Daniel Peer <peer@serie-a.de>                               |
// +----------------------------------------------------------------------+
// | Description:                                                         |
// +----------------------------------------------------------------------+
//
// $Id: log.inc.php,v 1.1.1.1 2004/07/15 13:30:13 opensurveypilot Exp $


// start session
@session_start();

if (is_file("./../config/config.inc.php"))
{
	require_once("./../config/config.inc.php"); // common config file
}	
elseif (is_file("./../../config/config.inc.php"))
{
	require_once("./../../config/config.inc.php"); // common config file
}

require_once ("DB.php"); // PEAR::DB
require_once ("Validate.php"); // PEAR::Validate (must be included before common config file)
require_once($cfgPathToTestgroupFiles."/config/testgroup.config.inc.php"); // testgroup config file
require_once($cfgPathToTestgroupFiles."/config/testgroup.file.inc.php"); // testgroup files
require_once($cfgPathToProbFiles."/config/prob.config.inc.php"); // prob config file
require_once($cfgPathToProbFiles."/config/prob.file.inc.php"); // prob files
require_once($cfgPathToTestgroupFiles."/lib/createcss.inc.php"); // css functions


/**
* Log Class
*
* @author  Daniel Peer <peer@serie-a.de>
* @access  public
*/

class Assessmentlog
{
	// declare variables
	
	/*
	Actionflags:
	------------
	1=login_time -> REL_ID = NULL
	2=test_start_time -> REL_ID = surveyID
	3=test_end_time	-> REL_ID = surveyID + surveyID in Filled Tabelle 
	*/
	
	var $errorMessage;
	var $db = "";
	
	/**
    *	Class Constructor
    *	@access	private
    */	
	function Assessmentlog()
    {
		$this->errorMessage = "";
        // connect to db
        $this->db = DB::connect(DSN, true);
        if (DB::isError($this->db))
        {
		   $this->errorMessage = $this->db->getMessage();
        }
	}
	
    /**
    *	sets error message
    *
    *	@access	private
    *	@param	string	$err
    */
    function setErrorMessage($err)
    {
        $this->errorMessage = $err;
    }

	/**
    *	gets error message
    *
    *	@access	private
    *	@param	string	$err
    */
	function getErrorMessage()
    {
       return $this->errorMessage;
    }

	/**
    *	Login to this testcontent
    *
    *	@access	public
    *	@param	
    *   @return string true/false
    */
	function login($login, $password, $testgroupId)
	{
		global $cfgTabUserData;
		global $cfgTabUserToGroup;
		global $cfgTabContentgroupToUsergroup;
		
		$sql = "SELECT * 
			FROM $cfgTabUserData, $cfgTabUserToGroup, $cfgTabContentgroupToUsergroup 
			WHERE USERDATA_PW = '$password' 
			AND USERDATA_EMAIL = '$login'
			AND USERDATA_ID_PK  = USER_ID_FK 
			AND GROUP_ID_FK  = CGROUP_TO_UGROUP_UGROUP_ID_FK 
			AND CGROUP_TO_UGROUP_CGROUP_ID_FK = $testgroupId
			";
			
		$result = $this->db->query($sql);
		
		if (DB::isError($result)) 
       	{
        	$this->setErrorMessage(new PEAR_Error("DB ERROR in login(): ".$result->getMessage()."in".__FILE__." on line ".__LINE__."with-------------$sql------------- "));
          	return new PEAR_Error("DB ERROR in login(): ".$result->getMessage()."in".__FILE__." on line ".__LINE__."with-------------$sql------------- ");
      	}
	
		$anz = $result->numRows();
	
		if ($anz < 1)
		{
			return false;
		}
		else
		{
			return true;
		}
	}

	/**
    *	get the login id from the logged user
    *
    *	@access	public
    *	@param	
    *   @return string true/false
    */
	function getLoginId ($login, $password)
	{
		global $cfgTabUserData;
		
		$sql = "SELECT USERDATA_ID_PK FROM $cfgTabUserData WHERE USERDATA_PW = '$password' and USERDATA_EMAIL = '$login'";
		
		$result = $this->db->query($sql);
		
		if (DB::isError($result)) 
       	{
        	$this->setErrorMessage(new PEAR_Error("DB ERROR in getLoginId(): ".$result->getMessage()."in".__FILE__." on line ".__LINE__."with-------------$sql------------- "));
          	return new PEAR_Error("DB ERROR in getLoginId(): ".$result->getMessage()."in".__FILE__." on line ".__LINE__."with-------------$sql------------- ");
      	}

	   	while ($row = $result->fetchRow(DB_FETCHMODE_ASSOC))
	    {
	           $userId = $row['USERDATA_ID_PK'];
	    }

		return $userId;
	}

	/**
    *	get the last login Date for the logged user
    *
    *	@access	public
    *	@param	
    *   @return string true/false
    */
	function getLastLogin ($userId, $logId)
	{
		global $cfgTabLog;
		global $cfgTabLogEvent;
		global $lang_script;

		$sql = "SELECT max(LOG_EVENT_TIME) as lastlog 
				FROM $cfgTabLog, $cfgTabLogEvent 
				WHERE 
				LOG_ID_PK = LOG_EVENT_LOG_ID_FK 
				AND 
				LOG_ID_PK!=$logId 
				AND LOG_EVENT_FLAG=1
				AND USER_ID_FK = $userId";

		$result = $this->db->query($sql);
		
		if (DB::isError($result)) 
       	{
        	$this->setErrorMessage(new PEAR_Error("DB ERROR in getLoginId(): ".$result->getMessage()."in".__FILE__." on line ".__LINE__."with-------------$sql------------- "));
          	return new PEAR_Error("DB ERROR in getLoginId(): ".$result->getMessage()."in".__FILE__." on line ".__LINE__."with-------------$sql------------- ");
      	}
		
		while ($row = $result->fetchRow(DB_FETCHMODE_ASSOC))
	    {
	           $lastlog = $row['lastlog'];
	    }
		
		if (!$lastlog)
		{
			$lastlog = $lang_script["log.inc.php"]["your1stlog"];
		}
		
		return $lastlog;
	}
	
	/**
    *	get this login Date for the logged user
    *
    *	@access	public
    *	@param	
    *   @return string true/false
    */
	function getThisLogin ($userId, $logId)
	{
		global $cfgTabLog;
		global $cfgTabLogEvent;
		
		$sql = "SELECT max(LOG_EVENT_TIME) as lastlog 
				FROM $cfgTabLog, $cfgTabLogEvent 
				WHERE 
				LOG_ID_PK = LOG_EVENT_LOG_ID_FK 
				AND 
				LOG_ID_PK=$logId 
				AND LOG_EVENT_FLAG=1";
		
		$result = $this->db->query($sql);
		
		if (DB::isError($result)) 
       	{
        	$this->setErrorMessage(new PEAR_Error("DB ERROR in getLoginId(): ".$result->getMessage()."in".__FILE__." on line ".__LINE__."with-------------$sql------------- "));
          	return new PEAR_Error("DB ERROR in getLoginId(): ".$result->getMessage()."in".__FILE__." on line ".__LINE__."with-------------$sql------------- ");
      	}
		
		while ($row = $result->fetchRow(DB_FETCHMODE_ASSOC))
	    {
	           $lastlog = $row['lastlog'];
	    }
		
		return $lastlog;
	}
	
	/**
    *	login for the logged user is written to database
    *
    *	@access	public
    *	@param	
    *   @return string true/false
    */
	function logLogin ($userId, $testgroupId)
	{
		global $cfgTabLog;
		global $cfgTabLogEvent;
		
		$today = date("Y-m-d H:i:s");
		
		$logId = $this->db->nextId($cfgTabLog);
		
		$sql = "INSERT INTO $cfgTabLog 
					(
					LOG_ID_PK, 
					USER_ID_FK, 
					GROUP_TO_CONTENT_ID_FK 
					)
				VALUES
					(
					$logId, 
					$userId, 
					$testgroupId
					)
				";
		
		$result = $this->db->query($sql);
		
		if (DB::isError($result)) 
       	{
        	$this->setErrorMessage(new PEAR_Error("DB ERROR in logLogin(): ".$result->getMessage()."in".__FILE__." on line ".__LINE__."with-------------$sql------------- "));
          	return new PEAR_Error("DB ERROR in logLogin(): ".$result->getMessage()."in".__FILE__." on line ".__LINE__."with-------------$sql------------- ");
      	}
		
		$eventId = $this->db->nextId($cfgTabLogEvent);
		
		$sql = "INSERT INTO $cfgTabLogEvent 
					(
					LOG_EVENT_ID_PK, 
					LOG_EVENT_LOG_ID_FK, 
					LOG_EVENT_TIME,
					LOG_EVENT_FLAG
					)
				VALUES
					(
					$eventId, 
					$logId, 
					'$today', 
					1
					)
				";

		$result = $this->db->query($sql);
		
		if (DB::isError($result)) 
       	{
        	$this->setErrorMessage(new PEAR_Error("DB ERROR in getLoginId(): ".$result->getMessage()."in".__FILE__." on line ".__LINE__."with-------------$sql------------- "));
          	return new PEAR_Error("DB ERROR in getLoginId(): ".$result->getMessage()."in".__FILE__." on line ".__LINE__."with-------------$sql------------- ");
      	}
		
		return $logId;
	}

	/**
    *	Testbegin for the logged user is written to the database
    *
    *	@access	public
    *	@param	
    *   @return string true/false
    */
	function logTestbegin ($userId, $testgroupId, $surveyId, $logId)
	{
		global $cfgTabLogEvent;
		
		$today = date("Y-m-d H:i:s");
		
		$eventId = $this->db->nextId($cfgTabLogEvent);
		
		
		$sql = "INSERT INTO $cfgTabLogEvent 
					(
					LOG_EVENT_ID_PK, 
					LOG_EVENT_LOG_ID_FK, 
					LOG_EVENT_TIME,
					LOG_EVENT_FLAG,
					LOG_EVENT_REL_ID_FK 
					)
				VALUES
					(
					$eventId, 
					$logId, 
					'$today', 
					2, 
					$surveyId 
					)
				";

		$result = $this->db->query($sql);
		
		if (DB::isError($result)) 
       	{
        	$this->setErrorMessage(new PEAR_Error("DB ERROR in logTestbegin(): ".$result->getMessage()."in".__FILE__." on line ".__LINE__."with-------------$sql------------- "));
          	return new PEAR_Error("DB ERROR in logTestbegin(): ".$result->getMessage()."in".__FILE__." on line ".__LINE__."with-------------$sql------------- ");
      	}
		
		return true;
	}
	
	/**
    *	Testend for the logged user is written to the database
    *
    *	@access	public
    *	@param	
    *   @return string true/false
    */
	function logTestend ($userId, $testgroupId, $surveyId, $logId)
	{
		global $cfgTabLogEvent;
		
		$today = date("Y-m-d H:i:s");
		
		$eventId = $this->db->nextId($cfgTabLogEvent);		
		
		$sql = "INSERT INTO $cfgTabLogEvent 
					(
					LOG_EVENT_ID_PK, 
					LOG_EVENT_LOG_ID_FK, 
					LOG_EVENT_TIME,
					LOG_EVENT_FLAG,
					LOG_EVENT_REL_ID_FK 
					)
				VALUES
					(
					$eventId, 
					$logId, 
					'$today', 
					3, 
					$surveyId 
					)
				";

		$result = $this->db->query($sql);
		
		if (DB::isError($result)) 
       	{
        	$this->setErrorMessage(new PEAR_Error("DB ERROR in logTestend(): ".$result->getMessage()."in".__FILE__." on line ".__LINE__."with-------------$sql------------- "));
          	return new PEAR_Error("DB ERROR in logTestend(): ".$result->getMessage()."in".__FILE__." on line ".__LINE__."with-------------$sql------------- ");
      	}
		return true;
	}
	
	/**
    *	Status for the user and the tests
    *
    *	@access	public
    *	@param	
    *   @return string
    */
	function getStatusUserTest ($userId, $testgroupId, $surveyId, $logId)
	{
		global $cfgTabLogEvent;
		global $cfgTabLog;
		global $lang_script;
		
		$statusArray = array ($lang_script["log.inc.php"]["statusNotStarted"], $lang_script["log.inc.php"]["statusPending"], $lang_script["log.inc.php"]["statusCompleted"]);

		$sql = "
		SELECT  * FROM
			$cfgTabLog, $cfgTabLogEvent
		WHERE 
			LOG_ID_PK = LOG_EVENT_LOG_ID_FK 
		AND LOG_EVENT_FLAG > 2 
		AND USER_ID_FK = $userId
		AND LOG_EVENT_REL_ID_FK = $surveyId ";

		$result = $this->db->query($sql);
		
		if (DB::isError($result)) 
       	{
        	$this->setErrorMessage(new PEAR_Error("DB ERROR in getStatusUserTest(): ".$result->getMessage()."in".__FILE__." on line ".__LINE__."with-------------$sql------------- "));
          	return new PEAR_Error("DB ERROR in getStatusUserTest(): ".$result->getMessage()."in".__FILE__." on line ".__LINE__."with-------------$sql------------- ");
      	}
		
		$anz = $result->numRows();
		
		if ($anz>0)
		{
			return $statusArray[2];
		}
		
		$sql = "
		SELECT  * FROM
			$cfgTabLog, $cfgTabLogEvent
		WHERE 
			LOG_ID_PK = LOG_EVENT_LOG_ID_FK 
		AND LOG_EVENT_FLAG > 1 
		AND USER_ID_FK = $userId
		AND LOG_EVENT_REL_ID_FK = $surveyId ";

		$result = $this->db->query($sql);
		
		if (DB::isError($result)) 
       	{
        	$this->setErrorMessage(new PEAR_Error("DB ERROR in getStatusUserTest(): ".$result->getMessage()."in".__FILE__." on line ".__LINE__."with-------------$sql------------- "));
          	return new PEAR_Error("DB ERROR in getStatusUserTest(): ".$result->getMessage()."in".__FILE__." on line ".__LINE__."with-------------$sql------------- ");
      	}
		
		$anz = $result->numRows();
		
		if ($anz>0)
		{
			return $statusArray[1];
		}
		
		return $statusArray[0];
		
		
	}
	
	/**
    *	Status for the user and the tests
    *
    *	@access	public
    *	@param	
    *   @return int
    */
	function getStatusUserTestId ($userId, $testgroupId, $surveyId, $logId)
	{
		global $cfgTabLogEvent;
		global $cfgTabLog;
		global $lang_script;
		
		$statusArray = array ($lang_script["log.inc.php"]["statusNotStarted"], $lang_script["log.inc.php"]["statusPending"], $lang_script["log.inc.php"]["statusCompleted"]);

		$sql = "
		SELECT  * FROM
			$cfgTabLog, $cfgTabLogEvent
		WHERE 
			LOG_ID_PK = LOG_EVENT_LOG_ID_FK 
		AND LOG_EVENT_FLAG > 2 
		AND USER_ID_FK = $userId
		AND LOG_EVENT_REL_ID_FK = $surveyId ";

		$result = $this->db->query($sql);
		
		if (DB::isError($result)) 
       	{
        	$this->setErrorMessage(new PEAR_Error("DB ERROR in getStatusUserTest(): ".$result->getMessage()."in".__FILE__." on line ".__LINE__."with-------------$sql------------- "));
          	return new PEAR_Error("DB ERROR in getStatusUserTest(): ".$result->getMessage()."in".__FILE__." on line ".__LINE__."with-------------$sql------------- ");
      	}
		
		$anz = $result->numRows();
		
		if ($anz>0)
		{
			return 2;
		}
		
		$sql = "
		SELECT  * FROM
			$cfgTabLog, $cfgTabLogEvent
		WHERE 
			LOG_ID_PK = LOG_EVENT_LOG_ID_FK 
		AND LOG_EVENT_FLAG > 1 
		AND USER_ID_FK = $userId
		AND LOG_EVENT_REL_ID_FK = $surveyId ";

		$result = $this->db->query($sql);
		
		if (DB::isError($result)) 
       	{
        	$this->setErrorMessage(new PEAR_Error("DB ERROR in getStatusUserTest(): ".$result->getMessage()."in".__FILE__." on line ".__LINE__."with-------------$sql------------- "));
          	return new PEAR_Error("DB ERROR in getStatusUserTest(): ".$result->getMessage()."in".__FILE__." on line ".__LINE__."with-------------$sql------------- ");
      	}
		
		$anz = $result->numRows();
		
		if ($anz>0)
		{
			return 1;
		}
		
		return 0;
	}
	
	/**
    *	Status for the user and the tests
    *
    *	@access	public
    *	@param	
    *   @return int
    */
	function getDateForTestDone ($userId, $testgroupId, $surveyId, $logId, $status)
	{
		global $cfgTabLogEvent;
		global $cfgTabLog;

		$sql = "
		SELECT  * FROM
			$cfgTabLog, $cfgTabLogEvent
		WHERE 
			LOG_ID_PK = LOG_EVENT_LOG_ID_FK 
		AND LOG_EVENT_FLAG = $status 
		AND USER_ID_FK = $userId 
		AND LOG_EVENT_REL_ID_FK = $surveyId 
		LIMIT 1";

		$result = $this->db->query($sql);
		
		if (DB::isError($result)) 
       	{
        	$this->setErrorMessage(new PEAR_Error("DB ERROR in getStatusUserTest(): ".$result->getMessage()."in".__FILE__." on line ".__LINE__."with-------------$sql------------- "));
          	return new PEAR_Error("DB ERROR in getStatusUserTest(): ".$result->getMessage()."in".__FILE__." on line ".__LINE__."with-------------$sql------------- ");
      	}
		
		while ($row = $result->fetchRow(DB_FETCHMODE_ASSOC))
	    {
	           $date = $row['LOG_EVENT_TIME'];
	    }
		
		return $date;
		
	}
	
	/**
    *	log sended mails
    *
    *	@access	public
    *	@param	
    *   @return int
    */
	function log_sended_mail ($sender, $testgroupId, $subject, $body, $recipients)
	{
		global $cfgTabMails;
		global $cfgTabMailRecipients;
		
		$nextId = $this->db->nextId($cfgTabMails);

		$sql = "
		INSERT INTO $cfgTabMails
		(
			TESTGROUP_MAIL_ID_PK,
			TESTGROUP_SUBJECT,
			TESTGROUP_SENDER,
			TESTGROUP_BODY,
			TESTGROUP_TESTGROUP_ID_FK,
			TESTGROUP_SENDED_DATE
		)
		values
		(
			$nextId,
			'$subject',
			'$sender',
			'$body',
			$testgroupId,
			NOW( )
		)";

		$result = $this->db->query($sql);
		
		if (DB::isError($result)) 
       	{
        	$this->setErrorMessage(new PEAR_Error("DB ERROR in log_sended_mail(): ".$result->getMessage()."in".__FILE__." on line ".__LINE__."with-------------$sql------------- "));
          	return new PEAR_Error("DB ERROR in log_sended_mail(): ".$result->getMessage()."in".__FILE__." on line ".__LINE__."with-------------$sql------------- ");
      	}
		
		
		for ($i=0;$i<count($recipients);$i++)
		{
			$sql = "
			INSERT INTO $cfgTabMailRecipients
			(
				MAIL_ID_FK,
				MAIL_ADDRESS
			)
			values
			(
				$nextId,
				'".$recipients[$i]."'
			)";
	
			$result = $this->db->query($sql);
			
			if (DB::isError($result)) 
	       	{
	        	$this->setErrorMessage(new PEAR_Error("DB ERROR in log_sended_mail(): ".$result->getMessage()."in".__FILE__." on line ".__LINE__."with-------------$sql------------- "));
	          	return new PEAR_Error("DB ERROR in log_sended_mail(): ".$result->getMessage()."in".__FILE__." on line ".__LINE__."with-------------$sql------------- ");
	      	}
			
		}
		
		return true;
		
	}

	/**
    *	gets the mails written for this testgroup
    *
    *	@access	public
    *	@param	
    *   @return int
    */
	function getMails ($testgroupId)
	{
		global $cfgTabMails;
		global $cfgTabMailRecipients;

		$sql = "
		SELECT  * FROM
			$cfgTabMails 
		WHERE 
			TESTGROUP_TESTGROUP_ID_FK = $testgroupId 
		ORDER BY TESTGROUP_SENDED_DATE";

		$result = $this->db->query($sql);
		
		if (DB::isError($result)) 
       	{
        	$this->setErrorMessage(new PEAR_Error("DB ERROR in getMails(): ".$result->getMessage()."in".__FILE__." on line ".__LINE__."with-------------$sql------------- "));
          	return new PEAR_Error("DB ERROR in getMails(): ".$result->getMessage()."in".__FILE__." on line ".__LINE__."with-------------$sql------------- ");
      	}
		
		while ($row = $result->fetchRow(DB_FETCHMODE_ASSOC))
	    {
	           $data[] = $row;
	    }
		
		for ($i=0;$i < count ($data); $i++)
		{
			$data[$i][RECIPIENTS] = $this->getRecipients($data[$i][TESTGROUP_MAIL_ID_PK]);
		}
		
		return $data;
		
	}
	
	/**
    *	gets the mails written for this testgroup
    *
    *	@access	public
    *	@param	
    *   @return int
    */
	function getRecipients ($mailId)
	{
		global $cfgTabMailRecipients;

		$sql = "
		SELECT MAIL_ADDRESS FROM
			$cfgTabMailRecipients 
		WHERE 
			MAIL_ID_FK = $mailId";

		$result = $this->db->query($sql);
		
		if (DB::isError($result)) 
       	{
        	$this->setErrorMessage(new PEAR_Error("DB ERROR in getMails(): ".$result->getMessage()."in".__FILE__." on line ".__LINE__."with-------------$sql------------- "));
          	return new PEAR_Error("DB ERROR in getMails(): ".$result->getMessage()."in".__FILE__." on line ".__LINE__."with-------------$sql------------- ");
      	}
		
		while ($row = $result->fetchRow(DB_FETCHMODE_ASSOC))
	    {
	           $data[] = $row[MAIL_ADDRESS];
	    }
		
		return $data;
		
	}

}
?>
