<?php
// +----------------------------------------------------------------------+
// | assessment pilot                                                     |
// +----------------------------------------------------------------------+
// | Copyright (c) 2002 serie a - Digitale Medien und Systeme GmbH        |
// +----------------------------------------------------------------------+
// | Authors: Daniel Peer <peer@serie-a.de>                               |
// +----------------------------------------------------------------------+
// | Description: Mask functions                                          |
// +----------------------------------------------------------------------+
//
// $Id: mask.inc.php,v 1.1.1.1 2004/07/15 13:30:14 opensurveypilot Exp $

/**
 *	procedural function set
 *
 *	@access	public
 *	@package proband
 *	@subpackage mask
 */

 
/**
 *	creates usermask withe the givven name and description
 *
 *	@access	public
 *	@param	string $name
 *	@param	string $description
 *  @return boolean|PEAR_Error true on success, PEAR_Error object on failure
 */
function createUsermask ($name, $description)
{
   	$db = DB::connect(DSN, true);
	if(PEAR::isError($db))
    { 
        return $db; 
    }
	

	global $cfgTabUsermask;
	global $cfgTabForms;
	
	
	$timestamp=time();
	$user_id = $_SESSION["sessionUserId"];
	$user_name = $_SESSION["sessionUserFirstname"]." ".$_SESSION["sessionUserLastname"];
	
	//id pk's for the tables related to the usermask table are built
	$nextId_Usermask = $db->nextId($cfgTabUsermask);

	
	$sql = "INSERT INTO $cfgTabUsermask (
			USERMASK_ID_PK, 
			USERMASK_NAME, 
			USERMASK_DESCRIPTION, 
			USERMASK_TIMESTAMP, 
			USERMASK_AUTHOR, 
			USERMASK_AUTHOR_ID 
			) values (
			$nextId_Usermask, 
			'$name', 
			'$description', 
			'$timestamp', 
			'$user_name', 
			'$user_id' 
			) ";

	$result = $db->query($sql);

	if (DB::isError($result)) 
    {
       	return new PEAR_Error("DB ERROR in createUsermask(): ".$result->getMessage()."in".__FILE__." on line ".__LINE__."with-------------$sql------------- ");
    }

	 // get next free id
        $nextId = $db->nextId($cfgTabForms);
        if (DB::isError($nextId)) 
        {
            return false;
        }
        
        // create insert statement
		$sql = "insert 
			into $cfgTabForms 
            (FORM_ID_PK, FORM_PROJECT_ID_FK, FORM_NAME, FORM_METHOD, FORM_HEADER, FORM_TARGET, FORM_ACTIVE, FORM_ORDER, FORM_INSERTDATE) 
            values 
            ('$nextId', '$nextId_Usermask', '$name', 'post', '$description', '', '', '0', NOW())";
        //
		$result = $db->query($sql);
        if (DB::isError($result)) 
        {

           return false;
        }
		
		
	return $nextId_Usermask;
}

/**
 *	gets a maskID and returns the formId for this mask
 *
 *	@access	public
 *	@param	integer $maskid
 *  @return int on success, PEAR_Error object on failure
 */
function MaskToFormID ($maskId)
{
   	$db = DB::connect(DSN, true);
	if(PEAR::isError($db))
    { 
        return $db; 
    }
	
	global $cfgTabForms;
	
	$sql = "SELECT FORM_ID_PK FROM $cfgTabForms WHERE FORM_PROJECT_ID_FK=$maskId";
	$result = $db->query($sql);
	
	if (DB::isError($result)) 
    {

       	return new PEAR_Error("DB ERROR in updateExtraNames(): ".$result->getMessage()."in".__FILE__." on line ".__LINE__."with-------------$sql------------- ");
    }
	
	//get the extranamesId as selectId
	while ($row = $result->fetchRow(DB_FETCHMODE_ASSOC))
    {
            $selectId = $row["FORM_ID_PK"];
    }
	
	if ($selectId)
	return $selectId;
	else
	return false;
}

/**
 *	deletes usermask and related rows in table T_PROB_MANDATORY and T_PROB_EXTRANAMES
 *
 *	@access	public
 *	@param	integer $maskid
 *  @return boolean|PEAR_Error true on success, PEAR_Error object on failure
 */
function deleteUsermask ($maskId)
{
   	$db = DB::connect(DSN, true);
	if(PEAR::isError($db))
    { 
        return $db; 
    }
	
	global $cfgTabForms;
	global $cfgTabUsermask;
	global $cfgTabFormtype;
	global $cfgTabFormelement;
	global $cfgTabFormEleRules;
	
	/*
	$sql = "SELECT FORM_ID_PK FROM $cfgTabForms WHERE FORM_PROJECT_ID_FK=$maskId";
	$result = $db->query($sql);
	
	if (DB::isError($result)) 
    {

       	return new PEAR_Error("DB ERROR in updateExtraNames(): ".$result->getMessage()."in".__FILE__." on line ".__LINE__."with-------------$sql------------- ");
    }
	
	//get the extranamesId as selectId
	while ($row = $result->fetchRow(DB_FETCHMODE_ASSOC))
    {
            $selectId = $row["FORM_ID_PK"];
    }
	
	$sql = "DELETE FROM $cfgTabForms WHERE FORM_PROJECT_ID_FK=$maskId";
	$result = $db->query($sql);
	
	if (DB::isError($result)) 
    {
      	return new PEAR_Error("DB ERROR in deleteUsermask(): ".$result->getMessage()."in".__FILE__." on line ".__LINE__."with-------------$sql------------- ");
    }
	
	$sql = "DELETE FROM $cfgTabFormtype WHERE FORMTYPE_FORM_ID_FK=$selectId";
	$result = $db->query($sql);
	
	if (DB::isError($result)) 
    {
      	return new PEAR_Error("DB ERROR in deleteUsermask(): ".$result->getMessage()."in".__FILE__." on line ".__LINE__."with-------------$sql------------- ");
    }
	
	$sql = "DELETE FROM $cfgTabFormelement WHERE FORMELEMENT_FORMTYPE_ID_FK=$selectId";
	$result = $db->query($sql);
	
	if (DB::isError($result)) 
    {
      	return new PEAR_Error("DB ERROR in deleteUsermask(): ".$result->getMessage()."in".__FILE__." on line ".__LINE__."with-------------$sql------------- ");
    }
	
	$sql = "DELETE FROM $cfgTabFormEleRules WHERE ELEMENTRULE_FORMTYPE_ID_FK=$selectId";
	$result = $db->query($sql);
	
	if (DB::isError($result)) 
    {
       	return new PEAR_Error("DB ERROR in deleteUsermask(): ".$result->getMessage()."in".__FILE__." on line ".__LINE__."with-------------$sql------------- ");
    }
	
	$sql = "DELETE FROM $cfgTabUsermask WHERE USERMASK_ID_PK = $maskId ";
	$result = $db->query($sql);

	if (DB::isError($result)) 
    {
      	return new PEAR_Error("DB ERROR in deleteUsermask(): ".$result->getMessage()."in".__FILE__." on line ".__LINE__."with-------------$sql------------- ");
    }
	
	*/
	
	$sql = "UPDATE $cfgTabUsermask SET USERMASK_DELETED = 1 WHERE USERMASK_ID_PK = $maskId ";
	$result = $db->query($sql);

	if (DB::isError($result)) 
    {
      	return new PEAR_Error("DB ERROR in deleteUsermask(): ".$result->getMessage()."in".__FILE__." on line ".__LINE__."with-------------$sql------------- ");
    }
	

	return true;
}


/**
 *	deletes usermask and related rows in table T_PROB_MANDATORY and T_PROB_EXTRANAMES
 *
 *	@access	public
 *	@param	integer $maskid
 *  @return boolean|PEAR_Error true on success, PEAR_Error object on failure
 */
function deleteFormtype ($formtypeId)
{
   	$db = DB::connect(DSN, true);
	if(PEAR::isError($db))
    { 
        return $db; 
    }
	
	global $cfgTabForms;
	global $cfgTabUsermask;
	global $cfgTabFormtype;
	global $cfgTabFormelement;
	global $cfgTabFormEleRules;
	
	
	$sql = "DELETE FROM $cfgTabFormtype WHERE FORMTYPE_ID_PK=$formtypeId";
	$result = $db->query($sql);

	if (DB::isError($result)) 
    {
      	//
       	return new PEAR_Error("DB ERROR in deleteUsermask(): ".$result->getMessage()."in".__FILE__." on line ".__LINE__."with-------------$sql------------- ");
    }
	
	$sql = "DELETE FROM $cfgTabFormelement WHERE FORMELEMENT_FORMTYPE_ID_FK=$formtypeId";
	$result = $db->query($sql);
	
	if (DB::isError($result)) 
    {
      	
       	return new PEAR_Error("DB ERROR in deleteUsermask(): ".$result->getMessage()."in".__FILE__." on line ".__LINE__."with-------------$sql------------- ");
    }
	
	$sql = "DELETE FROM $cfgTabFormEleRules WHERE ELEMENTRULE_FORMTYPE_ID_FK=$formtypeId";
	$result = $db->query($sql);
	
	if (DB::isError($result)) 
    {
      	
       	return new PEAR_Error("DB ERROR in deleteUsermask(): ".$result->getMessage()."in".__FILE__." on line ".__LINE__."with-------------$sql------------- ");
    }

	return true;
}

/**
 *	gets all usermasks
 *
 *	@access	public
 *  @return array|PEAR_Error array of usermasks on success, PEAR_Error object on failure
 */
function getAllUsermasks ()
{
    $db = DB::connect(DSN, true);
	if(PEAR::isError($db))
    { 
        return $db; 
    }
		
	global $cfgTabUsermask;

   	$sql = "select USERMASK_ID_PK, USERMASK_NAME from $cfgTabUsermask WHERE USERMASK_DELETED = 0";

	$result = $db->query($sql);
	
	if (DB::isError($result)) 
    {
      	
       	return new PEAR_Error("DB ERROR in getAllUsermasks(): ".$result->getMessage()."in".__FILE__." on line ".__LINE__."with-------------$sql------------- ");
    }

   	while ($row = $result->fetchRow(DB_FETCHMODE_ASSOC))
    {
           $getData[] = $row;
    }
    
	return $getData;
}

/**
 *	get one usermasks
 *
 *	@access	public
 *  @param integer $maskId
 *  @return array|PEAR_Error array of usermaskdata on success, PEAR_Error object on failure
 */
function getUsermask ($maskId)
{
    $db = DB::connect(DSN, true);
	if(PEAR::isError($db))
    { 
        return $db; 
    }
		
	global $cfgTabUsermask;

   	$sql = "select * from $cfgTabUsermask where USERMASK_ID_PK = $maskId";

	$result = $db->query($sql);
	
	if (DB::isError($result)) 
    {
       	return new PEAR_Error("DB ERROR in getUsermask(): ".$result->getMessage()."in".__FILE__." on line ".__LINE__."with-------------$sql------------- ");
    }

   	while ($row = $result->fetchRow(DB_FETCHMODE_ASSOC))
    {
           $getData[] = $row;
    }
    
	return $getData;
}

/**
 *	update usermasks
 *
 *	@access	public
 *  @param integer $maskId
 *  @param string $name
 *  @param string $maskdescription
 *  @return boolean|PEAR_Error true on success, PEAR_Error object on failure
 */
function updateUsermask ($maskId, $maskname, $maskdescription, $flagArray)
{
    $db = DB::connect(DSN, true);
	if(PEAR::isError($db))
    { 
        return $db; 
    }
		
	global $cfgTabUsermask;

   	$sql = "update $cfgTabUsermask set
				USERMASK_NAME = '$maskname',	
				USERMASK_DESCRIPTION = '$maskdescription', 
				USERMASK_BANK = ".$flagArray[0].",
				USERMASK_SCHOOL = ".$flagArray[1].",
				USERMASK_EDUCATION = ".$flagArray[2].",
				USERMASK_COURSE  = ".$flagArray[3]."
			where USERMASK_ID_PK = $maskId";

	$result = $db->query($sql);

	if (DB::isError($result)) 
    {
       	return new PEAR_nError("DB ERROR in updateUsermask(): ".$result->getMessage()."in".__FILE__." on line ".__LINE__."with-------------$sql------------- ");
    }
	
	return true;
}


/**
 *	update usermasks
 *
 *	@access	public
 *  @param integer $maskId
 *  @param string $name
 *  @param string $maskdescription
 *  @return boolean|PEAR_Error true on success, PEAR_Error object on failure
 */
function forceCompletion ($maskId)
{
    $db = DB::connect(DSN, true);
	if(PEAR::isError($db))
    { 
        return $db; 
    }
		
	global $cfgTabUserData;

   	$sql = "update $cfgTabUserData set USERDATA_INCOMPLETE = 1 where USERDATA_MASK_ID_FK = $maskId";

	$result = $db->query($sql);

	if (DB::isError($result)) 
    {
       	return new PEAR_nError("DB ERROR in forceCompletion(): ".$result->getMessage()."in".__FILE__." on line ".__LINE__."with-------------$sql------------- ");
    }
	
	return true;
}


	/**
    *	gets all questions
    *
    *	@access	public
    *	@param	
    *   @return string true/false
    */
    function getQuestions($maskId)
    {
		global $cfgTabFormtype;
	
		$db = DB::connect(DSN, true);
		if(PEAR::isError($db))
	    { 
	        return $db; 
	    }
		
		// fetch all questions in this group
        $sql = "select * 
           	from $cfgTabFormtype
           	where 
           	$cfgTabFormtype.FORMTYPE_FORM_ID_FK = '$maskId'";	
		
       $result = $db->query($sql);
	
		if (DB::isError($result)) 
	    {
	       	return new PEAR_nError("DB ERROR in getQuestions(): ".$result->getMessage()."in".__FILE__." on line ".__LINE__."with-------------$sql------------- ");
	    }

		while ($row = $result->fetchRow(DB_FETCHMODE_ASSOC))
        {
            $getQuestions[] = $row;
        }
		
		return $getQuestions;
		
    }


?>