<?php
// +----------------------------------------------------------------------+
// | assessment pilot                                                     |
// +----------------------------------------------------------------------+
// | Copyright (c) 2002 serie a - Digitale Medien und Systeme GmbH        |
// +----------------------------------------------------------------------+
// | Authors: Daniel Peer <peer@serie-a.de>                               |
// +----------------------------------------------------------------------+
// | Description:                                                         |
// +----------------------------------------------------------------------+
//
// $Id: prob.inc.php,v 1.1.1.1 2004/07/15 13:30:17 opensurveypilot Exp $

// start session
@session_start();

if (is_file("./../config/config.inc.php"))
{
	require_once("./../config/config.inc.php"); // common config file
}	
elseif (is_file("./../../config/config.inc.php"))
{
	require_once("./../../config/config.inc.php"); // common config file
}

require_once ("Validate.php"); // PEAR::Validate (must be included before common config file)

/**
* Proband Class
*
* @author  Daniel Peer <peer@serie-a.de>
* @access  public
*/
class Proband
{
	// declare variables
	var $lang;
	var $id;
	var $maskId;
	
	var $vname;
	var $nname;

	var $pw;
	var $age;
	var $sex;
	var $street;
	var $postalcode;
	var $city;
	var $phone;
	var $email;
	var $degree;
	var $degree_year;
	var $nation;
	var $course_name_Array;
	var $course_year_Array;
	var $edu_name_Array;
	var $edu_year_Array;
	var $notes;
	var $raw=0;
	
	var $bank_name;
	var $bank_blz;
	var $bank_ktonr;
	var $bank_owner;
	
	var $errorMessage;
	var $db = "";
	
	
	/**
    *	Class Constructor
    *	@access	private
    */	
	function Proband()
    {
	    	global $lang_script;

	    	$this->lang = $lang_script;
		$this->errorMessage = "";
        // connect to db
        $this->db = DB::connect(DSN, true);
        if (DB::isError($this->db)) 
        {    
		   $this->errorMessage = $db->getMessage();
        }		
	}
	
    /**
    *	sets error message
    *
    *	@access	private
    *	@param	string	$err
    */
    function setErrorMessage($err)
    {
        $this->errorMessage = $err;
    }
	
	
	/**
    *	gets error message
    *
    *	@access	private
    *	@param	string	$err
    */
	function getErrorMessage()
    {
       return $this->errorMessage;
    }	
	
    /**
    *	checks for valid inputs
    *
    *	@access	private
    *	@param	int	$step
    *   @return boolean true/false
    */
	function isValid($maskId, $bank, $school, $pw=1, $emailexists=0)
    {
	    	global $lang_script;

	    	$this->lang = $lang_script;
		$valid = true;

		if(!$this->vname)
       	{
		$this->errorMessage["masterdata"][0] = $this->lang["prob.inc.php"]["firstnameError"]."<br>\n";
		$valid = false;
		}

		if(!$this->nname)
       	{
		$this->errorMessage["masterdata"][1] = $this->lang["prob.inc.php"]["lastnameError"]."<br>\n";
		$valid = false;
		}

		if(!$this->age)
       	{
		$this->errorMessage["masterdata"][2] = $this->lang["prob.inc.php"]["dobError"]."<br>\n";
		$valid = false;
		}
		
		/*
		else
		{
			if(!validate::date($this->age, "%Y-%m-%d"))
        	{
           	$this->errorMessage["masterdata"][2] = "Das Geburtsdatum enth?lt ung?ltige Zeichen.<br>\n";
			$valid = false;
        	}
		}
		*/
		
		if(!$this->email)
       	{
		$this->errorMessage["masterdata"][3] = $this->lang["prob.inc.php"]["enteremailError"]."<br>\n";
		$valid = false;
		}
		else
		{
			if($this->email && !validate::email($this->email))
        	{
           	$this->errorMessage["masterdata"][3] = $this->lang["prob.inc.php"]["syntaxemailError"]."<br>\n";
			$valid = false;
        	}
			
			if($this->email &&  !$this->check_email() && $emailexists==1)
        	{
           	$this->errorMessage["masterdata"][3] = $this->lang["prob.inc.php"]["existemailError"]."<br>\n";
			$valid = false;
        	}
		}

		if(!$this->nation)
       	{
		$this->errorMessage["masterdata"][4] = $this->lang["prob.inc.php"]["nationalityError"]."<br>\n";
		$valid = false;
		}

		if(!$this->pw && $pw==1)
       	{
		$this->errorMessage["masterdata"][5] = $this->lang["prob.inc.php"]["enterpwdError"]."<br>\n";
		$valid = false;
		}
		else
		{
			if(!validate::string($this->pw, null, 3, 9) && $pw==1)
        	{
           	$this->errorMessage["masterdata"][5] = $this->lang["prob.inc.php"]["lengthpwdError"]."<br>\n";
			$valid = false;
        	}
		}

		if(!$this->street)
       	{
		$this->errorMessage["masterdata"][6] = $this->lang["prob.inc.php"]["addressError"]."<br>\n";
		$valid = false;
		}
			
		if(!$this->postalcode)
       	{
		$this->errorMessage["masterdata"][7] = $this->lang["prob.inc.php"]["postalcodeError"]."<br>\n";
		$valid = false;
		}
		else
		{
			if($this->postalcode && !validate::number($this->postalcode))
        	{
           	$this->errorMessage["masterdata"][7] = $this->lang["prob.inc.php"]["syntaxzipcodeError"]."<br>\n";
			$valid = false;
        	}
		}

		if(!$this->city)
       	{
		$this->errorMessage["masterdata"][8] = $this->lang["prob.inc.php"]["cityError"]."<br>\n";
		$valid = false;
		}

		if(!$this->phone)
       	{
		$this->errorMessage["masterdata"][9] = $this->lang["prob.inc.php"]["phoneError"]."<br>\n";
		$valid = false;
		}
		else
		{
			if($this->phone && !validate::number($this->phone))
        	{
           	$this->errorMessage["masterdata"][9] = $this->lang["prob.inc.php"]["syntaxphoneError"]."<br>\n";
			$valid = false;
        	}
		}
		
		if ($school)
		{
			if(!$this->degree)
	       	{
			$this->errorMessage["masterdata"][10] = $this->lang["prob.inc.php"]["graduationError"]."<br>\n";
			$valid = false;
			}
			
			if(!$this->degree_year)
	       	{
			$this->errorMessage["masterdata"][11] = $this->lang["prob.inc.php"]["graduationdateError"]."<br>\n";
			$valid = false;
			}
		}
		
		if ($bank)
		{
			if(!$this->bank_blz)
	       	{
			$this->errorMessage["masterdata"][12] = $this->lang["prob.inc.php"]["bankcodeError"]."<br>\n";
			$valid = false;
			}
			else
			{
				if($this->bank_blz && !validate::number($this->bank_blz))
	        	{
	           	$this->errorMessage["masterdata"][12] = $this->lang["prob.inc.php"]["syntaxbankcodeError"]."<br>\n";
				$valid = false;
	        	}
			}
			
			if(!$this->bank_ktonr)
	       	{
			$this->errorMessage["masterdata"][13] = $this->lang["prob.inc.php"]["accountnumberError"]."<br>\n";
			$valid = false;
			}
			else
			{
				if($this->bank_ktonr && !validate::number($this->bank_ktonr))
	        	{
	           	$this->errorMessage["masterdata"][13] = $this->lang["prob.inc.php"]["syntaxaccountnumberError"]."<br>\n";
				$valid = false;
	        	}
			}
			
			if(!$this->bank_name)
	       	{
			$this->errorMessage["masterdata"][14] = $this->lang["prob.inc.php"]["banknameError"]."<br>\n";
			$valid = false;
			}
			
			if(!$this->bank_owner)
	       	{
			$this->errorMessage["masterdata"][15] = $this->lang["prob.inc.php"]["accountownerError"]."<br>\n";
			$valid = false;
			}
		}
			
		return $valid;
	}
	
	/**
    *	gets the values in the degree-Array
    *
    *	@access	private
    *   @return Sting Array
    */
	function getSchool() 
	{
		global $cfgTabSchool;
		
		$sql = "select * from ".$cfgTabSchool;
	
       	$db = DB::connect(DSN, true);
        if (DB::isError($db)) 
        {    
		   $this->errorMessage = $db->getMessage();
        }
	
        $result = $db->query($sql);
	
		if (DB::isError($result))
        {
           $this->setErrorMessage($result->getMessage());
           return false;
        }
		while ($row = $result->fetchRow(DB_FETCHMODE_ASSOC))
        {
            $Data[] = $row;
        }
		return $Data;
	
	}
	
	
	/**
    *	gets the values in the Courses Table
    *
    *	@access	private
    *   @return Sting Array
    */	
	function getCourses()
	{
		global $cfgTabCourse;
		
		$sql = "select * from ".$cfgTabCourse;
	
       	$db = DB::connect(DSN, true);
        if (DB::isError($db)) 
        {
		   $this->errorMessage = $db->getMessage();
        }
	
        $result = $db->query($sql);
		
		if (DB::isError($result))
        {
           $this->setErrorMessage($result->getMessage());
           return false;
        }
		while ($row = $result->fetchRow(DB_FETCHMODE_ASSOC))
        {
            $Data[] = $row;
        }
		return $Data;
	}

	/**
    *	checks if the mailaddress is already in use
    *
    *	@access	private
    *   @return Sting Array
    */	
	function check_email()
	{
		global $cfgTabUserData;      
		
		$sql = "select USERDATA_EMAIL from ".$cfgTabUserData;
	
       	$db = DB::connect(DSN, true);
        if (DB::isError($db)) 
        {    
		   $this->errorMessage = $db->getMessage();
        }	
		
        $result = $db->query($sql);
		
		if (DB::isError($result)) 
        {
           $this->setErrorMessage($result->getMessage());
           return false;
        }
		$z=0;
		while ($row = $result->fetchRow(DB_FETCHMODE_ASSOC))
        {
            $Data[$z] = $row[USERDATA_EMAIL];
			$z++;
        }

		if (is_array ($Data))
		{
			if (in_array($this->email, $Data))
			{
				return false;
			}
			else
			{
				return true;
			}
		}
		
		
	}
	
	
	/**
    *	gets the values in the degree-Array
    *
    *	@access	private
    *   @return Sting Array
    */
	
	function getEducation()
	{
		global $cfgTabEducation;      
		
		$sql = "select * from ".$cfgTabEducation;	

		$db = DB::connect(DSN, true);
        if (DB::isError($db)) 
        {    
		   $this->errorMessage = $db->getMessage();
        }	
		
        $result = $db->query($sql);
		if (DB::isError($result)) 
        {
           $this->setErrorMessage($result->getMessage());
           return false;
        }
		while ($row = $result->fetchRow(DB_FETCHMODE_ASSOC))
        {
            $Data[] = $row;
        }
		return $Data;
	}

	/**
    *	saves form values to User Table
    *
    *	@access	private
    *   @return boolean true/false
    */
	function saveUserData()
    {
		global $cfgTabUserData;
		
		$db = DB::connect(DSN, true);
        if (DB::isError($db)) 
        {    
		   $this->errorMessage = $db->getMessage();
        }	
		
		$nextId = $db->nextId($cfgTabUserData);
		
		$datArray=explode (".",$this->age);
		$this->age=$datArray[2]."-".$datArray[1]."-".$datArray[0];
		
		$datArray=explode (".",$this->degree_year);
		$this->degree_year=$datArray[2]."-".$datArray[1]."-".$datArray[0];
		
		for ($i=0;$i<count($this->course_year_Array);$i++)
		{
			$datArray=explode (".",$this->course_year_Array[$i]);
			$this->course_year_Array[$i]=$datArray[2]."-".$datArray[1]."-".$datArray[0];
		}
		
		for ($i=0;$i<count($this->edu_year_Array);$i++)
		{
			$datArray=explode (".",$this->edu_year_Array[$i]);
			$this->edu_year_Array[$i]=$datArray[2]."-".$datArray[1]."-".$datArray[0];
		}

		$sql = "INSERT INTO $cfgTabUserData 
				(
					USERDATA_ID_PK, 
					USERDATA_VNAME, 
					USERDATA_NNAME, 
					USERDATA_MASK_ID_FK,
					USERDATA_PW,
					USERDATA_AGE,
					USERDATA_SEX,
					USERDATA_STREET,
					USERDATA_POSTALCODE,
					USERDATA_CITY,
					USERDATA_PHONE,
					USERDATA_EMAIL,
					USERDATA_DEGREE,
					USERDATA_DEGREE_YEAR,
					USERDATA_NATION,
					USERDATA_COURSE_NAME_1,
					USERDATA_COURSE_YEAR_1,
					USERDATA_COURSE_NAME_2,
					USERDATA_COURSE_YEAR_2,
					USERDATA_COURSE_NAME_3,
					USERDATA_COURSE_YEAR_3,
					USERDATA_COURSE_NAME_4,
					USERDATA_COURSE_YEAR_4,
					USERDATA_COURSE_NAME_5,
					USERDATA_COURSE_YEAR_5,
					USERDATA_EDUCATION_NAME_1,
					USERDATA_EDUCATION_YEAR_1,
					USERDATA_EDUCATION_NAME_2,
					USERDATA_EDUCATION_YEAR_2,
					USERDATA_EDUCATION_NAME_3,
					USERDATA_EDUCATION_YEAR_3,
					USERDATA_EDUCATION_NAME_4,
					USERDATA_EDUCATION_YEAR_4,
					USERDATA_EDUCATION_NAME_5,
					USERDATA_EDUCATION_YEAR_5,
					USERDATA_BANK_NAME, 
					USERDATA_BANK_BLZ, 
					USERDATA_BANK_KTONR, 
					USERDATA_BANK_OWNER, 
					USERDATA_NOTES, 
					USERDATA_RAW 
				)
				VALUES 
				(
					".$nextId.", 
					'".$this->vname."', 
					'".$this->nname."', 
					'".$this->maskId."',
					'".md5($this->pw)."',
					'".$this->age."',
					'".$this->sex."',
					'".$this->street."',
					'".$this->postalcode."',
					'".$this->city."',
					'".$this->phone."',
					'".$this->email."',
					'".$this->degree."',
					'".$this->degree_year."',
					'".$this->nation."',
					'".$this->course_name_Array[0]."',
					'".$this->course_year_Array[0]."',
					'".$this->course_name_Array[1]."',
					'".$this->course_year_Array[1]."',
					'".$this->course_name_Array[2]."',
					'".$this->course_year_Array[2]."',
					'".$this->course_name_Array[3]."',
					'".$this->course_year_Array[3]."',
					'".$this->course_name_Array[4]."',
					'".$this->course_year_Array[4]."',
					'".$this->edu_name_Array[0]."',
					'".$this->edu_year_Array[0]."',
					'".$this->edu_name_Array[1]."',
					'".$this->edu_year_Array[1]."',
					'".$this->edu_name_Array[2]."',
					'".$this->edu_year_Array[2]."',
					'".$this->edu_name_Array[3]."',
					'".$this->edu_year_Array[3]."',
					'".$this->edu_name_Array[4]."',
					'".$this->edu_year_Array[4]."',
					'".$this->bank_name."', 
					'".$this->bank_blz."', 
					'".$this->bank_ktonr."', 
					'".$this->bank_owner."', 
					'".$this->notes."', 
					".$this->raw."		
				)";	

        $result = $db->query($sql);
		
		if (DB::isError($result)) 
        {
           $this->errorMessage=$result->getMessage();
           return false;
        }
		else
		{
			return $nextId;
		}
	}

	/**
    *	updates form values to User Table
    *
    *	@access	private
    *   @return boolean true/false
    */
	function updateUserData($pw=1)
    {
		global $cfgTabUserData;
		
		$db = DB::connect(DSN, true);
        if (DB::isError($db)) 
        {    
		   $this->errorMessage = $db->getMessage();
        }	
		
		
		$datArray=explode (".",$this->age);
		$this->age=$datArray[2]."-".$datArray[1]."-".$datArray[0];
		
		$datArray=explode (".",$this->degree_year);
		$this->degree_year=$datArray[2]."-".$datArray[1]."-".$datArray[0];
		
		for ($i=0;$i<count($this->course_year_Array);$i++)
		{
			$datArray=explode (".",$this->course_year_Array[$i]);
			$this->course_year_Array[$i]=$datArray[2]."-".$datArray[1]."-".$datArray[0];
		}
		
		for ($i=0;$i<count($this->edu_year_Array);$i++)
		{
			$datArray=explode (".",$this->edu_year_Array[$i]);
			$this->edu_year_Array[$i]=$datArray[2]."-".$datArray[1]."-".$datArray[0];
		}
		
		if ($pw==1)
		{
			$sql = "UPDATE $cfgTabUserData SET 
					USERDATA_VNAME='".$this->vname."',
					USERDATA_NNAME='".$this->nname."',
					USERDATA_MASK_ID_FK='".$this->maskId."',
					USERDATA_PW='".md5($this->pw)."',
					USERDATA_AGE='".$this->age."',
					USERDATA_SEX='".$this->sex."',
					USERDATA_STREET='".$this->street."',
					USERDATA_POSTALCODE='".$this->postalcode."',
					USERDATA_CITY='".$this->city."',
					USERDATA_PHONE='".$this->phone."',
					USERDATA_EMAIL='".$this->email."',
					USERDATA_DEGREE='".$this->degree."',
					USERDATA_DEGREE_YEAR='".$this->degree_year."',
					USERDATA_NATION='".$this->nation."',
					USERDATA_COURSE_NAME_1='".$this->course_name_Array[0]."',
					USERDATA_COURSE_YEAR_1='".$this->course_year_Array[0]."',
					USERDATA_COURSE_NAME_2='".$this->course_name_Array[1]."',
					USERDATA_COURSE_YEAR_2='".$this->course_year_Array[1]."',
					USERDATA_COURSE_NAME_3='".$this->course_name_Array[2]."',
					USERDATA_COURSE_YEAR_3='".$this->course_year_Array[2]."',
					USERDATA_COURSE_NAME_4='".$this->course_name_Array[3]."',
					USERDATA_COURSE_YEAR_4='".$this->course_year_Array[3]."',
					USERDATA_COURSE_NAME_5='".$this->course_name_Array[4]."',
					USERDATA_COURSE_YEAR_5='".$this->course_year_Array[4]."',
					USERDATA_EDUCATION_NAME_1='".$this->edu_name_Array[0]."',
					USERDATA_EDUCATION_YEAR_1='".$this->edu_year_Array[0]."',
					USERDATA_EDUCATION_NAME_2='".$this->edu_name_Array[1]."',
					USERDATA_EDUCATION_YEAR_2='".$this->edu_year_Array[1]."',
					USERDATA_EDUCATION_NAME_3='".$this->edu_name_Array[2]."',
					USERDATA_EDUCATION_YEAR_3='".$this->edu_year_Array[2]."',
					USERDATA_EDUCATION_NAME_4='".$this->edu_name_Array[3]."',
					USERDATA_EDUCATION_YEAR_4='".$this->edu_year_Array[3]."',
					USERDATA_EDUCATION_NAME_5='".$this->edu_name_Array[4]."',
					USERDATA_EDUCATION_YEAR_5='".$this->edu_year_Array[4]."',
					USERDATA_BANK_NAME='".$this->bank_name."',
					USERDATA_BANK_BLZ='".$this->bank_blz."',
					USERDATA_BANK_KTONR='".$this->bank_ktonr."',
					USERDATA_BANK_OWNER='".$this->bank_owner."',
					USERDATA_NOTES='".$this->notes."',
					USERDATA_RAW='".$this->raw."', 
					USERDATA_INCOMPLETE = 0 
				WHERE USERDATA_ID_PK=".$this->id;
		}
		else
		{
			$sql = "UPDATE $cfgTabUserData SET 
					USERDATA_VNAME='".$this->vname."',
					USERDATA_NNAME='".$this->nname."',
					USERDATA_MASK_ID_FK='".$this->maskId."',
					USERDATA_AGE='".$this->age."',
					USERDATA_SEX='".$this->sex."',
					USERDATA_STREET='".$this->street."',
					USERDATA_POSTALCODE='".$this->postalcode."',
					USERDATA_CITY='".$this->city."',
					USERDATA_PHONE='".$this->phone."',
					USERDATA_EMAIL='".$this->email."',
					USERDATA_DEGREE='".$this->degree."',
					USERDATA_DEGREE_YEAR='".$this->degree_year."',
					USERDATA_NATION='".$this->nation."',
					USERDATA_COURSE_NAME_1='".$this->course_name_Array[0]."',
					USERDATA_COURSE_YEAR_1='".$this->course_year_Array[0]."',
					USERDATA_COURSE_NAME_2='".$this->course_name_Array[1]."',
					USERDATA_COURSE_YEAR_2='".$this->course_year_Array[1]."',
					USERDATA_COURSE_NAME_3='".$this->course_name_Array[2]."',
					USERDATA_COURSE_YEAR_3='".$this->course_year_Array[2]."',
					USERDATA_COURSE_NAME_4='".$this->course_name_Array[3]."',
					USERDATA_COURSE_YEAR_4='".$this->course_year_Array[3]."',
					USERDATA_COURSE_NAME_5='".$this->course_name_Array[4]."',
					USERDATA_COURSE_YEAR_5='".$this->course_year_Array[4]."',
					USERDATA_EDUCATION_NAME_1='".$this->edu_name_Array[0]."',
					USERDATA_EDUCATION_YEAR_1='".$this->edu_year_Array[0]."',
					USERDATA_EDUCATION_NAME_2='".$this->edu_name_Array[1]."',
					USERDATA_EDUCATION_YEAR_2='".$this->edu_year_Array[1]."',
					USERDATA_EDUCATION_NAME_3='".$this->edu_name_Array[2]."',
					USERDATA_EDUCATION_YEAR_3='".$this->edu_year_Array[2]."',
					USERDATA_EDUCATION_NAME_4='".$this->edu_name_Array[3]."',
					USERDATA_EDUCATION_YEAR_4='".$this->edu_year_Array[3]."',
					USERDATA_EDUCATION_NAME_5='".$this->edu_name_Array[4]."',
					USERDATA_EDUCATION_YEAR_5='".$this->edu_year_Array[4]."',
					USERDATA_BANK_NAME='".$this->bank_name."',
					USERDATA_BANK_BLZ='".$this->bank_blz."',
					USERDATA_BANK_KTONR='".$this->bank_ktonr."',
					USERDATA_BANK_OWNER='".$this->bank_owner."',
					USERDATA_NOTES='".$this->notes."',
					USERDATA_RAW='".$this->raw."',
					USERDATA_INCOMPLETE = 0 
				WHERE USERDATA_ID_PK=".$this->id;
		}
		
        $result = $db->query($sql);
		
		if (DB::isError($result)) 
        {
           $this->errorMessage=$result->getMessage();
           return false;
        }
		else
		{
			return true;
		}
	}
	
	
	/**
    *	get all ProbandGroups for overview
    *
    *	@access	public
    *	@param	
    *   @return string true/false
    */
   	function getProbandGroups ($actualNum = 0, $maxRow, $orderBy, $direction)
    {
        global $cfgTabGroups;
        
      	// select all raw Data
       	$sql = "select * 
				from $cfgTabGroups
			    order by $orderBy $direction 
                limit $actualNum, $maxRow";
       	//
		$result = $this->db->query($sql);
       	if (DB::isError($result)) 
       	{
          	    $this->setErrorMessage($sql."  ".$result->getMessage());
          	    return false;
      	}
		// get rows
       	while ($row = $result->fetchRow(DB_FETCHMODE_ASSOC))
        {
               $getRawData[] = $row;
        }
        
		return $getRawData;
    }
	
	/**
    *	add Proband to ProbandGroups
    *
    *	@access	public
    *	@param	
    *   @return string true/false
    */
   	function Proband_to_Group ($probId, $groupArray)
    {
        global $cfgTabUserToGroup;
		
		$sql = "delete from $cfgTabUserToGroup where USER_ID_FK=$probId ";
		$result = $this->db->query($sql);

		for ($i=0;$i < count($groupArray);$i++)
		{
			$sql = "insert into $cfgTabUserToGroup (USER_ID_FK, GROUP_ID_FK) values ($probId, ".$groupArray[$i].")";
			$result = $this->db->query($sql);
			
			if (DB::isError($result)) 
	       	{
	        	$this->setErrorMessage($sql."  ".$result->getMessage());
	          	return false;
	      	}
		}
   		return true;
    }
	
	/**
    *	add many Probands to ProbandGroups
    *
    *	@access	public
    *	@param	
    *   @return string true/false
    */
   	function Probands_to_Group ($probId, $groupArray)
    {
        global $cfgTabUserToGroup;
		
		$sql = "select GROUP_ID_FK from $cfgTabUserToGroup where USER_ID_FK=$probId ";
		$result = $this->db->query($sql);
		
		// get rows
		$i=0;
       	while ($row = $result->fetchRow(DB_FETCHMODE_ASSOC))
        {
               $groups[$i] = $row["GROUP_ID_FK"];
			   $i++;
        }

		for ($i=0;$i < count($groupArray);$i++)
		{
			
			if (! @in_array ($groupArray[$i], $groups))
			{
				$sql = "insert into $cfgTabUserToGroup (USER_ID_FK, GROUP_ID_FK) values ($probId, ".$groupArray[$i].")";
				$result = $this->db->query($sql);
				
				if (DB::isError($result)) 
		       	{
		        	$this->setErrorMessage($sql."  ".$result->getMessage());
		          	return false;
		      	}
			}
		}
   		return true;
    }
	
	/**
    *	add Proband to ProbandGroups
    *
    *	@access	public
    *	@param	
    *   @return string true/false
    */
   	function Group_to_Proband ($probArray, $groupId)
    {
        global $cfgTabUserToGroup;
		
		$sql = "delete from $cfgTabUserToGroup where GROUP_ID_FK=$groupId ";
		$result = $this->db->query($sql);

		for ($i=0;$i < count($probArray);$i++)
		{
			$sql = "insert into $cfgTabUserToGroup (USER_ID_FK,GROUP_ID_FK) values (".$probArray[$i].",$groupId)";
			$result = $this->db->query($sql);
			
			if (DB::isError($result)) 
	       	{
	        	$this->setErrorMessage($sql."  ".$result->getMessage());
	          	return false;
	      	}
		}
   		return true;
    }
	
	/**
    *	checks if Proband is already in the specified Group
    *
    *	@access	public
    *	@param	
    *   @return string true/false
    */
   	function Proband_in_Group($probId, $groupId)
    {
        global $cfgTabUserToGroup;
      
	  	$sql = "select * from $cfgTabUserToGroup where USER_ID_FK=$probId and GROUP_ID_FK=$groupId ";
		$result = $this->db->query($sql);
		if (DB::isError($result)) 
       	{
          	    $this->setErrorMessage($sql."  ".$result->getMessage());
      	}
		$numRows = $result->numRows();
		if ($numRows>0)
		{
			return true;
		}
		else
		{
   			return false;
		}
    }
	
	/**
    *	deletes Proband in the specified Group
    *
    *	@access	public
    *	@param	
    *   @return string true/false
    */
   	function delete_Proband_in_Group($probId, $groupId)
    {
        global $cfgTabUserToGroup;
      
	  	$sql = "delete from $cfgTabUserToGroup where USER_ID_FK=$probId and GROUP_ID_FK=$groupId ";
		$result = $this->db->query($sql);
		if (DB::isError($result)) 
       	{
          	    $this->setErrorMessage($sql."  ".$result->getMessage());
				return false;
      	}
		
		return true;
    }
	
	/**
    *	gets all GroupIds for one Proband
    *
    *	@access	public
    *	@param	
    *   @return string true/false
    */
   	function get_Groups_of_Proband($probId)
    {
        global $cfgTabUserToGroup;
      
	  	$sql = "select GROUP_ID_FK from $cfgTabUserToGroup where USER_ID_FK=$probId";
		$result = $this->db->query($sql);
		if (DB::isError($result)) 
       	{
          	    $this->setErrorMessage($sql."  ".$result->getMessage());
      	}
		
       	while ($row = $result->fetchRow(DB_FETCHMODE_ASSOC))
        {
               $Data[] = $row['GROUP_ID_FK'];
        }
        
		return $Data;
		
    }
	
	/**
    *	gets all probandIds for one Group
    *
    *	@access	public
    *	@param	
    *   @return string true/false
    */
   	function get_Probands_of_Group($groupId)
    {
        global $cfgTabUserToGroup;
      
	  	$sql = "select USER_ID_FK from $cfgTabUserToGroup where GROUP_ID_FK=$groupId";
		$result = $this->db->query($sql);
		if (DB::isError($result)) 
       	{
          	    $this->setErrorMessage($sql."  ".$result->getMessage());
      	}
		
       	while ($row = $result->fetchRow(DB_FETCHMODE_ASSOC))
        {
               $Data[] = $row['USER_ID_FK'];
        }
        
		return $Data;
		
    }
	
	
	/**
    *	updates Group Table
    *
    *	@access	public
    *	@param	
    *   @return true/false
    */
	function updateProbandGroup ($groupId, $name, $desc)
    {
        global $cfgTabGroups;
        
      	// select all raw Data
       	$sql = "update $cfgTabGroups set GROUPS_NAME='$name', GROUPS_DESCRIPTION='$desc' where GROUPS_ID_PK='$groupId'";
       	//
		$result = $this->db->query($sql);
       	if (DB::isError($result)) 
       	{
          	    $this->setErrorMessage($sql."  ".$result->getMessage());
          	    return false;
      	}
       
		return true;
    }
	
	/**
    *	deletes Row width givven GroupId from Group Table
    *
    *	@access	public
    *	@param	
    *   @return true/false
    */
	function deleteProbandGroup($groupId)
    {
        global $cfgTabGroups;
		global $cfgTabUserToGroup;
        
      	//delete raw Data with the incoming ID      
	  	$sql = "delete from $cfgTabGroups 
				where GROUPS_ID_PK=$groupId ";

		$result = $this->db->query($sql);
       	if (DB::isError($result)) 
       	{
          	    $this->setErrorMessage($sql."  ".$result->getMessage());
          	    return false;
      	}
		
		$sql = "delete from $cfgTabUserToGroup 
		where GROUP_ID_FK = $groupId ";

		$result = $this->db->query($sql);
       	if (DB::isError($result)) 
       	{
          	    $this->setErrorMessage($sql."  ".$result->getMessage());
          	    return false;
      	}

		return true;
		
    }
	
	/**
    *	insert into Group Table
    *
    *	@access	public
    *	@param	
    *   @return true/false
    */
	function insertProbandGroup($groupname, $groupdesc)
    {
        global $cfgTabGroups;
		
		$datum=date ("y-m-d H:i:s");
        
      	//delete raw Data with the incoming ID      
	  	$sql = "insert into $cfgTabGroups (GROUPS_NAME, GROUPS_DESCRIPTION,GROUPS_GROUPTIME) values ('$groupname', '$groupdesc','$datum')";

		$result = $this->db->query($sql);
       	if (DB::isError($result)) 
       	{
          	    $this->setErrorMessage($sql."  ".$result->getMessage());
          	    return false;
      	}
		else
		{
		 		return true;
		}
    }
	
	/**
    *	gets sum of ProbandGroups
    *
    *	@access	public
    *	@param	
    *   @return int
    */
	function getProbandGroupNum()
	{
		global $cfgTabGroups;        
        $numRows = "0";
     
       	// fetch selected survey
       	$sql = "select 1 
				from $cfgTabGroups ";

       	$result = $this->db->query($sql);
       	if (DB::isError($result)) 
       	{
               return false;
       	}
      
        $numRows = $result->numRows();

        return $numRows;
	}

	/**
    *	gets one ProbandGroup
    *
    *	@access	public
    *	@param	
    *   @return string[]
    */
	function getProbandGroupRow($groupId)
	{
		global $cfgTabGroups;      
		
		$sql = "select * 
           		from ".$cfgTabGroups." 
           		where GROUPS_ID_PK  = $groupId";	
	
        $result = $this->db->query($sql);
		if (DB::isError($result)) 
        {
           $this->setErrorMessage($result->getMessage());
           return false;
        }
		while ($row = $result->fetchRow(DB_FETCHMODE_ASSOC))
        {
            $rawData[] = $row;
        }
		return $rawData;
	}
	
	/**
    *	get all Proband User for overview
    *
    *	@access	public
    *	@param	
    *   @return string[]
    */
   	function ProbandUserOverview ($actualNum = 0, $maxRow, $orderBy, $direction, $raw=0)
    {
        global $cfgTabUserData;
        
      	// select all raw Data
       	$sql = "select * 
				from $cfgTabUserData
				where USERDATA_RAW = $raw
			    order by $orderBy $direction 
                limit $actualNum, $maxRow";
       	//
		$result = $this->db->query($sql);
       	if (DB::isError($result)) 
       	{
          	    $this->setErrorMessage($sql."  ".$result->getMessage());
          	    return false;
      	}
		// get rows
       	while ($row = $result->fetchRow(DB_FETCHMODE_ASSOC))
        {
               $getData[] = $row;
        }
        
		return $getData;
    }
	
	
	/**
    *	get all Usermasks for overview
    *
    *	@access	public
    *	@param	
    *   @return string[]
    */
   	function UsermaskOverview ($actualNum = 0, $maxRow, $orderBy, $direction)
    {
        global $cfgTabUsermask;

       	$sql = "select * 
				from $cfgTabUsermask
				where USERMASK_DELETED = 0 
			    order by $orderBy $direction 
                limit $actualNum, $maxRow";
       	//
		$result = $this->db->query($sql);
       	if (DB::isError($result)) 
       	{
          	    $this->setErrorMessage($sql."  ".$result->getMessage());
          	    return false;
      	}
		// get rows
       	while ($row = $result->fetchRow(DB_FETCHMODE_ASSOC))
        {
               $getData[] = $row;
        }
        
		return $getData;
    }
	
	/**
    *	gets sum of Usermasks
    *
    *	@access	public
    *	@param	
    *   @return int
    */
	function getUsermaskNum()
	{
		global $cfgTabUsermask;        
        $numRows = "0";
     
       	// fetch selected survey
       	$sql = "select 1 
				from $cfgTabUsermask ";

       	$result = $this->db->query($sql);
       	if (DB::isError($result)) 
       	{
               return false;
       	}
      
        $numRows = $result->numRows();

        return $numRows;
	}
	
	
	/**
    *	updates Proband User table
    *
    *	@access	public
    *	@param	
    *   @return string[]
    */
	function updateProbandUser($userId, $field, $value)
    {
        global $cfgTabUserData;
        
      	// select all raw Data
       	$sql = "update $cfgTabUserData set $field='$value' where USERDATA_ID_PK='$userId'";
       	//
		$result = $this->db->query($sql);
       	if (DB::isError($result)) 
       	{
          	    $this->setErrorMessage($sql."  ".$result->getMessage());
          	    return false;
      	}
       
		return true;
    }
	
	/**
    *	deletes Proband User from table
    *
    *	@access	public
    *	@param	
    *   @return string[]
    */
	function deleteProbandUser($userId)
    {
        global $cfgTabUserData;
		global $cfgTabUserToGroup;
		
		//delete raw Data with the incoming ID      
	  	$sql = "delete from $cfgTabUserData 
				where USERDATA_ID_PK=$userId ";

		$result = $this->db->query($sql);
       	if (DB::isError($result)) 
       	{
          	    $this->setErrorMessage($sql."  ".$result->getMessage());
          	    return false;
      	}
		
		$sql = "delete from $cfgTabUserToGroup 
				where USER_ID_FK = $userId ";

		$result = $this->db->query($sql);
       	if (DB::isError($result)) 
       	{
          	    $this->setErrorMessage($sql."  ".$result->getMessage());
          	    return false;
      	}

		return true;
    }

	/**
    *	gets sum of Proband User
    *
    *	@access	public
    *	@param	
    *   @return string true/false
    */
	function getProbandUserNum($raw=0)
	{
		global $cfgTabUserData;        
        $numRows = "0";
     
       	// fetch selected survey
       	$sql = "select 1 
				from $cfgTabUserData where USERDATA_RAW = $raw";

       	$result = $this->db->query($sql);
       	if (DB::isError($result)) 
       	{
               return false;
       	}
      
        $numRows = $result->numRows();

        return $numRows;
	}

	/**
    *	get one Proband User
    *
    *	@access	public
    *	@param	
    *   @return string true/false
    */
	function getProbandUserRow($userId)
	{
		global $cfgTabUserData;      
		
		$sql = "select * 
           		from ".$cfgTabUserData." 
           		where USERDATA_ID_PK  = $userId";	
	
        $result = $this->db->query($sql);
		if (DB::isError($result)) 
        {
           $this->setErrorMessage($result->getMessage());
           return false;
        }
		while ($row = $result->fetchRow(DB_FETCHMODE_ASSOC))
        {
            $Data[] = $row;
        }
		return $Data;
	}
	
	/**
    *	get Probands for Mailfunction
    *
    *	@access	public
    *	@param	
    *   @return string true/false
    */
	function getAllProbandsForMailfunction()
	{
		global $cfgTabUserData;      
		
		$sql = "select USERDATA_ID_PK, USERDATA_VNAME,  USERDATA_NNAME 
           		from ".$cfgTabUserData;	
	
        $result = $this->db->query($sql);
		if (DB::isError($result)) 
        {
           $this->setErrorMessage($result->getMessage());
           return false;
        }
		while ($row = $result->fetchRow(DB_FETCHMODE_ASSOC))
        {
            $Data[] = $row;
        }
		return $Data;
	}
	
	/**
    *	looks if the givven value is in the Education Array
    *
    *	@access	public
    *	@param	
    *   @return true/false
    */
	function inEduArray($val)
	{
		$check=false;

		$tmpArray=$this->getEducation();		
		
		for ($i=0;$i<count($tmpArray);$i++)
		{					
			if ($val==$tmpArray[$i][EDUCATION_NAME]) 
			{
    			return true;
			}
			else
			{
				$check=false;
			}
		}
		
		return $check;
	}
	
	/**
    *	looks if the givven value is in the Course Array
    *
    *	@access	public
    *	@param	
    *   @return true/false
    */
	function inCourseArray($val)
	{
		$check=false;

		$tmpArray=$this->getCourses();		
		
		for ($i=0;$i<count($tmpArray);$i++)
		{					
			if ($val==$tmpArray[$i][COURSE_NAME]) 
			{
    			return true;
			}
			else
			{
				$check=false;
			}
		}
		
		return $check;
	}
	
	/**
    *	add new Course to Course Array
    *
    *	@access	public
    *	@param	
    *   @return true/false
    */
	function addCourse($new)
	{
		global $cfgTabCourse;      
		
		$sql = "insert into ".$cfgTabCourse." (COURSE_NAME) values ('$new')";	
	
        $result = $this->db->query($sql);
		if (DB::isError($result)) 
        {
           $this->setErrorMessage($result->getMessage());
           return false;
        }
		return true;
	}
	
	/**
    *	deletes Course from Course Array
    *
    *	@access	public
    *	@param	
    *   @return true/false
    */
	function delCourse($new)
	{
		global $cfgTabCourse;      
		
		$sql = "delete from ".$cfgTabCourse." where COURSE_NAME='$new'";	
	
        $result = $this->db->query($sql);
		if (DB::isError($result)) 
        {
           $this->setErrorMessage($result->getMessage());
           return false;
        }
		return true;
	}
	
	/**
    *	adds Education to the Education Array
    *
    *	@access	public
    *	@param	
    *   @return true/false
    */
	function addEducation($new)
	{
		global $cfgTabEducation;      
		
		$sql = "insert into ".$cfgTabEducation." (EDUCATION_NAME) values ('$new')";	
	
        $result = $this->db->query($sql);
		if (DB::isError($result)) 
        {
           $this->setErrorMessage($result->getMessage());
           return false;
        }
		return true;
	}

	/**
    *	deletes Education from Education Array
    *
    *	@access	public
    *	@param	
    *   @return true/false
    */
	function delEducation($new)
	{
		global $cfgTabEducation;      
		
		$sql = "delete from ".$cfgTabEducation." where EDUCATION_NAME='$new'";	
	
        $result = $this->db->query($sql);
		if (DB::isError($result)) 
        {
           $this->setErrorMessage($result->getMessage());
           return false;
        }
		return true;
	}
		
		/**
    *	adds School to the School Array
    *
    *	@access	public
    *	@param	
    *   @return true/false
    */
	function addSchool($new)
	{
		global $cfgTabSchool;      
		
		$sql = "insert into ".$cfgTabSchool." (SCHOOL_NAME) values ('$new')";	
	
        $result = $this->db->query($sql);
		if (DB::isError($result)) 
        {
           $this->setErrorMessage($result->getMessage());
           return false;
        }
		return true;
	}

	/**
    *	deletes School from School Array
    *
    *	@access	public
    *	@param	
    *   @return true/false
    */
	function delSchool($new)
	{
		global $cfgTabSchool;      
		
		$sql = "delete from ".$cfgTabSchool." where SCHOOL_NAME='$new'";	
	
        $result = $this->db->query($sql);
		if (DB::isError($result)) 
        {
           $this->setErrorMessage($result->getMessage());
           return false;
        }
		return true;
	}

}
?>
