<?php
// +----------------------------------------------------------------------+
// | sm survey module - html_quickform_functions                          |
// +----------------------------------------------------------------------+
// | Copyright (c) 2002 serie a - Digitale Medien und Systeme GmbH        |
// +----------------------------------------------------------------------+
// | Authors: Jrn Allert <allert@serie-a.de>                             |
// |          Rene Renk <renk@serie-a.de>                                 |
// +----------------------------------------------------------------------+
// | Description: Basic functions to create forms-data			  |
// +----------------------------------------------------------------------+
//
// $Id: quickformfunctions.assess.inc.php,v 1.1.1.1 2004/07/15 13:30:23 opensurveypilot Exp $

//session_Start
@session_start();

// require all configuration files and libraries
require_once($cfgPathToProjectAdmin."/config/config.inc.php"); // common config file // common config file
require_once($cfgPathToConf."/file.inc.php"); // project files
require_once($cfgPathToProbFiles."/config/prob.config.inc.php"); // auth config file
require_once($cfgPathToProbFiles."/config/prob.file.inc.php"); // modules files
require_once($cfgPathToProbFiles."/lib/dbfunctions.assess.inc.php"); // dbFunctions
require_once($cfgPathToProbFiles."/lib/createformparts.assess.inc.php"); // class extension


/**
* createQuickFormFunctions class
*
* extending class createFormParts
*
* Form-output creating class
*
* @author  Jrn Allert <allert@serie-a.de>
* @author  Rene Renk <renk@serie-a.de>
* @access  public
*/
class createQuickFormFunctions extends createFormParts
{	
	/**
    *	gets error message
    *
    *	@access	private
    *	@param	string	$err						error message
    */
    function getErrorMessage($err)
    {
        ;//echo "<br><br>--------------ERROR!!!------------------<br><b>".$this->errorMessage = $err. "</b><br>--------------ERROR!!!------------------<br><br>";
    }
	
	/**
    *	Containing Html-QuickForm-class
    *	@var  class  $processedForm					instance of html-quickform
    */	
	var $dbFunctions = "";
	
	/**
    *	Containing survey-data
    *	@var  array  $qffSurveyArray				data of merged tables $this->srvyTabSurvey->$this->srvyTabForms
    */	
	var $qffSurveyArray = array();

	/**
    *	Containing forms-data
    *	@var  array  $qffFormsArray					data of merged tables $this->srvyTabForms->$this->srvyTabFormtype
    */	
	var $qffFormsArray = array();

	/**
    *	Containing type-data
    *	@var  array  $qffTypeArray					data of merged tables $this->srvyTabFormtype->$this->srvyTabFormelement
    */	
	var $qffTypeArray = array();
	
	/**
    *	Containing Html-QuickForm-class
    *	@var  class  $processedForm					instance of html-quickform
    */	
	var $processedForm;
	
	/**
    *	Containing Switchvalues
    *	@var  array  $switchToData					switchdata array
    */	
	var $switchToData = array();

	/**
    *	Containing SwitchIndizes
    *	@var  int  $switchToData					switchdata index
    */	
	var $switchToDataIndex = 0;
	
	/**
    *	Containing Formstatus
    *	@var  int  validateStatus					indicates form beeing validated
    */	
	var $validateStatus = 0;
	
	/**
    *	Containing curently processed survey path
    *	@var  int  surveyPathCounter				indicates form beeing validated
    */	
	var $surveyPathCounter = 0;
	
	/**
    *	Containing curently processed survey form group
    *	@var  int  $urveyFormCounter				indicates form beeing validated
    */	
	var $surveyFormCounter = 0;
	
	/**
    *	Containing processed survey path to jump back from node path
    *	@var  int  surveyPathCounter				indicates form beeing validated
    */	
	var $surveyBackupPathCounter = 0;
	
	/**
    *	Containing curently processed survey form group to jump back from node path
    *	@var  int  $urveyFormCounter				indicates form beeing validated
    */	
	var $surveyBackupFormCounter = 0;
	
	/**
    *	Containing curently processed size of survey form group
    *	@var  int  $surveySize						indicates size of form group
    */	
	var $surveySize = 0;

	/**
    *	continue
    *	@var  int  $continue						indicates if end of all forms
    */	
	var $continue = 0;
	
	/**
    *	global counter for switch indizes
    *	@var  int  $switchIndex						counts switches
    */	
	var $switchIndex = 0;
	
	/**
    *	Rules to be declared
    *	@var  int  $switchIndex						counts switches
    */	
	var $declaredRules = array();
	
	/**
    *	Rules to be declared
    *	@var  int  $switchIndex						counts switches
    */	
	var $defaultRules = array();
	
	/**
    *	setter methods
    */	
	
	// tables
	function setSrvyTabSurvey($srvyTabSurvey){
		$this->srvyTabSurvey = $srvyTabSurvey;
	}
	function setSrvyTabForms($srvyTabForms){
		$this->srvyTabForms = $srvyTabForms;
	}
	function setSrvyTabFormtype($srvyTabFormtype){
		$this->srvyTabFormtype = $srvyTabFormtype;
	}
	function setSrvyTabFormelement($srvyTabFormelement){
		$this->srvyTabFormelement = $srvyTabFormelement;
	}
	function setSrvyTabFormEleRules($srvyTabFormEleRules){
		$this->srvyTabFormEleRules = $srvyTabFormEleRules;
	}
	
	// div
	function setSrvySubmitButton($srvySubmitButton){
		$this->srvySubmitButton = $srvySubmitButton;
	}
	function setSrvyGeneralError($srvyGeneralError){
		$this->srvyGeneralError = $srvyGeneralError;
	}
	function setSrvyLang($srvyLang){
		$this->srvyLang = $srvyLang;
	}
	
	// css
	function setSrvyCssString($srvyCssString){
		$this->srvyCssString = $srvyCssString;
	}
	
	// wrappers global
	function setSrvyElementHeadHtml($srvyElementHeadHtml){
		$this->srvyElementHeadHtml = $srvyElementHeadHtml;
	}
	function setSrvyElementFootHtml($srvyElementFootHtml){
		$this->srvyElementFootHtml = $srvyElementFootHtml;
	}
	function setSrvyDisplayError($srvyDisplayError){
		$this->srvyDisplayError = $srvyDisplayError;
	}
	function setSrvySeparateSpacer($srvySeparateSpacer){
		$this->srvySeparateSpacer = $srvySeparateSpacer;
	}
	function setSrvyErrorHtml($srvyErrorHtml){
		$this->srvyErrorHtml = $srvyErrorHtml;
	}
	function setSrvyElementErrorWrappers($srvyErrorWrappersHtml){
		$this->srvyElementErrorWrappers = $srvyErrorWrappersHtml;
	}
	function setSrvyDisplayErrorFooter($srvyDisplayErrorFooter){
		$this->srvyDisplayErrorFooter = $srvyDisplayErrorFooter;
	}	

	// submitted values
	function setSubmittedFormValues($submittedFormValues){
		$this->submittedFormValues = $submittedFormValues;
	}
	
	
	
	
	
    /**
	*	Constructor
	*					
	*	creates basic survey array
	*	and induces creation of Formdatacontaining arrays
	*	ordered by argument
    *
    *	@access	public
	*
    *	@param	int		$surveyToCreate				ID of Survey to use
    *   @param	array	$getFormSession				1 = get results from session -- 0 = create new data
    */
	function createQuickFormFunctions($surveyToCreate,$getFormSession=1)
	{
		
		// global tablenames
		global $cfgTabUsermask;
		global $cfgTabForms;
		global $cfgTabFormtype;
		global $cfgTabFormelement;
		global $cfgTabFormEleRules;
		// global div
		global $cfgAssessmentGeneralError;
		global $cfgAssessmentSubmitButton;
		// global wrappers global   
		global $cfgAssessmentElementHeadHtml;
		global $cfgAssessmentElementFootHtml;
		global $cfgAssessmentSeparateSpacer;
		global $cfgAssessmentDisplayError;
		global $cfgAssessmentErrorHtml;
		global $cfgAssessmentElementErrorWrappers;
		global $cfgAssessmentDisplayErrorFooter;
		
		// set object variables
		$this->dbFunctions = &new dbFunctions;
		
		// tables
		$this->setSrvyTabSurvey($cfgTabUsermask);
		$this->setSrvyTabForms($cfgTabForms);
		$this->setSrvyTabFormtype($cfgTabFormtype);
		$this->setSrvyTabFormelement($cfgTabFormelement);
		$this->setSrvyTabFormEleRules($cfgTabFormEleRules);
		

		
		// div
		$this->setSrvySubmitButton($cfgAssessmentSubmitButton);
		$this->setSrvyGeneralError($cfgAssessmentGeneralError);
		if($lang = $_SESSION["sessionUserLanguageType"])
		{
			$this->setSrvyLang($lang);
		}
		else
		{
			$this->setSrvyLang("de");
		}
		// wrappers global
		

		$this->setSrvyElementHeadHtml($cfgAssessmentElementHeadHtml);
		$this->setSrvyElementFootHtml($cfgAssessmentElementFootHtml);
		$this->setSrvyDisplayError($cfgAssessmentDisplayError);
		$this->setSrvySeparateSpacer($cfgAssessmentSeparateSpacer);
		$this->setSrvyErrorHtml($cfgAssessmentErrorHtml);
		$this->setSrvyElementErrorWrappers($cfgAssessmentElementErrorWrappers);
		$this->setSrvyDisplayErrorFooter($cfgAssessmentDisplayErrorFooter);

		// submitted values
		$this->setSubmittedFormValues($_POST);

		// default rules
		$this->defaultRules = $this->dbFunctions->checkForDefaultRuleMessages($surveyToCreate);

		//check if Data comes from Session
		if (($getFormSession==1)AND($_SESSION["qffValuePool"]["qffSessionSurveyArray"]))
		{
			$this->qffSurveyArray	=	$_SESSION["qffValuePool"]["qffSessionSurveyArray"];
			$this->qffFormsArray	=	$_SESSION["qffValuePool"]["qffSessionFormsArray"];
			$this->qffTypeArray	=	$_SESSION["qffValuePool"]["qffSessionTypeArray"];
			
			//print_r($_SESSION["qffValuePool"]["qffSessionSurveyArray"]);
			//print_r($_SESSION["qffValuePool"]["qffSessionFormsArray"]);
			//print_r($_SESSION["qffValuePool"]["qffSessionTypeArray"]);
			
		}
		
		else
		{
			$_SESSION["qffValuePool"]["qffSessionSurveyArray"] = false;
			$_SESSION["qffValuePool"]["qffSessionFormsArray"]= false;
			$_SESSION["qffValuePool"]["qffSessionTypeArray"]= false;
			//create Survey Array
			$this->qffCreateSurveyArray($surveyToCreate);
			//print_r ($this->qffSurveyArray);
			
			//
			if($this->qffSurveyArray == "error")
			{
				echo ($error = str_replace('{errormessage}', $this->srvyGeneralError, $this->srvyErrorHtml));
				exit;
			}
			//create Forms Array
			$this->qffFormsArray	= $this->qffCreateFormsArray($this->qffSurveyArray);//create Forms Array
			
			//print_r ($this->qffFormsArray);
			// case no data
			if($this->qffFormsArray == "error")
			{
				echo ($error = str_replace('{errormessage}', $this->srvyGeneralError, $this->srvyErrorHtml));
				exit;
			}
			$this->qffTypeArray = $this->qffCreateFormtypeArray($this->qffFormsArray);
			//print_r ($this->qffTypeArray);
			// case no data
			if($this->qffTypeArray == "error")
			{
				echo ($error = str_replace('{errormessage}', $this->srvyGeneralError, $this->srvyErrorHtml));
				exit;
			}
			//Store Values to Session..
			session_register("qffValuePool");
			// ..if valid information
			if(!$_SESSION["qffValuePool"]["qffSessionSurveyArray"] 	= $this->qffSurveyArray)
			{
				$err = "No data for qffSurveyArray in function: createQuickFormFunctions::createQuickFormFunctions";
				$this->getErrorMessage($err);
				return false;
			}
			if(!$_SESSION["qffValuePool"]["qffSessionFormsArray"] 	= $this->qffFormsArray)
			{
				$err = "No data for qffFormsArray in function: createQuickFormFunctions::createQuickFormFunctions";
				$this->getErrorMessage($err);
				return false;
			}
			if(!$_SESSION["qffValuePool"]["qffSessionTypeArray"] 	= $this->qffTypeArray)
			{
				$err = "No data for qffTypeArray in function: createQuickFormFunctions::createQuickFormFunctions>";
				$this->getErrorMessage($err);
				return false;
			}
		return true;
		}
	}
	
    /**
    *	creates survey array  (recursive function)
    *
    *	@access	public
	*
    *	@param	int		$surveyId					ID of survey to create
	*	@param	int		$parentId					ID of root element
	*	@param	array	$arrayPart					arrayPart for recursive data creation
	*
    *	@return	array  	$surveyArray				survey array tree
    */
	function qffCreateSurveyArray($surveyId,$parentId = '0')
	{
		
		$arrayData = $this->dbFunctions->joinTabByArgtoArray($this->srvyTabSurvey,$this->srvyTabForms,array("USERMASK_ID_PK" => "$surveyId", ),array("FORM_PROJECT_ID_FK" => "$surveyId", "FORM_PARENT_ID" => $parentId),"FORM_ORDER");
		// case no data
		for( $i=0; $i < count($arrayData); $i++ )
		{	
			// sort array if not root path
			if($parentId != 0)
			{
				$this->qffSurveyArray[$parentId] = $this->qffSortArrayByNodeGroups($arrayData);
			}
			else
			{
			$this->qffSurveyArray[$parentId] = $arrayData;
			}
			// check if has childs
			if($this->dbFunctions->isNode($arrayData[$i]["FORM_ID_PK"],$this->srvyTabForms,"FORM_PARENT_ID") )
			{
				$this->qffCreateSurveyArray($surveyId,$arrayData[$i]["FORM_ID_PK"]);
			}
		}
	}
	
    /**
    *	creates forms array
    *
    *	@access	public
	*
	*	@param	array	$parentArray				survey array 
	*
    *	@return	array  	$finalArray					merged table data as array
    */
	function qffCreateFormsArray($parentArray)
	{	
		foreach($parentArray as $key => $value)
		{
			for( $i=0; $i < count($value); $i++ )
			{
				$resultArray   = $this->dbFunctions->joinTabByArgtoArray($this->srvyTabForms,$this->srvyTabFormtype,array("FORM_ID_PK" => $this->qffSurveyArray[$key][$i]["FORM_ID_PK"]), array("FORMTYPE_FORM_ID_FK" => $this->qffSurveyArray[$key][$i]["FORM_ID_PK"]), "FORMTYPE_ORDER");
				if(is_array($resultArray))
				{
					$finalArray[$key][$i] = $resultArray;
				}
				else
				{
					$finalArray[$key] = 0;
				}
			}
		}
	return $finalArray;
	}

    /**
    *	creates formtype array
    *
    *	@access	public
	*
	*	@param	array	$parentArray				Array containing steering sql field
    *	@param	string	$colOrderValue				String pointing ordering sql field
	*
    *	@return	array  	$finalArray					merged table data as array
    */
	function qffCreateFormtypeArray($parentArray)
	{	
		if (!is_array($parentArray))
		{
			return false;
		}
		//create Formtype Array
		foreach($parentArray as $key => $value)
		{
			for($i=0;$i<count($value);++$i)
			{
				for($k=0;$k<count($value[$i]);++$k)
				{
					$resultArray	=	$this->dbFunctions->joinTabByArgtoArray($this->srvyTabFormtype,$this->srvyTabFormelement,array("FORMTYPE_ID_PK" => $this->qffFormsArray[$key][$i][$k]["FORMTYPE_ID_PK"]), array("FORMELEMENT_FORMTYPE_ID_FK" => $this->qffFormsArray[$key][$i][$k]["FORMTYPE_ID_PK"]), "FORMELEMENT_ORDER");
					// case is data add to final array
					if(is_array($resultArray))
					{
						$finalArray[$key][$i][$k] = $resultArray;
					}
					// add rules information
					if (is_array($resultArray))
					{
						$finalArray[$key][$i][$k][0]["FORMTYPE_RULE"] = 1;
						$finalArray[$key][$i][$k][0]["FORMTYPE_RULE"] = $this->qffCheckRules($finalArray[$key][$i][$k][0]);
					}
				}
			}
		}
	return $finalArray;
	}

	/**
	*	indicates additional rules
	*
    *	@access	public
    *	@param	array	$checkForRulesData 
    */
	function qffCheckRules($checkForRulesData)
	{
		// function arguments
		$colArgument 		= "ELEMENTRULE_FORMTYPE_ID_FK";
		$colArgumentValue	= $checkForRulesData["FORMTYPE_ID_PK"];
		// get values
		$RulesData = $this->dbFunctions->tabToArrayWhithArg($this->srvyTabFormEleRules,array($colArgument => $colArgumentValue),"","ELEMENTRULE_ATTRIBUTE");
		// no rules
		if(count($RulesData) == 0)
		{
			return 0;
		}
		// get rules from array
		for($i = 0; $i < count($RulesData) ; ++$i)
		{
			// add rule if is rule
			$RulesData[$i]["ELEMENTRULE_VALUE"] 	=	"";// values for rangelength etc not implemented yet // 030309-rr
			$RulesData[$i]["ELEMENTRULE_RESET"]	=	false;
			// check for validation type
			//
			// define method of errorhandling here server/client/private
			//
			$RulesData[$i]["ELEMENTRULE_VALIDATION_TYPE"] = 'server';
		}
		return $RulesData;
	}
	
    /**
	* 	Creates Form using number of forms index
	*
    *	@access	public
	*
    *	@param	int		$this->surveyFormCounter			Index in $this->qffFormsArray[0] of Form to be shown
	*/
	function qffCreateFormOutput($surveyFormCounter = '0',$surveyPathCounter = '0', $display = '1', $validation=1)
	{
		//reset continue
		$this->continue = 0;
		// default for quitcounter
		$_SESSION["qffControlPool"]["fromNodeGroup"] = true;
		// reset errors
		$_SESSION["qffControlPool"]["validationErrors"] = false;
		// set form counters
		if ($surveyFormCounter == "")
		{
			$surveyFormCounter = '0';
		}
		$this->surveyFormCounter = $surveyFormCounter;
		
		// set path counters
		if ($surveyPathCounter == "")
		{
			$surveyPathCounter = '0';
		}
		$this->surveyPathCounter = $surveyPathCounter;
		// set survey size
		if($this->submittedFormValues["surveySize"])
		{
			$this->surveySize  = $this->submittedFormValues["surveySize"];
		}
		else
		{
			$this->surveySize  = count($this->qffSurveyArray[$this->surveyPathCounter]);
		}
		//
		// check if valid after first post and process switchdata
		if ($this->submittedFormValues["currentProcessedForm"])
		{	
			// validate form
			if ($validation)
			{
				if(!$this->qffValidateForm($this->surveyPathCounter,($this->surveyFormCounter - 1)))
				{
					return $this->processedForm->toHtml();
					//return; // validation processed
				}
			}
		}
		//
		
		//echo $this->surveyFormCounter;
		//echo $this->surveySize;
		// final form or nodegroup back
		if ($this->surveyFormCounter >= $this->surveySize)
		{ 
			return "ok";
		}
		//
		// start new form
		//
		
	
		// which form to be displayed
		$formTagData = $this->qffSurveyArray[$this->surveyPathCounter][$this->surveyFormCounter];
		// create formname
		$formName = "form_X0y0Z_nmb_".$formTagData["FORM_ID_PK"];
		// create formtag
		
		$this->processedForm = new quickformSmExtended($formName,$formTagData["FORM_METHOD"]);
		// clear templates
		$this->processedForm->clearElementTemplates();
		// add form header
		//$this->qffAddHeader($this->variableReplace(nl2br($formTagData["FORM_HEADER"])));
		// default workaround for validate bug // if no rules validate returns false script does not proceed //030327-rr
		// also prevents javascript from not finding elements by id // 030401-rr
		$this->qffCreateHidden('dummy','123456789');
		$this->processedForm->addRule('dummy', '', 'numeric');
		//add borderline
		$this->processedForm->addLine('');
		//
		// create formparts
		$formPartsNumber = count($this->qffFormsArray[$this->surveyPathCounter][$this->surveyFormCounter]);

		for ($i=0;$i<$formPartsNumber;$i++)
		{	
			// give over to process output
			$this->qffCheckFormType($this->surveyPathCounter,$this->surveyFormCounter,$i);
			//equal session and this type-array because of changes
			$_SESSION["qffValuePool"]["qffSessionTypeArray"] 	= $this->qffTypeArray;
		}
		// end create formparts
		//
		
		

		
		//set required note default
		$declaredRules = "";
		if(is_array($this->declaredRules))
		{
			foreach($this->declaredRules as $typeOfRule => $ruleFooterDisplay)
			{
				$declaredRules .= $ruleFooterDisplay." ";
			}
			$declaredRules ="<div>".$declaredRules."</div>";
		}
		$this->processedForm->setRequiredNote($declaredRules);
		// give current form per hidden
		$this->qffCreateHidden('currentProcessedForm',($this->surveyFormCounter+1));
		// give surveysize per hidden
		$this->qffCreateHidden('surveySize', $this->surveySize);
		// give surveysize per hidden
		$this->qffCreateHidden('surveyPath', $this->surveyPathCounter);
		// replace aliasses
		$head = $this->qffClearObsoleteAliasses($this->srvyElementHeadHtml);
		// set head wrapper
		$this->processedForm->addData($head);
		// make submit
		$this->processedForm->addElement('submit', $formName,$this->srvySubmitButton, array('class'=>'button'));
		// set foot wrapper
		$this->processedForm->addData($this->srvyElementFootHtml);
		// delete whitespace
		$this->processedForm->applyFilter('__ALL__', 'trim');	
		// display form

		if ($display == '1')
		{
			$this->processedForm->display();
			return true;
		}
		else
		{
			return $this->processedForm->toHtml();
		}
	}
	

    /**
	* 	Switches Formtypeelements for type of form
	*	calling html producing functions in class createFormParts which this class extends
	*
    *	@access	private
	*
	*	@param	array	$this->surveyFormCounter			which form
	*	@param	array	$formElementDataIndex		which formpart (formtype)
	*/
	function qffCheckFormType($currentPathCounter,$currentFormCounter,$formElementDataIndex)
	{	
		//determine formtype
		$formtype = strtolower($this->qffTypeArray[$currentPathCounter][$currentFormCounter][$formElementDataIndex][0]["FORMTYPE_TYPE"]);
		//create formtypedata to process (use reference)
		$formPartTagData = &$this->qffTypeArray[$currentPathCounter][$currentFormCounter][$formElementDataIndex];
		//switch Data to determine Formtype

		switch ($formtype)
		{
			case "textarea":
			{
			$this->qffCreateTextarea($formPartTagData);
			break;
			}
			case "text":
			{
			$this->qffCreateText($formPartTagData);
			break;
			}
			case "select":
			{
			$this->qffCreateSelect($formPartTagData);
			break;
			}
			case "radio":
			{
			$this->qffCreateRadio($formPartTagData);
			break;
			}
		}
		return true;
	}

    /**qffCreateTableGroup($formPartTagData)
	* 	Validates Form with required Values
	*
    *	@access	public
	*
    *	@param	int		$this->surveyFormCounter			Index in $this->qffFormsArray[0] of Form to be shown
	*/
	function qffValidateForm($validatePathCounter,$validateFormCounter)
	{
		//
		// create former form for validation
		//
		// which form to be displayed
		$formTagData = $this->qffSurveyArray[$validatePathCounter][$validateFormCounter];
		
		// create formname
		$formName = "form_X0y0Z_nmb_".$formTagData["FORM_ID_PK"];
		// create formtag
		$this->processedForm = &new quickformSmExtended($formName,$formTagData["FORM_METHOD"]);
		// clear templates
		$this->processedForm->clearElementTemplates();
		// add form header
		$this->qffAddHeader($this->variableReplace(nl2br($formTagData["FORM_HEADER"])));
		// default workaround for validate bug // if no rules validate returns false script does not proceed //030327-rr
		// also prevents javascript from not finding elements by id // 030401-rr
		$this->qffCreateHidden('dummy','123456789');
		$this->processedForm->addRule('dummy', '', 'numeric');
		// add borderline
		$this->processedForm->addLine('');
		// give validatestatus for class
		$this->validateStatus = 1;
		// create formparts
		$formPartsNumber = count($this->qffFormsArray[$validatePathCounter][$validateFormCounter]);
		
		for ($i=0;$i<$formPartsNumber;$i++)
		{	
			// give over to process output
			$this->qffCheckFormType($validatePathCounter,$validateFormCounter,$i);
			//equal session and this type-array because of changes
			$_SESSION["qffValuePool"]["qffSessionTypeArray"] 	= $this->qffTypeArray;
		}
		// end create Formparts
		//
		//set required note default
		$declaredRules = "";
		if(is_array($this->declaredRules))
		{
			foreach($this->declaredRules as $typeOfRule => $ruleFooterDisplay)
			{
				$declaredRules .= $ruleFooterDisplay." ";
			}
			$declaredRules ="<div>".$declaredRules."</div>";
		}
		$this->processedForm->setRequiredNote($declaredRules);
		// if validation failes show again
		if (!$this->processedForm->validate())
		{
			// set new control variables
			$_SESSION["qffControlPool"]["validationErrors"] = $this->processedForm->_errors;
			// give validatestatus per session
			$_SESSION["qffControlPool"]["validateStatus"] = 1;
			// set back history counter
			$_SESSION["qffControlPool"]["historyCounter"]--;
			//
			// create former form again to display errors properly
			//
			// which form to be displayed
			$formTagData = $this->qffSurveyArray[$validatePathCounter][$validateFormCounter];
			// create formname
			$formName = "form_X0y0Z_nmb_".$formTagData["FORM_ID_PK"];
			// create formtag
			$this->processedForm = &new quickformSmExtended($formName,$formTagData["FORM_METHOD"]);
			// clear templates
			$this->processedForm->clearElementTemplates();
			// add form header
			//$this->qffAddHeader($this->variableReplace(nl2br($formTagData["FORM_HEADER"])));
			// default workaround for validate bug // if no rules validate returns false script does not proceed //030327-rr
			// also prevents javascript from not finding elements by id // 030401-rr
			$this->qffCreateHidden('dummy','123456789');
			$this->processedForm->addRule('dummy', '', 'numeric');
			// add borderline
			$this->processedForm->addLine('');
			// give validatestatus for class
			$this->validateStatus = 1;
			// create formparts
			$formPartsNumber = count($this->qffFormsArray[$validatePathCounter][$validateFormCounter]);
			for ($i=0;$i<$formPartsNumber;$i++)
			{	
				// give over to process output
				$this->qffCheckFormType($validatePathCounter,$validateFormCounter,$i);
				//equal session and this type-array because of changes
				$_SESSION["qffValuePool"]["qffSessionTypeArray"] 	= $this->qffTypeArray;
			}
			// end create Formparts
			//
			//set required note default
			$declaredRules = "";
			if(is_array($this->declaredRules))
			{
				foreach($this->declaredRules as $typeOfRule => $ruleFooterDisplay)
				{
					$declaredRules .= $ruleFooterDisplay." ";
				}
				$declaredRules ="<div>".$declaredRules."</div>";
			}
			$this->processedForm->setRequiredNote($declaredRules);
			// add additional elements
			//
			// give current form per hidden
			$this->qffCreateHidden('currentProcessedForm',$this->surveyFormCounter);
			// give surveysize per hidden
			$this->qffCreateHidden('surveySize', $this->surveySize);
			// give current path per hidden
			$this->qffCreateHidden('surveyPath', $this->surveyPathCounter);
			// replace aliasses
			$head = $this->qffClearObsoleteAliasses($this->srvyElementHeadHtml);
			// set head wrapper
			$this->processedForm->addData($head);
			// make submit
			$this->processedForm->addElement('submit', $formName,$this->srvySubmitButton);
			// set foot wrapper
			$this->processedForm->addData($this->srvyElementFootHtml);
			// delete whitespace
			$this->processedForm->applyFilter('__ALL__', 'trim');	
			// display form
			//$this->processedForm->display();
			//return not validated
			return false;
		}
		// set back history counter
		// delete validation form and status
		$_SESSION["qffControlPool"]["validateStatus"] = false;
		$this->validateStatus = 0;
		// return validated
		if($_SESSION["qffControlPool"]["justPreview"])
		{
			return false; // function only called for Preview one group
		}
		return true;
	}
}
?>