<?php
// +----------------------------------------------------------------------+
// | survey pilot                                                         |
// +----------------------------------------------------------------------+
// | Copyright (c) 2002 serie a - Digitale Medien und Systeme GmbH        |
// +----------------------------------------------------------------------+
// | Authors: 	J?rn Allert <allert@serie-a.de>                           |
// |          	Rene Renk <renk@serie-a.de>                               |
// +----------------------------------------------------------------------+
//
// $Id: prob.add.course.php,v 1.1.1.1 2004/07/15 13:29:44 opensurveypilot Exp $

// start session
@session_start();

// require all configuration files and libraries
require_once("./../config/config.inc.php"); // common config file
require_once($cfgPathToConf."/file.inc.php"); // project files
require_once($cfgPathToLib."/common.inc.php"); // common functions
require_once($cfgPathToAuthFiles."/config/auth.file.inc.php"); // auth files
require_once($cfgPathToAuthFiles."/lib/user.inc.php"); // auth user functions
require_once($cfgPathToProbFiles."/config/prob.config.inc.php"); // proband config file
require_once($cfgPathToProbFiles."/config/prob.file.inc.php"); // proband files
require_once($cfgPathToProbFiles."/lib/prob.inc.php"); // proband functions
require_once("HTML/Template/IT.php"); // PEAR::HTML_TEMPLATE_IT

// create new userFunctions object
$client = &new userFunctions;

//login check
if ($client->getAuthentication($_SESSION["sessionId"], session_id()) == false)
{
    //redirect to login page
    ?>
    <script type="text/javascript">
    <!--
    window.location.href="<?php echo $cfgUrlToProject."/".$fileAuthLogin; ?>";
    -->
    </script>
    <?php
    exit;
}

// function permission check
if($_SESSION["sessionUserStatusId"] < $permRawDataDetailView)
{
    ?>
    <script type="text/javascript">
    <!--
    window.location.href="<?php echo $cfgUrlToProject."/".$fileNoPermission."?messageCode=2"; ?>";
    -->
    </script>
    <?php
    exit;
}

// instanciate probands object
$probands = &new Proband; 

// get sessionUserLogin
$sessionUserLogin = $_SESSION["sessionUserLogin"];

// get sessionUserPassword
$sessionUserPassword = $_SESSION["sessionUserPassword"];

// check if form was submitted
if($_SERVER["REQUEST_METHOD"] == "POST")
{
   
    if ($_POST["delete"])
	{
		
		if (is_array($_POST["liste"]))
		{
			foreach ($_POST["liste"] as $value)
			{
				$probands->delCourse($value);
			}
		}
		
		// create Template IT object
		$tpl = new HTML_Template_IT($cfgPathToProbTemplates);
		
		// load template
		$tpl->loadTemplatefile($templateProbCourseAdd, true, true);
		
		// set title
		$tpl->setVariable( "applicationtitle", $cfgApplicationType.$cfgApplicationVersion);
		
		if ($_GET["new"])
		{
			$new=$_GET["new"];
			$tpl->setVariable( "new", $new);
		}
		
		if ($_GET["back"])
		{
			$back=$_GET["back"];
			$tpl->setCurrentBlock("back") ;
			$tpl->setVariable( "lnk_back", $back );
			$tpl->parseCurrentBlock("back");
			$tpl->setVariable( "formaction", $fileProbAddCourse."?back=$back&new=$new" );
			
		}
		else
		{
			$tpl->setVariable( "formaction", $fileProbAddCourse );
		}
		
		
		if (is_array($_POST["liste"]))
		{
			$tpl->setVariable( "errors", count($_POST["liste"])." ".$lang_script["prob.add.course.php"]["deletecourseMessage"]);
		}
		else
		{
			$tpl->setVariable( "errors", $lang_script["prob.add.course.php"]["deletecourseError"]);
		}
		
		$tpl->setVariable( "lnk_education", $fileProbAddEdu );
		$tpl->setVariable( "lnk_courses", $fileProbAddCourse );
					$tpl->setVariable( "lnk_school", $fileProbAddSchool );
		
		
		$EduArray=$probands->getCourses();
	
		foreach ($EduArray as $EduArray_flat)
		{	
			foreach ($EduArray_flat as $value)
			{		
				$tpl->setCurrentBlock("liste") ;
				$tpl->setVariable( "liste_selected", "" );
				$tpl->setVariable( "liste_value", $value );
				$tpl->parseCurrentBlock("liste");	
			}
		}	

		// parse template
		$tpl->parse();
		
		// get the parsed template and print it
		$tpl->get();
		$tpl->show();		
	}
	else
	{
	    $new = $_POST["new"];
		
		$EduArray=$probands->getCourses();
		
		$check=true;
		
		foreach ($EduArray as $EduArray_flat)
		{	
			foreach ($EduArray_flat as $value)
			{		
				if ($value==$new)
				$check=false;		
			}
		}	
		
		if ($check)
		{
			// add
			if ($new!="")
			{
			    if ($probands->addCourse($new))
				{			
					// create Template IT object
					$tpl = new HTML_Template_IT($cfgPathToProbTemplates);
					
					// load template
					$tpl->loadTemplatefile($templateProbCourseAdd, true, true);
					
					// set title
					$tpl->setVariable( "applicationtitle", $cfgApplicationType.$cfgApplicationVersion);
					$tpl->setVariable( "errors", $lang_script["prob.add.course.php"]["addsuccesscourseMessage"]);
					$tpl->setVariable( "lnk_education", $fileProbAddEdu );
					$tpl->setVariable( "lnk_courses", $fileProbAddCourse );
					$tpl->setVariable( "lnk_school", $fileProbAddSchool );
					
					if ($_GET["new"])
					{
						$new=$_GET["new"];
						$tpl->setVariable( "new", $new);
					}
					
					if ($_GET["back"])
					{
						$back=$_GET["back"];
						$tpl->setCurrentBlock("back") ;
						$tpl->setVariable( "lnk_back", $back );
						$tpl->parseCurrentBlock("back");
						$tpl->setVariable( "formaction", $fileProbAddCourse."?back=$back&new=$new" );
						
					}
					else
					{
						$tpl->setVariable( "formaction", $fileProbAddCourse );
					}
					
					$EduArray=$probands->getCourses();
				
					foreach ($EduArray as $EduArray_flat)
					{	
						foreach ($EduArray_flat as $value)
						{		
							$tpl->setCurrentBlock("liste") ;
							$tpl->setVariable( "liste_selected", "" );
							$tpl->setVariable( "liste_value", $value );
							$tpl->parseCurrentBlock("liste");	
						}
					}	
		
					// parse template
					$tpl->parse();
					
					// get the parsed template and print it
					$tpl->get();
					$tpl->show();
				}
			
			}
			else
			{
					// create Template IT object
					$tpl = new HTML_Template_IT($cfgPathToProbTemplates);
					
					// load template
					$tpl->loadTemplatefile($templateProbCourseAdd, true, true);
					
					// set title
					$tpl->setVariable( "applicationtitle", $cfgApplicationType.$cfgApplicationVersion);
					$tpl->setVariable( "errors", $lang_script["prob.add.course.php"]["emptyenterError"]);
					$tpl->setVariable( "lnk_education", $fileProbAddEdu );
					$tpl->setVariable( "lnk_courses", $fileProbAddCourse );
					$tpl->setVariable( "lnk_school", $fileProbAddSchool );
					
					if ($_GET["new"])
					{
						$new=$_GET["new"];
						$tpl->setVariable( "new", $new);
					}
					
					if ($_GET["back"])
					{
						$back=$_GET["back"];
						$tpl->setCurrentBlock("back") ;
						$tpl->setVariable( "lnk_back", $back );
						$tpl->parseCurrentBlock("back");
						$tpl->setVariable( "formaction", $fileProbAddCourse."?back=$back&new=$new" );
						
					}
					else
					{
						$tpl->setVariable( "formaction", $fileProbAddCourse );
					}
					
					$EduArray=$probands->getCourses();
				
					foreach ($EduArray as $EduArray_flat)
					{	
						foreach ($EduArray_flat as $value)
						{		
							$tpl->setCurrentBlock("liste") ;
							$tpl->setVariable( "liste_selected", "" );
							$tpl->setVariable( "liste_value", $value );
							$tpl->parseCurrentBlock("liste");	
						}
					}	
		
					// parse template
					$tpl->parse();
					
					// get the parsed template and print it
					$tpl->get();
					$tpl->show();
			}
		}
		else
		{
			// create Template IT object
			$tpl = new HTML_Template_IT($cfgPathToProbTemplates);
			
			// load template
			$tpl->loadTemplatefile($templateProbCourseAdd, true, true);
			
			// set title
			$tpl->setVariable( "applicationtitle", $cfgApplicationType.$cfgApplicationVersion);
			$tpl->setVariable( "lnk_education", $fileProbAddEdu );
			$tpl->setVariable( "lnk_courses", $fileProbAddCourse );
			$tpl->setVariable( "lnk_school", $fileProbAddSchool );
			
			if ($_GET["new"])
			{
				$new=$_GET["new"];
				$tpl->setVariable( "new", $new);
			}
			
			if ($_GET["back"])
			{
				$back=$_GET["back"];
				$tpl->setCurrentBlock("back") ;
				$tpl->setVariable( "lnk_back", $back );
				$tpl->parseCurrentBlock("back");
				$tpl->setVariable( "formaction", $fileProbAddCourse."?back=$back&new=$new" );
				
			}
			else
			{
				$tpl->setVariable( "formaction", $fileProbAddCourse );
			}
			
			$EduArray=$probands->getCourses();
		
			foreach ($EduArray as $EduArray_flat)
			{	
				foreach ($EduArray_flat as $value)
				{		
					$tpl->setCurrentBlock("liste") ;
					$tpl->setVariable( "liste_selected", "" );
					$tpl->setVariable( "liste_value", $value );
					$tpl->parseCurrentBlock("liste");	
				}
			}	
	
			// parse template
			$tpl->parse();
			
			// get the parsed template and print it
			$tpl->get();
			$tpl->show();
		}
	}
}
else
{
	
	// create Template IT object
	$tpl = new HTML_Template_IT($cfgPathToProbTemplates);
	
	// load template
	$tpl->loadTemplatefile($templateProbCourseAdd, true, true);
	
	// set title
	$tpl->setVariable( "applicationtitle", $cfgApplicationType.$cfgApplicationVersion);
	$tpl->setVariable( "lnk_education", $fileProbAddEdu );
	$tpl->setVariable( "lnk_courses", $fileProbAddCourse );
	$tpl->setVariable( "lnk_school", $fileProbAddSchool );
	
	if ($_GET["new"])
	{
		$new=$_GET["new"];
		$tpl->setVariable( "new", $new);
	}
	
	if ($_GET["back"])
	{
		$back=$_GET["back"];
		$tpl->setCurrentBlock("back") ;
		$tpl->setVariable( "lnk_back", $back );
		$tpl->parseCurrentBlock("back");
		$tpl->setVariable( "formaction", $fileProbAddCourse."?back=$back&new=$new" );
		
	}
	else
	{
		$tpl->setVariable( "formaction", $fileProbAddCourse );
	}
	
	$EduArray=$probands->getCourses();
	
	if (is_array($EduArray))
	{
		foreach ($EduArray as $EduArray_flat)
		{	
			foreach ($EduArray_flat as $value)
			{		
				$tpl->setCurrentBlock("liste") ;
				$tpl->setVariable( "liste_selected", "" );
				$tpl->setVariable( "liste_value", $value );
				$tpl->parseCurrentBlock("liste");	
			}
		}
	}
	
	// parse template
	$tpl->parse();
	
	// get the parsed template and print it
	$tpl->get();
	$tpl->show();
}
?>

