<?php
// +----------------------------------------------------------------------+
// | survey pilot                                                         |
// +----------------------------------------------------------------------+
// | Copyright (c) 2002 serie a - Digitale Medien und Systeme GmbH        |
// +----------------------------------------------------------------------+
// | Authors: 	Jrn Allert <allert@serie-a.de>                           |
// |          	Rene Renk <renk@serie-a.de>                               |
// +----------------------------------------------------------------------+
//
// $Id: prob.assume.php,v 1.1.1.1 2004/07/15 13:29:47 opensurveypilot Exp $

// start session
@session_start();

// require all configuration files and libraries
require_once("./../config/config.inc.php"); // common config file
require_once($cfgPathToConf."/file.inc.php"); // project files
require_once($cfgPathToLib."/common.inc.php"); // common functions
require_once($cfgPathToAuthFiles."/config/auth.file.inc.php"); // auth files
require_once($cfgPathToAuthFiles."/lib/user.inc.php"); // auth user functions
require_once($cfgPathToProbFiles."/lib/prob.inc.php"); // proband functions
require_once($cfgPathToProbFiles."/config/prob.file.inc.php"); // proband files
require_once($cfgPathToProbFiles."/config/prob.config.inc.php"); // proband config
require_once("HTML/Template/IT.php"); // PEAR::HTML_TEMPLATE_IT

// create new userFunctions object
$client = &new userFunctions;

//login check
if ($client->getAuthentication($_SESSION["sessionId"], session_id()) == false)
{
    //redirect to login page
    ?>
    <script type="text/javascript">
    <!--
    window.location.href="<?php echo $cfgUrlToProject."/".$fileAuthLogin; ?>";
    -->
    </script>
    <?php
    exit;
}

// function permission check
if($_SESSION["sessionUserStatusId"] < $permRawDataDelete)
{
    ?>
    <script type="text/javascript">
    <!--
    window.location.href="<?php echo $cfgUrlToProject."/".$fileNoPermission."?messageCode=2"; ?>";
    -->
    </script>
    <?php
    exit;
}

$probands = &new Proband; 

// get sessionUserLogin
$sessionUserLogin = $_SESSION["sessionUserLogin"];

// get sessionUserPassword
$sessionUserPassword = $_SESSION["sessionUserPassword"];

// create Template IT object
$tpl = new HTML_Template_IT($cfgPathToProbTemplates);

// load template
$tpl->loadTemplatefile($templateProbAssume, true, true);

// set title
$tpl->setVariable( "applicationtitle", $cfgApplicationType.$cfgApplicationVersion);

// get user id for detailview
if(isset($_GET["userId"]))
{
    $userId = $_GET["userId"];
}

if($_SERVER["REQUEST_METHOD"] == "POST")
{
	$groupArray=$_POST["groups"];
	$userId = $_POST["userId"];
	if ($probands->Proband_to_Group ($userId, $groupArray))
	{
		//$tpl->setVariable( "status", "Speichern erfolgreich.");
	}
	else
	{
		$tpl->setVariable( "status", $lang_script["prob.assume.php"]["saveError"]);
	}
}

$tpl->setVariable( "lnk_edit", $fileProbEdit."?userId=$userId");
$tpl->setVariable( "lnk_delete", $fileProbDelete."?userId=$userId");
$tpl->setVariable( "lnk_assume", $fileProbAssume."?userId=$userId");

$tpl->setVariable( "formaction", $fileProbAssume);
$tpl->setVariable( "userId", $userId);

$probandgroupsArray = $probands->getProbandGroups(0, 1000, "GROUPS_NAME", "ASC");

$hisgroupsArray = $probands->get_Groups_of_Proband($userId);

for ($i=0;$i < count($probandgroupsArray);$i++)
{
	$tpl->setCurrentBlock("grouplist") ;
	
	if (is_array($hisgroupsArray))
	{
		if (in_array ($probandgroupsArray[$i]["GROUPS_ID_PK"], $hisgroupsArray))
		{
			$tpl->setVariable( "group_selected", "selected" );
		}
		else
		{
			$tpl->setVariable( "group_selected", "" );
		}
	}
	
	$tpl->setVariable( "group_name", $probandgroupsArray[$i]["GROUPS_NAME"]);
	$tpl->setVariable( "group_value", $probandgroupsArray[$i]["GROUPS_ID_PK"]);
	$tpl->parseCurrentBlock("grouplist");
}



// parse template
$tpl->parse();

// get the parsed template and print it
$tpl->get();
$tpl->show();   


?>
