<?php
// +----------------------------------------------------------------------+
// | survey pilot                                                         |
// +----------------------------------------------------------------------+
// | Copyright (c) 2002 serie a - Digitale Medien und Systeme GmbH        |
// +----------------------------------------------------------------------+
// | Authors: 	Jrn Allert <allert@serie-a.de>                           |
// |          	Rene Renk <renk@serie-a.de>                               |
// +----------------------------------------------------------------------+
//
// $Id: prob.delete.php,v 1.1.1.1 2004/07/15 13:29:47 opensurveypilot Exp $

// start session
@session_start();

// require all configuration files and libraries
require_once("./../config/config.inc.php"); // common config file
require_once($cfgPathToConf."/file.inc.php"); // project files
require_once($cfgPathToLib."/common.inc.php"); // common functions
require_once($cfgPathToAuthFiles."/config/auth.file.inc.php"); // auth files
require_once($cfgPathToAuthFiles."/lib/user.inc.php"); // auth user functions
require_once($cfgPathToProbFiles."/lib/prob.inc.php"); // proband functions
require_once($cfgPathToProbFiles."/config/prob.file.inc.php"); // proband files
require_once($cfgPathToProbFiles."/config/prob.config.inc.php"); // proband config
require_once("HTML/Template/IT.php"); // PEAR::HTML_TEMPLATE_IT

// create new userFunctions object
$client = &new userFunctions;

//login check
if ($client->getAuthentication($_SESSION["sessionId"], session_id()) == false)
{
    //redirect to login page
    ?>
    <script type="text/javascript">
    <!--
    window.location.href="<?php echo $cfgUrlToProject."/".$fileAuthLogin; ?>";
    -->
    </script>
    <?php
    exit;
}

// function permission check
if($_SESSION["sessionUserStatusId"] < $permRawDataDelete)
{
    ?>
    <script type="text/javascript">
    <!--
    window.location.href="<?php echo $cfgUrlToProject."/".$fileNoPermission."?messageCode=2"; ?>";
    -->
    </script>
    <?php
    exit;
}

$probands = &new Proband; 

// get sessionUserLogin
$sessionUserLogin = $_SESSION["sessionUserLogin"];

// get sessionUserPassword
$sessionUserPassword = $_SESSION["sessionUserPassword"];

// get user id for detailview
if(isset($_GET["userId"]))
{
    $userId = $_GET["userId"];
}

// fetch rawdata
$result=$probands->getProbandUserRow($userId);

$groups=$probands->get_Groups_of_Proband($userId);

if (count($groups) >0)
{
	$userError = $lang_script["prob.delete.php"]["usertogroupMessage1"]." ".count($groups)." ".$lang_script["prob.delete.php"]["usertogroupMessage2"];
}

// check if form was submitted
if($_SERVER["REQUEST_METHOD"] == "POST")
{
    $userId = $_POST["userId"];
    
    // delete
    if ($probands->deleteProbandUser($userId))
	{
		?>
        <script type="text/javascript">
        <!--
        window.location.href="<?php echo $cfgUrlToProject."/".$fileDeleteSuccessMessage; ?>";
        -->
        </script>
        <?php
	}
	else
	{
		$probands->getErrorMessage();
	}
}

// create Template IT object
$tpl = new HTML_Template_IT($cfgPathToProbTemplates);

// load template
$tpl->loadTemplatefile($templateProbDelete, true, true);

// set title
$tpl->setVariable( "applicationtitle", $cfgApplicationType.$cfgApplicationVersion);

$tpl->setVariable( "lnk_edit", $fileProbEdit."?userId=$userId");
$tpl->setVariable( "lnk_delete", $fileProbDelete."?userId=$userId");
$tpl->setVariable( "lnk_assume", $fileProbAssume."?userId=$userId");


$tpl->setVariable( "formaction", $fileProbDelete );

if (count($groups) >0)
{
	$tpl->setVariable( "errors", $userError );
}

$tpl->setVariable( "userId", $userId );
$tpl->setVariable( "name", $result[0][USERDATA_NNAME].", ".$result[0][USERDATA_VNAME] );
$tpl->setVariable( "gebdat", $result[0][USERDATA_AGE] );
$tpl->setVariable( "ort", $result[0][USERDATA_CITY] );
$tpl->setVariable( "abschluss", $result[0][USERDATA_DEGREE] );

// parse template
$tpl->parse();

// get the parsed template and print it
$tpl->get();
$tpl->show();   


?>
