<?php
// +----------------------------------------------------------------------+
// | Assessment pilot                                                         |
// +----------------------------------------------------------------------+
// | Copyright (c) 2002 serie a - Digitale Medien und Systeme GmbH        |
// +----------------------------------------------------------------------+
// | Authors: 	Daniel Peer <peer@serie-a.de>                             |
// |          	                                                          |
// +----------------------------------------------------------------------+
//
// $Id: prob.group.add.php,v 1.1.1.1 2004/07/15 13:29:49 opensurveypilot Exp $



// start session
@session_start();

// require all configuration files and libraries
require_once("./../config/config.inc.php"); // common config file
require_once($cfgPathToConf."/file.inc.php"); // project files
require_once($cfgPathToLib."/common.inc.php"); // common functions
require_once($cfgPathToProbFiles."/config/prob.config.inc.php"); // proband config file
require_once($cfgPathToProbFiles."/config/prob.file.inc.php"); // proband files
require_once($cfgPathToProbFiles."/lib/prob.inc.php"); // proband functions
require_once($cfgPathToAuthFiles."/lib/user.inc.php"); // auth user functions
require_once($cfgPathToAuthFiles."/config/auth.file.inc.php"); // auth user files
require_once($cfgPathToAuthFiles."/lib/permission.inc.php"); // permission functions
require_once("HTML/Template/IT.php"); // PEAR::HTML_TEMPLATE_IT


// create new userFunctions object
$client = &new userFunctions;

//login check
if ($client->getAuthentication($_SESSION["sessionId"], session_id()) == false)
{
    //redirect to login page
    ?>
    <script type="text/javascript">
    <!--
    window.location.href="<?php echo $cfgUrlToProject."/".$fileAuthLogin; ?>";
    -->
    </script>
    <?php
    exit;
}

// function permission check
if($_SESSION["sessionUserStatusId"] < $permRawDataDetailView)
{
    ?>
    <script type="text/javascript">
    <!--
    window.location.href="<?php echo $cfgUrlToProject."/".$fileNoPermission."?messageCode=2"; ?>";
    -->
    </script>
    <?php
    exit;
}


?>
<script language="JavaScript" src="./../lib/javascript/common.js"></script>
<?php



// instanciate probands object
$probandgroups = &new Proband;

// get user id for detailview
$groupId = (isset($_GET["groupId"])) ? $_GET["groupId"] : $_POST["groupId"];


$tpl = new HTML_Template_IT($cfgPathToProbTemplates);
$tpl->loadTemplatefile($templateProbGroupAdd, true, true); // do remove untouched blocks

if($_SERVER["REQUEST_METHOD"] == "POST")
{
	if ($_POST["groupname"]=="")
	{
		$tpl->setVariable( "errors", $lang_script["prob.group.add.php"]["groupnameError"]);
	}
	elseif ($_POST["groupdescription"]=="")
	{
		$tpl->setVariable( "errors", $lang_script["prob.group.add.php"]["groupdescriptionError"]);
	}
	else
	{
		$probandgroups->insertProbandGroup(cleanHTML($_POST["groupname"]),cleanHTML($_POST["groupdescription"]));
		
		?>
        <script type="text/javascript">
        <!--
        window.location.href="<?php echo $cfgUrlToProject."/".$fileInsertSuccessMessage; ?>";
        -->
        </script>
        <?php
		
		exit;
	}
	
}

// get sessionUserLogin
$sessionUserLogin = $_SESSION["sessionUserLogin"];

// get sessionUserPassword
$sessionUserPassword = $_SESSION["sessionUserPassword"];

// fetch Groups
$result=$probandgroups->getProbandGroupRow($groupId);


// set title
$tpl->setVariable( "applicationtitle", $cfgApplicationType.$cfgApplicationVersion);

$tpl->setVariable( "formaction", $fileProbGroupAdd	);

$tpl->setVariable( "groupname", $result[0][GROUPS_NAME] );
$tpl->setVariable( "groupdescription", $result[0][GROUPS_DESCRIPTION] );
$tpl->setVariable( "id", $result[0][GROUPS_ID_PK] );

// parse template
$tpl->parse();

// get the parsed template and print it
$tpl->get();
$tpl->show();
?>
