<?php
// +----------------------------------------------------------------------+
// | survey pilot                                                         |
// +----------------------------------------------------------------------+
// | Copyright (c) 2002 serie a - Digitale Medien und Systeme GmbH        |
// +----------------------------------------------------------------------+
// | Authors: 	Jrn Allert <allert@serie-a.de>                           |
// |          	Rene Renk <renk@serie-a.de>                               |
// +----------------------------------------------------------------------+
//
// $Id: prob.group.assume.php,v 1.1.1.1 2004/07/15 13:29:49 opensurveypilot Exp $

// start session
@session_start();

// require all configuration files and libraries
require_once("./../config/config.inc.php"); // common config file
require_once($cfgPathToConf."/file.inc.php"); // project files
require_once($cfgPathToLib."/common.inc.php"); // common functions
require_once($cfgPathToAuthFiles."/config/auth.file.inc.php"); // auth files
require_once($cfgPathToAuthFiles."/lib/user.inc.php"); // auth user functions
require_once($cfgPathToProbFiles."/lib/prob.inc.php"); // proband functions
require_once($cfgPathToProbFiles."/config/prob.file.inc.php"); // proband files
require_once($cfgPathToProbFiles."/config/prob.config.inc.php"); // proband config
require_once("HTML/Template/IT.php"); // PEAR::HTML_TEMPLATE_IT

// create new userFunctions object
$client = &new userFunctions;

//login check
if ($client->getAuthentication($_SESSION["sessionId"], session_id()) == false)
{
    //redirect to login page
    ?>
    <script type="text/javascript">
    <!--
    window.location.href="<?php echo $cfgUrlToProject."/".$fileAuthLogin; ?>";
    -->
    </script>
    <?php
    exit;
}

// function permission check
if($_SESSION["sessionUserStatusId"] < $permRawDataDelete)
{
    ?>
    <script type="text/javascript">
    <!--
    window.location.href="<?php echo $cfgUrlToProject."/".$fileNoPermission."?messageCode=2"; ?>";
    -->
    </script>
    <?php
    exit;
}

$probands = &new Proband; 

// get sessionUserLogin
$sessionUserLogin = $_SESSION["sessionUserLogin"];

// get sessionUserPassword
$sessionUserPassword = $_SESSION["sessionUserPassword"];

// create Template IT object
$tpl = new HTML_Template_IT($cfgPathToProbTemplates);

// load template
$tpl->loadTemplatefile($templateProbGroupAssume, true, true);

// set title
$tpl->setVariable( "applicationtitle", $cfgApplicationType.$cfgApplicationVersion);

// get user id for detailview
if(isset($_GET["groupId"]))
{
    $groupId = $_GET["groupId"];
}

if($_SERVER["REQUEST_METHOD"] == "POST")
{
	$userArray=$_POST["user"];
	$groupId = $_POST["groupId"];
	$probands->getProbandGroupRow ($groupId);

	if ($probands->Group_to_Proband ($userArray, $groupId))
	{
		//$tpl->setVariable( "status", "Speichern erfolgreich.");
	}
	else
	{
		$tpl->setVariable( "status", $lang_script["prob.group.assume.php"]["statusError"]);
	}
}

// fetch Groups
$result=$probands->getProbandGroupRow($groupId);

$tpl->setVariable( "lnk_edit", $fileProbGroupEdit."?groupId=$groupId");
$tpl->setVariable( "lnk_delete", $fileProbGroupDelete."?groupId=$groupId");
$tpl->setVariable( "lnk_assume", $fileProbGroupAssume."?groupId=$groupId");
$tpl->setVariable( "lnk_members", $fileProbGroupMembers."?groupId=$groupId");

$tpl->setVariable( "formaction", $fileProbGroupAssume);
$tpl->setVariable( "groupname", $result[0][GROUPS_NAME] );
$tpl->setVariable( "groupId", $groupId);

$probanduserArray = $probands->ProbandUserOverview(0, 1000, "USERDATA_NNAME", "ASC");
$groupUserArray = $probands->get_Probands_of_Group($groupId);

for ($i=0;$i < count($probanduserArray);$i++)
{
	$tpl->setCurrentBlock("userlist") ;
	
	if (is_array($groupUserArray))
	{
		if (in_array ($probanduserArray[$i]["USERDATA_ID_PK"], $groupUserArray))
		{
			$tpl->setVariable( "user_selected", "selected" );
		}
		else
		{
			$tpl->setVariable( "user_selected", "" );
		}
	}
	$tpl->setVariable( "user_name", $probanduserArray[$i]["USERDATA_NNAME"].", ".$probanduserArray[$i]["USERDATA_VNAME"]);
	$tpl->setVariable( "user_value", $probanduserArray[$i]["USERDATA_ID_PK"]);
	$tpl->parseCurrentBlock("userlist") ;
}

// parse template
$tpl->parse();

// get the parsed template and print it
$tpl->get();
$tpl->show();   


?>
