<?php
// +----------------------------------------------------------------------+
// | survey pilot                                                         |
// +----------------------------------------------------------------------+
// | Copyright (c) 2002 serie a - Digitale Medien und Systeme GmbH        |
// +----------------------------------------------------------------------+
// | Authors: 	Daniel Peer <peer@serie-a.de>                             |
// +----------------------------------------------------------------------+
//
// $Id: prob.group.overview.php,v 1.1.1.1 2004/07/15 13:29:51 opensurveypilot Exp $

// start session
@session_start();

// require all configuration files and libraries
require_once("./../config/config.inc.php"); // common config file
require_once($cfgPathToConf."/file.inc.php"); // project files
require_once($cfgPathToLib."/common.inc.php"); // common functions
require_once($cfgPathToAuthFiles."/lib/user.inc.php"); // auth user functions
require_once($cfgPathToProbFiles."/config/prob.config.inc.php"); // proband config file
require_once($cfgPathToProbFiles."/config/prob.file.inc.php"); // proband files
require_once($cfgPathToProbFiles."/lib/prob.inc.php"); // proband Rawdata functions
require_once($cfgPathToAuthFiles."/config/auth.file.inc.php"); // auth user functions
require_once("HTML/Template/IT.php"); // PEAR::HTML_TEMPLATE_IT
 
// create new userFunctions object
$client = &new userFunctions;

//login check
if ($client->getAuthentication($_SESSION["sessionId"], session_id()) ==  false)
{
    //redirect to login page
    ?>
    <script type="text/javascript">
    <!--
    window.location.href="<?php echo $cfgUrlToProject."/".$fileAuthLogin; ?>";
    -->
    </script>
    <?php
    exit;
} 
 
$probandgroups = &new Proband; 

if($_SERVER["REQUEST_METHOD"] == "POST")
{
	$groupIdArray=$_POST["groupId"];

	for ($i=0;$i<count($groupIdArray);$i++)
	{
		if ($_POST["selectAction"]==1) //Gruppe lschen
		{
			$probandgroups->deleteProbandGroup($groupIdArray[$i]);
		}
	}
}

// create Template IT object
$tpl = new HTML_Template_IT($cfgPathToProbTemplates);

// load template
$tpl->loadTemplatefile($templateProbGroupOverview, true, true);

// set title
$tpl->setVariable( "applicationtitle", $cfgApplicationType.$cfgApplicationVersion);

$tpl->setVariable( "formaction", $fileProbGroupOverview);

// get actual num as get variable
if(isset($_GET["actualNum"]))
{
    $actualNum = $_GET["actualNum"];
}
// get orderBy as get variable
if(isset($_GET["orderBy"]))
{
    $orderBy = $_GET["orderBy"];
}
else
{
    $orderBy = "GROUPS_NAME";
}
// get direction as get variable
if(isset($_GET["direction"]))
{
    $direction = $_GET["direction"];
}

// maximum rows
$maxRow = $cfgMaxRowInOverviews;
//total rows   

$totalNum =  $probandgroups->getProbandGroupNum(); 

// actual rows
if (!isset($actualNum))
{
    $actualNum = 0;
}
// get the Number of pages
$numPages = intval($totalNum/$maxRow);
if ($numPages < ($totalNum/$maxRow))
{ 
    $numPages++;
}

// prev button
if ($actualNum > 0) 
{
    $y = $actualNum - $maxRow;
    
    $tpl->setVariable( "prev_button", "<a class=\"navigation\" href=\"$fileProbGroupOverview?actualNum=$y&orderBy=$orderBy&direction=$direction\">&laquo;</a>" );
}
// display pages
for ($i = 1; $i <= $numPages; $i++)
{
    $y = ($i * $maxRow) - $maxRow;
    
    $tpl->setCurrentBlock( "num_buttons" );
    $tpl->setVariable( "num_button", "[<a class=\"navigation\" href=\"$fileProbGroupOverview?actualNum=$y&orderBy=$orderBy&direction=$direction\">$i</a>]" );
    $tpl->parseCurrentBlock();
}
//  next button
if ($actualNum < ($totalNum - $maxRow)) 
{
    $y = $actualNum  + $maxRow;
    
    $tpl->setVariable( "next_button", "<a class=\"navigation\" href=\"$fileProbGroupOverview?actualNum=$y&orderBy=$orderBy&direction=$direction\">&raquo;</a>" );
}

if(($actualNum + $maxRow) < $totalNum)
{
    $entryTo = $actualNum + $maxRow;
}
else
{
    $entryTo = $totalNum;
    
}

// entry from
$entryFrom = $entryTo < 1 ? "0" : $actualNum +1;

$tpl->setVariable( "entry_from", $entryFrom );
$tpl->setVariable( "entry_to", $entryTo );
$tpl->setVariable( "entry_total", $totalNum );


// get questions
$probandgroupsArray = $probandgroups->getProbandGroups($actualNum, $maxRow, $orderBy, $direction);
if($probandgroups->errorMessage)
{
    echo $probandgroups->errorMessage;
}

//eine reihe

for($j=0;$j<count($probandgroupsArray);$j++)
{   
    $tpl->setCurrentBlock( "Groups_overview" );
    $tpl->setVariable( "id", $probandgroupsArray[$j]["GROUPS_ID_PK"] );
	$tpl->setVariable( "groupId", $probandgroupsArray[$j]["GROUPS_ID_PK"] );
	$tpl->setVariable( "name", $probandgroupsArray[$j]["GROUPS_NAME"]);
	
	if (strlen($probandgroupsArray[$j]["GROUPS_DESCRIPTION"])>100)
	{
		$desc = substr($probandgroupsArray[$j]["GROUPS_DESCRIPTION"], 0, 97);
		$desc .="...";
	}
	else
	{
		$desc = substr($probandgroupsArray[$j]["GROUPS_DESCRIPTION"], 0, 100);
	}

	$tpl->setVariable( "desc", $desc);
    $tpl->setVariable( "dat", $probandgroupsArray[$j]["GROUPS_GROUPTIME"] );

    $tpl->setVariable( "edit_link", $fileProbGroupEdit."?groupId=".$probandgroupsArray[$j]["GROUPS_ID_PK"] );
   
    $tpl->parseCurrentBlock();	
}

// ende eine reihe


// headline
$tpl->setCurrentBlock( "headline" );
$tpl->setVariable( "headline", $lang_script["prob.group.overview.php"]["overview"] );
$tpl->parseCurrentBlock();

// get the parsed template and print it
$tpl->get();
$tpl->show();


?>
