<?php
// +----------------------------------------------------------------------+
// | Assessment pilot                                                         |
// +----------------------------------------------------------------------+
// | Copyright (c) 2002 serie a - Digitale Medien und Systeme GmbH        |
// +----------------------------------------------------------------------+
// | Authors: 	Daniel Peer <peer@serie-a.de>                             |
// |          	                                                          |
// +----------------------------------------------------------------------+
//
// $Id: prob.mask.add.php,v 1.1.1.1 2004/07/15 13:29:51 opensurveypilot Exp $

// start session
@session_start();

// require all configuration files and libraries
require_once("./../config/config.inc.php"); // common config file
require_once($cfgPathToConf."/file.inc.php"); // project files
require_once($cfgPathToLib."/common.inc.php"); // common functions
require_once($cfgPathToProbFiles."/config/prob.config.inc.php"); // proband config file
require_once($cfgPathToProbFiles."/config/prob.file.inc.php"); // proband files
require_once($cfgPathToProbFiles."/lib/prob.inc.php"); // proband functions
require_once($cfgPathToProbFiles."/lib/dbfunctions.assess.inc.php"); // DB functions
require_once($cfgPathToProbFiles."/lib/mask.inc.php"); // mask functions
require_once($cfgPathToProbFiles."/lib/createcss.inc.php"); // css functions
require_once($cfgPathToAuthFiles."/lib/user.inc.php"); // auth user functions
require_once($cfgPathToAuthFiles."/config/auth.file.inc.php"); // auth user files
require_once($cfgPathToAuthFiles."/lib/permission.inc.php"); // permission functions
require_once("HTML/Template/IT.php"); // PEAR::HTML_TEMPLATE_IT


// create new userFunctions object
$client = &new userFunctions;

//login check
if ($client->getAuthentication($_SESSION["sessionId"], session_id()) == false)
{
    //redirect to login page
    ?>
    <script type="text/javascript">
    <!--
    window.location.href="<?php echo $cfgUrlToProject."/".$fileAuthLogin; ?>";
    -->
    </script>
    <?php
    exit;
}

// function permission check
if($_SESSION["sessionUserStatusId"] < $permRawDataDetailView)
{
    ?>
    <script type="text/javascript">
    <!--
    window.location.href="<?php echo $cfgUrlToProject."/".$fileNoPermission."?messageCode=2"; ?>";
    -->
    </script>
    <?php
    exit;
}


if($_SERVER["REQUEST_METHOD"] == "POST")
{
	$maskname = cleanHTML($_POST["maskname"]);
	if ($maskname == "") 
		$errors = $lang_script["prob.mask.add.php"]["masknameError"]."<br>";
	
	$maskdescription = cleanHTML($_POST["maskdescription"]);
	if ($maskdescription == "") 
		$errors = $lang_script["prob.mask.add.php"]["maskdescriptionError"]."<br>";

	if (!$errors)
	{
		$maskId = createUsermask ($maskname, $maskdescription);
		$surveyDb = &new surveyFunctionsDB;
		$surveyDb->createResultTab($maskId);
		
		?>
        <script type="text/javascript">
        <!--
            opener.parent.content.location.reload();
			self.close();
        -->
        </script>
        <?php
		
		exit;
	}
}

$tpl = new HTML_Template_IT($cfgPathToProbTemplates);
$tpl->loadTemplatefile($templateProbMaskAdd, true, true); // do remove untouched blocks

// set title
$tpl->setVariable( "applicationtitle", $cfgApplicationType.$cfgApplicationVersion);

if ($errors)
	$tpl->setVariable( "errors", $errors);

$tpl->setVariable( "formaction", $fileProbMaskAdd);

// parse template
$tpl->parse();

// get the parsed template and print it
$tpl->get();
$tpl->show();


?>
