<?php
// +----------------------------------------------------------------------+
// | Assessment pilot                                                         |
// +----------------------------------------------------------------------+
// | Copyright (c) 2002 serie a - Digitale Medien und Systeme GmbH        |
// +----------------------------------------------------------------------+
// | Authors: 	Daniel Peer <peer@serie-a.de>                             |
// |          	                                                          |
// +----------------------------------------------------------------------+
//
// $Id: prob.mask.detail.php,v 1.1.1.1 2004/07/15 13:29:51 opensurveypilot Exp $

// start session
@session_start();

// require all configuration files and libraries
require_once("./../config/config.inc.php"); // common config file
require_once($cfgPathToConf."/file.inc.php"); // project files
require_once($cfgPathToLib."/common.inc.php"); // common functions
require_once($cfgPathToProbFiles."/config/prob.config.inc.php"); // proband config file
require_once($cfgPathToProbFiles."/config/prob.file.inc.php"); // proband files
require_once($cfgPathToProbFiles."/lib/prob.inc.php"); // proband functions
require_once($cfgPathToProbFiles."/lib/mask.inc.php"); // mask functions
require_once($cfgPathToAuthFiles."/lib/user.inc.php"); // auth user functions
require_once($cfgPathToAuthFiles."/config/auth.file.inc.php"); // auth user files
require_once($cfgPathToAuthFiles."/lib/permission.inc.php"); // permission functions
require_once("HTML/Template/IT.php"); // PEAR::HTML_TEMPLATE_IT


// create new userFunctions object
$client = &new userFunctions;

//login check
if ($client->getAuthentication($_SESSION["sessionId"], session_id()) == false)
{
    //redirect to login page
    ?>
    <script type="text/javascript">
    <!--
    window.location.href="<?php echo $cfgUrlToProject."/".$fileAuthLogin; ?>";
    -->
    </script>
    <?php
    exit;
}

// function permission check
if($_SESSION["sessionUserStatusId"] < $permRawDataDetailView)
{
    ?>
    <script type="text/javascript">
    <!--
    window.location.href="<?php echo $cfgUrlToProject."/".$fileNoPermission."?messageCode=2"; ?>";
    -->
    </script>
    <?php
    exit;
}

$tpl = new HTML_Template_IT($cfgPathToProbTemplates);
$tpl->loadTemplatefile($templateProbMaskDetail, true, true); // do remove untouched blocks

// get user id for detailview
$maskId = $_GET["maskId"];

if($_SERVER["REQUEST_METHOD"] == "POST")
{
	$_POST["bank"] ? $bank = $_POST["bank"] : $bank = 0;
	$_POST["school"] ? $school = $_POST["school"] : $school = 0;
	$_POST["education"] ? $education = $_POST["education"] : $education = 0;
	$_POST["course"] ? $course = $_POST["course"] : $course = 0;
	
	$maskId = $_POST["maskId"];
	$maskname = $_POST["maskname"];
	$maskdescription = $_POST["maskdescription"];
	$flagArray[0] = $bank;
	$flagArray[1] = $school;
	$flagArray[2] = $education;
	$flagArray[3] = $course;
	
	$mask = getUsermask ($maskId);
	
	$ok=true;

	if ($mask[0]["USERMASK_BANK"] < $bank)
	{
		$ok=false;
	}
	if ($mask[0]["USERMASK_SCHOOL"] < $school)
	{
		$ok=false;
	}
	if ($mask[0]["USERMASK_EDUCATION"] < $education)
	{
		$ok=false;
	}
	if ($mask[0]["USERMASK_COURSE"] < $course)
	{
		$ok=false;
	}
	
	if (!$ok)
	{
		forceCompletion ($maskId);
	}
		
	if (updateUsermask ($maskId, $maskname, $maskdescription, $flagArray))
	{
		$tpl->setVariable( "message", "<span style='color:blue'>".$lang_script["prob.mask.detail.php"]["saveMessage"]."</span>");
	}
}

// set title
$tpl->setVariable( "applicationtitle", $cfgApplicationType.$cfgApplicationVersion);

$tpl->setVariable( "lnk_detail", $fileProbMaskDetail."?maskId=$maskId");
$tpl->setVariable( "lnk_question", $fileProbQuestionAdd."?maskId=$maskId");
$tpl->setVariable( "lnk_edit", $fileProbQuestionEdit."?maskId=$maskId");
$tpl->setVariable( "lnk_view", $fileProbMaskPreview."?maskId=$maskId");


$tpl->setVariable( "maskId", $maskId);
$tpl->setVariable( "formaction", $fileProbMaskDetail);

$mask = getUsermask ($maskId);

$tpl->setVariable( "maskname", $mask[0]["USERMASK_NAME"]);
$tpl->setVariable( "maskauthor", $mask[0]["USERMASK_AUTHOR"]);
$tpl->setVariable( "maskdescription", $mask[0]["USERMASK_DESCRIPTION"]);
$tpl->setVariable( "insertdate", date('d.m.Y',$mask[0]["USERMASK_TIMESTAMP"]));

if ($mask[0]["USERMASK_BANK"]==1)
{
	$tpl->setVariable( "bankselected", "checked" );
}
if ($mask[0]["USERMASK_SCHOOL"]==1)
{
	$tpl->setVariable( "schoolselected", "checked" );
}
if ($mask[0]["USERMASK_EDUCATION"]==1)
{
	$tpl->setVariable( "educationselected", "checked" );
}
if ($mask[0]["USERMASK_COURSE"]==1)
{
	$tpl->setVariable( "courseselected", "checked" );
}

// parse template
$tpl->parse();

// get the parsed template and print it
$tpl->get();
$tpl->show();
?>
