<?php
// +----------------------------------------------------------------------+
// | Assessment pilot                                                         |
// +----------------------------------------------------------------------+
// | Copyright (c) 2002 serie a - Digitale Medien und Systeme GmbH        |
// +----------------------------------------------------------------------+
// | Authors: 	Daniel Peer <peer@serie-a.de>                             |
// |          	                                                          |
// +----------------------------------------------------------------------+
//
// $Id: prob.mask.extrafields.php,v 1.1.1.1 2004/07/15 13:29:51 opensurveypilot Exp $

// start session
@session_start();

// require all configuration files and libraries
require_once("./../config/config.inc.php"); // common config file
require_once($cfgPathToConf."/file.inc.php"); // project files
require_once($cfgPathToLib."/common.inc.php"); // common functions
require_once($cfgPathToProbFiles."/config/prob.config.inc.php"); // proband config file
require_once($cfgPathToProbFiles."/config/prob.file.inc.php"); // proband files
require_once($cfgPathToProbFiles."/lib/prob.inc.php"); // proband functions
require_once($cfgPathToProbFiles."/lib/mask.inc.php"); // mask functions
require_once($cfgPathToAuthFiles."/lib/user.inc.php"); // auth user functions
require_once($cfgPathToAuthFiles."/config/auth.file.inc.php"); // auth user files
require_once($cfgPathToAuthFiles."/lib/permission.inc.php"); // permission functions
require_once("HTML/Template/IT.php"); // PEAR::HTML_TEMPLATE_IT


// create new userFunctions object
$client = &new userFunctions;

//login check
if ($client->getAuthentication($_SESSION["sessionId"], session_id()) == false)
{
    //redirect to login page
    ?>
    <script type="text/javascript">
    <!--
    window.location.href="<?php echo $cfgUrlToProject."/".$fileAuthLogin; ?>";
    -->
    </script>
    <?php
    exit;
}

// function permission check
if($_SESSION["sessionUserStatusId"] < $permRawDataDetailView)
{
    ?>
    <script type="text/javascript">
    <!--
    window.location.href="<?php echo $cfgUrlToProject."/".$fileNoPermission."?messageCode=2"; ?>";
    -->
    </script>
    <?php
    exit;
}

?>
<script language="JavaScript" src="./../lib/javascript/common.js"></script>
<?php

// instanciate probands object
$probands = &new Proband; 

// get user id for detailview
$maskId = $_GET["maskId"];

if($_SERVER["REQUEST_METHOD"] == "POST")
{
	$maskId = $_POST["maskId"];
	
	$nameArray[0] = $_POST["1"];
	$nameArray[1] = $_POST["2"];
	$nameArray[2] = $_POST["3"];
	$nameArray[3] = $_POST["4"];
	$nameArray[4] = $_POST["5"];
	$nameArray[5] = $_POST["6"];
	$nameArray[6] = $_POST["7"];
	$nameArray[7] = $_POST["8"];
	$nameArray[8] = $_POST["9"];
	$nameArray[9] = $_POST["10"];
	
	$validArray[0] = $_POST["validation1"];
	$validArray[1] = $_POST["validation2"];
	$validArray[2] = $_POST["validation3"];
	$validArray[3] = $_POST["validation4"];
	$validArray[4] = $_POST["validation5"];
	$validArray[5] = $_POST["validation6"];
	$validArray[6] = $_POST["validation7"];
	$validArray[7] = $_POST["validation8"];
	$validArray[8] = $_POST["validation9"];
	$validArray[9] = $_POST["validation10"];

	updateExtraNames ($nameArray,$validArray,$maskId);
}

$validationArray = array(
					array ("no", $lang_script["prob.mask.extrafields.php"]["noArray"]),
					array ("num", $lang_script["prob.mask.extrafields.php"]["numArray"]),
					array ("alpha", $lang_script["prob.mask.extrafields.php"]["alphaArray"]),
					array ("url", $lang_script["prob.mask.extrafields.php"]["urlArray"]),
					array ("email", $lang_script["prob.mask.extrafields.php"]["emailArray"]),
					array ("date", $lang_script["prob.mask.extrafields.php"]["dateArray"])
					);
					
$nameArray = getExtraNames ($maskId);

$dbValidArray = getExtraNamesValidations ($maskId);

$tpl = new HTML_Template_IT($cfgPathToProbTemplates);
$tpl->loadTemplatefile($templateProbMaskExtrafields, true, true); // do remove untouched blocks

// set title
$tpl->setVariable( "applicationtitle", $cfgApplicationType.$cfgApplicationVersion);

$tpl->setVariable( "v1", $nameArray[0]);
$tpl->setVariable( "v2", $nameArray[1]);
$tpl->setVariable( "v3", $nameArray[2]);
$tpl->setVariable( "v4", $nameArray[3]);
$tpl->setVariable( "v5", $nameArray[4]);
$tpl->setVariable( "v6", $nameArray[5]);
$tpl->setVariable( "v7", $nameArray[6]);
$tpl->setVariable( "v8", $nameArray[7]);
$tpl->setVariable( "v9", $nameArray[8]);
$tpl->setVariable( "v10", $nameArray[9]);

for ($a=1;$a<=10;$a++)
{
	for ($i=0;$i<count($validationArray);$i++)
	{
		$tpl->setCurrentBlock("validation".$a) ;
		
		if ($validationArray[$i][0]==$dbValidArray[$a-1])
			$tpl->setVariable( "validationSelected".$a, " checked" );
		else
			$tpl->setVariable( "validationSelected".$a, "");
			
		$tpl->setVariable( "validationValue".$a, $validationArray[$i][0]);
		$tpl->setVariable( "validationCaption".$a, $validationArray[$i][1]);
		$tpl->parseCurrentBlock() ;
	}
}

$tpl->setVariable( "lnk_detail", $fileProbMaskDetail."?maskId=$maskId");
$tpl->setVariable( "lnk_extra", $fileProbMaskExtrafields."?maskId=$maskId");
$tpl->setVariable( "lnk_mandatory", $fileProbMaskMandatory."?maskId=$maskId");

$tpl->setVariable( "maskId", $maskId);
$tpl->setVariable( "formaction", $fileProbMaskExtrafields);


// parse template
$tpl->parse();

// get the parsed template and print it
$tpl->get();
$tpl->show();
?>
