<script language="JavaScript" src="./../lib/javascript/common.js"></script>
<?php
// +----------------------------------------------------------------------+
// | survey pilot                                                         |
// +----------------------------------------------------------------------+
// | Copyright (c) 2002 serie a - Digitale Medien und Systeme GmbH        |
// +----------------------------------------------------------------------+
// | Authors: 	Daniel Peer <peer@serie-a.de>                             |
// +----------------------------------------------------------------------+
//
// $Id: prob.overview.php,v 1.1.1.1 2004/07/15 13:29:52 opensurveypilot Exp $

// start session
@session_start();

// require all configuration files and libraries
require_once("./../config/config.inc.php"); // common config file
require_once($cfgPathToConf."/file.inc.php"); // project files
require_once($cfgPathToLib."/common.inc.php"); // common functions
require_once($cfgPathToAuthFiles."/lib/user.inc.php"); // auth user functions
require_once($cfgPathToProbFiles."/config/prob.config.inc.php"); // proband config file
require_once($cfgPathToProbFiles."/config/prob.file.inc.php"); // proband files
require_once($cfgPathToProbFiles."/lib/prob.inc.php"); // proband functions
require_once($cfgPathToAuthFiles."/config/auth.file.inc.php"); // auth user functions
require_once("HTML/Template/IT.php"); // PEAR::HTML_TEMPLATE_IT
 
// create new userFunctions object
$client = &new userFunctions;

//login check
if ($client->getAuthentication($_SESSION["sessionId"], session_id()) ==  false)
{
    //redirect to login page
    ?>
    <script type="text/javascript">
    <!--
    window.location.href="<?php echo $cfgUrlToProject."/".$fileAuthLogin; ?>";
    -->
    </script>
    <?php
    exit;
} 

$_GET["raw"] ? $raw=$_GET["raw"] : $raw=0;

$probanduser = &new Proband; 


if ($raw)
{
	$section = $lang_script["prob.overview.php"]["rawdata"];
}
else
{
	$section = $lang_script["prob.overview.php"]["paneluser"];
}


if($_SERVER["REQUEST_METHOD"] == "POST")
{
	$userIdArray=$_POST["userId"];
	
	for ($i=0;$i<count($userIdArray);$i++)
	{
		if ($_POST["selectAction"]==1) //user lschen
		{
			$probanduser->deleteProbandUser($userIdArray[$i]);
		}
		
		if ($_POST["selectAction"]==2) //user einer Gruppe zuordnen
		{
			$openwindow=true;			
		}
	}
	
	if ($openwindow)
	{
		session_register("userIdArray");		
		?>
	    <script type="text/javascript">
	    <!--
	    openWindow(500,500,'<?=$fileProbOverviewAssume?>','_new');
	    -->
	    </script>
	    <?php
	}
}

// create Template IT object
$tpl = new HTML_Template_IT($cfgPathToProbTemplates);

// load template
$tpl->loadTemplatefile($templateProbOverview, true, true);

// set title
$tpl->setVariable( "applicationtitle", $cfgApplicationType.$cfgApplicationVersion);

$tpl->setVariable( "section", $section);

if ($raw)
{
	$tpl->setVariable( "formaction", $fileProbOverview."?raw=1");
}
else
{
	$tpl->setVariable( "formaction", $fileProbOverview);
}


// get actual num as get variable
if(isset($_GET["actualNum"]))
{
    $actualNum = $_GET["actualNum"];
}
// get orderBy as get variable
if(isset($_GET["orderBy"]))
{
    $orderBy = $_GET["orderBy"];
}
else
{
    $orderBy = "USERDATA_NNAME";
}
// get direction as get variable
if(isset($_GET["direction"]))
{
    $direction = $_GET["direction"];
}

// maximum rows
$maxRow = $cfgMaxRowInOverviews;
//total rows   

$totalNum =  $probanduser->getProbandUserNum($raw); 

// actual rows
if (!isset($actualNum))
{
    $actualNum = 0;
}
// get the Number of pages
$numPages = intval($totalNum/$maxRow);
if ($numPages < ($totalNum/$maxRow))
{ 
    $numPages++;
}

// prev button
if ($actualNum > 0) 
{
    $y = $actualNum - $maxRow;
    
    $tpl->setVariable( "prev_button", "<a class=\"navigation\" href=\"$fileProbOverview?actualNum=$y&orderBy=$orderBy&direction=$direction\">&laquo;</a>" );
}
// display pages
for ($i = 1; $i <= $numPages; $i++)
{
    $y = ($i * $maxRow) - $maxRow;
    
    $tpl->setCurrentBlock( "num_buttons" );
    $tpl->setVariable( "num_button", "[<a class=\"navigation\" href=\"$fileProbOverview?actualNum=$y&orderBy=$orderBy&direction=$direction\">$i</a>]" );
    $tpl->parseCurrentBlock();
}
//  next button
if ($actualNum < ($totalNum - $maxRow)) 
{
    $y = $actualNum  + $maxRow;
    
    $tpl->setVariable( "next_button", "<a class=\"navigation\" href=\"$fileProbOverview?actualNum=$y&orderBy=$orderBy&direction=$direction\">&raquo;</a>" );
}

if(($actualNum + $maxRow) < $totalNum)
{
    $entryTo = $actualNum + $maxRow;
}
else
{
    $entryTo = $totalNum;
    
}

// entry from
$entryFrom = $entryTo < 1 ? "0" : $actualNum +1;

$tpl->setVariable( "entry_from", $entryFrom );
$tpl->setVariable( "entry_to", $entryTo );
$tpl->setVariable( "entry_total", $totalNum );


// get questions
$probanduserArray = $probanduser->ProbandUserOverview($actualNum, $maxRow, $orderBy, $direction, $raw);

if($probanduser->errorMessage)
{
    echo $probanduser->errorMessage;
}

//eine reihe

for($j=0;$j<count($probanduserArray);$j++)
{   
    $tpl->setCurrentBlock( "User_overview" );
    $tpl->setVariable( "id", $probanduserArray[$j]["USERDATA_ID_PK"] );
	$tpl->setVariable( "userId", $probanduserArray[$j]["USERDATA_ID_PK"] );
	$tpl->setVariable( "name", $probanduserArray[$j]["USERDATA_NNAME"].", ".$probanduserArray[$j]["USERDATA_VNAME"]);
	$tpl->setVariable( "gebdat", $probanduserArray[$j]["USERDATA_AGE"] );
	$tpl->setVariable( "ort", $probanduserArray[$j]["USERDATA_CITY"] );
	$tpl->setVariable( "abschluss", $probanduserArray[$j]["USERDATA_DEGREE"] );

    $tpl->setVariable( "edit_link", $fileProbEdit."?userId=".$probanduserArray[$j]["USERDATA_ID_PK"] );
   
    $tpl->parseCurrentBlock();	
}

// ende eine reihe

// orderby butons
if ($raw)
{
	$tpl->setVariable( "order_link_name_up", "$fileProbOverview?raw=1&actualNum=$actualNum&orderBy=USERDATA_NNAME&direction=ASC" );
	$tpl->setVariable( "order_link_name_down", "$fileProbOverview?raw=1&actualNum=$actualNum&orderBy=USERDATA_NNAME&direction=DESC" );
	$tpl->setVariable( "order_link_age_up", "$fileProbOverview?raw=1&actualNum=$actualNum&orderBy=USERDATA_AGE&direction=ASC" );
	$tpl->setVariable( "order_link_age_down", "$fileProbOverview?raw=1&actualNum=$actualNum&orderBy=USERDATA_AGE&direction=DESC" );
	$tpl->setVariable( "order_link_city_up", "$fileProbOverview?raw=1&actualNum=$actualNum&orderBy=USERDATA_CITY&direction=ASC" );
	$tpl->setVariable( "order_link_city_down", "$fileProbOverview?raw=1&actualNum=$actualNum&orderBy=USERDATA_CITY&direction=DESC" );
	$tpl->setVariable( "order_link_degree_up", "$fileProbOverview?raw=1&actualNum=$actualNum&orderBy=USERDATA_DEGREE&direction=ASC" );
	$tpl->setVariable( "order_link_degree_down", "$fileProbOverview?raw=1&actualNum=$actualNum&orderBy=USERDATA_DEGREE&direction=DESC" );
}
else
{
	$tpl->setVariable( "order_link_name_up", "$fileProbOverview?actualNum=$actualNum&orderBy=USERDATA_NNAME&direction=ASC" );
	$tpl->setVariable( "order_link_name_down", "$fileProbOverview?actualNum=$actualNum&orderBy=USERDATA_NNAME&direction=DESC" );
	$tpl->setVariable( "order_link_age_up", "$fileProbOverview?actualNum=$actualNum&orderBy=USERDATA_AGE&direction=ASC" );
	$tpl->setVariable( "order_link_age_down", "$fileProbOverview?actualNum=$actualNum&orderBy=USERDATA_AGE&direction=DESC" );
	$tpl->setVariable( "order_link_city_up", "$fileProbOverview?actualNum=$actualNum&orderBy=USERDATA_CITY&direction=ASC" );
	$tpl->setVariable( "order_link_city_down", "$fileProbOverview?actualNum=$actualNum&orderBy=USERDATA_CITY&direction=DESC" );
	$tpl->setVariable( "order_link_degree_up", "$fileProbOverview?actualNum=$actualNum&orderBy=USERDATA_DEGREE&direction=ASC" );
	$tpl->setVariable( "order_link_degree_down", "$fileProbOverview?actualNum=$actualNum&orderBy=USERDATA_DEGREE&direction=DESC" );
}

// headline
$tpl->setCurrentBlock( "headline" );
$tpl->setVariable( "headline", $lang_script["prob.overview.php"]["overview"] );
$tpl->parseCurrentBlock();

// get the parsed template and print it
$tpl->get();
$tpl->show();


?>
