<?php
// +----------------------------------------------------------------------+
// | survey pilot                                                         |
// +----------------------------------------------------------------------+
// | Copyright (c) 2002 serie a - Digitale Medien und Systeme GmbH        |
// +----------------------------------------------------------------------+
// | Authors: 	Jrn Allert <allert@serie-a.de>                           |
// |          	Rene Renk   <renk@serie-a.de>                             |
// +----------------------------------------------------------------------+
//
// $Id: prob.question.add.php,v 1.1.1.1 2004/07/15 13:29:53 opensurveypilot Exp $

require_once("./lib/prob.question.inc.php"); // survey question create functions

// start session
@session_start();

// delete unfinished questuions in session
unset($_SESSION["newQuestion"]);

// require all configuration files and libraries
require_once("./../config/config.inc.php"); // common config file
require_once($cfgPathToConf."/file.inc.php"); // project files
require_once($cfgPathToLib."/common.inc.php"); // common functions
require_once($cfgPathToProbFiles."/lib/mask.inc.php"); // mask functions
require_once($cfgPathToProbFiles."/config/prob.config.inc.php"); // survey files
require_once($cfgPathToProbFiles."/config/prob.file.inc.php"); // survey files
require_once($cfgPathToAuthFiles."/lib/user.inc.php"); // auth user functions
require_once($cfgPathToAuthFiles."/config/auth.file.inc.php"); // auth user functions
require_once($cfgPathToAuthFiles."/lib/permission.inc.php"); // auth permission functions
require_once("HTML/Template/IT.php"); // PEAR::HTML_TEMPLATE_IT
 
// create new userFunctions object
$client = &new userFunctions;

//login check
if ($client->getAuthentication($_SESSION["sessionId"], session_id()) ==  false)
{
    //redirect to login page
    ?>
    <script type="text/javascript">
    <!--
    window.location.href="<?php echo $cfgUrlToProject."/".$fileAuthLogin; ?>";
    -->
    </script>
    <?php
    exit;
}

// function permission check
if($_SESSION["sessionUserStatusId"] < $permSurveyQuestionAdd)
{
    ?>
    <script type="text/javascript">
    <!--
    window.location.href="<?php echo $cfgUrlToProject."/".$fileNoPermission."?messageCode=2"; ?>";
    -->
    </script>
    <?php
    exit;
}

// get projectId
$maskId = $_GET["maskId"];
$formId = MaskToFormID ($maskId);

// create new permissionFunctions object
$permission = &new permissionFunctions;
// get Permission
$permissionMode = $permission->getPermissionMode($_SESSION["sessionUserId"], $projectId, 1);
if($permission->errorMessage)
{
    echo $permission->errorMessage;
}
// permission must be 2 (write)
if($permissionMode < 2)
{
    ?>
    <script type="text/javascript">
    <!--
    window.location.href="<?php echo $cfgUrlToProject."/".$fileNoPermission."?messageCode=1"; ?>";
    -->
    </script>
    <?php
    exit;
}

$myQuestion = new Question($maskId);
$_SESSION["newQuestion"] = $myQuestion;

$tpl = new HTML_Template_IT($cfgPathToProbTemplates);
$tpl->loadTemplatefile($templateProbQuestionAdd, true, false); // dont remove untouched blocks

// set title
$tpl->setVariable("applicationtitle", $cfgApplicationType.$cfgApplicationVersion);

$tpl->setVariable( "lnk_detail", $fileProbMaskDetail."?maskId=$maskId");
$tpl->setVariable( "lnk_question", $fileProbQuestionAdd."?maskId=$maskId");
$tpl->setVariable( "lnk_edit", $fileProbQuestionEdit."?maskId=$maskId");
$tpl->setVariable( "lnk_view", $fileProbMaskPreview."?maskId=$maskId");

$tpl->setVariable( "formaction", $maskId);

$tpl->setVariable("question", $_POST["question"]);
$tpl->setVariable("errors", $_GET["errors"]);
$tpl->setVariable("groupId", $formId);
$tpl->parse();
$tpl->show();
?>