<?php
// +----------------------------------------------------------------------+
// | survey pilot                                                         |
// +----------------------------------------------------------------------+
// | Copyright (c) 2002 serie a - Digitale Medien und Systeme GmbH        |
// +----------------------------------------------------------------------+
// | Authors: 	Jrn Allert <allert@serie-a.de>                           |
// |          	Rene Renk   <renk@serie-a.de>                             |
// +----------------------------------------------------------------------+
//
// $Id: prob.question.add.textarea.php,v 1.1.1.1 2004/07/15 13:29:58 opensurveypilot Exp $

require_once("./lib/prob.question.inc.php"); // survey question create functions

// start session
@session_start();

// require all configuration files and libraries
require_once("./../config/config.inc.php"); // common config file
require_once($cfgPathToConf."/file.inc.php"); // project files
require_once($cfgPathToLib."/common.inc.php"); // common functions
require_once($cfgPathToProbFiles."/config/prob.config.inc.php"); // survey files
require_once($cfgPathToProbFiles."/config/prob.file.inc.php"); // survey files
require_once($cfgPathToAuthFiles."/lib/user.inc.php"); // auth user functions
require_once($cfgPathToProbFiles."/lib/mask.inc.php"); // survey files
require_once($cfgPathToAuthFiles."/config/auth.file.inc.php"); // auth user functions
require_once($cfgPathToAuthFiles."/lib/permission.inc.php"); // auth permission functions
require_once("HTML/Template/IT.php"); // PEAR::HTML_TEMPLATE_IT

// create new userFunctions object
$client = &new userFunctions;

//login check
if ($client->getAuthentication($_SESSION["sessionId"], session_id()) ==  false)
{
    //redirect to login page
    ?>
    <script type="text/javascript">
    <!--
    window.location.href="<?php echo $cfgUrlToProject."/".$fileAuthLogin; ?>";
    -->
    </script>
    <?php
    exit;
}  

// function permission check
if($_SESSION["sessionUserStatusId"] < $permSurveyQuestionEditText)
{
    ?>
    <script type="text/javascript">
    <!--
    window.location.href="<?php echo $cfgUrlToProject."/".$fileNoPermission."?messageCode=2"; ?>";
    -->
    </script>
    <?php
    exit;
}

// get projectId
$maskId = (isset($_GET["maskId"])) ? $_GET["maskId"] : $_SESSION["newQuestion"]->maskId;
$groupId = (isset($_POST["groupId"])) ? $_POST["groupId"] : $_SESSION["newQuestion"]->groupId;

// create new permissionFunctions object
$permission = &new permissionFunctions;
// get Permission
$permissionMode = $permission->getPermissionMode($_SESSION["sessionUserId"], $projectId, 1);
if($permission->errorMessage)
{
    echo $permission->errorMessage;
}
// permission must be 2 (write)
if($permissionMode < 2)
{
    ?>
    <script type="text/javascript">
    <!--
    window.location.href="<?php echo $cfgUrlToProject."/".$fileNoPermission."?messageCode=1"; ?>";
    -->
    </script>
    <?php
    exit;
}

	$debug=0;
if ($debug==1)
{
echo $maskId ;
echo "Session:<br>--------------------------<br>";
print_r($_SESSION["newQuestion"]);
echo "<br>";
echo "Post:<br>--------------------------<br>";
print_r($_POST);
echo "<br>";
echo "Get:<br>--------------------------<br>";
print_r($_GET);
echo "<br>";
}

if($_SERVER["REQUEST_METHOD"] == "POST")
{
	// set step
	$step = $_POST["step"];
	
	// save question, type // get rules
	//
	if($step == 2)
	{
		// save values to question object
	    $myQuestion = $_SESSION["newQuestion"];
		$myQuestion->setType($_POST["type"]);
		$myQuestion->setSize(0);
		$myQuestion->setQuestion($_POST["question"]);
		$myQuestion->setGroupId($groupId);
		($_POST["imageuse"]) ? $myQuestion->setQuestionImage(trim($_POST["imagename"])) : $myQuestion->setQuestionImage("");
		$_SESSION["newQuestion"] = $myQuestion;
		
		// invalid back to step 1
		if(!$myQuestion->isValid(2))
		{
			$tpl = new HTML_Template_IT($cfgPathToProbTemplates);
			$tpl->loadTemplatefile($templateProbQuestionAdd, true, false); // dont remove untouched blocks
			$tpl->setVariable("applicationtitle", $cfgApplicationType.$cfgApplicationVersion);
			$tpl->setVariable("formaction", $fileProbQuestionAddTextarea."?maskId=$maskId" );
			$tpl->setVariable( "lnk_detail", $fileProbMaskDetail."?maskId=$maskId");
			$tpl->setVariable( "lnk_question", $fileProbQuestionAdd."?maskId=$maskId");
			$tpl->setVariable( "lnk_edit", $fileProbQuestionEdit."?maskId=$maskId");
			$tpl->setVariable( "lnk_view", $fileProbMaskPreview."?maskId=$maskId");

			$tpl->setVariable("errors", $myQuestion->errorMessage);
			
			$tpl->setVariable("question", $myQuestion->question);
			$tpl->setVariable("textSelected", " selected" );
			$tpl->setVariable("groupId", $myQuestion->groupId);
			$tpl->setVariable("current", $step);
			$tpl->parse();
			$tpl->show();
			exit;
		}
		
		// display form
		$tpl = new HTML_Template_IT($cfgPathToProbTemplates);
		$tpl->loadTemplatefile($templateProbQuestionAddText, true, false); // dont remove untouched blocks
		$tpl->touchBlock("Header");
		$tpl->setVariable("applicationtitle", $cfgApplicationType.$cfgApplicationVersion);
		$tpl->setVariable("formaction", $fileProbQuestionAddTextarea."?maskId=$maskId" );
			$tpl->setVariable( "lnk_detail", $fileProbMaskDetail."?maskId=$maskId");
			$tpl->setVariable( "lnk_question", $fileProbQuestionAdd."?maskId=$maskId");
			$tpl->setVariable( "lnk_edit", $fileProbQuestionEdit."?maskId=$maskId");
			$tpl->setVariable( "lnk_view", $fileProbMaskPreview."?maskId=$maskId");

			
		
		$tpl->setVariable("required", ($myQuestion->questionRules["required"]) ? " checked" : "");
		if (isset($myQuestion->questionRules) && ($myQuestion->questionRules["required"] == ''))
		{
			$myQuestion->questionRules["required"] = $myQuestion->questionDefaultRules[$_SESSION["sessionUserLanguageType"]]["required"];
		}
		$tpl->setVariable("requiredError", ($myQuestion->questionRules["required"]) ? $myQuestion->questionRules['required'] : $myQuestion->questionDefaultRules[$_SESSION["sessionUserLanguageType"]]['required']);
		$tpl->setVariable("numeric", ($myQuestion->questionRules["numeric"]) ? " checked" : "");
		if (isset($myQuestion->questionRules) && ($myQuestion->questionRules["numeric"] == ''))
		{
			$myQuestion->questionRules["numeric"] = $myQuestion->questionDefaultRules[$_SESSION["sessionUserLanguageType"]]["numeric"];
		}
		$tpl->setVariable("numericError", ($myQuestion->questionRules["numeric"]) ? $myQuestion->questionRules['numeric'] : $myQuestion->questionDefaultRules[$_SESSION["sessionUserLanguageType"]]['numeric']);
		$tpl->setVariable("groupId", $myQuestion->groupId);
		$tpl->setVariable("current", 2);
		$tpl->setVariable("step", 3);
		$tpl->parse();
		$tpl->show();
	}
	// save rules // show summary
	//
	elseif ($step == 3)
	{
		// save values to question object
    	$myQuestion = $_SESSION["newQuestion"];
		($_POST["required"])? $myQuestion->setQuestionRules('required', $_POST["requirederror"]) : $myQuestion->setQuestionRules('required', '##tobedeleted##');
		($_POST["numeric"])? $myQuestion->setQuestionRules('numeric', $_POST["numericerror"]) : $myQuestion->setQuestionRules('numeric', '##tobedeleted##');
	    $_SESSION["newQuestion"] = $myQuestion;
		  
		// fill in summary template
		$tpl = new HTML_Template_IT($cfgPathToProbTemplates);
		$tpl->loadTemplatefile($templateProbQuestionAddDetailview, true, true); // do remove untouched blocks
		$tpl->setVariable("applicationtitle", $cfgApplicationType.$cfgApplicationVersion);
		$tpl->setVariable("formaction", $fileProbQuestionAddTextarea."?maskId=$maskId" );
			$tpl->setVariable( "lnk_detail", $fileProbMaskDetail."?maskId=$maskId");
			$tpl->setVariable( "lnk_question", $fileProbQuestionAdd."?maskId=$maskId");
			$tpl->setVariable( "lnk_edit", $fileProbQuestionEdit."?maskId=$maskId");
			$tpl->setVariable( "lnk_view", $fileProbMaskPreview."?maskId=$maskId");

		
		$tpl->setVariable( "questiontype" , $myQuestion->type );
		$tpl->setVariable( "question" , $myQuestion->question );
		
		// display according to types
		if (($myQuestion->type == "textarea") || ($myQuestion->type == "text") || ($myQuestion->type == "switchtext"))
		{
			;// do nothing
		}
		elseif (($myQuestion->type != "texttable") && ($myQuestion->type != "radiotable") && ($myQuestion->type != "checkboxtable"))
		{
			$tpl->setCurrentBlock("nomatrixheader");
			
			$tpl->setVariable( "optionname" , $lang_script["prob.question.add.textarea.php"]["optionname"] );
			$tpl->setVariable( "valuename" , $lang_script["prob.question.add.textarea.php"]["valuename"] );
			$tpl->setVariable( "switchname" , $lang_script["prob.question.add.textarea.php"]["switchname"] );
			
			$tpl->parseCurrentBlock();
			
			// option data
			$optNumber = count($myQuestion->optionHeader);
			for ($i=0;$i<$optNumber;++$i)
			{
				$tpl->setCurrentBlock("nomatrixvalues");
				
				$tpl->setVariable( "option" , $myQuestion->optionHeader[$i] );
				$tpl->setVariable( "value" , $myQuestion->optionMultipleValue[$i] );
				$tpl->setVariable( "switch" , $myQuestion->toSwitchGroupName[$i] );
				
				$tpl->parseCurrentBlock();
			}
		}
		else
		{
			$tpl->setCurrentBlock("matrixheader");
			
			$tpl->setVariable( "matrixcolumnname" , $lang_script["prob.question.add.textarea.php"]["matrixcolumnname"] );
			$tpl->setVariable( "matrixrowname" , $lang_script["prob.question.add.textarea.php"]["matrixrowname"] );
			$tpl->setVariable( "matrixvaluename" , $lang_script["prob.question.add.textarea.php"]["matrixvaluename"] );
			$tpl->setVariable( "matrixswitchname" , $lang_script["prob.question.add.textarea.php"]["matrixswitchname"] );
				
			$tpl->parseCurrentBlock();
			
			// option data
			$optNumber = count($myQuestion->optionHeader);
			for ($i=0;$i<$optNumber;++$i)
			{
				$tpl->setCurrentBlock("matrixvalues");
				
				$tpl->setVariable( "matrixcolumn" , $myQuestion->optionHeader[$i] );
				$tpl->setVariable( "matrixrow" , $myQuestion->optionAddHeader[$i] );
				$tpl->setVariable( "matrixvalues" , $myQuestion->optionMultipleValue[$i] );
				$tpl->setVariable( "matrixswitch" , $myQuestion->toSwitchGroupName[$i] );
				
				$tpl->parseCurrentBlock();
			}
		}
		// required
		if ($myQuestion->questionRules["required"] && $myQuestion->questionRules["required"] != '##tobedeleted##')
		{
			$tpl->setCurrentBlock("required");
			
			$tpl->setVariable( "required" , $lang_script["prob.question.add.textarea.php"]["yes"] );
			
			$tpl->parseCurrentBlock();
		}
		// numeric
		if ($myQuestion->questionRules["numeric"] && $myQuestion->questionRules["numeric"] != '##tobedeleted##')
		{
			$tpl->setCurrentBlock("numeric");
			
			$tpl->setVariable( "numeric" , $lang_script["prob.question.add.textarea.php"]["yes"] );
			
			$tpl->parseCurrentBlock();
		}
		// insert submit button
		$tpl->touchBlock("submit");
		
		// set value for step
		$tpl->setVariable( "step" , "4" );
		
		$tpl->parse();
		$tpl->get();
		$tpl->show();
		exit;
	}
	elseif($step == 4)
	{
	    $myQuestion = $_SESSION["newQuestion"];
	    $myQuestion->saveToDB();
		forceCompletion ($maskId);
	    ?>
	    <html><body>
	    <script type="text/javascript">
	    <!--
	     window.location.href="<?php echo $fileProbQuestionAddTextarea."?maskId=$maskId&step=8"?>";
	    -->
	    </script>
	    <?php
	    exit;
	}
}
elseif($_GET["step"] == 8)
{ //
$tpl = new HTML_Template_IT($cfgPathToProbTemplates);
	$tpl->loadTemplatefile($templateProbQuestionAddSwitch, true, false); // dont remove untouched blocks
	$tpl->setVariable("applicationtitle", $cfgApplicationType.$cfgApplicationVersion);
	$tpl->setVariable("yes_link", $fileProbQuestionAdd."?maskId=$maskId" );
	$tpl->setVariable("no_link",$fileProbQuestionEdit."?maskId=$maskId" );
	$tpl->setVariable( "lnk_detail", $fileProbMaskDetail."?maskId=$maskId");
	$tpl->setVariable( "lnk_question", $fileProbQuestionAdd."?maskId=$maskId");
	$tpl->setVariable( "lnk_edit", $fileProbQuestionEdit."?maskId=$maskId");
$tpl->setVariable( "lnk_view", $fileProbMaskPreview."?maskId=$maskId");

	$tpl->setVariable("errors", $myQuestion->errorMessage);

	$tpl->setVariable("groupId", $myQuestion->groupId);
	$tpl->parse();
	$tpl->show();
	exit;
}
?>
