<?php
// +----------------------------------------------------------------------+
// | survey pilot                                                         |
// +----------------------------------------------------------------------+
// | Copyright (c) 2002 serie a - Digitale Medien und Systeme GmbH        |
// +----------------------------------------------------------------------+
// | Authors: 	Jrn Allert <allert@serie-a.de>                           |
// |          	Rene Renk   <renk@serie-a.de>                             |
// +----------------------------------------------------------------------+
//
// $Id: prob.question.edit.php,v 1.1.1.1 2004/07/15 13:29:58 opensurveypilot Exp $

require_once("./lib/prob.question.inc.php"); // survey question create functions

// start session
@session_start();

// delete unfinished questuions in session
unset($_SESSION["newQuestion"]);

// require all configuration files and libraries
require_once("./../config/config.inc.php"); // common config file
require_once($cfgPathToConf."/file.inc.php"); // project files
require_once($cfgPathToLib."/common.inc.php"); // common functions
require_once($cfgPathToProbFiles."/lib/mask.inc.php"); // mask functions
require_once($cfgPathToProbFiles."/config/prob.config.inc.php"); // survey files
require_once($cfgPathToProbFiles."/config/prob.file.inc.php"); // survey files
require_once($cfgPathToAuthFiles."/lib/user.inc.php"); // auth user functions
require_once($cfgPathToAuthFiles."/config/auth.file.inc.php"); // auth user functions
require_once($cfgPathToAuthFiles."/lib/permission.inc.php"); // auth permission functions
require_once("HTML/Template/IT.php"); // PEAR::HTML_TEMPLATE_IT
 
// create new userFunctions object
$client = &new userFunctions;

//login check
if ($client->getAuthentication($_SESSION["sessionId"], session_id()) ==  false)
{
    //redirect to login page
    ?>
    <script type="text/javascript">
    <!--
    window.location.href="<?php echo $cfgUrlToProject."/".$fileAuthLogin; ?>";
    -->
    </script>
    <?php
    exit;
}

// function permission check
if($_SESSION["sessionUserStatusId"] < $permSurveyQuestionAdd)
{
    ?>
    <script type="text/javascript">
    <!--
    window.location.href="<?php echo $cfgUrlToProject."/".$fileNoPermission."?messageCode=2"; ?>";
    -->
    </script>
    <?php
    exit;
}

// get projectId
$maskId = $_GET["maskId"];
$formId = MaskToFormID ($maskId);

if($_SERVER["REQUEST_METHOD"] == "POST")
{
	// create new groupFunctions object

	$questionIdArray=$_POST["questionId"];
	
	for ($i=0;$i<count($questionIdArray);$i++)
	{
		if ($_POST["selectAction"]==1) //user lschen
		{
			//echo $questionIdArray[$i]."<br>";
			deleteFormtype ($questionIdArray[$i]);
		}
	}
}


// create new permissionFunctions object
$permission = &new permissionFunctions;
// get Permission
$permissionMode = $permission->getPermissionMode($_SESSION["sessionUserId"], $projectId, 1);
if($permission->errorMessage)
{
    echo $permission->errorMessage;
}
// permission must be 2 (write)
if($permissionMode < 2)
{
    ?>
    <script type="text/javascript">
    <!--
    window.location.href="<?php echo $cfgUrlToProject."/".$fileNoPermission."?messageCode=1"; ?>";
    -->
    </script>
    <?php
    exit;
}

$tpl = new HTML_Template_IT($cfgPathToProbTemplates);
$tpl->loadTemplatefile($templateProbQuestionEdit, true, true); // dont remove untouched blocks

// set title
$tpl->setVariable("applicationtitle", $cfgApplicationType.$cfgApplicationVersion);
$tpl->setVariable( "formaction", $fileProbQuestionEdit."?maskId=$maskId");

$tpl->setVariable( "lnk_detail", $fileProbMaskDetail."?maskId=$maskId");
$tpl->setVariable( "lnk_question", $fileProbQuestionAdd."?maskId=$maskId");
$tpl->setVariable( "lnk_edit", $fileProbQuestionEdit."?maskId=$maskId");
$tpl->setVariable( "lnk_view", $fileProbMaskPreview."?maskId=$maskId");

// get questions
$questionsArray = getQuestions($formId);

for($j=0;$j<count($questionsArray);$j++)
{

	$tpl->setCurrentBlock( "question_overview" );
	$tpl->setVariable( "id", $questionsArray[$j]["FORMTYPE_ID_PK"] );
	$tpl->setVariable( "questionId", $questionsArray[$j]["FORMTYPE_ID_PK"] );
	$tpl->setVariable( "formtype", $questionsArray[$j]["FORMTYPE_ID_PK"] );
	$tpl->setVariable( "formtype_order", ($questionsArray[$j]["REL_ORDER_NUM"] + $actualNum));
	$tpl->setVariable( "element_header", $questionsArray[$j]["FORMTYPE_QUESTION"] ); // otto: used to be FORMELEMENT_HEADER
    // check Formtype
	switch ($questionsArray[$j]["FORMTYPE_TYPE"])
	{
		case "select":
		{
			$displayType = $lang_script["prob.question.edit.php"]["select"];
			break;
		}
		case "radio":
		{
			$displayType = $lang_script["prob.question.edit.php"]["radio"];
			break;
		}
		case "checkbox":
		{
			$displayType = $lang_script["prob.question.edit.php"]["checkbox"];
			break;
		}
		case "radiotable":
		{
			$displayType = $lang_script["prob.question.edit.php"]["radiotable"];
			break;
		}
		case "texttable":
		{
			$displayType = $lang_script["prob.question.edit.php"]["texttable"];
			break;
		}
		case "checkboxtable":
		{
			$displayType = $lang_script["prob.question.edit.php"]["checkboxtable"];
			break;
		}
		case "groupedtext":
		{
			$displayType = $lang_script["prob.question.edit.php"]["groupedtext"];
			break;
		}
		case "switchtext":
		{
			$displayType = $lang_script["prob.question.edit.php"]["switchtext"];
			break;
		}
		case "textarea":
		{
			$displayType = $lang_script["prob.question.edit.php"]["textarea"];
			break;
		}
		case "text":
		{
			$displayType = $lang_script["prob.question.edit.php"]["text"];
			break;
		}
		default:
		{
			$displayType = $lang_script["prob.question.edit.php"]["allocationError"];
			break;
		}
	}
	
	$tpl->setVariable( "typ_formtype", $displayType);	
    $tpl->parseCurrentBlock();
}


$tpl->parse();
$tpl->show();
?>
