<?php
// +----------------------------------------------------------------------+
// | sa project pilot                                                     |
// +----------------------------------------------------------------------+
// | Copyright (c) 2002 serie a - Digitale Medien und Systeme GmbH        |
// +----------------------------------------------------------------------+
// | Authors: 	Jrn Allert <allert@serie-a.de>                           |
// |          	Rene Renk   <renk@serie-a.de>                             |
// +----------------------------------------------------------------------+
//
// $Id: statistic.export.inc.php,v 1.2 2007/01/04 14:49:47 easy_israel Exp $

require_once("./../survey/lib/security/security.inc.php"); // security functions

// start session
@session_start();

// require all configuration files and libraries
require_once("./../config/config.inc.php"); // common config file // common config file
require_once($cfgPathToSurveyFiles."/config/survey.config.inc.php"); // survey config
require_once($cfgPathToSurveyFiles."/lib/survey.inc.php"); // survey functions
require_once($cfgPathToStatisticFiles."/lib/statistic.inc.php"); // statistics functions
require_once("Spreadsheet/Excel/Writer.php"); // ExcelcreatingClass
require_once("Validate.php"); // PEAR::Validate
/**
* exportFunctions class
*
* Export Management Class
*
* @author  Jrn Allert <allert@serie-a.de>
* @author  Rene Renk <renk@serie-a.de>
* @access  public
*/
class exportFunctions
{
    /**
    *	error message
    *	@var    string  $errorMessage
    */
    var $errorMessage;
	
	/**
    *	sets error message
    *
    *	@access	private
    *	@param	string	$err
    */
    function setErrorMessage($err)
    {
        $this->errorMessage = $err;
    }
	
	/**
    *	gets error message
    *
    *	@access	private
    */
    function getErrorMessage()
    {
        return $this->errorMessage;
    }
	
	/**
    *	constructor
    *
    *	@access	private
    *	@param	int	$projectId
    */
	function exportFunctions()
	{
		// create new surveyFunctions object
		$this->statistics = &new statisticFunctions;
	}
	
	/**
    *	cleans String from html
    *
    *	@access	private
    *	@param	string	$string
    */
	function cleanHeaderString($string)
	{
		// make clean question
		$string = $string;
		$string = ereg_replace("\t"," ",$string);
		$string = ereg_replace("\r","",$string);
		$string = ereg_replace("&nbsp;"," ",$string);
		$string = stripslashes(ereg_replace("<[^>]+>", "", $string));
		return $string;
	}
	
	/**
    *	creates main excel sheet
    *
    *	@access	private
    *	@param	int	$projectId
    */
	function exportToExcel($projectId, $sessionGroupsToTans = '', $sessionLimitOutputByDate = array())
	{
		global $lang_script;
		// set bigger time limit for big results
		set_time_limit(180);
		
		// headline
		$headlineArray =  $this->statistics->getSurveyForGroup($projectId);
		
		// Creating a workbook
		$excelWorkbook = new Spreadsheet_Excel_Writer();
		
		// set formats
		//
		// headline format
		$properties = array('size'=>'18','_bold'=>'0x222');
		$formatHeadline = $excelWorkbook->addFormat($properties);
		// labels format
		$properties = array('size'=>'14','_bold'=>'0x222');
		$formatLabels = $excelWorkbook->addFormat($properties);
		// questions format
		$properties = array('size'=>'10','TextWrap'=> 1,'align'=>'top','Bold'=>'1');
		$formatQuestion = $excelWorkbook->addFormat($properties);
		// Group Header Format
		$properties = array('size'=>'10','TextWrap'=> 1,'align'=>'top','Bold'=>'1','Color'=>'blue');
		$formatGroup = $excelWorkbook->addFormat($properties);
		// entries format
		$properties = array('size'=>'10','TextWrap'=> 1,'align'=> 'left');
		$formatEntries = $excelWorkbook->addFormat($properties);
		// rowheader format
		$properties = array('size'=>'10','TextWrap'=> 1,'align'=> 'left','italic'=> 1,'Color'=>'blue');
		$formatRowHeader = $excelWorkbook->addFormat($properties);
		//
		// end set formats
		
		// make workbook/sheet name set sheetindex
		$workbookName = $lang_script["statistic.export.inc.php"]["workbookName"];
		$worksheetPrefix = $lang_script["statistic.export.inc.php"]["worksheetPrefix"]."_";
		$worksheetIndex = 1;
		
		// set additional header
		//
		// if is tan protected
		if($headlineArray[0]["PROJECT_SECURITY"] == "tan")
		{
			$additionalHeader = $lang_script["statistic.export.inc.php"]["securityTAN"];
			
			// fill security object
			$securityFunctions = &new securityFunctions;
			$securityFunctions->setProjectId($projectId);
			$securityFunctions->setTanTableName();
			$securityFunctions->setTanGroupTableName();
			
			// check if groups to tans set
			$sessionGroupsToTans = ($sessionGroupsToTans)? $sessionGroupsToTans : 'all';
			$securityFunctions->setGroupsToTans($sessionGroupsToTans);
			// check if time limit
			if($sessionLimitOutputByDate)
			{
				$arrayFromTo["from"]	= $sessionLimitOutputByDate["from"]["timestamp"];
				$arrayFromTo["to"]		= $sessionLimitOutputByDate["to"]["timestamp"];
				$this->statistics->setResultTimeLimit($arrayFromTo);
				$securityFunctions->setTanTimeLimit($arrayFromTo);
			}
    		$timeFromLimit = $sessionLimitOutputByDate["from"]["day"].".".$sessionLimitOutputByDate["from"]["month"].".".$sessionLimitOutputByDate["from"]["year"];
			$timeToLimit   = $sessionLimitOutputByDate["to"]["day"].".".$sessionLimitOutputByDate["to"]["month"].".".$sessionLimitOutputByDate["to"]["year"];
			
			// get tangroupdata
			$groupsToTans = $securityFunctions->getGroupsToTans();
			$groupsToTansNames = $securityFunctions->getGroupsToTansNames();
			$groupsToTansIds = $securityFunctions->getGroupsToTansIds();
			$allTans	=	$securityFunctions->getTanNum();
			$usedTans	=	$securityFunctions->getUsedTanNum();
		}
		//
		// end set additional header
		
		// sending HTTP headers
		$excelWorkbook->send($lang_script["statistic.export.inc.php"]["excelResults"]."_".$workbookName.'.xls');
		// Creating main worksheet
		$worksheetMain =& $excelWorkbook->addWorksheet($workbookName);
		// matrixcounters
		$actualWorksheetRow 	= 0;
		$actualWorksheetColumn	= 0;
		$worksheetLastColumn	= 4;
		$sizeSpacerHeaderHeight	= 40;
		$sizeSpacerHeight	= 30;
		$sizeSmallHeaderHeight	= 30;
		$sizeContentHeight	= 20;
		
		// set columns
		//
		// question columns
		$worksheetMain->setColumn(0,0,100);
		// option column
		$worksheetMain->setColumn(1,1,60);
		// percent column
		$worksheetMain->setColumn(2,2,10);
		// number answer column
		$worksheetMain->setColumn(3,3,10);
		// anwer value column
		$worksheetMain->setColumn(3,4,20);
		//
		// end set columns
		
		// headerline
		//
		$worksheetMain->setRow($actualWorksheetRow,$sizeSpacerHeaderHeight,$formatSpacer);
		$worksheetMain->mergeCells($actualWorksheetRow,0,$actualWorksheetRow,$worksheetLastColumn);
		$worksheetMain->write($actualWorksheetRow, $actualWorksheetColumn, $lang_script["statistic.export.inc.php"]["totalsummary"], $formatHeadline);
		++$actualWorksheetRow;
		
		// spacer
		$worksheetMain->setRow($actualWorksheetRow,$sizeSpacerHeight,$formatSpacer);
		$worksheetMain->mergeCells($actualWorksheetRow,0,$actualWorksheetRow,$worksheetLastColumn);
		++$actualWorksheetRow;
		
		// name and user
		$worksheetMain->write($actualWorksheetRow, $actualWorksheetColumn, $headlineArray[0]["PROJECT_NAME"],$formatLabels);
		++$actualWorksheetColumn;
		// amount of user 
		$userNum = $this->statistics->getUserNum($projectId, $groupsToTansIds);
		if(!$userNum)
		{
			$userNum = '0';
		}
		if($this->statistics->errorMessage)
		{
		    $error .= $this->statistics->$errorMessage;
		}
		$worksheetMain->mergeCells($actualWorksheetRow,2,$actualWorksheetRow,$worksheetLastColumn);
		$worksheetMain->write($actualWorksheetRow, $actualWorksheetColumn, $lang_script["statistic.export.inc.php"]["participant"], $formatLabels);
		++$actualWorksheetColumn;
		$worksheetMain->write($actualWorksheetRow, $actualWorksheetColumn, $userNum,$formatLabels);
		++$actualWorksheetRow;
		$actualWorksheetColumn = 0;
		
		// optonal additional header
		if($additionalHeader)
		{
			// spacer
			$worksheetMain->setRow($actualWorksheetRow,$sizeContentHeight,$formatSpacer);
			$worksheetMain->mergeCells($actualWorksheetRow,0,$actualWorksheetRow,$worksheetLastColumn);
			++$actualWorksheetRow;
			
			// tan and used
			$worksheetMain->write($actualWorksheetRow, $actualWorksheetColumn, $additionalHeader, $formatQuestion);
			++$actualWorksheetColumn;
			if(!$userNum)
			{
				$userNum = '0';
			}
			if($this->statistics->errorMessage)
			{
			    $error .= $this->statistics->$errorMessage;
			}
			$worksheetMain->write($actualWorksheetRow, $actualWorksheetColumn, ($lang_script["statistic.export.inc.php"]["TANtotalconsumed"]." "), $formatQuestion);
			++$actualWorksheetColumn;
			$worksheetMain->write($actualWorksheetRow, $actualWorksheetColumn, $allTans, $formatQuestion);
			++$actualWorksheetColumn;
			$worksheetMain->write($actualWorksheetRow, $actualWorksheetColumn, $usedTans, $formatQuestion);
			
			++$actualWorksheetRow;
			$actualWorksheetColumn = 0;
			
			// groups
			$worksheetMain->write($actualWorksheetRow, $actualWorksheetColumn, $lang_script["statistic.export.inc.php"]["exportgroups"], $formatQuestion);
			++$actualWorksheetColumn;
			$worksheetMain->mergeCells($actualWorksheetRow,1,$actualWorksheetRow,$worksheetLastColumn);
			$worksheetMain->write($actualWorksheetRow, $actualWorksheetColumn, join(", ",$groupsToTansNames), $formatQuestion);
			++$actualWorksheetRow;
			$actualWorksheetColumn = 0;
			
			//timelimit
			$worksheetMain->write($actualWorksheetRow, $actualWorksheetColumn, $lang_script["statistic.export.inc.php"]["period"], $formatQuestion);
			++$actualWorksheetColumn;
			$worksheetMain->write($actualWorksheetRow, $actualWorksheetColumn, ($lang_script["statistic.export.inc.php"]["interval"]." "), $formatQuestion);
			++$actualWorksheetColumn;
			$worksheetMain->write($actualWorksheetRow, $actualWorksheetColumn, $timeFromLimit, $formatQuestion);
			++$actualWorksheetColumn;
			$worksheetMain->write($actualWorksheetRow, $actualWorksheetColumn, $timeToLimit, $formatQuestion);
			
			++$actualWorksheetRow;
			$actualWorksheetColumn = 0;
		}
		$worksheetMain->setRow($actualWorksheetRow,$sizeSpacerHeight);
		$worksheetMain->mergeCells($actualWorksheetRow,0,$actualWorksheetRow,$worksheetLastColumn);
		++$actualWorksheetRow;
		
		// percentexplain
		$worksheetMain->mergeCells($actualWorksheetRow,0,$actualWorksheetRow,$worksheetLastColumn);
		$worksheetMain->write($actualWorksheetRow, $actualWorksheetColumn, $lang_script["statistic.export.inc.php"]["percentMessage"], $formatEntries);
		++$actualWorksheetRow;
		
		//spacer
		$worksheetMain->setRow($actualWorksheetRow,$sizeSpacerHeaderHeight,$formatSpacer);
		$worksheetMain->mergeCells($actualWorksheetRow,0,$actualWorksheetRow,$worksheetLastColumn);
		++$actualWorksheetRow;
		//
		// end header line
		
		// define percent
		$onePercent = ($userNum / 100);
		
		// labels line
		$worksheetMain->write($actualWorksheetRow, $actualWorksheetColumn, $lang_script["statistic.export.inc.php"]["question"], $formatLabels);
		++$actualWorksheetColumn;
		$worksheetMain->write($actualWorksheetRow, $actualWorksheetColumn, $lang_script["statistic.export.inc.php"]["options"], $formatLabels);
		++$actualWorksheetColumn;
		$worksheetMain->write($actualWorksheetRow, $actualWorksheetColumn, $lang_script["statistic.export.inc.php"]["percent"], $formatLabels);
		++$actualWorksheetColumn;
		$worksheetMain->write($actualWorksheetRow, $actualWorksheetColumn, $lang_script["statistic.export.inc.php"]["number"], $formatLabels);
		++$actualWorksheetColumn;
		$worksheetMain->write($actualWorksheetRow, $actualWorksheetColumn, $lang_script["statistic.export.inc.php"]["questionvalue"], $formatLabels);
		++$actualWorksheetRow;
		$worksheetMain->setRow($actualWorksheetRow,$sizeSpacerHeight);
		$worksheetMain->mergeCells($actualWorksheetRow,0,$actualWorksheetRow,$worksheetLastColumn);
		++$actualWorksheetRow;
		// end labels line
		
		// metadata line
		// reset worksheet column
		$actualWorksheetColumn = 0;  
		
		// write metasheet data
		$worksheetMain->write($actualWorksheetRow, $actualWorksheetColumn, $lang_script["statistic.export.inc.php"]["metadatashow"], $formatQuestion);
		++$actualWorksheetColumn;
		$worksheetMain->write($actualWorksheetRow, $actualWorksheetColumn, "metadata", $formatEntries);
		$actualWorksheetColumn = 0; 
		++$actualWorksheetRow;++$actualWorksheetRow;
		// make metadatasheet
		$this->createMetaDataSheet($projectId,&$excelWorkbook,$groupsToTansIds);
		
		// end metadataline
		
		// get groups
		$groupArray = $this->statistics->getSortedGroups($projectId);
		
		for($i=0;$i<count($groupArray);$i++)
		{
			$actualWorksheetColumn = 0;
			
			// write group header
			$worksheetMain->setRow($actualWorksheetRow,$sizeSpacerHeight, $formatGroup);
			$worksheetMain->write($actualWorksheetRow, $actualWorksheetColumn, $lang_script["statistic.export.inc.php"]["groupanswer"], $formatGroup);
			++$actualWorksheetColumn;
			$worksheetMain->write($actualWorksheetRow, $actualWorksheetColumn, $groupArray[$i]["FORM_NAME"], $formatGroup);
			++$actualWorksheetRow;
			++$actualWorksheetRow;
			
			// get question data
		    $maxRow = $this->statistics->getQuestionsInGroup($groupArray[$i]["FORM_ID_PK"]);
		    $questionArray = $this->statistics->getSurveyQuestionsForGroup($groupArray[$i]["FORM_ID_PK"], 0, $maxRow, "FORMTYPE_ORDER", "ASC");
		    for($l=0;$l<count($questionArray);$l++)
		    {
				// reset worksheet column
				$actualWorksheetColumn = 0;  
				
				// make clean question
				$cleanQuestion	=	$this->cleanHeaderString($questionArray[$l]["FORMTYPE_QUESTION"]);
				
                // get answer options
                $answerArray = $this->statistics->getQuestionsAnswers($questionArray[$l]["FORMTYPE_ID_PK"]);
				// get type of question
		        $formType = $questionArray[$l]["FORMTYPE_TYPE"];
				
				// check if element has single overview pages
				if (($formType == "texttable")||($formType == "text")||($formType == "textarea")||($formType == "switchtext")||($formType == "groupedtext"))
				{
					$thisWorksheetPrefix = $worksheetPrefix.$worksheetIndex;
					$toShowQuestion  = $cleanQuestion;
					++$worksheetIndex;
				}
				else
				{
					$toShowQuestion = $cleanQuestion;
				}
				// write question
				$worksheetMain->write($actualWorksheetRow, $actualWorksheetColumn, $toShowQuestion, $formatQuestion);
		        ++$actualWorksheetColumn;
				
				// insert values
		        switch($formType)
		        {
		            case "select":
		                //
						// save current row
						$firstRowHere = $actualWorksheetRow;
						//
		                for($m=0;$m<count($answerArray);$m++)
		                {
							// clean Output from Html
							$cleanHeader	=	$this->cleanHeaderString($answerArray[$m]["FORMELEMENT_HEADER"]);
							// write question options
		                    $worksheetMain->write($actualWorksheetRow, $actualWorksheetColumn, $cleanHeader, $formatEntries);
							//
		                    ++$actualWorksheetColumn;
		                    // get answer num
		                    $answerNum = $this->statistics->getAnswerNum($projectId, $answerArray[$m]["FORMELEMENT_ID_PK"], $groupsToTansIds);
		                    // get percent
		                    $answerPercent = @round($answerNum / $onePercent/ 100,4);
		                    // write percent
		                    $worksheetMain->write($actualWorksheetRow, $actualWorksheetColumn, $answerPercent, $formatEntries);
							++$actualWorksheetColumn;
							$worksheetMain->write($actualWorksheetRow, $actualWorksheetColumn, $answerNum, $formatEntries);
							++$actualWorksheetColumn;
							$worksheetMain->write($actualWorksheetRow, $actualWorksheetColumn, $answerArray[$m]["FORMELEMENT_MULTIPLEVALUE"], $formatEntries);
							// new line
							$actualWorksheetColumn = 1;
							++$actualWorksheetRow;
		                }
					// merge question field
					$worksheetMain->mergeCells($firstRowHere,0,$actualWorksheetRow-1,0);
					$worksheetMain->setRow($actualWorksheetRow,$sizeSpacerHeight);
					// spacer row
					++$actualWorksheetRow;
					//if no options
					$actualWorksheetColumn = 1;
		            break;
		            
		            case "radio":
		                //
						// save current row
						$firstRowHere = $actualWorksheetRow;
						//
						
		                for($m=0;$m<count($answerArray);$m++)
		                {
							// clean Output from Html
							$cleanHeader	=	$this->cleanHeaderString($answerArray[$m]["FORMELEMENT_HEADER"]);
		                    // write question options
							$worksheetMain->write($actualWorksheetRow, $actualWorksheetColumn, $cleanHeader, $formatEntries);
		                    ++$actualWorksheetColumn;
		                    // get answer num
		                    $answerNum = $this->statistics->getAnswerNum($projectId, $answerArray[$m]["FORMELEMENT_ID_PK"], $groupsToTansIds);
		                    // get percent
		                    $answerPercent = @round($answerNum / $onePercent/ 100,4);
		                    $worksheetMain->write($actualWorksheetRow, $actualWorksheetColumn, $answerPercent, $formatEntries);
							++$actualWorksheetColumn;
							$worksheetMain->write($actualWorksheetRow, $actualWorksheetColumn, $answerNum, $formatEntries);
							++$actualWorksheetColumn;
							$worksheetMain->write($actualWorksheetRow, $actualWorksheetColumn, $answerArray[$m]["FORMELEMENT_MULTIPLEVALUE"], $formatEntries);
							// new line
							$actualWorksheetColumn = 1;
							++$actualWorksheetRow;
		                }
					// merge question field
					$worksheetMain->mergeCells($firstRowHere,0,$actualWorksheetRow-1,0);
					// spacer row
					$worksheetMain->setRow($actualWorksheetRow,$sizeSpacerHeight);
					++$actualWorksheetRow;
					//if no options
					$actualWorksheetColumn = 1;
		            break;
		            
		            case "checkbox":
		                //
						// save current row
						$firstRowHere = $actualWorksheetRow;
						//
		                for($m=0;$m<count($answerArray);$m++)
		                {
							// clean Output from Html
							$cleanHeader	=	$this->cleanHeaderString($answerArray[$m]["FORMELEMENT_HEADER"]);
		                    // write question options
							$worksheetMain->write($actualWorksheetRow, $actualWorksheetColumn, $cleanHeader, $formatEntries);
		                    ++$actualWorksheetColumn;
		                    
		                    // get answer num
		                    $answerNum = $this->statistics->getAnswerNum($projectId, $answerArray[$m]["FORMELEMENT_ID_PK"], $groupsToTansIds);
		                    // get percent
		                    $answerPercent = @round($answerNum / $onePercent/ 100,4);
		                    $worksheetMain->write($actualWorksheetRow, $actualWorksheetColumn, $answerPercent, $formatEntries);
							++$actualWorksheetColumn;
							$worksheetMain->write($actualWorksheetRow, $actualWorksheetColumn, $answerNum, $formatEntries);
							++$actualWorksheetColumn;
							$worksheetMain->write($actualWorksheetRow, $actualWorksheetColumn, $answerArray[$m]["FORMELEMENT_MULTIPLEVALUE"], $formatEntries);
							// new line
							$actualWorksheetColumn = 1;
							++$actualWorksheetRow;
		                }
					// merge question field
					$worksheetMain->mergeCells($firstRowHere,0,$actualWorksheetRow-1,0);
					// spacer row
					$worksheetMain->setRow($actualWorksheetRow,$sizeSpacerHeight);
					++$actualWorksheetRow;
					//if no options
					$actualWorksheetColumn = 1;
		            break;
		            
		            case "checkboxtable":
		                //
						// save current row
						$firstRowHere = $actualWorksheetRow;
						//
		                for($m=0;$m<count($answerArray);$m++)
		                {
							// clean Output from Html
							$cleanHeader	=	$this->cleanHeaderString($answerArray[$m]["FORMELEMENT_HEADER"]);
							// clean Output from Html
							$cleanAddHeader	=	$this->cleanHeaderString($answerArray[$m]["FORMELEMENT_ADDHEADER"]);
		                    // write one header for a matrix row
							if($cleanAddHeader != $backupAddHeader)
							{
								$worksheetMain->write($actualWorksheetRow, $actualWorksheetColumn,  $cleanAddHeader, $formatRowHeader);
								++$actualWorksheetRow;
								$backupAddHeader	=	$cleanAddHeader;
								$m--;
								continue;
							}
							// write question options
							$worksheetMain->write($actualWorksheetRow, $actualWorksheetColumn, $cleanHeader, $formatEntries);
		                    ++$actualWorksheetColumn;
		                    // get answer num
		                    $answerNum = $this->statistics->getAnswerNum($projectId, $answerArray[$m]["FORMELEMENT_ID_PK"], $groupsToTansIds);
		                    // get percent
		                    $answerPercent = @round($answerNum / $onePercent/ 100,4);
		                    $worksheetMain->write($actualWorksheetRow, $actualWorksheetColumn, $answerPercent, $formatEntries);
							++$actualWorksheetColumn;
							$worksheetMain->write($actualWorksheetRow, $actualWorksheetColumn, $answerNum, $formatEntries);
							++$actualWorksheetColumn;
							$worksheetMain->write($actualWorksheetRow, $actualWorksheetColumn, $answerArray[$m]["FORMELEMENT_MULTIPLEVALUE"], $formatEntries);
							// new line
							$actualWorksheetColumn = 1;
							++$actualWorksheetRow;
		                }
					// merge question field
					$worksheetMain->mergeCells($firstRowHere,0,$actualWorksheetRow-1,0);
					// spacer row
					$worksheetMain->setRow($actualWorksheetRow,$sizeSpacerHeight);
					++$actualWorksheetRow;
					//if no options
					$actualWorksheetColumn = 1;
					unset($backupAddHeader);
		            break;
		            
		            case "radiotable":
		                //
						// save current row
						$firstRowHere = $actualWorksheetRow;
						//
		                for($m=0;$m<count($answerArray);$m++)
		                {
							// clean Output from Html
							$cleanHeader	=	$this->cleanHeaderString($answerArray[$m]["FORMELEMENT_HEADER"]);
							// clean Output from Html
							$cleanAddHeader	=	$this->cleanHeaderString($answerArray[$m]["FORMELEMENT_ADDHEADER"]);
							// write one header for a matrix row
							if($cleanAddHeader != $backupAddHeader)
							{
								$worksheetMain->write($actualWorksheetRow, $actualWorksheetColumn,  $cleanAddHeader, $formatRowHeader);
								++$actualWorksheetRow;
								$backupAddHeader	=	$cleanAddHeader;
								$m--;
								continue;
							}
		                    // write question options
							$worksheetMain->write($actualWorksheetRow, $actualWorksheetColumn,  $cleanHeader, $formatEntries);
		                    ++$actualWorksheetColumn;
		                    // get answer num
		                    $answerNum = $this->statistics->getAnswerNum($projectId, $answerArray[$m]["FORMELEMENT_ID_PK"], $groupsToTansIds);
		                    // get percent
		                    $answerPercent = @round($answerNum / $onePercent/ 100,4);
		                    $worksheetMain->write($actualWorksheetRow, $actualWorksheetColumn, $answerPercent, $formatEntries);
							++$actualWorksheetColumn;
							$worksheetMain->write($actualWorksheetRow, $actualWorksheetColumn, $answerNum, $formatEntries);
							++$actualWorksheetColumn;
							$worksheetMain->write($actualWorksheetRow, $actualWorksheetColumn, $answerArray[$m]["FORMELEMENT_MULTIPLEVALUE"], $formatEntries);
							// new line
							$actualWorksheetColumn = 1;
							++$actualWorksheetRow;
		                }
					// merge question field
					$worksheetMain->mergeCells($firstRowHere,0,$actualWorksheetRow-1,0);
					// spacer row
					$worksheetMain->setRow($actualWorksheetRow,$sizeSpacerHeight);
					++$actualWorksheetRow;
					//if no options
					$actualWorksheetColumn = 1;
					unset($backupAddHeader);
		            break;
		            
		            case "texttable":
		                //
						// save current row
						$firstRowHere = $actualWorksheetRow;
						//
						// get Number of answers
						$answerNum = $this->statistics->getTextValuesNum($projectId, $questionArray[$l]["FORMTYPE_ID_PK"], $groupsToTansIds);
						//
						$worksheetMain->write($actualWorksheetRow-1, $actualWorksheetColumn, $thisWorksheetPrefix, $formatEntries);
		                ++$actualWorksheetRow;
		                for($m=0;$m<count($answerArray);$m++)
		                {
							// clean Output from Html
							$cleanHeader	=	$this->cleanHeaderString($answerArray[$m]["FORMELEMENT_HEADER"]);
							// clean Output from Html
							$cleanAddHeader	=	$this->cleanHeaderString($answerArray[$m]["FORMELEMENT_ADDHEADER"]);
							// write one header for a matrix row
							if($cleanAddHeader != $backupAddHeader)
							{
								$worksheetMain->write($actualWorksheetRow, $actualWorksheetColumn,  $cleanAddHeader, $formatRowHeader);
								++$actualWorksheetRow;
								$backupAddHeader	=	$cleanAddHeader;
								$m--;
								continue;
							}
		                    // write question options
							$worksheetMain->write($actualWorksheetRow, $actualWorksheetColumn,  $cleanHeader, $formatEntries);
		                    ++$actualWorksheetColumn;
							// new line
							$actualWorksheetColumn = 1;
							++$actualWorksheetRow;
		                }
						
		                if($answerNum && $answerNum > 0)
		                {
		                    // text value sheet
		                    $this->createTextValueSheet($projectId,$questionArray[$l]["FORMTYPE_ID_PK"],$cleanQuestion,$thisWorksheetPrefix,&$excelWorkbook,$groupsToTansIds);
		                }
					// merge question field
					$worksheetMain->mergeCells($firstRowHere,0,$actualWorksheetRow-1,0);
					// spacer row
					$worksheetMain->setRow($actualWorksheetRow,$sizeSpacerHeight);
					++$actualWorksheetRow;
					//if no options
					$actualWorksheetColumn = 1;
					unset($backupAddHeader);
		            break;
		            
		            case "groupedtext":
						//
						// save current row
						$firstRowHere = $actualWorksheetRow;
						//
						// get Number of answers
						$answerNum = $this->statistics->getTextValuesNum($projectId, $questionArray[$l]["FORMTYPE_ID_PK"], $groupsToTansIds);
						//
						$worksheetMain->write($actualWorksheetRow-1, $actualWorksheetColumn, $thisWorksheetPrefix, $formatEntries);
		                ++$actualWorksheetRow;
						for($m=0;$m<count($answerArray);$m++)
		                {
							// clean Output from Html
							$cleanHeader	=	$this->cleanHeaderString($answerArray[$m]["FORMELEMENT_HEADER"]);
		                    // write question options
							$worksheetMain->write($actualWorksheetRow, $actualWorksheetColumn, $cleanHeader, $formatEntries);
		                    ++$actualWorksheetColumn;
							// new line
							$actualWorksheetColumn = 1;
							++$actualWorksheetRow;
		                }
						
		                if($answerNum && $answerNum > 0)
		                {
		                    // text value sheet
		                    $this->createTextValueSheet($projectId,$questionArray[$l]["FORMTYPE_ID_PK"],$cleanQuestion,$thisWorksheetPrefix,&$excelWorkbook,$groupsToTansIds);
		                }
					// merge question field
					$worksheetMain->mergeCells($firstRowHere,0,$actualWorksheetRow-1,0);
					// spacer row
					$worksheetMain->setRow($actualWorksheetRow,$sizeSpacerHeight);
					++$actualWorksheetRow;
					//if no options
					$actualWorksheetColumn = 1;
		            break;
		            
		            case "textarea":
						
						// get Number of answers
						$answerNum = $this->statistics->getTextValuesNum($projectId, $questionArray[$l]["FORMTYPE_ID_PK"], $groupsToTansIds);
	                    // write question options
						$worksheetMain->write($actualWorksheetRow, $actualWorksheetColumn, $thisWorksheetPrefix, $formatEntries);
	                    ++$actualWorksheetColumn;
						++$actualWorksheetRow;
						
		                if($answerNum && $answerNum > 0)
		                {
		                    // text value sheet
		                    $this->createTextValueSheet($projectId,$questionArray[$l]["FORMTYPE_ID_PK"],$cleanQuestion,$thisWorksheetPrefix,&$excelWorkbook,$groupsToTansIds);
		                }
					$worksheetMain->setRow($actualWorksheetRow,$sizeSpacerHeight);
					++$actualWorksheetRow;
					//if no options
					$actualWorksheetColumn = 1;
		            break;
		            
		            case "text":
						
						// get Number of answers
						$answerNum = $this->statistics->getTextValuesNum($projectId, $questionArray[$l]["FORMTYPE_ID_PK"], $groupsToTansIds);
	                    // write question options
						$worksheetMain->write($actualWorksheetRow, $actualWorksheetColumn, $thisWorksheetPrefix, $formatEntries);
	                    ++$actualWorksheetColumn;
						++$actualWorksheetRow;
						
		                if($answerNum && $answerNum > 0)
		                {
		                    // text value sheet
		                    $this->createTextValueSheet($projectId,$questionArray[$l]["FORMTYPE_ID_PK"],$cleanQuestion,$thisWorksheetPrefix,&$excelWorkbook,$groupsToTansIds);
		                }
					$worksheetMain->setRow($actualWorksheetRow,$sizeSpacerHeight);
					++$actualWorksheetRow;
					//if no options
					$actualWorksheetColumn = 1;
		            break;
		            
		            case "switchtext":
						
						// get Number of answers
						$answerNum = $this->statistics->getTextValuesNum($projectId, $questionArray[$l]["FORMTYPE_ID_PK"], $groupsToTansIds);
						//
		                for($m=0;$m<count($answerArray);$m++)
		                {
		                    // write question options
							$worksheetMain->write($actualWorksheetRow, $actualWorksheetColumn, $thisWorksheetPrefix, $formatEntries);
		                    ++$actualWorksheetColumn;
							// new line
							$actualWorksheetColumn = 1;
							++$actualWorksheetRow;
		                }
						
		                if($answerNum && $answerNum > 0)
		                {
		                    // text value sheet
		                    $this->createTextValueSheet($projectId,$questionArray[$l]["FORMTYPE_ID_PK"],$cleanQuestion,$thisWorksheetPrefix,&$excelWorkbook,$groupsToTansIds);
		                }
					$worksheetMain->setRow($actualWorksheetRow,$sizeSpacerHeight);
					++$actualWorksheetRow;
					//if no options
					$actualWorksheetColumn = 1;
		            break;
				} 
		    }
		}
		// Let's send the file
		$excelWorkbook->close();
		return true;
	}
	// end function
	
	
	/**
    *	creates text value excel sheet
    *
    *	@access	private
    *	@param	int	$projectId
    */
	function createTextValueSheet($projectId,$questionId,$question,$workSheetName,$excelWorkbook,$groupsToTansIds = '')
	{
		global $lang_script;
		// make clean Question
		$cleanQuestion = stripslashes(urldecode($question));
		
		// for sheetname
		$sheetName = ereg_replace(" ","_",$cleanQuestion);
		$sheetName = ereg_replace("\"","",$sheetName);
		$sheetName = ereg_replace("\'","",$sheetName);
		//$sheetName = ereg_replace("\n","",$sheetName);
		$sheetName = ereg_replace("\t"," ",$sheetName);
		$sheetName = ereg_replace("\r","",$sheetName);
		$sheetName = stripslashes(ereg_replace("<[^>]+>", "", $sheetName));
		$sheetName = strtolower($sheetName);
		
		// check length
		$sheetNameLength = strlen($sheetName);
		if ($sheetNameLength < 15)
		{
			$cutLimit = $sheetNameLength;
		}
		else
		{
			$cutLimit = 15;
		}
		
		// Creating text value worksheet questionid used as variable name
		$$questionId =& $excelWorkbook->addWorksheet($workSheetName);
		// worksheetrowreset
		$actualWorksheetRow 	= 0;
		$actualWorksheetColumn	= 0;
		$worksheetLastColumn	= 2;
		$sizeSpacerHeaderHeight	= 40;
		$sizeSpacerHeight	= 30;
		$sizeContentHeight	= 20;
		
		// set formats
		//
		// headline format
		$properties = array('size'=>'18','TextWrap'=> 1,'_bold'=>'0x222');
		$formatHeadline = $excelWorkbook->addFormat($properties);
		// labels format
		$properties = array('size'=>'14','TextWrap'=> 1);
		$formatLabels = $excelWorkbook->addFormat($properties);
		// spacer format
		$properties = array('size'=>'10','align'=> 'vcenter','Bold'=>'1');
		$formatSpacer = $excelWorkbook->addFormat($properties);
		// entries format
		$properties = array('size'=>'10','TextWrap'=> 1,'align'=> 'left');
		$formatEntries = $excelWorkbook->addFormat($properties);
		// entries format
		$properties = array('size'=>'10','TextWrap'=> 1,'align'=> 'left','Bold'=>'1');
		$formatSum = $excelWorkbook->addFormat($properties);
		//
		// end set formats
		
		// set columns
		//
		// option/input columns
		$$questionId->setColumn(0,0,80);
		//  num columns
		$$questionId->setColumn(1,1,15);
		//	percent columns
		$$questionId->setColumn(2,2,15);

		//
		// end set columns
				
		// headline data
		$headlineArray =  $this->statistics->getSurveyForGroup($projectId);
		
		// headerline
		$$questionId->setRow($actualWorksheetRow,$sizeSpacerHeaderHeight,$formatSpacer);
		$$questionId->mergeCells($actualWorksheetRow,0,$actualWorksheetRow,$worksheetLastColumn);
		$$questionId->write($actualWorksheetRow, $actualWorksheetColumn, $lang_script["statistic.export.inc.php"]["singleresultoverview"], $formatHeadline);
		++$actualWorksheetRow;
		// spacer
		$$questionId->setRow($actualWorksheetRow,$sizeSpacerHeight,$formatSpacer);
		$$questionId->mergeCells($actualWorksheetRow,0,$actualWorksheetRow,$worksheetLastColumn);
		++$actualWorksheetRow;
		$$questionId->setRow($actualWorksheetRow,$sizeSpacerHeaderHeight,$formatSpacer);
		$$questionId->write($actualWorksheetRow, $actualWorksheetColumn, $lang_script["statistic.export.inc.php"]["project"], $formatLabels);
		++$actualWorksheetColumn;
		$$questionId->mergeCells($actualWorksheetRow,$actualWorksheetColumn,$actualWorksheetRow,$worksheetLastColumn);
		$$questionId->write($actualWorksheetRow, $actualWorksheetColumn, $headlineArray[0]["PROJECT_NAME"],$formatLabels);
		$actualWorksheetColumn = 0;
		++$actualWorksheetRow;
		// amount of user 
		$userNum = $this->statistics->getUserNum($projectId, $groupsToTansIds);
		if(!$userNum)
		{
			$userNum = '0';
		}
		// define percent
		$onePercent = ($userNum / 100);
		
		if($this->statistics->errorMessage)
		{
		    $error .= $this->statistics->$errorMessage;
		}
		$$questionId->setRow($actualWorksheetRow,$sizeSpacerHeaderHeight,$formatSpacer);
		$$questionId->write($actualWorksheetRow, $actualWorksheetColumn, ($lang_script["statistic.export.inc.php"]["participant"]." "), $formatLabels);
		++$actualWorksheetColumn;
		$$questionId->write($actualWorksheetRow, $actualWorksheetColumn, $userNum,$formatLabels);
		++$actualWorksheetRow;
		$actualWorksheetColumn = 0;
		// spacer
		$$questionId->setRow($actualWorksheetRow,$sizeSpacerHeight,$formatSpacer);
		$$questionId->mergeCells($actualWorksheetRow,0,$actualWorksheetRow,$worksheetLastColumn);
		++$actualWorksheetRow;
		// questionheader
		$$questionId->mergeCells($actualWorksheetRow,0,$actualWorksheetRow,$worksheetLastColumn);
		$$questionId->write($actualWorksheetRow, $actualWorksheetColumn, ($lang_script["statistic.export.inc.php"]["questioninput"]." "), $formatLabels);
		++$actualWorksheetRow;
		// small spacer
		$$questionId->setRow($actualWorksheetRow,$sizeContentHeight);
		$$questionId->mergeCells($actualWorksheetRow,0,$actualWorksheetRow,$worksheetLastColumn);
		++$actualWorksheetRow;
		// question
		$$questionId->mergeCells($actualWorksheetRow,0,$actualWorksheetRow,$worksheetLastColumn);
		$$questionId->write($actualWorksheetRow, $actualWorksheetColumn, $cleanQuestion,$formatLabels);
		++$actualWorksheetRow;
		$$questionId->setRow($actualWorksheetRow,$sizeSpacerHeight);
		$$questionId->mergeCells($actualWorksheetRow,0,$actualWorksheetRow,$worksheetLastColumn);
		++$actualWorksheetRow;
		$actualWorksheetColumn = 0;
		// percentexplain
		$$questionId->mergeCells($actualWorksheetRow,0,$actualWorksheetRow,$worksheetLastColumn);
		$$questionId->write($actualWorksheetRow, $actualWorksheetColumn, $lang_script["statistic.export.inc.php"]["percentMessage"], $formatEntries);
		++$actualWorksheetRow;/*
		$$questionId->mergeCells($actualWorksheetRow,0,$actualWorksheetRow,$worksheetLastColumn);
		$$questionId->write($actualWorksheetRow, $actualWorksheetColumn, $lang_script["statistic.export.inc.php"]["percentMessage"], $formatEntries);
		++$actualWorksheetRow;*/
		$$questionId->setRow($actualWorksheetRow,$sizeSpacerHeight);
		$$questionId->mergeCells($actualWorksheetRow,0,$actualWorksheetRow,$worksheetLastColumn);
		++$actualWorksheetRow;
		$actualWorksheetColumn = 0;
		// end header line
		
		// labels
		$$questionId->write($actualWorksheetRow, $actualWorksheetColumn, $lang_script["statistic.export.inc.php"]["answeroptionresult"], $formatLabels);
		++$actualWorksheetColumn;
		$$questionId->write($actualWorksheetRow, $actualWorksheetColumn, $lang_script["statistic.export.inc.php"]["percent"], $formatLabels);
		++$actualWorksheetColumn;
		$$questionId->write($actualWorksheetRow, $actualWorksheetColumn, $lang_script["statistic.export.inc.php"]["number"], $formatLabels);
		++$actualWorksheetRow;
		$$questionId->setRow($actualWorksheetRow,$sizeSpacerHeight);
		$$questionId->mergeCells($actualWorksheetRow,0,$actualWorksheetRow,$worksheetLastColumn);
		++$actualWorksheetRow;
		$actualWorksheetColumn = 0;
		// end labels
		
		// get answersoptions
		$answerArray = $this->statistics->getQuestionsAnswers($questionId);
		
		if(!$answerArray)
		{
			$textValueArray[$answerArray[0]["FORMELEMENT_ID_PK"]] = $this->statistics->getTextValuesGrouped($projectId,'',$questionId,$groupsToTansIds);
			$idWithOptions[$answerArray[0]["FORMELEMENT_ID_PK"]] = $lang_script["statistic.export.inc.php"]["answer"];
		}
		// sort options to ids
		for($i=0;$i<count($answerArray);++$i)
		{
			// clean Output from Html
			$cleanHeader	=	$this->cleanHeaderString($answerArray[$i]["FORMELEMENT_HEADER"]);
			// clean Output from Html
			$cleanAddHeader	=	$this->cleanHeaderString($answerArray[$i]["FORMELEMENT_ADDHEADER"]);
			
			$textValueArray[$answerArray[$i]["FORMELEMENT_ID_PK"]] = $this->statistics->getTextValuesGrouped($projectId, $answerArray[$i]["FORMELEMENT_ID_PK"],'',$groupsToTansIds);
			$idWithOptions[$answerArray[$i]["FORMELEMENT_ID_PK"]] = $cleanHeader." - ".$cleanAddHeader;
			(count($answerArray)==1)? ($idWithOptions[$answerArray[$i]["FORMELEMENT_ID_PK"]] = $lang_script["statistic.export.inc.php"]["answer"]) : "";
			//$grandTotal = $grandTotal + $textValueArray[$answerArray[$i]["FORMELEMENT_ID_PK"]][(count($textValueArray[$answerArray[$i]["FORMELEMENT_ID_PK"]])-1)]["TOTALBYNOW"];
		}
		
		// display values
		if(!is_array($textValueArray))
		{
			// parse template
			exit;
		}
		foreach($textValueArray as $optionKey => $resultValue)
		{
			
			// display option
			$$questionId->setRow($actualWorksheetRow,$sizeSpacerHeight);
			$$questionId->mergeCells($actualWorksheetRow,0,$actualWorksheetRow,$worksheetLastColumn);
			$$questionId->write($actualWorksheetRow, $actualWorksheetColumn, $idWithOptions[$optionKey],$formatSpacer);
			++$actualWorksheetRow;
			$actualWorksheetColumn = 0;
			// results
			for($i=0;$i<count($resultValue);$i++)
			{
				$multipleValue	=	$this->cleanHeaderString($resultValue[$i]["RESULT_MULTIPLEVALUE"]);
				$$questionId->write($actualWorksheetRow, $actualWorksheetColumn, $multipleValue, $formatEntries);// value
				++$actualWorksheetColumn;
				$$questionId->write($actualWorksheetRow, $actualWorksheetColumn,  @round($resultValue[$i]["num"] / $onePercent,2), $formatEntries);//percent
				++$actualWorksheetColumn;
				$$questionId->write($actualWorksheetRow, $actualWorksheetColumn, $resultValue[$i]["num"], $formatEntries);//num
				++$actualWorksheetColumn;
				//
				$totalNumSum = $totalNumSum + ($resultValue[$i]["num"]* intval($resultValue[$i]["RESULT_MULTIPLEVALUE"]));
				++$actualWorksheetRow;
				$actualWorksheetColumn = 0;
			}
			++$actualWorksheetRow;
			/*/ display sum
			if(count($answerArray)>1 && $totalNumSum > 0)
			{
				$$questionId->write($actualWorksheetRow, $actualWorksheetColumn, "Summe", $formatSum);// value
				++$actualWorksheetColumn;
				$$questionId->write($actualWorksheetRow, $actualWorksheetColumn, @round(($totalNumSum/($grandTotal/100)),2), $formatSum);//percent
				++$actualWorksheetColumn;
				$$questionId->write($actualWorksheetRow, $actualWorksheetColumn, $totalNumSum, $formatSum);//num
				++$actualWorksheetColumn;
			}
			elseif($totalNumSum > 0)
			{
				$$questionId->write($actualWorksheetRow, $actualWorksheetColumn, "Einzeleingabe", $formatSum);// value
				++$actualWorksheetColumn;
				$$questionId->write($actualWorksheetRow, $actualWorksheetColumn, @round(($totalNumSum/($grandTotal/100)),2), $formatSum);//percent
				++$actualWorksheetColumn;
				$$questionId->write($actualWorksheetRow, $actualWorksheetColumn, $totalNumSum, $formatSum);//num
				++$actualWorksheetColumn;
			}
			else
			{
				$$questionId->write($actualWorksheetRow, $actualWorksheetColumn, "Texteingabe", $formatSum);// value
				++$actualWorksheetColumn;++$actualWorksheetColumn;
				$$questionId->write($actualWorksheetRow, $actualWorksheetColumn,"Keine Summe", $formatSum);//num
				++$actualWorksheetColumn;
			}
			++$actualWorksheetRow;
			$actualWorksheetColumn = 0;
			$$questionId->setRow($actualWorksheetRow,$sizeSpacerHeight);
			$$questionId->mergeCells($actualWorksheetRow,0,$actualWorksheetRow,$worksheetLastColumn);
			++$actualWorksheetRow;*/
			$totalNumSum = 0;
		}
	}
	// end functiom
	
	/**
    *	creates text value excel sheet
    *
    *	@access	private
    *	@param	int	$projectId
    */
	function createMetaDataSheet($projectId,$excelWorkbook,$groupsToTansIds = '')
	{
		global $lang_script;
		// headline
		$headlineArray =  $this->statistics->getSurveyForGroup($projectId);
		
		// Headline
		$cleanQuestion = $lang_script["statistic.export.inc.php"]["metadataoverview"];
				
		// Creating text value worksheet questionid used as variable name
		$metaSheet =& $excelWorkbook->addWorksheet("metadata");
		// worksheetrowreset
		$actualWorksheetRow 	= 0;
		$actualWorksheetColumn	= 0;
		$worksheetLastColumn	= 3;
		$sizeSpacerHeaderHeight	= 40;
		$sizeSpacerHeight	= 30;
		$sizeContentHeight	= 20;
		
		// set formats
		//
		// headline format
		$properties = array('size'=>'18','TextWrap'=> 1,'_bold'=>'0x222');
		$formatHeadline = $excelWorkbook->addFormat($properties);
		// labels format
		$properties = array('size'=>'14','TextWrap'=> 1);
		$formatLabels = $excelWorkbook->addFormat($properties);
		// spacer format
		$properties = array('size'=>'10','align'=> 'vcenter','Bold'=>'1');
		$formatSpacer = $excelWorkbook->addFormat($properties);
		// entries format
		$properties = array('size'=>'10','TextWrap'=> 1,'align'=> 'left');
		$formatEntries = $excelWorkbook->addFormat($properties);
		//
		// end set formats
		
		// set columns
		//
		// type columns
		$metaSheet->setColumn(0,0,40);
		// value columns
		$metaSheet->setColumn(1,1,80);
		// percent columns
		$metaSheet->setColumn(2,2,10);
		// num columns
		$metaSheet->setColumn(3,3,10);
		//
		// end set columns
				
		// headline data
		$headlineArray =  $this->statistics->getSurveyForGroup($projectId);
		
		// headerline
		$metaSheet->setRow($actualWorksheetRow,$sizeSpacerHeaderHeight,$formatSpacer);
		$metaSheet->mergeCells($actualWorksheetRow,0,$actualWorksheetRow,$worksheetLastColumn);
		$metaSheet->write($actualWorksheetRow, $actualWorksheetColumn, $lang_script["statistic.export.inc.php"]["metadata"], $formatHeadline);
		++$actualWorksheetRow;
		// spacer
		$metaSheet->setRow($actualWorksheetRow,$sizeSpacerHeight,$formatSpacer);
		$metaSheet->mergeCells($actualWorksheetRow,0,$actualWorksheetRow,$worksheetLastColumn);
		++$actualWorksheetRow;
		
		$metaSheet->write($actualWorksheetRow, $actualWorksheetColumn, $headlineArray[0]["PROJECT_NAME"],$formatLabels);
		++$actualWorksheetColumn;
		// amount of user 
		$userNum = $this->statistics->getUserNum($projectId,$groupsToTansIds);
		if(!$userNum)
		{
			$userNum = '0';
		}
		if($this->statistics->errorMessage)
		{
		    $error .= $this->statistics->$errorMessage;
		}
		$metaSheet->mergeCells($actualWorksheetRow,1,$actualWorksheetRow,$worksheetLastColumn);
		$metaSheet->write($actualWorksheetRow, $actualWorksheetColumn, ($lang_script["statistic.export.inc.php"]["participant"]." ".$userNum),$formatLabels);
		++$actualWorksheetRow;
		$metaSheet->setRow($actualWorksheetRow,$sizeSpacerHeaderHeight);
		$metaSheet->mergeCells($actualWorksheetRow,0,$actualWorksheetRow,$worksheetLastColumn);
		++$actualWorksheetRow;
		$actualWorksheetColumn = 0;
		// end header line
		
		// define value for one percent
		$onePercent = ($userNum / 100);
		
		// labels
		$metaSheet->write($actualWorksheetRow, $actualWorksheetColumn, $lang_script["statistic.export.inc.php"]["datatype"], $formatLabels);
		++$actualWorksheetColumn;
		$metaSheet->write($actualWorksheetRow, $actualWorksheetColumn, $lang_script["statistic.export.inc.php"]["value"], $formatLabels);
		++$actualWorksheetColumn;
		$metaSheet->write($actualWorksheetRow, $actualWorksheetColumn, $lang_script["statistic.export.inc.php"]["percent"], $formatLabels);
		++$actualWorksheetColumn;
		$metaSheet->write($actualWorksheetRow, $actualWorksheetColumn, $lang_script["statistic.export.inc.php"]["number"], $formatLabels);
		++$actualWorksheetRow;
		$metaSheet->setRow($actualWorksheetRow,$sizeSpacerHeight);
		$metaSheet->mergeCells($actualWorksheetRow,0,$actualWorksheetRow,$worksheetLastColumn);
		++$actualWorksheetRow;
		$actualWorksheetColumn = 0;
		// end labels
		
		// define columns to how
		$columnsToFetch = array('FILLED_USER_OS'=>$lang_script["statistic.export.inc.php"]["userOS"], 'FILLED_USER_BROWSER'=>$lang_script["statistic.export.inc.php"]["userBrowser"], 'FILLED_HTTP_REFERER'=>$lang_script["statistic.export.inc.php"]["linkedfrom"], 'FILLED_REMOTE_ADDRESS'=>$lang_script["statistic.export.inc.php"]["userIP"], 'FILLED_HOST_ADDRESS'=>$lang_script["statistic.export.inc.php"]["userHostIP"]);// 
		
		// get grouped metadata
		$metaData	=	$this->statistics->getMetaValues($projectId, $columnsToFetch,$groupsToTansIds);
		
		if(!is_array($metaData))
		{
			return;
		}
		// display values
		foreach($metaData as $metaType => $metaResults)
		{
			// meta type
			$metaSheet->write($actualWorksheetRow, $actualWorksheetColumn, $columnsToFetch[$metaType], $formatLabels);
			++$actualWorksheetColumn;
			// values and co
			for($i = 0;$i < count($metaResults) ;$i++)
			{
				$resultToShow	=	$metaResults[$i][$metaType];
				if(!$resultToShow)
				{
					if(!isset($resultToShow))
					{
						$resultToShow = $lang_script["statistic.export.inc.php"]["emptyvalue"];
					}
					else
					{
						$resultToShow = $lang_script["statistic.export.inc.php"]["novalue"];
					}
				}
				if($metaType == "FILLED_HTTP_REFERER")
				{
					$resultToShow	=	explode( "?", $resultToShow);
					$resultToShow	=	"URL: ".$resultToShow[0];
				}
				// write value
				$metaSheet->write($actualWorksheetRow, $actualWorksheetColumn, $resultToShow, $formatEntries);
				++$actualWorksheetColumn;
				
				$answerPercent = @round($metaResults[$i]["num"] / $onePercent/ 100,4);
				
				// write percent
				$metaSheet->write($actualWorksheetRow, $actualWorksheetColumn, $answerPercent, $formatEntries);
				++$actualWorksheetColumn;
				// write num
				$metaSheet->write($actualWorksheetRow, $actualWorksheetColumn,$metaResults[$i]["num"], $formatEntries);
				++$actualWorksheetRow;
				$actualWorksheetColumn = 1;
			}
			$actualWorksheetColumn = 0;
			$metaSheet->setRow($actualWorksheetRow,$sizeSpacerHeight);
			$metaSheet->mergeCells($actualWorksheetRow,0,$actualWorksheetRow,$worksheetLastColumn);
			++$actualWorksheetRow;
		}
	}
	// end functiom
}
// end class
?>
