<?php
// +----------------------------------------------------------------------+
// | sa project pilot                                                     |
// +----------------------------------------------------------------------+
// | Copyright (c) 2002 serie a - Digitale Medien und Systeme GmbH        |
// +----------------------------------------------------------------------+
// | Authors: 	Jrn Allert <allert@serie-a.de>                           |
// |          	Rene Renk   <renk@serie-a.de>                             |
// +----------------------------------------------------------------------+
//
// $Id: statistic.export.singlerow.inc.php,v 1.1.1.1 2004/07/15 13:31:22 opensurveypilot Exp $

require_once("./../survey/lib/security/security.inc.php"); // security functions

// start session
@session_start();

// require all configuration files and libraries
require_once($cfgPathToProjectAdmin."/config/config.inc.php"); // common config file // common config file
require_once($cfgPathToSurveyFiles."/config/survey.config.inc.php"); // survey config
require_once($cfgPathToSurveyFiles."/lib/survey.inc.php"); // survey functions
require_once($cfgPathToStatisticFiles."/lib/statistic.inc.php"); // statistics functions
require_once("Spreadsheet/Excel/Writer.php"); // ExcelcreatingClass
require_once ("Validate.php"); // PEAR::Validate

/**
* exportFunctions class
*
* Export Management Class
*
* @author  Jrn Allert <allert@serie-a.de>
* @author  Rene Renk <renk@serie-a.de>
* @access  public
*/
class exportToExcelRow
{
    /**
    *	error message
    *	@var    string  $errorMessage
    */
    var $errorMessage;
	
    /**
    *	format for workbook
    *	@var   object
    */
    var $formatHeadline;
	
    /**
    *	format for workbook
    *	@var   object
    */
    var $formatLabels;
	
    /**
    *	format for workbook
    *	@var   object
    */
    var $formatQuestion;
	
    /**
    *	format for workbook
    *	@var   object
    */
    var $formatEntries;
	
    /**
    *	global worksheetrow
    *	@var   object
    */
    var $actualWorksheetRow;
	
    /**
    *	global worksheetrow
    *	@var   object
    */
    var $worksheetNew;
	
	/**
    *	sets error message
    *
    *	@access	private
    *	@param	string	$err
    */
    function setErrorMessage($err)
    {
        $this->errorMessage = $err;
    }
	
	/**
    *	gets error message
    *
    *	@access	private
    */
    function getErrorMessage()
    {
        return $this->errorMessage;
    }
	
	/**
    *	constructor
    *
    *	@access	private
    *	@param	int	$projectId
    */
	function exportToExcelRow()
	{
		// create new surveyFunctions object
		$this->statistics = &new statisticFunctions;
	}
	
	
	/**
    *	creates worksheet to write to
    *
    *	@access	private
    *	@param	object	$workbook
    *	@param	array	$filledTableData
    *	@param	array	$headlineArray
    *	@param	string	$worksheetName
    *	return	object  $this->worksheetNew
    */
	function createSheetInProgress($workbook, $filledTableData, $headlineArray, $worksheetName,$tanGroupData='')
	{
		global $lang_script;
		/*/ set additional header
		//
		// if is tan protected
		if($headlineArray[0]["PROJECT_SECURITY"] == "tan")
		{
			$additionalHeader = $lang_script["statistic.export.singlerow.inc.php"]["securityTAN"];
			
			// get number of tans (used)
			$securityFunctions = &new securityFunctions;
			$securityFunctions->setProjectId($projectId);
			$securityFunctions->setTanTableName();
			$allTans	=	$securityFunctions->getTanNum();
			$usedTans	=	$securityFunctions->getUsedTanNum();
			
			$additionalHeadersArgument = "TANS Gesamt / Verbraucht: ".$allTans." / ".$usedTans;
		}
		//
		/*/// end set additional header
		
		//heights
		$sizeSpacerHeaderHeight	= 40;
		$sizeSpacerHeight	= 30;
		$sizeContentHeight	= 20;
		
		// Creatingworksheet
		$this->worksheetNew =& $workbook->addWorksheet($worksheetName);
		
		// question columns
		$this->worksheetNew->setColumn(0,255,25);
		
		// headerline
		//
		$this->worksheetNew->setRow($this->actualWorksheetRow,$sizeSpacerHeaderHeight); // $formatSpacer
		//$worksheetInProgress->mergeCells($this->actualWorksheetRow,0,$this->actualWorksheetRow,$worksheetLastColumn);
		$this->worksheetNew->write($this->actualWorksheetRow, $actualWorksheetColumn, ($lang_script["statistic.export.singlerow.inc.php"]["rowview"]." ".$headlineArray[0]["PROJECT_NAME"]), $this->formatHeadline);
		++$this->actualWorksheetRow;
		// if tan group
		if(is_array($tanGroupData))
		{	
			$this->worksheetNew->setRow($this->actualWorksheetRow,$sizeSpacerHeight);
			++$this->actualWorksheetRow;
			
			$actualWorksheetColumn = 0;
			// teilnehmer
			$this->worksheetNew->setRow($this->actualWorksheetRow,$sizeContentHeight);
			$this->worksheetNew->write($this->actualWorksheetRow, $actualWorksheetColumn, $lang_script["statistic.export.singlerow.inc.php"]["participant"], $this->formatQuestion);
			$actualWorksheetColumn++;
			$this->worksheetNew->write($this->actualWorksheetRow, $actualWorksheetColumn, count($filledTableData), $this->formatQuestion);
			$this->actualWorksheetRow++;
			
			$actualWorksheetColumn = 0;
			// Tangroups
			$this->worksheetNew->setRow($this->actualWorksheetRow,$sizeSpacerHeight);
			$this->worksheetNew->write($this->actualWorksheetRow, $actualWorksheetColumn, $lang_script["statistic.export.singlerow.inc.php"]["TANgroupresults"], $this->formatQuestion);
			$actualWorksheetColumn++;
			$this->worksheetNew->write($this->actualWorksheetRow, $actualWorksheetColumn, join(", ", $tanGroupData["tanNames"]), $this->formatQuestion);
			$this->actualWorksheetRow++;
			
			$actualWorksheetColumn = 0;
			// allTans
			$this->worksheetNew->setRow($this->actualWorksheetRow,$sizeContentHeight);
			$this->worksheetNew->write($this->actualWorksheetRow, $actualWorksheetColumn, $lang_script["statistic.export.singlerow.inc.php"]["allTANs"], $this->formatQuestion);
			$actualWorksheetColumn++;
			$this->worksheetNew->write($this->actualWorksheetRow, $actualWorksheetColumn, $tanGroupData["allTans"], $this->formatQuestion);
			$this->actualWorksheetRow++;
			
			$actualWorksheetColumn = 0;
			// usedTans
			$this->worksheetNew->setRow($this->actualWorksheetRow,$sizeContentHeight);
			$this->worksheetNew->write($this->actualWorksheetRow, $actualWorksheetColumn, $lang_script["statistic.export.singlerow.inc.php"]["usedTANs"], $this->formatQuestion);
			$actualWorksheetColumn++;
			$this->worksheetNew->write($this->actualWorksheetRow, $actualWorksheetColumn, $tanGroupData["usedTans"], $this->formatQuestion);
			$this->actualWorksheetRow++;
			
			$actualWorksheetColumn = 0;
			// timeLimit From
			$this->worksheetNew->setRow($this->actualWorksheetRow,$sizeContentHeight);
			$this->worksheetNew->write($this->actualWorksheetRow, $actualWorksheetColumn, $lang_script["statistic.export.singlerow.inc.php"]["timefrom"], $this->formatQuestion);
			$actualWorksheetColumn++;
			$this->worksheetNew->write($this->actualWorksheetRow, $actualWorksheetColumn, $tanGroupData["timeFromLimit"], $this->formatQuestion);
			$this->actualWorksheetRow++;
			
			$actualWorksheetColumn = 0;
			// timeLimit to
			$this->worksheetNew->setRow($this->actualWorksheetRow,$sizeContentHeight);
			$this->worksheetNew->write($this->actualWorksheetRow, $actualWorksheetColumn, $lang_script["statistic.export.singlerow.inc.php"]["timeuntil"], $this->formatQuestion);
			$actualWorksheetColumn++;
			$this->worksheetNew->write($this->actualWorksheetRow, $actualWorksheetColumn, $tanGroupData["timeToLimit"], $this->formatQuestion);
			$this->actualWorksheetRow++;
			
			$actualWorksheetColumn = 0;
		}
		// spacer
		$this->worksheetNew->setRow($this->actualWorksheetRow,$sizeSpacerHeight); // $formatSpacer
		//$worksheetInProgress->mergeCells($this->actualWorksheetRow,0,$this->actualWorksheetRow,$worksheetLastColumn);
		++$this->actualWorksheetRow;
		$this->worksheetNew->write($this->actualWorksheetRow+1, $actualWorksheetColumn, $lang_script["statistic.export.singlerow.inc.php"]["date"], $this->formatQuestion);
		$this->worksheetNew->write($this->actualWorksheetRow+1, $actualWorksheetColumn+1, $lang_script["statistic.export.singlerow.inc.php"]["TAN"], $this->formatQuestion);
		$this->worksheetNew->write($this->actualWorksheetRow+1, $actualWorksheetColumn+2, $lang_script["statistic.export.singlerow.inc.php"]["user"], $this->formatQuestion);
		//
		// end headerline
		
		// insert userdata
		//
		// goto result row
		$userDataWorksheetRow = $this->actualWorksheetRow + 2;
		// if filled surveys write user header in ID_PK order // has to be changed to user id if implemented userdata // 030314-rr
		if ($filledTableData)
		{
			for($dataIndex = 0; $dataIndex < count($filledTableData); $dataIndex++) 
			{
				$this->worksheetNew->write($userDataWorksheetRow, $actualWorksheetColumn, $filledTableData[$dataIndex]["FILLED_TIME"], $this->formatQuestion);
				$this->worksheetNew->write($userDataWorksheetRow, $actualWorksheetColumn+1, $filledTableData[$dataIndex]["FILLED_DETERMINATOR"], $this->formatQuestion);
				$this->worksheetNew->write($userDataWorksheetRow, $actualWorksheetColumn+2, $filledTableData[$dataIndex]["SECURITYTAN_USER"], $this->formatQuestion);
				++$userDataWorksheetRow;
			}
		}
		//
		// end insert userdata
		return true;
	}
	/**
    *	creates main excel sheet
    *
    *	@access	private
    *	@param	int	$projectId
    */
	function exportToExcelRowView($projectId, $sessionGroupsToTans = array(),$sessionLimitOutputByDate=array())
	{
		global $lang_script;
		// set bigger time limit for big results
		set_time_limit(180);
		
		// Creating a workbook
		$excelWorkbook = & new Spreadsheet_Excel_Writer();
		
		// set formats
		//
		// headline format
		$properties = array('size'=>'18','_bold'=>'0x222','align'=>'top');
		$this->formatHeadline = $excelWorkbook->addFormat($properties);
		// labels format
		$properties = array('size'=>'14','_bold'=>'0x222');
		$this->formatLabels = $excelWorkbook->addFormat($properties);
		// questions format
		$properties = array('size'=>'10','TextWrap'=> 1,'align'=>'top','Bold'=>'1');
		$this->formatQuestion = $excelWorkbook->addFormat($properties);
		// entries format
		$properties = array('size'=>'10','TextWrap'=> 1,'align'=> 'center');
		$this->formatEntries = $excelWorkbook->addFormat($properties);
		//
		// end set formats
		
		//heights
		$sizeSpacerHeaderHeight	= 40;
		$sizeSpacerHeight	= 30;
		$sizeContentHeight	= 20;
		
		// worksheetcounters
		$this->actualWorksheetRow 	= 0;
		$actualWorksheetColumn	= 0;
		$firstColumnAfterLabels = 3;
		
		// make workbook/sheet name set sheetindex
		$workbookName = $lang_script["statistic.export.singlerow.inc.php"]["workbookName"];
		$worksheetPrefix = $lang_script["statistic.export.singlerow.inc.php"]["worksheetPrefix"]."_";
		$worksheetIndex = 1;
		$worksheetName = $worksheetPrefix.$worksheetIndex."_".$lang_script["statistic.export.singlerow.inc.php"]["worksheetName1"]."_".$lang_script["statistic.export.singlerow.inc.php"]["worksheetName2"]."_".$worksheetIndex;
		
		// sending HTTP headers
		$excelWorkbook->send($lang_script["statistic.export.singlerow.inc.php"]["excelResults"].'_'.$workbookName.'.xls');
		
		// headline
		$headlineArray =  $this->statistics->getSurveyForGroup($projectId);
        if (PEAR::isError($headlineArray)) 
        {
		   echo $headlineArray->getMessage();
        }
		// if is tan protected
		if($headlineArray[0]["PROJECT_SECURITY"] == "tan")
		{
			$additionalHeader = $lang_script["statistic.export.singlerow.inc.php"]["securityTAN"];
			
			// fill security object
			$securityFunctions = &new securityFunctions;
			$securityFunctions->setProjectId($projectId);
			$securityFunctions->setTanTableName();
			$securityFunctions->setTanGroupTableName();
			
			// check if groups to tans set
			$sessionGroupsToTans = ($sessionGroupsToTans)? $sessionGroupsToTans : 'all';
			$securityFunctions->setGroupsToTans($sessionGroupsToTans);
			
			// check if time limit
			if($sessionLimitOutputByDate)
			{
				$arrayFromTo["from"]	= $sessionLimitOutputByDate["from"]["timestamp"];
				$arrayFromTo["to"]		= $sessionLimitOutputByDate["to"]["timestamp"];
				$this->statistics->setResultTimeLimit($arrayFromTo);
				$securityFunctions->setTanTimeLimit($arrayFromTo);
			}
		    $tanGroupData["timeFromLimit"] = $sessionLimitOutputByDate["from"]["day"].".".$sessionLimitOutputByDate["from"]["month"].".".$sessionLimitOutputByDate["from"]["year"];
			$tanGroupData["timeToLimit"]   = $sessionLimitOutputByDate["to"]["day"].".".$sessionLimitOutputByDate["to"]["month"].".".$sessionLimitOutputByDate["to"]["year"];
			
			// get tangroupdata
			$groupsToTans = $securityFunctions->getGroupsToTans();
			$groupsToTansNames = $securityFunctions->getGroupsToTansNames();
			$groupsToTansIds = $securityFunctions->getGroupsToTansIds();
			$allTans	=	$securityFunctions->getTanNum();
			$usedTans	=	$securityFunctions->getUsedTanNum();
			$tanGroupData["tanNames"]	= $groupsToTansNames;
			$tanGroupData["allTans"]	= $allTans;
			$tanGroupData["usedTans"]	= $usedTans;
			//$additionalHeadersArgument = "TANS Gesamt / Verbraucht: ".$allTans." / ".$usedTans;
		}
		//
		// filled table data
		$filledTableData	=	$this->statistics->getFilledForms($projectId,$groupsToTansIds);
        if (PEAR::isError($filledTableData)) 
        {
		   echo $filledTableData->getMessage();
        }
		// get first worksheet
		//
		$newworksheetOk = $this->createSheetInProgress(&$excelWorkbook, &$filledTableData, &$headlineArray, $worksheetName,$tanGroupData);
		$worksheetInProgress = &$this->worksheetNew;
		//
		// end get first worksheet
		
		//insert question data
		//
		$actualWorksheetColumn	= $firstColumnAfterLabels;
		
		// if no results display
		if(!$filledTableData)
		{
			$worksheetInProgress->write($this->actualWorksheetRow, $actualWorksheetColumn, $lang_script["statistic.export.singlerow.inc.php"]["noresults"], $this->formatQuestion);
			$excelWorkbook->close();
			return true;
		}
		//
		
		// get groups
		$groupArray = $this->statistics->getSortedGroups($projectId);
        if (PEAR::isError($groupArray)) 
        {
		   echo $groupArray->getMessage();
        }
		
		// loop groups/questions/options an write to sheet 
		//
		for($groupsIndex = 0; $groupsIndex < count($groupArray); $groupsIndex++)
		{
			// get questions
		    $maxRow  = $this->statistics->getQuestionsInGroup($groupArray[$groupsIndex]["FORM_ID_PK"]);
	        if (PEAR::isError($maxRow)) 
	        {
			   echo $maxRow->getMessage();
	        }
		    $questionArray = $this->statistics->getSurveyQuestionsForGroup($groupArray[$groupsIndex]["FORM_ID_PK"], 0, $maxRow, "FORMTYPE_ORDER", "ASC");
	        if (PEAR::isError($questionArray)) 
	        {
			   echo $questionArray->getMessage();
	        }
			$questionsNum = count($questionArray);
			
			// loop questions
			//
			for($questionIndex = 0; $questionIndex < $questionsNum; $questionIndex++)
			{
				// make clean question
				$cleanQuestion = $questionArray[$questionIndex]["FORMTYPE_QUESTION"];
				$cleanQuestion = ereg_replace("\t"," ",$cleanQuestion);
				$cleanQuestion = ereg_replace("\r","",$cleanQuestion);
				$cleanQuestion = ereg_replace("&nbsp;"," ",$cleanQuestion);
				$cleanQuestion = stripslashes(ereg_replace("<[^>]+>", "", $cleanQuestion));
				// get options
				$optionsArray 	 = $this->statistics->getQuestionsAnswers($questionArray[$questionIndex]["FORMTYPE_ID_PK"]);
				$optionsNum		 = count($optionsArray);
				// write question
				$worksheetInProgress->write($this->actualWorksheetRow, $actualWorksheetColumn, $cleanQuestion, $this->formatQuestion);
				
				
				if($optionsNum){
				$worksheetInProgress->mergeCells($this->actualWorksheetRow,$actualWorksheetColumn,$this->actualWorksheetRow,($actualWorksheetColumn + ($optionsNum-1)));
				}
				$makeMerge++;
				
				//  go to options row
				++$this->actualWorksheetRow;
				
				// set counter for options
				$actualWorksheetOptionColumn = $actualWorksheetColumn;
				
				// check if textelement without options
				if(!$optionsNum)
				{
					$this->getSurveyExcelResultData(&$filledTableData, false, $questionArray[$questionIndex]["FORMTYPE_ID_PK"], $questionArray[$questionIndex]["FORMTYPE_TYPE"], $this->actualWorksheetRow,$actualWorksheetColumn,&$worksheetInProgress,$projectId);
				}
				// loop options
				//
				for($optionsIndex = 0; $optionsIndex < $optionsNum; $optionsIndex++)
			    {
					// make clean question
					$cleanOption	= $optionsArray[$optionsIndex]["FORMELEMENT_HEADER"].(($optionsArray[$optionsIndex]["FORMELEMENT_ADDHEADER"] != "")? ("/ ".$optionsArray[$optionsIndex]["FORMELEMENT_ADDHEADER"]) : "");
					$cleanOption	= ereg_replace("\t"," ",$cleanOption);
					$cleanOption	= ereg_replace("\r","",$cleanOption);
					$cleanOption	= ereg_replace("&nbsp;"," ",$cleanOption);
					$cleanOption    = stripslashes(ereg_replace("<[^>]+>", "", $cleanOption));
					// write option
					$worksheetInProgress->write($this->actualWorksheetRow, ($actualWorksheetOptionColumn + $optionsIndex), $cleanOption, $this->formatQuestion);
					// write results
					$this->getSurveyExcelResultData(&$filledTableData, $optionsArray[$optionsIndex]["FORMELEMENT_ID_PK"], $questionArray[$questionIndex]["FORMTYPE_ID_PK"], $questionArray[$questionIndex]["FORMTYPE_TYPE"],$this->actualWorksheetRow,($actualWorksheetOptionColumn + $optionsIndex),&$worksheetInProgress,$projectId,$groupsToTansIds);
			    }
				//
				// end loop options
				
				// set counter for total options
				$totalProcessedOptionsNum = $totalProcessedOptionsNum + $optionsNum;
				// set counter for total questions
				++$totalProcessedQuestionsNum;
				
				// if sheet full create new one
				if($totalProcessedOptionsNum > 200)
				{
					$this->actualWorksheetRow 	= 0;
					++$worksheetIndex;
					$worksheetName = $worksheetPrefix.$worksheetIndex.$lang_script["statistic.export.singlerow.inc.php"]["worksheetName"].($totalProcessedQuestionsNum +1);
					$newworksheetOk = $this->createSheetInProgress(&$excelWorkbook, &$filledTableData, &$headlineArray, $worksheetName);
					$worksheetInProgress = &$this->worksheetNew;
					$actualWorksheetColumn	= $firstColumnAfterLabels;
					$totalProcessedOptionsNum = 0;
					continue;
				}
				
				// go back to question row to do next question
				--$this->actualWorksheetRow;
				// set next column to write in
				$actualWorksheetColumn = $actualWorksheetColumn  + ($optionsNum ? $optionsNum : 1);
			}
			//
			// end loop questions
		}
		//
		// end groups/questions/options an write to sheet 
		
		// Let's send the file
		$excelWorkbook->close();
		return true;
	}
	// end function
	
	
	/**
    *	gets data for single option or text
    *
    *	@access	private
    *	@param	int	$projectId
    */
	function getSurveyExcelResultData($filledTableData, $elementId, $typeId, $type, $worksheetRow, $workSheetColumn, $worksheetToWriteTo, $projectId, $groupsToTansIds = array())
	{
		// write to next row
		++$worksheetRow;

		// create output according to type
		//
		if( ($type=="text")||($type=="textarea") )
		{
			// get text values
			$valueToShow	=	$this->statistics->getTextValuesLinkToFilledId($projectId, $typeId, '', $groupsToTansIds);
	        if (PEAR::isError($valueToShow)) 
	        {
			   echo $valueToShow->getMessage();
	        }
			// loop FILLED_ID_PK
			for($dataIndex = 0; $dataIndex < count($filledTableData); $dataIndex++)
			{
				// filled id as key from function get values
				$worksheetToWriteTo->write($worksheetRow, $workSheetColumn, $valueToShow[$filledTableData[$dataIndex]["FILLED_ID_PK"]], $this->formatEntries); // ." : ".$filledTableData[$dataIndex]["FILLED_ID_PK"]
				++$worksheetRow;
			}
			return true;
		}
		elseif ( ($type=="switchtext")||($type=="groupedtext")||($type=="texttable") )
		{
			// get text values
			$valueToShow	=	$this->statistics->getTextValuesLinkToFilledId($projectId, $typeId, $elementId, $groupsToTansIds);
	        if (PEAR::isError($valueToShow)) 
	        {
			   echo $valueToShow->getMessage();
	        }
			// loop FILLED_ID_PK
			for($dataIndex = 0; $dataIndex < count($filledTableData); $dataIndex++)
			{
				// filled id as key from function get values
				$worksheetToWriteTo->write($worksheetRow, $workSheetColumn, $valueToShow[$filledTableData[$dataIndex]["FILLED_ID_PK"]], $this->formatEntries); // ." : ".$filledTableData[$dataIndex]["FILLED_ID_PK"]
				++$worksheetRow;
			}
			return true;
		}
		elseif ( ($type=="radio")||($type=="checkbox")||($type=="select")||($type=="radiotable")||($type=="checkboxtable") )
		{
			// get text values
			$valueToShow	=	$this->statistics->getcheckedQuestionsLinkToFilledId($projectId, $typeId, $elementId, $groupsToTansIds);
	        if (PEAR::isError($valueToShow)) 
	        {
			   echo $valueToShow->getMessage();
	        }
			// loop FILLED_ID_PK
			for($dataIndex = 0; $dataIndex < count($filledTableData); $dataIndex++)
			{
				if($valueToShow[$filledTableData[$dataIndex]["FILLED_ID_PK"]])
				{
					$yesOrNo = '1';
				}
				else
				{
					$yesOrNo = '0';
				}
				// filled id as key from function get values
				$worksheetToWriteTo->write($worksheetRow, $workSheetColumn, $yesOrNo, $this->formatEntries);//  $valueToShow[$filledTableData[$dataIndex]["FILLED_ID_PK"]]
				++$worksheetRow;
			}
			return true;
		}
		//
		// end create output according to type  
	}
}
// end class
?>
