<?php
// +----------------------------------------------------------------------+
// | sa statistics module                                                 |
// +----------------------------------------------------------------------+
// | Copyright (c) 2002 serie a - Digitale Medien und Systeme GmbH        |
// +----------------------------------------------------------------------+
// | Authors: Jrn Allert <allert@serie-a.de>                             |
// |          Rene Renk <renk@serie-a.de>                                 |
// +----------------------------------------------------------------------+
// | Description:                                                         |
// +----------------------------------------------------------------------+
//
// $Id: statistic.inc.php,v 1.2 2007/01/06 10:22:06 easy_israel Exp $
// require all configuration files and libraries
require_once($cfgPathToProjectAdmin."/config/config.inc.php"); // common config file // common config file
require_once($cfgPathToConf."/file.inc.php"); // project files
require_once($cfgPathToSurveyFiles."/config/survey.config.inc.php"); // survey config file
require_once ("DB.php"); // PEAR::DB
@include("phpchartdir.php"); // Chart Director

/**
* statisticFunctions class
*
* Statistic Management Class
*
* @author  Jrn Allert <allert@serie-a.de>
* @author  Rene Renk <renk@serie-a.de>
* @access  public
*/
class statisticFunctions
{
    // default values
    
    /**
    *	error message
    *	@var    string  $errorMessage
    */
    var $errorMessage;
    
    /**
    *	array to store sorted groups used in recursive function
    *	@var    array  $errorMessage
    */
	var $sortedGroupsArray = array();
	
    /**
    *	array to store timelimit for output
    *	@var    array  $errorMessage
    */
	var $resultTimeLimit = array();
	
    /**
    *	constructor 
    *
    *	@access	public
    */
    function statisticFunctions()
    {
        $this->errorMessage = "";
        // connect to db
        $this->db = DB::connect(DSN, true);
        if (DB::isError($this->db)) 
        {    
           return new PEAR_Error("DB ERROR: ".$this->db->getMessage()."in".__FILE__." on line ".__LINE__);
        }
    }
    
    /**
    *	sets error message
    *
    *	@access	private
    *	@param	string	$err
    */
    function setErrorMessage($err)
    {
        $this->errorMessage = $err;
    }
    
    /**
    *	sets error message
    *
    *	@access	private
    *	@param	string	$arrayFromTo
    */
    function setResultTimeLimit($arrayFromTo)
    {
        $this->resultTimeLimit["from"] = $arrayFromTo["from"];
		// woraround for getting results inclusive day choosen -rr030926
		$this->resultTimeLimit["to"] = $arrayFromTo["to"] + 86400;
    }
	
    /**
    *	checks if a table is already created
    *
    *	@access	public
    *	@param	string  $table  name of table
    *   @return string true/false
    */
    function existsTable($table)
    {
        $tableArray = $this->db->getListOf("tables");
        if (DB::isError($test)) 
        {  
           $this->setErrorMessage($result->getMessage());
           return false; 
        }
        if ($_ENV["OS"]=="Windows_NT"){
        	if(in_array(strtolower($table), $tableArray)){
            	return true;
        	}
		} else {
			if(in_array($table, $tableArray)){
            	return true;
        	}
		}
        return false;
    }
	
    /**
    *	gets the number answers with this ids
    *
    *	@access public
    *   @param  int     $projectId  id of survey project
    *   @param  string  $answerIdString  answer ids seperated by |
    *	@return	int     number of users with this answer combination
    */
    function getAnswerNum($projectId, $answerIdString, $tanGroupIds = array())
    {
        // put values in array
        $answerIdArray = explode("|", $answerIdString);
        $answerIdArrayLength = count($answerIdArray);
        
        $wordArray = Array('A','B','C','D','E','F','G','H','I','J','K','L','M','N','O','P','Q','R','S','T','U','V','W','X','Y','Z',
            'AA','AB','AC','AD','AE','AF','AG','AH','AI','AJ','AK','AL','AM','AN','AO','AP','AQ','AR','AS','AT','AU','AV','AW','AX','AY','AZ');
        
		//result
        $table 		 = "T_SURVEY_RESULT_".$projectId;
		// filled
		$filledTable = "T_SURVEY_FILLED_".$projectId;
		// tan
		$tanTable	 = "T_SURVEY_SECURITYTAN_".$projectId;
		// group
		$groupTable	 = "T_SURVEY_TANGROUP_".$projectId;
		
		if(!$this->existsTable($filledTable))
		{
			return 0;
		}
		
        $totalNum = 0;
        
        if($answerIdArrayLength == 1)
        {
			// all
			if( (count($tanGroupIds) < 1) || $tanGroupIds[0] < -1)
			{
				$sqlAdd = "";
			}
			// defined number of groups
			elseif($tanGroupIds[0] > 0)
			{
				$sql = "select 
							$tanTable.SECURITYTAN_TAN
						from 
							$tanTable
						left join
							$groupTable 
						on
							$tanTable.SECURITYTAN_TANGROUP_ID_FK = $groupTable.TANGROUP_ID_PK
						where
							$tanTable.SECURITYTAN_TAN_USED = 'yes' 
						and	$groupTable.TANGROUP_ID_PK in (".join(", ", $tanGroupIds).")";
		        //
				$result = $this->db->query($sql);
		        if (DB::isError($result)) 
		    	{
		       	    return new PEAR_Error("DB ERROR: ".$result->getMessage()."in".__FILE__." on line ".__LINE__."with-------------$sql------------- ");
		   	 	}
				//
		        while ($row = $result->fetchRow(DB_FETCHMODE_ASSOC))
		        {
		            $tanIdArray[] = $row["SECURITYTAN_TAN"];
		        }
				// if no result give string not matching
				if(!$tanIdArray)
				{
					$tanIdArray[] = '99999999999999999999999999990000009999999999999999999999999999999999';
				}
				$sqlAdd = " and	$filledTable.FILLED_DETERMINATOR in (".join(", ", $tanIdArray).") ";
			}
			// ungrouped
			else
			{
				$sql = "select 
							$tanTable.SECURITYTAN_TAN
						from 
							$tanTable
						where
							$tanTable.SECURITYTAN_TAN_USED = 'yes' 
						and	$tanTable.SECURITYTAN_TANGROUP_ID_FK is not null";
		        //
				//echo $sql;
				$result = $this->db->query($sql);
		        if (DB::isError($result)) 
		    	{
		       	    return new PEAR_Error("DB ERROR: ".$result->getMessage()."in".__FILE__." on line ".__LINE__."with-------------$sql------------- ");
		   	 	}
				//
		        while ($row = $result->fetchRow(DB_FETCHMODE_ASSOC))
		        {
		            $tanIdArray[] = $row["SECURITYTAN_TAN"];
		        }
				// if no result give string not matching
				if(!$tanIdArray)
				{
					$tanIdArray[] = '99999999999999999999999999990000009999999999999999999999999999999999';
				}
				$sqlAdd = "and $filledTable.FILLED_DETERMINATOR not in (".join(", ", $tanIdArray).")";
			}
			
			// limitbyTime ?
			if($this->resultTimeLimit)
			{
				$sqlAdd .= " and $filledTable.FILLED_TIME >= FROM_UNIXTIME(".$this->resultTimeLimit["from"].")
						  and $filledTable.FILLED_TIME <= FROM_UNIXTIME(".$this->resultTimeLimit["to"].")";
			}
			// check if tan protected
			if($tanGroupIds)
			{
				$sql = "select 
							$table.RESULT_FILLED_ID_FK
						from 
							$table
						left join
							$filledTable
						on
							$table.RESULT_FILLED_ID_FK = $filledTable.FILLED_ID_PK
						where
							$table.RESULT_FORMELEMENT_ID = $answerIdArray[0] 
							".$sqlAdd;
			}
			else
			{
				$sql = "select 
							$table.RESULT_FILLED_ID_FK
						from 
							$table
						where
							$table.RESULT_FORMELEMENT_ID = $answerIdArray[0] 
							".$sqlAdd;
			}
        }
        
        //make self join
        elseif($answerIdArrayLength > 1)
        {
            $sql = "select $wordArray[0].RESULT_FILLED_ID_FK from $table $wordArray[0]";
            
            for($k=1;$k<$answerIdArrayLength;$k++)
            {
                $sql .= ", $table $wordArray[$k] ";
            }
            $sql .= "where ";
            for($k=1;$k<$answerIdArrayLength;$k++)
            {
                if($k>1)
                {
                    $sql .= "and ";
                }
                $sql .= "$wordArray[0].RESULT_FILLED_ID_FK = $wordArray[$k].RESULT_FILLED_ID_FK ";
            }
            for($k=0;$k<$answerIdArrayLength;$k++)
            {
                $sql .= "and $wordArray[$k].RESULT_FORMELEMENT_ID = $answerIdArray[$k] ";
            }
            $sql .= "GROUP BY $wordArray[0].RESULT_FILLED_ID_FK";
        }
        $result = $this->db->query($sql);
        if (DB::isError($result)) 
    	{
       	    return new PEAR_Error("DB ERROR: ".$result->getMessage()."in".__FILE__." on line ".__LINE__."with-------------$sql------------- ");
   	 	}
        
        $numRows = $result->numRows();
               
        return $numRows;
    }

    /**
    *	gets values for text entries and link to $filledId
    *
    *	@access public
    *   @param  int     $projectId
    *   @param  int     $questionId
    *	@return	string  encoded string
    */
    function getTextValuesLinkToFilledId($projectId, $questionId, $elementId = false , $tanGroupIds = array())
    {
		//result
        $table 		 = "T_SURVEY_RESULT_".$projectId;
		// filled
		$filledTable = "T_SURVEY_FILLED_".$projectId;
		// tan
		$tanTable	 = "T_SURVEY_SECURITYTAN_".$projectId;
		// group
		$groupTable	 = "T_SURVEY_TANGROUP_".$projectId;
		
		if(!$this->existsTable($filledTable))
		{
			return 0;
		}
		
		// create wheres for select if tangroup given
		// all
		if( (count($tanGroupIds) < 1) || $tanGroupIds[0] < -1)
		{
			$sqlAdd = "";
		}
		// defined number of groups
		elseif($tanGroupIds[0] > 0)
		{
			$sql = "select 
						$tanTable.SECURITYTAN_TAN
					from 
						$tanTable
					left join
						$groupTable 
					on
						$tanTable.SECURITYTAN_TANGROUP_ID_FK = $groupTable.TANGROUP_ID_PK
					where
						$tanTable.SECURITYTAN_TAN_USED = 'yes' 
					and	$groupTable.TANGROUP_ID_PK in (".join(", ", $tanGroupIds).")";
	        //
			$result = $this->db->query($sql);
	        if (DB::isError($result)) 
	    	{
	       	    return new PEAR_Error("DB ERROR: ".$result->getMessage()."in".__FILE__." on line ".__LINE__."with-------------$sql------------- ");
	   	 	}
			//
	        while ($row = $result->fetchRow(DB_FETCHMODE_ASSOC))
	        {
	            $tanIdArray[] = $row["SECURITYTAN_TAN"];
	        }
			// if no result give string not matching
			if(!$tanIdArray)
			{
				$tanIdArray[] = '99999999999999999999999999990000009999999999999999999999999999999999';
			}
			$sqlAdd = "and $filledTable.FILLED_DETERMINATOR in (".join(", ", $tanIdArray).")";
		}
		// ungrouped
		else
		{
			$sql = "select 
						$tanTable.SECURITYTAN_TAN
					from 
						$tanTable
					where
						$tanTable.SECURITYTAN_TAN_USED = 'yes' 
					and	$tanTable.SECURITYTAN_TANGROUP_ID_FK is not null";
	        //
			//echo $sql;
			$result = $this->db->query($sql);
	        if (DB::isError($result)) 
	    	{
	       	    return new PEAR_Error("DB ERROR: ".$result->getMessage()."in".__FILE__." on line ".__LINE__."with-------------$sql------------- ");
	   	 	}
			//
	        while ($row = $result->fetchRow(DB_FETCHMODE_ASSOC))
	        {
	            $tanIdArray[] = $row["SECURITYTAN_TAN"];
	        }
			// if no result give string not matching
			if(!$tanIdArray)
			{
				$tanIdArray[] = '99999999999999999999999999990000009999999999999999999999999999999999';
			}
			$sqlAdd = "and $filledTable.FILLED_DETERMINATOR not in (".join(", ", $tanIdArray).")";
		}
		// limitbyTime ?
		if($this->resultTimeLimit)
		{
			$sqlAdd .= " and $filledTable.FILLED_TIME >= FROM_UNIXTIME(".$this->resultTimeLimit["from"].")
					  and $filledTable.FILLED_TIME <= FROM_UNIXTIME(".$this->resultTimeLimit["to"].")";
		}

		if(!$elementId)
		{
	        //$sql = "select RESULT_MULTIPLEVALUE, RESULT_FILLED_ID_FK  from $table 
	        //    where RESULT_FORMTYPE_ID = $questionId"; 
	        $sql = "select 
						$table.RESULT_MULTIPLEVALUE, $table.RESULT_FILLED_ID_FK  
					from 
						$table 
					left join
						$filledTable
					on
						$table.RESULT_FILLED_ID_FK = $filledTable.FILLED_ID_PK
	            	where 1 = 1
					".$sqlAdd." 
					and $table.RESULT_FORMTYPE_ID = $questionId "; 
        }
		else
		{
	        //$sql = "select RESULT_MULTIPLEVALUE, RESULT_FILLED_ID_FK, RESULT_FORMELEMENT_ID from $table 
	        //    where RESULT_FORMTYPE_ID = $questionId 
			//	 and RESULT_FORMELEMENT_ID = $elementId"; 
	        $sql = "select 
						$table.RESULT_MULTIPLEVALUE, 
						$table.RESULT_FILLED_ID_FK, 
						$table.RESULT_FORMELEMENT_ID 
					from 
						$table 
					left join
						$filledTable
					on
						$table.RESULT_FILLED_ID_FK = $filledTable.FILLED_ID_PK
	            	where 1 = 1
					".$sqlAdd." 
					and	$table.RESULT_FORMTYPE_ID = $questionId 
					and	$table.RESULT_FORMELEMENT_ID = $elementId"; 
		}
		
		$result = $this->db->query($sql);
        if (DB::isError($result)) 
        {
            return new PEAR_Error("DB ERROR: ".$result->getMessage()."in".__FILE__." on line ".__LINE__."with-------------$sql------------- ");
        }
        while ($row = $result->fetchRow(DB_FETCHMODE_ASSOC))
        {
            if(!$elementId)
			{
				$textValueArray[$row["RESULT_FILLED_ID_FK"]] = $row["RESULT_MULTIPLEVALUE"];
			}
			else
			{
				$textValueArray[$row["RESULT_FILLED_ID_FK"]] = $row["RESULT_MULTIPLEVALUE"];
			}
        }
		return $textValueArray;
    }

    /**
    *	gets values for text entries
    *
    *	@access public
    *   @param  int     $projectId
    *   @param  int     $questionId
    *	@return	string  encoded string
    */
    function getTextValues($projectId, $questionId, $tanGroupIds = array())
    {
		//result
        $table 		 = "T_SURVEY_RESULT_".$projectId;
		// filled
		$filledTable = "T_SURVEY_FILLED_".$projectId;
		// tan
		$tanTable	 = "T_SURVEY_SECURITYTAN_".$projectId;
		// group
		$groupTable	 = "T_SURVEY_TANGROUP_".$projectId;
		
		if(!$this->existsTable($filledTable))
		{
			return 0;
		}
		
		// create wheres for select if tangroup given
		// all
		if( (count($tanGroupIds) < 1) || $tanGroupIds[0] < -1)
		{
			$sqlAdd = "";
		}
		// defined number of groups
		elseif($tanGroupIds[0] > 0)
		{
			$sql = "select 
						$tanTable.SECURITYTAN_TAN
					from 
						$tanTable
					left join
						$groupTable 
					on
						$tanTable.SECURITYTAN_TANGROUP_ID_FK = $groupTable.TANGROUP_ID_PK
					where
						$tanTable.SECURITYTAN_TAN_USED = 'yes' 
					and	$groupTable.TANGROUP_ID_PK in (".join(", ", $tanGroupIds).")";
	        //
			$result = $this->db->query($sql);
	        if (DB::isError($result)) 
	    	{
	       	    return new PEAR_Error("DB ERROR: ".$result->getMessage()."in".__FILE__." on line ".__LINE__."with-------------$sql------------- ");
	   	 	}
			//
	        while ($row = $result->fetchRow(DB_FETCHMODE_ASSOC))
	        {
	            $tanIdArray[] = $row["SECURITYTAN_TAN"];
	        }
			// if no result give string not matching
			if(!$tanIdArray)
			{
				$tanIdArray[] = '99999999999999999999999999990000009999999999999999999999999999999999';
			}
			$sqlAdd = "and $filledTable.FILLED_DETERMINATOR in (".join(", ", $tanIdArray).")";
		}
		// ungrouped
		else
		{
			$sql = "select 
						$tanTable.SECURITYTAN_TAN
					from 
						$tanTable
					where
						$tanTable.SECURITYTAN_TAN_USED = 'yes' 
					and	$tanTable.SECURITYTAN_TANGROUP_ID_FK is not null";
	        //
			//echo $sql;
			$result = $this->db->query($sql);
	        if (DB::isError($result)) 
	    	{
	       	    return new PEAR_Error("DB ERROR: ".$result->getMessage()."in".__FILE__." on line ".__LINE__."with-------------$sql------------- ");
	   	 	}
			//
	        while ($row = $result->fetchRow(DB_FETCHMODE_ASSOC))
	        {
	            $tanIdArray[] = $row["SECURITYTAN_TAN"];
	        }
			// if no result give string not matching
			if(!$tanIdArray)
			{
				$tanIdArray[] = '99999999999999999999999999990000009999999999999999999999999999999999';
			}
			$sqlAdd = "and $filledTable.FILLED_DETERMINATOR not in (".join(", ", $tanIdArray).")";
		}

		// limitbyTime ?
		if($this->resultTimeLimit)
		{
			$sqlAdd .= " and $filledTable.FILLED_TIME >= FROM_UNIXTIME(".$this->resultTimeLimit["from"].")
					     and $filledTable.FILLED_TIME <= FROM_UNIXTIME(".$this->resultTimeLimit["to"].")";
		}

		// check if tan protected
        $sql = "select 
					$table.RESULT_MULTIPLEVALUE, $table.RESULT_FORMELEMENT_ID, $table.RESULT_FILLED_ID_FK  
				from 
					$table 
				left join
					$filledTable
				on
					$table.RESULT_FILLED_ID_FK = $filledTable.FILLED_ID_PK
            	where 1 = 1
				".$sqlAdd." 
				and	$table.RESULT_FORMTYPE_ID = $questionId 
            	order by 
					$table.RESULT_FILLED_ID_FK ASC, $table.RESULT_ID_PK ASC"; 
		
		$result = $this->db->query($sql);
        if (DB::isError($result)) 
        {
            return new PEAR_Error("DB ERROR: ".$result->getMessage()."in".__FILE__." on line ".__LINE__."with-------------$sql------------- ");
        }
        while ($row = $result->fetchRow(DB_FETCHMODE_ASSOC))
        {
            $textValueArray[] = $row;
        }
		//print_r($textValueArray);
		return $textValueArray;
    }
	
    /**
    *	gets values for text entries grouped by options and results
    *
    *	@access public
    *   @param  int     $projectId
    *   @param  int     $questionId
    *	@return	string  encoded string
    */
    function getTextValuesGrouped($projectId, $optionId = 0, $questionId = 0, $tanGroupIds = array())
    {
		//result
        $table 		 = "T_SURVEY_RESULT_".$projectId;
		// filled
		$filledTable = "T_SURVEY_FILLED_".$projectId;
		// tan
		$tanTable	 = "T_SURVEY_SECURITYTAN_".$projectId;
		// group
		$groupTable	 = "T_SURVEY_TANGROUP_".$projectId;
			
		if(!$this->existsTable($filledTable))
		{
			return 0;
		}
		
		// create wheres for select if tangroup given
		// all
		if( (count($tanGroupIds) < 1) || $tanGroupIds[0] < -1)
		{
			$sqlAdd = "";
		}
		// defined number of groups
		elseif($tanGroupIds[0] > 0)
		{
			$sql = "select 
						$tanTable.SECURITYTAN_TAN
					from 
						$tanTable
					left join
						$groupTable 
					on
						$tanTable.SECURITYTAN_TANGROUP_ID_FK = $groupTable.TANGROUP_ID_PK
					where
						$tanTable.SECURITYTAN_TAN_USED = 'yes' 
					and	$groupTable.TANGROUP_ID_PK in (".join(", ", $tanGroupIds).")";
	        //
			$result = $this->db->query($sql);
	        if (DB::isError($result)) 
	    	{
	       	    return new PEAR_Error("DB ERROR: ".$result->getMessage()."in".__FILE__." on line ".__LINE__."with-------------$sql------------- ");
	   	 	}
			//
	        while ($row = $result->fetchRow(DB_FETCHMODE_ASSOC))
	        {
	            $tanIdArray[] = $row["SECURITYTAN_TAN"];
	        }
			// if no result give string not matching
			if(!$tanIdArray)
			{
				$tanIdArray[] = '99999999999999999999999999990000009999999999999999999999999999999999';
			}
			$sqlAdd = "and $filledTable.FILLED_DETERMINATOR in (".join(", ", $tanIdArray).")";
		}
		// ungrouped
		else
		{
			$sql = "select 
						$tanTable.SECURITYTAN_TAN
					from 
						$tanTable
					where
						$tanTable.SECURITYTAN_TAN_USED = 'yes' 
					and	$tanTable.SECURITYTAN_TANGROUP_ID_FK is not null";
	        //
			//echo $sql;
			$result = $this->db->query($sql);
	        if (DB::isError($result)) 
	    	{
	       	    return new PEAR_Error("DB ERROR: ".$result->getMessage()."in".__FILE__." on line ".__LINE__."with-------------$sql------------- ");
	   	 	}
			//
	        while ($row = $result->fetchRow(DB_FETCHMODE_ASSOC))
	        {
	            $tanIdArray[] = $row["SECURITYTAN_TAN"];
	        }
			// if no result give string not matching
			if(!$tanIdArray)
			{
				$tanIdArray[] = '99999999999999999999999999990000009999999999999999999999999999999999';
			}
			$sqlAdd = "and $filledTable.FILLED_DETERMINATOR not in (".join(", ", $tanIdArray).")";
		}
		
		// limitbyTime ?
		if($this->resultTimeLimit)
		{
			$sqlAdd .= " and $filledTable.FILLED_TIME >= FROM_UNIXTIME(".$this->resultTimeLimit["from"].")
					     and $filledTable.FILLED_TIME <= FROM_UNIXTIME(".$this->resultTimeLimit["to"].")";
		}
		
        // Keine Elemente
	    if(!$optionId)
		{
        $sql = "select 
					count(*) as num, 
					RESULT_MULTIPLEVALUE 
				from 
					$table 
				left join
					$filledTable
				on
					$table.RESULT_FILLED_ID_FK = $filledTable.FILLED_ID_PK
            	where 1 = 1
				and	RESULT_FORMTYPE_ID = $questionId 
				".$sqlAdd." 
            	group by 
					RESULT_MULTIPLEVALUE 
				order by 
					num DESC"; // group by RESULT_MULTIPLEVALUE //count(*) as num, 
		}
		else
		{
        $sql = "select 
					count(*) as num, 
					RESULT_MULTIPLEVALUE 
				from 
					$table 
				left join
					$filledTable
				on
					$table.RESULT_FILLED_ID_FK = $filledTable.FILLED_ID_PK
            	where 1 = 1
				and	RESULT_FORMELEMENT_ID = $optionId 
				".$sqlAdd." 
            	group by 
					RESULT_MULTIPLEVALUE 
				order by 
					num DESC"; // group by RESULT_MULTIPLEVALUE //count(*) as num, 
		}
		//echo "<br>".$sql."<br>";
		$result = $this->db->query($sql);
        if (DB::isError($result)) 
        {
            return new PEAR_Error("DB ERROR: ".$result->getMessage()."in".__FILE__." on line ".__LINE__."with-------------$sql------------- ");
        }
        while ($row = $result->fetchRow(DB_FETCHMODE_ASSOC))
        {
            $totalOptionAnswers = $totalOptionAnswers + ($row["num"]*intval($row["RESULT_MULTIPLEVALUE"]));
			$row["TOTALBYNOW"] = $totalOptionAnswers;
			$textValueArray[] = $row;
        }
		//print_r($textValueArray);
		return $textValueArray;
    }
	
    /**
    *	gets metadata as overview
    *
    *	@access public
    *   @param  int     $projectId
    *   @param  int     $questionId
    *	@return	string  encoded string
    */
    function getMetaValues($projectId, $columnsToFetch, $tanGroupIds = array())
    {
		// filled
		$filledTable = "T_SURVEY_FILLED_".$projectId;
		// tan
		$tanTable	 = "T_SURVEY_SECURITYTAN_".$projectId;
		// group
		$groupTable	 = "T_SURVEY_TANGROUP_".$projectId;

		if(!$this->existsTable($filledTable))
		{
			return 0;
		}
		
		// create wheres for select if tangroup given
		// all
		if( (count($tanGroupIds) < 1) || $tanGroupIds[0] < -1)
		{
			$sqlAdd = "";
		}
		// defined number of groups
		elseif($tanGroupIds[0] > 0)
		{
			$sql = "select 
						$tanTable.SECURITYTAN_TAN
					from 
						$tanTable
					left join
						$groupTable 
					on
						$tanTable.SECURITYTAN_TANGROUP_ID_FK = $groupTable.TANGROUP_ID_PK
					where
						$tanTable.SECURITYTAN_TAN_USED = 'yes' 
					and	$groupTable.TANGROUP_ID_PK in (".join(", ", $tanGroupIds).")";
	        //
			$result = $this->db->query($sql);
	        if (DB::isError($result)) 
	    	{
	       	    return new PEAR_Error("DB ERROR: ".$result->getMessage()."in".__FILE__." on line ".__LINE__."with-------------$sql------------- ");
	   	 	}
			//
	        while ($row = $result->fetchRow(DB_FETCHMODE_ASSOC))
	        {
	            $tanIdArray[] = $row["SECURITYTAN_TAN"];
	        }
			// if no result give string not matching
			if(!$tanIdArray)
			{
				$tanIdArray[] = '99999999999999999999999999990000009999999999999999999999999999999999';
			}
			$sqlAdd = "and FILLED_DETERMINATOR in (".join(", ", $tanIdArray).")";
		}
		// ungrouped
		else
		{
			$sql = "select 
						$tanTable.SECURITYTAN_TAN
					from 
						$tanTable
					where
						$tanTable.SECURITYTAN_TAN_USED = 'yes' 
					and	$tanTable.SECURITYTAN_TANGROUP_ID_FK is not null";
	        //
			//echo $sql;
			$result = $this->db->query($sql);
	        if (DB::isError($result)) 
	    	{
	       	    return new PEAR_Error("DB ERROR: ".$result->getMessage()."in".__FILE__." on line ".__LINE__."with-------------$sql------------- ");
	   	 	}
			//
	        while ($row = $result->fetchRow(DB_FETCHMODE_ASSOC))
	        {
	            $tanIdArray[] = $row["SECURITYTAN_TAN"];
	        }
			// if no result give string not matching
			if(!$tanIdArray)
			{
				$tanIdArray[] = '99999999999999999999999999990000009999999999999999999999999999999999';
			}
			$sqlAdd = "and $filledTable.FILLED_DETERMINATOR not in (".join(", ", $tanIdArray).")";
		}

		// limitbyTime ?
		if($this->resultTimeLimit)
		{
			$sqlAdd .= " and $filledTable.FILLED_TIME >= FROM_UNIXTIME(".$this->resultTimeLimit["from"].")
					     and $filledTable.FILLED_TIME <= FROM_UNIXTIME(".$this->resultTimeLimit["to"].")";
		}
		
		// get values for metadatasheet
		foreach($columnsToFetch as $column => $comment)
		{
			$sql = "select 
					$column, count(*) as num 
					from 
						$filledTable
					where 1 = 1 
					".$sqlAdd." 
					group by 
						$column 
	            	order by
						 num DESC";
	        $result = $this->db->query($sql);
			if (DB::isError($result)) 
	        {
	            return new PEAR_Error("DB ERROR: ".$result->getMessage()."in".__FILE__." on line ".__LINE__."with-------------$sql------------- ");
	        }
	        while ($row = $result->fetchRow(DB_FETCHMODE_ASSOC))
	        {
	            $metaValueArray["$column"][] = $row;
	        }
		}
		//
		return $metaValueArray;
    }
	
    /**
    *	gets value for every checked qustion
    *
    *	@access public
    *   @param  int     $projectId
    *   @param  int     $questionId
    *	@return	string  encoded string
    */
    function getcheckedQuestionsLinkToFilledId($projectId, $questionId, $elementId,$tanGroupIds = array())
    {
		//result
        $table 		 = "T_SURVEY_RESULT_".$projectId;
		// filled
		$filledTable = "T_SURVEY_FILLED_".$projectId;
		// tan
		$tanTable	 = "T_SURVEY_SECURITYTAN_".$projectId;
		// group
		$groupTable	 = "T_SURVEY_TANGROUP_".$projectId;
		
		if(!$this->existsTable($filledTable))
		{
			return 0;
		}
		
		// create wheres for select if tangroup given
		// all
		if( (count($tanGroupIds) < 1) || $tanGroupIds[0] < -1)
		{
			$sqlAdd = "";
		}
		// defined number of groups
		elseif($tanGroupIds[0] > 0)
		{
			$sql = "select 
						$tanTable.SECURITYTAN_TAN
					from 
						$tanTable
					left join
						$groupTable 
					on
						$tanTable.SECURITYTAN_TANGROUP_ID_FK = $groupTable.TANGROUP_ID_PK
					where
						$tanTable.SECURITYTAN_TAN_USED = 'yes' 
					and	$groupTable.TANGROUP_ID_PK in (".join(", ", $tanGroupIds).")";
	        //
			$result = $this->db->query($sql);
	        if (DB::isError($result)) 
	    	{
	       	    return new PEAR_Error("DB ERROR: ".$result->getMessage()."in".__FILE__." on line ".__LINE__."with-------------$sql------------- ");
	   	 	}
			//
	        while ($row = $result->fetchRow(DB_FETCHMODE_ASSOC))
	        {
	            $tanIdArray[] = $row["SECURITYTAN_TAN"];
	        }
			// if no result give string not matching
			if(!$tanIdArray)
			{
				$tanIdArray[] = '99999999999999999999999999990000009999999999999999999999999999999999';
			}
			$sqlAdd = "and $filledTable.FILLED_DETERMINATOR in (".join(", ", $tanIdArray).")";
		}
		// ungrouped
		else
		{
			$sql = "select 
						$tanTable.SECURITYTAN_TAN
					from 
						$tanTable
					where
						$tanTable.SECURITYTAN_TAN_USED = 'yes' 
					and	$tanTable.SECURITYTAN_TANGROUP_ID_FK is not null";
	        //
			//echo $sql;
			$result = $this->db->query($sql);
	        if (DB::isError($result)) 
	    	{
	       	    return new PEAR_Error("DB ERROR: ".$result->getMessage()."in".__FILE__." on line ".__LINE__."with-------------$sql------------- ");
	   	 	}
			//
	        while ($row = $result->fetchRow(DB_FETCHMODE_ASSOC))
	        {
	            $tanIdArray[] = $row["SECURITYTAN_TAN"];
	        }
			// if no result give string not matching
			if(!$tanIdArray)
			{
				$tanIdArray[] = '99999999999999999999999999990000009999999999999999999999999999999999';
			}
			$sqlAdd = "and $filledTable.FILLED_DETERMINATOR not in (".join(", ", $tanIdArray).")";
		}
		
		// limitbyTime ?
		if($this->resultTimeLimit)
		{
			$sqlAdd .= " and $filledTable.FILLED_TIME >= FROM_UNIXTIME(".$this->resultTimeLimit["from"].")
					     and $filledTable.FILLED_TIME <= FROM_UNIXTIME(".$this->resultTimeLimit["to"].")";
		}
		// check if tan secured
        $sql = "select 
					$table.RESULT_MULTIPLEVALUE, 
					$table.RESULT_FILLED_ID_FK, 
					$table.RESULT_FORMELEMENT_ID 
				from 
					$table 
				left join
					$filledTable
				on
					$table.RESULT_FILLED_ID_FK = $filledTable.FILLED_ID_PK
            	where 1 = 1
				".$sqlAdd." 
				and	$table.RESULT_FORMTYPE_ID = $questionId 
				and	$table.RESULT_FORMELEMENT_ID = $elementId"; 
		
		$result = $this->db->query($sql);
        if (DB::isError($result)) 
        {
            return new PEAR_Error("DB ERROR: ".$result->getMessage()."in".__FILE__." on line ".__LINE__."with-------------$sql------------- ");
        }
        while ($row = $result->fetchRow(DB_FETCHMODE_ASSOC))
        {
			$textValueArray[$row["RESULT_FILLED_ID_FK"]] = $row["RESULT_FORMELEMENT_ID"];
        }
		return $textValueArray;
    }
	
    /**
    *	gets values for text entries
    *
    *	@access public
    *   @param  int     $projectId
    *   @param  int     $questionId
    *	@return	string  encoded string
    */
    function getTextValuesNum($projectId, $questionId, $tanGroupIds = array())
    {
		//result
        $table 		 = "T_SURVEY_RESULT_".$projectId;
		// filled
		$filledTable = "T_SURVEY_FILLED_".$projectId;
		// tan
		$tanTable	 = "T_SURVEY_SECURITYTAN_".$projectId;
		// group
		$groupTable	 = "T_SURVEY_TANGROUP_".$projectId;
		
		if(!$this->existsTable($filledTable))
		{
			return 0;
		}
		
		// all
		if( (count($tanGroupIds) < 1) || $tanGroupIds[0] < -1)
		{
			$sqlAdd = " ";
		}
		// defined number of groups
		elseif($tanGroupIds[0] > 0)
		{
			$sql = "select 
						$tanTable.SECURITYTAN_TAN
					from 
						$tanTable
					left join
						$groupTable 
					on
						$tanTable.SECURITYTAN_TANGROUP_ID_FK = $groupTable.TANGROUP_ID_PK
					where
						$tanTable.SECURITYTAN_TAN_USED = 'yes' 
					and	$groupTable.TANGROUP_ID_PK in (".join(", ", $tanGroupIds).")";
	        //
			$result = $this->db->query($sql);
	        if (DB::isError($result)) 
	    	{
	       	    return new PEAR_Error("DB ERROR: ".$result->getMessage()."in".__FILE__." on line ".__LINE__."with-------------$sql------------- ");
	   	 	}
			//
	        while ($row = $result->fetchRow(DB_FETCHMODE_ASSOC))
	        {
	            $tanIdArray[] = $row["SECURITYTAN_TAN"];
	        }
			// if no result give string not matching
			if(!$tanIdArray)
			{
				$tanIdArray[] = '99999999999999999999999999990000009999999999999999999999999999999999';
			}
			$sqlAdd = " and	$filledTable.FILLED_DETERMINATOR in (".join(", ", $tanIdArray).") ";
		}
		// ungrouped
		else
		{
			$sql = "select 
						$tanTable.SECURITYTAN_TAN
					from 
						$tanTable
					where
						$tanTable.SECURITYTAN_TAN_USED = 'yes' 
					and	$tanTable.SECURITYTAN_TANGROUP_ID_FK is not null";
	        //
			//echo $sql;
			$result = $this->db->query($sql);
	        if (DB::isError($result)) 
	    	{
	       	    return new PEAR_Error("DB ERROR: ".$result->getMessage()."in".__FILE__." on line ".__LINE__."with-------------$sql------------- ");
	   	 	}
			//
	        while ($row = $result->fetchRow(DB_FETCHMODE_ASSOC))
	        {
	            $tanIdArray[] = $row["SECURITYTAN_TAN"];
	        }
			// if no result give string not matching
			if(!$tanIdArray)
			{
				$tanIdArray[] = '99999999999999999999999999990000009999999999999999999999999999999999';
			}
			$sqlAdd = "and $filledTable.FILLED_DETERMINATOR not in (".join(", ", $tanIdArray).")";
		}
		
		// limitbyTime ?
		if($this->resultTimeLimit)
		{
			$sqlAdd .= " and $filledTable.FILLED_TIME >= FROM_UNIXTIME(".$this->resultTimeLimit["from"].")
					     and $filledTable.FILLED_TIME <= FROM_UNIXTIME(".$this->resultTimeLimit["to"].")";
		}
		
        $sql = "select 
					$table.RESULT_FILLED_ID_FK 
				from 
					$table 
				left join
					$filledTable
				on
					$table.RESULT_FILLED_ID_FK = $filledTable.FILLED_ID_PK
            	where 1 = 1
				".$sqlAdd." 
				and	$table.RESULT_FORMTYPE_ID = $questionId "; 

		$result = $this->db->query($sql);
        if (DB::isError($result)) 
        {
            return new PEAR_Error("DB ERROR: ".$result->getMessage()."in".__FILE__." on line ".__LINE__."with-------------$sql------------- ");
        }
        $numRows = $result->numRows();
		return $numRows;
    }
	
    /**
    *	gets values for filled forms
    *
    *	@access public
    *   @param  int     $projectId
    *	@return	array   filled form data
    */
    function getFilledForms($projectId, $tanGroupIds = array())
    {
		// filled
		$filledTable = "T_SURVEY_FILLED_".$projectId;
		// tan
		$tanTable	 = "T_SURVEY_SECURITYTAN_".$projectId;
		// group
		$groupTable	 = "T_SURVEY_TANGROUP_".$projectId;
		
		if(!$this->existsTable($filledTable))
		{
			return 0;
		}
		
		// create wheres for select if tangroup given
		// all
		if( (count($tanGroupIds) < 1) || $tanGroupIds[0] < -1)
		{
			$sqlAdd = "";
		}
		// defined number of groups
		elseif($tanGroupIds[0] > 0)
		{
			$sql = "select 
						$tanTable.SECURITYTAN_TAN
					from 
						$tanTable
					left join
						$groupTable 
					on
						$tanTable.SECURITYTAN_TANGROUP_ID_FK = $groupTable.TANGROUP_ID_PK
					where
						$tanTable.SECURITYTAN_TAN_USED = 'yes' 
					and	$groupTable.TANGROUP_ID_PK in (".join(", ", $tanGroupIds).")";
	        //
			$result = $this->db->query($sql);
	        if (DB::isError($result)) 
	    	{
	       	    return new PEAR_Error("DB ERROR: ".$result->getMessage()."in".__FILE__." on line ".__LINE__."with-------------$sql------------- ");
	   	 	}
			//
	        while ($row = $result->fetchRow(DB_FETCHMODE_ASSOC))
	        {
	            $tanIdArray[] = $row["SECURITYTAN_TAN"];
	        }
			// if no result give string not matching
			if(!$tanIdArray)
			{
				$tanIdArray[] = '99999999999999999999999999990000009999999999999999999999999999999999';
			}
			$sqlAdd = "and $filledTable.FILLED_DETERMINATOR in (".join(", ", $tanIdArray).")";
		}
		// ungrouped
		else
		{
			$sql = "select 
						$tanTable.SECURITYTAN_TAN
					from 
						$tanTable
					where
						$tanTable.SECURITYTAN_TAN_USED = 'yes' 
					and	$tanTable.SECURITYTAN_TANGROUP_ID_FK is not null";
	        //
			$result = $this->db->query($sql);
	        if (DB::isError($result)) 
	    	{
	       	    return new PEAR_Error("DB ERROR: ".$result->getMessage()."in".__FILE__." on line ".__LINE__."with-------------$sql------------- ");
	   	 	}
			//
	        while ($row = $result->fetchRow(DB_FETCHMODE_ASSOC))
	        {
	            $tanIdArray[] = $row["SECURITYTAN_TAN"];
	        }
			// if no result give string not matching
			if(!$tanIdArray)
			{
				$tanIdArray[] = '99999999999999999999999999990000009999999999999999999999999999999999';
			}
			$sqlAdd = "and $filledTable.FILLED_DETERMINATOR not in (".join(", ", $tanIdArray).")";
		}
		
		// limitbyTime ?
		if($this->resultTimeLimit)
		{
			$sqlAdd .= " and $filledTable.FILLED_TIME >= FROM_UNIXTIME(".$this->resultTimeLimit["from"].")
					     and $filledTable.FILLED_TIME <= FROM_UNIXTIME(".$this->resultTimeLimit["to"].")";
		}
		// check if tan secured
		if($tanGroupIds)
		{
	        $sql = "select 
						* 
					from 
						$filledTable 
					left join 
						$tanTable 
					on $filledTable.FILLED_DETERMINATOR = $tanTable.SECURITYTAN_TAN 
					where 1 = 1
					".$sqlAdd."
					order by 
						$filledTable.FILLED_ID_PK ASC"; 
        }
		else
		{
	        $sql = "select 
						* 
					from 
						$filledTable 
					where 1 = 1
					".$sqlAdd."
					order by 
						$filledTable.FILLED_ID_PK ASC"; 
		}
		$result = $this->db->query($sql);
        if (DB::isError($result)) 
        {
            return new PEAR_Error("DB ERROR: ".$result->getMessage()."in".__FILE__." on line ".__LINE__."with-------------$sql------------- ");
        }
        while ($row = $result->fetchRow(DB_FETCHMODE_ASSOC))
        {
            $filledValueArray[] = $row;
        }
		return $filledValueArray;
    }

    /**
    *	gets number of users who participates on the survey
    *
    *	@access public
    *   @param  int     $projectId
    *	@return	string  encoded string
    */
    function getUserNum($projectId, $tanGroupIds = array())
    {
        global $cfgSrvyTabFilled;
        
        $filledTable = $cfgSrvyTabFilled.$projectId;
		
		if(!$this->existsTable($filledTable))
		{
			return 0;
		}
		
		// tan
		$tanTable	 = "T_SURVEY_SECURITYTAN_".$projectId;
		// group
		$groupTable	 = "T_SURVEY_TANGROUP_".$projectId;
		
		// all
		if( (count($tanGroupIds) < 1) || $tanGroupIds[0] < -1)
		{
			$sqlAdd = "";
		}
		// defined number of groups
		elseif($tanGroupIds[0] > 0)
		{
			$sql = "select 
						$tanTable.SECURITYTAN_TAN
					from 
						$tanTable
					left join
						$groupTable 
					on
						$tanTable.SECURITYTAN_TANGROUP_ID_FK = $groupTable.TANGROUP_ID_PK
					where
						$tanTable.SECURITYTAN_TAN_USED = 'yes' 
					and	$groupTable.TANGROUP_ID_PK in (".join(", ", $tanGroupIds).")";
	        //
			$result = $this->db->query($sql);
	        if (DB::isError($result)) 
	    	{
	       	    return new PEAR_Error("DB ERROR: ".$result->getMessage()."in".__FILE__." on line ".__LINE__."with-------------$sql------------- ");
	   	 	}
			//
	        while ($row = $result->fetchRow(DB_FETCHMODE_ASSOC))
	        {
	            $tanIdArray[] = $row["SECURITYTAN_TAN"];
	        }
			// if no result give string not matching
			if(!$tanIdArray)
			{
				$tanIdArray[] = '99999999999999999999999999990000009999999999999999999999999999999999';
			}
			$sqlAdd = "and $filledTable.FILLED_DETERMINATOR in (".join(", ", $tanIdArray).")";
		}
		// ungrouped
		else
		{
			$sql = "select 
						$tanTable.SECURITYTAN_TAN
					from 
						$tanTable
					where
						$tanTable.SECURITYTAN_TAN_USED = 'yes' 
					and	$tanTable.SECURITYTAN_TANGROUP_ID_FK is not null";
	        //
			//echo $sql;
			$result = $this->db->query($sql);
	        if (DB::isError($result)) 
	    	{
	       	    return new PEAR_Error("DB ERROR: ".$result->getMessage()."in".__FILE__." on line ".__LINE__."with-------------$sql------------- ");
	   	 	}
			//
	        while ($row = $result->fetchRow(DB_FETCHMODE_ASSOC))
	        {
	            $tanIdArray[] = $row["SECURITYTAN_TAN"];
	        }
			// if no result give string not matching
			if(!$tanIdArray)
			{
				$tanIdArray[] = '99999999999999999999999999990000009999999999999999999999999999999999';
			}
			$sqlAdd = "and $filledTable.FILLED_DETERMINATOR not in (".join(", ", $tanIdArray).")";
		}
		
		// limitbyTime ?
		if($this->resultTimeLimit)
		{
			$sqlAdd .= " and $filledTable.FILLED_TIME >= FROM_UNIXTIME(".$this->resultTimeLimit["from"].")
					     and $filledTable.FILLED_TIME <= FROM_UNIXTIME(".$this->resultTimeLimit["to"].")";
		}
		
		$sql = "select 
					1 
				from 
					$filledTable
				where 1 = 1 ".$sqlAdd;
				
        $result = $this->db->query($sql);
        if (DB::isError($result)) 
    	{
       	    return new PEAR_Error("DB ERROR: ".$result->getMessage()."in".__FILE__." on line ".__LINE__."with-------------$sql------------- ");
   	 	}
        $numRows = $result->numRows();
        
        return ($numRows)? $numRows : '0';
    }
    
    /**
    *	encodes german special charts for chart director
    *
    *	@access public
    *   @param  string  string
    *	@return	string encoded string
    */
    function encodeSpecialChars($string)
    {
        $string = preg_replace("//","ae",$string);
        $string = preg_replace("//","Ae",$string);
        $string = preg_replace("//","ue",$string);
        $string = preg_replace("//","Ue",$string);
        $string = preg_replace("//","oe",$string);
        $string = preg_replace("//","Oe",$string);
        $string = preg_replace("//","ss",$string);
        
        return $string;
    }
    
	
	/// from survey-inc
	
	/**
    *	get alls groups in a survey
    *
    *	@access	public
    *	@param	$projectId  survey project id
    *   @return array       array with group info
    */
	function getGroupsForSurvey($projectId)
    {
		global $cfgSrvyTabForms;
		
		// select all groups for this survey
		$sql = "select * 
			from $cfgSrvyTabForms
			where FORM_PROJECT_ID_FK = '$projectId' 
			order by FORM_ORDER";
		//
		$result = $this->db->query($sql);
		if (DB::isError($result)) 
        {
           return new PEAR_Error("DB ERROR: ".$result->getMessage()."in".__FILE__." on line ".__LINE__."with-------------$sql------------- ");
        }
		while ($row = $result->fetchRow(DB_FETCHMODE_ASSOC))
        {
            $getGroupsForSurvey[] = $row;
        }
		return $getGroupsForSurvey;
	}
	
	/**
    *	get alls groups in a survey with same parentId
    *
    *	@access	public
    *	@param	$projectId  survey project id
    *   @return array       array with group info
    */
	function getGroupsForSurveyWithParent($projectId, $parentId)
    {
		global $cfgSrvyTabForms;
		
		// select all groups for this survey
		$sql = "select * 
			from $cfgSrvyTabForms
			where FORM_PROJECT_ID_FK = '$projectId' 
			and FORM_PARENT_ID = '$parentId' 
			order by FORM_ORDER";
		//
		$result = $this->db->query($sql);
		if (DB::isError($result)) 
        {
        	return new PEAR_Error("DB ERROR: ".$result->getMessage()."in".__FILE__." on line ".__LINE__."with-------------$sql------------- ");
        }
		while ($row = $result->fetchRow(DB_FETCHMODE_ASSOC))
        {
            $getGroupsForSurvey[] = $row;
        }
		return $getGroupsForSurvey;
	}
	
    /**
    *	creates forms array  (recursive function)
    *
    *	@access	public
	*
    *	@param	int		$surveyId					ID of survey to create
	*	@param	int		$parentId					ID of root element
	*	@param	array	$arrayPart					arrayPart for recursive data creation
	*
    *	@return	array  	$surveyArray				survey array tree
    */
	function createSortedGroups($projectId,$parentId = '0')
	{
		global $cfgSrvyTabForms;
		
		// &dbFunctions::joinTabByArgtoArray($this->srvyTabSurvey,$this->srvyTabForms,array("PROJECT_ID_PK" => "$surveyId", ),array("FORM_PROJECT_ID_FK" => "$surveyId", "FORM_PARENT_ID" => $parentId),"FORM_ORDER");
		$arrayData = $this->getGroupsForSurveyWithParent($projectId, $parentId);

		// case no data
		for( $i=0; $i < count($arrayData); $i++ )
		{	
			// sort array if not root path
			if($parentId != 0)
			{
				$this->sortedGroupsArray[$parentId] = $this->sortArrayByNodeGroups($arrayData);
			}
			else
			{
				$this->sortedGroupsArray[$parentId] = $arrayData;
			}
			// check if has childs
			if($this->isNode($arrayData[$i]["FORM_ID_PK"],$cfgSrvyTabForms,"FORM_PARENT_ID") )
			{
				$this->createSortedGroups($projectId,$arrayData[$i]["FORM_ID_PK"]);
			}
		}
		return true;
	}
	
    /**
    *	inits creating of sorted groups (recursive function)
    *
    *	@access	public
	*
    *	@param	int		$surveyId					ID of survey to create
	*	@param	int		$parentId					ID of root element
	*	@param	array	$arrayPart					arrayPart for recursive data creation
	*
    *	@return	array  	$surveyArray				survey array tree
    */
	function insertGroupsAtPosition($arrayToMerge)
	{
		// if all inserted return merged array
		if (count($arrayToMerge) == 1)
		{
			$this->sortedGroupsArray = $arrayToMerge;
			return;
		}
		// get last element to insert
		$partToInsert = array_shift($arrayToMerge);
		//
		//loop arraytomerge 
		for($i = 0 ; $i < count($arrayToMerge) ;$i++)
		{	
			// loop parts of arraytomerge to find parent group
			for($k = 0; $k < count($arrayToMerge[$i]) ;$k++)
			{
				// if parentgroup found
				if($partToInsert[0]["FORM_PARENT_ID"] == $arrayToMerge[$i][$k]["FORM_ID_PK"])
				{
					// check if last in order
					if(!$arrayToMerge[$i][$k+1])
					{
						for($h = 0; $h < count($partToInsert); $h++)
						{
							// paste parttoinsert to group
							$arrayToMerge[$i][$k+1+$h] = $partToInsert[$h];
						}
						continue 2;
					}
					else
					{
						// get tail of arrayToMerge
						$tailofArrayToMerge = array_slice($arrayToMerge[$i], ($k+1));
						// paste $partToInsert
						for($h = 0; $h < count($partToInsert); $h++)
						{
							// paste parttoinsert to group
							$arrayToMerge[$i][$k+1+$h] = $partToInsert[$h];
						}
						// paste tail
						for($j = $h; $j < (count($tailofArrayToMerge)+$h); $j++)
						{	
							// set tailindex
							$tailIndex++;
							// paste parttoinsert to group
							$arrayToMerge[$i][$k+1+$j] = $tailofArrayToMerge[$tailIndex-1];
						}
						$tailIndex = 0;
						continue 2;
					}
				}
			}
		}
		// call function to get other parts added
		$this->insertGroupsAtPosition(&$arrayToMerge);
	}
	
    /**
    *	inits creating of sorted groups
    *
    *	@access	public
	*
    *	@param	int		$surveyId					ID of survey to create
	*	@param	int		$parentId					ID of root element
	*	@param	array	$arrayPart					arrayPart for recursive data creation
	*
    *	@return	array  	$surveyArray				survey array tree
    */
	function getSortedGroups($projectId)
	{
		global $lang_script;
		// sort array by nodegroups
		if($this->createSortedGroups($projectId))
		{
			// reverse to get subgroups first
			$arrayToMerge = array_reverse($this->sortedGroupsArray);
			// get nodegroups merged between parents
			$remergedArray = $this->insertGroupsAtPosition(&$arrayToMerge);
			// return array to create overview
			return $this->sortedGroupsArray[0];
		}
		return new PEAR_Error($lang_script["statistic.inc.php"]["PEAR_sortError"]." in".__FILE__." on line ".__LINE__);
	}
	
	/**
    *	Sorts an Array by Nodegroups
    *
    *	@access	private
    *	@param	array	$arrayToSort
    *	@return	array   sorted Array
    */
	function sortArrayByNodeGroups($arrayToSort)
	{	
		if (!is_array($arrayToSort))
		{
			$this->getErrorMessage("Supplied argument arrayToSort not valid in function sortArrayByArgument::qffSortArrayByNodeGroups-$arrayToSort-.");
		}
		// get node group id's
		for ($i=0;$i<count($arrayToSort);$i++)
		{
			if( $arrayToSort[$i]["FORM_NODEGROUP"] == 0 )
			{
				$nodeGroupPool[] = $arrayToSort[$i];
			}
		}
		$groupRootNodes = $nodeGroupPool;
		// sort if more than one alternative pathes
		if(count($nodeGroupPool) > 0)
		{
			foreach($nodeGroupPool as $nodeGroupKey => $nodeGroupValue)
			{
				// insert group root node as first element
				$newOrderArray[] = array_shift($groupRootNodes);
				for ($i=0;$i<count($arrayToSort);$i++)
				{
					if( $arrayToSort[$i]["FORM_NODEGROUP"] == $nodeGroupValue["FORM_ID_PK"] )
					{
						// insert group child groups
						$newOrderArray[] = $arrayToSort[$i];
					}
				}
			}
		}
		// else no sorting
		else
		{
			$newOrderArray = $arrayToSort;
		}
		return $newOrderArray;
		//end function
	}
	
    /**
    *	checks if node has childs
    *
    *	@access	public
     *	@param	int     $id   
    *   @return string  true/false
    */
    function isNode($id,$table,$arg)
    {
        $sql = "select 1 from ".$table." where ".$arg." = '".$id."'";
        $result = $this->db->query($sql);
        if (DB::isError($result)) 
        {
            return new PEAR_Error("DB ERROR: ".$result->getMessage()."in".__FILE__." on line ".__LINE__."with-------------$sql------------- ");
        }
        
        if ($result->numRows()  > 0)
        {
            return true;
        }
                
        return  false;
    }
	
	/**
    *	gets all questions from one group in one surveys for overview
    *
    *	@access	public
    *	@param	
    *   @return string true/false
    */
    function getSurveyQuestionsForGroup($groupId, $actualNum = 0, $maxRow, $orderby, $direction)
    {
		global $cfgSrvyTabFormtype;
		
		// fetch all questions in this group
        $sql = "select * 
           	from $cfgSrvyTabFormtype
           	where 
           	$cfgSrvyTabFormtype.FORMTYPE_FORM_ID_FK = '$groupId'
			order by $orderby $direction 
            limit $actualNum, $maxRow";	
		//
        $result = $this->db->query($sql);
		//echo "sql:$sql";
        if (DB::isError($result)) 
        {
           return new PEAR_Error("DB ERROR: ".$result->getMessage()."in".__FILE__." on line ".__LINE__."with-------------$sql------------- ");
        }
		while ($row = $result->fetchRow(DB_FETCHMODE_ASSOC))
        {
            $getQuestions[] = $row;
			// set order as value to key pk
			$orderNumForId[$row["FORMTYPE_ID_PK"]] = $row["FORMTYPE_ORDER"];
        }
		// get relative order nums
		/*$relOrderNumForId = $this->convertToRelativeOrderNum($orderNumForId); // not needed in statistics // 030502-rr
		// insert relorder nums
		for ($i=0;$i<count($getQuestions);++$i)
		{
			$getQuestions[$i]["REL_ORDER_NUM"] = $relOrderNumForId[$getQuestions[$i]["FORMTYPE_ID_PK"]];
		}*/
		return $getQuestions;
		
    }
	
    /**
    *	gets all answers to a question
    *
    *	@access	public
    *	@param	string $questionId  question id
    *   @return string true/false
    */
	function getQuestionsAnswers($questionId)
    {
        global $cfgSrvyTabFormelement;
		        
        // fetch all questions
		$sql = "select * 
            from $cfgSrvyTabFormelement
            where FORMELEMENT_FORMTYPE_ID_FK = '$questionId' 
            order by FORMELEMENT_ORDER";
		//
		$result = $this->db->query($sql);
        if (DB::isError($result)) 
        {
            return new PEAR_Error("DB ERROR: ".$result->getMessage()."in".__FILE__." on line ".__LINE__."with-------------$sql------------- ");
        }
        while ($row = $result->fetchRow(DB_FETCHMODE_ASSOC))
        {
            $answerArray[] = $row;
        }
		return $answerArray;
    }
	
	/**
    *	gets questions for one group
    *
    *	@access	public
    *	@param	
    *   @return string true/false
    */
	function getQuestionsInGroup($groupId)
	{
		global $cfgSrvyTabFormtype;
        
        // fetch all questions
		$sql = "select 1	
			from $cfgSrvyTabFormtype 
            where $cfgSrvyTabFormtype.FORMTYPE_FORM_ID_FK = '$groupId'";
		//
		$result = $this->db->query($sql);
        if (DB::isError($result)) 
        {
           return new PEAR_Error("DB ERROR: ".$result->getMessage()."in".__FILE__." on line ".__LINE__."with-------------$sql------------- ");
        }
		
        $numRows = $result->numRows();
        return $numRows;
	}
	
	/**
    *	gets the survey for one group
    *
    *	@access	public
    *	@param	
    *   @return string true/false
    */
	function getSurveyForGroup($projectId)
	{
	    global $cfgSrvyTabSurvey;
	
		 // select all surveys
        $sql = "select * 
			from $cfgSrvyTabSurvey
			where PROJECT_ID_PK  = '$projectId'";
		//
		$result = $this->db->query($sql);
		//echo "sql:$sql";
        if (DB::isError($result)) 
        {
		   return new PEAR_Error("DB ERROR: ".$result->getMessage()."in".__FILE__." on line ".__LINE__."with-------------$sql------------- ");
        }
		while ($row = $result->fetchRow(DB_FETCHMODE_ASSOC))
        {
            $getSurveyGroup[] = $row;
        }
        
		return $getSurveyGroup;
	}
	
} // end of class 
