<?php
// +----------------------------------------------------------------------+
// | sa project pilot                                                     |
// +----------------------------------------------------------------------+
// | Copyright (c) 2002 serie a - Digitale Medien und Systeme GmbH        |
// +----------------------------------------------------------------------+
// | Authors: 	Jrn Allert <allert@serie-a.de>                           |
// |          	Rene Renk   <renk@serie-a.de>                             |
// +----------------------------------------------------------------------+
//
// $Id: statistic.add.chart.php,v 1.1.1.1 2004/07/15 13:31:02 opensurveypilot Exp $

// start session
@session_start();

// require all configuration files and libraries
require_once("./../config/config.inc.php"); // common config file
require_once($cfgPathToConf."/file.inc.php"); // project files
require_once($cfgPathToLib."/common.inc.php"); // common functions
require_once($cfgPathToAuthFiles."/config/auth.file.inc.php"); // auth files
require_once($cfgPathToAuthFiles."/lib/user.inc.php"); // auth user functions
require_once($cfgPathToSurveyFiles."/config/survey.config.inc.php"); // survey config
require_once($cfgPathToSurveyFiles."/config/survey.file.inc.php"); // survey files
require_once($cfgPathToSurveyFiles."/lib/survey.inc.php"); // survey functions
require_once($cfgPathToStatisticFiles."/config/statistic.file.inc.php"); // statistics files
require_once($cfgPathToStatisticFiles."/lib/statistic.inc.php"); // statistics functions
require_once($cfgPathToAuthFiles."/lib/permission.inc.php"); // auth user functions
require_once("HTML/Template/IT.php"); // PEAR::HTML_TEMPLATE_IT
//require_once("phpchartdir.php"); // Chart Director
 
// create new userFunctions object
$client = &new userFunctions;
 
//login check
if ($client->getAuthentication($_SESSION["sessionId"], session_id()) ==  false)
{
    //redirect to login page
    ?>
    <script type="text/javascript">
    <!--
    window.location.href="<?php echo $cfgUrlToProject."/".$fileAuthLogin; ?>";
    -->
    </script>
    <?php
    exit;
}

// get project id
$projectId = $_GET["projectId"];

// create new permissionFunctions object
$permission = &new permissionFunctions;
 
// get Permission
$permissionMode = $permission->getPermissionMode($_SESSION["sessionUserId"], $projectId, 1);
if($permission->errorMessage)
{
    echo $permission->errorMessage;
}
// permission must be 1 (read)
if($permissionMode < 1)
{
    ?>
    <script type="text/javascript">
    <!--
    window.location.href="<?php echo $cfgUrlToProject."/".$fileNoPermission."?messageCode=1"; ?>";
    -->
    </script>
    <?php
    exit;
}

// create new surveyFunctions object
$survey = &new surveyFunctions;

// create javascript array 
$javascriptArray = "var questions = new Array(\n";

$groupArray = $survey->getGroupsForSurvey($projectId);
$groupArraySize = count($groupArray);

for($i=0;$i<count($groupArray);$i++)
{
    $maxRow = $survey->getQuestionsInGroup($groupArray[$i]["FORM_ID_PK"]);
    $questionArray = $survey->getSurveyQuestionsForGroup($groupArray[$i]["FORM_ID_PK"], $actualNum = 0, $maxRow, "FORMTYPE_ORDER", "ASC");
    //print_r($questionArray);
    if(is_array($questionArray))
    {
        $questionArraySize = count($questionArray);
        for($l=0;$l<count($questionArray);$l++)
        {
            $answerArray = $survey->getQuestionsAnswers($questionArray[$l]["FORMTYPE_ID_PK"]);
            //print_r($answerArray );
            $answerArraySize = count($answerArray);
            if(is_array($answerArray))
            {
                $javascriptArray .= "new Array(\n";
                for($k=0;$k<count($answerArray);$k++)
                {
                    $javascriptArray .= "new Array(\"".addslashes($answerArray[$k]["FORMELEMENT_HEADER"])."\", ".$answerArray[$k]["FORMELEMENT_ID_PK"].")";
                    if($k+1 < $answerArraySize)
                    {
                        $javascriptArray .= ", \n";
                    }
                }
                $javascriptArray .= ")\n";
            }
            else
            {
                $javascriptArray .= "null";
            }
            
            
            if($l+1 < $questionArraySize)
            {
                $javascriptArray .= ", \n";
            }
        }
    }
    else
    {
        $javascriptArray .= "null";
    }
        
    if($i+1 < $groupArraySize)
    {
        $javascriptArray .= ", \n";
    }
}

$javascriptArray .= ")";

// create Template IT object
$tpl = new HTML_Template_IT($cfgPathToStatisticTemplates);

// load template
$tpl->loadTemplatefile($templateStatisticAddChart, true, true);

// set title
$tpl->setVariable( "applicationtitle", $cfgApplicationType.$cfgApplicationVersion);

$tpl->setVariable( "questionarray", $javascriptArray );
$tpl->setVariable( "formaction", $fileStatisticChart);

$groupArray = $survey->getGroupsForSurvey($projectId);
for($i=0;$i<count($groupArray);$i++)
{
    $maxRow = $survey->getQuestionsInGroup($groupArray[$i]["FORM_ID_PK"]);
    $questionArray = $survey->getSurveyQuestionsForGroup($groupArray[$i]["FORM_ID_PK"], $actualNum = 0, $maxRow, "FORMTYPE_ORDER", "ASC");
    for($l=0;$l<count($questionArray);$l++)
    {
        $tpl->setCurrentBlock( "question" );
        $tpl->setVariable( "questionvalue", $questionArray[$l]["FORMTYPE_ID_PK"] );
        $tpl->setVariable( "questionname",  $questionArray[$l]["FORMTYPE_QUESTION"] );
        $tpl->parseCurrentBlock();
    }
}

$tpl->setVariable( "projectId", $projectId );

// parse template
$tpl->parse();

// get the parsed template and print it
$tpl->get();
$tpl->show();
?>