<?php
// +----------------------------------------------------------------------+
// | sa project pilot                                                     |
// +----------------------------------------------------------------------+
// | Copyright (c) 2002 serie a - Digitale Medien und Systeme GmbH        |
// +----------------------------------------------------------------------+
// | Authors: 	Jrn Allert <allert@serie-a.de>                           |
// |          	Rene Renk   <renk@serie-a.de>                             |
// +----------------------------------------------------------------------+
//
// $Id: statistic.chart.php,v 1.1.1.1 2004/07/15 13:31:02 opensurveypilot Exp $

// start session
@session_start();

// require all configuration files and libraries
require_once("./../config/config.inc.php"); // common config file
require_once($cfgPathToConf."/file.inc.php"); // project files
require_once($cfgPathToLib."/common.inc.php"); // common functions
require_once($cfgPathToAuthFiles."/config/auth.file.inc.php"); // auth files
require_once($cfgPathToAuthFiles."/lib/user.inc.php"); // auth user functions
require_once($cfgPathToAuthFiles."/lib/permission.inc.php"); // auth user functions
require_once($cfgPathToSurveyFiles."/config/survey.config.inc.php"); // survey config
require_once($cfgPathToSurveyFiles."/config/survey.file.inc.php"); // survey files
require_once($cfgPathToSurveyFiles."/lib/survey.inc.php"); // survey functions
require_once($cfgPathToStatisticFiles."/config/statistic.file.inc.php"); // statistics files
require_once($cfgPathToStatisticFiles."/lib/statistic.inc.php"); // statistics functions
require_once("HTML/Template/IT.php"); // PEAR::HTML_TEMPLATE_IT
//require_once("phpchartdir.php"); // Chart Director
 
// create new userFunctions object
$client = &new userFunctions;
 
//login check
if ($client->getAuthentication($_SESSION["sessionId"], session_id()) ==  false)
{
    //redirect to login page
    ?>
    <script type="text/javascript">
    <!--
    window.location.href="<?php echo $cfgUrlToProject."/".$fileAuthLogin; ?>";
    -->
    </script>
    <?php
    exit;
}

// Start of checking the permissions 
$fileUserPermissionMode	=	$permUserStatisticChart;
$filePermissionMode		=	$permStatisticChart;

// filepermission
if($_SESSION["sessionUserStatusId"] < $filePermissionMode)
{
    ?>
    <script type="text/javascript">
    <!--
    window.location.href="<?php echo $cfgUrlToProject."/".$fileNoPermission."?messageCode=".$filePermissionMode."&messageType=file"; ?>";
    -->
    </script>
    <?php
    exit;
}
// get projectId
$projectId = (isset($_GET["projectId"])) ? $_GET["projectId"] : $_POST["projectId"];

// create new permissionFunctions object
$permission = &new permissionFunctions;

// get Permission
$permissionMode = $permission->getPermissionMode($_SESSION["sessionUserId"], $projectId, 1);
if($permission->errorMessage)
{
    echo $permission->errorMessage;
}
// userpermission
if($permissionMode < $fileUserPermissionMode)
{
    ?>
    <script type="text/javascript">
    <!--
    window.location.href="<?php echo $cfgUrlToProject."/".$fileNoPermission."?messageCode=".$fileUserPermissionMode."&messageType=user"; ?>";
    -->
    </script>
    <?php
    exit;
}
// End of checking the permissions

// create new surveyFunctions object
$survey = &new surveyFunctions;

// empty chartOutput (png Image)
$_SESSION["chartOutput"] = "";


if (class_exists ("XYChart"))
{
	#Create a XYChart object of size 300 x 240 pixels
	$c = new XYChart(600, 290, 0xcccccc, 0x999999);
	
	#Set the plot area at (45, 25) and of size 240 x 180. Use two alternative
	#background colors (0xffffc0 and 0xffffe0)
	$plotAreaObj = $c->setPlotArea(45, 25, 500, 240);
	$plotAreaObj->setBackground(0xffffc0, 0xffffe0);
	
	#Add a legend box at (50, 20) using horizontal layout. Use 8 pt Arial font,
	#with transparent background
	$legendObj = $c->addLegend(50, 20, false, "", 8);
	$legendObj->setBackground(Transparent);
	
	#Revenue 20 pixels at the top of the y-axis for the legend box
	$c->yAxis->setTopMargin(20);
	    
	// check if form was submitted
	if($_SERVER["REQUEST_METHOD"] == "POST")
	{
	    // get project id
	    $projectId = $_POST["projectId"];
	    
	    // create new statisticFunctions object
	    $statistic = &new statisticFunctions;
	    
	    // get question ids
	    $questionString = $_POST["Addselection"];
	    if($questionString != "")
	    {
	        // cut last # in $questionString;
	        $questionStringCut = substr($questionString, 0, strlen($questionString)-1);
	        // put values in array
	        $questionIdArray = explode("#", $questionStringCut);
	    }
	    
	    // get question names
	    $questionNameString = $_POST["AddselectionName"];
	    if($questionNameString != "")
	    {
	        // cut last # in $questionString;
	        $questionNameStringCut = substr($questionNameString, 0, strlen($questionNameString)-1);
	        // put values in array
	        $questionNameArray = explode("#", $questionNameStringCut);
	    }
	    
	    if(is_array($questionIdArray))
	    {
	        // get chart num
	        $chartNum = count($questionIdArray);
	        
	        for($j=0;$j<$chartNum;$j++)
	        {
	            // add labels
	            $labels[$j] = $statistic->encodeSpecialChars($questionNameArray[$j]);
	                       
	            // cut last | in $questionString;
	            $answerIdStringCut = substr($questionIdArray[$j], 0, strlen($questionIdArray[$j])-1);
	            
	            // get answer data from result table
	            $answerNum = $statistic->getAnswerNum($projectId, $answerIdStringCut);
	            
	            // check for error
	            if ($statistic->errorMessage)
	            {
	                $error = $statistic->errorMessage;
	                echo $error;
	            }
	            
	            $data[$j] = $answerNum;
	        }
	        
	        // define colors
	        $colourArray = array("0xcc0000", "0x009933", "0x000099", "0xffff00", "0xff33ff", "0x999900", "0x9933cc", "0x993300", "0x003333", "0x99cc00", "0x000000");
	        
	        #Add a title to the chart using 10 pt Arial font (dynamic)
	        //$c->addTitle(" User in Prozent - Frage \"Wer bin ich?\"", "", 10);
	        
	        #Add a title to the y-axis
	        //$c->yAxis->setTitle("");
	        
	        #Set the x axis labels
	        $c->xAxis->setLabels($labels);
	        
	         #Add layer
	        $layer = $c->addBarLayer3($data, $colourArray, $labels, 5);
	        //$layer->setBorderColor(-1,1);
	    }
	}
	
	// save chart in session
	$_SESSION["chartOutput"] = $c->makeChart2(PNG);
}

// create Template IT object
$tpl = new HTML_Template_IT($cfgPathToStatisticTemplates);

// load template
$tpl->loadTemplatefile($templateStatisticChart, true, true);

// set title
$tpl->setVariable( "applicationtitle", $cfgApplicationType.$cfgApplicationVersion);

$tpl->setVariable( "lnk_detail", $fileStatisticDetailview."?projectId=".$projectId );
$tpl->setVariable( "lnk_diagramm", $fileStatisticChart."?projectId=".$projectId );
$tpl->setVariable( "lnk_pie", $fileStatisticPie."?projectId=".$projectId );
$tpl->setVariable( "lnk_table", $fileStatisticTable."?projectId=".$projectId );
$tpl->setVariable( "lnk_export", $fileStatisticExport."?projectId=".$projectId );

$tpl->setVariable( "questionarray", $javascriptArray );
$tpl->setVariable( "formaction", $fileStatisticChart);
$tpl->setVariable( "addselection", $_POST["Addselection"] );
$tpl->setVariable( "addselectionname", $_POST["AddselectionName"] );
$tpl->setVariable( "chart_add_link", $fileStatisticAddChart."?projectId=".$projectId );
$tpl->setVariable( "projectId", $projectId );

// parse template
$tpl->parse();

// get the parsed template and print it
$tpl->get();
$tpl->show();
?>