<?php
// +----------------------------------------------------------------------+
// | sa project pilot                                                     |
// +----------------------------------------------------------------------+
// | Copyright (c) 2002 serie a - Digitale Medien und Systeme GmbH        |
// +----------------------------------------------------------------------+
// | Authors: 	Jrn Allert <allert@serie-a.de>                           |
// |          	Rene Renk <renk@serie-a.de>                               |
// +----------------------------------------------------------------------+
//
// $Id: statistic.detailview.php,v 1.1.1.1 2004/07/15 13:31:04 opensurveypilot Exp $

// start session
@session_start();

// require all configuration files and libraries
require_once("./../config/config.inc.php"); // common config file
require_once($cfgPathToConf."/file.inc.php"); // project files
require_once($cfgPathToLib."/common.inc.php"); // common functions
require_once($cfgPathToAuthFiles."/lib/user.inc.php"); // auth user functions
require_once($cfgPathToAuthFiles."/lib/permission.inc.php"); // auth user functions
require_once($cfgPathToSurveyFiles."/config/survey.config.inc.php"); // auth config file
require_once($cfgPathToSurveyFiles."/config/survey.file.inc.php"); // auth files
require_once($cfgPathToSurveyFiles."/lib/survey.inc.php"); // survey functions
require_once($cfgPathToStatisticFiles."/config/statistic.file.inc.php"); // statistic user functions
require_once("HTML/Template/IT.php"); // PEAR::HTML_TEMPLATE_IT

// create new userFunctions object
$client = &new userFunctions;

//login check
if ($client->getAuthentication($_SESSION["sessionId"], session_id()) ==  false)
{
    //redirect to login page
    ?>
    <script type="text/javascript">
    <!--
    window.location.href="<?php echo $cfgUrlToProject."/".$fileAuthLogin; ?>";
    -->
    </script>
    <?php
    exit;
} 

// Start of checking the permissions 
$fileUserPermissionMode	=	$permUserStatisticDetail;
$filePermissionMode		=	$permStatisticDetail;

// filepermission
if($_SESSION["sessionUserStatusId"] < $filePermissionMode)
{
    ?>
    <script type="text/javascript">
    <!--
    window.location.href="<?php echo $cfgUrlToProject."/".$fileNoPermission."?messageCode=".$filePermissionMode."&messageType=file"; ?>";
    -->
    </script>
    <?php
    exit;
}
// get projectId
$projectId = (isset($_GET["projectId"])) ? $_GET["projectId"] : $_POST["projectId"];

// create new permissionFunctions object
$permission = &new permissionFunctions;

// get Permission
$permissionMode = $permission->getPermissionMode($_SESSION["sessionUserId"], $projectId, 1);
if($permission->errorMessage)
{
    echo $permission->errorMessage;
}
// userpermission
if($permissionMode < $fileUserPermissionMode)
{
    ?>
    <script type="text/javascript">
    <!--
    window.location.href="<?php echo $cfgUrlToProject."/".$fileNoPermission."?messageCode=".$fileUserPermissionMode."&messageType=user"; ?>";
    -->
    </script>
    <?php
    exit;
}
// End of checking the permissions

// init function class
$newSurveyData = &new surveyFunctions;

// get survey data
$surveyData = $newSurveyData->getSurveyForGroup($projectId);

// create Template IT object
$tpl = new HTML_Template_IT($cfgPathToStatisticTemplates);

// load template
$tpl->loadTemplatefile($templateStatisticDetailView, true, false);

// set title
$tpl->setVariable( "applicationtitle", $cfgApplicationType.$cfgApplicationVersion);

$tpl->setVariable( "errors", $userError );

$tpl->setVariable( "lnk_detail", $fileStatisticDetailview."?projectId=".$projectId );
$tpl->setVariable( "lnk_diagramm", $fileStatisticChart."?projectId=".$projectId );
$tpl->setVariable( "lnk_pie", $fileStatisticPie."?projectId=".$projectId );
$tpl->setVariable( "lnk_table", $fileStatisticTable."?projectId=".$projectId );
$tpl->setVariable( "lnk_export", $fileStatisticExport."?projectId=".$projectId );

$tpl->setVariable( "surveyname", $surveyData[0]["PROJECT_NAME"] );
$tpl->setVariable( "surveyauthor", $surveyData[0]["PROJECT_AUTHOR"] );
$tpl->setVariable( "surveydescription", $surveyData[0]["PROJECT_DESCRIPTION"] );
$tpl->setVariable( "previewpath", $surveyData[0]["PROJECT_OUTPUTDIR"] );
$previewLink = $cfgUrlToOutput."/".$surveyData[0]["PROJECT_OUTPUTDIR"]."/".$fileSurveyPreview."?projectId=".$surveyData[0]["PROJECT_ID_PK"];
$tpl->setVariable( "previewlink", $previewLink );
if($surveyData[0]["PROJECT_ACTIVE"] == "yes")
{
    $surveyActive = "checked";
}
$tpl->setVariable( "activechecked", $surveyActive );
$startdateArray = explode("-",$surveyData[0]["PROJECT_STARTDATE"]);

// 
$questionData = $newSurveyData->getGroupsForSurvey($projectId);

$numGroups = count($questionData);

//get groupnums and formtypeids
if($numGroups)
{
	
	$tpl->setVariable("numgroups",$numGroups);
	
	//get questionnums
	for ($i=0;$i<$numGroups;$i++)
	{
		$argumentValue = $questionData[$i]["FORM_ID_PK"];
		$moreQuestion = $newSurveyData->getTableEntriesNum($cfgSrvyTabFormtype,array("FORMTYPE_FORM_ID_FK" => $argumentValue));
		$numQuestion = $numQuestion + $moreQuestion;
	}
	$tpl->setVariable("numquestions",$numQuestion);
	
	//answered Table
	$answeredTable = $cfgSrvyTabFilled.$projectId;
	// get answered nums
	$numAnswer = $newSurveyData->getTableEntriesNum($answeredTable,0);
	$tpl->setVariable("answers",$numAnswer);
}
else
{
	$tpl->setVariable("numgroups",0);
	$tpl->setVariable("numquestions",0);
	//answered Table
	$answeredTable = $cfgSrvyTabFilled.$projectId;
	// get answered nums
	$numAnswer = $newSurveyData->getTableEntriesNum($answeredTable,0);
	$tpl->setVariable("answers",$numAnswer);
}

// parse template
$tpl->parse();

// get the parsed template and print it
$tpl->get();
$tpl->show();
?>
