<?php
// +----------------------------------------------------------------------+
// | sa project pilot                                                     |
// +----------------------------------------------------------------------+
// | Copyright (c) 2002 serie a - Digitale Medien und Systeme GmbH        |
// +----------------------------------------------------------------------+
// | Authors: 	Jrn Allert <allert@serie-a.de>                           |
// |          	Rene Renk   <renk@serie-a.de>                             |
// +----------------------------------------------------------------------+
//
// $Id: statistic.export.frameset.php,v 1.1.1.1 2004/07/15 13:31:04 opensurveypilot Exp $

// start session
@session_start();

// require all configuration files and libraries
require_once("./../config/config.inc.php"); // common config file
require_once($cfgPathToConf."/file.inc.php"); // project files
require_once($cfgPathToLib."/common.inc.php"); // common functions
require_once($cfgPathToAuthFiles."/config/auth.file.inc.php"); // auth files
require_once($cfgPathToAuthFiles."/lib/user.inc.php"); // auth user functions
require_once($cfgPathToAuthFiles."/lib/permission.inc.php"); // auth user functions
require_once($cfgPathToSurveyFiles."/config/survey.config.inc.php"); // survey config
require_once($cfgPathToSurveyFiles."/lib/security/security.inc.php"); // security functions
require_once($cfgPathToStatisticFiles."/config/statistic.file.inc.php"); // statistics files
require_once($cfgPathToStatisticFiles."/lib/statistic.inc.php"); // statistics functions
require_once("HTML/Template/IT.php"); // PEAR::HTML_TEMPLATE_IT

// make sure old sessionvalues empty
unset($_SESSION["groupsToTans"]);
session_unregister("groupsToTans");
unset($_SESSION["sessionLimitOutputByDate"]);
session_unregister("sessionLimitOutputByDate");
	
// create new userFunctions object
$client = &new userFunctions;
 
//login check
if ($client->getAuthentication($_SESSION["sessionId"], session_id()) ==  false)
{
    //redirect to login page
    ?>
    <script type="text/javascript">
    <!--
    window.location.href="<?php echo $cfgUrlToProject."/".$fileAuthLogin; ?>";
    -->
    </script>
    <?php
    exit;
}

// Start of checking the permissions 
$fileUserPermissionMode	=	$permUserStatisticTable;
$filePermissionMode		=	$permStatisticTable;

// filepermission
if($_SESSION["sessionUserStatusId"] < $filePermissionMode)
{
    ?>
    <script type="text/javascript">
    <!--
    window.location.href="<?php echo $cfgUrlToProject."/".$fileNoPermission."?messageCode=".$filePermissionMode."&messageType=file"; ?>";
    -->
    </script>
    <?php
    exit;
}
// get projectId
$projectId = (isset($_GET["projectId"])) ? $_GET["projectId"] : $_POST["projectId"];

// create new permissionFunctions object
$permission = &new permissionFunctions;

// get Permission
$permissionMode = $permission->getPermissionMode($_SESSION["sessionUserId"], $projectId, 1);
if($permission->errorMessage)
{
    echo $permission->errorMessage;
}
// userpermission
if($permissionMode < $fileUserPermissionMode)
{
    ?>
    <script type="text/javascript">
    <!--
    window.location.href="<?php echo $cfgUrlToProject."/".$fileNoPermission."?messageCode=".$fileUserPermissionMode."&messageType=user"; ?>";
    -->
    </script>
    <?php
    exit;
}
// End of checking the permissions

// emtpty explorer Value
//$_SESSION["explorerValue"] = "/";

// create new surveyFunctions object
$statistics = &new statisticFunctions;

// headline
$headlineArray =  $statistics->getSurveyForGroup($projectId);

// if no tan full view
if($headlineArray[0]["PROJECT_SECURITY"] != "tan")
{
    ?>
    <script type="text/javascript">
    <!--
    window.location.href="<?php echo $cfgUrlToProject."/statistic/".$fileStatisticExportContent."?projectId=".$_GET["projectId"].'&notan=1'; ?>";
    -->
    </script>
    <?php
    exit;
}

// create Template IT
$tpl = new HTML_Template_IT($cfgPathToStatisticTemplates);

// load template
$tpl->loadTemplatefile($templateStatisticExport, true, true);
// set title
$tpl->setVariable( "applicationtitle", $cfgApplicationType.$cfgApplicationVersion);
$tpl->setVariable( "statistic_export_frame_teaser", $fileStatisticExportTeaser."?projectId=".$_GET["projectId"] );
$tpl->setVariable( "statistic_export_frame_content",  $fileStatisticEmptyLgrey );

// parse template
$tpl->parse();

// get the parsed template and print it
$tpl->get();
$tpl->show();
?>
