<?php
// +----------------------------------------------------------------------+
// | sa project pilot                                                     |
// +----------------------------------------------------------------------+
// | Copyright (c) 2002 serie a - Digitale Medien und Systeme GmbH        |
// +----------------------------------------------------------------------+
// | Authors: 	Jrn Allert <allert@serie-a.de>                           |
// |          	Rene Renk   <renk@serie-a.de>                             |
// +----------------------------------------------------------------------+
//
// $Id: statistic.export.php,v 1.2 2007/01/04 14:49:47 easy_israel Exp $

require_once("../survey/lib/security/security.inc.php"); // security functions

// start session
@session_start();

// require all configuration files and libraries
require_once("./../config/config.inc.php"); // common config file
require_once($cfgPathToConf."/file.inc.php"); // project files
require_once($cfgPathToLib."/common.inc.php"); // common functions
require_once($cfgPathToAuthFiles."/config/auth.file.inc.php"); // auth files
require_once($cfgPathToAuthFiles."/lib/user.inc.php"); // auth user functions
require_once($cfgPathToAuthFiles."/lib/permission.inc.php"); // auth user functions
require_once($cfgPathToSurveyFiles."/config/survey.config.inc.php"); // survey config
require_once($cfgPathToSurveyFiles."/config/survey.file.inc.php"); // survey files
require_once($cfgPathToSurveyFiles."/lib/survey.inc.php"); // survey functions
require_once($cfgPathToStatisticFiles."/config/statistic.file.inc.php"); // statistics files
require_once($cfgPathToStatisticFiles."/lib/statistic.inc.php"); // statistics functions
    require_once($cfgPathToStatisticFiles."/lib/export/statistic.export.inc.php"); // export functions
require_once($cfgPathToStatisticFiles."/lib/export/statistic.matrix.export.inc.php"); // export functions
require_once($cfgPathToStatisticFiles."/lib/export/statistic.export.singlerow.inc.php"); // export functions
require_once("HTML/Template/IT.php"); // PEAR::HTML_TEMPLATE_IT
// create new userFunctions object
$client = &new userFunctions;

//login check
if ($client->getAuthentication($_SESSION["sessionId"], session_id()) ==  false)
{
    //redirect to login page
    ?>
    <script type="text/javascript">
    <!--
    window.location.href="<?php echo $cfgUrlToProject."/".$fileAuthLogin; ?>";
    -->
    </script>
    <?php
    exit;
}

// Start of checking the permissions 
$fileUserPermissionMode	=	$permUserStatisticExport;
$filePermissionMode		=	$permStatisticExport;

// filepermission
if($_SESSION["sessionUserStatusId"] < $filePermissionMode)
{
    ?>
    <script type="text/javascript">
    <!--
    window.location.href="<?php echo $cfgUrlToProject."/".$fileNoPermission."?messageCode=".$filePermissionMode."&messageType=file"; ?>";
    -->
    </script>
    <?php
    exit;
}
// get projectId
$projectId = (isset($_GET["projectId"])) ? $_GET["projectId"] : $_POST["projectId"];

// create new permissionFunctions object
$permission = &new permissionFunctions;

// get Permission
$permissionMode = $permission->getPermissionMode($_SESSION["sessionUserId"], $projectId, 1);
if($permission->errorMessage)
{
    echo $permission->errorMessage;
}
// userpermission
if($permissionMode < $fileUserPermissionMode)
{
    ?>
    <script type="text/javascript">
    <!--
    window.location.href="<?php echo $cfgUrlToProject."/".$fileNoPermission."?messageCode=".$fileUserPermissionMode."&messageType=user"; ?>";
    -->
    </script>
    <?php
    exit;
}
// End of checking the permissions


//
// if form sent 
if($_SERVER["REQUEST_METHOD"] == "POST")
{
	// get export Format
	$exportFormat = $_POST["exportFormat"];
	// create new exportFunctions object
	$exports = &new exportFunctions;
	// export to chosen format
	switch ($exportFormat)
	{
		case "msExcel":
		{
			// export file and get optional error
			$exports = &new exportFunctions;
			$exportStat		= $exports->exportToExcel($projectId, $_SESSION["groupsToTans"],$_SESSION["sessionLimitOutputByDate"]);
			$exportError	= $exports->getErrormessage();
			break;
		}
		case "msExcelMatrix":
		{
			// export file and get optional error
			$exports = &new exportMatrixFunctions;
			$exportStat		= $exports->exportToExcel($projectId, $_SESSION["groupsToTans"],$_SESSION["sessionLimitOutputByDate"]);
			$exportError	= $exports->getErrormessage();
			break;
		}
		case "msExcelRow":
		{
			// export file and get optional error
			$exports = &new exportToExcelRow;
			$exportStat		= $exports->exportToExcelRowView($projectId, $_SESSION["groupsToTans"],$_SESSION["sessionLimitOutputByDate"]);
			$exportError	= $exports->getErrormessage();
			break;
		}
		default: 
			break;
	}
}
// create Template IT object
$tpl = new HTML_Template_IT($cfgPathToStatisticTemplates);

if ($_GET["notan"]==1)
$tpl->loadTemplatefile($templateStatisticExportContentNoTan, true, true);
else
$tpl->loadTemplatefile($templateStatisticExportContent, true, true);

// create new surveyFunctions object
$survey = &new surveyFunctions;
// headline
$headlineArray =  $survey->getSurveyForGroup($projectId);

// set additional header
//
// if is tan protected
if($headlineArray[0]["PROJECT_SECURITY"] == "tan")
{
	// fill security object
	$securityFunctions = &new securityFunctions;
	$securityFunctions->setProjectId($projectId);
	$securityFunctions->setTanTableName();
	$securityFunctions->setTanGroupTableName();
	
	// check if groups to tans set
	$sessionGroupsToTans = ($_SESSION["groupsToTans"])? $_SESSION["groupsToTans"] : 'all';
	$securityFunctions->setGroupsToTans($sessionGroupsToTans);
	
	// display timerange
    $tpl->touchBlock( "timelimit" );
    $tpl->setVariable( "time_from", $_SESSION["sessionLimitOutputByDate"]["from"]["day"].".".$_SESSION["sessionLimitOutputByDate"]["from"]["month"].".".$_SESSION["sessionLimitOutputByDate"]["from"]["year"] );
    $tpl->setVariable( "time_to", $_SESSION["sessionLimitOutputByDate"]["to"]["day"].".".$_SESSION["sessionLimitOutputByDate"]["to"]["month"].".".$_SESSION["sessionLimitOutputByDate"]["to"]["year"] );

	// get tangroupdata
	$groupsToTans = $securityFunctions->getGroupsToTans();
	$groupsToTansNames = $securityFunctions->getGroupsToTansNames();
	$tpl->setVariable( "tan_groups", join(", ",$groupsToTansNames));
}
else
{
	// make sure old sessionvalues empty
	unset($_SESSION["groupsToTans"]);
	session_unregister("groupsToTans");
	unset($_SESSION["sessionLimitOutputByDate"]);
	session_unregister("sessionLimitOutputByDate");
}

// set title
$tpl->setVariable( "applicationtitle", $cfgApplicationType.$cfgApplicationVersion);

// survey id
$tpl->setVariable( "projectId", $projectId );
// errormessage
$tpl->setVariable( "errormessage", $exportError );
// survey name
$tpl->setVariable( "survey_name", $headlineArray[0]["PROJECT_NAME"] );


$tpl->setVariable( "lnk_detail", $fileStatisticDetailview."?projectId=".$projectId );
$tpl->setVariable( "lnk_diagramm", $fileStatisticChart."?projectId=".$projectId );
$tpl->setVariable( "lnk_pie", $fileStatisticPie."?projectId=".$projectId );
$tpl->setVariable( "lnk_table", $fileStatisticTable."?projectId=".$projectId );
$tpl->setVariable( "lnk_export", $fileStatisticExport."?projectId=".$projectId );


// parse template
$tpl->parse();
// get the parsed template and print it
$tpl->get();
$tpl->show();
?>
