<?php 
// +----------------------------------------------------------------------+
// | survey pilot                                                         |
// +----------------------------------------------------------------------+
// | Copyright (c) 2002 serie a - Digitale Medien und Systeme GmbH        |
// +----------------------------------------------------------------------+
// | Authors: Jrn Allert <allert@serie-a.de>                             |
// |          Rene Renk <renk@serie-a.de>                                 |
// +----------------------------------------------------------------------+
//
// $Id: statistic.export.teaser.php,v 1.1.1.1 2004/07/15 13:31:04 opensurveypilot Exp $

require_once("../survey/lib/security/security.inc.php"); // security functions

// start session
@session_start();

// require all configuration files and libraries
require_once("./../config/config.inc.php"); // common config file
require_once($cfgPathToConf."/file.inc.php"); // project files
require_once($cfgPathToLib."/common.inc.php"); // common functions
require_once($cfgPathToAuthFiles."/config/auth.file.inc.php"); // auth files
require_once($cfgPathToAuthFiles."/lib/user.inc.php"); // auth user functions
require_once($cfgPathToAuthFiles."/lib/permission.inc.php"); // auth user functions
require_once($cfgPathToSurveyFiles."/config/survey.config.inc.php"); // survey config
require_once($cfgPathToStatisticFiles."/config/statistic.file.inc.php"); // statistics files
require_once($cfgPathToStatisticFiles."/lib/statistic.inc.php"); // statistics functions
require_once("HTML/Template/IT.php"); // PEAR::HTML_TEMPLATE_IT

// create new userFunctions object
$client = &new userFunctions;

//login check
if ($client->getAuthentication($_SESSION["sessionId"], session_id()) ==  false)
{
    //redirect to login page
    ?>
    <script type="text/javascript">
    <!--
    window.location.href="<?php echo $cfgUrlToProject."/".$fileAuthLogin; ?>";
    -->
    </script>
    <?php
    exit;
}

// Start of checking the permissions 
$fileUserPermissionMode	=	$permUserStatisticTable;
$filePermissionMode		=	$permStatisticTable;

// filepermission
if($_SESSION["sessionUserStatusId"] < $filePermissionMode)
{
    ?>
    <script type="text/javascript">
    <!--
    window.location.href="<?php echo $cfgUrlToProject."/".$fileNoPermission."?messageCode=".$filePermissionMode."&messageType=file"; ?>";
    -->
    </script>
    <?php
    exit;
}
// get projectId
$projectId = (isset($_GET["projectId"])) ? $_GET["projectId"] : $_POST["projectId"];

// create new permissionFunctions object
$permission = &new permissionFunctions;

// get Permission
$permissionMode = $permission->getPermissionMode($_SESSION["sessionUserId"], $projectId, 1);
if($permission->errorMessage)
{
    echo $permission->errorMessage;
}
// userpermission
if($permissionMode < $fileUserPermissionMode)
{
    ?>
    <script type="text/javascript">
    <!--
    window.location.href="<?php echo $cfgUrlToProject."/".$fileNoPermission."?messageCode=".$fileUserPermissionMode."&messageType=user"; ?>";
    -->
    </script>
    <?php
    exit;
}
// End of checking the permissions

//create new security object
$security = &new securityFunctions;
// set project id
$security->setProjectId($projectId);
// set tan table name
$security->setTanTableName();
// set group table name
$security->setTanGroupTableName();

// activecheck
if (($surveyData[0]["PROJECT_ACTIVE"]=="yes")AND(!$_GET["warningChecked"]))
{
	// create Template IT object
	$tpl = new HTML_Template_IT($cfgPathToSurveyTemplates);
	
	// load template
	$tpl->loadTemplatefile($templateSurveyActiveWarning, true, true);
	
	// set title
	$tpl->setVariable( "applicationtitle", $cfgApplicationType.$cfgApplicationVersion);

	$tpl->setVariable( "projectId", "$projectId" );
	$tpl->get();
	$tpl->show();
	exit;
}
$errors = array();

// create Template IT object
$tpl = new HTML_Template_IT($cfgPathToStatisticTemplates);

// load template
$tpl->loadTemplatefile($templateStatisticExportTeaser, true, true);

// set title
$tpl->setVariable( "applicationtitle", $cfgApplicationType.$cfgApplicationVersion);

$tpl->setVariable( "projectid", $projectId); 
$tpl->setVariable( "errors", $error );

$tanGroups = $_POST["tanGroups"];

if(!$tanGroups)
{
	// show all
	$tanGroups[]	=	-2;
}

// store groups to delete to session
for ($i=0;$i<count($tanGroups);$i++)
{
	switch ($tanGroups[$i])
	{
		case -2:
			$security->setGroupsToTans("all");
			break 2;
		case -1:
			$security->setGroupsToTans("allUngrouped");
			break 2;
		default:
			$security->setGroupsToTans($tanGroups[$i]);
	}
}

// get names of choosen groups
$groupsToTans = $security->getGroupsToTans();

// set groups to session
$_SESSION["groupsToTans"] = $groupsToTans;

// get groups
$tanGroups	=	$security->getTanGroups();

// on Post reload content
if($_SERVER["REQUEST_METHOD"] == "POST")
{
    //check Submitted Time 
	
	$filterOptionsTime["dayFrom"]	= $_POST["limitOutputDayFrom"];
	$filterOptionsTime["monthFrom"]	= $_POST["limitOutputMonthFrom"];
	$filterOptionsTime["yearFrom"]	= $_POST["limitOutputYearFrom"];
	
	$filterOptionsTime["dayTo"]		= $_POST["limitOutputDayTo"];
	$filterOptionsTime["monthTo"]	= $_POST["limitOutputMonthTo"];
	$filterOptionsTime["yearTo"]	= $_POST["limitOutputYearTo"];
	
	// reset ??
	if($_POST["filterOptionReset"])
	{
		unset($filterOptionsTime);
		session_unregister("sessionLimitOutputByDate");
		unset($_SESSION["sessionLimitOutputByDate"]);
	}
	//missing param ?
	if($filterOptionsTime["dayFrom"] || $filterOptionsTime["monthFrom"] || $filterOptionsTime["yearFrom"] || $filterOptionsTime["dayTo"] || $filterOptionsTime["monthTo"] || $filterOptionsTime["yearTo"])
	{
		if(!$filterOptionsTime["dayFrom"] || !$filterOptionsTime["monthFrom"] || !$filterOptionsTime["yearFrom"] || !$filterOptionsTime["dayTo"] || !$filterOptionsTime["monthTo"] || !$filterOptionsTime["yearTo"])
		{
			$errors[] = $lang_script["statistic.export.teaser.php"]["timeparamError"];
		}
		else
		{
			//make Timestamps
			$fromTime	= getTimestamp($filterOptionsTime["dayFrom"].".".$filterOptionsTime["monthFrom"].".".$filterOptionsTime["yearFrom"]);
			if(!is_array($fromTime))
			{
				$errors[] = $fromTime." ".$lang_script["statistic.export.teaser.php"]["timefromError"];
			}
			$toTime		= getTimestamp($filterOptionsTime["dayTo"].".".$filterOptionsTime["monthTo"].".".$filterOptionsTime["yearTo"]);
			if(!is_array($toTime))
			{
				$errors[] = $toTime." ".$lang_script["statistic.export.teaser.php"]["timetoError"];
			}
			// from time bigger to time ?
			if($fromTime["timestamp"] > $toTime["timestamp"])
			{
				$errors[] = $lang_script["statistic.export.teaser.php"]["timerelationError"];
			}
			else
			{
				$_SESSION["sessionLimitOutputByDate"]["from"]	= $fromTime;
				$_SESSION["sessionLimitOutputByDate"]["to"]		= $toTime;
			}
		}
	}
	// no params ?
	else
	{
		unset($filterOptionsTime);
		session_unregister("sessionLimitOutputByDate");
		unset($_SESSION["sessionLimitOutputByDate"]);
	}
	
	if(!$errors)
	{
	    ?>
	    <script type="text/javascript">
	    <!--
	    top.window.frames['navcontent'].location.href="<?php echo $cfgUrlToProject."/statistic/".$fileStatisticExportContent."?projectId=".$_GET["projectId"]; ?>";
	    -->
	    </script>
	    <?php
	}
}

// check if time default isset
if(!$_SESSION["sessionLimitOutputByDate"])
{
	$tpl->setVariable("first_submit", true );
}
else
{
	$tpl->setVariable("first_submit", false );
}

$tpl->touchBlock( "choose_group_block");

$selectedGroups = array();

// general group set ?
if($groupsToTans)
{
	for($i=0;$i<count($groupsToTans);$i++)
	{
		switch($groupsToTans[$i]->getTanGroupValue("TANGROUP_ID_PK"))
		{
			case -2:
				$tpl->setVariable( "tan_group_selected_all", "selected" );
				$selected = true;
				break 2;
			case -1:
				$tpl->setVariable( "tan_group_selected_allUngrouped", "selected" );
				$selected = true;
				break 2;
			default:
				$selectedGroups[] = $groupsToTans[$i]->getTanGroupValue("TANGROUP_ID_PK");
		}
	}
}
// display groups to select from
for($i=0;$i<count($tanGroups);$i++)
{
	$tpl->setCurrentBlock( "tan_group_list");
	$tpl->setVariable( "tan_group_id", $tanGroups[$i]->getTanGroupValue("TANGROUP_ID_PK") );
	$tpl->setVariable( "tan_group_name", $tanGroups[$i]->getTanGroupValue("TANGROUP_NAME") );
	if(!$selected && in_array($tanGroups[$i]->getTanGroupValue("TANGROUP_ID_PK"), $selectedGroups))
	{
		$tpl->setVariable( "tan_group_selected", "selected" );
	}
	$tpl->parseCurrentBlock();
}

// time
//

// get last 6 weeks
$defaultTimeFromWeeks = 4; // was 2
$dateArray = getdate();
$twoWeekAgoTimestamp = $dateArray[0] - ($defaultTimeFromWeeks * 604800);
$eightWeekAgoDate = date("j.m.Y", $twoWeekAgoTimestamp);
$defaultTimeFromData = explode(".",$eightWeekAgoDate);

// set day from
for($d=1;$d<=31;$d++)
{
	$dd = (strlen((string)$d) == 1) ? "0".$d : $d;
    $tpl->setCurrentBlock( "limit_output_day_from" );
    $tpl->setVariable( "limit_output_day_from_value", $d );
	$tpl->setVariable( "limit_output_day_from_content", $dd );
    if($filterOptionsTime["dayFrom"] == $d)
    {
        $tpl->setVariable( "limit_output_day_from_selected", "selected" );
    }
	elseif(!isset($filterOptionsTime["dayFrom"]) && $defaultTimeFromData[0] == $d)
	{
		 $tpl->setVariable( "limit_output_day_from_selected", "selected" );
	}
    $tpl->parseCurrentBlock();
}

// set day to
for($d=1;$d<=31;$d++)
{
	$dd = (strlen((string)$d) == 1) ? "0".$d : $d;
    $tpl->setCurrentBlock( "limit_output_day_to" );
    $tpl->setVariable( "limit_output_day_to_value", $d );
	$tpl->setVariable( "limit_output_day_to_content", $dd );
    if($filterOptionsTime["dayTo"] == $d)
    {
        $tpl->setVariable( "limit_output_day_to_selected", "selected" );
    }
	elseif(!isset($filterOptionsTime["dayTo"]) && $dateArray["mday"] == $d)
	{
		 $tpl->setVariable( "limit_output_day_to_selected", "selected" );
	}
    $tpl->parseCurrentBlock();
}

//
//

// set month from
for($m=1;$m<=12;$m++)
{
	$mm = (strlen((string)$m) == 1) ? "0".$m : $m;
	$tpl->setCurrentBlock( "limit_output_month_from" );
    $tpl->setVariable( "limit_output_month_from_value", $m );
    $tpl->setVariable( "limit_output_month_from_content", $mm );
	if($filterOptionsTime["monthFrom"] == $m )
    {
        $tpl->setVariable( "limit_output_month_from_selected", "selected" );
    }
	elseif(!isset($filterOptionsTime["monthFrom"]) && $defaultTimeFromData[1] == $m)
	{
		 $tpl->setVariable( "limit_output_month_from_selected", "selected" );
	}
    $tpl->parseCurrentBlock();
}

// set month to
for($m=1;$m<=12;$m++)
{
	$mm = (strlen((string)$m) == 1) ? "0".$m : $m;
	$tpl->setCurrentBlock( "limit_output_month_to" );
    $tpl->setVariable( "limit_output_month_to_value", $m );
    $tpl->setVariable( "limit_output_month_to_content", $mm );
	if($filterOptionsTime["monthTo"] == $m )
    {
        $tpl->setVariable( "limit_output_month_to_selected", "selected" );
    }
	elseif(!isset($filterOptionsTime["monthTo"]) && $dateArray["mon"] == $m)
	{
		 $tpl->setVariable( "limit_output_month_to_selected", "selected" );
	}
    $tpl->parseCurrentBlock();
}

//
//

// set year from
for($y=2003;$y<=2020;$y++)
{
	$tpl->setCurrentBlock( "limit_output_year_from" );
    $tpl->setVariable( "limit_output_year_from_value", $y );
	$tpl->setVariable( "limit_output_year_from_content", $y );
    if($filterOptionsTime["yearFrom"] == $y)
    {
        $tpl->setVariable( "limit_output_year_from_selected", "selected" );
    }
	elseif(!isset($filterOptionsTime["yearFrom"]) && $defaultTimeFromData[2] == $y)
	{
		 $tpl->setVariable( "limit_output_year_from_selected", "selected" );
	}
    $tpl->parseCurrentBlock();
}

// set year to
for($y=2003;$y<=2020;$y++)
{
	$tpl->setCurrentBlock( "limit_output_year_to" );
    $tpl->setVariable( "limit_output_year_to_value", $y );
	$tpl->setVariable( "limit_output_year_to_content", $y );
    if($filterOptionsTime["yearTo"] == $y)
    {
        $tpl->setVariable( "limit_output_year_to_selected", "selected" );
    }
	elseif(!isset($filterOptionsTime["yearTo"]) && $dateArray["year"] == $y)
	{
		 $tpl->setVariable( "limit_output_year_to_selected", "selected" );
	}
    $tpl->parseCurrentBlock();
}

// common settings
$tpl->setVariable( "step", 1 );
$tpl->setVariable( "headlinetext", $lang_script["statistic.export.teaser.php"]["selectTANgroup"] );
$tpl->setVariable( "errors", join("<br", $errors) );

$tpl->setVariable( "lnk_detail", $fileStatisticDetailview."?projectId=".$projectId );
$tpl->setVariable( "lnk_diagramm", $fileStatisticChart."?projectId=".$projectId );
$tpl->setVariable( "lnk_pie", $fileStatisticPie."?projectId=".$projectId );
$tpl->setVariable( "lnk_table", $fileStatisticTable."?projectId=".$projectId );
$tpl->setVariable( "lnk_export", $fileStatisticExport."?projectId=".$projectId );

// display template
$tpl->parse();
$tpl->get();
$tpl->show();
?>
