<?php
// +----------------------------------------------------------------------+
// | sa project pilot                                                     |
// +----------------------------------------------------------------------+
// | Copyright (c) 2002 serie a - Digitale Medien und Systeme GmbH        |
// +----------------------------------------------------------------------+
// | Authors: 	Jrn Allert <allert@serie-a.de>                           |
// |          	Rene Renk   <renk@serie-a.de>                             |
// +----------------------------------------------------------------------+
//
// $Id: statistic.group.overview.php,v 1.1.1.1 2004/07/15 13:31:06 opensurveypilot Exp $

//session_start
@session_start();

// require all configuration files and libraries
require_once("./../config/config.inc.php"); // common config file
require_once($cfgPathToConf."/file.inc.php"); // project files
require_once($cfgPathToLib."/common.inc.php"); // common functions
require_once($cfgPathToSurveyFiles."/config/survey.config.inc.php"); // survey files
require_once($cfgPathToSurveyFiles."/config/survey.file.inc.php"); // survey files
require_once($cfgPathToSurveyFiles."/lib/survey.inc.php"); // survey functions
require_once($cfgPathToAuthFiles."/lib/user.inc.php"); // auth user functions
require_once($cfgPathToAuthFiles."/config/auth.file.inc.php"); // auth user functions
require_once($cfgPathToStatisticFiles."/config/statistic.file.inc.php"); // statistic user functions
require_once($cfgPathToAuthFiles."/lib/permission.inc.php"); // auth permission functions
require_once("HTML/Template/IT.php"); // PEAR::HTML_TEMPLATE_IT

// create new userFunctions object
$client = &new userFunctions;

//login check
if ($client->getAuthentication($_SESSION["sessionId"], session_id()) ==  false)
{
    //redirect to login page
    ?>
    <script type="text/javascript">
    <!--
    window.location.href="<?php echo $cfgUrlToProject."/".$fileAuthLogin; ?>";
    -->
    </script>
    <?php
    exit;
} 

// create new surveyFunctions object
$survey = &new surveyFunctions; 

// create Template IT object
$tpl = new HTML_Template_IT($cfgPathToStatisticTemplates);

// load template
$tpl->loadTemplatefile($templateStatisticGroupOverview, true, true);

// set title
$tpl->setVariable( "applicationtitle", $cfgApplicationType.$cfgApplicationVersion);

// get projectId id as get variable
if(isset($_GET["projectId"]))
{
    $projectId = $_GET["projectId"];
}
else
{
	$projectId = 0;
}

// get groupId id as get variable
if(isset($_GET["groupId"]))
{
    $groupId = $_GET["groupId"];
}
else
{
	$groupId = 0;
}

// get actual num as get variable
if(isset($_GET["actualNum"]))
{
    $actualNum = $_GET["actualNum"];
}
// get orderBy as get variable
if(isset($_GET["orderBy"]))
{
    $orderBy = $_GET["orderBy"];
}
else
{
    $orderBy = "FORM_ORDER";
}
// get direction as get variable
if(isset($_GET["direction"]))
{
    $direction = $_GET["direction"];
}

// maximum rows
$maxRow = $cfgMaxRowInOverviews;

//total rows  
$totalNum =  $survey->getSurveyGroupsNum($projectId, "", $groupId);

// actual rows
if (!isset($actualNum))
{
    $actualNum = 0;
}
// get the Number of pages
$numPages = intval($totalNum/$maxRow);
if ($numPages < ($totalNum/$maxRow))
{ 
    $numPages++;
}

// prev button
if ($actualNum > 0) 
{
    $y = $actualNum - $maxRow;
    
    $tpl->setVariable( "prev_button", "<a class=\"navigation\" href=\"$fileStatisticGroupOverview?projectId=$projectId&actualNum=$y&orderBy=$orderBy&direction=$direction\">&laquo;</a>" );
}
// display pages
for ($i = 1; $i <= $numPages; $i++)
{
    $y = ($i * $maxRow) - $maxRow;
    
    $tpl->setCurrentBlock( "num_buttons" );
    $tpl->setVariable( "num_button", "[<a class=\"navigation\" href=\"$fileStatisticGroupOverview?projectId=$projectId&actualNum=$y&orderBy=$orderBy&direction=$direction\">$i</a>]" );
    $tpl->parseCurrentBlock();
}
//  next button
if ($actualNum < ($totalNum - $maxRow)) 
{
    $y = $actualNum  + $maxRow;
    
    $tpl->setVariable( "next_button", "<a class=\"navigation\" href=\"$fileStatisticGroupOverview?projectId=$projectId&actualNum=$y&orderBy=$orderBy&direction=$direction\">&raquo;</a>" );
}

// entry to
$entryTo = ($actualNum + $maxRow) < $totalNum ? $actualNum + $maxRow : $totalNum;
// entry from
$entryFrom = $entryTo < 1 ? "0" : $actualNum +1;

$tpl->setVariable( "entry_from", $entryFrom );
$tpl->setVariable( "entry_to", $entryTo );
$tpl->setVariable( "entry_total", $totalNum );

// orderby butons
$tpl->setVariable( "order_link_nr_up", "$fileStatisticGroupOverview?projectId=$projectId&groupId=$groupId&actualNum=$actualNum&orderBy=FORM_ORDER&direction=ASC" );
$tpl->setVariable( "order_link_nr_down", "$fileStatisticGroupOverview?projectId=$projectId&groupId=$groupId&actualNum=$actualNum&orderBy=FORM_ORDER&direction=DESC" );
$tpl->setVariable( "order_link_name_up", "$fileStatisticGroupOverview?projectId=$projectId&groupId=$groupId&actualNum=$actualNum&orderBy=FORM_NAME&direction=ASC" );
$tpl->setVariable( "order_link_name_down", "$fileStatisticGroupOverview?projectId=$projectId&groupId=$groupId&actualNum=$actualNum&orderBy=FORM_NAME&direction=DESC" );
$tpl->setVariable( "order_link_insert_date_up", "$fileStatisticGroupOverview?projectId=$projectId&groupId=$groupId&actualNum=$actualNum&orderBy=FORM_INSERTDATE&direction=ASC" );
$tpl->setVariable( "order_link_insert_date_down", "$fileStatisticGroupOverview?projectId=$projectId&groupId=$groupId&actualNum=$actualNum&orderBy=FORM_INSERTDATE&direction=DESC" );

// get headline
$headlineArray =  $survey->getSurveyForGroupInQuestions($groupId,$projectId);
if($surveyQuestionsGroup->errorMessage)
{
    echo $surveyQuestionsGroup->errorMessage;
}
$tpl->setCurrentBlock( "headline" );
$tpl->setVariable( "survey_Id", $headlineArray[0]["FORM_PROJECT_ID_FK"] );
$tpl->setVariable( "headline_survey", $headlineArray[0]["PROJECT_NAME"] );
if($groupId != 0)
{
    $tpl->setVariable( "headline_group", " --> ".$headlineArray[0]["FORM_NAME"] );
}
$tpl->parseCurrentBlock();	

// get start sub folder nodes
$startSubFolder = $survey->getStartSubfolderNodes($projectId, $groupId);
for($l=0;$l<count($startSubFolder);$l++)
{
    // get questions
    $statisticOverviewArray = $survey->getSurveyGroupsForOverview($projectId, $startSubFolder[$l]["FORM_ID_PK"], $groupId, $actualNum, $maxRow, $orderBy, $direction);
    if($surveyOverview->errorMessage)
    {
        echo $surveyOverview->errorMessage;
    }
    for($j=0;$j<count($statisticOverviewArray);$j++)
    {
        // split string at 35 signs
    	$statisticOverviewArray[$j]["FORM_HEADER"] = substr($statisticOverviewArray[$j]["FORM_HEADER"],0,35);
    	$statisticOverviewArray[$j]["FORM_HEADER"] = $statisticOverviewArray[$j]["FORM_HEADER"]."...";
    	
    	// get count questions for group
    	$getQuestionsForGroup =	$survey->getQuestionsInGroup($statisticOverviewArray[$j]["FORM_ID_PK"]);
    
        $tpl->setCurrentBlock( "survey_group_overview" );
        $tpl->setVariable( "id", $statisticOverviewArray[$j]["FORM_ID_PK"] );
    	$tpl->setVariable( "name", $statisticOverviewArray[$j]["FORM_NAME"] );
        $tpl->setVariable( "form_header", $statisticOverviewArray[$j]["FORM_HEADER"] );
        $tpl->setVariable( "form_order", ($statisticOverviewArray[$j]["REL_ORDER_NUM"] + $actualNum));
    	$tpl->setVariable( "questions_in_group", $getQuestionsForGroup );
        $tpl->setVariable( "insertdate", $statisticOverviewArray[$j]["FORM_INSERTDATE"] );
        $tpl->setVariable( "chart_link", $fileStatisticGroupChart."?projectId=$projectId&groupId=".$statisticOverviewArray[$j]["FORM_ID_PK"] );
    	$tpl->setVariable( "pie_link", $fileStatisticGroupPie."?projectId=$projectId&groupId=".$statisticOverviewArray[$j]["FORM_ID_PK"] );
    	$tpl->setVariable( "table_link", $fileStatisticGroupTable."?projectId=$projectId&groupId=".$statisticOverviewArray[$j]["FORM_ID_PK"] );
        $tpl->setVariable( "export_link", $fileStatisticGroupExport."?projectId=$projectId&groupId=".$statisticOverviewArray[$j]["FORM_ID_PK"] );
        $tpl->parseCurrentBlock();	
    }
}

// get the parsed template and print it
$tpl->get();
$tpl->show();
?>
