<?php
// +----------------------------------------------------------------------+
// | sa project pilot                                                     |
// +----------------------------------------------------------------------+
// | Copyright (c) 2002 serie a - Digitale Medien und Systeme GmbH        |
// +----------------------------------------------------------------------+
// | Authors: 	Jrn Allert <allert@serie-a.de>                           |
// |          	Rene Renk   <renk@serie-a.de>                             |
// +----------------------------------------------------------------------+
//
// $Id: statistic.group.pie.php,v 1.1.1.1 2004/07/15 13:31:06 opensurveypilot Exp $

// start session
@session_start();

// require all configuration files and libraries
require_once("./../config/config.inc.php"); // common config file
require_once($cfgPathToConf."/file.inc.php"); // project files
require_once($cfgPathToLib."/common.inc.php"); // common functions
require_once($cfgPathToAuthFiles."/config/auth.file.inc.php"); // auth files
require_once($cfgPathToAuthFiles."/lib/user.inc.php"); // auth user functions
require_once($cfgPathToAuthFiles."/lib/permission.inc.php"); // auth user functions
require_once($cfgPathToSurveyFiles."/config/survey.config.inc.php"); // survey config
require_once($cfgPathToSurveyFiles."/config/survey.file.inc.php"); // survey files
require_once($cfgPathToSurveyFiles."/lib/survey.inc.php"); // survey functions
require_once($cfgPathToStatisticFiles."/config/statistic.file.inc.php"); // statistics files
require_once($cfgPathToStatisticFiles."/lib/statistic.inc.php"); // statistics functions
require_once("HTML/Template/IT.php"); // PEAR::HTML_TEMPLATE_IT
//require_once("phpchartdir.php"); // Chart Director
 
// create new userFunctions object
$client = &new userFunctions;
 
//login check
if ($client->getAuthentication($_SESSION["sessionId"], session_id()) ==  false)
{
    //redirect to login page
    ?>
    <script type="text/javascript">
    <!--
    window.location.href="<?php echo $cfgUrlToProject."/".$fileAuthLogin; ?>";
    -->
    </script>
    <?php
    exit;
}

// Start of checking the permissions 
$fileUserPermissionMode	=	$permUserStatisticGroupPie;
$filePermissionMode		=	$permStatisticGroupPie;

// filepermission
if($_SESSION["sessionUserStatusId"] < $filePermissionMode)
{
    ?>
    <script type="text/javascript">
    <!--
    window.location.href="<?php echo $cfgUrlToProject."/".$fileNoPermission."?messageCode=".$filePermissionMode."&messageType=file"; ?>";
    -->
    </script>
    <?php
    exit;
}
// get projectId
$projectId = (isset($_GET["projectId"])) ? $_GET["projectId"] : $_POST["projectId"];

// create new permissionFunctions object
$permission = &new permissionFunctions;

// get Permission
$permissionMode = $permission->getPermissionMode($_SESSION["sessionUserId"], $projectId, 1);
if($permission->errorMessage)
{
    echo $permission->errorMessage;
}

// userpermission
if($permissionMode < $fileUserPermissionMode)
{
    ?>
    <script type="text/javascript">
    <!--
    window.location.href="<?php echo $cfgUrlToProject."/".$fileNoPermission."?messageCode=".$fileUserPermissionMode."&messageType=user"; ?>";
    -->
    </script>
    <?php
    exit;
}
// End of checking the permissions

// create new surveyFunctions object
$survey = &new surveyFunctions;

// get group id
$groupId = $_GET["groupId"];

// empty chartOutput (png Image)
$_SESSION["chartOutput"] = "";

#Create a PieChart object of size 600 x 300 pixels
$c = new PieChart(600, 300, 0xcccccc, 0x999999);

$c->setBackground(0xffffc0, 0xffffe0);

#Set the center of the pie at (180, 140) and the radius to 100 pixels
$c->setPieSize(300, 140, 100);
    
// check if form was submitted
if($_SERVER["REQUEST_METHOD"] == "POST")
{
    // get project id
    $projectId = $_POST["projectId"];
    
    // get group id
    $groupId = $_POST["groupId"];
    
    // create new statisticFunctions object
    $statistic = &new statisticFunctions;
    
    // get question ids
    $questionString = $_POST["Addselection"];
    if($questionString != "")
    {
        // cut last # in $questionString;
        $questionStringCut = substr($questionString, 0, strlen($questionString)-1);
        // put values in array
        $questionIdArray = explode("#", $questionStringCut);
    }
    
    // get question names
    $questionNameString = $_POST["AddselectionName"];
    if($questionNameString != "")
    {
        // cut last # in $questionString;
        $questionNameStringCut = substr($questionNameString, 0, strlen($questionNameString)-1);
        // put values in array
        $questionNameArray = explode("#", $questionNameStringCut);
    }
    
    if(is_array($questionIdArray))
    {
        // get chart num
        $chartNum = count($questionIdArray);
        
        for($j=0;$j<$chartNum;$j++)
        {
            // add labels
            $labels[$j] = $statistic->encodeSpecialChars($questionNameArray[$j]);
            
            // cut last | in $questionString;
            $answerIdStringCut = substr($questionIdArray[$j], 0, strlen($questionIdArray[$j])-1);
            
            // get answer data from result table
            $answerNum = $statistic->getAnswerNum($projectId, $answerIdStringCut);
            
            // check for error
            if ($statistic->errorMessage)
            {
                $error = $statistic->errorMessage;
                echo $error;
            }
            
            $data[$j] = $answerNum;
        }
        
        // add legend at 5, 5
        $c->addLegend(5,5);
        
        // define colors
        //$colorArray = array("0xcc0000", "0x009933", "0x000099", "0xffff00", "0xff33ff", "0x999900", "0x9933cc", "0x993300", "0x003333", "0x99cc00", "0x000000");
        
        // set colors
        //$c->setColors($colorArray);
        
        #Draw the pie in 3D
        $c->set3D();
        
        #Set the pie data and the pie labels
        $c->setData($data, $labels);
    }
}

// save chart in session
$_SESSION["chartOutput"] = $c->makeChart2(PNG);

// create Template IT object
$tpl = new HTML_Template_IT($cfgPathToStatisticTemplates);

// load template
$tpl->loadTemplatefile($templateStatisticGroupPie, true, true);

// set title
$tpl->setVariable( "applicationtitle", $cfgApplicationType.$cfgApplicationVersion);
 
$tpl->setVariable( "questionarray", $javascriptArray );
$tpl->setVariable( "formaction", $fileStatisticPie);
$tpl->setVariable( "addselection", $_POST["Addselection"] );
$tpl->setVariable( "addselectionname", $_POST["AddselectionName"] );
$tpl->setVariable( "chart_add_link", $fileStatisticGroupAddChart."?projectId=$projectId&groupId=$groupId" );

$tpl->setVariable( "projectId", $projectId );
$tpl->setVariable( "groupId", $groupId );

// parse template
$tpl->parse();

// get the parsed template and print it
$tpl->get();
$tpl->show();
?>