<?php
// +----------------------------------------------------------------------+
// | sa project pilot                                                     |
// +----------------------------------------------------------------------+
// | Copyright (c) 2002 serie a - Digitale Medien und Systeme GmbH        |
// +----------------------------------------------------------------------+
// | Authors: 	Jrn Allert <allert@serie-a.de>                           |
// |          	Rene Renk   <renk@serie-a.de>                             |
// +----------------------------------------------------------------------+
//
// $Id: statistic.group.table.php,v 1.1.1.1 2004/07/15 13:31:08 opensurveypilot Exp $

require_once("./../config/config.inc.php"); // common config file
require_once("./../survey/lib/security/security.inc.php"); // security functions

// start session
@session_start();

// require all configuration files and libraries

require_once($cfgPathToConf."/file.inc.php"); // project files
require_once($cfgPathToLib."/common.inc.php"); // common functions
require_once($cfgPathToAuthFiles."/config/auth.file.inc.php"); // auth files
require_once($cfgPathToAuthFiles."/lib/user.inc.php"); // auth user functions
require_once($cfgPathToAuthFiles."/lib/permission.inc.php"); // auth user functions
require_once($cfgPathToSurveyFiles."/config/survey.config.inc.php"); // survey config
require_once($cfgPathToSurveyFiles."/config/survey.file.inc.php"); // survey files
require_once($cfgPathToSurveyFiles."/lib/survey.inc.php"); // survey functions
require_once($cfgPathToStatisticFiles."/config/statistic.file.inc.php"); // statistics files
require_once($cfgPathToStatisticFiles."/lib/statistic.inc.php"); // statistics functions
require_once("HTML/Template/IT.php"); // PEAR::HTML_TEMPLATE_IT
 
// create new userFunctions object
$client = &new userFunctions;
 
//login check
if ($client->getAuthentication($_SESSION["sessionId"], session_id()) ==  false)
{
    //redirect to login page
    ?>
    <script type="text/javascript">
    <!--
    window.location.href="<?php echo $cfgUrlToProject."/".$fileAuthLogin; ?>";
    -->
    </script>
    <?php
    exit;
}

// Start of checking the permissions 
$fileUserPermissionMode	=	$permUserStatisticGroupTable;
$filePermissionMode		=	$permStatisticGroupTable;

// filepermission
if($_SESSION["sessionUserStatusId"] < $filePermissionMode)
{
    ?>
    <script type="text/javascript">
    <!--
    window.location.href="<?php echo $cfgUrlToProject."/".$fileNoPermission."?messageCode=".$filePermissionMode."&messageType=file"; ?>";
    -->
    </script>
    <?php
    exit;
}
// get projectId
$projectId = (isset($_GET["projectId"])) ? $_GET["projectId"] : $_POST["projectId"];

// create new permissionFunctions object
$permission = &new permissionFunctions;

// get Permission
$permissionMode = $permission->getPermissionMode($_SESSION["sessionUserId"], $projectId, 1);
if($permission->errorMessage)
{
    echo $permission->errorMessage;
}
// userpermission
if($permissionMode < $fileUserPermissionMode)
{
    ?>
    <script type="text/javascript">
    <!--
    window.location.href="<?php echo $cfgUrlToProject."/".$fileNoPermission."?messageCode=".$fileUserPermissionMode."&messageType=user"; ?>";
    -->
    </script>
    <?php
    exit;
}
// End of checking the permissions

// create new surveyFunctions object
$statistics = &new statisticFunctions;

// create new surveyFunctions object
$survey = &new surveyFunctions;

// create Template IT object
$tpl = new HTML_Template_IT($cfgPathToStatisticTemplates);

// load template
$tpl->loadTemplatefile($templateStatisticTable, true, true);

// set title
$tpl->setVariable( "applicationtitle", $cfgApplicationType.$cfgApplicationVersion);

// get group id
$groupId = $_GET["groupId"];

// headline
$headlineArray =  $survey->getSurveyForGroup($projectId);

// if is tan protected
if($headlineArray[0]["PROJECT_SECURITY"] == "tan")
{
	// fill security object
	$securityFunctions = &new securityFunctions;
	$securityFunctions->setProjectId($projectId);
	$securityFunctions->setTanTableName();
	$securityFunctions->setTanGroupTableName();
	$securityFunctions->setTanGroupTableName();
	
	// check if groups to tans set
	$sessionGroupsToTans = ($_SESSION["groupsToTans"])? $_SESSION["groupsToTans"] : '';
	$securityFunctions->setGroupsToTans($sessionGroupsToTans);
	
	// get tangroupdata
	$groupsToTans = $securityFunctions->getGroupsToTans();
	$groupsToTansNames = $securityFunctions->getGroupsToTansNames();
	$groupsToTansIds = $securityFunctions->getGroupsToTansIds();
	$tpl->setVariable( "tan_groups", join(", ",$groupsToTansNames));
	//$allTans	=	$securityFunctions->getTanNum();
	//$usedTans	=	$securityFunctions->getUsedTanNum();
}
else
{
	// make sure old sessionvalues empty
	unset($_SESSION["groupsToTans"]);
	session_unregister("groupsToTans");
	$groupsToTansIds = '';
}


// survey name
$tpl->setVariable( "survey_name", $headlineArray[0]["PROJECT_NAME"] );

$groupArray = $survey->getSurveyForGroupInQuestions($groupId,$projectId);
// group name
$tpl->setVariable( "group_name", " -> ".$groupArray[0]["FORM_NAME"] );

// get user num 
$userNum = $statistics->getUserNum($projectId,$groupsToTansIds);
if($statistics->errorMessage)
{
    $error .= $statistics->$errorMessage;
}
$tpl->setVariable( "user_total_num", $userNum );

$onePercent = ($userNum / 100);

$maxRow = $survey->getQuestionsInGroup($groupId);
$questionArray = $survey->getSurveyQuestionsForGroup($groupId, 0, $maxRow, "FORMTYPE_ORDER", "ASC");
//print_r($questionArray);
for($l=0;$l<count($questionArray);$l++)
{
    // get type of question
    $formType = $questionArray[$l]["FORMTYPE_TYPE"];
    switch($formType)
    {
        case "select":
            // get answer num
            $answerArray = $survey->getQuestionsAnswers($questionArray[$l]["FORMTYPE_ID_PK"]);
            //print_r($answerArray);
            for($m=0;$m<count($answerArray);$m++)
            {
                $tpl->setCurrentBlock( "answer" );
                $tpl->setVariable( "answer", $answerArray[$m]["FORMELEMENT_HEADER"] );
                $tpl->parseCurrentBlock();
                
                // get answer num
                $answerNum = $statistics->getAnswerNum($projectId, $answerArray[$m]["FORMELEMENT_ID_PK"],$groupsToTansIds);
                // get percent
                $answerPercent = @round($answerNum / $onePercent,2);
                
                $tpl->setCurrentBlock( "answer_result" );
                $tpl->setVariable( "answer_result", $answerNum );
                $tpl->setVariable( "answer_percent", $answerPercent );
                $tpl->parseCurrentBlock();
            }
        break;
        
        case "radio":
            // get answer num
            $answerArray = $survey->getQuestionsAnswers($questionArray[$l]["FORMTYPE_ID_PK"]);
            //print_r($answerArray);
            for($m=0;$m<count($answerArray);$m++)
            {
                $tpl->setCurrentBlock( "answer" );
                $tpl->setVariable( "answer", $answerArray[$m]["FORMELEMENT_HEADER"] );
                $tpl->parseCurrentBlock();
                
                // get answer num
                $answerNum = $statistics->getAnswerNum($projectId, $answerArray[$m]["FORMELEMENT_ID_PK"],$groupsToTansIds);
                // get percent
                $answerPercent = @round($answerNum / $onePercent,2);
                
                $tpl->setCurrentBlock( "answer_result" );
                $tpl->setVariable( "answer_result", $answerNum );
                $tpl->setVariable( "answer_percent", $answerPercent );
                $tpl->parseCurrentBlock();
            }
        break;
        
        case "checkbox":
            // get answer num
            $answerArray = $survey->getQuestionsAnswers($questionArray[$l]["FORMTYPE_ID_PK"]);
            //print_r($answerArray);
            for($m=0;$m<count($answerArray);$m++)
            {
                $tpl->setCurrentBlock( "answer" );
                $tpl->setVariable( "answer", $answerArray[$m]["FORMELEMENT_HEADER"] );
                $tpl->parseCurrentBlock();
                
                // get answer num
                $answerNum = $statistics->getAnswerNum($projectId, $answerArray[$m]["FORMELEMENT_ID_PK"],$groupsToTansIds);
                // get percent
                $answerPercent = @round($answerNum / $onePercent,2);
                
                $tpl->setCurrentBlock( "answer_result" );
                $tpl->setVariable( "answer_result", $answerNum );
                $tpl->setVariable( "answer_percent", $answerPercent );
                $tpl->parseCurrentBlock();
            }
        break;
        
        case "textarea":
            // get answer num
            $textValueArray = $statistics->getTextValues($projectId, $questionArray[$l]["FORMTYPE_ID_PK"],$groupsToTansIds);
            
            // get answer num
            $answerNum = count($textValueArray);
            // display max 5 
            $maxAnswerNum = 5;
            
            $answerForNum = $answerNum < $maxAnswerNum ? $answerNum : $maxAnswerNum;
            //print_r($textValueArray);
            for($m=0;$m<$answerForNum;$m++)
            {
                $tpl->setCurrentBlock( "answer" );
                $tpl->setVariable( "answer", $textValueArray[$m]["RESULT_MULTIPLEVALUE"] );
                $tpl->parseCurrentBlock();
                
                // get percent
                $answerPercent = @round($textValueArray[$m]["num"] / $onePercent,2);
                
                $tpl->setCurrentBlock( "answer_result" );
                $tpl->setVariable( "answer_result", $textValueArray[$m]["num"] );
                $tpl->setVariable( "answer_percent", $answerPercent );
                $tpl->parseCurrentBlock();
            }
            if($answerNum > $maxAnswerNum)
            {
                $tpl->setCurrentBlock( "extended_result" );
                $tpl->setVariable( "extended_link", $fileStatisticTableTextAnswers."?projectId=".$projectId."&questionId=".$questionArray[$l]["FORMTYPE_ID_PK"] );
                $tpl->parseCurrentBlock();
            }
        break;
        
        case "text":
            // get answer num
            $textValueArray = $statistics->getTextValues($projectId, $questionArray[$l]["FORMTYPE_ID_PK"],$groupsToTansIds);
            
            // get answer num
            $answerNum = count($textValueArray);
            // display max 5 
            $maxAnswerNum = 5;
            
            $answerForNum = $answerNum < $maxAnswerNum ? $answerNum : $maxAnswerNum;
            //print_r($textValueArray);
            for($m=0;$m<$answerForNum;$m++)
            {
                $tpl->setCurrentBlock( "answer" );
                $tpl->setVariable( "answer", $textValueArray[$m]["RESULT_MULTIPLEVALUE"] );
                $tpl->parseCurrentBlock();
                
                // get percent
                $answerPercent = @round($textValueArray[$m]["num"] / $onePercent,2);
                
                $tpl->setCurrentBlock( "answer_result" );
                $tpl->setVariable( "answer_result", $textValueArray[$m]["num"] );
                $tpl->setVariable( "answer_percent", $answerPercent );
                $tpl->parseCurrentBlock();
            }
            if($answerNum > $maxAnswerNum)
            {
                $tpl->setCurrentBlock( "extended_result" );
                $tpl->setVariable( "extended_link", $fileStatisticTableTextAnswers."?projectId=".$projectId."&questionId=".$questionArray[$l]["FORMTYPE_ID_PK"] );
                $tpl->parseCurrentBlock();
            }
        break;
    }
    $tpl->setCurrentBlock( "question_detail" );
    $tpl->setVariable( "question", $questionArray[$l]["FORMTYPE_QUESTION"] );
    $tpl->parseCurrentBlock();
}

// parse template
$tpl->parse();

// get the parsed template and print it
$tpl->get();
$tpl->show();
?>