<?php
// +----------------------------------------------------------------------+
// | sa project pilot                                                     |
// +----------------------------------------------------------------------+
// | Copyright (c) 2002 serie a - Digitale Medien und Systeme GmbH        |
// +----------------------------------------------------------------------+
// | Authors: 	Jrn Allert <allert@serie-a.de>                           |
// |          	Rene Renk   <renk@serie-a.de>                             |
// +----------------------------------------------------------------------+
//
// $Id: statistic.overview.php,v 1.1.1.1 2004/07/15 13:31:08 opensurveypilot Exp $

//session_start
@session_start();

// require all configuration files and libraries
require_once("./../config/config.inc.php"); // common config file
require_once($cfgPathToConf."/file.inc.php"); // project files
require_once($cfgPathToLib."/common.inc.php"); // common functions
require_once($cfgPathToSurveyFiles."/config/survey.config.inc.php"); // survey files
require_once($cfgPathToSurveyFiles."/config/survey.file.inc.php"); // survey files
require_once($cfgPathToSurveyFiles."/lib/survey.inc.php"); // survey functions
require_once($cfgPathToAuthFiles."/lib/user.inc.php"); // auth user functions
require_once($cfgPathToAuthFiles."/config/auth.file.inc.php"); // auth user functions
require_once($cfgPathToStatisticFiles."/config/statistic.file.inc.php"); // statistic user functions
require_once($cfgPathToAuthFiles."/lib/permission.inc.php"); // auth permission functions
require_once("HTML/Template/IT.php"); // PEAR::HTML_TEMPLATE_IT

// create new userFunctions object
$client = &new userFunctions;

//login check
if ($client->getAuthentication($_SESSION["sessionId"], session_id()) ==  false)
{
    //redirect to login page
    ?>
    <script type="text/javascript">
    <!--
    window.location.href="<?php echo $cfgUrlToProject."/".$fileAuthLogin; ?>";
    -->
    </script>
    <?php
    exit;
}

// get surveyId id as get variable
if(isset($_GET["projectId"]))
{
    $projectId = $_GET["projectId"];
}
elseif(isset($_GET["projectId"]))
{
    $projectId = $_GET["projectId"];
}
else
{
	$projectId = 0;
}

// create new permissionFunctions object
$permission = &new permissionFunctions;

// create new surveyFunctions object
$surveyOverview = &new surveyFunctions; 

// create Template IT object
$tpl = new HTML_Template_IT($cfgPathToStatisticTemplates);

// load template
$tpl->loadTemplatefile($templateStatisticOverview, true, true);

// set title
$tpl->setVariable( "applicationtitle", $cfgApplicationType.$cfgApplicationVersion);

// get actual num as get variable
if(isset($_GET["actualNum"]))
{
    $actualNum = $_GET["actualNum"];
}
// get orderBy as get variable
if(isset($_GET["orderBy"]))
{
    $orderBy = $_GET["orderBy"];
}
else
{
    $orderBy = "PROJECT_NAME";
}
// get direction as get variable
if(isset($_GET["direction"]))
{
    $direction = $_GET["direction"];
}

// maximum rows
$maxRow = $cfgMaxRowInOverviews;

//total rows   
$totalNum =  $surveyOverview->getSurveysNum($projectId);

// actual rows
if (!isset($actualNum))
{
    $actualNum = 0;
}
// get the Number of pages
$numPages = intval($totalNum/$maxRow);
if ($numPages < ($totalNum/$maxRow))
{ 
    $numPages++;
}

// prev button
if ($actualNum > 0) 
{
    $y = $actualNum - $maxRow;
    
    $tpl->setVariable( "prev_button", "<a class=\"navigation\" href=\"$fileStatisticOverview?projectId=$projectId&actualNum=$y&orderBy=$orderBy&direction=$direction\">&laquo;</a>" );
}
// display pages
for ($i = 1; $i <= $numPages; $i++)
{
    $y = ($i * $maxRow) - $maxRow;
    
    $tpl->setCurrentBlock( "num_buttons" );
    $tpl->setVariable( "num_button", "[<a class=\"navigation\" href=\"$fileStatisticOverview?projectId=$projectId&actualNum=$y&orderBy=$orderBy&direction=$direction\">$i</a>]" );
    $tpl->parseCurrentBlock();
}
//  next button
if ($actualNum < ($totalNum - $maxRow)) 
{
    $y = $actualNum  + $maxRow;
    
    $tpl->setVariable( "next_button", "<a class=\"navigation\" href=\"$fileStatisticOverview?projectId=$projectId&actualNum=$y&orderBy=$orderBy&direction=$direction\">&raquo;</a>" );
}

if(($actualNum + $maxRow) < $totalNum)
{
    $entryTo = $actualNum + $maxRow;
}
else
{
    $entryTo = $totalNum;
}

// entry from
$entryFrom = $entryTo < 1 ? "0" : $actualNum +1;

$tpl->setVariable( "entry_from", $entryFrom );
$tpl->setVariable( "entry_to", $entryTo );
$tpl->setVariable( "entry_total", $totalNum );

// orderby butons
$tpl->setVariable( "order_link_name_up", "$fileStatisticOverview?projectId=$projectId&actualNum=$actualNum&orderBy=PROJECT_NAME&direction=ASC" );
$tpl->setVariable( "order_link_name_down", "$fileStatisticOverview?projectId=$projectId&actualNum=$actualNum&orderBy=PROJECT_NAME&direction=DESC" );
$tpl->setVariable( "order_link_author_up", "$fileStatisticOverview?projectId=$projectId&actualNum=$actualNum&orderBy=PROJECT_AUTHOR&direction=ASC" );
$tpl->setVariable( "order_link_author_down", "$fileStatisticOverview?projectId=$projectId&actualNum=$actualNum&orderBy=PROJECT_AUTHOR&direction=DESC" );
$tpl->setVariable( "order_link_active_up", "$fileStatisticOverview?projectId=$projectId&actualNum=$actualNum&orderBy=PROJECT_ACTIVE&direction=ASC" );
$tpl->setVariable( "order_link_active_down", "$fileStatisticOverview?projectId=$projectId&actualNum=$actualNum&orderBy=PROJECT_ACTIVE&direction=DESC" );
$tpl->setVariable( "order_link_insert_date_up", "$fileStatisticOverview?projectId=$projectId&actualNum=$actualNum&orderBy=PROJECT_TIMESTAMP&direction=ASC" );
$tpl->setVariable( "order_link_insert_date_down", "$fileStatisticOverview?projectId=$projectId&actualNum=$actualNum&orderBy=PROJECT_TIMESTAMP&direction=DESC" );

// get questions

$statisticOverviewArray = $surveyOverview->getSurveys($projectId, $actualNum, $maxRow, $orderBy, $direction);

if($surveyOverview->errorMessage)
{
    echo $surveyOverview->errorMessage;
}
for($j=0;$j<count($statisticOverviewArray);$j++)
{
    // get Permission
    $permissionMode = $permission->getPermissionMode($_SESSION["sessionUserId"], $statisticOverviewArray[$j]["PROJECT_ID_PK"], 1);
    // permission must be 1 (read) or higher
    if($permissionMode >= 1)
    {
        $tpl->setCurrentBlock( "survey_overview" );
        $tpl->setVariable( "id", $statisticOverviewArray[$j]["PROJECT_ID_PK"] );
    	$tpl->setVariable( "name", $statisticOverviewArray[$j]["PROJECT_NAME"] );
        $tpl->setVariable( "author", $statisticOverviewArray[$j]["PROJECT_AUTHOR"] );
		if($statisticOverviewArray[$j]["PROJECT_ACTIVE"] == "yes")
		{
		    $surveyActive = "aktiv";
		}
		else
		{
		    $surveyActive = "inaktiv";
		}
	    $tpl->setVariable( "active",$surveyActive );
        $tpl->setVariable( "insertdate", $statisticOverviewArray[$j]["PROJECT_TIMESTAMP"] );
        $tpl->setVariable( "detailview_link", $fileStatisticDetailview."?projectId=".$statisticOverviewArray[$j]["PROJECT_ID_PK"] );
        $tpl->parseCurrentBlock();
    }
}

// headline
$tpl->setCurrentBlock( "headline" );
if($totalNum == 1)
{
    $tpl->setVariable( "headline", $lang_script["statistic.overview.php"]["projectDetail"] );
}
else
{
    $tpl->setVariable( "headline", $lang_script["statistic.overview.php"]["allProjects"] );
}
$tpl->parseCurrentBlock();

// get the parsed template and print it
$tpl->get();
$tpl->show();
?>
