<?php
// +----------------------------------------------------------------------+
// | sa project pilot                                                     |
// +----------------------------------------------------------------------+
// | Copyright (c) 2002 serie a - Digitale Medien und Systeme GmbH        |
// +----------------------------------------------------------------------+
// | Authors: 	Jrn Allert <allert@serie-a.de>                           |
// |          	Rene Renk   <renk@serie-a.de>                             |
// +----------------------------------------------------------------------+
//
// $Id: statistic.table.dev.php,v 1.1.1.1 2004/07/15 13:31:10 opensurveypilot Exp $

// start session
@session_start();

// require all configuration files and libraries
require_once("./../config/config.inc.php"); // common config file
require_once($cfgPathToConf."/file.inc.php"); // project files
require_once($cfgPathToLib."/common.inc.php"); // common functions
require_once($cfgPathToAuthFiles."/config/auth.file.inc.php"); // auth files
require_once($cfgPathToAuthFiles."/lib/user.inc.php"); // auth user functions
require_once($cfgPathToAuthFiles."/lib/permission.inc.php"); // auth user functions
require_once($cfgPathToSurveyFiles."/config/survey.config.inc.php"); // survey config
require_once($cfgPathToSurveyFiles."/lib/security/security.inc.php"); // security functions
require_once($cfgPathToStatisticFiles."/config/statistic.file.inc.php"); // statistics files
require_once($cfgPathToStatisticFiles."/lib/statistic.inc.php"); // statistics functions
require_once("HTML/Template/IT.php"); // PEAR::HTML_TEMPLATE_IT
 
// create new userFunctions object
$client = &new userFunctions;
 
//login check
if ($client->getAuthentication($_SESSION["sessionId"], session_id()) ==  false)
{
    //redirect to login page
    ?>
    <script type="text/javascript">
    <!--
    window.location.href="<?php echo $cfgUrlToProject."/".$fileAuthLogin; ?>";
    -->
    </script>
    <?php
    exit;
}

// create new permissionFunctions object
$permission = &new permissionFunctions;

// get project id
$projectId = $_GET["projectId"];
 
// get Permission
$permissionMode = $permission->getPermissionMode($_SESSION["sessionUserId"], $projectId, 1);
if($permission->errorMessage)
{
    echo $permission->errorMessage;
}
// permission must be 1 (read)
if($permissionMode < 1)
{
    ?>
    <script type="text/javascript">
    <!--
    window.location.href="<?php echo $cfgUrlToProject."/".$fileNoPermission."?messageCode=1"; ?>";
    -->
    </script>
    <?php
    exit;
}

// create new surveyFunctions object
$statistics = &new statisticFunctions;

// create Template IT object
$tpl = new HTML_Template_IT($cfgPathToStatisticTemplates);

// load template
$tpl->loadTemplatefile($templateStatisticTable, true, true);

// set title
$tpl->setVariable( "applicationtitle", $cfgApplicationType.$cfgApplicationVersion);

// headline
$headlineArray =  $statistics->getSurveyForGroup($projectId);

// set additional header
//
// if is tan protected
if($headlineArray[0]["PROJECT_SECURITY"] == "tan")
{
	$additionalHeader = $lang_script["statistic.table.dev.php"]["securityTAN"];
	
	// get number of tans (used)
	$securityFunctions = &new securityFunctions;
	$securityFunctions->setProjectId($projectId);
	$securityFunctions->setTanTableName();
	$allTans	=	$securityFunctions->getTanNum();
	$usedTans	=	$securityFunctions->getUsedTanNum();

    $tpl->setCurrentBlock( "answer_result" );
    $tpl->setVariable( "tans_total_num", $allTans );
    $tpl->setVariable( "tans_used_num", $usedTans );
    $tpl->parseCurrentBlock();
	
}
//
// end set additional header
		
		
// survey name
$tpl->setVariable( "survey_name", $headlineArray[0]["PROJECT_NAME"] );

// get user num 
$userNum = $statistics->getUserNum($projectId);
if($statistics->errorMessage)
{
    $error .= $statistics->$errorMessage;
}
$tpl->setVariable( "user_total_num", $userNum );

$onePercent = ($userNum / 100);

$groupArray = $statistics->getGroupsForSurvey($projectId);

$groupArray = $statistics->getSortedGroups($projectId);

// set link for metadataoverview
$tpl->setCurrentBlock( "answer" );
$tpl->setVariable( "answer", $lang_script["statistic.table.dev.php"]["answerMessage"]);
$tpl->parseCurrentBlock();

$tpl->setCurrentBlock( "answer_result" );
$tpl->setVariable( "answer_result", "&nbsp;" );
$tpl->setVariable( "answer_percent", "&nbsp;" );
$tpl->parseCurrentBlock();
// link to overview
$tpl->setCurrentBlock( "extended_result" );
$tpl->setVariable( "linkname", $lang_script["statistic.table.dev.php"]["showMetadata"]);
$tpl->setVariable( "extended_link", $fileStatisticTableMetaData."?projectId=".$projectId);
$tpl->parseCurrentBlock();

$tpl->setCurrentBlock( "question_detail" );
$tpl->setVariable( "question", $lang_script["statistic.table.dev.php"]["overviewMetadata"]);
$tpl->parseCurrentBlock();
		
for($i=0;$i<count($groupArray);$i++)
{
	// if results are subgroup values
	if($groupArray[$i]["FORM_SUBGROUP"])
	{
		// subgrouppointer
		$parentGroupName = false;
		// parse array for parent group name
		foreach($groupArray as $key => $groupData)
		{
			($groupData["FORM_ID_PK"] == $groupArray[$i]["FORM_SUBGROUP"])? $parentGroupName = $groupData["FORM_NAME"] : "";
		}
        $tpl->setCurrentBlock( "question_detail" );
        $tpl->setVariable( "question", "<b>".$lang_script["statistic.table.dev.php"]["switchgroupresults"]."<br>".$lang_script["statistic.table.dev.php"]["linkedfromgroup"]."</b>");
	$tpl->setVariable( "answer", ($parentGroupName)? $parentGroupName : $lang_script["statistic.table.dev.php"]["noname"] );
        $tpl->parseCurrentBlock();
		continue;
	}
    $maxRow = $statistics->getQuestionsInGroup($groupArray[$i]["FORM_ID_PK"]);
    $questionArray = $statistics->getSurveyQuestionsForGroup($groupArray[$i]["FORM_ID_PK"], 0, $maxRow, "FORMTYPE_ORDER", "ASC");
	
	// set question data entries
    for($l=0;$l<count($questionArray);$l++)
    {
	
		// question
	    $tpl->setCurrentBlock("question_header");
	    $tpl->setVariable( "question", $questionArray[$l]["FORMTYPE_QUESTION"] );
	    $tpl->parseCurrentBlock();
	
        // get type of question
        $formType = $questionArray[$l]["FORMTYPE_TYPE"];
        switch($formType)
        {
            case "select":
                // get answer num
                $answerArray = $statistics->getQuestionsAnswers($questionArray[$l]["FORMTYPE_ID_PK"]);
                for($m=0;$m<count($answerArray);$m++)
                {
					$tpl->touchBlock("openrow");
					
					$tpl->setCurrentBlock("answer");
                    $tpl->setVariable( "answer", $answerArray[$m]["FORMELEMENT_HEADER"] );
                    $tpl->parseCurrentBlock();
                    
                    // get answer num
                    $answerNum = $statistics->getAnswerNum($projectId, $answerArray[$m]["FORMELEMENT_ID_PK"]);
                    // get percent
                    $answerPercent = @round($answerNum / $onePercent,2);
                    
                    $tpl->setCurrentBlock( "answer_result" );
                    $tpl->setVariable( "answer_result", $answerNum );
                    $tpl->setVariable( "answer_percent", "(".$answerPercent."&nbsp;%)" );
                    $tpl->parseCurrentBlock();
					
					$tpl->touchBlock("endrow");
                }
            break;
            
            case "radio":
                // get answer num
                $answerArray = $statistics->getQuestionsAnswers($questionArray[$l]["FORMTYPE_ID_PK"]);
                for($m=0;$m<count($answerArray);$m++)
                {
					$tpl->touchBlock("openrow");
					
                    $tpl->setCurrentBlock( "answer" );
                    $tpl->setVariable( "answer", $answerArray[$m]["FORMELEMENT_HEADER"] );
                    $tpl->parseCurrentBlock();
                    
                    // get answer num
                    $answerNum = $statistics->getAnswerNum($projectId, $answerArray[$m]["FORMELEMENT_ID_PK"]);
                    // get percent
                    $answerPercent = @round($answerNum / $onePercent,2);
                    
                    $tpl->setCurrentBlock( "answer_result" );
                    $tpl->setVariable( "answer_result", $answerNum );
                    $tpl->setVariable( "answer_percent", "(".$answerPercent."&nbsp;%)" );
                    $tpl->parseCurrentBlock();
					$tpl->touchBlock("endrow");
                }
            break;
            
            case "checkbox":
                // get answer num
                $answerArray = $statistics->getQuestionsAnswers($questionArray[$l]["FORMTYPE_ID_PK"]);
                for($m=0;$m<count($answerArray);$m++)
                {
					$tpl->touchBlock("openrow");
					
                    $tpl->setCurrentBlock( "answer" );
                    $tpl->setVariable( "answer", $answerArray[$m]["FORMELEMENT_HEADER"]);
                    $tpl->parseCurrentBlock();
                    
                    // get answer num
                    $answerNum = $statistics->getAnswerNum($projectId, $answerArray[$m]["FORMELEMENT_ID_PK"]);
                    // get percent
                    $answerPercent = @round($answerNum / $onePercent,2);
                    
                    $tpl->setCurrentBlock( "answer_result" );
                    $tpl->setVariable( "answer_result", $answerNum );
                    $tpl->setVariable( "answer_percent", "(".$answerPercent."&nbsp;%)" );
                    $tpl->parseCurrentBlock();
					
					$tpl->touchBlock("endrow");
                }
            break;
            
            case "checkboxtable":
                // get answer num
                $answerArray = $statistics->getQuestionsAnswers($questionArray[$l]["FORMTYPE_ID_PK"]);
				for($m=0;$m<count($answerArray);$m++)
                {
					$tpl->touchBlock("openrow");
                    $tpl->setCurrentBlock( "answer" );
                    $tpl->setVariable( "answer", $answerArray[$m]["FORMELEMENT_ADDHEADER"]." - ".$answerArray[$m]["FORMELEMENT_HEADER"] );
                    $tpl->parseCurrentBlock();
                    
                    // get answer num
                    $answerNum = $statistics->getAnswerNum($projectId, $answerArray[$m]["FORMELEMENT_ID_PK"]);
                    // get percent
                    $answerPercent = @round($answerNum / $onePercent,2);
                    
                    $tpl->setCurrentBlock( "answer_result" );
                    $tpl->setVariable( "answer_result", $answerNum );
                    $tpl->setVariable( "answer_percent", "(".$answerPercent."&nbsp;%)" );
                    $tpl->parseCurrentBlock();
					$tpl->touchBlock("endrow");
                }
            break;
            
            case "radiotable":
                // get answer num
                $answerArray = $statistics->getQuestionsAnswers($questionArray[$l]["FORMTYPE_ID_PK"]);
				for($m=0;$m<count($answerArray);$m++)
                {
					$tpl->touchBlock("openrow");
                    $tpl->setCurrentBlock( "answer" );
                    $tpl->setVariable( "answer", $answerArray[$m]["FORMELEMENT_ADDHEADER"]." - ".$answerArray[$m]["FORMELEMENT_HEADER"] );
                    $tpl->parseCurrentBlock();
                    
                    // get answer num
                    $answerNum = $statistics->getAnswerNum($projectId, $answerArray[$m]["FORMELEMENT_ID_PK"]);
                    // get percent
                    $answerPercent = @round($answerNum / $onePercent,2);
                    
                    $tpl->setCurrentBlock( "answer_result" );
                    $tpl->setVariable( "answer_result", $answerNum );
                    $tpl->setVariable( "answer_percent", "(".$answerPercent."&nbsp;%)" );
                    $tpl->parseCurrentBlock();
		    $tpl->touchBlock("endrow");
                }
            break;
            
            case "texttable":
				
				// get Number of answers
				$answerNum = $statistics->getTextValuesNum($projectId, $questionArray[$l]["FORMTYPE_ID_PK"]);
				
				// get answer options
                $answerArray = $statistics->getQuestionsAnswers($questionArray[$l]["FORMTYPE_ID_PK"]);
				
                // get answer options num
                $answerOptionNum = count($answerArray);
				//
				for($m=0;$m<$answerOptionNum;$m++)
                {
					$tpl->touchBlock("openrow");
                    $tpl->setCurrentBlock( "answer" );
                    $tpl->setVariable( "answer", $answerArray[$m]["FORMELEMENT_ADDHEADER"]." - ".$answerArray[$m]["FORMELEMENT_HEADER"] );
                    $tpl->parseCurrentBlock(); 
                    
                    $tpl->setCurrentBlock( "answer_result" );
                    $tpl->setVariable( "answer_result", "&nbsp;" );
                    $tpl->setVariable( "answer_percent", "&nbsp;" );
                    $tpl->parseCurrentBlock();
                }
				
                if($answerNum && $answerNum > 0)
                {
                    $tpl->setCurrentBlock( "extended_result" );
		    $tpl->setVariable( "linkname", $lang_script["statistic.table.dev.php"]["texttablevalues"]);
                    $tpl->setVariable( "extended_link", $fileStatisticTableTextAnswers."?projectId=".$projectId."&questionId=".$questionArray[$l]["FORMTYPE_ID_PK"]."&question=".urlencode($questionArray[$l]["FORMTYPE_QUESTION"]) );
                    $tpl->parseCurrentBlock();
                }
				$tpl->touchBlock("endrow");
            break;
            
            case "groupedtext":
                
				// get Number of answers
				$answerNum = $statistics->getTextValuesNum($projectId, $questionArray[$l]["FORMTYPE_ID_PK"]);
				
				// get answer options
                $answerArray = $statistics->getQuestionsAnswers($questionArray[$l]["FORMTYPE_ID_PK"]);
				
                // get answer options num
                $answerOptionNum = count($answerArray);
				//
                for($m=0;$m<$answerOptionNum;$m++)
                {
					$tpl->touchBlock("openrow");
                    $tpl->setCurrentBlock( "answer" );
                    $tpl->setVariable( "answer", $answerArray[$m]["FORMELEMENT_HEADER"] );
                    $tpl->parseCurrentBlock();
                    
                    $tpl->setCurrentBlock( "answer_result" );
                    $tpl->setVariable( "answer_result", "&nbsp;" );
                    $tpl->setVariable( "answer_percent", "&nbsp;" );
                    $tpl->parseCurrentBlock();
                }
				
                if($answerNum && $answerNum > 0)
                {
                    $tpl->setCurrentBlock( "extended_result" );
		    $tpl->setVariable( "linkname", $lang_script["statistic.table.dev.php"]["grouptextvalues"]);
                    $tpl->setVariable( "extended_link", $fileStatisticTableTextAnswers."?projectId=".$projectId."&questionId=".$questionArray[$l]["FORMTYPE_ID_PK"]."&question=".urlencode($questionArray[$l]["FORMTYPE_QUESTION"]) );
                    $tpl->parseCurrentBlock();
                }
				$tpl->touchBlock("endrow");
            break;
            
            case "textarea":
				
				// get Number of answers
				$answerNum = $statistics->getTextValuesNum($projectId, $questionArray[$l]["FORMTYPE_ID_PK"]);
				
				$tpl->touchBlock("openrow");
                $tpl->setCurrentBlock( "answer" );
                $tpl->setVariable( "answer", $lang_script["statistic.table.dev.php"]["textareainput"]);
                $tpl->parseCurrentBlock();
				
                $tpl->setCurrentBlock( "answer_result" );
                $tpl->setVariable( "answer_result", "&nbsp;" );
                $tpl->setVariable( "answer_percent", "&nbsp;" );
                $tpl->parseCurrentBlock();
				
                if($answerNum && $answerNum > 0)
                {
                    $tpl->setCurrentBlock( "extended_result" );
		    $tpl->setVariable( "linkname", $lang_script["statistic.table.dev.php"]["freetextvalues"]);
                    $tpl->setVariable( "extended_link", $fileStatisticTableTextAnswers."?projectId=".$projectId."&questionId=".$questionArray[$l]["FORMTYPE_ID_PK"]."&question=".urlencode($questionArray[$l]["FORMTYPE_QUESTION"]) );
                    $tpl->parseCurrentBlock();
                }
				$tpl->touchBlock("endrow");
            break;
            
            case "text":
				
				// get Number of answers
				$answerNum = $statistics->getTextValuesNum($projectId, $questionArray[$l]["FORMTYPE_ID_PK"]);
				
				$tpl->touchBlock("openrow");
                $tpl->setCurrentBlock( "answer" );
                $tpl->setVariable( "answer",  $lang_script["statistic.table.dev.php"]["textinput"]);
                $tpl->parseCurrentBlock();
                
                $tpl->setCurrentBlock( "answer_result" );
                $tpl->setVariable( "answer_result", "&nbsp;" );
                $tpl->setVariable( "answer_percent", "&nbsp;" );
                $tpl->parseCurrentBlock();
				
                if($answerNum && $answerNum > 0)
                {
                    $tpl->setCurrentBlock( "extended_result" );
		    $tpl->setVariable( "linkname", $lang_script["statistic.table.dev.php"]["textareavalues"]);
                    $tpl->setVariable( "extended_link", $fileStatisticTableTextAnswers."?projectId=".$projectId."&questionId=".$questionArray[$l]["FORMTYPE_ID_PK"]."&question=".urlencode($questionArray[$l]["FORMTYPE_QUESTION"]) );
                    $tpl->parseCurrentBlock();
                }
				$tpl->touchBlock("endrow");
            break;
            
            case "switchtext":
				
				// get Number of answers
				$answerNum = $statistics->getTextValuesNum($projectId, $questionArray[$l]["FORMTYPE_ID_PK"]);
				
				// get answer options
                $answerArray = $statistics->getQuestionsAnswers($questionArray[$l]["FORMTYPE_ID_PK"]);
                // get answer options num
                $answerOptionNum = count($answerArray);
				//
                for($m=0;$m<$answerOptionNum;$m++)
                {
		    $tpl->touchBlock("openrow");
                    $tpl->setCurrentBlock( "answer" );
                    $tpl->setVariable( "answer", $lang_script["statistic.table.dev.php"]["textinputswitch"]);
                    $tpl->parseCurrentBlock();
                    
                    $tpl->setCurrentBlock( "answer_result" );
                    $tpl->setVariable( "answer_result", "&nbsp;" );
                    $tpl->setVariable( "answer_percent", "&nbsp;" );
                    $tpl->parseCurrentBlock();
                }
				
                if($answerNum && $answerNum > 0)
                {
                    $tpl->setCurrentBlock( "extended_result" );
		    $tpl->setVariable( "linkname", $lang_script["statistic.table.dev.php"]["switchtextareavalues"]);
                    $tpl->setVariable( "extended_link", $fileStatisticTableTextAnswers."?projectId=".$projectId."&questionId=".$questionArray[$l]["FORMTYPE_ID_PK"]."&question=".urlencode($questionArray[$l]["FORMTYPE_QUESTION"]) );
                    $tpl->parseCurrentBlock();
                }
				$tpl->touchBlock("endrow");
            break;
        }   
		// question end
        $tpl->touchBlock("question_footer");
    }
}

// parse template
$tpl->parse();

// get the parsed template and print it
$tpl->get();
$tpl->show();
?>
