<?php
// +----------------------------------------------------------------------+
// | sa project pilot                                                     |
// +----------------------------------------------------------------------+
// | Copyright (c) 2002 serie a - Digitale Medien und Systeme GmbH        |
// +----------------------------------------------------------------------+
// | Authors: 	Jrn Allert <allert@serie-a.de>                           |
// |          	Rene Renk   <renk@serie-a.de>                             |
// +----------------------------------------------------------------------+
//
// $Id: statistic.table.metadata.php,v 1.1.1.1 2004/07/15 13:31:11 opensurveypilot Exp $

require_once("./../survey/lib/security/security.inc.php"); // security functions

// start session
@session_start();

// require all configuration files and libraries
require_once("./../config/config.inc.php"); // common config file
require_once($cfgPathToConf."/file.inc.php"); // project files
require_once($cfgPathToLib."/common.inc.php"); // common functions
require_once($cfgPathToAuthFiles."/config/auth.file.inc.php"); // auth files
require_once($cfgPathToAuthFiles."/lib/user.inc.php"); // auth user functions
require_once($cfgPathToAuthFiles."/lib/permission.inc.php"); // auth user functions
require_once($cfgPathToSurveyFiles."/config/survey.config.inc.php"); // survey config
require_once($cfgPathToSurveyFiles."/config/survey.file.inc.php"); // survey files
require_once($cfgPathToSurveyFiles."/lib/survey.inc.php"); // survey functions
require_once($cfgPathToStatisticFiles."/config/statistic.file.inc.php"); // statistics files
require_once($cfgPathToStatisticFiles."/lib/statistic.inc.php"); // statistics functions
require_once("HTML/Template/IT.php"); // PEAR::HTML_TEMPLATE_IT
 
// create new userFunctions object
$client = &new userFunctions;
 
//login check
if ($client->getAuthentication($_SESSION["sessionId"], session_id()) ==  false)
{
    //redirect to login page
    ?>
    <script type="text/javascript">
    <!--
    window.location.href="<?php echo $cfgUrlToProject."/".$fileAuthLogin; ?>";
    -->
    </script>
    <?php
    exit;
}

// create new permissionFunctions object
$permission = &new permissionFunctions;

// get project id
$projectId = $_GET["projectId"];
 
// get Permission
$permissionMode = $permission->getPermissionMode($_SESSION["sessionUserId"], $projectId, 1);
if($permission->errorMessage)
{
    echo $permission->errorMessage;
}
// permission must be 1 (read)
if($permissionMode < 1)
{
    ?>
    <script type="text/javascript">
    <!--
    window.location.href="<?php echo $cfgUrlToProject."/".$fileNoPermission."?messageCode=1"; ?>";
    -->
    </script>
    <?php
    exit;
}

// create new surveyFunctions object
$statistics = &new statisticFunctions;

// create new surveyFunctions object
$survey = &new surveyFunctions;

// create Template IT object
$tpl = new HTML_Template_IT($cfgPathToStatisticTemplates);

// load template
$tpl->loadTemplatefile($templateStatisticTableMetaData, true, true);

// set title
$tpl->setVariable( "applicationtitle", $cfgApplicationType.$cfgApplicationVersion);

// headline
$headlineArray =  $survey->getSurveyForGroup($projectId);

// if is tan protected
if($headlineArray[0]["PROJECT_SECURITY"] == "tan")
{
	// fill security object
	$securityFunctions = &new securityFunctions;
	$securityFunctions->setProjectId($projectId);
	$securityFunctions->setTanTableName();
	$securityFunctions->setTanGroupTableName();
	$securityFunctions->setTanGroupTableName();
	
	// check if groups to tans set
	$sessionGroupsToTans = ($_SESSION["groupsToTans"])? $_SESSION["groupsToTans"] : '';
	$securityFunctions->setGroupsToTans($sessionGroupsToTans);
	$sessionLimitOutputByDate = ($_SESSION["sessionLimitOutputByDate"])? $_SESSION["sessionLimitOutputByDate"] : '';
	if($sessionLimitOutputByDate)
	{
		$arrayFromTo["from"]	= $sessionLimitOutputByDate["from"]["timestamp"];
		$arrayFromTo["to"]	= $sessionLimitOutputByDate["to"]["timestamp"];
		$statistics->setResultTimeLimit($arrayFromTo);
	}
	// get tangroupdata
	$groupsToTans = $securityFunctions->getGroupsToTans();
	$groupsToTansNames = $securityFunctions->getGroupsToTansNames();
	$groupsToTansIds = $securityFunctions->getGroupsToTansIds();
	$tpl->setVariable( "tan_groups", join(", ",$groupsToTansNames));
	//$allTans	=	$securityFunctions->getTanNum();
	//$usedTans	=	$securityFunctions->getUsedTanNum();
}
else
{
	// make sure old sessionvalues empty
	unset($_SESSION["groupsToTans"]);
	session_unregister("groupsToTans");
	unset($_SESSION["sessionLimitOutputByDate"]);
	session_unregister("sessionLimitOutputByDate");
}

// survey name
$tpl->setVariable( "survey_name", $headlineArray[0]["PROJECT_NAME"] );

// get user num 
$userNum = $statistics->getUserNum($projectId,$groupsToTansIds);
if($statistics->errorMessage)
{
    $error .= $statistics->$errorMessage;
}
$tpl->setVariable( "user_total_num", $userNum );

$onePercent = ($userNum / 100);

// which values to fetch
$columnsToFetch = array('FILLED_USER_OS'=>$lang_script["statistic.table.metadata.php"]["userOS"], 'FILLED_USER_BROWSER'=>$lang_script["statistic.table.metadata.php"]["userBrowser"], 'FILLED_HTTP_REFERER'=>$lang_script["statistic.table.metadata.php"]["linkedfrom"], 'FILLED_REMOTE_ADDRESS'=>$lang_script["statistic.table.metadata.php"]["userIP"], 'FILLED_HOST_ADDRESS'=>$lang_script["statistic.table.metadata.php"]["userHostIP"]);// 

// get grouped metadata
$metaData	=	$statistics->getMetaValues($projectId, $columnsToFetch, $groupsToTansIds);
$metaData	=  (is_array($metaData))? $metaData : array();

// display values
foreach($metaData as $metaType => $metaResults)
{
	// loop $columnsToFetch
    for($i = 0;$i < count($metaResults) ;$i++)
    {
        $tpl->setCurrentBlock("metadata");
		// sweep Variable names from url
		$resultToShow	=	$metaResults[$i][$metaType];
		if($metaType == "FILLED_HTTP_REFERER")
		{
			$resultToShow	=	explode( "?", $resultToShow);
			$resultToShow	=	$resultToShow[0];
		}
		if(!$resultToShow)
		{
			if(!isset($resultToShow))
			{
				$resultToShow = $lang_script["statistic.table.metadata.php"]["emptyvalue"];
			}
			else
			{
				$resultToShow = $lang_script["statistic.table.metadata.php"]["novalue"];
			}
		}
        $tpl->setVariable("metadata", $resultToShow);
		$tpl->parseCurrentBlock();
        // get percent
        $answerPercent = @round($metaResults[$i]["num"] / $onePercent,2);
		$tpl->setCurrentBlock("metaresult");
		$tpl->setVariable( "metadata_result_num", $metaResults[$i]["num"]);
		$tpl->setVariable( "metadata_percent", "(".$answerPercent.")" );
		$tpl->parseCurrentBlock();
    }
	// question
	$tpl->setCurrentBlock( "meta_detail" );
	$tpl->setVariable( "metatype", $columnsToFetch[$metaType]);
	$tpl->parseCurrentBlock();
}

// parse template
$tpl->parse();

// get the parsed template and print it
$tpl->get();
$tpl->show();
?>
