<?php
// +----------------------------------------------------------------------+
// | sa project pilot                                                     |
// +----------------------------------------------------------------------+
// | Copyright (c) 2002 serie a - Digitale Medien und Systeme GmbH        |
// +----------------------------------------------------------------------+
// | Authors: 	Jrn Allert <allert@serie-a.de>                           |
// |          	Rene Renk   <renk@serie-a.de>                             |
// +----------------------------------------------------------------------+
//
// $Id: statistic.table.php,v 1.1.1.1 2004/07/15 13:31:13 opensurveypilot Exp $


require_once("./../survey/lib/security/security.inc.php"); // security functions

// start session
@session_start();

// require all configuration files and libraries
require_once("./../config/config.inc.php"); // common config file
require_once($cfgPathToConf."/file.inc.php"); // project files
require_once($cfgPathToLib."/common.inc.php"); // common functions
require_once($cfgPathToAuthFiles."/config/auth.file.inc.php"); // auth files
require_once($cfgPathToAuthFiles."/lib/user.inc.php"); // auth user functions
require_once($cfgPathToAuthFiles."/lib/permission.inc.php"); // auth user functions
require_once($cfgPathToSurveyFiles."/config/survey.config.inc.php"); // survey config
require_once($cfgPathToStatisticFiles."/config/statistic.file.inc.php"); // statistics files
require_once($cfgPathToStatisticFiles."/lib/statistic.inc.php"); // statistics functions
require_once("HTML/Template/IT.php"); // PEAR::HTML_TEMPLATE_IT
 
// create new userFunctions object
$client = &new userFunctions;
 
//login check
if ($client->getAuthentication($_SESSION["sessionId"], session_id()) ==  false)
{
    //redirect to login page
    ?>
    <script type="text/javascript">
    <!--
    window.location.href="<?php echo $cfgUrlToProject."/".$fileAuthLogin; ?>";
    -->
    </script>
    <?php
    exit;
}

// Start of checking the permissions 
$fileUserPermissionMode	=	$permUserStatisticTable;
$filePermissionMode		=	$permStatisticTable;

// filepermission
if($_SESSION["sessionUserStatusId"] < $filePermissionMode)
{
    ?>
    <script type="text/javascript">
    <!--
    window.location.href="<?php echo $cfgUrlToProject."/".$fileNoPermission."?messageCode=".$filePermissionMode."&messageType=file"; ?>";
    -->
    </script>
    <?php
    exit;
}
// get projectId
$projectId = (isset($_GET["projectId"])) ? $_GET["projectId"] : $_POST["projectId"];

// create new permissionFunctions object
$permission = &new permissionFunctions;

// get Permission
$permissionMode = $permission->getPermissionMode($_SESSION["sessionUserId"], $projectId, 1);
if($permission->errorMessage)
{
    echo $permission->errorMessage;
}
// userpermission
if($permissionMode < $fileUserPermissionMode)
{
    ?>
    <script type="text/javascript">
    <!--
    window.location.href="<?php echo $cfgUrlToProject."/".$fileNoPermission."?messageCode=".$fileUserPermissionMode."&messageType=user"; ?>";
    -->
    </script>
    <?php
    exit;
}
// End of checking the permissions

// create new surveyFunctions object
$statistics = &new statisticFunctions;

// create Template IT object
$tpl = new HTML_Template_IT($cfgPathToStatisticTemplates);

// headline
$headlineArray =  $statistics->getSurveyForGroup($projectId);

// set additional header
//
// if is tan protected
if($headlineArray[0]["PROJECT_SECURITY"] == "tan")
{
	// load template without logo
	$tpl->loadTemplatefile($templateStatisticTableContent, true, true);
	
	$additionalHeader = $lang_script["statistic.table.php"]["securityTAN"];
	
	// fill security object
	$securityFunctions = &new securityFunctions;
	$securityFunctions->setProjectId($projectId);
	$securityFunctions->setTanTableName();
	$securityFunctions->setTanGroupTableName();
	$securityFunctions->setTanGroupTableName();
	
	// check if groups to tans set
	$sessionGroupsToTans 	  = ($_SESSION["groupsToTans"])? $_SESSION["groupsToTans"] : 'all';
	$sessionLimitOutputByDate = ($_SESSION["sessionLimitOutputByDate"])? $_SESSION["sessionLimitOutputByDate"] : '';
	if($sessionLimitOutputByDate)
	{
		$arrayFromTo["from"]	= $sessionLimitOutputByDate["from"]["timestamp"];
		$arrayFromTo["to"]		= $sessionLimitOutputByDate["to"]["timestamp"];
		$statistics->setResultTimeLimit($arrayFromTo);
		$securityFunctions->setTanTimeLimit($arrayFromTo);
	}
	$securityFunctions->setGroupsToTans($sessionGroupsToTans);
	
	// display timerange
    $tpl->touchBlock( "timelimit" );
    $tpl->setVariable( "time_from", $sessionLimitOutputByDate["from"]["day"].".".$sessionLimitOutputByDate["from"]["month"].".".$sessionLimitOutputByDate["from"]["year"] );
    $tpl->setVariable( "time_to", $sessionLimitOutputByDate["to"]["day"].".".$sessionLimitOutputByDate["to"]["month"].".".$sessionLimitOutputByDate["to"]["year"] );

	// get tangroupdata
	$groupsToTans = $securityFunctions->getGroupsToTans();
	$groupsToTansNames = $securityFunctions->getGroupsToTansNames();
	$groupsToTansIds = $securityFunctions->getGroupsToTansIds();
	$tpl->setVariable( "tan_groups", join(", ",$groupsToTansNames));
	$allTans	=	$securityFunctions->getTanNum();
	$usedTans	=	$securityFunctions->getUsedTanNum();

    $tpl->setCurrentBlock( "answer_result" );
    $tpl->setVariable( "tans_total_num", $allTans );
    $tpl->setVariable( "tans_used_num", $usedTans );
    $tpl->parseCurrentBlock();
}
else
{
	// make sure old sessionvalues empty
	unset($_SESSION["groupsToTans"]);
	session_unregister("groupsToTans");
	unset($_SESSION["sessionLimitOutputByDate"]);
	session_unregister("sessionLimitOutputByDate");
	// load template with logo
	$tpl->loadTemplatefile($templateStatisticTableContentNoTan, true, true);
	$tpl->setVariable( "lnk_detail", $fileStatisticDetailview."?projectId=".$projectId );
	$tpl->setVariable( "lnk_diagramm", $fileStatisticChart."?projectId=".$projectId );
	$tpl->setVariable( "lnk_pie", $fileStatisticPie."?projectId=".$projectId );
	$tpl->setVariable( "lnk_table", $fileStatisticTable."?projectId=".$projectId );
	$tpl->setVariable( "lnk_export", $fileStatisticExport."?projectId=".$projectId );
}
//
// end set additional header

// set title
$tpl->setVariable( "applicationtitle", $cfgApplicationType.$cfgApplicationVersion);

// set projectID
$tpl->setVariable( "projectId", "$projectId" );


// survey name
$tpl->setVariable( "survey_name", $headlineArray[0]["PROJECT_NAME"] );

// get user num 
$userNum = $statistics->getUserNum($projectId,$groupsToTansIds);
if($statistics->errorMessage)
{
    $error .= $statistics->$errorMessage;
}
$tpl->setVariable( "user_total_num", $userNum );

if($userNum)
{
	$onePercent = ($userNum / 100);
}

$groupArray = $statistics->getSortedGroups($projectId);

// set link for metadataoverview
$tpl->setCurrentBlock( "answer" );
$tpl->setVariable( "answer", $lang_script["statistic.table.php"]["answerMessage"]);
$tpl->parseCurrentBlock();

$tpl->setCurrentBlock( "answer_result" );
$tpl->setVariable( "answer_result", "&nbsp;" );
$tpl->setVariable( "answer_percent", "&nbsp;" );
$tpl->parseCurrentBlock();
// link to overview
$tpl->setCurrentBlock( "extended_result" );
$tpl->setVariable( "linkname", $lang_script["statistic.table.php"]["showMetadata"]);
$tpl->setVariable( "extended_link", $fileStatisticTableMetaData."?projectId=".$projectId);
$tpl->parseCurrentBlock();

$tpl->setCurrentBlock( "question_detail" );
$tpl->setVariable( "question", $lang_script["statistic.table.php"]["overviewMetadata"]);
$tpl->parseCurrentBlock();

for($i=0;$i<count($groupArray);$i++)
{
	// if results are subgroup values
    $tpl->setCurrentBlock( "question_detail" );
	// check if rootgroup or subgroup
	($groupArray[$i]["FORM_PARENT_ID"])? $group = $lang_script["statistic.table.php"]["subgroup"] : $group = $lang_script["statistic.table.php"]["group"];
    $tpl->setVariable( "question", "<b>".$lang_script["statistic.table.php"]["answersfrom"]." ".$group.":</b>");
    $tpl->setVariable( "answer", $groupArray[$i]["FORM_NAME"]);
    $tpl->parseCurrentBlock();
	
    $maxRow = $statistics->getQuestionsInGroup($groupArray[$i]["FORM_ID_PK"]);
    $questionArray = $statistics->getSurveyQuestionsForGroup($groupArray[$i]["FORM_ID_PK"], 0, $maxRow, "FORMTYPE_ORDER", "ASC");
	
	// set question data entries
    for($l=0;$l<count($questionArray);$l++)
    {
        // get type of question
        $formType = $questionArray[$l]["FORMTYPE_TYPE"];
        switch($formType)
        {
            case "select":
                // get answer num
                $answerArray = $statistics->getQuestionsAnswers($questionArray[$l]["FORMTYPE_ID_PK"]);
                //print_r($answerArray);
                for($m=0;$m<count($answerArray);$m++)
                {
                    $tpl->setCurrentBlock( "answer" );
                    $tpl->setVariable( "answer", $answerArray[$m]["FORMELEMENT_HEADER"] );
                    $tpl->parseCurrentBlock();
                    
                    // get answer num
                    $answerNum = $statistics->getAnswerNum($projectId, $answerArray[$m]["FORMELEMENT_ID_PK"],$groupsToTansIds);
			        if (Pear::isError($answerNum)) 
			    	{
			       	    echo $answerNum->getMessage();
			   	 	}
                    // get percent
                    $answerPercent = @round($answerNum / $onePercent,2);
                    
                    $tpl->setCurrentBlock( "answer_result" );
                    $tpl->setVariable( "answer_result", $answerNum );
                    $tpl->setVariable( "answer_percent", "(".$answerPercent."&nbsp;%)" );
                    $tpl->parseCurrentBlock();
                }
            break;
            
            case "radio":
                // get answer num
                $answerArray = $statistics->getQuestionsAnswers($questionArray[$l]["FORMTYPE_ID_PK"]);
                //print_r($answerArray);
                for($m=0;$m<count($answerArray);$m++)
                {
                    $tpl->setCurrentBlock( "answer" );
                    $tpl->setVariable( "answer", $answerArray[$m]["FORMELEMENT_HEADER"] );
                    $tpl->parseCurrentBlock();
                    
                    // get answer num
                    $answerNum = $statistics->getAnswerNum($projectId, $answerArray[$m]["FORMELEMENT_ID_PK"],$groupsToTansIds);
			        if (Pear::isError($answerNum)) 
			    	{
			       	    echo $answerNum->getMessage();
			   	 	}
                    // get percent
                    $answerPercent = @round($answerNum / $onePercent,2);
                    
                    $tpl->setCurrentBlock( "answer_result" );
                    $tpl->setVariable( "answer_result", $answerNum );
                    $tpl->setVariable( "answer_percent", "(".$answerPercent."&nbsp;%)" );
                    $tpl->parseCurrentBlock();
                }
            break;
            
            case "checkbox":
                // get answer num
                $answerArray = $statistics->getQuestionsAnswers($questionArray[$l]["FORMTYPE_ID_PK"]);
                //print_r($answerArray);
                for($m=0;$m<count($answerArray);$m++)
                {
                    $tpl->setCurrentBlock( "answer" );
                    $tpl->setVariable( "answer", $answerArray[$m]["FORMELEMENT_HEADER"]);
                    $tpl->parseCurrentBlock();
                    
                    // get answer num
                    $answerNum = $statistics->getAnswerNum($projectId, $answerArray[$m]["FORMELEMENT_ID_PK"],$groupsToTansIds);
			        if (Pear::isError($answerNum)) 
			    	{
			       	    echo $answerNum->getMessage();
			   	 	}
                    // get percent
                    $answerPercent = @round($answerNum / $onePercent,2);
                    
                    $tpl->setCurrentBlock( "answer_result" );
                    $tpl->setVariable( "answer_result", $answerNum );
                    $tpl->setVariable( "answer_percent", "(".$answerPercent."&nbsp;%)" );
                    $tpl->parseCurrentBlock();
                }
            break;
            
            case "checkboxtable":
                // get answer num
                $answerArray = $statistics->getQuestionsAnswers($questionArray[$l]["FORMTYPE_ID_PK"]);
                for($m=0;$m<count($answerArray);$m++)
                {
                    $tpl->setCurrentBlock( "answer" );
                    $tpl->setVariable( "answer", $answerArray[$m]["FORMELEMENT_ADDHEADER"]." - ".$answerArray[$m]["FORMELEMENT_HEADER"] );
                    $tpl->parseCurrentBlock();
                    
                    // get answer num
                    $answerNum = $statistics->getAnswerNum($projectId, $answerArray[$m]["FORMELEMENT_ID_PK"],$groupsToTansIds);
			        if (Pear::isError($answerNum)) 
			    	{
			       	    echo $answerNum->getMessage();
			   	 	}
                    // get percent
                    $answerPercent = @round($answerNum / $onePercent,2);
                    
                    $tpl->setCurrentBlock( "answer_result" );
                    $tpl->setVariable( "answer_result", $answerNum );
                    $tpl->setVariable( "answer_percent", "(".$answerPercent."&nbsp;%)" );
                    $tpl->parseCurrentBlock();
                }
            break;
            
            case "radiotable":
                // get answer num
                $answerArray = $statistics->getQuestionsAnswers($questionArray[$l]["FORMTYPE_ID_PK"]);
                for($m=0;$m<count($answerArray);$m++)
                {
                    $tpl->setCurrentBlock( "answer" );
                    $tpl->setVariable( "answer", $answerArray[$m]["FORMELEMENT_ADDHEADER"]." - ".$answerArray[$m]["FORMELEMENT_HEADER"] );
                    $tpl->parseCurrentBlock();
                    
                    // get answer num
                    $answerNum = $statistics->getAnswerNum($projectId, $answerArray[$m]["FORMELEMENT_ID_PK"],$groupsToTansIds);
			        if (Pear::isError($answerNum)) 
			    	{
			       	    echo $answerNum->getMessage();
			   	 	}
					// get percent
                    $answerPercent = @round($answerNum / $onePercent,2);
                    
                    $tpl->setCurrentBlock( "answer_result" );
                    $tpl->setVariable( "answer_result", $answerNum );
                    $tpl->setVariable( "answer_percent", "(".$answerPercent."&nbsp;%)" );
                    $tpl->parseCurrentBlock();
                }
            break;
            
            case "texttable":
				
				// get Number of answers
				$answerNum = $statistics->getTextValuesNum($projectId, $questionArray[$l]["FORMTYPE_ID_PK"],$groupsToTansIds);
		        if (Pear::isError($answerNum)) 
		    	{
		       	    echo $answerNum->getMessage();
		   	 	}
				// get answer options
                $answerArray = $statistics->getQuestionsAnswers($questionArray[$l]["FORMTYPE_ID_PK"]);
				
                // get answer options num
                $answerOptionNum = count($answerArray);
				//
                for($m=0;$m<$answerOptionNum;$m++)
                {
                    $tpl->setCurrentBlock( "answer" );
                    $tpl->setVariable( "answer", $answerArray[$m]["FORMELEMENT_ADDHEADER"]." - ".$answerArray[$m]["FORMELEMENT_HEADER"] );
                    $tpl->parseCurrentBlock(); 
                    
                    $tpl->setCurrentBlock( "answer_result" );
                    $tpl->setVariable( "answer_result", "&nbsp;" );
                    $tpl->setVariable( "answer_percent", "&nbsp;" );
                    $tpl->parseCurrentBlock();
                }
				
                if($answerNum && $answerNum > 0)
                {
                    $tpl->setCurrentBlock( "extended_result" );
		    $tpl->setVariable( "linkname", $lang_script["statistic.table.php"]["texttablevalues"]);
                    $tpl->setVariable( "extended_link", $fileStatisticTableTextAnswers."?projectId=".$projectId."&questionId=".$questionArray[$l]["FORMTYPE_ID_PK"]."&question=".urlencode($questionArray[$l]["FORMTYPE_QUESTION"]) );
                    $tpl->parseCurrentBlock();
                }
            break;
            
            case "groupedtext":
                
				// get Number of answers
				$answerNum = $statistics->getTextValuesNum($projectId, $questionArray[$l]["FORMTYPE_ID_PK"],$groupsToTansIds);
		        if (Pear::isError($answerNum)) 
		    	{
		       	    echo $answerNum->getMessage();
		   	 	}
				// get answer options
                $answerArray = $statistics->getQuestionsAnswers($questionArray[$l]["FORMTYPE_ID_PK"]);
				
                // get answer options num
                $answerOptionNum = count($answerArray);
				//
                for($m=0;$m<$answerOptionNum;$m++)
                {
                    $tpl->setCurrentBlock( "answer" );
                    $tpl->setVariable( "answer", $answerArray[$m]["FORMELEMENT_HEADER"] );
                    $tpl->parseCurrentBlock();
                    
                    $tpl->setCurrentBlock( "answer_result" );
                    $tpl->setVariable( "answer_result", "&nbsp;" );
                    $tpl->setVariable( "answer_percent", "&nbsp;" );
                    $tpl->parseCurrentBlock();
                }
				
                if($answerNum && $answerNum > 0)
                {
                    $tpl->setCurrentBlock( "extended_result" );
		    $tpl->setVariable( "linkname", $lang_script["statistic.table.php"]["grouptextvalues"]);
                    $tpl->setVariable( "extended_link", $fileStatisticTableTextAnswers."?projectId=".$projectId."&questionId=".$questionArray[$l]["FORMTYPE_ID_PK"]."&question=".urlencode($questionArray[$l]["FORMTYPE_QUESTION"]) );
                    $tpl->parseCurrentBlock();
                }
            break;
            
            case "textarea":
				
				// get Number of answers
				$answerNum = $statistics->getTextValuesNum($projectId, $questionArray[$l]["FORMTYPE_ID_PK"],$groupsToTansIds);
		        if (Pear::isError($answerNum)) 
		    	{
		       	    echo $answerNum->getMessage();
		   	 	}
                $tpl->setCurrentBlock( "answer" );
                $tpl->setVariable( "answer",  $lang_script["statistic.table.php"]["textareainput"]);
                $tpl->parseCurrentBlock();
				
                $tpl->setCurrentBlock( "answer_result" );
                $tpl->setVariable( "answer_result", "&nbsp;" );
                $tpl->setVariable( "answer_percent", "&nbsp;" );
                $tpl->parseCurrentBlock();
				
                if($answerNum && $answerNum > 0)
                {
                    $tpl->setCurrentBlock( "extended_result" );
		    $tpl->setVariable( "linkname", $lang_script["statistic.table.php"]["freetextvalues"]);
                    $tpl->setVariable( "extended_link", $fileStatisticTableTextAnswers."?projectId=".$projectId."&questionId=".$questionArray[$l]["FORMTYPE_ID_PK"]."&question=".urlencode($questionArray[$l]["FORMTYPE_QUESTION"]) );
                    $tpl->parseCurrentBlock();
                }
            break;
            
            case "text":
				
				// get Number of answers
				$answerNum = $statistics->getTextValuesNum($projectId, $questionArray[$l]["FORMTYPE_ID_PK"],$groupsToTansIds);
		        if (Pear::isError($answerNum)) 
		    	{
		       	    echo $answerNum->getMessage();
		   	 	}
                $tpl->setCurrentBlock( "answer" );
                $tpl->setVariable( "answer", $lang_script["statistic.table.php"]["textinput"]);
                $tpl->parseCurrentBlock();
                
                $tpl->setCurrentBlock( "answer_result" );
                $tpl->setVariable( "answer_result", "&nbsp;" );
                $tpl->setVariable( "answer_percent", "&nbsp;" );
                $tpl->parseCurrentBlock();
				
                if($answerNum && $answerNum > 0)
                {
                    $tpl->setCurrentBlock( "extended_result" );
					$tpl->setVariable( "linkname", $lang_script["statistic.table.php"]["textareavalues"]);
                    $tpl->setVariable( "extended_link", $fileStatisticTableTextAnswers."?projectId=".$projectId."&questionId=".$questionArray[$l]["FORMTYPE_ID_PK"]."&question=".urlencode($questionArray[$l]["FORMTYPE_QUESTION"]) );
                    $tpl->parseCurrentBlock();
                }
            break;
            
            case "switchtext":
				
				// get Number of answers
				$answerNum = $statistics->getTextValuesNum($projectId, $questionArray[$l]["FORMTYPE_ID_PK"],$groupsToTansIds);
		        if (Pear::isError($answerNum)) 
		    	{
		       	    echo $answerNum->getMessage();
		   	 	}
				// get answer options
                $answerArray = $statistics->getQuestionsAnswers($questionArray[$l]["FORMTYPE_ID_PK"]);
                // get answer options num
                $answerOptionNum = count($answerArray);
				//
                for($m=0;$m<$answerOptionNum;$m++)
                {
                    $tpl->setCurrentBlock( "answer" );
                    $tpl->setVariable( "answer", $lang_script["statistic.table.php"]["textinputswitch"]);
                    $tpl->parseCurrentBlock();
                    
                    $tpl->setCurrentBlock( "answer_result" );
                    $tpl->setVariable( "answer_result", "&nbsp;" );
                    $tpl->setVariable( "answer_percent", "&nbsp;" );
                    $tpl->parseCurrentBlock();
                }
				
                if($answerNum && $answerNum > 0)
                {
                    $tpl->setCurrentBlock( "extended_result" );
					$tpl->setVariable( "linkname", $lang_script["statistic.table.php"]["switchtextareavalues"]);
                    $tpl->setVariable( "extended_link", $fileStatisticTableTextAnswers."?projectId=".$projectId."&questionId=".$questionArray[$l]["FORMTYPE_ID_PK"]."&question=".urlencode($questionArray[$l]["FORMTYPE_QUESTION"]) );
                    $tpl->parseCurrentBlock();
                }
            break;
        }   
		// question
        $tpl->setCurrentBlock( "question_detail" );
        $tpl->setVariable( "question", $questionArray[$l]["FORMTYPE_QUESTION"] );
		
        $tpl->parseCurrentBlock();
    }
}

// parse template
$tpl->parse();

// get the parsed template and print it
$tpl->get();
$tpl->show();
?>
