<?php
// +----------------------------------------------------------------------+
// | sa project pilot                                                     |
// +----------------------------------------------------------------------+
// | Copyright (c) 2002 serie a - Digitale Medien und Systeme GmbH        |
// +----------------------------------------------------------------------+
// | Authors: 	Jrn Allert <allert@serie-a.de>                           |
// |          	Rene Renk   <renk@serie-a.de>                             |
// +----------------------------------------------------------------------+
//
// $Id: statistic.table.textanswers.php,v 1.1.1.1 2004/07/15 13:31:14 opensurveypilot Exp $


require_once("./../survey/lib/security/security.inc.php"); // security functions

// start session
@session_start();

// require all configuration files and libraries
require_once("./../config/config.inc.php"); // common config file
require_once($cfgPathToConf."/file.inc.php"); // project files
require_once($cfgPathToLib."/common.inc.php"); // common functions
require_once($cfgPathToAuthFiles."/config/auth.file.inc.php"); // auth files
require_once($cfgPathToAuthFiles."/lib/user.inc.php"); // auth user functions
require_once($cfgPathToAuthFiles."/lib/permission.inc.php"); // auth user functions
require_once($cfgPathToSurveyFiles."/config/survey.config.inc.php"); // survey config
require_once($cfgPathToSurveyFiles."/config/survey.file.inc.php"); // survey files
require_once($cfgPathToSurveyFiles."/lib/survey.inc.php"); // survey functions
require_once($cfgPathToStatisticFiles."/config/statistic.file.inc.php"); // statistics files
require_once($cfgPathToStatisticFiles."/lib/statistic.inc.php"); // statistics functions
require_once("HTML/Template/IT.php"); // PEAR::HTML_TEMPLATE_IT
 
// create new userFunctions object
$client = &new userFunctions;
 
//login check
if ($client->getAuthentication($_SESSION["sessionId"], session_id()) ==  false)
{
    //redirect to login page
    ?>
    <script type="text/javascript">
    <!--
    window.location.href="<?php echo $cfgUrlToProject."/".$fileAuthLogin; ?>";
    -->
    </script>
    <?php
    exit;
}

// create new permissionFunctions object
$permission = &new permissionFunctions;

// get project id
$projectId = $_GET["projectId"];
 
// get Permission
$permissionMode = $permission->getPermissionMode($_SESSION["sessionUserId"], $projectId, 1);
if($permission->errorMessage)
{
    echo $permission->errorMessage;
}
// permission must be 1 (read)
if($permissionMode < 1)
{
    ?>
    <script type="text/javascript">
    <!--
    window.location.href="<?php echo $cfgUrlToProject."/".$fileNoPermission."?messageCode=1"; ?>";
    -->
    </script>
    <?php
    exit;
}

// get question id
$questionId = $_GET["questionId"];

// create new surveyFunctions object
$statistics = &new statisticFunctions;

// create Template IT object
$tpl = new HTML_Template_IT($cfgPathToStatisticTemplates);

// load template
$tpl->loadTemplatefile($templateStatisticTableTextAnswers, true, true);

// set title
$tpl->setVariable( "applicationtitle", $cfgApplicationType.$cfgApplicationVersion);

// headline
$headlineArray =  $statistics->getSurveyForGroup($projectId);

// if is tan protected
if($headlineArray[0]["PROJECT_SECURITY"] == "tan")
{
	// fill security object
	$securityFunctions = &new securityFunctions;
	$securityFunctions->setProjectId($projectId);
	$securityFunctions->setTanTableName();
	$securityFunctions->setTanGroupTableName();
	$securityFunctions->setTanGroupTableName();
	
	// check if groups to tans set
	$sessionGroupsToTans = ($_SESSION["groupsToTans"])? $_SESSION["groupsToTans"] : '';
	$securityFunctions->setGroupsToTans($sessionGroupsToTans);
	$sessionLimitOutputByDate = ($_SESSION["sessionLimitOutputByDate"])? $_SESSION["sessionLimitOutputByDate"] : '';
	if($sessionLimitOutputByDate)
	{
		$arrayFromTo["from"]	= $sessionLimitOutputByDate["from"]["timestamp"];
		$arrayFromTo["to"]	= $sessionLimitOutputByDate["to"]["timestamp"];
		$statistics->setResultTimeLimit($arrayFromTo);
	}
	// get tangroupdata
	$groupsToTans = $securityFunctions->getGroupsToTans();
	$groupsToTansNames = $securityFunctions->getGroupsToTansNames();
	$groupsToTansIds = $securityFunctions->getGroupsToTansIds();
	$tpl->setVariable( "tan_groups", join(", ",$groupsToTansNames));
	//$allTans	=	$securityFunctions->getTanNum();
	//$usedTans	=	$securityFunctions->getUsedTanNum();
}
else
{
	// make sure old sessionvalues empty
	unset($_SESSION["groupsToTans"]);
	session_unregister("groupsToTans");
	unset($_SESSION["sessionLimitOutputByDate"]);
	session_unregister("sessionLimitOutputByDate");
}

// survey name
$tpl->setVariable( "survey_name", $headlineArray[0]["PROJECT_NAME"] );

// get user num 
$userNum = $statistics->getUserNum($projectId, $groupsToTansIds);
if($statistics->errorMessage)
{
    $error .= $statistics->$errorMessage;
}
$tpl->setVariable( "user_total_num", $userNum );

$onePercent = ($userNum / 100);

// get answersoptions
$answerArray = $statistics->getQuestionsAnswers($questionId);

if(!$answerArray)
{
	$textValueArray[$answerArray[0]["FORMELEMENT_ID_PK"]] = $statistics->getTextValuesGrouped($projectId,'',$questionId, $groupsToTansIds);
	$idWithOptions[$answerArray[0]["FORMELEMENT_ID_PK"]] = $lang_script["statistic.table.textanswers.php"]["answer"];
}
// sort options to ids
for($i=0;$i<count($answerArray);++$i)
{
	$textValueArray[$answerArray[$i]["FORMELEMENT_ID_PK"]] = $statistics->getTextValuesGrouped($projectId, $answerArray[$i]["FORMELEMENT_ID_PK"],'',$groupsToTansIds);
	$idWithOptions[$answerArray[$i]["FORMELEMENT_ID_PK"]] = $answerArray[$i]["FORMELEMENT_HEADER"]." - ".$answerArray[$i]["FORMELEMENT_ADDHEADER"];
	(count($answerArray)==1)? ($idWithOptions[$answerArray[$i]["FORMELEMENT_ID_PK"]] = $lang_script["statistic.table.textanswers.php"]["answer"]) : "";
	$grandTotal = $grandTotal + $textValueArray[$answerArray[$i]["FORMELEMENT_ID_PK"]][(count($textValueArray[$answerArray[$i]["FORMELEMENT_ID_PK"]])-1)]["TOTALBYNOW"];
}
// question
$tpl->setVariable( "question", stripslashes(urldecode($_GET["question"])) );

// display values
if(!is_array($textValueArray))
{
	// parse template
	$tpl->parse();
	// get the parsed template and print it
	$tpl->get();
	$tpl->show();
	exit;
}
foreach($textValueArray as $optionKey => $resultValue)
{

	// results
	for($i=0;$i<count($resultValue);$i++)
	{
		$tpl->setCurrentBlock("results");
		$tpl->setVariable( "answer_result", $resultValue[$i]["RESULT_MULTIPLEVALUE"] );
		$tpl->setVariable( "answer_num", $resultValue[$i]["num"] ); 
		$answerPercent = @round($resultValue[$i]["num"] / $onePercent,2);
		$tpl->setVariable( "answer_percent", $answerPercent."%");
		$tpl->parseCurrentBlock("results");
		//
		$totalNumSum = $totalNumSum + ($resultValue[$i]["num"]* intval($resultValue[$i]["RESULT_MULTIPLEVALUE"]));
	}
	// option
	$tpl->setCurrentBlock("answer_option");
	
	
	/*
	if(count($answerArray)>1 && $totalNumSum > 0)
	{
		$tpl->setVariable("answer_sum_header", "Summe");
		$tpl->setVariable("answer_sum", "&nbsp;".$totalNumSum);
		$tpl->setVariable("answer_sum_percent", "(".@round(($totalNumSum/($grandTotal/100)),2)."%)");
	}
	elseif($totalNumSum > 0)
	{
		$tpl->setVariable("answer_sum_header", "Einzeleingabe");
		$tpl->setVariable("answer_sum", "&nbsp;".$totalNumSum);
		$tpl->setVariable("answer_sum_percent", "(".@round(($totalNumSum/($grandTotal/100)),2)."%)");
	}
	else
	{
		$tpl->setVariable("answer_sum_header", "Texteingabe");
		$tpl->setVariable("answer_sum", "Keine Summe");
	}*/
	
    $tpl->setVariable("answer", "&nbsp;".$idWithOptions[$optionKey]);
	$tpl->parseCurrentBlock("answer_option");
	$totalNumSum = 0;
}

// parse template
$tpl->parse();

// get the parsed template and print it
$tpl->get();
$tpl->show();
?>
