<?php
// +----------------------------------------------------------------------+
// | sm survey module - html_quickform_functions                          |
// +----------------------------------------------------------------------+
// | Copyright (c) 2002 serie a - Digitale Medien und Systeme GmbH        |
// +----------------------------------------------------------------------+
// | Authors: Jrn Allert <allert@serie-a.de>                             |
// |          Rene Renk <renk@serie-a.de>                                 |
// +----------------------------------------------------------------------+
// | Description: Basic functions to convert data to XML and vice versa   |
// |         								                              |
// +----------------------------------------------------------------------+
//
// $Id: createcss.inc.php,v 1.1.1.1 2004/07/15 13:32:44 opensurveypilot Exp $

//session_Start
@session_start();

// require all configuration files and libraries
require_once($cfgPathToProjectAdmin."/config/config.inc.php"); // common config file // common config file
require_once($cfgPathToConf."/file.inc.php"); // project files
require_once($cfgPathToSurveyFiles."/config/survey.config.inc.php"); // auth config file
require_once($cfgPathToSurveyConfig."/survey.file.inc.php"); // modules files
require_once($cfgPathToSurveyLib."/".$fileSrvyDBfunctions); // dbFunctions

/**
* createCSS class
*
*
* creates 
*
* @author  Jrn Allert <allert@serie-a.de>
* @author  Rene Renk <renk@serie-a.de>
* @access  public
*/
class createCSS
{

    /**
    *	handle for db connection
    *	@var  object  $dbclass
    */
    var $dbclass;

	/**
	*	CONSTRUCTOR
    *	opens database
    *
    *	@access	private
    *	@param	string	$err						error message
    */
    function createCSS()
    {
		// global Tabs
		global $cfgSrvyTabCss;
		global $cfgSrvyTabSurvey;
		global $cfgSrvyTabError;
		// global div
		global $cfgPathToOutput;
	
		// set vars
		$this->srvyTabCss		=	$cfgSrvyTabCss;
		$this->srvyTabError		=	$cfgSrvyTabError;
		$this->srvyTabSurvey		=	$cfgSrvyTabSurvey;
		$this->pathToOutput		=	$cfgPathToOutput;
		
		$this->dbclass = &new DB;
		$this->dbclass = DB::connect(DSN, true);
		if (DB::isError($this->dbclass)) 
        {    
			$err = "Could not connect to Database in function createCSS:createCSS";
            $this->getErrorMessage($err);
            $status = "error";
			return $status;
        }
    }

	/**
    *	gets error message
    *
    *	@access	private
    *	@param	string	$err						error message
    */
    function getErrorMessage($err)
    {
        echo "<br><br>--------------ERROR!!!------------------<br><b>".$this->errorMessage = $err. "</b><br>--------------ERROR!!!------------------<br><br>";
    }

    /**
	*	
	*	creates basic.css file
    *
    *	@access	public
	*
    *	@param	int		$surveyId				options to insert
    */
	function createCssFileFromDatabase($surveyId)
	{
		// get css values
		$mySqlStatement = "select * 
			from ".$this->srvyTabCss." 
			where CSSSTYLE_PROJECT_ID = '$surveyId'";
		//
		$dbResult = $this->dbclass->query($mySqlStatement);
		if (DB::isError($dbResult))
		{	
			$err = "Could not select in createCSS:createCssFileFromDatabase with Arguments: ".$mySqlStatement;
            $this->getErrorMessage($err);
            $status = "error";
		}
		// if data does not exists get default values
		if(!$resultData = $dbResult->fetchRow(DB_FETCHMODE_ASSOC))
		{
			$mySqlStatement = "select * 
				from ".$this->srvyTabCss." 
				where CSSSTYLE_PROJECT_ID = '0'";
			//
			$dbResult = $this->dbclass->query($mySqlStatement);
			if (DB::isError($dbResult))
			{	
				$err = "Could not select in createCSS:createCssFileFromDatabase with Arguments: ".$mySqlStatement;
	            $this->getErrorMessage($err);
	            return $status = "error1";
			}
			// no Data found
			if(!$resultData = $dbResult->fetchRow(DB_FETCHMODE_ASSOC))
			{
				return $status = "error2";
			}
		}
		// get css data
		$cssData = $resultData;
		//
		// get outputdir
		$mySqlStatement = "select * 
			from ".$this->srvyTabSurvey." 
			where PROJECT_ID_PK = '$surveyId'";
		//
		$dbResult = $this->dbclass->query($mySqlStatement);
		if (DB::isError($dbResult))
		{	
			$err = "Could not select in createCSS:createCssFileFromDatabase with Arguments: ".$mySqlStatement;
            $this->getErrorMessage($err);
            $status = "error";
		}
		if(!$resultData = $dbResult->fetchRow(DB_FETCHMODE_ASSOC))
		{
			return $status = "error3";
		}
		// get survey data
		$surveyData = $resultData;
		// outputdir
		$outputDir = $surveyData["PROJECT_OUTPUTDIR"];
		
		// assign cssdata
		$cssFontcolor			=		"#".$cssData["CSSSTYLE_FONTCOLOR"];
		$cssHeadercolor			=		"#".$cssData["CSSSTYLE_FONTCOLORHEADER"];
		$cssBgForm			=		"#".$cssData["CSSSTYLE_BGFORM"];
		$cssBgHeader			=		"#".$cssData["CSSSTYLE_BGHEADER"];
		$cssHeaderHeight		=		$cssData["CSSSTYLE_HEADERHEIGHT"];
		$cssBgInput			=		"#".$cssData["CSSSTYLE_BGINPUT"];
		$cssInputWidth			=		$cssData["CSSSTYLE_FIELDWIDTH"];
		$cssInputHeight			=		$cssData["CSSSTYLE_AREAHEIGHT"];
		$cssLinecolor			=		"#".$cssData["CSSSTYLE_LINECOLOR"];
		$cssRequiredcolor		=		"#".$cssData["CSSSTYLE_REQUIREDCOLOR"];
		$cssNumericcolor		=		"#".$cssData["CSSSTYLE_NUMERICCOLOR"];
		// fonttype
		switch($cssData["CSSSTYLE_FONTTYPE"])
		{
			case "arial":
			{
				$cssFontfamily = "arial,verdana,sans-serif";break;
			}
			case "verdana":
			{
				$cssFontfamily = "verdana,arial,sans-serif";break;
			}
			case "times":
			{
				$cssFontfamily = "Times New Roman,garamond,arial";break;
			}
			default:
			{
				$cssFontfamily = "arial,verdana,sans-serif";break;
			}
		}
		// fontsize
		$cssFontsizeHead		=	$cssData["CSSSTYLE_FONTSIZE"];
		$cssFontsizeQuestion		=	round($cssData["CSSSTYLE_FONTSIZE"]/100*80);
		$cssFontsizeLabel		=	round($cssData["CSSSTYLE_FONTSIZE"]/100*70);
		$cssFontsizeRequired		=	round($cssData["CSSSTYLE_FONTSIZE"]/100*60);
		
		// create file
		$cssFile="
		/*<!--//Define body styles-->*/\n																		
		\n
		\n
		body.basic				{background-color:".$cssBgForm.";}\n
		\n
		/*<!--//Define table styles-->*/\n																		
		\n
		table.basic				{align:left;width:100%;valign:top;}\n
		table.border			{background-color:#000000;}\n
		\n
		/*<!--//Define common table styles-->*/\n																
		\n
		td.basic			{background-color:".$cssBgForm.";}\n
		td.cssheader			{color:".$cssHeadercolor.";background-color:".$cssBgHeader.";font-family:".$cssFontfamily.";font-size:".$cssFontsizeHead."px;font-weight:bold;text-align:left;width:100%;height:".$cssHeaderHeight."px;}\n
		td.cssline			{width:100%;height:1px;}\n
		td.cssrequired			{color:".$cssFontcolor.";font-family:".$cssFontfamily.";font-size:".$cssFontsizeRequired."px;}\n
		td.csselement			{color:".$cssFontcolor.";font-family:".$cssFontfamily.";font-size:".$cssFontsizeLabel."px;align:left;width:50%;vertical-align:top;}\n
		td.cssoption			{color:".$cssFontcolor.";font-family:".$cssFontfamily.";font-size:".$cssFontsizeLabel."px;align:left;text-align:left;}\n
		td.csstableoption		{color:".$cssFontcolor.";font-family:".$cssFontfamily.";font-size:".$cssFontsizeLabel."px;align:left;text-align:center;vertical-align:middle;}\n
		td.csslogin			{color:".$cssFontcolor.";font-family:".$cssFontfamily.";font-size:".$cssFontsizeQuestion."px;}\n
		td.csselementlabel		{color:".$cssFontcolor.";font-family:".$cssFontfamily.";font-size:".$cssFontsizeQuestion."px;font-weight:bold;align:left;width:50%;}\n
		\n
		/*<!--//Define common form styles-->*/\n															
		\n
		textarea.basic			{color:".$cssFontcolor.";background-color:".$cssBgInput.";font-family:".$cssFontfamily.";font-size:".$cssFontsizeLabel."px;width:".$cssInputWidth."px;height:".$cssInputHeight."px;}\n
		input.basic			{color:".$cssFontcolor.";background-color:".$cssBgInput.";font-family:".$cssFontfamily.";font-size:".$cssFontsizeLabel."px;width:".$cssInputWidth."px;vertical-align:middle;}\n
		input.radio			{color:".$cssFontcolor.";background-color:".$cssBgForm.";font-family:".$cssFontfamily.";font-size:".$cssFontsizeLabel."px;vertical-align:middle;}\n
		input.checkbox			{color:".$cssFontcolor.";background-color:".$cssBgForm.";font-family:".$cssFontfamily.";font-size:".$cssFontsizeLabel."px;vertical-align:middle;}\n
		select.basic			{color:".$cssFontcolor.";background-color:".$cssBgInput.";font-family:".$cssFontfamily.";font-size:".$cssFontsizeLabel."px;}\n
		\n
		/*<!--//Define div form styles-->*/\n																
		\n
		span.csserror			{color:".$cssRequiredcolor.";background-color:".$cssBgForm.";font-family:".$cssFontfamily.";font-size:".$cssFontsizeRequired."px;align:left;vertical-align:top;}\n
		span.cssnumericerror		{color:".$cssNumericcolor.";background-color:".$cssBgForm.";font-family:".$cssFontfamily.";font-size:".$cssFontsizeRequired."px;align:left;vertical-align:top;}\n
		span.cssrequired		{color:".$cssFontcolor.";font-family:".$cssFontfamily.";font-size:".$cssFontsizeRequired."px;vertical-align:top;}\n
		\n
		/*<!--//Define hr styles-->*/\n																
		\n
		hr.csshr			{color:".$cssLinecolor.";size:1;}\n
		";
		// write css
		$cssOldFile = fopen ($this->pathToOutput."/".$outputDir."/basic.css", "w");
	    if(!$cssOldFile)
        {   
            $this->getErrorMessage("copySurveyStartFiles: can't create basic.css");
            return $status="error";
        }
        if(!fwrite($cssOldFile,$cssFile))
        {   
            $this->getErrorMessage("copySurveyStartFiles: can't write into basic.css");
            return false;
        }
        fclose($cssOldFile);
	}
	
    /**
	*	
	*	inserts css data into Database
    *
    *	@access	public
	*
    *	@param	int		$surveyId				SurveyId
    *   @param	array	$ruleOptions				Attributes to Change
    */
	function insertRuleDataIntoDatabase($ruleOptions,$surveyId = 0)
	{		
		// create mysqlStatementArguments
		foreach ($ruleOptions as $key => $value)
		{	
			if($value)
			{
			$mySqlStatementArgs .= " $key = '$value',";
			}
		}
		// cut comma from end
		$mySqlStatementArgs = substr($mySqlStatementArgs,0,(strlen($mySqlStatementArgs)-1));
		//
		// check if entry already exists
		$mySqlStatement = "select 1 
			from ".$this->srvyTabError." 
			where ERROR_PROJECT_ID = '$surveyId'";
		//
		$dbResult = $this->dbclass->query($mySqlStatement);
		if (DB::isError($dbResult))
		{	
			$err = "Could not select createCSS:insertRuleDataIntoDatabase with Arguments: ".$mySqlStatement;
            $this->getErrorMessage($err);
            $status = "error";
		}
		// if entry update
		if($dbResult->fetchRow())
		{
			foreach($ruleOptions as $key => $value)
			{	
				// sql
		        $mySqlStatement = "update 
					$this->srvyTabError 
					set 
					ERROR_MESSAGE = '$value' 
					where ERROR_PROJECT_ID = '$surveyId' 
					and ERROR_TYPE = '$key'";
				//
				$dbResult = $this->dbclass->query($mySqlStatement);
				if (DB::isError($dbResult))
				{	
					$err = "DBerror with update in createCSS:insertRuleDataIntoDatabase with Arguments: ".$mySqlStatement;
		            $this->getErrorMessage($err);
		            $status = "error";
				}
			}
		}
		// else insert
		else
		{
			foreach($ruleOptions as $key => $value)
			{	
				// get next free id
		        $nextId = $this->dbclass->nextId($this->srvyTabError);
				if (DB::isError($nextId)) 
		        {
					$err = "Could not get next_ID from ".$this->srvyTabError." in function createCSS:insertCssDataIntoDatabase";
		            $this->getErrorMessage($err);
		            $status = "error";
					return $status;
		        }
				// statement
				$mySqlStatement = "insert 
					into $this->srvyTabError 
					set ERROR_ID_PK = '$nextId', ERROR_PROJECT_ID = '$surveyId', ERROR_LANG = 'de', ERROR_TYPE = '$key', ERROR_MESSAGE = '$value'";
				//
				$dbResult = $this->dbclass->query($mySqlStatement);
				if (DB::isError($dbResult))
				{	
					$err = "DBerror with insert in createCSS:insertRuleDataIntoDatabase with Arguments: ".$mySqlStatement;
		            $this->getErrorMessage($err);
		            $status = "error";
					return $status;
		        }
				// english defaults
				
				// get next free id
		        $nextId = $this->dbclass->nextId($this->srvyTabError);
				if (DB::isError($nextId)) 
		        {
					$err = "Could not get next_ID from ".$this->srvyTabError." in function createCSS:insertCssDataIntoDatabase";
		            $this->getErrorMessage($err);
		            $status = "error";
					return $status;
		        }
				// statement
				$mySqlStatement = "insert 
					into $this->srvyTabError 
					set ERROR_ID_PK = '$nextId', ERROR_PROJECT_ID = '$surveyId', ERROR_LANG = 'en', ERROR_TYPE = '$key', ERROR_MESSAGE = '$value'";
				//
				$dbResult = $this->dbclass->query($mySqlStatement);
				if (DB::isError($dbResult))
				{	
					$err = "DBerror with insert in createCSS:insertRuleDataIntoDatabase with Arguments: ".$mySqlStatement;
		            $this->getErrorMessage($err);
		            $status = "error";
					return $status;
		        }
			}
		}
	return $status="ok";
	}

    /**
	*	
	*	inserts css data into Database
    *
    *	@access	public
	*
    *	@param	int		$surveyId				SurveyId
    *   @param	array	$cssOptions				Attributes to Change
    */
	function insertCssDataIntoDatabase($cssOptions,$surveyId=1)
	{		
		// create mysqlStatementArguments
		foreach ($cssOptions as $key => $value)
		{	
			if($value)
			{
			$mySqlStatementArgs .= " $key = '$value',";
			}
		}
		// cut comma from end
		$mySqlStatementArgs = substr($mySqlStatementArgs,0,(strlen($mySqlStatementArgs)-1));
		//
		// check if entry already exists
		$mySqlStatement = "select 1 
			from ".$this->srvyTabCss." 
			where CSSSTYLE_PROJECT_ID = '$surveyId'";
		//
		$dbResult = $this->dbclass->query($mySqlStatement);
		if (DB::isError($dbResult))
		{	
			$err = "Could not select createCSS:insertCssDataIntoDatabase with Arguments: ".$mySqlStatement;
            $this->getErrorMessage($err);
            $status = "error";
		}
		// if entry update
		if($dbResult->fetchRow())
		{
			// sql
	        $mySqlStatement = "update 
				$this->srvyTabCss 
				set 
				".$mySqlStatementArgs." 
				where CSSSTYLE_PROJECT_ID = '$surveyId'";
			//
			$dbResult = $this->dbclass->query($mySqlStatement);
			if (DB::isError($dbResult))
			{	
				$err = "DBerror with update in createCSS:insertCssDataIntoDatabase with Arguments: ".$mySqlStatement;
	            $this->getErrorMessage($err);
	            $status = "error";
			}
		}
		// else insert
		else
		{
			// get next free id
	        $nextId = $this->dbclass->nextId($this->srvyTabCss);
			if (DB::isError($nextId)) 
	        {
				$err = "Could not get next_ID from ".$this->srvyTabCss." in function createCSS:insertCssDataIntoDatabase";
	            $this->getErrorMessage($err);
	            $status = "error";
				return $status;
	        }
			// statement
			$mySqlStatementArgs = "CSSSTYLE_PROJECT_ID = '$surveyId', CSSSTYLE_ID_PK = '$nextId', ".$mySqlStatementArgs;
			$mySqlStatement = "insert 
				into ".$this->srvyTabCss." 
				set 
				".$mySqlStatementArgs;
			//
			$dbResult = $this->dbclass->query($mySqlStatement);
			if (DB::isError($dbResult))
			{	
				$err = "DBerror with insert in createCSS:insertCssDataIntoDatabase with Arguments: ".$mySqlStatement;
	            $this->getErrorMessage($err);
	            $status = "error";
				return $status;
	        }
		}
	return $status="ok";
	}
	
	
    /**
	*	
	*	copys a css-Block from other Survey
    *
    *	@access	public
	*
    *	@param	int		$surveyId				SurveyId
    *   @param	int		$copyFromId				Id of survey zo copy styles from
    */
	function copyCssFromDatabase($surveyId,$copyFromId)
	{
		// check if entry already exists
		$mySqlStatement = "select * 
			from ".$this->srvyTabCss." 
			where CSSSTYLE_PROJECT_ID = '$copyFromId'";
		//
		$dbResult = $this->dbclass->query($mySqlStatement);
		if (DB::isError($dbResult))
		{	
			$err = "Could not select in createCSS:copyCssFromDatabase with Arguments: ".$mySqlStatement;
            $this->getErrorMessage($err);
            $status = "error";
		}
		// if row exists
		if($resultData = $dbResult->fetchRow(DB_FETCHMODE_ASSOC))
		{
			// get next free id
	        $nextId = $this->dbclass->nextId($this->srvyTabCss);
			if (DB::isError($nextId)) 
	        {
				$err = "Could not get next_ID from ".$this->srvyTabCss." in function createCSS:copyCssFromDatabase";
	            $this->getErrorMessage($err);
	            $status = "error";
				return $status;
	        }
			// Set new Values
			$resultData["CSSSTYLE_ID_PK"] = $nextId;
			$resultData["CSSSTYLE_PROJECT_ID"] = $surveyId;
			// create mysqlStatementArguments
			foreach ($resultData as $key => $value)
			{	
				if($value)
				{
				$mySqlStatementArgs .= " $key = '$value',";
				}
			}
			// cut comma from end
			$mySqlStatementArgs = substr($mySqlStatementArgs,0,(strlen($mySqlStatementArgs)-1));
			//insert new row
			$mySqlStatement = "insert 
				into ".$this->srvyTabCss." 
				set 
				".$mySqlStatementArgs;
			//
			$dbResult = $this->dbclass->query($mySqlStatement);
			if (DB::isError($dbResult))
			{	
				$err = "DBerror with insert in createCSS:copyCssFromDatabase with Arguments: ".$mySqlStatement;
	            $this->getErrorMessage($err);
	            $status = "error";
				return $status;
	        }
		}
		// else insert default row
		else
		{
			// get next free id
	        $nextId = $this->dbclass->nextId($this->srvyTabCss);
			if (DB::isError($nextId)) 
	        {
				$err = "Could not get next_ID from ".$this->srvyTabCss." in function createCSS:copyCssFromDatabase";
	            $this->getErrorMessage($err);
	            $status = "error";
				return $status;
	        }
			//insert new row
			$mySqlStatement = "insert 
				into ".$this->srvyTabCss." 
				set 
				CSSSTYLE_ID_PK = '$nextId', CSSSTYLE_PROJECT_ID = '$surveyId'";
			//
			$dbResult = $this->dbclass->query($mySqlStatement);
			if (DB::isError($dbResult))
			{	
				$err = "DBerror with insert in createCSS:copyCssFromDatabase with Arguments: ".$mySqlStatement;
	            $this->getErrorMessage($err);
	            $status = "error";
				return $status;
	        }
		}
	}


    /**
	*	
	*	get css-Data for survey
    *
    *	@access	public
	*
    *	@param	int		$surveyId				SurveyId
    *   @param	int		$copyFromId				Id of survey zo copy styles from
    */
	function getCssDataFromDatabase($surveyId)
	{
		// check if entry already exists
		$mySqlStatement = "select * 
			from ".$this->srvyTabCss." 
			where CSSSTYLE_PROJECT_ID = '$surveyId'";
		//
		$dbResult = $this->dbclass->query($mySqlStatement);
		if (DB::isError($dbResult))
		{	
			$err = "Could not select in createCSS:copyCssFromDatabase with Arguments: ".$mySqlStatement;
            $this->getErrorMessage($err);
            $status = "error";
		}
		// if row exists
		if($resultData = $dbResult->fetchRow(DB_FETCHMODE_ASSOC))
		{
			return $resultData;
		}
		// if row does not exist
		$mySqlStatement = "select * 
			from ".$this->srvyTabCss." 
			where CSSSTYLE_PROJECT_ID = '0'";
		//
		$dbResult = $this->dbclass->query($mySqlStatement);
		if (DB::isError($dbResult))
		{	
			$err = "Could not select in createCSS:copyCssFromDatabase with Arguments: ".$mySqlStatement;
            $this->getErrorMessage($err);
            $status = "error";
		}
		// if row exists
		if($resultData = $dbResult->fetchRow(DB_FETCHMODE_ASSOC))
		{
			return $resultData;
		}
		// else error
		$err = "Could not get data in createCSS:copyCssFromDatabase with Arguments: ".$mySqlStatement;
        $this->getErrorMessage($err);
        $status = "error";
		return $status;
	}

    /**
	*	
	*	get css-Data for survey
    *
    *	@access	public
	*
    *	@param	int		$surveyId				SurveyId
    *   @param	int		$copyFromId				Id of survey zo copy styles from
    */
	function setCssDataToDefault($surveyId)
	{
		// check if entry already exists
		$mySqlStatement = "delete 
			from ".$this->srvyTabCss." 
			where CSSSTYLE_PROJECT_ID = '$surveyId'";
		//
		$dbResult = $this->dbclass->query($mySqlStatement);
		if (DB::isError($dbResult))
		{	
			$err = "Could not delete in createCSS:setCssDataToDefault with Arguments: ".$mySqlStatement;
            $this->getErrorMessage($err);
            $status = "error";
		}
		// get next free id
        $nextId = $this->dbclass->nextId($this->srvyTabCss);
		if (DB::isError($nextId)) 
        {
			$err = "Could not get next_ID from ".$this->srvyTabCss." in function createCSS:copyCssFromDatabase";
            $this->getErrorMessage($err);
            $status = "error";
			return $status;
        }
		//insert new row
		$mySqlStatement = "insert 
			into ".$this->srvyTabCss." 
			set 
			CSSSTYLE_ID_PK = '$nextId', CSSSTYLE_PROJECT_ID = '$surveyId'";
		//
		$dbResult = $this->dbclass->query($mySqlStatement);
		if (DB::isError($dbResult))
		{	
			$err = "DBerror with insert in createCSS:setCssDataToDefault with Arguments: ".$mySqlStatement;
            $this->getErrorMessage($err);
            $status = "error";
			return $status;
        }
	}
	
	
    /**
	*	
	*	get css-Data for survey
    *
    *	@access	public
	*
    *	@param	int		$surveyId				SurveyId
    *   @param	int		$copyFromId				Id of survey zo copy styles from
    */
	function deleteCssDataToDefault($surveyId)
	{
		// check if entry already exists
		$mySqlStatement = "delete 
			from ".$this->srvyTabCss." 
			where CSSSTYLE_PROJECT_ID = '$surveyId'";
		//
		$dbResult = $this->dbclass->query($mySqlStatement);
		if (DB::isError($dbResult))
		{	
			$err = "Could not delete in createCSS:setCssDataToDefault with Arguments: ".$mySqlStatement;
            $this->getErrorMessage($err);
            $status = "error";
		}
		return $status;
	}
}
?>
