<?php
// +----------------------------------------------------------------------+
// | sm survey module - template integration management                   |
// +----------------------------------------------------------------------+
// | Copyright (c) 2002 serie a - Digitale Medien und Systeme GmbH        |
// +----------------------------------------------------------------------+
// | Authors: Jrn Allert <allert@serie-a.de>                             |
// |          Rene Renk <renk@serie-a.de>                                 |
// +----------------------------------------------------------------------+
// | Description: Basic functions for upload management                   |
// +----------------------------------------------------------------------+
//
// $Id: tmpl2project.inc.php,v 1.1.1.1 2004/07/15 13:32:47 opensurveypilot Exp $

//session_Start
@session_start();

// require all configuration files and libraries
require_once($cfgPathToProjectAdmin."/config/config.inc.php"); // common config file // common config file
require_once($cfgPathToConf."/file.inc.php"); // project files
require_once($cfgPathToSurveyFiles."/config/survey.config.inc.php"); // auth config file
require_once($cfgPathToSurveyConfig."/survey.file.inc.php"); // modules files
require_once($cfgPathToTmplFiles."/lib/tmpl.inc.php"); // auth category functions

/**
* tmplFileCreate class
*
* extends tmplFunctions in template todule
*
* template integration class
*
* @author  Jrn Allert <allert@serie-a.de>
* @author  Rene Renk <renk@serie-a.de>
* @access  public
*/
class tmplFileCreate extends tmplFunctions
{

    /**
    *	handle for db connection
    *	@var    string  $db
    */
    var $dbSur = "";
	
    /**
    *	create new tmplFunctions object 
    *
    *	@access	public
    */
    function tmplFileCreate()
    {
		// call parent constructor
		parent::tmplFunctions();
		
		// global variables
		global $cfgSrvyTabTmpl2Project;
		global $cfgSrvyTabSurvey;
		
		global $cfgPathToOutput;
		global $cfgPathToCodebase;
		
		/*/ global codenames
		global $codeSurveyPreviewTop;
		global $codeSurveyPreviewContent;
		global $codeSurveyFormTop;
		global $codeSurveyFormContent;
		*/
		
		// set variables
		$this->tmplTabTmpl2Project	=	$cfgSrvyTabTmpl2Project;
		$this->tmplTabsurvey		=	$cfgSrvyTabSurvey;
		
		$this->tmplPathToOutput		=	$cfgPathToOutput;
		$this->tmplPathToCodebase	=	$cfgPathToCodebase;
		
		/*/ set codenames
		$this->codeSurveyPreviewTop		=	$codeSurveyPreviewTop;
		$this->codeSurveyPreviewContent		=	$codeSurveyPreviewContent;
		$this->codeSurveyFormTop		=	$codeSurveyFormTop;
		$this->codeSurveyFormContent		=	$codeSurveyFormContent;
		*/
		
      	// connect to survey database
        $this->dbSur = DB::connect(DSN, true);
        if (DB::isError($db)) 
        {    
            $this->setErrorMessage($dbSur->getMessage());
            return false;
        }
	}

	/**
    *	gets template names for overview
    *
    *	@access	private
	*
	*	$projectId			projectId
    *   @return array/false
    */
	function getTemplateNames($projectId)
	{
		// select ids of files used
        $sql = "select TMPL_TO_PRJCT_ID_PK, TMPL_TO_PRJCT_PROJECT_ID, TMPL_TO_PRJCT_FORM_ID, TMPL_TO_PRJCT_LOGIN_ID, TMPL_TO_PRJCT_CONFIRM_ID, TMPL_TO_PRJCT_DEACTIVATED_ID 
			from $this->tmplTabTmpl2Project 
            where TMPL_TO_PRJCT_PROJECT_ID = '$projectId'";
		//
        $result = $this->dbSur->query($sql);
        if (DB::isError($result)) 
        {
           $this->setErrorMessage($result->getMessage());
           return false;
        }
       	$templateIds = $result->fetchRow(DB_FETCHMODE_ASSOC);
		if($templateIds)
		{
			foreach($templateIds as $templateKey => $templateId)
			{
				// get content data
				$templateDataForId = $this->getContentData($templateId);
				// build names array
				$templateNames[$templateKey] = $templateDataForId["CONTENT_NAME"];
			}
			return $templateNames;
		}
		return false;
	}
	/**
    *	saves files to specified folder
    *
    *	@access	public
	*
	*	$filePath			template path
	*	$fileName			template Name
	*	$outputPath			target directory
	*	$targetName			target file Name
    *   @return true false
    */
	function saveToDir($filePath,$fileName,$outputPath,$targetName,$topCode,$contentCode,$type)
	{
		// read filecode
		if(!$fileCode	=	$this->readFileCode($filePath,$fileName))
		{
			return false;
		}
		// check if template valid
		if(!$this->checkTemplate($type,$fileCode))
		{
			return false;
		}
		//
		// replace topcode
		if($topCode)
		{
			if(!$topCode	=	$this->readFileCode($this->tmplPathToCodebase, $topCode))
			{
				return false;
			}
			$fileCode = str_replace('{topcode}', $topCode, $fileCode);
		}
		// replace contentcode
		if($contentCode)
		{
			if(!$contentCode	=	$this->readFileCode($this->tmplPathToCodebase, $contentCode))
			{
				return false;
			}
			$fileCode = str_replace('{contentcode}', $contentCode, $fileCode);
		}
		//
		// write file to outputdir
		if(!fwrite((fopen($outputPath."/".$targetName,"w+")) ,$fileCode))
        {   
            $this->setErrorMessage("saveToDir(): can't create preview.php");
            return false;
        }
		return true;
		//
	}
	
	/**
    *	check for aliasses
    *
    *	@access	private
    *   @return true/false
    */
    function checkTemplate($type,$templFile)
    {
	    global $lang_script;
		//
		switch ($type)
		{
			case "form":
			{	
				if((!ereg('{topcode}',$templFile))||(!ereg('{contentcode}',$templFile)))
				{
					$this->setErrorMessage($lang_script["tmpl2project.inc.php"]["checkTemplSubstError"]);
					return false;
				}
				break;
			}
			case "confirm":
			{	
				if(!ereg('{topcode}',$templFile)||(!ereg('{contentcode}',$templFile)))
				{
					$this->setErrorMessage($lang_script["tmpl2project.inc.php"]["checkTemplSubstError"]);
					return false;
				}
				break;
			}
			case "login":
			{	
				if(!ereg('{topcode}',$templFile))
				{
					$this->setErrorMessage($lang_script["tmpl2project.inc.php"]["checkTemplSubstError"]);
					return false;
				}
				break;
			}
		}
	return true;
	}

	/**
    *	saves all files with new template needed for preview
    *
    *	@access	private
    *   @return array path with Id as $key
    */
    function saveFileforProject($projectId, $type, $tmplPath, $fileId)
    {
		// global codenames
		global $lang_script;
		
		global $codeSurveyPreviewTop;
		global $codeSurveyPreviewContent;
		
		global $codeSurveyGroupdetailTop;
		global $codeSurveyGroupdetailContent;
		
		global $codeSurveyFormTop;
		global $codeSurveyFormContent;
		
		global $codeSurveyCofirmTop;
		global $codeSurveyCofirmContent;
		
		global $codeSurveyLoginTop;
		
		// get output path
        $sql = "select PROJECT_OUTPUTDIR 
			from $this->tmplTabsurvey 
            where PROJECT_ID_PK = '$projectId'";
		//
        $result = $this->dbSur->query($sql);
        if (DB::isError($result)) 
        {
           $this->setErrorMessage($result->getMessage());
           return false;
        }
        //
		$row = $result->fetchRow(DB_FETCHMODE_ASSOC); 
		$outputDir = $row["PROJECT_OUTPUTDIR"];
		$outputPath = $this->tmplPathToOutput."/".$outputDir;
		//
		// template name
		$fileData	= $this->getContentData($fileId);
		$fileName	= $fileData["CONTENT_FILENAME"];
		$filePath	= $this->pathToOutputTmpl."/".$fileData['path'];
		// save settings to database
		//
		// check what to save
		switch ($type)
		{
			case "form":
			{
				$toUpdateColumn 	= "TMPL_TO_PRJCT_FORM_ID";
				$targetName[0]		= "preview.php";
				$contentCode[0]		= $codeSurveyPreviewContent;
				$topCode[0]		= $codeSurveyPreviewTop;
				$targetName[1]		= "form.php";
				$contentCode[1]		= $codeSurveyFormContent;
				$topCode[1]		= $codeSurveyFormTop;
				$targetName[2]		= "groupdetail.php";
				$contentCode[2]		= $codeSurveyGroupdetailContent;
				$topCode[2]		= $codeSurveyGroupdetailTop;
				
				break;
			}
			case "confirm":
			{
				$toUpdateColumn 	= "TMPL_TO_PRJCT_CONFIRM_ID";
				$targetName[0]		= "confirm.php";
				$topCode[0]		= $codeSurveyCofirmTop;
				$contentCode[0]		= $codeSurveyCofirmContent;
				break;
			}
			case "login":
			{
				$toUpdateColumn 	= "TMPL_TO_PRJCT_LOGIN_ID";
				$targetName[0]		= "login.php";
				$topCode[0]		= $codeSurveyLoginTop;
				break;
			}
			case "deactivated":
			{
				$toUpdateColumn 	= "TMPL_TO_PRJCT_DEACTIVATED_ID";
				$targetName[0]		= "deactivated.php";
				break;
			}
			default:
			{
				$this->setErrorMessage($lang_script["tmpl2project.inc.php"]["templUpdateErrorMsg"]);
				return false;
			}
		
		}
		// check if data
	    $sql = "select TMPL_TO_PRJCT_ID_PK, TMPL_TO_PRJCT_PROJECT_ID, TMPL_TO_PRJCT_FORM_ID, TMPL_TO_PRJCT_LOGIN_ID, TMPL_TO_PRJCT_CONFIRM_ID, TMPL_TO_PRJCT_DEACTIVATED_ID 
			from $this->tmplTabTmpl2Project 
            where TMPL_TO_PRJCT_PROJECT_ID = $projectId";
		//
        $result = $this->dbSur->query($sql);
        if (DB::isError($result)) 
        {
           $this->setErrorMessage($result->getMessage());
           return false;
        }
        // get info update or insert
		if ($row = $result->fetchRow(DB_FETCHMODE_ASSOC)) 
        {
			// get backup
			$oldTemplateId = $row["$toUpdateColumn"];
			// update
	        $sql = "update 
				$this->tmplTabTmpl2Project 
				set 
				$toUpdateColumn = '$fileId'  
				where TMPL_TO_PRJCT_PROJECT_ID = '$projectId'";
			//
	        $result = $this->dbSur->query($sql);
	        if (DB::isError($result)) 
	        {
	           $this->setErrorMessage($result->getMessage());
			   return false;
	        }
		}
		else
		{
			//insert
			// get next free id
	        $nextId = $this->db->nextId($this->tmplTabTmpl2Project);
	        if (DB::isError($nextId)) 
	        {
	            $this->setErrorMessage($result->getMessage());
	            return false;
	        }
	        // create insert statement
	        $sql = "insert 
				into $this->tmplTabTmpl2Project 
	            (TMPL_TO_PRJCT_ID_PK, TMPL_TO_PRJCT_PROJECT_ID, $toUpdateColumn) 
	            values 
	            ('$nextId', '$projectId', '$fileId')";
			//
	        $result = $this->dbSur->query($sql);
	        if (DB::isError($result)) 
	        {
	           $this->setErrorMessage($result->getMessage());
	           return false;
	        }
		}
		// write fies
		for($i = 0; $i <count($targetName); $i++)
		{
			// save file
			if(!$this->saveToDir($filePath,$fileName,$outputPath,$targetName[$i],$topCode[$i],$contentCode[$i],$type))
			{
				if($nextId)
				{
					// get output path
			        $sql = "delete 
						from $this->tmplTabTmpl2Project 
			            where TMPL_TO_PRJCT_ID_PK = '$nextId'";
					//
			        $result = $this->dbSur->query($sql);
			        if (DB::isError($result)) 
			        {
			           $this->setErrorMessage($result->getMessage());
			           return false;
			        }
				}
				else if($oldTemplateId)
				{
					// update back to old template
			        $sql = "update 
						$this->tmplTabTmpl2Project 
						set 
						$toUpdateColumn = '$oldTemplateId'  
						where TMPL_TO_PRJCT_PROJECT_ID = '$projectId'";
					//
			        $result = $this->dbSur->query($sql);
			        if (DB::isError($result)) 
			        {
			           $this->setErrorMessage($result->getMessage());
					   return false;
			        }
				}
				return false;
			}
		}
		//
		return true;;
	}
}




?>
