<?php
// +----------------------------------------------------------------------+
// | sm survey module -	createformparts									  |
// +----------------------------------------------------------------------+
// | Copyright (c) 2002 serie a - Digitale Medien und Systeme GmbH        |
// +----------------------------------------------------------------------+
// | Authors: Jrn Allert <allert@serie-a.de>                             |
// |          Rene Renk <renk@serie-a.de>                                 |
// +----------------------------------------------------------------------+
// | Description: Basic functions to pass data to html_Quickform/Pearclass|
// |         								                              |
// +----------------------------------------------------------------------+
//
// $Id: createformparts.inc.php,v 1.1.1.1 2004/07/15 13:32:51 opensurveypilot Exp $

//session_Start
@session_start();

// require all configuration files and libraries
require_once($cfgPathToProjectAdmin."/config/config.inc.php"); // common config file // common config file
require_once($cfgPathToConf."/file.inc.php"); // project files
require_once($cfgPathToSurveyFiles."/config/survey.config.inc.php"); // auth config file
require_once($cfgPathToSurveyConfig."/survey.file.inc.php"); // modules files
require_once($cfgPathToSurveyLib."/".$fileSrvyDBfunctions); // dbFunctions
require_once($cfgPathToSurveyLib."/".$fileSrvyQuickformExtended); //Quickformextension

/**
* createFormParts class
*
* extended by createQuickFormFunctions class 
*
* formelement creating class
*
* @author  Jrn Allert <allert@serie-a.de>
* @author  Rene Renk <renk@serie-a.de>
* @access  public
*/
class createFormParts
{	
	/**
	*	creates Hiddenfield
	*
    *	@access	public
    *	@param	array	$formPartTagData 			Array containing Elementdata surrogat from $this->qffTypeArray
	*/
	function qffCreateHidden($myHiddenName,$myHiddenValue,$hiddenNew=1)
    {
		//set new value for hidden if wanted
		if($hiddenNew==1)
		{
			$constants[$myHiddenName] = $myHiddenValue;
			$this->processedForm->setConstants($constants);
		}
		//create Hidden 	-------   $form->addElement('hidden', 'ihidTest', 'hiddenField');
		$this->processedForm->addElement('hidden', 
										$myHiddenName,
										$myHiddenValue);
	}
	
	/**
	*	creates Headerfield
	*
    *	@access	public
    *	@param	array	$formPartTagData 			Array containing Elementdata surrogat from $this->qffTypeArray
	*/
	function qffAddHeader($header)
    {
		//add Header
		$this->processedForm->addHeader($header);
	}
	
	/**
	*	replaces non required aliasses
	*
    *	@access	public
    *	@param	string		$html 			String containing to be cleared aliasses
	*/
	function qffClearObsoleteAliasses($html)
    {
		// replace alias
		$html		= 	str_replace('{require}', "", $html);
		// replace alias
		$html 		= 	str_replace('{label}', "", $html);
		// replace alias
		$html		=	str_replace('{addimage}', "", $html);
		// replace alias
		$html 		= 	str_replace('{validationerror}', "&nbsp;", $html);
		// replace alias{rowheadertdwidth}
		$html 		= 	str_replace('{rowheader}', "&nbsp;", $html);
		// replace alias{rowheadertdwidth}
		$html 		= 	str_replace('{rowheadertdwidth}', "", $html);
		// replace alias{rowheadertdwidth}
		$html 		= 	str_replace('{optionlabels}', "", $html);
		// replace alias{rowheadertdwidth}
		$html 		= 	str_replace('{optiontdwidth}', "", $html);
		// replace alias{rowheadertdwidth}
		$html 		= 	str_replace('{optiontdwidth}', "", $html);
		// return cleared string
		return $html;
	}
	
	/**
	*	function to replace dynamic variables like date...
	*
    *	@access	public
    *	@param	string	$haystack 
    */
	function variableReplace($haystack)
	{
		//date
		$dateToShow = date("d.m.y");
		$newString = str_replace("###DATE###", $dateToShow, $haystack);
		// Tangroup
		$newString = str_replace("###TANGROUP###", $_SESSION["tanGroupName"], $newString);
		return $newString;
	}
	
	/**
	*	applies additional rules for conventional elemnets
	*
    *	@access	public
    *	@param	array	$RulesData 
    */
	function qffProcessRules($processRulesData)
	{	
		// no rules
		if(count($processRulesData) == 0)
		{
			return;
		}
		// process rules
		for($k = 0; $k < count($processRulesData) ; ++$k)
		{
			// add rule  addRule($element, $message='', $type='', $format='', $validation='server', $reset = false, $force = false)
			$this->processedForm->addRule($processRulesData[$k]["ELEMENTRULE_FORMTYPE_ID_FK"],$processRulesData[$k]["ELEMENTRULE_ALERT"],$processRulesData[$k]["ELEMENTRULE_ATTRIBUTE"],$processRulesData[$k]["ELEMENTRULE_VALUE"],$processRulesData[$k]["ELEMENTRULE_VALIDATION_TYPE"],false,'','','',$processRulesData[$k]["ELEMENTRULE_CHECKALLOW"]);  
		}
	}
	
	/**
	*	applies additional rules for table elements
	*
    *	@access	public
    *	@param	array	$RulesData 
    */
	function qffProcessTableRules($processRulesData, $rows, $cols, $formType, &$processedFormData)
	{	
		// check which type of table is processed and addRule 
		switch($formType)
		{
			case "radiotable":
				// no rules
				if(count($processRulesData) == 0)
				{
					return;
				}
				// process rules
				for($k = 0; $k < count($processRulesData) ; ++$k)
				{
					for ($i = 0; $i < $rows; ++$i)
					{
						// add rule  addRule($element, $message='', $type='', $format='', $validation='server', $reset = false, $force = false)
						$this->processedForm->addRule($processRulesData[$k]["ELEMENTRULE_FORMTYPE_ID_FK"]."[$i]",$processRulesData[$k]["ELEMENTRULE_ALERT"],$processRulesData[$k]["ELEMENTRULE_ATTRIBUTE"],$processRulesData[$k]["ELEMENTRULE_VALUE"],$processRulesData[$k]["ELEMENTRULE_VALIDATION_TYPE"],false,"",$formType);
					}
				}
				break;
			case "checkboxtable":
				// no rules
				if(count($processRulesData) == 0)
				{
					return;
				}
				// process rules
				for($k = 0; $k < count($processRulesData) ; ++$k)
				{
					switch($processRulesData[$k]["ELEMENTRULE_ATTRIBUTE"])
					{
					case "maxCheck":
					
						// add rule  addRule($element, $message='', $type='', $format='', $validation='server', $reset = false, $force = false)
						$this->processedForm->addRule($processRulesData[$k]["ELEMENTRULE_FORMTYPE_ID_FK"],$processRulesData[$k]["ELEMENTRULE_ALERT"],$processRulesData[$k]["ELEMENTRULE_ATTRIBUTE"],$processRulesData[$k]["ELEMENTRULE_VALUE"],$processRulesData[$k]["ELEMENTRULE_VALIDATION_TYPE"],false,'','','',$processRulesData[$k]["ELEMENTRULE_CHECKALLOW"]);
						
						break;
					
					default:
					
						// with one column required must be applied vertical
						if($cols == 1)
						{
							for ($i = 0; $i < $rows*$cols; ++$i)
							{
								$processedFormRow = 1;
								// add rule  addRule($element, $message='', $type='', $format='', $validation='server', $reset = false, $force = false)
								$this->processedForm->addRule($processRulesData[$k]["ELEMENTRULE_FORMTYPE_ID_FK"]."[".$processedFormData[$i]["FORMELEMENT_ID_PK"]."]",$processRulesData[$k]["ELEMENTRULE_ALERT"],$processRulesData[$k]["ELEMENTRULE_ATTRIBUTE"],$processRulesData[$k]["ELEMENTRULE_VALUE"],$processRulesData[$k]["ELEMENTRULE_VALIDATION_TYPE"],false,true,$formType,$processedFormRow);
							}
						}
						else
						{
							for ($i = 0; $i < $rows*$cols; ++$i)
							{
								$processedFormRow = intval($i/$cols);
								// add rule  addRule($element, $message='', $type='', $format='', $validation='server', $reset = false, $force = false)
								$this->processedForm->addRule($processRulesData[$k]["ELEMENTRULE_FORMTYPE_ID_FK"]."[".$processedFormData[$i]["FORMELEMENT_ID_PK"]."]",$processRulesData[$k]["ELEMENTRULE_ALERT"],$processRulesData[$k]["ELEMENTRULE_ATTRIBUTE"],$processRulesData[$k]["ELEMENTRULE_VALUE"],$processRulesData[$k]["ELEMENTRULE_VALIDATION_TYPE"],false,true,$formType,$processedFormRow);
							}
						}
					}
				}
				break;
			//groupedtext
			case "groupedtext":
				// no rules
				if(count($processRulesData) == 0)
				{
					return;
				}
				// process rules
				for($k = 0; $k < count($processRulesData) ; ++$k)
				{
					for ($i = 0; $i < count($processedFormData); ++$i)
					{
						// add rule  addRule($element, $message='', $type='', $format='', $validation='server', $reset = false, $force = false)
						$this->processedForm->addRule($processRulesData[$k]["ELEMENTRULE_FORMTYPE_ID_FK"]."[".$processedFormData[$i]["FORMELEMENT_ID_PK"]."]",$processRulesData[$k]["ELEMENTRULE_ALERT"],$processRulesData[$k]["ELEMENTRULE_ATTRIBUTE"],$processRulesData[$k]["ELEMENTRULE_VALUE"],$processRulesData[$k]["ELEMENTRULE_VALIDATION_TYPE"],false,true,$formType);
					}
				}
				break;
			//switchtext
			case "switchtext":
				// no rules
				if(count($processRulesData) == 0)
				{
					return;
				}
				// process rules
				for($k = 0; $k < count($processRulesData) ; ++$k)
				{
					for ($i = 0; $i < count($processedFormData); ++$i)
					{
						// add rule  addRule($element, $message='', $type='', $format='', $validation='server', $reset = false, $force = false)
						$this->processedForm->addRule($processRulesData[$k]["ELEMENTRULE_FORMTYPE_ID_FK"]."[".$processedFormData[$i]["FORMELEMENT_ID_PK"]."]",$processRulesData[$k]["ELEMENTRULE_ALERT"],$processRulesData[$k]["ELEMENTRULE_ATTRIBUTE"],$processRulesData[$k]["ELEMENTRULE_VALUE"],$processRulesData[$k]["ELEMENTRULE_VALIDATION_TYPE"],false,true,$formType);
					}
				}
				break;
			// texttable
			default:
				// no rules
				if(count($processRulesData) == 0)
				{
					return;
				}
				// process rules
				for($k = 0; $k < count($processRulesData) ; ++$k)
				{
					for ($i = 0; $i < $rows*$cols; ++$i)
					{
						// add rule  addRule($element, $message='', $type='', $format='', $validation='server', $reset = false, $force = false)
						$this->processedForm->addRule($processRulesData[$k]["ELEMENTRULE_FORMTYPE_ID_FK"]."[".$processedFormData[$i]["FORMELEMENT_ID_PK"]."]",$processRulesData[$k]["ELEMENTRULE_ALERT"],$processRulesData[$k]["ELEMENTRULE_ATTRIBUTE"],$processRulesData[$k]["ELEMENTRULE_VALUE"],$processRulesData[$k]["ELEMENTRULE_VALIDATION_TYPE"],false,true,$formType);
					}
				}
				break;
		}
	}
	
	/**
	*	checks if has rule
	*
    *	@access	public
    *	@param	array	$RulesData 
    */
	function qffhasRule($processRulesData)
	{
		// search rules for required
		for($i = 0; $i < count($processRulesData) ; ++$i)
		{
			if($rule = $processRulesData[$i]["ELEMENTRULE_ATTRIBUTE"])
			{
				$displayRules[$i]["type"] = $processRulesData[$i]["ELEMENTRULE_ATTRIBUTE"];
				$displayRules[$i]["alert"] = $processRulesData[$i]["ELEMENTRULE_ALERT"];
				// set footer note if needed
				switch($displayRules[$i]["type"])
				{
					case "required":
						$this->declaredRules["required"] = str_replace("{errorfooter}", $this->defaultRules[$this->srvyLang]["requirednote"], $this->srvyDisplayErrorFooter["required"]);
						break;
					case "numeric":
						$this->declaredRules["numeric"] = str_replace("{errorfooter}", $this->defaultRules[$this->srvyLang]["numericnote"], $this->srvyDisplayErrorFooter["numeric"]);
				}
			}
		}
		return $displayRules;
	}
	
	/**
	*	creates Textfield
	*
    *	@access	public
    *	@param	array	$formPartTagData 			Array containing Elementdata surrogat from $this->qffTypeArray
    */
	function qffCreateText($formPartTagData)
    {
		// add question breaks
		$question	=	$this->variableReplace(nl2br($formPartTagData[0]["FORMTYPE_QUESTION"]));
		// check breaks
		if($formPartTagData[0]["FORMTYPE_IMAGE"])
		{
			
			// get number of breaks in question
			$pieces = explode("<br", $question);
			for($i=-2;$i<count($pieces);$i++)
			{
				$additionalBreaks .= "<br>";
			}
		}
		// check for rules
		$myProcessRulesData = $formPartTagData[0]["FORMTYPE_RULE"];
		// replace alias
		if($displayRules = $this->qffhasRule($myProcessRulesData))
		{
			for($i = 0; $i < count($displayRules) ; ++$i)
			{
				$displayRulesAlert 	.= str_replace("{thisError}", $displayRules[$i]["alert"], $this->srvyElementErrorWrappers[$displayRules[$i]["type"]]);
				$displayRulesHtml	.= $this->srvyDisplayError[$displayRules[$i]["type"]];
			}
			$head 		= 	str_replace('{require}', $displayRulesHtml, $this->srvyElementHeadHtml);
			// if error has occured
			if($_SESSION["qffControlPool"]["validationErrors"][$formPartTagData[0]["FORMTYPE_ID_PK"]])
			{
				$head 		= 	str_replace('{validationerror}', $displayRulesAlert.$additionalBreaks, $head);
			}
			else
			{
				$head 		= 	str_replace('{validationerror}', "&nbsp;".$additionalBreaks, $head);
			}
			// reset errors
			$displayRulesHtml = "";
			$displayRulesAlert = "";
		}
		else
		{
			$head 		= 	str_replace('{require}', "&nbsp;", $this->srvyElementHeadHtml);
			$head 		= 	str_replace('{validationerror}', "&nbsp;".$additionalBreaks, $head);
		}
		// check for additional imagetag
		($formPartTagData[0]["FORMTYPE_IMAGE"])? ($addImageTag = "<br><br>".$formPartTagData[0]["FORMTYPE_IMAGE"]) : ($addImageTag = "");
		// replace alias
		$head 		= 	str_replace('{label}', $question, $head);
		$head		=	str_replace('{addimage}', $addImageTag, $head);
		// not needed aliasses
		$head = $this->qffClearObsoleteAliasses($head);
		// set head wrapper
		$this->processedForm->addData($head);
		// check for post // workaround for buggy validation // 030324-rr
		$formDefaults[$formPartTagData[0]["FORMTYPE_ID_PK"]]  = ($_POST[$formPartTagData[0]["FORMTYPE_ID_PK"]])? $_POST[$formPartTagData[0]["FORMTYPE_ID_PK"]] : "";
		$this->processedForm->setDefaults($formDefaults);
		//create Textfield 	-------   $form->addElement('text', 'itxtTest', 'Test Text:');
		$this->processedForm->addElement('text', 
										$formPartTagData[0]["FORMTYPE_ID_PK"],
										$question,
										array('size'=>'20',
											  'class'=>'basic'));// defaultclass to be extended function);
		// set foot wrapper
		$this->processedForm->addData($this->srvyElementFootHtml);
		//add borderline
		$this->processedForm->addLine('');
		// process rules data
		if(is_array($myProcessRulesData))
		{
			$this->qffProcessRules($myProcessRulesData);
		}
		// return data
		return $formPartTagData;
	}
	

	/**
	*	creates Passwordfield
	*
    *	@access	public
    *	@param	array	$formPartTagData 			Array containing Elementdata surrogat from $this->qffTypeArray
    */
	function qffCreatePassword($formPartTagData)
    {
		// add question breaks
		$question	=	$this->variableReplace(nl2br($formPartTagData[0]["FORMTYPE_QUESTION"]));
		// check breaks
		if($formPartTagData[0]["FORMTYPE_IMAGE"])
		{
			// get number of breaks in question
			$pieces = explode("<br", $question);
			for($i=-2;$i<count($pieces);$i++)
			{
				$additionalBreaks .= "<br>";
			}
		}
		// check for rules
		$myProcessRulesData = $formPartTagData[0]["FORMTYPE_RULE"];
		// replace alias
		if($displayRules = $this->qffhasRule($myProcessRulesData))
		{
			for($i = 0; $i < count($displayRules) ; ++$i)
			{
				$displayRulesAlert 	.= str_replace("{thisError}", $displayRules[$i]["alert"], $this->srvyElementErrorWrappers[$displayRules[$i]["type"]]);
				$displayRulesHtml	.= $this->srvyDisplayError[$displayRules[$i]["type"]];
			}
			$head 		= 	str_replace('{require}', $displayRulesHtml, $this->srvyElementHeadHtml);
			// if error has occured
			if($this->validateStatus == 1)
			{
				$head 		= 	str_replace('{validationerror}', $displayRulesAlert.$additionalBreaks, $head);
			}
			else
			{
				$head 		= 	str_replace('{validationerror}', "&nbsp;".$additionalBreaks, $head);
			}
			// reset errors
			$displayRulesHtml = "";
			$displayRulesAlert = "";
		}
		else
		{
			$head 		= 	str_replace('{require}', "&nbsp;", $this->srvyElementHeadHtml);
			$head 		= 	str_replace('{validationerror}', "&nbsp;".$additionalBreaks, $head);
		}
		// check for additional imagetag
		($formPartTagData[0]["FORMTYPE_IMAGE"])? ($addImageTag = "<br><br>".$formPartTagData[0]["FORMTYPE_IMAGE"]) : ($addImageTag = "");
		// replace alias
		$head 		= 	str_replace('{label}', $question, $head);
		$head		=	str_replace('{addimage}', $addImageTag, $head);
		// not needed aliasses
		$head = $this->qffClearObsoleteAliasses($head);
		// set head wrapper
		$this->processedForm->addData($head);
		//create Password 	-------   $form->addElement('password', 'ipwdTest', 'Test Password:');
		$this->processedForm->addElement('password', 
										$formPartTagData[0]["FORMTYPE_ID_PK"],
										$question,
										array('class'=>'basic'));// defaultclass to be extended function);
		// set foot wrapper
		$this->processedForm->addData($this->srvyElementFootHtml);
		//add borderline
		$this->processedForm->addLine('');
		// process rules data
		if(is_array($myProcessRulesData))
		{
			$this->qffProcessRules($myProcessRulesData);
		}
		// return data
		return $formPartTagData;
	}
	
	
    /**
	*	creates Textarea
	*
    *	@access	public
    *	@param	array	$formPartTagData 			Array containing Elementdata surrogat from $this->qffTypeArray
    */
	function qffCreateTextarea($formPartTagData)
    {
		// add question breaks
		$question	=	$this->variableReplace(nl2br($formPartTagData[0]["FORMTYPE_QUESTION"]));
		// check breaks
		if($formPartTagData[0]["FORMTYPE_IMAGE"])
		{
			// get number of breaks in question
			$pieces = explode("<br", $question);
			for($i=-2;$i<count($pieces);$i++)
			{
				$additionalBreaks .= "<br>";
			}
		}
		// check for rules
		$myProcessRulesData = $formPartTagData[0]["FORMTYPE_RULE"];
		// replace alias
		if($displayRules = $this->qffhasRule($myProcessRulesData))
		{
			for($i = 0; $i < count($displayRules) ; ++$i)
			{
				$displayRulesAlert 	.= str_replace("{thisError}", $displayRules[$i]["alert"], $this->srvyElementErrorWrappers[$displayRules[$i]["type"]]);
				$displayRulesHtml	.= $this->srvyDisplayError[$displayRules[$i]["type"]];
			}
			$head 		= 	str_replace('{require}', $displayRulesHtml, $this->srvyElementHeadHtml);
			// if error has occured
			if($_SESSION["qffControlPool"]["validationErrors"][$formPartTagData[0]["FORMTYPE_ID_PK"]])
			{
				$head 		= 	str_replace('{validationerror}', $displayRulesAlert.$additionalBreaks, $head);
			}
			else
			{
				$head 		= 	str_replace('{validationerror}', "&nbsp;".$additionalBreaks, $head);
			}
			// reset errors
			$displayRulesHtml = "";
			$displayRulesAlert = "";
		}
		else
		{
			$head 		= 	str_replace('{require}', "&nbsp;", $this->srvyElementHeadHtml);
			$head 		= 	str_replace('{validationerror}', "&nbsp;".$additionalBreaks, $head);
		}
		// check for additional imagetag
		($formPartTagData[0]["FORMTYPE_IMAGE"])? ($addImageTag = "<br><br>".$formPartTagData[0]["FORMTYPE_IMAGE"]) : ($addImageTag = "");
		// replace alias
		$head 		= 	str_replace('{label}', $question, $head);
		$head		=	str_replace('{addimage}', $addImageTag, $head);
		// not needed aliasses
		$head = $this->qffClearObsoleteAliasses($head);
		// set head wrapper
		$this->processedForm->addData($head);
		// check for post // workaround for buggy validation // 030324-rr
		$formDefaults[$formPartTagData[0]["FORMTYPE_ID_PK"]]  = ($_POST[$formPartTagData[0]["FORMTYPE_ID_PK"]])? $_POST[$formPartTagData[0]["FORMTYPE_ID_PK"]] : "";
		$this->processedForm->setDefaults($formDefaults);
		//create Textarea 	-------   $form->addElement('textarea', 'itxaTest', 'Test TextArea:',array('additional'=>'arguments'));
		$this->processedForm->addElement('textarea', 
										$formPartTagData[0]["FORMTYPE_ID_PK"],
										$question,
										array('rows'=>'20',
											  'cols'=>'11',
											  'class'=>'basic'));// defaultclass to be extended function
		// set foot wrapper
		$this->processedForm->addData($this->srvyElementFootHtml);
		//add borderline
		$this->processedForm->addLine('');
		// process rules data
		if(is_array($myProcessRulesData))
		{
			$this->qffProcessRules($myProcessRulesData);
		}
		// return data
		return $formPartTagData;
	}
	
	
	/**
	*	creates Selectfield
	*
    *	@access	public
    *	@param	array	$formPartTagData 			Array containing Elementdata surrogat from $this->qffTypeArray
    */
	function qffCreateSelect($formPartTagData)
    {
		// add question breaks
		$question	=	$this->variableReplace(nl2br($formPartTagData[0]["FORMTYPE_QUESTION"]));
		// check breaks
		if($formPartTagData[0]["FORMTYPE_IMAGE"])
		{
			// get number of breaks in question
			$pieces = explode("<br", $question);
			for($i=-2;$i<count($pieces);$i++)
			{
				$additionalBreaks .= "<br>";
			}
		}
		// check for rules
		$myProcessRulesData = $formPartTagData[0]["FORMTYPE_RULE"];
		// replace alias
		if($displayRules = $this->qffhasRule($myProcessRulesData))
		{
			for($i = 0; $i < count($displayRules) ; ++$i)
			{
				$displayRulesAlert 	.= str_replace("{thisError}", $displayRules[$i]["alert"], $this->srvyElementErrorWrappers[$displayRules[$i]["type"]]);
				$displayRulesHtml	.= $this->srvyDisplayError[$displayRules[$i]["type"]];
			}
			$head 		= 	str_replace('{require}', $displayRulesHtml, $this->srvyElementHeadHtml);
			// if error has occured
			if($_SESSION["qffControlPool"]["validationErrors"][$formPartTagData[0]["FORMTYPE_ID_PK"]])
			{
				$head 		= 	str_replace('{validationerror}', $displayRulesAlert.$additionalBreaks, $head);
			}
			else
			{
				$head 		= 	str_replace('{validationerror}', "&nbsp;".$additionalBreaks, $head);
			}
			// reset errors
			$displayRulesHtml = "";
			$displayRulesAlert = "";
		}
		else
		{
			$head 		= 	str_replace('{require}', "&nbsp;", $this->srvyElementHeadHtml);
			$head 		= 	str_replace('{validationerror}', "&nbsp;".$additionalBreaks, $head);
		}
		// check for additional imagetag
		($formPartTagData[0]["FORMTYPE_IMAGE"])? ($addImageTag = "<br><br>".$formPartTagData[0]["FORMTYPE_IMAGE"]) : ($addImageTag = "");
		// replace alias
		$head 		= 	str_replace('{label}', $question, $head);
		$head		=	str_replace('{addimage}', $addImageTag, $head);
		// not needed aliasses
		$head = $this->qffClearObsoleteAliasses($head);
		// set head wrapper
		$this->processedForm->addData($head);
		//create options array and check for defaults
		$lastOption = (count($formPartTagData));
		for ($i=0;$i<$lastOption;$i++)
			{	
				//create options
				$options[$formPartTagData[$i]["FORMELEMENT_ID_PK"]] = $formPartTagData[$i]["FORMELEMENT_HEADER"];
				//check for post // workaround for buggy validation // 030324-rr
				if ($_POST[$formPartTagData[0]["FORMTYPE_ID_PK"]] == $formPartTagData[$i]["FORMELEMENT_ID_PK"])
				{
					$formDefaults[$formPartTagData[0]["FORMTYPE_ID_PK"]][]  = $formPartTagData[$i]["FORMELEMENT_ID_PK"];
				}
				// check for switch
				if ($formPartTagData[$i]["FORMELEMENT_SWITCHTO"])
				{
					$this->switchToData[$this->switchIndex]["switchTo"]  		= $formPartTagData[$i]["FORMELEMENT_SWITCHTO"];
					$this->switchToData[$this->switchIndex]["switchElementId"]  = $formPartTagData[$i]["FORMELEMENT_ID_PK"];
					$this->switchToData[$this->switchIndex]["switchFormTagId"]  = $formPartTagData[0]["FORMTYPE_ID_PK"];
					$this->switchToData[$this->switchIndex]["switchSurveyContinue"]	= $formPartTagData[$i]["FORMELEMENT_SRVY_CNTNUE"]; 
					$this->switchToData[$this->switchIndex]["switchFormType"]   = "select";
					$this->switchIndex++;
				}
			}
		// additional Arguments   -------------   defaultValues['iselTest']  = array('B', 'C');
		$this->processedForm->setDefaults($formDefaults);
		//create Select
		//$form->addElement('select', 'iselTest', 'Test Select:', array('A'=>'A', 'B'=>'B','C'=>'C','D'=>'D'));
		//quickformSmExtended_select($elementName=null, $elementLabel=null, $options=null, $attributes=null)
		$this->processedForm->addElement('select',
										$formPartTagData[0]["FORMTYPE_ID_PK"],
										$question,
										$options,
										array('class'=>'basic'));
		// set foot wrapper
		$this->processedForm->addData($this->srvyElementFootHtml);
		//add borderline
		$this->processedForm->addLine('');
		// get element and add options
		$select = &$this->processedForm->getElement($formPartTagData[0]["FORMTYPE_ID_PK"]);
		// set size
		$select->setSize($formPartTagData[0]["FORMTYPE_SIZE"]);
		// process rules data
		if(is_array($myProcessRulesData))
		{
			$this->qffProcessRules($myProcessRulesData);
		}
		// return data
		return $formPartTagData;
	}
	
	/**
	*	creates Checkbox(es)
	*
    *	@access	public
    *	@param	array	$formPartTagData 			Array containing Elementdata surrogat from $this->qffTypeArray
    */
	function qffCreateCheckbox($formPartTagData)
    {
		// add question breaks
		$question	=	$this->variableReplace(nl2br($formPartTagData[0]["FORMTYPE_QUESTION"]));
		// check breaks
		if($formPartTagData[0]["FORMTYPE_IMAGE"])
		{
			// get number of breaks in question
			$pieces = explode("<br", $question);
			for($i=-2;$i<count($pieces);$i++)
			{
				$additionalBreaks .= "<br>";
			}
		}
		// check for rules
		$myProcessRulesData = $formPartTagData[0]["FORMTYPE_RULE"];
		// check for maxCheckFunction
		for($i = 0; $i < count($myProcessRulesData); ++$i)
		{
			if($myProcessRulesData[$i]["ELEMENTRULE_ATTRIBUTE"] == "maxCheck")
			{
				$jsFunctionCaller["maxChecked"] = $myProcessRulesData[$i]["ELEMENTRULE_CHECKALLOW"];
			}
		}
		// replace alias
		if($displayRules = $this->qffhasRule($myProcessRulesData))
		{
			for($i = 0; $i < count($displayRules) ; ++$i)
			{
				$displayRulesAlert 	.= str_replace("{thisError}", $displayRules[$i]["alert"], $this->srvyElementErrorWrappers[$displayRules[$i]["type"]]);
				$displayRulesHtml	.= $this->srvyDisplayError[$displayRules[$i]["type"]];
			}
			$head 		= 	str_replace('{require}', $displayRulesHtml, $this->srvyElementHeadHtml);
			// if error has occured
			if($_SESSION["qffControlPool"]["validationErrors"][$formPartTagData[0]["FORMTYPE_ID_PK"]])
			{
				$head 		= 	str_replace('{validationerror}', $displayRulesAlert.$additionalBreaks, $head);
			}
			else
			{
				$head 		= 	str_replace('{validationerror}', "&nbsp;".$additionalBreaks, $head);
			}
			// reset errors
			$displayRulesHtml = "";
			$displayRulesAlert = "";
		}
		else
		{
			$head 		= 	str_replace('{require}', "&nbsp;", $this->srvyElementHeadHtml);
			$head 		= 	str_replace('{validationerror}', "&nbsp;".$additionalBreaks, $head);
		}
		// check for additional imagetag
		($formPartTagData[0]["FORMTYPE_IMAGE"])? ($addImageTag = "<br><br>".$formPartTagData[0]["FORMTYPE_IMAGE"]) : ($addImageTag = "");
		// replace alias
		$head 		= 	str_replace('{label}', $question, $head);
		$head		=	str_replace('{addimage}', $addImageTag, $head);
		// not needed aliasses
		$head = $this->qffClearObsoleteAliasses($head);
		// set head wrapper
		$this->processedForm->addData($head);
		//create options array and check for defaults
		$AmountBoxes = (count($formPartTagData));
		for ($i=0;$i<$AmountBoxes;$i++)
			{	
				// insert additional image if present
				if($formPartTagData[$i]["FORMELEMENT_HEADERIMAGE"])
				{
					$imageTag =  str_replace('border="0"', 'border="0" align="middle"', stripslashes($formPartTagData[$i]["FORMELEMENT_HEADERIMAGE"])).(($formPartTagData[$i]["FORMELEMENT_HEADER"])? "&nbsp;" : "");
				}
				else
				{
					$imageTag = "";
				}
				// check if header should be displayed
				($formPartTagData[$i]["FORMELEMENT_HIDEHEADER"])? ($headerTag = "") : ($headerTag = $formPartTagData[$i]["FORMELEMENT_HEADER"]);
				//create options 	$checkbox[] = &quickformSmExtended::createElement('checkbox', '7', null, 'A');//'7' can be used as value for multiple choice avaiable as $key rr
				$Boxes[] = &quickformSmExtended::createElement('checkbox', $formPartTagData[$i]["FORMELEMENT_ID_PK"], null, "&nbsp;".$imageTag.$headerTag,($jsFunctionCaller["maxChecked"])? array("class" => "checkbox", 'onClick' => 'javascript:checkEntries(this.name , document.forms[0], elementsChecked'.$formPartTagData[0]["FORMTYPE_ID_PK"].');') : array("class" => "checkbox"));// defaultclass to be extended function
				//check for post // workaround for buggy validation // 030324-rr
				if ($_POST[$formPartTagData[0]["FORMTYPE_ID_PK"]][$formPartTagData[$i]["FORMELEMENT_ID_PK"]] == true && !$jsFunctionCaller["maxChecked"]) // temporary solution to avoid more than allowed checks if required // 030429-rr
				{
					$formDefaults[$formPartTagData[0]["FORMTYPE_ID_PK"]][$formPartTagData[$i]["FORMELEMENT_ID_PK"]]= true;
				}
				// check for switch
				if ($formPartTagData[$i]["FORMELEMENT_SWITCHTO"])
				{
					$this->switchToData[$this->switchIndex]["switchTo"]  		= $formPartTagData[$i]["FORMELEMENT_SWITCHTO"];
					$this->switchToData[$this->switchIndex]["switchElementId"]  = $formPartTagData[$i]["FORMELEMENT_ID_PK"];
					$this->switchToData[$this->switchIndex]["switchFormTagId"]  = $formPartTagData[0]["FORMTYPE_ID_PK"];
					$this->switchToData[$this->switchIndex]["switchSurveyContinue"]	= $formPartTagData[$i]["FORMELEMENT_SRVY_CNTNUE"];
					$this->switchToData[$this->switchIndex]["switchFormType"]   = "checkbox";
					$this->switchIndex++;
				}
			}
		// set defaults
		$this->processedForm->setDefaults($formDefaults);
		// check alignment
		if ( $formPartTagData[0]["FORMTYPE_ALIGN"] == 'ver' )
		{
			$separateElements = "<br>";
		}
		else
		{
			$separateElements = "&nbsp;";
		}
		// create checkboxelement   quickformSmExtended_checkbox($elementName=null, $elementLabel=null, $text=null, $attributes=null)
		$this->processedForm->addElementGroup($Boxes,
											$question,
											$formPartTagData[0]["FORMTYPE_ID_PK"],
											$separateElements);
		// set foot wrapper
		$this->processedForm->addData($this->srvyElementFootHtml);
		//add borderline
		$this->processedForm->addLine('');
		// process rules data
		if(is_array($myProcessRulesData))
		{
			$this->qffProcessRules($myProcessRulesData);
		}
		// return data
		return $formPartTagData;
	}
	
	/**
	*	creates Radiobuttons
	*
    *	@access	public
    *	@param	array	$formPartTagData 			Array containing Elementdata surrogat from $this->qffTypeArray
    */
	function qffCreateRadio($formPartTagData)
    {
		// add question breaks
		$question	=	$this->variableReplace(nl2br($formPartTagData[0]["FORMTYPE_QUESTION"]));
		// check breaks
		if($formPartTagData[0]["FORMTYPE_IMAGE"])
		{
			// get number of breaks in question
			$pieces = explode("<br", $question);
			for($i=-2;$i<count($pieces);$i++)
			{
				$additionalBreaks .= "<br>";
			}
		}
		// check for rules
		$myProcessRulesData = $formPartTagData[0]["FORMTYPE_RULE"];
		// replace alias
		if($displayRules = $this->qffhasRule($myProcessRulesData))
		{
			for($i = 0; $i < count($displayRules) ; ++$i)
			{
				$displayRulesAlert 	.= str_replace("{thisError}", $displayRules[$i]["alert"], $this->srvyElementErrorWrappers[$displayRules[$i]["type"]]);
				$displayRulesHtml	.= $this->srvyDisplayError[$displayRules[$i]["type"]];
			}
			$head 		= 	str_replace('{require}', $displayRulesHtml, $this->srvyElementHeadHtml);
			// if error has occured
			if($_SESSION["qffControlPool"]["validationErrors"][$formPartTagData[0]["FORMTYPE_ID_PK"]])
			{
				$head 		= 	str_replace('{validationerror}', $displayRulesAlert.$additionalBreaks, $head);
			}
			else
			{
				$head 		= 	str_replace('{validationerror}', "&nbsp;".$additionalBreaks, $head);
			}
			// reset errors
			$displayRulesHtml = "";
			$displayRulesAlert = "";
		}
		else
		{
			$head 		= 	str_replace('{require}', "&nbsp;", $this->srvyElementHeadHtml);
			$head 		= 	str_replace('{validationerror}', "&nbsp;".$additionalBreaks, $head);
		}
		// check for additional imagetag
		($formPartTagData[0]["FORMTYPE_IMAGE"])? ($addImageTag = "<br><br>".$formPartTagData[0]["FORMTYPE_IMAGE"]) : ($addImageTag = "");
		// replace alias
		$head 		= 	str_replace('{label}', $question, $head);
		$head		=	str_replace('{addimage}', $addImageTag, $head);
		// not needed aliasses
		$head = $this->qffClearObsoleteAliasses($head);
		// set head wrapper
		$this->processedForm->addData($head);
		//create options array and check for defaults
		$lastOption = (count($formPartTagData));
		for ($i=0;$i<$lastOption;$i++)
			{	
				// insert additional image if present
				if($formPartTagData[$i]["FORMELEMENT_HEADERIMAGE"])
				{
					$imageTag =  str_replace('border="0"', 'border="0" align="middle"', stripslashes($formPartTagData[$i]["FORMELEMENT_HEADERIMAGE"])).(($formPartTagData[$i]["FORMELEMENT_HEADER"])? "&nbsp;" : "");
				}
				else
				{
					$imageTag = "";
				}
				// check if header should be displayed
				($formPartTagData[$i]["FORMELEMENT_HIDEHEADER"])? ($headerTag = "") : ($headerTag = $formPartTagData[$i]["FORMELEMENT_HEADER"]);
				$Radios[] = &quickformSmExtended::createElement('radio', null, null, "&nbsp;".$imageTag.$headerTag,$formPartTagData[$i]["FORMELEMENT_ID_PK"],array("class" => "radio"));
				//check for post // workaround for buggy validation // 030324-rr
				if ($_POST[$formPartTagData[0]["FORMTYPE_ID_PK"]] == $formPartTagData[$i]["FORMELEMENT_ID_PK"])
				{
					$formDefaults[$formPartTagData[0]["FORMTYPE_ID_PK"]] = $formPartTagData[$i]["FORMELEMENT_ID_PK"];
				}
				// check for switch
				if ($formPartTagData[$i]["FORMELEMENT_SWITCHTO"])
				{
					$this->switchToData[$this->switchIndex]["switchTo"]  		= $formPartTagData[$i]["FORMELEMENT_SWITCHTO"];
					$this->switchToData[$this->switchIndex]["switchElementId"]  = $formPartTagData[$i]["FORMELEMENT_ID_PK"];
					$this->switchToData[$this->switchIndex]["switchFormTagId"]  = $formPartTagData[0]["FORMTYPE_ID_PK"];
					$this->switchToData[$this->switchIndex]["switchSurveyContinue"]	= $formPartTagData[$i]["FORMELEMENT_SRVY_CNTNUE"];
					$this->switchToData[$this->switchIndex]["switchFormType"]   = "radio";
					$this->switchIndex++;
				}
			}
		// set defaults
		$this->processedForm->setDefaults($formDefaults);
		// check alignment
		if ( $formPartTagData[0]["FORMTYPE_ALIGN"] == 'ver' )
		{
			$separateElements = "<br>";
		}
		else
		{
			$separateElements = "&nbsp;";
		}
		// create radio  quickformSmExtended_radio($elementName=null, $elementLabel=null, $text=null, $value=null, $attributes=null)
		$this->processedForm->addElementGroup($Radios,
											$question,
											$formPartTagData[0]["FORMTYPE_ID_PK"],
											$separateElements);
		// set foot wrapper
		$this->processedForm->addData($this->srvyElementFootHtml);
		//add borderline
		$this->processedForm->addLine('');
		// process rules data
		if(is_array($myProcessRulesData))
		{
			$this->qffProcessRules($myProcessRulesData);
		}
		// return data
		return $formPartTagData;
	}
	
	/**
	*	creates grouped text
	*
    *	@access	public
    *	@param	array	$formPartTagData 			Array containing Elementdata surrogat from $this->qffTypeArray
    */
	function qffCreateGroupedText($formPartTagData)
    {
		// global wrappers
		global $cfgSrvyGroupedHeadHtml;
		global $cfgSrvyGroupedOptionWrapperHtml;
		global $cfgSrvyGroupedFootHtml;
		global $cfgSrvyGroupedInputSpacerHtml;
		
		global $cfgSrvyHorGroupedHeadHtml;
		global $cfgSrvyHorGroupedOptionWrapperHtml;
		global $cfgSrvyHorGroupedFootHtml;
		global $cfgSrvyHorGroupedInputSpacerHtml;
		
		// check for rules
		$myProcessRulesData = $formPartTagData[0]["FORMTYPE_RULE"];
		// check alignment
		if ( $formPartTagData[0]["FORMTYPE_ALIGN"] == 'ver' )
		{
			$separateElements	= $cfgSrvyGroupedInputSpacerHtml;
			$head				= $cfgSrvyGroupedHeadHtml;
			$optionWrapper		= $cfgSrvyGroupedOptionWrapperHtml;
			$foot			 	= $cfgSrvyGroupedFootHtml;
			
		}
		else
		{
			$separateElements	= $cfgSrvyHorGroupedInputSpacerHtml;
			$head				= $cfgSrvyHorGroupedHeadHtml;
			$optionWrapper		= $cfgSrvyHorGroupedOptionWrapperHtml;
			$foot			 	= $cfgSrvyHorGroupedFootHtml;
		}

		// options number
		$optionsInOneRow = count($formPartTagData);

		// set widths for table tds
		//
		// get biggest header string as width-indicator for options
		for ($i = 1; $i < count($formPartTagData); $i++)
		{
			$stringArray = explode(" ", $formPartTagData[$i]["FORMELEMENT_HEADER"]);
			if(is_array($stringArray))
			{
				foreach($stringArray as $stringArrayPart)
				{
					if(!$biggestString || $biggestString < strlen($stringArrayPart))
					{
						$biggestString =  strlen($stringArrayPart);
					}
				}
			}
			elseif(!$biggestString || $biggestString < strlen($formPartTagData[$i]["FORMELEMENT_HEADER"]))
			{
				$biggestString =  strlen($formPartTagData[$i]["FORMELEMENT_HEADER"]);
			}
		}
		// get fontsize from cssdata
		$cssTemp		= explode("td.csstableoption", $this->srvyCssString);
		$cssTemp		= explode("font-size:", $cssTemp[1]);
		$cssFontSize	= intval(substr($cssTemp[1],0,3));
		// if textinputs are bigger than header
		$optionTdWidth 	= ($biggestString*$cssFontSize) + 10;
		if($optionTdWidth < ($formPartTagData[0]["FORMTYPE_SIZE"] + 10))
		{
			$optionTdWidth 	= ($formPartTagData[0]["FORMTYPE_SIZE"] + 10);
		}
		$rowHeaderTdWidth = 1;

		// create options array and check for defaults
		for ($i=0;$i<$optionsInOneRow;$i++)
			{	
				//create options
				$text[] = &quickformSmExtended::createElement('text', $formPartTagData[$i]["FORMELEMENT_ID_PK"], '', array('class'=>'basic', 'style'=>'width:'.$formPartTagData[0]["FORMTYPE_SIZE"].';'));
				//check for post // workaround for buggy validation // 030324-rr
				$formDefaults[$formPartTagData[0]["FORMTYPE_ID_PK"]][$formPartTagData[$i]["FORMELEMENT_ID_PK"]] = $_POST[$formPartTagData[0]["FORMTYPE_ID_PK"]][$formPartTagData[$i]["FORMELEMENT_ID_PK"]];
				// replace alias
				$option = str_replace('{option}', $formPartTagData[$i]["FORMELEMENT_HEADER"], $optionWrapper);
				$option = str_replace('{optiontdwidth}', $optionTdWidth, $option);
				// create optionhtml
				$optionHtml .= $option;
				// check for switch
				if ($formPartTagData[$i]["FORMELEMENT_SWITCHTO"])
				{
					$this->switchToData[$this->switchIndex]["switchTo"]  		= $formPartTagData[$i]["FORMELEMENT_SWITCHTO"];
					$this->switchToData[$this->switchIndex]["switchElementId"]  = $formPartTagData[$i]["FORMELEMENT_ID_PK"];
					$this->switchToData[$this->switchIndex]["switchFormTagId"]  = $formPartTagData[0]["FORMTYPE_ID_PK"];
					$this->switchToData[$this->switchIndex]["switchSurveyContinue"]	= $formPartTagData[$i]["FORMELEMENT_SRVY_CNTNUE"];
					$this->switchToData[$this->switchIndex]["switchFormType"]   = $formPartTagData[0]["FORMTYPE_TYPE"];
					$this->switchToData[$this->switchIndex]["switchFormRow"]    = '0';
					$this->switchIndex++;
				}
			}
		// set defaults
		$this->processedForm->setDefaults($formDefaults);
		// add question breaks
		$question	=	$this->variableReplace(nl2br($formPartTagData[0]["FORMTYPE_QUESTION"]));
		// check breaks
		if($formPartTagData[0]["FORMTYPE_IMAGE"])
		{
			// get number of breaks in question
			$pieces = explode("<br", $question);
			for($i=-2;$i<count($pieces);$i++)
			{
				$additionalBreaks .= "<br>";
			}
		}
		// replace alias
		if($displayRules = $this->qffhasRule($myProcessRulesData))
		{
			for($i = 0; $i < count($displayRules) ; ++$i)
			{
				$displayRulesAlert 	.= str_replace("{thisError}", $displayRules[$i]["alert"], $this->srvyElementErrorWrappers[$displayRules[$i]["type"]]);
				$displayRulesHtml	.= $this->srvyDisplayError[$displayRules[$i]["type"]];
			}
			$head 		= 	str_replace('{require}', $displayRulesHtml, $head);
			// if error has occured
			if($this->validateStatus == 1)
			{
				if(is_array($_SESSION["qffControlPool"]["validationErrors"]))
				{
					// loop possible matching errors
					foreach($_SESSION["qffControlPool"]["validationErrors"] as $errorKey => $errorValue)
					{
						// formtypeId check if one element missing
						$explodedName  		= explode ("[", $errorKey);
						$errorFormtypeId	= $explodedName[0];
						//
						if($errorFormtypeId == $formPartTagData[0]["FORMTYPE_ID_PK"])
						{
							$displayGroupedError = true;
							break;
						}
						$displayGroupedError = false;
					}
				}
			}
			// display error if needed
			if($displayGroupedError)
			{
				$head 		= 	str_replace('{validationerror}', $displayRulesAlert.$additionalBreaks, $head);
			}
			else
			{
				$head 		= 	str_replace('{validationerror}', "&nbsp;".$additionalBreaks, $head);
			}
			// reset errors
			$displayRulesHtml = "";
			$displayRulesAlert = "";
		}
		else
		{
			$head 		= 	str_replace('{validationerror}', "&nbsp;".$additionalBreaks, $head);
		}
		// check for additional imagetag
		($formPartTagData[0]["FORMTYPE_IMAGE"])? ($addImageTag = "<br><br>".$formPartTagData[0]["FORMTYPE_IMAGE"]) : ($addImageTag = "");
		// replace aliasses
		$head 					= 	str_replace('{label}', $question, $head);
		$head					=	str_replace('{addimage}', $addImageTag, $head);
		$head 					= 	str_replace('{rowheadertdwidth}', $rowHeaderTdWidth, $head);
		$head 					= 	str_replace('{rowheader}', $formPartTagData[0]["FORMELEMENT_ADDHEADER"], $head);
		$head 					= 	str_replace('{optionlabels}', $optionHtml, $head);
		$head 					= 	str_replace('{optiontdwidth}', $optionTdWidth, $head);
		$separateElements 		= 	str_replace('{optiontdwidth}', $optionTdWidth, $separateElements);
		// not needed aliasses
		$head = $this->qffClearObsoleteAliasses($head);
		// set head wrapper
		$this->processedForm->addData($head);
		// create radio  quickformSmExtended_radio($elementName=null, $elementLabel=null, $text=null, $value=null, $attributes=null)
		$this->processedForm->addElementGroup($text, 
											$question,
											$formPartTagData[0]["FORMTYPE_ID_PK"],
											$separateElements);
		// set foot wrapper
		$this->processedForm->addData($foot);
		//add borderline
		$this->processedForm->addLine('');
		// return data
		if(is_array($myProcessRulesData))
		{
			$this->qffProcessTableRules($myProcessRulesData, 1, $optionsInOneRow, $formPartTagData[0]["FORMTYPE_TYPE"], $formPartTagData);
		}
		return $formPartTagData;
		
	}
	

	/**
	*	creates grouped radio or checkbox
	*
    *	@access	public
    *	@param	array	$formPartTagData 			Array containing Elementdata surrogat from $this->qffTypeArray
    */
	function qffCreateTableGroup($formPartTagData)
    {
		// global wrappers
		
		global $cfgSrvyTableFirstHeadHtml;
		global $cfgSrvyTableFirstOptionWrapperHtml;
		global $cfgSrvyTableFirstFootHtml;
		global $cfgSrvyTableFirstInputSpacerHtml;
		
		$separateElements	= $cfgSrvyTableFirstInputSpacerHtml;
		$head			= $cfgSrvyTableFirstHeadHtml;
		$optionWrapper		= $cfgSrvyTableFirstOptionWrapperHtml;
		$foot			= $cfgSrvyTableFirstFootHtml;
		
		// check for rules
		$myProcessRulesData = $formPartTagData[0]["FORMTYPE_RULE"];
		// check type
		$typeToShow = $formPartTagData[0]["FORMTYPE_TYPE"];
		// number of group rows
		$groupRows  = $formPartTagData[0]["FORMTYPE_TABLESPAN"];
		// options number
		if ($groupRows > 0)
		{
			$optionsInOneRow = (count($formPartTagData)/$groupRows);
		}
		else
		{
			$optionsInOneRow = count($formPartTagData);
		}
		// check for maxCheckFunction
		if($typeToShow == "checkboxtable")// && ($optionsInOneRow == 1 || $groupRows < 2)
		{
			for($i = 0; $i < count($myProcessRulesData); ++$i)
			{
				if($myProcessRulesData[$i]["ELEMENTRULE_ATTRIBUTE"] == "maxCheck")
				{
					$jsFunctionCaller["maxChecked"] = $myProcessRulesData[$i]["ELEMENTRULE_CHECKALLOW"];
				}
			}
		}
		// search for addheaders 
		for($i=1; $i<count($formPartTagData);$i++)
		{
			$hasAddHeaders = trim($formPartTagData[$i]["FORMELEMENT_ADDHEADER"]).trim($formPartTagData[$i]["FORMELEMENT_ADDHEADERIMAGE"]);
			if($hasAddHeaders)
			{
				$hasAddHeaders = true;
				break;
			}
			$hasAddHeaders = false;
		}
		// set widths for table tds
		//
		// get biggest header string as width-indicator for options
		$biggestString = 0;
		for ($i = 1; $i < count($formPartTagData); $i++)
		{
			// split header into strings if not hidden
			(!$formPartTagData[$i]["FORMELEMENT_HIDEHEADER"])? ($stringArray = explode(" ", $formPartTagData[$i]["FORMELEMENT_HEADER"])) : ($stringArray = "");
			// if more than one string check sizes
			if(is_array($stringArray))
			{
				foreach($stringArray as $stringArrayPart)
				{
					if(!$biggestString || $biggestString < strlen($stringArrayPart))
					{
						$biggestString =  strlen($stringArrayPart);
					}
				}
			}
			else
			{
				// get headerstring if not hidden
				(!$formPartTagData[$i]["FORMELEMENT_HIDEHEADER"])? ($string = $formPartTagData[$i]["FORMELEMENT_HEADER"]) :($string = "");
				// check for size
				if(!$biggestString || $biggestString < strlen($string))
				{
					$biggestString =  strlen($string);
				}
			}
		}
		// get fontsize from cssdata
		$cssTemp		= explode("td.csstableoption", $this->srvyCssString);
		$cssTemp		= explode("font-size:", $cssTemp[1]);
		$cssFontSize	= intval(substr($cssTemp[1],0,3));
		// set width
		if($typeToShow != "texttable")
		{
			$optionTdWidth 	= ($biggestString*$cssFontSize) + 10;
		}
		// if textinputs are bigger than header
		else
		{
			$optionTdWidth 	= ($biggestString*$cssFontSize) + 10;
			if($optionTdWidth < ($formPartTagData[0]["FORMTYPE_SIZE"] + 10))
			{
				$optionTdWidth 	= ($formPartTagData[0]["FORMTYPE_SIZE"] + 10);
			}
		}
		// loop imagesizes to get maybe even bigger
		$biggestImageWidth = 0;
		for ($i = 1; $i < count($formPartTagData); $i++)
		{
			$imageData = explode("\"", $formPartTagData[$i]["FORMELEMENT_HEADERIMAGE"]);
			$imageData = explode("=", $imageData[1]);
			$imagesize = @getimagesize($imageData[0]);
			if(is_array($imagesize))
			{
				if(!$biggestImageWidth || $biggestImageWidth < intval($imagesize[0]))
				{
					$biggestImageWidth =  intval($imagesize[0]);
				}
			}
		}
		if(($biggestImageWidth + 10) > $optionTdWidth)
		{
			$optionTdWidth = $biggestImageWidth + 10;
		}
		//
		// get biggest addheader string as width-indicator for rowheaders
		//
		$biggestString = 0;
		for ($i = 1; $i < count($formPartTagData); $i++)
		{
			// split header into strings if not hidden
			(!$formPartTagData[$i]["FORMELEMENT_HIDEADDHEADER"])? ($stringArray = explode(" ", $formPartTagData[$i]["FORMELEMENT_ADDHEADER"])) : ($stringArray = "");
			// if more than one string check sizes
			if(is_array($stringArray))
			{
				foreach($stringArray as $stringArrayPart)
				{
					if(!$biggestString || $biggestString < strlen($stringArrayPart))
					{
						$biggestString =  strlen($stringArrayPart);
					}
				}
			}
			else
			{
				// get headerstring if not hidden
				(!$formPartTagData[$i]["FORMELEMENT_HIDEADDHEADER"])? ($string = $formPartTagData[$i]["FORMELEMENT_ADDHEADER"]) : ($string = "");
				// check for size
				if(!$biggestString || $biggestString < strlen($string))
				{
					$biggestString =  strlen($string);
				}
			}
		}
		$rowHeaderTdWidth 	= ($biggestString*$cssFontSize);
		
		// loop imagesizes to get maybe even bigger
		$biggestImageWidth = 0;
		for ($i = 1; $i < count($formPartTagData); $i++)
		{
			$imageData = explode("\"", $formPartTagData[$i]["FORMELEMENT_ADDHEADERIMAGE"]);
			$imageData = explode("=", $imageData[1]);
			$imagesize = @getimagesize($imageData[0]);
			if(is_array($imagesize))
			{
				if(!$biggestImageWidth || $biggestImageWidth < intval($imagesize[0]))
				{
					$biggestImageWidth =  intval($imagesize[0]);
				}
			}
		}
		if($biggestImageWidth > $rowHeaderTdWidth)
		{
			$rowHeaderTdWidth = $biggestImageWidth;
		}
		//
		// end set widths for table tds
		
		// create options array and check for defaults
		for ($i=0;$i<$optionsInOneRow;$i++)
			{	
				//create options
				switch ($typeToShow)
				{
					case "radiotable":
					{
						// radio
						$formOptions[] = &quickformSmExtended::createElement('radio', null, null, '',$formPartTagData[$i]["FORMELEMENT_ID_PK"],array("class" => "radio"));
						//check for post // workaround for buggy validation // 030324-rr
						if ($_POST[$formPartTagData[0]["FORMTYPE_ID_PK"]][0] == $formPartTagData[$i]["FORMELEMENT_ID_PK"])
						{
							$formDefaults[$formPartTagData[0]["FORMTYPE_ID_PK"]."[0]"] = $formPartTagData[$i]["FORMELEMENT_ID_PK"];
						}
						break;
					}
					case "checkboxtable":
					{
						// checkbox
						$formOptions[] = &quickformSmExtended::createElement('checkbox', $formPartTagData[$i]["FORMELEMENT_ID_PK"], null, '',($jsFunctionCaller["maxChecked"])? array('class' => 'checkbox', 'onClick' => 'javascript:checkEntries(this.name , document.forms[0], elementsChecked'.$formPartTagData[0]["FORMTYPE_ID_PK"].');') : array('class' => 'checkbox'));
						//check for post // workaround for buggy validation // 030324-rr
						if ($_POST[$formPartTagData[0]["FORMTYPE_ID_PK"]][$formPartTagData[$i]["FORMELEMENT_ID_PK"]] == true && !$jsFunctionCaller["maxChecked"]) // temporary solution to avoid more than allowed checks if required // 030429-rr
						{
							$formDefaults[$formPartTagData[0]["FORMTYPE_ID_PK"]][$formPartTagData[$i]["FORMELEMENT_ID_PK"]]= true;
						}
						break;
					}
					case "texttable":
					{
						// text
						$formOptions[] = &quickformSmExtended::createElement('text', $formPartTagData[$i]["FORMELEMENT_ID_PK"], '', array('class'=>'basic', 'style'=>'width:'.$formPartTagData[0]["FORMTYPE_SIZE"].';'));
						//check for post // workaround for buggy validation // 030324-rr
						$formDefaults[$formPartTagData[0]["FORMTYPE_ID_PK"]][$formPartTagData[$i]["FORMELEMENT_ID_PK"]] = $_POST[$formPartTagData[0]["FORMTYPE_ID_PK"]][$formPartTagData[$i]["FORMELEMENT_ID_PK"]];
						break;
					}
					default:
					{
						return $formPartTagData;
					}
				}
				// replace alias
				if($formPartTagData[$i]["FORMELEMENT_HEADERIMAGE"] || $formPartTagData[$i]["FORMELEMENT_HEADER"])
				{
					($formPartTagData[$i]["FORMELEMENT_HEADERIMAGE"])? ($headerImageTag =  $formPartTagData[$i]["FORMELEMENT_HEADERIMAGE"]."<br>") : ($headerImageTag =  "");
					($formPartTagData[$i]["FORMELEMENT_HEADER"] && !$formPartTagData[$i]["FORMELEMENT_HIDEHEADER"])? ($headerTag =  trim($formPartTagData[$i]["FORMELEMENT_HEADER"])."<br>") : ($headerTag =  "");
					($empty = $headerImageTag.$headerTag == "")? $headerImageTag = "&nbsp;" : "";
					$option = str_replace('{option}', $headerImageTag.$headerTag, $optionWrapper);
				}
				else
				{
					$option = str_replace('{option}', "&nbsp;", $optionWrapper);
				}
				$option = str_replace('{optiontdwidth}', $optionTdWidth, $option);
				// create optionhtml
				$optionHtml .= $option;
				// check for switch
				if ($formPartTagData[$i]["FORMELEMENT_SWITCHTO"])
				{
					$this->switchToData[$this->switchIndex]["switchTo"]  		= $formPartTagData[$i]["FORMELEMENT_SWITCHTO"];
					$this->switchToData[$this->switchIndex]["switchElementId"]  	= $formPartTagData[$i]["FORMELEMENT_ID_PK"];
					$this->switchToData[$this->switchIndex]["switchFormTagId"] 	= $formPartTagData[0]["FORMTYPE_ID_PK"];
					$this->switchToData[$this->switchIndex]["switchSurveyContinue"]	= $formPartTagData[$i]["FORMELEMENT_SRVY_CNTNUE"];
					$this->switchToData[$this->switchIndex]["switchFormType"] 	= "$typeToShow";
					$this->switchToData[$this->switchIndex]["switchFormRow"]  	= '0';
					$this->switchIndex++;
				}
				////
			}
		// set defaults
		$this->processedForm->setDefaults($formDefaults);
		// add question breaks
		$question	=	$this->variableReplace(nl2br($formPartTagData[0]["FORMTYPE_QUESTION"]));
		// check breaks
		if($formPartTagData[0]["FORMTYPE_IMAGE"])
		{
			// get number of breaks in question
			$pieces = explode("<br", $question);
			for($i=-2;$i<count($pieces);$i++)
			{
				$additionalBreaks .= "<br>";
			}
		}
		// replace alias
		if($displayRules = $this->qffhasRule($myProcessRulesData))
		{
			for($i = 0; $i < count($displayRules) ; ++$i)
			{
				$displayRulesAlert 	.= str_replace("{thisError}", $displayRules[$i]["alert"], $this->srvyElementErrorWrappers[$displayRules[$i]["type"]]);
				$displayRulesHtml	.= $this->srvyDisplayError[$displayRules[$i]["type"]];
			}
			$head 		= 	str_replace('{require}', $displayRulesHtml, $head);
			// if error has occured
			if($this->validateStatus == 1)
			{
				if(is_array($_SESSION["qffControlPool"]["validationErrors"]))
				{
					// loop possible matching errors
					foreach($_SESSION["qffControlPool"]["validationErrors"] as $errorKey => $errorValue)
					{
						// formtypeId check if one element missing
						$explodedName  		= explode ("[", $errorKey);
						$errorFormtypeId	= $explodedName[0];
						//
						if($errorFormtypeId == $formPartTagData[0]["FORMTYPE_ID_PK"])
						{
							$displayGroupedError = true;
							break;
						}
						$displayGroupedError = false;
					}
				}
				// display error if needed
				if($displayGroupedError)
				{
					$head 		= 	str_replace('{validationerror}', $displayRulesAlert.$additionalBreaks, $head);
				}
				else
				{
					$head 		= 	str_replace('{validationerror}', "&nbsp;".$additionalBreaks, $head);
				}
			}
			// reset errors
			$displayRulesHtml = "";
			$displayRulesAlert = "";
		}
		else
		{
			$head 		= 	str_replace('{validationerror}', "&nbsp;".$additionalBreaks, $head);
		}
		// check for additional imagetag
		($formPartTagData[0]["FORMTYPE_IMAGE"])? ($addImageTag = "<br><br>".$formPartTagData[0]["FORMTYPE_IMAGE"]) : ($addImageTag = "");
		// more aliasses
		$head 					= 	str_replace('{label}', $question, $head);
		$head					=	str_replace('{addimage}', $addImageTag, $head);
		$head 					= 	str_replace('{rowheadertdwidth}', $rowHeaderTdWidth, $head);
		// check for additional image
		($formPartTagData[0]["FORMELEMENT_ADDHEADERIMAGE"])? ($headerImageTag =  $formPartTagData[0]["FORMELEMENT_ADDHEADERIMAGE"]."<br>") : ($headerImageTag =  "");
		// check for header
		($formPartTagData[0]["FORMELEMENT_ADDHEADER"] && !$formPartTagData[0]["FORMELEMENT_HIDEADDHEADER"])? ($headerTag =  $formPartTagData[0]["FORMELEMENT_ADDHEADER"]."<br>&nbsp;") : ($headerTag =  "&nbsp;");
		$head 					= 	str_replace('{rowheader}', "<br>".$headerImageTag.$headerTag, $head);
		$head 					= 	str_replace('{optionlabels}', $optionHtml, $head);
		$head 					= 	str_replace('{optiontdwidth}', $optionTdWidth, $head);
		$separateElements 		= 	str_replace('{optiontdwidth}', $optionTdWidth, $separateElements);
		// not needed aliasses
		$head = $this->qffClearObsoleteAliasses($head);
		// set head wrapper
		$this->processedForm->addData($head);
		// create group quickformSmExtended_radio($elementName=null, $elementLabel=null, $text=null, $value=null, $attributes=null)
		if($typeToShow == "radiotable")
		{
		$this->processedForm->addElementGroup($formOptions, 
											$question,
											$formPartTagData[0]["FORMTYPE_ID_PK"]."[0]",
											$separateElements);
		}
		else
		{
		$this->processedForm->addElementGroup($formOptions, 
											$question,
											$formPartTagData[0]["FORMTYPE_ID_PK"],
											$separateElements);
		}
		// add additional rows
		for ($k=1;$k<$groupRows;$k++)
		{
			$this->qffAddTableGroupRow(&$formPartTagData,$k,$rowHeaderTdWidth,$optionTdWidth,$typeToShow,$jsFunctionCaller);
		}
		// set foot wrapper
		$this->processedForm->addData($foot);
		//add borderline
		$this->processedForm->addLine('');
		// process rules data
		if(is_array($myProcessRulesData))
		{
			$this->qffProcessTableRules($myProcessRulesData, $groupRows, $optionsInOneRow, $typeToShow, $formPartTagData);
		}
		// return data
		return $formPartTagData;
		
	}
	
	/**
	*	creates additional group text row
	*
    *	@access	public
    *	@param	array	$formPartTagData 			Array containing Elementdata surrogat from $this->qffTypeArray
    */
	function qffAddTableGroupRow($formPartTagData,$rowCounter,$rowHeaderTdWidth,$optionTdWidth,$typeToShow,$jsFunctionCaller)
    {
		// global wrappers
		global $cfgSrvyTableHeadHtml;
		global $cfgSrvyTableOptionWrapperHtml;
		global $cfgSrvyTableFootHtml;
		global $cfgSrvyTableInputSpacerHtml;
		
		// check for rules
		$myProcessRulesData = $formPartTagData[0]["FORMTYPE_RULE"];
		
		// html
		$separateElements	= $cfgSrvyTableInputSpacerHtml;
		$head				= $cfgSrvyTableHeadHtml;
		$optionWrapper		= $cfgSrvyTableOptionWrapperHtml;
		$foot			 	= $cfgSrvyTableFootHtml;
		
		// number of group rows
		$groupRows = $formPartTagData[0]["FORMTYPE_TABLESPAN"];
		// first row to process
		$firstOption = ((count($formPartTagData)/$groupRows)*$rowCounter);
		// last row to process
		$lastOption = $firstOption + (count($formPartTagData)/$groupRows);
		// create options array and check for defaults
		for ($i = $firstOption; $i < $lastOption; $i++)
			{	
				//create options
				switch ($typeToShow)
				{
					case "radiotable":
					{
						// radio
						$formOptions[] = &quickformSmExtended::createElement('radio', null, null, '',$formPartTagData[$i]["FORMELEMENT_ID_PK"],array("class" => "radio"));
						//check for post // workaround for buggy validation // 030324-rr
						if ($_POST[$formPartTagData[0]["FORMTYPE_ID_PK"]][$rowCounter] == $formPartTagData[$i]["FORMELEMENT_ID_PK"])
						{
							$formDefaults[$formPartTagData[0]["FORMTYPE_ID_PK"]."[$rowCounter]"] = $formPartTagData[$i]["FORMELEMENT_ID_PK"];
						}
						break;
					}
					case "checkboxtable":
					{
						// checkbox
						$formOptions[] = &quickformSmExtended::createElement('checkbox', $formPartTagData[$i]["FORMELEMENT_ID_PK"], null, '',($jsFunctionCaller["maxChecked"])? array('class' => 'checkbox', 'onClick' => 'javascript:checkEntries(this.name , document.forms[0], elementsChecked'.$formPartTagData[$rowCounter]["FORMTYPE_ID_PK"].');') : array('class' => 'checkbox'));
						//check for post // workaround for buggy validation // 030324-rr
						if ($_POST[$formPartTagData[$rowCounter]["FORMTYPE_ID_PK"]][$formPartTagData[$i]["FORMELEMENT_ID_PK"]] == true && !$jsFunctionCaller["maxChecked"]) // temporary solution to avoid more than allowed checks if required // 030429-rr
						{
							$formDefaults[$formPartTagData[$rowCounter]["FORMTYPE_ID_PK"]][$formPartTagData[$i]["FORMELEMENT_ID_PK"]]= true;
						}
						break;
					}
					case "texttable":
					{
						// text
						$formOptions[] = &quickformSmExtended::createElement('text', $formPartTagData[$i]["FORMELEMENT_ID_PK"], '', array('class'=>'basic', 'style'=>'width:'.$formPartTagData[0]["FORMTYPE_SIZE"].';'));
						//check for post // workaround for buggy validation // 030324-rr
						$formDefaults[$formPartTagData[0]["FORMTYPE_ID_PK"]][$formPartTagData[$i]["FORMELEMENT_ID_PK"]] = $_POST[$formPartTagData[0]["FORMTYPE_ID_PK"]][$formPartTagData[$i]["FORMELEMENT_ID_PK"]];
						break;
					}
					default:
					{
						return $formPartTagData;
					}
				}
				// replace alias
				$option = str_replace('{option}', $formPartTagData[$i]["FORMELEMENT_HEADER"]."<br><br>", $optionWrapper);
				$option = str_replace('{optiontdwidth}', $optionTdWidth, $option);
				// create optionhtml
				$optionHtml .= $option;
				// check for switch
				if ($formPartTagData[$i]["FORMELEMENT_SWITCHTO"])
				{
					$this->switchToData[$this->switchIndex]["switchTo"]  		= $formPartTagData[$i]["FORMELEMENT_SWITCHTO"];
					$this->switchToData[$this->switchIndex]["switchElementId"] 	= $formPartTagData[$i]["FORMELEMENT_ID_PK"];
					$this->switchToData[$this->switchIndex]["switchFormTagId"] 	= $formPartTagData[0]["FORMTYPE_ID_PK"];
					$this->switchToData[$this->switchIndex]["switchSurveyContinue"]	= $formPartTagData[$i]["FORMELEMENT_SRVY_CNTNUE"];
					$this->switchToData[$this->switchIndex]["switchFormType"]	= "$typeToShow";
					$this->switchToData[$this->switchIndex]["switchFormRow"]	= "$rowCounter";
					$this->switchIndex++;
				}
			}
		// set defaults
		$this->processedForm->setDefaults($formDefaults);
		// add question breaks
		$question	=	$this->variableReplace(nl2br($formPartTagData[0]["FORMTYPE_QUESTION"]));
		// check breaks
		if($formPartTagData[0]["FORMTYPE_IMAGE"])
		{
			// get number of breaks in question
			$pieces = explode("<br", $question);
			for($i=-2;$i<count($pieces);$i++)
			{
				$additionalBreaks .= "<br>";
			}
		}
		// replace aliasses
		$head 		= 	str_replace('{rowheadertdwidth}', $rowHeaderTdWidth, $head);
		// check for additional image
		($formPartTagData[$firstOption]["FORMELEMENT_ADDHEADERIMAGE"])? ($headerImageTag =  $formPartTagData[$firstOption]["FORMELEMENT_ADDHEADERIMAGE"]."<br>") : ($headerImageTag =  "");
		// check for header
		($formPartTagData[$firstOption]["FORMELEMENT_ADDHEADER"] && !$formPartTagData[$firstOption]["FORMELEMENT_HIDEADDHEADER"])? ($headerTag =  $formPartTagData[$firstOption]["FORMELEMENT_ADDHEADER"]."<br>&nbsp;") : ($headerTag =  "&nbsp;");
		$head 		= 	str_replace('{rowheader}', "<br>".$headerImageTag.$headerTag, $head);
		$head 		= 	str_replace('{optionlabels}', $optionHtml, $head);
		$head 		= 	str_replace('{optiontdwidth}', $optionTdWidth, $head);
		$separateElements 		= 	str_replace('{optiontdwidth}', $optionTdWidth, $separateElements);
		// not needed aliasses
		$head = $this->qffClearObsoleteAliasses($head);
		// set head wrapper
		$this->processedForm->addData($head);
		// create radio  quickformSmExtended_radio($elementName=null, $elementLabel=null, $text=null, $value=null, $attributes=null)
		if($typeToShow == "radiotable")
		{
			// check if only one column then give [0] for index to allow vertical required
			if ($lastOption - $firstOption == 1)
			{
				$rowCounter = 0;
			}
			$this->processedForm->addElementGroup($formOptions, 
												$question,
												$formPartTagData[0]["FORMTYPE_ID_PK"]."[$rowCounter]",
												$separateElements);
		}
		else
		{
			$this->processedForm->addElementGroup($formOptions, 
												$question,
												$formPartTagData[0]["FORMTYPE_ID_PK"],
												$separateElements);
		}
		// set foot wrapper
		//$this->processedForm->addData($foot);
		// return data
		return $formPartTagData;
		
	}

	/**
	*	creates switchtext
	*
    *	@access	public
    *	@param	array	$formPartTagData 			Array containing Elementdata surrogat from $this->qffTypeArray
    */
	function qffCreateTextSwitch($formPartTagData)
    {
		// check for rules
		$myProcessRulesData = $formPartTagData[0]["FORMTYPE_RULE"];
		// create options and check for defaults and switches
		$lastOption = (count($formPartTagData));
		for ($i=0;$i<$lastOption;$i++)
			{	
				//create options
				$text[] = &quickformSmExtended::createElement('text', $formPartTagData[$i]["FORMELEMENT_ID_PK"], '', array('class'=>'basic'));
				//check for post // workaround for buggy validation // 030324-rr
				$formDefaults[$formPartTagData[0]["FORMTYPE_ID_PK"]][$formPartTagData[$i]["FORMELEMENT_ID_PK"]] = $_POST[$formPartTagData[0]["FORMTYPE_ID_PK"]][$formPartTagData[0]["FORMELEMENT_ID_PK"]];
				// check for switch
				if ($formPartTagData[$i]["FORMELEMENT_SWITCHTO"])
				{
					$this->switchToData[$this->switchIndex]["switchTo"]  		= $formPartTagData[$i]["FORMELEMENT_SWITCHTO"];
					$this->switchToData[$this->switchIndex]["switchElementId"]	= $formPartTagData[$i]["FORMELEMENT_ID_PK"];
					$this->switchToData[$this->switchIndex]["switchFormTagId"]	= $formPartTagData[0]["FORMTYPE_ID_PK"];
					$this->switchToData[$this->switchIndex]["switchSurveyContinue"]	= $formPartTagData[$i]["FORMELEMENT_SRVY_CNTNUE"];
					$this->switchToData[$this->switchIndex]["switchFormType"]	= "switchtext";
					$this->switchIndex++;
				}
				////
			}
		// set defaults
		$this->processedForm->setDefaults($formDefaults);
		// add question breaks
		$question	=	$this->variableReplace(nl2br($formPartTagData[0]["FORMTYPE_QUESTION"]));
		// check breaks
		if($formPartTagData[0]["FORMTYPE_IMAGE"])
		{
			// get number of breaks in question
			$pieces = explode("<br", $question);
			for($i=-2;$i<count($pieces);$i++)
			{
				$additionalBreaks .= "<br>";
			}
		}
		// replace alias
		$head 		= 	str_replace('{label}', $question, $this->srvyElementHeadHtml);
		// check for addimage
		($formPartTagData[0]["FORMTYPE_IMAGE"])? ($addImageTag = "<br><br>".$formPartTagData[0]["FORMTYPE_IMAGE"]) : ($addImageTag = "");
		$head		=	str_replace('{addimage}', $addImageTag, $head);
		//
		if($displayRules = $this->qffhasRule($myProcessRulesData))
		{
			for($i = 0; $i < count($displayRules) ; ++$i)
			{
				$displayRulesAlert 	.= str_replace("{thisError}", $displayRules[$i]["alert"], $this->srvyElementErrorWrappers[$displayRules[$i]["type"]]);
				$displayRulesHtml	.= $this->srvyDisplayError[$displayRules[$i]["type"]];
			}
			$head 		= 	str_replace('{require}', $displayRulesHtml, $head);
			// if error has occured
			if($this->validateStatus == 1)
			{
				if(is_array($_SESSION["qffControlPool"]["validationErrors"]))
				{
					// loop possible matching errors
					foreach($_SESSION["qffControlPool"]["validationErrors"] as $errorKey => $errorValue)
					{
						// formtypeId check if one element missing
						$explodedName  		= explode ("[", $errorKey);
						$errorFormtypeId	= $explodedName[0];
						//
						if($errorFormtypeId == $formPartTagData[0]["FORMTYPE_ID_PK"])
						{
							$displayGroupedError = true;
							break;
						}
						$displayGroupedError = false;
					}
				}
			}
			// display error if needed
			if($displayGroupedError)
			{
				$head 		= 	str_replace('{validationerror}', $displayRulesAlert.$additionalBreaks, $head);
			}
			else
			{
				$head 		= 	str_replace('{validationerror}', "&nbsp;".$additionalBreaks, $head);
			}
			// reset errors
			$displayRulesHtml = "";
			$displayRulesAlert = "";
		}
		else
		{
			$head 		= 	str_replace('{validationerror}', "&nbsp;".$additionalBreaks, $head);
		}
		// not needed aliasses
		$head = $this->qffClearObsoleteAliasses($head);
		// set head wrapper
		$this->processedForm->addData($head);
		// alignment
		$separateElements = "<br>";
		// create radio  quickformSmExtended_radio($elementName=null, $elementLabel=null, $text=null, $value=null, $attributes=null)
		$this->processedForm->addElementGroup($text, 
											$question,
											$formPartTagData[0]["FORMTYPE_ID_PK"],
											$separateElements);
		// set foot wrapper
		$this->processedForm->addData($this->srvyElementFootHtml);
		//add borderline
		$this->processedForm->addLine('');
		// process rules data
		if(is_array($myProcessRulesData))
		{
			$this->qffProcessTableRules($myProcessRulesData, 1, count($formPartTagData), $formPartTagData[0]["FORMTYPE_TYPE"], $formPartTagData);
		}
		// return data
		return $formPartTagData;
	}
}
?>
