<?php
// +----------------------------------------------------------------------+
// | sm survey module -	quickform.extended								  |
// +----------------------------------------------------------------------+
// | Copyright (c) 2002 serie a - Digitale Medien und Systeme GmbH        |
// +----------------------------------------------------------------------+
// | Authors: Jrn Allert <allert@serie-a.de>                             |
// |          Rene Renk <renk@serie-a.de>                                 |
// +----------------------------------------------------------------------+
// | Description: Extending  html_Quickform/Pearclass with new functions  |
// |         								                              |
// +----------------------------------------------------------------------+
//
// $Id: quickform.extended.inc.org030331.php,v 1.1.1.1 2004/07/15 13:32:51 opensurveypilot Exp $

require_once($cfgPathToProjectAdmin."/config/config.inc.php"); // common config file // common config file
require_once($cfgPathToSurveyFiles."/config/survey.config.inc.php"); // auth config file

require_once("PEAR.php");
require_once("HTML/Common.php");
require_once("HTML/QuickForm.php"); //Pear Formclass to be extended


/**
* extends Html-Quickform with new functionalities
*
* @author      Jrn Allert <allert@serie-a.de>
* @author      Rene Renk <renk@serie-a.de>
* @version     0.1
* @since       PHP 4.0.3pl1
*/
class quickformSmExtended extends HTML_QuickForm {
	
    /**
     * FormGroupHeader Template string
     * @var       string
     * @since     2.0
     * @access    private
     */
    var $_formGroupHeaderTemplate;

    /**
     * Line Template string
     * @var       string
     * @since     2.0
     * @access    private
     */
    var $_lineTemplate;

    // {{{ constructor
    /**
     * Class constructor
     * @param    string      $formName          Form's name.
     * @param    string      $method            (optional)Form's method defaults to 'POST'
     * @param    string      $action            (optional)Form's action
     * @param    string      $target            (optional)Form's target defaults to '_self'
     * @param    array       $attributes        (optional)Associative array of form tag extra attributes
     * @access   public
     */
    function quickformSmExtended($formName="", $method="POST", $action="", $target="_self", $attributes=null)
    {	
		parent::HTML_QuickForm($formName, $method, $action, $target, $attributes=null);
    } // end constructor
    
    // }}}
	// {{{ clearAllTemplates()
    /**
     * Clears all the HTML out of the templates that surround notes, elements, etc.
     * Useful when you want to use addData() to create a completely custom form look
     *
     * @since   2.0
     * @access  public
     * @returns void
     */
    function clearElementTemplates()
    {
		// global templates
		global  $cfgSrvyHeaderHtml;
		global  $cfgSrvyLineHtml;
		global	$cfgSrvyElementHtml;
		global	$cfgSrvyFormHtml;
		global	$cfgSrvyRequiredNoteHtml;
		global	$cfgSrvyHeaderHtml;
		
		// set new templates 
		$this->_templates = array();
        $this->setElementTemplate('{element}');
		$this->setLineTemplate($cfgSrvyLineHtml);
        $this->setFormTemplate($cfgSrvyFormHtml);
        $this->setRequiredNoteTemplate($cfgSrvyRequiredNoteHtml);
		$this->setHeaderTemplate($cfgSrvyHeaderHtml);
       
    }
    // }}}
    // {{{ addformGroupHeader()

    /**
     * Adds a formGroupHeader in the form
     *
     * @param     string    $label      label of formGroupHeader
     * @since     1.0   
     * @access    public
     * @return    void
     * @throws    
     */
    function addFormGroupHeader($label)
    {
        $this->_elements[] = array("formGroupHeader"=>$label);
    } // end func formGroupHeader

    /**
     * Adds a line in the form
     *
     * @param     string    $label      label of line
     * @since     1.0   
     * @access    public
     * @return    void
     * @throws    
     */
    function addLine($label)
    {
        $this->_elements[] = array("line"=>'');
    } // end func addLine
    // }}}
    // {{{ _wrapLine ()
	
    /**
     * Html Wrapper method for form lines
     *
     * @param     string    $line line to be wrapped
     * @since     1.0
     * @access    private
     * @return    void
     * @throws    
     */
    function _wrapLine ($line)
    {
        $tabs = $this->_getTabs();
        $html = "";
        $html = $this->_lineTemplate;
        return $html;
    } // end func _wrapLine
	
    // }}}
    // {{{_wrapFormGroupHeader()
	
    /**
     * Html Wrapper method for form formGroupHeader
     *
     * @param     string    $header formGroupHeader to be wrapped
     * @since     1.0
     * @access    private
     * @return    void
     * @throws    
     */
    function _wrapFormGroupHeader ($header)
    {
        $tabs = $this->_getTabs();
        $html = "";
        $html = str_replace('{formGroupHeader}', $header, $this->_formGroupHeaderTemplate);
        return $html;
    } // end func wrapformGroupHeader
        
    // }}}
    // {{{ _buildLine()
	
    /**
     * Builds a form line
     *
     * @param     string    $element    line to be built
     * @since     1.0    
     * @access    private
     * @return    void
     * @throws    
     */
    function _buildLine($element)
    {
        $line = $element["line"];
        return $this->_wrapLine($line);
    } // end func _buildLine
	
    // }}}
    // {{{ setHeaderTemplate()
	
    /**
     * Builds a form formGroupHeader
     *
     * @param     string    $element    header to be built
     * @since     1.0    
     * @access    private
     * @return    void
     * @throws    
     */
    function _buildFormGroupHeader($element)
    {
        $header = $element["formGroupHeader"];
        return $this->_wrapFormGroupHeader($header);
    } // end func _buildFormGroupHeader
    
    // }}}
    // {{{ setFormGroupHeaderTemplate()

    /**
     * Sets header template 
     *
     * @param     string   $html    The HTML surrounding the header 
     * @since     2.0
     * @access    public
     * @return    void
     */
    function setFormGroupHeaderTemplate($html)
    {
        $this->_formGroupHeaderTemplate = $html;
    } // end func setFormGroupHeaderTemplate

    // }}}
    // {{{ setLineTemplate()

    /**
     * Sets Line template 
     *
     * @param     string   $html    The HTML surrounding the header 
     * @since     2.0
     * @access    public
     * @return    void
     */
    function setLineTemplate($html)
    {
        $this->_lineTemplate = $html;
    } // end func setLineTemplate

    // }}}
    // {{{ toHtml ()

    /**
     * Returns an HTML version of the form
     *
     * @return   string     Html version of the form
     * @since     1.0
     * @access   public
     */
    function toHtml ()
    {
        $html = "";
        reset($this->_elements);
        foreach ($this->_elements as $element) {
            if (isset($element["header"])) {
                $html .= $this->_buildHeader($element);
            } elseif (isset($element["formGroupHeader"])) {
                $html .= $this->_buildFormGroupHeader($element);
            } elseif (isset($element["line"])) {
                $html .= $this->_buildLine($element);
            } elseif (isset($element["data"])) {
                $html .= $element['data'];
            } else {
                $html .= $this->_buildElement($element);
            }
        }
        if (!empty($this->_required) && $this->_freezeAll == false) {
            $html .= $this->_wrapRequiredNote($formTable);
        }
        $html = $this->_wrapForm($html);
        if (!empty($this->_rules) && $this->_freezeAll == false) {
            $tabs = $this->_getTabs();
            $html =
                "\n$tabs<script language=\"javascript\">\n" .
                "$tabs<!-- \n" . $html = $this->_buildRules() . 
                "$tabs//-->\n" .
                "$tabs</script>" .
                $html;
        }
        return $html;
    } // end func toHtml

    /**
     * Adds a validation rule for the given field
     *
     * @param    string     $element       		Form element name
     * @param    string     $message       		Message to display for invalid data
     * @param    string     $type          		Rule type use getRegisteredType to get types
     * @param    string     $format        		(optional)Required for extra rule data
     * @param    string     $validation    		(optional)Where to perform validation: "server", "client"
     * @param    string    	$customizedFormType (optional)indicates extended formtypes whith different validation 030308-rr
     * @param    string    	$processedFormRow   (optional)indicates row for extended formtype 030308-rr
	 * @param    boolean    $reset         		Reset the form element to it's original val if there is an error?
     * @param    boolean    $force         		Force the rule to be applied, even if the target form element does not exist
     * @since    1.0
     * @access   public
     */
    function addRule($element, $message='', $type='', $format='', $validation='server', $reset = false, $force = false, $customizedFormType = false, $processedFormRow = false)
    {
        if (!$force) {
            if (!$this->elementExists($element)) {
                return PEAR::raiseError(null, QUICKFORM_UNREGISTERED_ELEMENT, null, E_USER_WARNING, "Element '$element' does not exist in HTML_QuickForm::addRule()", 'HTML_QuickForm_Error', true);
            }
        }
        if ($type == 'required' || $type == 'uploadedfile') {
            $this->_required[] = $element;
		}
        if (!isset($this->_rules[$element])) {
            $this->_rules[$element] = array();
        }
        if ($validation == 'client') {
            $this->updateAttributes(array('onsubmit'=>'return validate_'.$this->_attributes['name'] . '();'));
        }
        $this->_rules[$element][] = array('type'=>$type, 'format'=>$format, 'message'=>$message, 'validation'=>$validation, 'reset'=>$reset, 'customizedFormType'=>$customizedFormType, 'processedFormRow'=>$processedFormRow);
    } // end func addRule
	
    /**
     * Performs the server side validation
     * @access    public
     * @since     1.0
     * @return    boolean   true if no error found
     * @throws    
     */
    function validate()
    {
        if (count($this->_rules) == 0 || count($this->_submitValues) == 0) {
            return false;
        }
		// default for checkboxtable is false 030308-rr
		$checkboxRow 		 = false;
		$checkboxTableErrors = false;
		
		//print_r($this->_rules);
		//print_r($this->_submitValues);
		//print_r($this->_registeredRules);
		//print_r($this->_required);
		
		// loop rules
        foreach ($this->_rules as $elementName => $rules) 
		{
			// if any errors skip function
            if (isset($this->_errors[$elementName])) 
			{
                continue;
            }
			// loop every rule for element
            foreach ($rules as $rule) 
			{
				// reset variables and set
                $type = $format = $message = null;
                $type = $rule['type'];
                // error out if the rule is not registered
                if (!$this->isRuleRegistered($type)) 
				{
                    return PEAR::raiseError(null, QUICKFORM_INVALID_RULE, null, E_USER_WARNING, "Rule '$type' is not registered in HTML_QuickForm::validate()", 'HTML_QuickForm_Error', true);
                }
                $format = $rule['format'];
                $message = $rule['message'];
                $validation = $rule['validation'];
				$customizedFormType = $rule['customizedFormType'];
				$processedFormRow = $rule['processedFormRow'];
				$ruleData = $this->_registeredRules[$type];
				//
				// switch rulesdata type
                switch ($ruleData[0]) 
				{
					// regular expression
                    case 'regex':
						//
						// following switch is workaround for extended formtypes: radiotable, checkboxtable, texttable
						// 030308-rr
						//
						// check which type of data to validate
						switch ($customizedFormType)
						{
							// if is radiotable
	                        case 'radiotable':
								$regex = str_replace('%data%', $format, $ruleData[1]);
								
								// make array out of formpart name
								$arrayEnding = "[".str_replace("[", "][", $elementName);
								$myValueKey = '$this->_submitValues'.$arrayEnding;
								eval ("\$value = $myValueKey;");
								
								// check if values submitted
								if (!preg_match($regex, $value)) 
								{
		                            if (empty($this->_submitValues[$elementName]) && !$this->isElementRequired($elementName)) 
									{
		                                continue 2;
		                            } 
									else 
									{
		                                $this->_errors[$elementName] = $message;
		                                continue 2;
		                            }
		                        }
								break;
							// if is checkboxtable
	                        case 'checkboxtable':
								$regex = str_replace('%data%', $format, $ruleData[1]);
								
								// make array out of formpart name
								$arrayEnding = "[".str_replace("[", "][", $elementName);
								$myValueKey = '$this->_submitValues'.$arrayEnding;
								eval ("\$value = $myValueKey;");
								
								// formtype to confirm checked question
								$explodedName  = explode ("[", $elementName);
								$formtypeId	   = $explodedName[0];
								
								// check if values submitted
								if (!preg_match($regex, $value)) 
								{
									if (empty($value) && !$this->isElementRequired($elementName)) 
									{
		                                // row has at least one valid result
										$checkboxRow[$formtypeId][$processedFormRow] = true;
										continue 2;
		                            } 
									else 
									{
		                                // collect one error for every row
										$checkboxTableErrors[$formtypeId][$processedFormRow]["message"] 	= $message;
										$checkboxTableErrors[$formtypeId][$processedFormRow]["elementName"] = $elementName;
		                                continue 2;
		                            }
		                        }
								// set row checked
								else
								{
									// row has at least one valid result
									$checkboxRow[$formtypeId][$processedFormRow] = true;
								}
								break;
							// if is checkboxtable
	                        case 'texttable':
								$regex = str_replace('%data%', $format, $ruleData[1]);
								
								// make array out of formpart name
								$arrayEnding = "[".str_replace("[", "][", $elementName);
								$myValueKey        	  = '$this->_submitValues'.$arrayEnding;
								$myElementRequiredKey = '$this->isElementRequired'.$arrayEnding;
								eval ("\$value    = $myValueKey;");
								eval ("\$required = $myElementRequiredKey;");
								
								//echo $message;
								
								// check if values submitted
								if (!preg_match($regex, $value)) 
								{
									if (empty($value) && !$this->isElementRequired($elementName)) 
									{
		                                continue 2;
		                            } 
									else 
									{
										$this->_errors[$elementName] = $message;
										continue 2;
		                            }
		                        }
								break;
							// if is groupedtext
	                        case 'groupedtext':
								$regex = str_replace('%data%', $format, $ruleData[1]);
								
								// make array out of formpart name
								$arrayEnding = "[".str_replace("[", "][", $elementName);
								$myValueKey        	  = '$this->_submitValues'.$arrayEnding;
								eval ("\$value    = $myValueKey;");
															
								// check if values submitted
								if (!preg_match($regex, $value)) 
								{
									if (empty($value) && !$this->isElementRequired($elementName)) 
									{
		                                continue 2;
		                            } 
									else 
									{
										$this->_errors[$elementName] = $message;
										continue 2;
		                            }
		                        }
								break;
							// if is swichtext
	                        case 'switchtext':
								$regex = str_replace('%data%', $format, $ruleData[1]);
								
								// make array out of formpart name
								$arrayEnding = "[".str_replace("[", "][", $elementName);
								$myValueKey        	  = '$this->_submitValues'.$arrayEnding;
								eval ("\$value    = $myValueKey;");
															
								// check if values submitted
								if (!preg_match($regex, $value)) 
								{
									if (empty($value) && !$this->isElementRequired($elementName)) 
									{
		                                continue 2;
		                            } 
									else 
									{
										$this->_errors[$elementName] = $message;
										continue 2;
		                            }
		                        }
								break;
							//
							// end workaround
							//
							// if is no special group
							default:
								$regex = str_replace('%data%', $format, $ruleData[1]);
								// check if values submitted
		                        if (!preg_match($regex, $this->_submitValues[$elementName])) 
								{
		                            if (empty($this->_submitValues[$elementName]) && !$this->isElementRequired($elementName)) 
									{
		                                continue 2;
		                            } 
									else 
									{
		                                $this->_errors[$elementName] = $message;
		                                continue 2;
		                            }
		                        }
						}
	                	break;
					// function to check
                    case 'function':
                        if (method_exists($this, $ruleData[1])) 
						{
                            if (!$this->$ruleData[1]($elementName, $this->_submitValues[$elementName], $format)) 
							{
                                $this->_errors[$elementName] = $message;
                                continue 2;
                            }
                        } 
						else 
						{
                            if (!$ruleData[1]($elementName, $this->_submitValues[$elementName], $format)) 
							{
                                $this->_errors[$elementName] = $message;
                                continue 2;
                            }
                        }
                        break;
                }
            }
        }
		//
		// following part is workaround for extended formtypes: checkboxtable 030307-rr
		//
		// check checkboxtableerrors against filled checkboxtablerows
		if($checkboxTableErrors)
		{
			foreach($checkboxTableErrors as $formtypeId => $processedRowErrorData)
			{
				foreach($processedRowErrorData as $rowIndex => $errormessageData)
				{
					// if no valid result in row set error
					if(!$checkboxRow[$formtypeId][$rowIndex])
					{
						$this->_errors[$errormessageData["elementName"]] = $errormessageData["message"];
					}
				}
			}
		}
		// end workaround
		//
        if (count($this->_errors) > 0) 
		{
            $files = $this->_submitFiles;
            for (reset($files); $element=key($files); next($files)) 
			{
                $file = pos($files);
                @unlink($file["tmp_name"]);
            }
            return false;
        }
        return true;
    } // end func validate
	
    // }}}
} // end class HTML_QuickForm
?>
