<?php 
// +----------------------------------------------------------------------+
// | sm survey module - output start page                                 |
// +----------------------------------------------------------------------+
// | Copyright (c) 2002 serie a - Digitale Medien und Systeme GmbH        |
// +----------------------------------------------------------------------+
// | Authors: J?rn Allert <allert@serie-a.de>                             |
// |          Rene Renk <renk@serie-a.de>                                 |
// +----------------------------------------------------------------------+
//
// $Id: login.top.code.php,v 1.1.1.1 2004/07/15 13:32:57 opensurveypilot Exp $

//session_start
@session_start();

// read xml file
$filename = "survey.xml";
$fd = fopen ($filename, "r");
$contents = fread ($fd, filesize ($filename));
fclose ($fd);

preg_match("/(<lang>)(.*)(<\/lang>)/i", $contents, $matches);
$surveylang = $matches[2];

preg_match("/(<id>)(.*)(<\/id>)/i", $contents, $matches);
$projectId = $matches[2];

// require all configuration files and libraries
require_once("./../../administration/config/config.inc.php"); // common config file
require_once($cfgPathToConf."/file.inc.php"); // project files
require_once($cfgPathToSurveyFiles."/config/survey.config.inc.php"); // auth config file
require_once($cfgPathToSurveyFiles."/lib/security/security.inc.php"); // security functions
require_once($cfgPathToSurveyConfig."/survey.file.inc.php"); // modules files
require_once($cfgPathToSurveyLib."/".$fileSrvyQuickformfunctions); // modules files
require_once("./../../administration/config/lang/".$surveylang.".script.inc.php");

// login check
if ($_SESSION["surveySessionId"] != session_id())
{
    ?>
    <html><body>
    <script type="text/javascript">
    window.location.href="index.php";
    </script>
    <?php
    exit;
}

// check if form was submitted
if($_SERVER["REQUEST_METHOD"] == "POST")
{
    // get email and tan
    $email = $_POST["login"];
    $tan = $_POST["tan"];
    $projectId = $_SESSION["projectId"];
    
    //create new security object
    $security = &new securityFunctions;
    
    // set project id
    $security->setProjectId($projectId);
    
    // set tan table name
    $security->setTanTableName();
    
    // check if tan is in db
    if($security->checkTan($tan))
    {
        // insert tan user in db and set tan_used to yes
        $security->updateTan($tan, $email);
        
		// give tan to session as determination value
		$_SESSION["tanAsDeterminationValue"] = $tan;
		
        // set login cookie
        $cookieParams["projectId"] = $projectId;
        $cookieParams["surveySessionId"] = session_id();
        $cookieParams["securityMethod"] = "tan";
        $security->writeCookie($cookieParams);
        
        // redirect to form
        if(!$security->errorMessage)
        {
            ?>
            <html><body>
            <script type="text/javascript">
            window.location.href="form.php";
            </script>
            <?php
            exit;
        }
    }
    else
    {
        ?>
        <script type="text/javascript">
        var errors= "Ung?ltiger TAN";
        </script>
        <?php
    }
}
else
{
    ?>
    <script type="text/javascript">
    var errors= "";
    </script>
    <?php
}
?>