<?php
// +----------------------------------------------------------------------+
// | sa survey module - survey management                                 |
// +----------------------------------------------------------------------+
// | Copyright (c) 2002 serie a - Digitale Medien und Systeme GmbH        |
// +----------------------------------------------------------------------+
// | Authors: Jrn Allert <allert@serie-a.de>                             |
// |          Rene Renk <renk@serie-a.de>                                 |
// +----------------------------------------------------------------------+
// | Description:                                                         |
// +----------------------------------------------------------------------+
//
// $Id: security.inc.php,v 1.1.1.1 2004/07/15 13:33:00 opensurveypilot Exp $
// require all configuration files and libraries

// start session
@session_start();

if (is_file("./../config/config.inc.php"))
{
	require_once("./../config/config.inc.php"); // common config file
}	
elseif (is_file("./../../config/config.inc.php"))
{
	require_once("./../../config/config.inc.php"); // common config file
}


require_once($cfgPathToConf."/file.inc.php"); // project files
require_once($cfgPathToSurveyFiles."/config/survey.config.inc.php"); // auth config file
require_once ("DB.php"); // PEAR::DB
/**
* security functions class
*
* @author  Jrn Allert <allert@serie-a.de>
* @author  Rene Renk <renk@serie-a.de>
* @access  public
*/
class securityFunctions
{
    /**
    *	error message
    *	@var    string  $errorMessage
    */
    var $errorMessage;
    
    /**
    *	survey ID
    *	@var    int  $projectId
    */
    var $projectId;
    
    /**
    *	security method
    *	@var    int  $securityMethod
    */
    var $securityMethod;
    
    /**
    *	tan table
    *	@var    string  $tanTableName
    */
    var $tanTableName;
    
    /**
    *	group table
    *	@var    string  $tanGroupTableName
    */
	var $tanGroupTableName;
    
    /**
    *	groups to tans
    *	@var    string  $groupsToTans
    */
	var $groupsToTans;
	
    /**
    *	new group to create
    *	@var    string  $groupsToTans
    */
	var $newGroupToCreate;
	
    /**
    *	group to move tans to
    *	@var    string  $groupsToTans
    */
	var $groupToMoveTansTo;
	
    /**
    *	tan time limit
    *	@var    array  $groupsToTans
    */
	var $tanTimeLimit;
	
    /**
    *	constructor 
    *
    *	@access	private
    */
    function securityFunctions()
    {
        ;// ..
    }
    
    /**
    *	sets error message
    *
    *	@access	private
    *	@param	string	$err
    */
    function setErrorMessage($err)
    {
        $this->errorMessage = $err;
    }
    
    /**
    *	setsurveyId
    *
    *	@access	public
    *	@param	string	$id
    */
    function setProjectId($id)
    {
        $this->projectId = $id;
    }
    
    /**
    *	setSecurityMethod
    *
    *	@access	public
    *	@param	string	$method
    */
    function setSecurityMethod($method)
    {
        $this->securityMethod = $method;
    }
	
    /**
    *	set Tan Time Limit
    *
    *	@access	public
    *	@param	string	$method
    */
    function setTanTimeLimit($timeFromTo)
    {
        $this->tanTimeLimit["from"] = $timeFromTo["from"];
		// woraround for getting results inclusive day choosen -rr031205
		$this->tanTimeLimit["to"] = $timeFromTo["to"] + 86400;
    }
	
    /**
    *	setSecurityMethod
    *
    *	@access	public
    *	@param	string	$method
    */
    function setTanTableName()
    {
        $this->tanTableName = "T_SURVEY_SECURITYTAN_".$this->projectId;
    }
    
    /**
    *	setSecurityMethod
    *
    *	@access	public
    *	@param	string	$method
    */
    function setTanGroupTableName()
    {
        $this->tanGroupTableName = "T_SURVEY_TANGROUP_".$this->projectId;
    }
	
    /**
    *	setSecurityMethod
    *
    *	@access	public
    *	@param	string	$method
    */
    function setNewGroupToCreate($name)
    {
        $this->newGroupToCreate = $name;
    }
	
    /**
    *	setSecurityMethod
    *
    *	@access	public
    *	@param	string	$method
    */
    function setGroupToMoveTansTo($id)
    {
        $this->groupToMoveTansTo = $this->getTanGroupFromDb($id);
    }
	
    /**
    *	set tan groups
    *
    *	@access	public
    *   @return string true/false
    */
    function setGroupsToTans($groups = '')
	{
		if(!$groups)
		{
			$this->groupsToTans[] = $this->getTanGroupFromDb("all");
		}
		elseif(is_array($groups))
		{
			if(is_object($groups[0]))
			{
				$this->groupsToTans = $groups;
				return true;
			}
			for($i=0;$i<count($groups);$i++)
			{
				$this->groupsToTans[] = $this->getTanGroupFromDb($groups[$i]);
			}
			return true;
		}
		$this->groupsToTans[] = $this->getTanGroupFromDb($groups);
		return true;
	}
	
    /**
    *	get array of values for tan group array
    *
	*	convenience Method
	*
    *	@access	public
    *   @return string true/false
    */
    function getGroupsToTansIds()
	{
		for($i=0;$i<count($this->groupsToTans);$i++)
		{
			$Ids[] = $this->groupsToTans[$i]->getTanGroupValue("TANGROUP_ID_PK");
		}
		return $Ids;
	}
	
    /**
    *	get array of values for tan group array
    *
	*	convenience Method
	*
    *	@access	public
    *   @return string true/false
    */
    function getGroupsToTansNames()
	{
		for($i=0;$i<count($this->groupsToTans);$i++)
		{
			$Names[] = $this->groupsToTans[$i]->getTanGroupValue("TANGROUP_NAME");
		}
		return $Names;
	}
	
    /**
    *	get tan groups from db
    *
    *	@access	public
    *   @return string true/false
    */
    function getTanGroupFromDb($index)
    {
	global $lang_script;
	    
        switch ($index)
		{
			case "all":
				$tanGroupValues["TANGROUP_ID_PK"] 	= "-2";
				$tanGroupValues["TANGROUP_NAME"] 	= $lang_script["security.inc.php"]["allTans"];
		        return new TanGroup($tanGroupValues);
			
			case "allUngrouped":
				$tanGroupValues["TANGROUP_ID_PK"] 	= "-1";
				$tanGroupValues["TANGROUP_NAME"] 	= $lang_script["security.inc.php"]["nongroupTans"];
		        return new TanGroup($tanGroupValues);
			
			default:
				
				$db = DB::connect(DSN, true);
		        if (DB::isError($db)) 
		        {    
		           return false;
		        }
				
		        $sql = "select * 
					from 
						$this->tanGroupTableName
					where
						TANGROUP_ID_PK = ".$index;
		        //
				$result = $db->query($sql);
		    	if (DB::isError($result)) 
		    	{
		            $this->setErrorMessage($result->getMessage());
		            return false;
		    	}
		        $row = $result->fetchRow(DB_FETCHMODE_ASSOC);
				// store 
				return new TanGroup($row);
		}
    }
	
    /**
    *	get groups to delete
    *
    *	@access	public
    *   @return string true/false
    */
    function getGroupsToTans()
    {
		return $this->groupsToTans;
	}
	
    /**
    *	empty groups to delete
    *
    *	@access	public
    *   @return string true/false
    */
    function emptyGroupsToTans()
    {
		$this->groupsToTans = array();
	}
    /**
    *	getSecurityMethod
    *
    *	@access	public
    */
    function getSecurityMethod()
    {
        if($this->securityMethod == "")
        {
            $this->getSecuritySettings();
        }
        
        return $this->securityMethod;
    }
    
    /**
    *	get survey information
    *
    *	@access	public
    *   @return array   survey information
    */
    function getSecuritySettings()
    {
        global $cfgTabSurvey;
        
        $db = DB::connect(DSN, true);
        if (DB::isError($db)) 
        {    
           return false;
        }
		
        $sql = "select PROJECT_SECURITY 
            from  $cfgTabSurvey 
            where PROJECT_ID_PK = ".$this->projectId;
        //
		$securityMethod = $db->getOne($sql);
        if (DB::isError($securityMethod)) 
        {
           $this->setErrorMessage("getSecuritySettings(): ".$securityMethod->getMessage()." $sql");
           return false;
        }
        
        $this->setSecurityMethod($securityMethod);
        
        return true;
    }
    
    /**
    *	saves security method
    *
    *	@access	public
    *   @return boolean true/false
    */
    function saveSecuritySettings()
    {
        global $cfgTabSurvey;
        
        $db = DB::connect(DSN, true);
        if (DB::isError($db)) 
        {    
           return false;
        }
		
        $sql = "update 
			$cfgTabSurvey 
            set 
            PROJECT_SECURITY = '".$this->securityMethod."' 
            where PROJECT_ID_PK = ".$this->projectId;
        //
		$result = $db->query($sql);
        if (DB::isError($result)) 
        {
           $this->setErrorMessage("saveSecuritySettings(): ".$result->getMessage()." $sql");
           return false;
        }
        
        return true;
    }
    
    /**
    *	create tan db table
    *
    *	@access	public
    *   @return boolean true/false
    */
    function createTanAndGroupTable()
    {
	
        $db = DB::connect(DSN, true);
        if (DB::isError($db)) 
        {    
           return false;
        }
		
        if(!$this->existsTable())
        {
            // define create statement for result
            $sql = "CREATE TABLE $this->tanTableName
                (SECURITYTAN_ID_PK int not null,
			SECURITYTAN_TAN int not null,
			SECURITYTAN_TAN_USED char(3) default 'no' not null,
			SECURITYTAN_USER varchar(250),
			SECURITYTAN_USED_TIME datetime,
			SECURITYTAN_TANGROUP_ID_FK int(11),
			primary key (SECURITYTAN_ID_PK));";
            //
			$result = $db->query($sql);
            if (DB::isError($result)) 
            {
               $this->setErrorMessage("createTanAndGroupTable(): ".$result->getMessage()." $sql");
               return false;
            }
			$nextId = $db->nextId($this->tanTableName);
            if (DB::isError($nextId)) 
            {
               $this->setErrorMessage("createTanAndGroupTable(): ".$nextId->getMessage()." $sql");
               return false;
            }
        }
        
        if(!$this->existsTanGroupTable())
        {
            // define create statement for result
            $sql = "CREATE TABLE $this->tanGroupTableName
                (TANGROUP_ID_PK int not null,
			TANGROUP_NAME varchar(50),
			TANGROUP_INSERTDATE datetime,
			PRIMARY KEY (TANGROUP_ID_PK));";
            //
			$result = $db->query($sql);
            if (DB::isError($result)) 
            {
               $this->setErrorMessage("createTanAndGroupTable(): ".$result->getMessage()." $sql");
               return false;
            }
			$nextId = $db->nextId($this->tanGroupTableName);
            if (DB::isError($nextId)) 
            {
               $this->setErrorMessage("createTanAndGroupTable(): ".$nextId->getMessage()." $sql");
               return false;
            }
        }
        return true;
    }
        
    
    /**
    *	checks if a table is already created
    *
    *	@access	public
    *	@param	string  $table  name of table
    *   @return string true/false
    */
    function existsTable()
    {

        $db = DB::connect(DSN, true);
        if (DB::isError($db)) 
        {    
           return false;
        }
		
        $tableArray = $db->getListOf("tables");
        if (DB::isError($test)) 
        {  
           $this->setErrorMessage("existsTable(): ".$result->getMessage()." $sql");
           return false; 
        }
        
        if(in_array($this->tanTableName, $tableArray))
        {
            return true;
        }
        
        return false;
    }
    
    /**
    *	checks if a group table is already created
    *
    *	@access	public
    *	@param	string  $table  name of table
    *   @return string true/false
    */
    function existsTanGroupTable()
    {

        $db = DB::connect(DSN, true);
        if (DB::isError($db)) 
        {    
           return false;
        }
		
        $tableArray = $db->getListOf("tables");
        if (DB::isError($test)) 
        {  
           $this->setErrorMessage("existsTable(): ".$result->getMessage()." $sql");
           return false; 
        }
        
        if(in_array($this->tanGroupTableName, $tableArray))
        {
            return true;
        }
        
        return false;
    }
	
    /**
    *	checks if a tan Group already exists
    *
    *	@access	public
    *	@param	string  $newGroup  name of new group
    *   @return string true/false
    */
    function tanGroupExists($newGroup = '')
    {
		
        $db = DB::connect(DSN, true);
        if (DB::isError($db)) 
        {    
           return false;
        }
		
		$sql = "select 
					1 
				from 
					$this->tanGroupTableName
            	where 
            		TANGROUP_NAME = '$newGroup'";
        //
		$result = $db->query($sql);
    	if (DB::isError($result)) 
    	{
            return false;
    	}
        
        $numRows = $result->numRows();
        
        if($numRows > '0')
        {
            return true;
        }
        
        return false;
    }
	
    /**
    *	create a tan
    *
    *	@access	public
    *	@param	string  $table  name of table
    *   @return string true/false
    */
    function createTan($min, $max, $count)
    {
        srand ((double) microtime() * 1000000);
        for($i=0;$i<$count;$i++)
        {
			$newTan = $this->insertTanToDB(mt_rand($min, $max));
            if(PEAR::isError($newTan))
			{
				$this->setErrorMessage("createTan(): ".$newTan->getMessage()." $sql");
				return false;
            }
			elseif(!$newTan)
            {
                $i = $i-1;
            }
        }
		return true;
    }
    
    /**
    *	insert tan to db
    *
    *	@access	public
    *	@param	int  $tan  tan
    *   @return string true/false
    */
    function insertTanToDB($tan)
    {
        $db = DB::connect(DSN, true);
        if (DB::isError($db)) 
        {    
           return $db;
        }
		// check if group has to be created
		if($this->newGroupToCreate != '')
		{
			$result = $this->insertNewTanGroup();
			if(PEAR::isError($result))
			{
				return $result;
			}
		}
		
		$sql = "select 1 
			from $this->tanTableName 
            where 
            SECURITYTAN_TAN = $tan";
        //
		$result = $db->query($sql);
    	if (DB::isError($result)) 
    	{
            return $result;
    	}
        
        $numRows = $result->numRows();
        
        if($numRows > "0")
        {
            return false;
        }
        
		// tangroup id
		$tanGroupId	=	$this->groupsToTans[0]->getTanGroupValue('TANGROUP_ID_PK');
		if(!$tanGroupId)
		{
		    return false;
		}
		elseif($tanGroupId <1)
		{
			$tanGroupId = "null";
		}
        
		// get next free id
        $nextId = $db->nextId($this->tanTableName);
        if (DB::isError($nextId)) 
        {
           	return $nextId;
        }
        
        $sql = "insert into 
					$this->tanTableName 
            		(SECURITYTAN_ID_PK, SECURITYTAN_TAN,SECURITYTAN_TANGROUP_ID_FK) 
            	values 
            		($nextId, $tan, $tanGroupId)";
        //
		$result = $db->query($sql);
        if (DB::isError($result)) 
        {
           return $result;
        }
        
        return true;
    }
    
    /**
    *	insert new tan group
    *
    *	@access	public
    *	@param	int  $tan  tan
    *   @return string true/false
    */
    function insertNewTanGroup()
    {
        $db = DB::connect(DSN, true);
        if (DB::isError($db)) 
        {    
           return $db;
        }
		
		$sql = "select 
					TANGROUP_ID_PK
				from 
					$this->tanGroupTableName
            	where 
            		TANGROUP_NAME = '".$this->newGroupToCreate."'";
        //
		$result = $db->query($sql);
    	if (DB::isError($result)) 
    	{
            return $result;
    	}
		// already exists
		if($result->numRows() > 0)
		{
	        $row = $result->fetchRow(DB_FETCHMODE_ASSOC);
	        $newGroup = $row["TANGROUP_ID_PK"];
			if(!$this->setGroupsToTans($newGroup)) return new PEAR_Error("could not set groupToTan with groupid=".$row["TANGROUP_ID_PK"].__FILE__." on line ".__LINE__);
        }
		// create group
		else
		{
	        // get next free id
	        $nextId = $db->nextId($this->tanGroupTableName);
	        if (DB::isError($nextId)) 
	        {
	           	return $nextId;
	        }
	        
	        $sql = "insert into 
						$this->tanGroupTableName
	            		(TANGROUP_ID_PK, TANGROUP_NAME, TANGROUP_INSERTDATE) 
	            	values 
	            		($nextId, '".$this->newGroupToCreate."', NOW())";
	        //
			$result = $db->query($sql);
	        if (DB::isError($result)) 
	        {
			   return $result;
	        }
			if(!$this->setGroupsToTans($nextId)) return new PEAR_Error("could not set groupToTan with groupid=$nextId ".__FILE__." on line ".__LINE__);
		}
		// group created, empty newGroupString
		$this->newGroupToCreate = '';
		
		return true;
	}
	
    /**
    *	empty tan list
    *
    *	@access	public
    *   @return string true/false
    */
    function emptyTanList()
    {
		for($i=0;$i<count($this->groupsToTans);$i++)
		{
	        switch ($this->groupsToTans[$i]->getTanGroupValue('TANGROUP_ID_PK'))
			{
				case "-2":
					// delete all free tans
			        $sqlWhere = "";
					break 2;
				
				case "-1":
					// delete all free tans ungrouped
			        $sqlWhere = "and $this->tanTableName.SECURITYTAN_TANGROUP_ID_FK is null";
					break 2;
				
				default:
					$link = ($i > 0)? " or " : " and ";
					$sqlWhere .= $link."$this->tanTableName.SECURITYTAN_TANGROUP_ID_FK = ".$this->groupsToTans[$i]->getTanGroupValue('TANGROUP_ID_PK');
			}
		}
		
		$db = DB::connect(DSN, true);
        if (DB::isError($db)) 
        {    
           return false;
        }
		// select ids to delete
		$sql = "select 
					$this->tanTableName.SECURITYTAN_ID_PK 
				from 
					$this->tanTableName
				left join
					$this->tanGroupTableName 
				on
					$this->tanTableName.SECURITYTAN_TANGROUP_ID_FK = $this->tanGroupTableName.TANGROUP_ID_PK
				where
					$this->tanTableName.SECURITYTAN_TAN_USED != 'yes'";
        // add where 
		$sql .= " ".$sqlWhere;
		// proceed statement
		$result = $db->query($sql);
    	if (DB::isError($result)) 
    	{
            $this->setErrorMessage($result->getMessage());
            return false;
    	}
        while ($row = $result->fetchRow(DB_FETCHMODE_ASSOC))
        {
            $tanArray[] = $row["SECURITYTAN_ID_PK"];
        }
		//no tans to delete
		if (count($tanArray)<1) return true;
		
		$sql = "delete 
			from 
				$this->tanTableName
			where
				SECURITYTAN_ID_PK in (".join(", ",$tanArray).")";
        // 
		$result = $db->query($sql);
    	if (DB::isError($result)) 
    	{
            $this->setErrorMessage($result->getMessage());
            return false;
    	}
         
        return true;
    }
    
    /**
    *	get tan list
    *
    *	@access	public
    *   @return string true/false
    */
    function getTanList()
    {
		if(count($this->groupsToTans)>0)
		{
			for($i=0;$i<count($this->groupsToTans);$i++)
			{
		        switch ($this->groupsToTans[$i]->getTanGroupValue('TANGROUP_ID_PK'))
				{
					case "-2":
						// get all tans
				        $sqlWhere = "";
						break 2;
					
					case "-1":
						// get all tans ungrouped
				        $sqlWhere = "and $this->tanTableName.SECURITYTAN_TANGROUP_ID_FK is null";
						break 2;
					
					default:
						$link = ($i > 0)? " or " : " and ";
						$sqlWhere .= $link."$this->tanTableName.SECURITYTAN_TANGROUP_ID_FK = ".$this->groupsToTans[$i]->getTanGroupValue('TANGROUP_ID_PK');
				}
			}
		}
		else
		{
			// get all tans
	        $sqlWhere = "";
		}
		$db = DB::connect(DSN, true);
        if (DB::isError($db)) 
        {
           return false;
        }
		// select tans
		$sql = "select 
					* 
				from 
					$this->tanTableName
				left join
					$this->tanGroupTableName 
				on
					$this->tanTableName.SECURITYTAN_TANGROUP_ID_FK = $this->tanGroupTableName.TANGROUP_ID_PK
				where
					1 = 1";
        // add where 
		$sql .= " ".$sqlWhere;
		// proceed statement
		$result = $db->query($sql);
    	if (DB::isError($result)) 
    	{
            $this->setErrorMessage($result->getMessage());
            return false;
    	}
        while ($row = $result->fetchRow(DB_FETCHMODE_ASSOC))
        {
            $tanArray[] = $row;
        }
        
        return $tanArray;
    }
    

    /**
    *	get tan groups
    *
    *	@access	public
    *   @return string true/false
    */
    function getTanGroups()
    {
        // table exists ?
		$result = $this->existsTanGroupTable();
        if (PEAR::isError($result)) 
        {    
           echo $result->getMessage();exit;
        }
		elseif(!$result)
		{
			$result = $this->createTanAndGroupTable();
	        if(PEAR::isError($result)) 
	        {    
	            echo $result->getMessage();exit;
	        }
		}
		
		$db = DB::connect(DSN, true);
        if (DB::isError($db)) 
        {    
           return false;
        }
		
        $sql = "select * 
			from $this->tanGroupTableName";
        //
		$result = $db->query($sql);
    	if (DB::isError($result)) 
    	{
            $this->setErrorMessage($result->getMessage());
            return false;
    	}
        while ($row = $result->fetchRow(DB_FETCHMODE_ASSOC))
        {
            $groupArray[] = new TanGroup($row);
        }
        
        return $groupArray;
    }
	
    /**
    *	delete tan groups
    *
    *	@access	public
    *   @return string true/false
    */
    function deleteTanGroups()
    {
        // delete free tans
		$this->emptyTanList();
		
		$db = DB::connect(DSN, true);
        if (DB::isError($db)) 
        {    
           return $db;
        }
		if(count($this->groupsToTans)>0)
		{
			// move used tans
			$result = $this->moveTansToGroup();
	        if (PEAR::isError($result)) 
	        {    
	        	return $result;
	        }
			elseif(!$result)
			{
				return false;
			}
			for($i=0;$i<count($this->groupsToTans);$i++)
			{
				// move used Tans to 
		        $sql = "delete from 
							$this->tanGroupTableName
						where
							TANGROUP_ID_PK = ".$this->groupsToTans[$i]->getTanGroupValue('TANGROUP_ID_PK');
		        //
				$result = $db->query($sql);
		    	if (DB::isError($result)) 
		    	{
		            return $result;
		    	}
			}
		}
		else
		{
			return false;
		}
        return true;
    }
	
    /**
    *	move used tans to other group
    *
    *	@access	public
    *   @return string true/false
    */
    function moveTansToGroup()
	{
        $db = DB::connect(DSN, true);
        if (DB::isError($db)) 
        { 
           return false;
        }
		if(count($this->groupsToTans)>0)
		{
			for($i=0;$i<count($this->groupsToTans);$i++)
			{
				$groupsToMove[] = $this->groupsToTans[$i]->getTanGroupValue('TANGROUP_ID_PK');
			}
		}
		else
		{
			return false;
		}
		// set id
		$newGroup = ($this->groupToMoveTansTo->getTanGroupValue('TANGROUP_ID_PK') < 1)? "NULL" : $this->groupToMoveTansTo->getTanGroupValue('TANGROUP_ID_PK');
		//
		$sql = "update 
					$this->tanTableName 
            	set 
					SECURITYTAN_TANGROUP_ID_FK = ".$newGroup."
				where
					SECURITYTAN_TAN_USED = 'yes'
           		and SECURITYTAN_TANGROUP_ID_FK IN(".(join(", ",$groupsToMove)).")";
        //
		$result = $db->query($sql);
    	if (DB::isError($result)) 
    	{
           return $result;
    	}
        return true;
	}
	
    /**
    *	get tan num
    *
    *	@access	public
    *   @return string true/false
    */
    function getTanNum()
    {
		if(count($this->groupsToTans)>0)
		{
			for($i=0;$i<count($this->groupsToTans);$i++)
			{
		        switch ($this->groupsToTans[$i]->getTanGroupValue('TANGROUP_ID_PK'))
				{
					case "-2":
						// get all tans
				        $sqlWhere = "";
						break 2;
					
					case "-1":
						// get all tans ungrouped
				        $sqlWhere = "and $this->tanTableName.SECURITYTAN_TANGROUP_ID_FK is null";
						break 2;
					
					default:
						$link = ($i > 0)? " or " : " and ";
						$sqlWhere .= $link."$this->tanTableName.SECURITYTAN_TANGROUP_ID_FK = ".$this->groupsToTans[$i]->getTanGroupValue('TANGROUP_ID_PK');
				}
			}
		}
		else
		{
			// get all tans
	        $sqlWhere = "";
		}
		$db = DB::connect(DSN, true);
        if (DB::isError($db)) 
        {
           return false;
        }

		// select ids to delete
		$sql = "select 
					1 
				from 
					$this->tanTableName
				left join
					$this->tanGroupTableName 
				on
					$this->tanTableName.SECURITYTAN_TANGROUP_ID_FK = $this->tanGroupTableName.TANGROUP_ID_PK
				where
					1 = 1";
        // add where 
		$sql .= " ".$sqlWhere;
		// proceed statement
		$result = $db->query($sql);
    	if (DB::isError($result)) 
    	{
            $this->setErrorMessage($result->getMessage());
            return false;
    	}
        $numRows = $result->numRows();
        
        return $numRows;
    }
    
    /**
    *	get tan list
    *
    *	@access	public
    *   @return string true/false
    */
    function getUsedTanNum()
    {
		if(count($this->groupsToTans)>0)
		{
			for($i=0;$i<count($this->groupsToTans);$i++)
			{
		        switch ($this->groupsToTans[$i]->getTanGroupValue('TANGROUP_ID_PK'))
				{
					case "-2":
						// get all tans
				        $sqlWhere = "";
						break 2;
					
					case "-1":
						// get all tans ungrouped
				        $sqlWhere = "and $this->tanTableName.SECURITYTAN_TANGROUP_ID_FK is null";
						break 2;
					
					default:
						$link = ($i > 0)? " or " : " and ";
						$sqlWhere .= $link."$this->tanTableName.SECURITYTAN_TANGROUP_ID_FK = ".$this->groupsToTans[$i]->getTanGroupValue('TANGROUP_ID_PK');
				}
			}
		}
		else
		{
			// get all tans
	        $sqlWhere = "";
		}
		// timeLimit
		if($this->tanTimeLimit)
		{
			$sqlWhere .=" and SECURITYTAN_USED_TIME  >= FROM_UNIXTIME(".$this->tanTimeLimit["from"].")
					      and SECURITYTAN_USED_TIME  <= FROM_UNIXTIME(".$this->tanTimeLimit["to"].") ";
		}
		$db = DB::connect(DSN, true);
        if (DB::isError($db)) 
        {
           return false;
        }
		// select ids to delete
		$sql = "select 
					1 
				from 
					$this->tanTableName
				left join
					$this->tanGroupTableName 
				on
					$this->tanTableName.SECURITYTAN_TANGROUP_ID_FK = $this->tanGroupTableName.TANGROUP_ID_PK
				where
					$this->tanTableName.SECURITYTAN_TAN_USED = 'yes'";
        // add where 
		$sql .= " ".$sqlWhere;
		// proceed statement
		$result = $db->query($sql);
    	if (DB::isError($result)) 
    	{
            $this->setErrorMessage($result->getMessage());
            return false;
    	}
        $numRows = $result->numRows();
        
        return $numRows;
    }
    
    /**
    *	check tan
    *
    *	@access	public
    *   @return string true/false
    */
    function checkTan($tan)
    {
        $db = DB::connect(DSN, true);
        if (DB::isError($db)) 
        {    
           return false;
        }
		
		$sql = "select 1 
			from $this->tanTableName
            where SECURITYTAN_TAN = '$tan' 
			and SECURITYTAN_TAN_USED = 'no'";
		//
        $result = $db->query($sql);
    	if (DB::isError($result)) 
    	{
            $this->setErrorMessage($result->getMessage());
            return false;
    	}
        $numRows = $result->numRows();
        
        if($numRows == 1)
        {
            return true;
        }
        
        return false;
    }
	
    /**
    *	get Group for Tan
    *
    *	@access	public
    *   @return string true/false
    */
    function getGroupForTan($tan)
    {
        $db = DB::connect(DSN, true);
        if (DB::isError($db)) 
        {    
           return false;
        }
		
		$sql = "select 
					$this->tanGroupTableName.TANGROUP_ID_PK,
					$this->tanGroupTableName.TANGROUP_NAME,
					$this->tanGroupTableName.TANGROUP_INSERTDATE
				from 
					$this->tanTableName
				left join
					$this->tanGroupTableName 
				on
					$this->tanTableName.SECURITYTAN_TANGROUP_ID_FK = $this->tanGroupTableName.TANGROUP_ID_PK
				where
					$this->tanTableName.SECURITYTAN_TAN = '$tan'";
		//
        $result = $db->query($sql);
    	if (DB::isError($result)) 
    	{
            $this->setErrorMessage($result->getMessage());
            return false;
    	}
        while ($row = $result->fetchRow(DB_FETCHMODE_ASSOC))
        {
             return new TanGroup($row);
        }
        
        return false;
    }
    
    
    /**
    *	check tan
    *
    *	@access	public
    *   @return string true/false
    */
    function updateTan($tan, $email)
    {
        $db = DB::connect(DSN, true);
        if (DB::isError($db)) 
        { 
           return false;
        }
		
		$sql = "update 
			$this->tanTableName 
            set 
			SECURITYTAN_TAN_USED = 'yes', 
			SECURITYTAN_USER = '$email', 
			SECURITYTAN_USED_TIME = NOW() 
			where SECURITYTAN_TAN = '$tan'";
        //
		$result = $db->query($sql);
    	if (DB::isError($result)) 
    	{
            $this->setErrorMessage($result->getMessage());
            return false;
    	}
        
        return true;
    }
    
    
    
    /**
    *	writes security Cookie Params to Db
    *
    *	@access	public
    *   $param  string		$cookieName
    *   $param	timestamp	$cookieExpires
    *   @return boolean|PEAR::Error true/false on success Error-object on failure
    */
    function setSecurityCookieParams($cookieName, $cookieExpires)
	{
        // insert or update ?
		$sql = "select
					T_SURVEY_COOKIE_ID_PK 
				from
					T_SURVEY_COOKIE
				where
					T_SURVEY_COOKIE_PROJECT_ID_FK = ".$this->projectId;
        //
		$db = DB::connect(DSN, true);
		$result = $db->query($sql);
    	if (DB::isError($result)) 
    	{
            return $result;
    	}
		$row = $result->fetchRow(DB_FETCHMODE_ASSOC);
		$cookieId = $row["T_SURVEY_COOKIE_ID_PK"];
		// insert
		if(!$cookieId)
        {
	        // get next free id
	        $nextId = $db->nextId("T_SURVEY_COOKIE");
	        if (DB::isError($nextId)) 
	        {
	            return $nextId;
	        }
			$cookieExpires = (!$cookieExpires) ? '0000:00:00' : $cookieExpires;
			$sql = "insert into
						T_SURVEY_COOKIE
		            (T_SURVEY_COOKIE_ID_PK, T_SURVEY_COOKIE_PROJECT_ID_FK, T_SURVEY_COOKIE_NAME, T_SURVEY_COOKIE_EXPIRES) 
		            values 
		            ($nextId, ".$this->projectId.", '".$cookieName."', '".$cookieExpires."')";
			//
			$result = $db->query($sql);
	    	if (DB::isError($result)) 
	    	{
	            return $result;
	    	}
			if(!$result)
			{
				return false;
			}
			return true;
		}
		//update
		elseif($cookieId)
		{
	        //
			$cookieExpires = (!$cookieExpires) ? '0000:00:00' : $cookieExpires;
			$sql = "update 
						T_SURVEY_COOKIE
					set
		            	T_SURVEY_COOKIE_NAME = '".$cookieName."', 
						T_SURVEY_COOKIE_EXPIRES = '".$cookieExpires."' 
					where
						T_SURVEY_COOKIE_ID_PK = $cookieId
					and T_SURVEY_COOKIE_PROJECT_ID_FK = ".$this->projectId;
			//
			$result = $db->query($sql);
	    	if(DB::isError($result)) 
	    	{
	            return $result;
	    	}
			if(!$result)
			{
				return false;
			}
			return true;
		}
		else
		{
			return false;
		}
	}
	
    /**
    *	gets security Cookie Data
    *
    *	@access	public
    *   $param  string		$cookieName
    *   $param	timestamp	$cookieExpires
    *   @return array|PEAR::Error cookie data on success Error-object on failure
    */
    function getSecurityCookieParams()
	{
        $db = DB::connect(DSN, true);
		// insert or update ?
		$sql = "select
					T_SURVEY_COOKIE_NAME, 
					DATE_FORMAT(T_SURVEY_COOKIE_EXPIRES, '%d.%m.%Y') as T_SURVEY_COOKIE_EXPIRES,
					UNIX_TIMESTAMP(T_SURVEY_COOKIE_EXPIRES) as T_SURVEY_COOKIE_EXPIRES_TIMESTAMP
				from
					T_SURVEY_COOKIE
				where
					T_SURVEY_COOKIE_PROJECT_ID_FK = ".$this->projectId;
        //
		$result = $db->query($sql);
    	if (DB::isError($result)) 
    	{
            return $result;
    	}
		$row = $result->fetchRow(DB_FETCHMODE_ASSOC);
		return $row;
	}
	
	
    /**
    *	deletes security Cookie Data
    *
    *	@access	public
    *   $param  string		$cookieName
    *   $param	timestamp	$cookieExpires
    *   @return array|PEAR::Error true on success Error-object on failure
    */
    function unsetSecurityCookieParams()
	{
        $db = DB::connect(DSN, true);
		// insert or update ?
		$sql = "delete	from
					T_SURVEY_COOKIE 
				where
					T_SURVEY_COOKIE_PROJECT_ID_FK = ".$this->projectId;
        //
		$result = $db->query($sql);
    	if (DB::isError($result)) 
    	{
            return $result;
    	}
		return true;
	}
	
    /**
    *	denies user admittance if form filled already
    *
    *	@access	public
    *   $param  string		$cookieName
    *   $param	timestamp	$cookieExpires
    *   @return boolean true/false
    */
	function checkForSecurityCookie()
	{
		$params = $this->getSecurityCookieParams();
		$cookieName = (!$params["T_SURVEY_COOKIE_NAME"])? ("osp_cookie"."_".$this->projectId) : ($params["T_SURVEY_COOKIE_NAME"]."_".$this->projectId);
		
		if (isset($_COOKIE[$cookieName])) 
        {
			$cookieContentArray = preg_split("/(?<!t)\|/",$_COOKIE[$cookieName]);
			if (count($cookieContentArray)) 
            {
				$projectId = $cookieContentArray[0];
			}
			if($projectId == $this->projectId)
			{
				return true;
			}
		} 
		return false;
	}

    /**
    *	writes a security cookie
    *
    *	@access	public
    *   $param  string		$cookieName
    *   $param	timestamp	$cookieExpires
    *   @return boolean true/false
    */
	function writeSecurityCookie()
	{
      	$params = $this->getSecurityCookieParams();
        // check if limit given else set very high
		$expiretime = (!$params["T_SURVEY_COOKIE_EXPIRES_TIMESTAMP"])? 8888888888 : $params["T_SURVEY_COOKIE_EXPIRES_TIMESTAMP"] ;
		// set default name if not in DB
		$cookieName = (!$params["T_SURVEY_COOKIE_NAME"])? ("osp_cookie"."_".$this->projectId) : ($params["T_SURVEY_COOKIE_NAME"]."_".$this->projectId);
		// set cookie
		setcookie( $params["T_SURVEY_COOKIE_NAME"]."_".$this->projectId, $this->projectId, $expiretime + 60*60*24);
        
        return true;
	}
	
    /**
    *	writes the login cookie
    *
    *	@access	public
    *   $param  array   $params
    *   @return string true/false
    */
    function writeCookie($params)
    {
       if (gettype($params) != "array")
         {
			return false;
		}
        
		$testArray = array("surveySessionId", "projectId", "securityMethod");
		foreach ($testArray as $elem) 
        {
			if (!isset($params[$elem])) 
            {
				return false;
			}
			if ($params[$elem] == "") 
            {
				return false;
			}
			$params[$elem]= str_replace("\|", "\\\|", $params[$elem]);
		}
		//print_r($params);
        
		$time = gmstrftime("%A, %d-%b-%Y %H:%M:%S", time()+60*60*24*365*10);
		setcookie ( "survey_pilot_form", $params["surveySessionId"]."|".$params["projectId"]."|".$params["securityMethod"], 
            time()+60*60*24*365*10);
        
        return true;
	}
				
	/**
    *	reads the login cookie
    *
    *	@access	public
    *   @return array   cookie content
    */
    function readCookie()
    {
		$ssoContent = array();
		if (isset($_COOKIE["survey_pilot_form"])) 
        {
			$cookieContentArray = preg_split("/(?<!t)\|/",$_COOKIE["survey_pilot_form"]);
			if (count($cookieContentArray) >= 3) 
            {
				$cookieContent["surveySessionId"] = $cookieContentArray[0];
				$cookieContent["projectId"] = $cookieContentArray[1];
				$cookieContent["securityMethod"] = $cookieContentArray[2];
			}
		} 
        
		return $cookieContent;
	}
	
	/**
    *	deletes the login cookie
    *
    *	@access	public
    *   @return array   cookie content
    */
    function deleteCookie()
    {
		setcookie ( "survey_pilot_form", "", time()-60*60*24*365*10);
		return true;
	}
}


/**
* TanGroup class
*
* @author  Jrn Allert <allert@serie-a.de>
* @author  Rene Renk <renk@serie-a.de>
* @access  public
*/
class TanGroup
{
    /**
    *	error message
    *	@var    mixed  
    */
    var $tanGroupValues = array();
	
	/**
    *	constructor
    *
    *	dont call from outside the class...
    */
	function TanGroup($tanGroupValues)
	{
		if(is_array($tanGroupValues))
		{
			foreach($tanGroupValues as $key => $value)
			{
				$this->tanGroupValues[$key] = $value;
			}
		}
		return;
	}
	
	/**
	*
    *	create a TanGroup object from an asscociative array
	*	
	* 	@access	public
	* 	@static factory method
    */
	function setTanGroup(&$tanGroupValues)
	{
	    return new TanGroup($tanGroupValues);
	}
	
	/**
	*
    *	setter Method
	*	
	* 	@access	public
	* 	@static factory method
    */
	function setTanGroupValue($tanGroupValueKey, $value)
	{
		$this->tanGroupValues[$tanGroupValueKey] = $value;
	}

	/**
	*
    *	getter Method
	*	
	* 	@access	public
	* 	@static factory method
    */
	function getTanGroupValue($tanGroupValueKey)
	{
		return stripslashes($this->tanGroupValues[$tanGroupValueKey]);
	}
}
?>
