<?php
// +----------------------------------------------------------------------+
// | survey pilot                                                         |
// +----------------------------------------------------------------------+
// | Copyright (c) 2002 serie a - Digitale Medien und Systeme GmbH        |
// +----------------------------------------------------------------------+
// | Authors: Jrn Allert <allert@serie-a.de>                             |
// |          Rene Renk <renk@serie-a.de>                                 |
// |          Otto Poellath <otto@poellath.org>                           |
// +----------------------------------------------------------------------+
// | Description:                                                         |
// +----------------------------------------------------------------------+
//
// $Id: survey.question.inc.php,v 1.1.1.1 2004/07/15 13:32:39 opensurveypilot Exp $

// start session
@session_start();
 
require_once("../config/config.inc.php"); // common config file // common config file
require_once ("Validate.php"); // PEAR::Validate
require_once($cfgPathToConf."/file.inc.php"); // project files
require_once($cfgPathToSurveyFiles."/config/survey.config.inc.php"); // survey configuration
require_once($cfgPathToSurveyFiles."/config/survey.file.inc.php"); // survey files
require_once ("DB.php"); // PEAR::DB

/**
* question Functions class
*
* @author  Jrn Allert <allert@serie-a.de>
* @author  Ralf Poehllath <otto@poellath.org>
* @author  Rene Renk <renk@serie-a.de>
* @access  public
*/
class Question
{
	// declare variables
	var $question;
	var $questionImage;
	var $type;
	var $questionRules;
	var $ruleCheckAllow;
	var $questionDefaultRules;
	var $requireValues;
	var $size;
	var $align;
	var $inputWidth;
	var $optionHeader;
	var $optionHideHeader;
	var $optionHeaderImage;
	var $optionAddHeader;
	var $optionHideAddHeader;
	var $optionAddHeaderImage;
	var $optionMultipleValue;
	var $switches;
	var $toSwitchGroupName;
	var $tableSpan;
	var $tempSizeCounter;
		
	var $db;
	var $id;
	var $projectId;
	var $groupId;
	var $order;
	var $active = "1";
		
	var $errorMessage;
	
	function Question($projectId = 0)
    {
		global $cfgSrvyTabError;
		
        $db = DB::connect(DSN, true);
        if (DB::isError($this->db)) 
        {    
           return false;
        }
		
		if(!$projectId)
		{
			return;
		}
		// check for default messages
		//
		// get defaultRulesMessages if set for project
        $sql = "select ERROR_LANG, ERROR_TYPE, ERROR_MESSAGE 
			from $cfgSrvyTabError 
			where ERROR_PROJECT_ID = '$projectId'";
		//
		$result = $db->query($sql);
		if (DB::isError($result)) 
		{
			$this->errorMessage = $result->getMessage()."SQL: $sql";
			return false;
		}
		if($result->numRows() > 0)
		{
			while ($row = $result->fetchRow(DB_FETCHMODE_ASSOC))
	        {
				$existingRules[$row["ERROR_LANG"]][$row["ERROR_TYPE"]] = $row["ERROR_MESSAGE"];
			}
		}
		// else get global defaultRulesMessages
		else
		{
			// sql
	        $sql = "select ERROR_LANG, ERROR_TYPE, ERROR_MESSAGE 
				from $cfgSrvyTabError 
				where ERROR_PROJECT_ID = '0'";
			//
			$result = $db->query($sql);
			if (DB::isError($result)) 
			{
				$this->errorMessage = $result->getMessage()."SQL: $sql";
				return false;
			}
			while ($row = $result->fetchRow(DB_FETCHMODE_ASSOC))
	        {
				$existingRules[$row["ERROR_LANG"]][$row["ERROR_TYPE"]] = $row["ERROR_MESSAGE"];
			}
		}
		// set rules if existing
		if(is_array($existingRules))
		{
			foreach($existingRules as $idOfRule => $ruleMessages)
			{
				$this->setQuestionDefaultRules("$idOfRule", $ruleMessages);
			}
		}
	}
	
	// command methods
	//
	// setter methods
	function setQuestion($question)
    {
		$this->question = $question;
	}
	function setQuestionImage($questionImage)
    {
		$this->questionImage = $questionImage;
	}
	function setType($type)
    {
		$this->type = $type;
	}
	function setRequireValues($requireValues)
    {
		$this->requireValues = $requireValues;
	}
	function setSize($size)
    {
		$this->size = $size;
	}
	function setId($id)
    {
		$this->id = $id;
	}
    function setProjectId($projectId)
    {
		$this->projectId = $projectId;
	}
	function setGroupId($groupId)
    {
		$this->groupId = $groupId;
	}
	function setOrder($order)
    {
		$this->order = $order;
	}
	function setActive($active)
    {
		$this->active = $active;
	}
	function setAlign($align)
    {
		$this->align = $align;
	}
	function setInputWidth($inputWidth)
    {
		$this->inputWidth = $inputWidth;
	}
	function setTableSpan($tableSpan)
    {
		$this->tableSpan = $tableSpan;
	}
	function setTempSizeCounter($tempSizeCounter)
    {
		$this->tempSizeCounter = $tempSizeCounter;
	}
	function setRuleCheckAllow($ruleCheckAllow)
    {
		$this->ruleCheckAllow = $ruleCheckAllow;
	}
	//
	function setQuestionDefaultRules($type, $ruleMessage)
    {
		$this->questionDefaultRules[$type] = $ruleMessage;
	}
	function setQuestionRules($type, $ruleMessage)
    {
		$this->questionRules[$type] = $ruleMessage;
	}
	function setOptionHeader($index, $optionHeader)
    {
		$this->optionHeader[$index] = $optionHeader;
	}
	function setOptionHideHeader($index, $optionHideHeader)
    {
		$this->optionHideHeader[$index] = $optionHideHeader;
	}
	function setOptionHeaderImage($index, $optionHeaderImage)
    {
		$this->optionHeaderImage[$index] = $optionHeaderImage;
	}
	function setOptionAddHeader($index, $optionAddHeader)
    {
		$this->optionAddHeader[$index] = $optionAddHeader;
	}
	function setOptionHideAddHeader($index, $optionHideAddHeader)
    {
		$this->optionHideAddHeader[$index] = $optionHideAddHeader;
	}
	function setOptionAddHeaderImage($index, $optionAddHeaderImage)
    {
		$this->optionAddHeaderImage[$index] = $optionAddHeaderImage;
	}
	function setOptionMultipleValue($index, $optionMultipleValue)
    {
		$this->optionMultipleValue[$index] = $optionMultipleValue;
	}
	function setSwitch($index, $groupId)
    {
		$this->switches[$index] = $groupId;
	}
	function setToSwitchGroupName($index, $toSwitchGroupName)
    {
		$this->toSwitchGroupName[$index] = $toSwitchGroupName;
	}
	function setFormsEnd($index, $formsEnd)
    {
		$this->formsend[$index] = $formsEnd;
	}
	// end setter methods
	
	// getter methods
	function getQuestionDefaultRules($type, $ruleMessage)
    {
		$this->questionDefaultRules[$type] = $ruleMessage;
	}
	function getQuestionRules($type)
    {
		return $this->questionRules[$type];
	}
	function getOptionHeader($index)
    {
		return $this->optionHeader[$index];
	}
	function getOptionHideHeader($index)
    {
		return $this->optionHideHeader[$index];
	}
	function getOptionHeaderImage($index)
    {
		return $this->optionHeaderImage[$index];
	}
	function getOptionAddHeader($index)
    {
		return $this->optionAddHeader[$index];
	}
	function getOptionHideAddHeader($index)
    {
		return $this->optionHideAddHeader[$index];
	}
	function getOptionAddHeaderImage($index)
    {
		return $this->optionAddHeaderImage[$index];
	}
	function getOptionMultipleValue($index)
    {
		return $this->optionMultipleValue[$index];
	}
	function getSwitch($index)
    {
		return $this->switches[$index];
	}
	function getToSwitchGroupName($index)
    {
		return $this->toSwitchGroupName[$index];
	}
    function getFormsEnd($index)
    {
		return $this->formsend[$index];
	}
	// getter methods
	//
	// end command methods
	
	
    /**
    *	checks for valid inputs
    *
    *	@access	private
    *	@param	int	$step
    *   @return boolean true/false
    */
	function isValid($step="")
    {
	    	global $lang_script;
	    
	    
		$valid = true;
		
		if(!$this->question)
        {
			$this->errorMessage .= $lang_script["survey.question.inc.php"]["questionError"]."<br>\n";
			$valid = false;
		}
		
		if(($step == 3) && ($this->size < 1) && (!$this->tableSpan))
        {
			switch ($this->type)
			{
				default:
				{
					$valid = false;
					$this->errorMessage .= $lang_script["survey.question.inc.php"]["number1Error"]."<br>"
								.$lang_script["survey.question.inc.php"]["number2Error"]."<br><br>";
				}
			}
		}

		if(	($step == 3)	&&	 (($this->type == "texttable")||($this->type == "radiotable")||($this->type == "checkboxtable"))	&&	(($this->size < 1)||($this->tableSpan < 1))	)
		{
			$valid = false;
			$this->errorMessage .= $lang_script["survey.question.inc.php"]["select1Error"]."<br>"
						.$lang_script["survey.question.inc.php"]["select2Error"]."<br><br>";
		}
		
		if((($step == 3) && ($this->type == "groupedtext"))&& ($this->inputWidth < 10))
        {
			$this->errorMessage .= $lang_script["survey.question.inc.php"]["size1Error"]."<br>"
						.$lang_script["survey.question.inc.php"]["size2Error"]."<br><br>";
			$valid = false;
		}
		
		if(($this->required == "1") && ($this->type == "switchtext"))
        {
			$this->errorMessage .= $lang_script["survey.question.inc.php"]["type1Error"]."<br>"
						.$lang_script["survey.question.inc.php"]["type2Error"]."<br><br>";
			$valid = false;
		}
		// labels fuer angegebene elemente
		if((($step == 35)||($step == 4))&& ($this->size > 0))
        {
			for($i=0; $i < $this->size; $i++)
            {
				if($this->optionHeader[$i] == "")
                {
					switch($this->type)
					{
						case "select":
							$this->errorMessage .= $lang_script["survey.question.inc.php"]["labelselectError"]." ".($i+1)." ".$lang_script["survey.question.inc.php"]["isemptyError"]."<br>\n";
							$valid = false;
							break;
						case "checkbox":
							$this->errorMessage .= $lang_script["survey.question.inc.php"]["labelcheckError"]." ".($i+1)." ".$lang_script["survey.question.inc.php"]["isemptyError"]."<br>\n";
							$valid = false;
							break;
						case "radio":
							$this->errorMessage .= $lang_script["survey.question.inc.php"]["labelradioError"]." ".($i+1)." ".$lang_script["survey.question.inc.php"]["isemptyError"]."<br>\n";
							$valid = false;
							break;
						default:
							$this->errorMessage .= $lang_script["survey.question.inc.php"]["labelError"]." ".($i+1)." ".$lang_script["survey.question.inc.php"]["isemptyError"]."<br>\n";
							$valid = false;
							break;
					}
				}
			}
		}
		// labels fuer angegebene elemente fuer matrix
		if(($step == 4) && ($this->size > 0))
        {
			for($i=0; $i < $this->size; $i++)
            {
				$missingRow = intval($i/$this->tableSpan);
				if($this->optionHeader[$missingRow] == "")
                {
					$errorMessage[$missingRow] = $lang_script["survey.question.inc.php"]["labelError"]." ".($missingRow+1)." ".$lang_script["survey.question.inc.php"]["isemptyError"]."<br>\n";
					$valid = false;
				}
			}
			(is_array($errorMessage))? $this->errorMessage = implode ('',$errorMessage) : "";
		}
		
		// reihenlabels fuer angegebene elemente fuer matrix
		if(($step == 5) && ($this->size > 0))
        {
			for($i=0; $i < $this->size; $i++)
            {
				$missingRow = intval($i/$this->tempSizeCounter);
				if($this->optionAddHeader[$i] == "")
                {
					$errorMessage[$missingRow] = $lang_script["survey.question.inc.php"]["rowlabelError"]." ".($missingRow+1)." ".$lang_script["survey.question.inc.php"]["isemptyError"]."<br>\n";
					$valid = false;
				}
			}
			(is_array($errorMessage))? $this->errorMessage = implode ('',$errorMessage) : "";
		}
		return $valid;
	}
	
	
    /**
    *	saves form values to db or calls updatedb()
    *
    *	@access	private
    *   @return boolean true/false
    */
	function saveToDB()
    {
		global $cfgSrvyTabFormtype, $cfgSrvyTabFormelement, $cfgSrvyTabFormEleRules, $cfgSrvyTabForms; // global tabs
        
		global $langSurveyRequired, $langSurveyNumeric, $langSurveyNumericRequired; // global rulemessages
		
        // check if formelement already exist
		if($this->id > 0)
        {
			$this->updateDB();
			return;
		}
	
        $this->db = DB::connect(DSN, true);
        if (DB::isError($this->db)) 
        {    
           return false;
        }
        
        $typOrder = $this->getNextOrderId();
        $formtypeId = $this->db->nextId($cfgSrvyTabFormtype);
        // sql
		$sql = "insert 
			into $cfgSrvyTabFormtype 
            (FORMTYPE_ID_PK, FORMTYPE_FORM_ID_FK, FORMTYPE_QUESTION, FORMTYPE_TYPE, FORMTYPE_SIZE, FORMTYPE_ORDER, FORMTYPE_ALIGN, FORMTYPE_ACTIVE,	FORMTYPE_TABLESPAN, FORMTYPE_IMAGE, FORMTYPE_TIMESTAMP) 
            values 
            ('".$formtypeId."', '".$this->groupId."', '".$this->question."', '".$this->type."', '".$this->inputWidth."', '".$typOrder."', '".$this->align."', '".$this->active."', '".$this->tableSpan."', '".$this->questionImage."', NOW())";
        //
		$result = $this->db->query($sql);
        if (DB::isError($result)) 
        {
        	$this->errorMessage = $result->getMessage()."SQL: $sql";
            return false;
        }

		// optionen
		for($i=0; $i < $this->size; $i++)
        {
	        $formelementId = $this->db->nextId($cfgSrvyTabFormelement);
			// sql
			$sql = "insert 
				into $cfgSrvyTabFormelement 
                (FORMELEMENT_ID_PK, FORMELEMENT_FORMTYPE_ID_FK, FORMELEMENT_FORM_ID_FK, FORMELEMENT_MULTIPLEVALUE, FORMELEMENT_HEADER, FORMELEMENT_HIDEHEADER, FORMELEMENT_HEADERIMAGE, FORMELEMENT_ADDHEADER, FORMELEMENT_HIDEADDHEADER, FORMELEMENT_ADDHEADERIMAGE, FORMELEMENT_ORDER, FORMELEMENT_SWITCHTO, FORMELEMENT_SRVY_CNTNUE) 
                values 
                ('".$formelementId."', '".$formtypeId."', '".$this->groupId."', '".$this->optionMultipleValue[$i]."', '".$this->optionHeader[$i]."', '".$this->optionHideHeader[$i]."', '".$this->optionHeaderImage[$i]."', '".$this->optionAddHeader[$i]."', '".$this->optionHideAddHeader[$i]."', '".$this->optionAddHeaderImage[$i]."', '".$i."', '".$this->switches[$i]."', '".$this->formsend[$i]."')";
			//
			$result = $this->db->query($sql);
			if (DB::isError($result)) 
			{
				$this->errorMessage = $result->getMessage()."SQL: $sql";
				return false;
			}
		}
		// filter types where no numeric allowed
		if(($this->type == "radio")||($this->type == "checkbox")||($this->type == "checkboxtable")||($this->type == "radiotable")||($this->type == "select"))
		{
			$this->setQuestionRules('numeric' ,'##tobedeleted##');
		}
		// filter types where no required allowed
		if(($this->type == "switchtext"))
		{
			$this->setQuestionRules('required' ,'##tobedeleted##');
		}
		// filter types where no maxCheck allowed
		if(($this->type != "checkbox" && $this->type != "checkboxtable"))
		{
			$this->setQuestionRules('maxCheck' ,'##tobedeleted##');
		}
        // question Rules to db
        if(is_array($this->questionRules))
        {
			foreach($this->questionRules as $typeOfRule => $ruleMessage)
			{
				if($ruleMessage != '##tobedeleted##')
				{
					if(!$ruleMessage)
					{
						$ruleMessage = "&nbsp;";
					}
		        	$elementrulesId = $this->db->nextId($cfgSrvyTabFormEleRules);
					$sql = "insert 
						into $cfgSrvyTabFormEleRules 
		                (ELEMENTRULE_ID_PK, ELEMENTRULE_FORMTYPE_ID_FK, ELEMENTRULE_FORM_ID_FK, ELEMENTRULE_ATTRIBUTE, ELEMENTRULE_ALERT, ELEMENTRULE_CHECKALLOW) 
		                values 
		                ('$elementrulesId', '$formtypeId', '$this->groupId', '$typeOfRule', '$ruleMessage', '$this->ruleCheckAllow')";
					//
					$result = $this->db->query($sql);
					if (DB::isError($result)) 
					{
						$this->errorMessage = $result->getMessage()."SQL: $sql";
						return false;
					}
				}
			}
        }

	return true;
	}
	
	
    /**
    *	updates db with for values
    *
    *	@access	private
    *   @return boolean true/false
    */
	function updateDB()
    {
		global $cfgSrvyTabFormtype, $cfgSrvyTabFormelement, $cfgSrvyTabFormEleRules, $cfgSrvyTabForms;
		
		global $langSurveyRequired, $langSurveyNumeric, $langSurveyNumericRequired; // global rulemessages
		
        $this->db = DB::connect(DSN, true);
        if (DB::isError($this->db)) 
        {    
           return false;
        }
        $sql = "update 
			$cfgSrvyTabFormtype 
			set 
       		FORMTYPE_FORM_ID_FK = '".$this->groupId."', 
       		FORMTYPE_QUESTION = '".$this->question."', 
       		FORMTYPE_TYPE = '".$this->type."', 
		FORMTYPE_SIZE = '".$this->inputWidth."', 
       		FORMTYPE_ORDER = '".$this->order."', 
		FORMTYPE_ALIGN = '".$this->align."', 
       		FORMTYPE_ACTIVE = '".$this->active."', 
		FORMTYPE_TABLESPAN = '".$this->tableSpan."', 
		FORMTYPE_IMAGE = '".$this->questionImage."', 
		FORMTYPE_TIMESTAMP = NOW() 
		where FORMTYPE_ID_PK = ".$this->id;
		//FORMTYPE_IMAGE $this->questionImage
		$result = $this->db->query($sql);
        if (DB::isError($result)) 
        {
        	$this->errorMessage = $result->getMessage()."SQL: $sql";
            return false;
        }

		// optionen
		$sql = "select FORMELEMENT_ID_PK, FORMELEMENT_ORDER 
            from $cfgSrvyTabFormelement 
            where FORMELEMENT_FORMTYPE_ID_FK = ".$this->id." 
            order by FORMELEMENT_ORDER";
		//
		$result = $this->db->query($sql);
		if (DB::isError($result)) 
		{
			$this->errorMessage = $result->getMessage()."SQL: $sql";
			return false;
		}
		for($i=0; $row = $result->fetchRow(); $i++)
        {
            $maxOrder = $row[1];

			if($i < $this->size)
			{ 	
                // update
                $sql = "update
                $cfgSrvyTabFormelement 
                set 
		FORMELEMENT_MULTIPLEVALUE =	'".$this->optionMultipleValue[$i]."', 
                FORMELEMENT_HEADER = '".$this->optionHeader[$i]."', 
		FORMELEMENT_HIDEHEADER = '".$this->optionHideHeader[$i]."', 
		FORMELEMENT_HEADERIMAGE = '".$this->optionHeaderImage[$i]."', 
                FORMELEMENT_ADDHEADER = '".$this->optionAddHeader[$i]."', 
		FORMELEMENT_HIDEADDHEADER = '".$this->optionHideAddHeader[$i]."', 
		FORMELEMENT_ADDHEADERIMAGE = '".$this->optionAddHeaderImage[$i]."', 
                FORMELEMENT_SWITCHTO = '".$this->switches[$i]."', 
		FORMELEMENT_SRVY_CNTNUE = '".$this->formsend[$i]."' 
                where FORMELEMENT_ID_PK = '".$row[0]."'";
                //
                $result2 = $this->db->query($sql);
                //echo $sql."<br>\n";
                if (DB::isError($result2)) 
                {
                    $this->errorMessage = $result2->getMessage()."SQL: $sql";
                    return false;
                }
                
                if($this->switches[$i] != "0")
                {
                    // get last element in this subfolder
                    $sql = "select FORM_ID_PK 
                    from $cfgSrvyTabForms 
                    where (FORM_ID_PK = ".$this->switches[$i]." and FORM_NODEGROUP = '0') 
                    or (FORM_NODEGROUP = ".$this->switches[$i].") 
                    order by FORM_ORDER";
                    //
                    $result3 = $this->db->query($sql);
                    if (DB::isError($result3)) 
                    {
                        $this->errorMessage = $result3->getMessage()."SQL: $sql";
                        return false;
                    }
                    while ($row = $result3->fetchRow(DB_FETCHMODE_ASSOC))
                    {
                        $formsArray[] = $row;
                    }
                
                    $formsArrayNum = count($formsArray);
                    $lastFormsArrayId = $formsArray[$formsArrayNum-1]["FORM_ID_PK"];    
                    $formsEnd = $this->getFormsEnd($i);
		         }
			}
			else
			{ 
                // delete
                $sql = "delete 
                    from $cfgSrvyTabFormelement
                    where FORMELEMENT_ID_PK = ".$row[0];
                //
                $result2 = $this->db->query($sql);
                if (DB::isError($result2)) 
                {
                    $this->errorMessage = $result2->getMessage()."SQL: $sql";
                    return false;
                }
			}
		}
		// insert options
		for(; $i < $this->size; $i++)
		{
			$formelementId = $this->db->nextId($cfgSrvyTabFormelement);
			// sql
			$sql = "insert 
				into $cfgSrvyTabFormelement 
				(FORMELEMENT_ID_PK, FORMELEMENT_FORMTYPE_ID_FK, FORMELEMENT_FORM_ID_FK, FORMELEMENT_MULTIPLEVALUE, FORMELEMENT_HEADER, FORMELEMENT_HIDEHEADER, FORMELEMENT_HEADERIMAGE, FORMELEMENT_ADDHEADER, FORMELEMENT_HIDEADDHEADER, FORMELEMENT_ADDHEADERIMAGE, FORMELEMENT_ORDER, FORMELEMENT_SWITCHTO, FORMELEMENT_SRVY_CNTNUE) 
				values 
				('".$formelementId."', '".$this->id."', '".$this->groupId."', '".$this->optionMultipleValue[$i]."', '".$this->optionHeader[$i]."', '".$this->optionHideHeader[$i]."', '".$this->optionHeaderImage[$i]."', '".$this->optionAddHeader[$i]."', '".$this->optionHideAddHeader[$i]."', '".$this->optionAddHeaderImage[$i]."', '".(++$maxOrder)."', '".($this->switches[$i] ? $this->switches[$i] : "0")."', '".$this->formsend[$i]."')";	
			//
			$result = $this->db->query($sql);
			if (DB::isError($result)) 
			{
				$this->errorMessage = $result->getMessage()."SQL: $sql";
				return false;
			}
		}
        // select rule data from db
		// 
		// already existing rules
        $sql = "select ELEMENTRULE_ATTRIBUTE, ELEMENTRULE_ALERT 
			from $cfgSrvyTabFormEleRules 
			where ELEMENTRULE_FORMTYPE_ID_FK = ".$this->id;
		//
		$result = $this->db->query($sql);
		if (DB::isError($result)) 
		{
			$this->errorMessage = $result->getMessage()."SQL: $sql";
			return false;
		}
		while ($row = $result->fetchRow(DB_FETCHMODE_ASSOC))
        {
			if($row["ELEMENTRULE_ALERT"])
			{
				$existingRules[$row["ELEMENTRULE_ATTRIBUTE"]] = $row["ELEMENTRULE_ALERT"];
			}
		}
		// filter types where no numeric allowed
		if(($this->type == "radio")||($this->type == "checkbox")||($this->type == "checkboxtable")||($this->type == "radiotable")||($this->type == "select"))
		{
			$this->setQuestionRules('numeric' ,'##tobedeleted##');
		}
		// filter types where no required allowed
		if(($this->type == "switchtext"))
		{
			$this->setQuestionRules('required' ,'##tobedeleted##');
		}
		// filter types where no maxCheck allowed
		if(($this->type != "checkbox" && $this->type != "checkboxtable"))
		{
			$this->setQuestionRules('maxCheck' ,'##tobedeleted##');
		}
		//
		// insert/update/delete rules into db
		//
		// pflichtfeld not yet in db  -> insert
        if(is_array($this->questionRules))
        {
			foreach($this->questionRules as $typeOfRule => $ruleMessage)
			{
				// new rule
				if(!$existingRules["$typeOfRule"] && $ruleMessage != '##tobedeleted##')
				{
		        	$elementrulesId = $this->db->nextId($cfgSrvyTabFormEleRules);
					if(!$ruleMessage)
					{
						$ruleMessage = "&nbsp;";
					}
					// sql
					$sql = "insert 
						into $cfgSrvyTabFormEleRules 
		                (ELEMENTRULE_ID_PK, ELEMENTRULE_FORMTYPE_ID_FK, ELEMENTRULE_FORM_ID_FK, ELEMENTRULE_ATTRIBUTE, ELEMENTRULE_ALERT, ELEMENTRULE_CHECKALLOW) 
		                values 
		                ('$elementrulesId', '$this->id', '$this->groupId', '$typeOfRule', '$ruleMessage', '$this->ruleCheckAllow')";
					//
					$result = $this->db->query($sql);
					if (DB::isError($result)) 
					{
						$this->errorMessage = $result->getMessage()."SQL: $sql";
						return false;
					}
				}
				// update existing rule
				elseif($ruleMessage != '##tobedeleted##')
				{
					if(!$ruleMessage)
					{
						$ruleMessage = "&nbsp;";
					}
					// sql
					$sql = "update 
						$cfgSrvyTabFormEleRules 
						set ELEMENTRULE_ALERT = '$ruleMessage', ELEMENTRULE_CHECKALLOW = '$this->ruleCheckAllow' 
						where ELEMENTRULE_FORMTYPE_ID_FK = ".$this->id." 
						and ELEMENTRULE_ATTRIBUTE = '$typeOfRule'";
					//
					$result = $this->db->query($sql);
					if (DB::isError($result)) 
					{
						$this->errorMessage = $result->getMessage()."SQL: $sql";
						return false;
					}
					// set false this existing rule, all other will be deleted
					$existingRules["$typeOfRule"] = false;
				}
				// or delete it
				elseif($ruleMessage == '##tobedeleted##')
				{
			        $sql = "delete 
						from $cfgSrvyTabFormEleRules 
						where ELEMENTRULE_FORMTYPE_ID_FK = ".$this->id." 
						and ELEMENTRULE_ATTRIBUTE = '$typeOfRule'";
					//
			        $result = $this->db->query($sql);
			        if (DB::isError($result)) 
			        {
						$this->errorMessage = $result->getMessage()."SQL: $sql";
						return false;
			        }
				}
			}
		}
		// end insert/update/delete rules into db
		//
		return true;
	}
	
	
    /**
    *	deletes values from db
    *
    *	@access	private
    *   @return boolean true/false
    */
	function deleteFromDB()
    {
		global $cfgSrvyTabFormtype, $cfgSrvyTabFormelement, $cfgSrvyTabFormEleRules;
		
		//connect to db
        $this->db = DB::connect(DSN, true);
        if (DB::isError($this->db)) 
        {    
           return false;
        }
        
        // frage 
        $sql = "delete 
			from $cfgSrvyTabFormtype 
			where FORMTYPE_ID_PK = '".$this->id."'";
		//
        $result = $this->db->query($sql);
        if (DB::isError($result)) 
        {
			$this->errorMessage = $result->getMessage()."SQL: $sql";
			return false;
        }

		// optionen
		$sql = "delete 
			from $cfgSrvyTabFormelement 
			where FORMELEMENT_FORMTYPE_ID_FK = '".$this->id."'";
		//
		$result = $this->db->query($sql);
		if (DB::isError($result)) 
		{
			$this->errorMessage = $result->getMessage()."SQL: $sql";
			return false;
		}

        // regeln
        if(is_array($this->questionRules))
        {
			// delete rules
			$sql = "delete 
				from $cfgSrvyTabFormEleRules
				where ELEMENTRULE_FORMTYPE_ID_FK = '".$this->id."'";
			//
			$result = $this->db->query($sql);
			if (DB::isError($result)) 
			{
				$this->errorMessage = $result->getMessage()."SQL: $sql";
				return false;
			}
		}
		return true;
	}
    
    /**
	* returns groups
	*
	* @access public
    * @param id     $groupId 	id of group
	*/
	function groupsAfterGroupId($projectId, $groupId)
    {
        global $cfgSrvyTabForms;
        
        // connect to db
        $db = DB::connect(DSN, true);
        if (DB::isError($this->db)) 
        {    
           return false;
        }
        // sql
        $sql = "select FORM_ID_PK, FORM_NAME 
			from $cfgSrvyTabForms 
            where FORM_PROJECT_ID_FK = $projectId 
			and FORM_PARENT_ID = $groupId 
			and FORM_NODEGROUP = '0' 
            order by FORM_ORDER ASC";
		//
        $result = $db->query($sql);
        if (DB::isError($result)) 
        {
			$this->errorMessage = $result->getMessage()."SQL: $sql";
			return false;
        }
        while ($row = $result->fetchRow(DB_FETCHMODE_ASSOC))
        {
            $groupArray[] = $row;
        }
        
        return $groupArray;
	}
	
	
    /**
    *	returns question values for id
    *
    *	@access	private
    *	@param	int	$id
	*	@param	boolean	$withSwitchGroupNames
    *   @return object
    */
	function QuestionWithId($id, $withSwitchGroupNames = false)
	{
		// global variables
		global $cfgSrvyTabFormtype, $cfgSrvyTabFormelement, $cfgSrvyTabFormEleRules, $cfgSrvyTabForms, $cfgSrvyTabError;
		
		// init question object
		$myQuestion = new Question();
		// set form id
		$myQuestion->setId($id);
		
		// init db class
        $db = DB::connect(DSN, true);
        if (DB::isError($db)) 
        {    
           return false;
        }
		
        // get and set project id
		//
		// formid from Formtype
        $sql = "select FORMTYPE_FORM_ID_FK  
            from $cfgSrvyTabFormtype 
            where FORMTYPE_ID_PK = '$id'";
		//
        $row = $db->getRow($sql);
        if (DB::isError($result)) 
        {
			$this->errorMessage = $result->getMessage()."SQL: $sql";
			return false;
        }
		// projectidfrom forms
        $sql = "select FORM_PROJECT_ID_FK  
            from $cfgSrvyTabForms 
            where FORM_ID_PK = '$row[0]'";
		//
        $row = $db->getRow($sql);
        if (DB::isError($result)) 
        {
			$this->errorMessage = $result->getMessage()."SQL: $sql";
			return false;
        }
        $myQuestion->setProjectId($row[0]);
		$projectId = $row[0];
		//
		// end get and set project id
		
		// BEGIN select and set question type values
		//
        $sql = "select FORMTYPE_FORM_ID_FK, FORMTYPE_QUESTION, FORMTYPE_TYPE, FORMTYPE_ACTIVE, FORMTYPE_SIZE, FORMTYPE_ORDER, FORMTYPE_ALIGN, FORMTYPE_TABLESPAN, FORMTYPE_IMAGE 
            from $cfgSrvyTabFormtype 
            where FORMTYPE_ID_PK = '$id'";
		//
        $result = $db->query($sql);
        if (DB::isError($result)) 
        {
			$this->errorMessage = $result->getMessage()."SQL: $sql";
			return false;
        }
		$row = $result->fetchRow(DB_FETCHMODE_ASSOC);
		
		$myQuestion->setGroupId($row['FORMTYPE_FORM_ID_FK']);
		$myQuestion->setQuestion($row['FORMTYPE_QUESTION']);
		$myQuestion->setType($row['FORMTYPE_TYPE']);
		$myQuestion->setActive($row['FORMTYPE_ACTIVE']);
		$myQuestion->setInputWidth($row['FORMTYPE_SIZE']);
		$myQuestion->setOrder($row['FORMTYPE_ORDER']);
		$myQuestion->setAlign($row['FORMTYPE_ALIGN']);
		$myQuestion->setTableSpan($row['FORMTYPE_TABLESPAN']);
		$myQuestion->setQuestionImage($row['FORMTYPE_IMAGE']);
		
		// select forelement values
        $sql = "select FORMELEMENT_MULTIPLEVALUE, FORMELEMENT_HEADER, FORMELEMENT_HIDEHEADER, FORMELEMENT_HEADERIMAGE, FORMELEMENT_ADDHEADER, FORMELEMENT_HIDEADDHEADER, FORMELEMENT_ADDHEADERIMAGE, FORMELEMENT_SWITCHTO, FORMELEMENT_SRVY_CNTNUE 
			from $cfgSrvyTabFormelement 
			where FORMELEMENT_FORMTYPE_ID_FK = '$id' 
			order by FORMELEMENT_ORDER ASC";
		// proceed statement
        $result = $db->query($sql);
        if (DB::isError($result)) 
        {
			$this->errorMessage = $result->getMessage()."SQL: $sql";
			return false;
        }
		// get and set number of options
		$formElementNumber = $result->numRows();
		$myQuestion->setSize($formElementNumber);
		// get results
		for($i = 0; $i < $formElementNumber ; ++$i)
        {
			$row[$i] = $result->fetchRow(DB_FETCHMODE_ASSOC);
		}
		// set values for options
		for($i=0; $i < $formElementNumber; $i++)
        {
			$myQuestion->setOptionMultipleValue($i, $row[$i]['FORMELEMENT_MULTIPLEVALUE']);
			$myQuestion->setOptionHeader($i, $row[$i]['FORMELEMENT_HEADER']);
			$myQuestion->setOptionHideHeader($i, $row[$i]['FORMELEMENT_HIDEHEADER']);
			$myQuestion->setOptionHeaderImage($i, $row[$i]['FORMELEMENT_HEADERIMAGE']);
			$myQuestion->setOptionAddHeader($i, $row[$i]['FORMELEMENT_ADDHEADER']);
			$myQuestion->setOptionHideAddHeader($i, $row[$i]['FORMELEMENT_HIDEADDHEADER']);
			$myQuestion->setOptionAddHeaderImage($i, $row[$i]['FORMELEMENT_ADDHEADERIMAGE']);
			$myQuestion->setSwitch($i, $row[$i]['FORMELEMENT_SWITCHTO']);
			$myQuestion->setFormsEnd($i, $row[$i]['FORMELEMENT_SRVY_CNTNUE']);
            
			// set names of groups switched to if required
			if( ($withSwitchGroupNames) && ($row[$i]['FORMELEMENT_SWITCHTO'] != "0") )
			{
				// select name of form switched to
				$sql = "select FORM_NAME 
					from $cfgSrvyTabForms 
					where FORM_ID_PK = '".$row[$i]['FORMELEMENT_SWITCHTO']."'";
	        	//
				$switchName = $db->getOne($sql);
				if (DB::isError($switchName)) 
				{
					$this->errorMessage = $switchName->getMessage()."SQL: $sql";
					return false;
				}
			$myQuestion->setToSwitchGroupName($i, $switchName);
			}
        }
		//
		// END select and set question type values
        
		// select and set rule data from db
		//
		// sql
        $sql = "select ELEMENTRULE_ATTRIBUTE, ELEMENTRULE_ALERT, ELEMENTRULE_CHECKALLOW 
			from $cfgSrvyTabFormEleRules 
			where ELEMENTRULE_FORMTYPE_ID_FK = '$id'";
		//
		$result = $db->query($sql);
		if (DB::isError($result)) 
		{
			$this->errorMessage = $result->getMessage()."SQL: $sql";
			return false;
		}
		while ($row = $result->fetchRow(DB_FETCHMODE_ASSOC))
        {
			$existingRules[$row["ELEMENTRULE_ATTRIBUTE"]] = $row["ELEMENTRULE_ALERT"];
			// special Values
			$myQuestion->setRuleCheckAllow($row["ELEMENTRULE_CHECKALLOW"]);
		}
		// set rules if existing
		if(is_array($existingRules))
		{
			foreach($existingRules as $typeOfRule => $ruleMessage)
			{
				$myQuestion->setQuestionRules("$typeOfRule", $ruleMessage);
			}
		}
		// reset existing Rules
		$existingRules = false;
		//
		// end select and set rule data from db
		
		// check for default messages
		//
		// get defaultRulesMessages if set for project
        $sql = "select ERROR_LANG, ERROR_TYPE, ERROR_MESSAGE 
			from $cfgSrvyTabError 
			where ERROR_PROJECT_ID = '$projectId'";
		//
		$result = $db->query($sql);
		if (DB::isError($result)) 
		{
			$this->errorMessage = $result->getMessage()."SQL: $sql";
			return false;
		}
		if($result->numRows() > 0)
		{
			while ($row = $result->fetchRow(DB_FETCHMODE_ASSOC))
	        {
				$existingRules[$row["ERROR_LANG"]][$row["ERROR_TYPE"]] = $row["ERROR_MESSAGE"];
			}
		}
		// else get global defaultRulesMessages
		else
		{
			// sql
	        $sql = "select ERROR_LANG, ERROR_TYPE, ERROR_MESSAGE 
				from $cfgSrvyTabError 
				where ERROR_PROJECT_ID = '0'";
			//
			$result = $db->query($sql);
			if (DB::isError($result)) 
			{
				$this->errorMessage = $result->getMessage()."SQL: $sql";
				return false;
			}
			while ($row = $result->fetchRow(DB_FETCHMODE_ASSOC))
	        {
				$existingRules[$row["ERROR_LANG"]][$row["ERROR_TYPE"]] = $row["ERROR_MESSAGE"];
			}
		}
		// set rules if existing
		if(is_array($existingRules))
		{
			foreach($existingRules as $idOfRule => $ruleMessages)
			{
				$myQuestion->setQuestionDefaultRules("$idOfRule", $ruleMessages);
			}
		}
		//
		return $myQuestion;
	}
	
	
    /**
    *	returns question in specified group
    *
    *	@access	private
    *	@param	int	$groupId
    *   @return array
    */
	function QuestionsInGroup($groupId)
	{
		// global variables
		global $cfgSrvyTabFormtype;
		
        $db = DB::connect(DSN, true);
        if (DB::isError($this->db)) 
        {    
           return false;
        }
        // sql
        $sql = "select FORMTYPE_ID_PK 
			from $cfgSrvyTabFormtype 
			where FORMTYPE_FORM_ID_FK = '$groupId' 
			order by FORMTYPE_ORDER ASC";
        //
        $all = $db->getAll($sql);
        if (DB::isError($all)) 
        {
            echo $maxNum->getMessage();
            return "Fehler. ".$maxNum->getMessage();
        }
        for($i=0; $i < count($all); $i++)
        {
        	$questions[] = &Question::QuestionWithId($all[$i][0]);
        }
        return $questions;
	}
	
    /**
    *	moves question to different order
    *
    *	@access	private
    *	@param	int	$groupId
    *   @return boolean true/false
    */
	function moveToOrder($order)
	{
		// global variables
		global $cfgSrvyTabFormtype;
		
        $this->db = DB::connect(DSN, true);
        if (DB::isError($this->db)) 
        {    
           return false;
        }
		// sql
        $sql = "update $cfgSrvyTabFormtype 
			set FORMTYPE_ORDER = (FORMTYPE_ORDER + 1) 
			where FORMTYPE_ORDER >= $order 
			and FORMTYPE_FORM_ID_FK = '".$this->groupId."'";
		//
        $result = $this->db->query($sql);
        if (DB::isError($result)) 
        {
			$this->errorMessage = $result->getMessage()."SQL: $sql";
			return false;
        }
        
        $this->setOrder($order);
		// sql
        $sql = "update 
			$cfgSrvyTabFormtype 
			set 
			FORMTYPE_ORDER = '".$this->order."' 
			where FORMTYPE_ID_PK = '".$this->id."'";
        //
		$result = $this->db->query($sql);
        if (DB::isError($result)) 
        {
			$this->errorMessage = $result->getMessage()."SQL: $sql";
			return false;
        }
		
		return true;
	}
	
	
    /**
    *	moves question to end of group
    *
    *	@access	private
    *	@param	int	$groupId
    *   @return boolean true/false
    */
	function moveToEnd()
	{
		// global variables
		global $cfgSrvyTabFormtype;
		
        $this->db = DB::connect(DSN, true);
        if (DB::isError($this->db)) 
        {    
           return false;
        }
        
        $this->setOrder($this->getNextOrderId());
		// sql
        $sql = "update 
			$cfgSrvyTabFormtype 
			set 
			FORMTYPE_ORDER = '".$this->order."' 
			where FORMTYPE_ID_PK = '".$this->id."'";
        //
		$result = $this->db->query($sql);
        if (DB::isError($result)) 
        {
			$this->errorMessage = $result->getMessage()."SQL: $sql";
			return false;
        }
		
		return true;
	}
    
	
    /**
    *	gets next oreder id
    *
    *	@access	private
    *	@param	int	$groupId
    *   @return int
    */
    function getNextOrderId()
    {
		// global variables
		global $cfgSrvyTabFormtype;
		
        $this->db = DB::connect(DSN, true);
        if (DB::isError($this->db)) 
        {    
           return false;
        }
        // sql
        $sql = "select max(FORMTYPE_ORDER) 
            from $cfgSrvyTabFormtype 
            where FORMTYPE_FORM_ID_FK = $this->groupId";
        //
        $maxNum = $this->db->getOne($sql);
        if (DB::isError($maxNum)) 
        {
			$this->errorMessage = $maxNum->getMessage()."SQL: $sql";
			return false;
        }
        return $maxNum+1;
    }
}

// 021203-rr // if these should be needed sometimes, subclasses for div tablegroups must be added also these statements are not up to date

class CheckboxQuestion extends Question
{
	function CheckboxQuestion($groupId, $question, $required,$align){
		global $lang_script;
		$this->type = "checkbox";
		$this->groupId = $groupId;
		$this->question = $question;
		$this->align = ($align == "ver") ? $lang_script["survey.question.inc.php"]["vertical"] : $lang_script["survey.question.inc.php"]["horizontal"];
		$this->required = ($required != "") ? "1" : "0";
	}
}

class SelectQuestion extends Question
{
	function SelectQuestion($groupId, $question, $required){
		$this->type = "select";
		$this->groupId = $groupId;
		$this->question = $question;
		$this->required = ($required != "") ? "1" : "0";
	}
}

class RadiobuttonQuestion extends Question
{
	function RadiobuttonQuestion($groupId, $question, $required,$align){
		global $lang_script;
		$this->type = "radio";
		$this->groupId = $groupId;
		$this->question = $question;
		$this->align = ($align == "ver") ? $lang_script["survey.question.inc.php"]["vertical"] : $lang_script["survey.question.inc.php"]["horizontal"];
		$this->required = ($required != "") ? "1" : "0";
	}
}

class GroupedTextQuestion extends Question
{
	function GroupedTextQuestion($groupId, $question, $required,$align,$tableSpan){
		global $lang_script;
		$this->type = "groupedtext";
		$this->groupId = $groupId;
		$this->question = $question;
		$this->inputWidth = $inputWidth;
		$this->align = ($align == "ver") ? $lang_script["survey.question.inc.php"]["vertical"] : $lang_script["survey.question.inc.php"]["horizontal"];
		$this->required = ($required != "") ? "1" : "0";
		$this->tableSpan = $tableSpan;
	}
}

class TextQuestion extends Question
{
	function TextQuestion($groupId, $question, $required){
		$this->type = "text";
		$this->size = 0;
		$this->groupId = $groupId;
		$this->question = $question;
		$this->required = ($required != "") ? "1" : "0";
	}
	
	// command methods
	function setOptionHeader($index, $optionHeader){ return false; }
	function setOptionAddHeader($index, $optionAddHeader){ return false; }
	function getOptionHeader($index){ return false; }
	function getOptionAddHeader($index){ return false; }
}

class TextareaQuestion extends Question
{
	function TextareaQuestion($groupId, $question, $required){
		$this->type = "textarea";
		$this->size = 0;
		$this->groupId = $groupId;
		$this->question = $question;
		$this->required = ($required != "") ? "1" : "0";
	}
	
	// command methods
	function setOptionHeader($index, $optionHeader){ return false; }
	function setOptionAddHeader($index, $optionAddHeader){ return false; }
	function getOptionHeader($index){ return false; }
	function getOptionAddHeader($index){ return false; }
}
 
?>
