<?php
// +----------------------------------------------------------------------+
// | sm survey module - xmlFunctions                                      |
// +----------------------------------------------------------------------+
// | Copyright (c) 2002 serie a - Digitale Medien und Systeme GmbH        |
// +----------------------------------------------------------------------+
// | Authors: Jrn Allert <allert@serie-a.de>                             |
// |          Rene Renk <renk@serie-a.de>                                 |
// +----------------------------------------------------------------------+
// | Description: Basic functions to convert data to XML and vice versa   |
// |         								                              |
// +----------------------------------------------------------------------+
//
// $Id: xmlfunctions.inc.php,v 1.1.1.1 2004/07/15 13:33:00 opensurveypilot Exp $

// require all configuration files and libraries
require_once($cfgPathToProjectAdmin."/config/config.inc.php"); // common config file // common config file
require_once($cfgPathToConf."/file.inc.php"); // project files
require_once($cfgPathToSurveyFiles."/config/survey.config.inc.php"); // auth config file
require_once($cfgPathToSurveyConfig."/survey.file.inc.php"); // modules files
require_once("XML/sql2xml.php");
require_once("XML/XPath.php");

/**
* xmlFunctions class
*
* Basic functions to convert data to XML and vice versa
*
* @author  Jrn Allert <allert@serie-a.de>
* @author  Rene Renk <renk@serie-a.de>
* @access  public
*/
class xmlFunctions
{
    /**
    *	global counter for xmlFunctions
    *	@var    int  $xmlFctCounter
    */
	var $xmlFctCounter					  = 0;
	
	/**
    *	gets error message
    *
    *	@access	private
    *	@param	string	$err
    */
    function getErrorMessage($err)
    {
        $this->errorMessage = $err;
    }
	
    /**
    *	merges two tables by argument
    *   puts all data in a xmlfilestring.
    *
    *	@access	private
    *	@param	string	$xmlFctTableOne
    *	@param	string	$xmlFctTableTwo
    *	@param	array	$xmlFctTabArgument // just one argument right now
	*	@param	string	$xmlFctOrderby
    *	@return	string  merged table data as Xml_file_string
    */
	function joinTabByArgtoXml ($xmlFctTableOne,$xmlFctTableTwo,$xmlFctTabArgument="NO",$xmlFctOrderby="NO")
	{
		$sql2xmlclass = new xml_sql2xml(DSN_SRVY);
		$MySqlStatement = "select * from $xmlFctTableOne join $xmlFctTableTwo";
		if (($xmlFctTabArgument!="NO")AND($xmlFctTabArgument!=""))
		{
			foreach($xmlFctTabArgument as $key => $value)
			{
				$TabCol 	= $key;
				$TabColVal	= $value;
			}
			$MySqlStatement .= " where $xmlFctTableTwo.$TabCol = $TabColVal AND $xmlFctTableOne.$TabCol = $TabColVal";
		}
		if (($xmlFctOrderby!="NO")AND($xmlFctOrderby!=""))
		{
			$MySqlStatement .= " order by $xmlFctOrderby";
		}
		//echo "<br><br><br>".$MySqlStatement;  //--Echo Statement for Debug
		$xmlFctTabjoinTabXmlfile = $sql2xmlclass->getxml($MySqlStatement);
		return $xmlFctTabjoinTabXmlfile;
	}
	
	
	
    /**
    *	gets all table data by optional number
	*	of Arguments.
	*	optional Methods AND/OR --Default = AND
    *   puts all data in a xmlfilestring.
    *
    *	@access	private
    *	@param	string	$xmlFctTable
    *	@param	array	$xmlFctTabArguments
    *	@param	string	$xmlFctMethod
    *	@return	string  table data as Xml_file_string
    */
	function tabToXmlWhithArg ($xmlFctTable,$xmlFctTabArguments=0,$xmlFctMethod="AND",$xmlFctOrderby="NO")
	{
		$sql2xmlclass = new xml_sql2xml(DSN_SRVY);
		$MySqlStatement = "select * from $xmlFctTable";
		if ($xmlFctTabArguments!=0)
		{
			foreach($xmlFctTabArguments as $key => $value)
			{
				if ($this->xmlFctCounter==0)
				{
					$MySqlStatement .=" where ".$key." = '".$value."'";
				}
				else
				{
					//check for AND/OR statement
					$xmlFctMethod = strtoupper($xmlFctMethod);
					if ($xmlFctMethod=="OR")
					{
						$MySqlStatement .=" OR ".$key." = '".$value."'";
					}
					else
					{
						$MySqlStatement .=" AND ".$key." = '".$value."'";
					}
				}
			$this->xmlFctCounter=1;
			}
		$this->xmlFctCounter=0;
		}
		// check for order by statement
		$xmlFctOrderby = strtoupper($xmlFctOrderby);
		if (($xmlFctOrderby!="NO")AND($xmlFctOrderby!=""))
		{
			$MySqlStatement .= " order by $xmlFctOrderby";
		}
		$xmlFctTabtoXmlfile = $sql2xmlclass->getxml($MySqlStatement);
		return $xmlFctTabtoXmlfile;
	}
	
	
    /**
    *	creates an Array from XML-file
	*	using $Nodename as DataContaining XML-Tagname
    *   puts all data in $OutputArray[Datasetnumber][Data].
	*	optional argument to sort array
    *
    *	@access	private
    *	@param	string	$XmlString
	*	@param	string	$SortBy
    *	@param	string	$Nodename
    *	@return	array   XML-string Data as Array[Datasetnumber][Data]
    */
	function createArrayFromXml($XmlString,$SortBy="",$Nodename='//row')
	{
		//Create new Object
		if (XML_XPath::isError($xml = new XML_XPath($XmlString, 'string'))) 
		{ 
		    $this->getErrorMessage($xml->getMessage()); 
			return false; 
		}
		//Parse for values 
		$OutputArray = array(); 
		$result = $xml->evaluate("$Nodename"); 
		for ($i=0;$result->next();$i++) 
		{ 
			if (!$result->firstChild()) 
			{ 
			    continue; 
			} 
			do 
			{ 
			    $tmp_var = strtolower($result->nodeName()); 
			    $OutputArray[$i][$tmp_var] = $result->substringData();
			} 
			while 
				($result->nextSibling());
		// create sort order
		if ($SortBy!="")
			{
				$SortElementValue[$i] = $OutputArray[$i][$SortBy];
			}
		}
		// sort array by argument
		if ($SortBy!="")
		{
			$i=0;
			asort($SortElementValue);
			foreach($SortElementValue as $key=> $value) 
			{
			  	$SortedOutput[$i]=$OutputArray[$key];
				$i++;
			}
			$OutputArray = $SortedOutput;
		}
		return $OutputArray;
	}
	
	/**
    *	Sorts an Array by Argument
    *
    *	@access	private
    *	@param	array	$ArrayToSort
	*	@param	string	$SortBy
    *	@return	array   sorted Array
    */
	function sortArrayByArgument($ArrayToSort,$SortBy="")
	{	
		If (is_array($ArrayToSort)==0)
		{
			getErrorMessage("Supplied argument '$ArrayToSort' not valid.");
		}
		for ($i=0;$i<count($ArrayToSort);$i++)
			{
				$SortElementValue[$i] = $ArrayToSort[$i][$SortBy];
			}
		$i=0;
		asort($SortElementValue);
		foreach($SortElementValue as $key => $value) 
		{
		  	$SortedOutput[$i]=$ArrayToSort[$key];
			$i++;
		}
	return $SortedOutput;
	}
	
}
?>