<?php
// +----------------------------------------------------------------------+
// | survey pilot                                                         |
// +----------------------------------------------------------------------+
// | Copyright (c) 2002 serie a - Digitale Medien und Systeme GmbH        |
// +----------------------------------------------------------------------+
// | Authors: 	Jrn Allert <allert@serie-a.de>                           |
// |          	Rene Renk   <renk@serie-a.de>                             |
// +----------------------------------------------------------------------+
//
// $Id: survey.add.php,v 1.1.1.1 2004/07/15 13:31:51 opensurveypilot Exp $

// start session
@session_start();

// require all configuration files and libraries
require_once("./../config/config.inc.php"); // common config file
require_once ("Validate.php"); // PEAR::Validate
require_once($cfgPathToConf."/file.inc.php"); // project files
require_once($cfgPathToLib."/common.inc.php"); // common functions
require_once($cfgPathToSurveyFiles."/config/survey.config.inc.php"); // survey files
require_once($cfgPathToSurveyFiles."/config/survey.file.inc.php"); // survey files
require_once($cfgPathToSurveyFiles."/lib/survey.inc.php"); // survey functions
require_once($cfgPathToAuthFiles."/lib/user.inc.php"); // auth user functions
require_once($cfgPathToAuthFiles."/config/auth.file.inc.php"); // auth user functions
require_once("HTML/Template/IT.php"); // PEAR::HTML_TEMPLATE_IT

// create new userFunctions object
$client = &new userFunctions;

//login check
if ($client->getAuthentication($_SESSION["sessionId"], session_id()) ==  false)
{
    //redirect to login page
    ?>
    <script type="text/javascript">
    <!--
    window.location.href="<?php echo $cfgUrlToProject."/".$fileAuthLogin; ?>";
    -->
    </script>
    <?php
    exit;
}

// Start of checking the permissions 
$fileUserPermissionMode	=	$permUserSurveyAdd;
$filePermissionMode		=	$permSurveyAdd;

// filepermission
if($_SESSION["sessionUserStatusId"] < $filePermissionMode)
{
    ?>
    <script type="text/javascript">
    <!--
    window.location.href="<?php echo $cfgUrlToProject."/".$fileNoPermission."?messageCode=".$filePermissionMode."&messageType=file"; ?>";
    -->
    </script>
    <?php
    exit;
}

// End of checking the permissions

// check if form was submitted
if($_SERVER["REQUEST_METHOD"] == "POST")
{
	$surveyName = cleanHtml($_POST["surveyName"]);

    if($surveyName != "")
    {
        // check format
        if(!validate::string($surveyName, VAL_DENAME, 1, 50))
        {
            $errors["surveyName"] = $lang_script["survey.add.php"]["surveyNameUnvalidChars1"]." ".$surveyName." ".$lang_script["survey.add.php"]["surveyNameUnvalidChars2"];
        }
    }
    else
    {
        $errors["surveyName"] = $lang_script["survey.add.php"]["surveyNameFillIn"];
    }
	
	$surveyDescription = cleanHtml($_POST["surveyDescription"]);
    if($surveyDescription != "")
    {
        // check format
        if(!validate::string($surveyDescription, VAL_DENAME_PUNCTUATION, 1, 500))
        {
            $errors["surveyDescription"] = $lang_script["survey.add.php"]["surveyDescriptionLength"];
        }
    }
    else
    {
        $errors["surveyDescription"] = $lang_script["survey.add.php"]["surveyDescriptionFillIn"];
    }
    
    $surveyActive = $_POST["surveyActive"];
    if($surveyActive == "1")
    {
        $surveyActiveChecked = "checked";
    }
	
	$surveyOutputDir = cleanHtml(ereg_replace(" ","_",(strtolower($_POST["surveyOutputDir"]))));
    if($surveyOutputDir != "")
    {
        // check format
        if(!validate::string($surveyOutputDir, VAL_ALPHA_NUM_, 1, 50))
        {
            $errors["surveyOutputDir"] = $lang_script["survey.add.php"]["surveyOutputDirLength"];
        }
    }
    else
    {
        $errors["surveyOutputDir"] = $lang_script["survey.add.php"]["surveyOutputDirFillIn"];
    }

    $surveyStartDateYear = $_POST["surveyStartDateYear"];
    $surveyStartDateMonth = $_POST["surveyStartDateMonth"];
    $surveyStartDateDay = $_POST["surveyStartDateDay"];
    if($surveyStartDateYear !=  "" and $surveyStartDateMonth !=  "" and $surveyStartDateDay != "")
    {
        // validate date
        if(!validate::date($surveyStartDateDay.$surveyStartDateMonth.$surveyStartDateYear,'%d%m%Y'))
        {
            $errors["surveyStartDate"] = $lang_script["survey.add.php"]["surveyStartDateInvalid"];
        }
        else
        {
            $surveyStartDate = $surveyStartDateYear."-".$surveyStartDateMonth."-".$surveyStartDateDay;
        }
    }
        
    $surveyEndDateYear = $_POST["surveyEndDateYear"];
    $surveyEndDateMonth = $_POST["surveyEndDateMonth"];
    $surveyEndDateDay = $_POST["surveyEndDateDay"];
    if($surveyEndDateYear !=  "" and $surveyEndDateMonth !=  "" and $surveyEndDateDay != "")
    {
        // validate date
        if(!Validate::date($surveyEndDateDay.$surveyEndDateMonth.$surveyEndDateYear,'%d%m%Y'))
        {
            $errors["surveyEndDate"] = $lang_script["survey.add.php"]["surveyEndDateInvalid"];
        }
        else
        {
            $surveyEndDate = $surveyEndDateYear."-".$surveyEndDateMonth."-".$surveyEndDateDay;
        }
    }
        
    // put error Array in String
    if($errors)
    {
        foreach($errors as $error)
        {
            $surveyError .= "$error<br>";
        }
    }
    // no errors, so we can insert new user    
    else
    {
	    // create new userFunctions object
        $survey = &new surveyFunctions;
        
	$surveyArray["surveyAuthorId"] 		= $_SESSION["sessionUserId"];
        $surveyArray["surveyName"] 		= $surveyName;
        $surveyArray["surveyAuthor"] 		= $_SESSION["sessionUserFirstname"]." ".$_SESSION["sessionUserLastname"];
        $surveyArray["surveyDescription"] 	= $surveyDescription;
	$surveyArray["surveyOutputDir"] 	= $surveyOutputDir;
        $surveyArray["surveyActive"] 		= $surveyActiveChecked;
	$surveyArray["surveyStartDate"] 	= $surveyStartDate;
	$surveyArray["surveyEndDate"] 		= $surveyEndDate;
		
        $result	= $survey->addSurvey($surveyArray);
        if($survey->errorMessage)
        {
            $surveyError .= "<br>".$survey->errorMessage;
        }
        
        // create outputdir
        $survey->createOutputDir($surveyOutputDir);
        if($survey->errorMessage)
        {
            $surveyError .= "<br>".$survey->errorMessage;
        }
        
        // copy files in output dir
        $survey->copySurveyAddFiles($surveyOutputDir);
        if($survey->errorMessage)
        {
            $surveyError .= "<br>".$survey->errorMessage;
        }
 
        if(!$surveyError)
        {
          ?>
		  <html><body>
	      <script type="text/javascript">
		  <!--
          		window.location.href="<?php echo $cfgUrlToProject."/".$fileCommonSuccessMessage; ?>";
          -->
          </script>
		  <?php
		  exit;
        }
    }
}

// create Template IT object
$tpl = new HTML_Template_IT($cfgPathToSurveyTemplates);

// load template
$tpl->loadTemplatefile($templateSurveyAdd, true, true);

// set title
$tpl->setVariable( "applicationtitle", $cfgApplicationType.$cfgApplicationVersion);

$tpl->setVariable( "formaction", $fileSurveyAdd );

$tpl->setVariable( "errors", $surveyError );

$tpl->setVariable( "surveyname", $surveyName );
$tpl->setVariable( "surveyauthor", $surveyAuthor );
$tpl->setVariable( "surveydescription", $surveyDescription );
$tpl->setVariable( "surveyoutputpath", $surveyOutputDir );
$tpl->setVariable( "surveyactive", $surveyActiveChecked );
$tpl->setVariable( "projectId", "$projectId" );

// parse template
$tpl->parse();

// get the parsed template and print it
$tpl->get();
$tpl->show();
?>
