<?php 
// +----------------------------------------------------------------------+
// | survey pilot                                                         |
// +----------------------------------------------------------------------+
// | Copyright (c) 2002 serie a - Digitale Medien und Systeme GmbH        |
// +----------------------------------------------------------------------+
// | Authors: J?rn Allert <allert@serie-a.de>                             |
// |          Rene Renk <renk@serie-a.de>                                 |
// +----------------------------------------------------------------------+
//
// $Id: survey.create.php,v 1.3 2007/01/03 10:56:06 easy_israel Exp $

// start session
@session_start();

// require all configuration files and libraries
require_once("./../config/config.inc.php"); // common config file
require_once($cfgPathToConf."/file.inc.php"); // project files
require_once($cfgPathToLib."/common.inc.php"); // common functions
require_once($cfgPathToSurveyFiles."/config/survey.config.inc.php"); // survey config file
require_once($cfgPathToSurveyFiles."/config/survey.file.inc.php"); // survey files
require_once($cfgPathToSurveyFiles."/lib/database/dbfunctions.inc.php"); // survey db functions
require_once($cfgPathToSurveyFiles."/lib/survey.inc.php"); // survey functions
require_once($cfgPathToAuthFiles."/lib/user.inc.php"); // auth functions
require_once($cfgPathToAuthFiles."/config/auth.file.inc.php"); // auth files
require_once($cfgPathToAuthFiles."/lib/permission.inc.php"); // permission functions
require_once("HTML/Template/IT.php"); // PEAR::HTML_TEMPLATE_IT
require_once($cfgPathToLangFiles."/lib/languagefunctions.inc.php");

// create new userFunctions object
$client = &new userFunctions;

//login check
if ($client->getAuthentication($_SESSION["sessionId"], session_id()) ==  false)
{
    //redirect to login page
    ?>
    <script type="text/javascript">
    <!--
    window.location.href="<?php echo $cfgUrlToProject."/".$fileAuthLogin; ?>";
    -->
    </script>
    <?php
    exit;
} 

// Start of checking the permissions 
$fileUserPermissionMode	=	$permUserSurveyCreate;
$filePermissionMode		=	$permSurveyCreate;

// filepermission
if($_SESSION["sessionUserStatusId"] < $filePermissionMode)
{
    ?>
    <script type="text/javascript">
    <!--
    window.location.href="<?php echo $cfgUrlToProject."/".$fileNoPermission."?messageCode=".$filePermissionMode."&messageType=file"; ?>";
    -->
    </script>
    <?php
    exit;
}
// get projectId
$projectId = (isset($_GET["projectId"])) ? $_GET["projectId"] : $_POST["projectId"];

// create new permissionFunctions object
$permission = &new permissionFunctions;

// get Permission
$permissionMode = $permission->getPermissionMode($_SESSION["sessionUserId"], $projectId, 1);
if($permission->errorMessage)
{
    echo $permission->errorMessage;
}
// userpermission
if($permissionMode < $fileUserPermissionMode)
{
    ?>
    <script type="text/javascript">
    <!--
    window.location.href="<?php echo $cfgUrlToProject."/".$fileNoPermission."?messageCode=".$fileUserPermissionMode."&messageType=user"; ?>";
    -->
    </script>
    <?php
    exit;
}
// End of checking the permissions

// init survey dbclass 
$surveyDb = &new surveyFunctionsDB;

// init dbFunctions
$dbFunctions = &new dbFunctions;

// get survey data
$surveyData = $dbFunctions->tabToArrayWhithArg($cfgSrvyTabSurvey,array("PROJECT_ID_PK"=>"$projectId"));

// check if form was submitted
if($_SERVER["REQUEST_METHOD"] == "POST")
{
    $surveyStatus = $_POST["surveyStatus"];
    $panellang = $_POST["panellang"];
   
    // change status
    $status = $dbFunctions->updateTable($cfgSrvyTabSurvey,array("PROJECT_ACTIVE"=>$surveyStatus),array("PROJECT_ID_PK"=>"$projectId"));
    
    if($surveyStatus == "yes")
    {
        // create new surveyFunctions object
        $survey = &new surveyFunctions;
        
        // check if table is there
        if(!$survey->existsTable("T_SURVEY_RESULT_".$projectId))
        {
            // make resulttables
    	    $resultTabsStatus = $surveyDb->createResultTab($projectId);
    	    switch ($resultTabsStatus)
    	    {
        		case "syntax":
        		{
        		    $err = $lang_script["survey.create.php"]["activateError"];
        		    break;
        		}
        		default:
        		{
        		    $err = $lang_script["survey.create.php"]["createTableSuccess"];
        		}
    	    }
        }
        if($survey->errorMessage)
        {
            $error .= $survey->errorMessage;
        }
        
        // create outputdir
        $survey->createOutputDir($surveyData[0]["PROJECT_OUTPUTDIR"]);
        if($survey->errorMessage)
        {
            $error .= $survey->errorMessage;
        }
        
        // check if there are templates set
        $templateArray = $survey->isTemplateSet($projectId);
        if($survey->errorMessage)
        {
            $error .= $survey->errorMessage;
        }
        
        // copy files in output dir
        $survey->copySurveyCreateFiles($projectId, $surveyData[0]["PROJECT_OUTPUTDIR"], $templateArray, $panellang);
        if($survey->errorMessage)
        {
            $error .= $survey->errorMessage;
        }
    }
    
    // check $status and $error
    if (!$error and $status=="ok")
    {
         	?>
			<script type="text/javascript">
			<!--
			opener.parent.content.location.reload();
			opener.parent.projecttree.location.reload();
			//window.location.href="<?php echo $fileSurveyCreate."?projectId=".$projectId."&warningChecked=yes"; ?>";
			-->
			</script>
		  	<?php
    }
}


// get survey data
$surveyData = $dbFunctions->tabToArrayWhithArg($cfgSrvyTabSurvey,array("PROJECT_ID_PK"=>"$projectId"));

// create Template IT object
$tpl = new HTML_Template_IT($cfgPathToSurveyTemplates);

// load template
$tpl->loadTemplatefile($templateSurveyCreate, true, true);

// set title
$tpl->setVariable( "applicationtitle", $cfgApplicationType.$cfgApplicationVersion);

//set the links
$tpl->setVariable( "lnk_settings", $fileSurveyEdit."?projectId=".$projectId."&warningChecked=yes" );
$tpl->setVariable( "lnk_preview", $fileSurveyAdminPreview."?projectId=".$projectId );
$tpl->setVariable( "lnk_clearing", $fileSurveyMake."?projectId=".$projectId );
$tpl->setVariable( "lnk_delete", $fileSurveyDelete."?projectId=".$projectId );

$tpl->setVariable( "name", $surveyData[0]["PROJECT_NAME"] );
$tpl->setVariable( "author", $surveyData[0]["PROJECT_AUTHOR"] );
if ($surveyData[0]["PROJECT_ACTIVE"] == "yes")
{
    $tpl->setVariable( "surveystatusyes", "selected" );
}
else
{
    $tpl->setVariable( "surveystatusno", "selected" );
}
$tpl->setVariable( "projectid", $projectId );
$tpl->setVariable( "errors", $error );

$lf = new languageFunctions();
$installedLanguages = $lf->getInstalledLanguages();


$filename = $cfgPathToOutput."/".$surveyData[0]["PROJECT_OUTPUTDIR"]."/"."survey.xml";
if (is_file($filename))
{
	// read xml file
	$fd = fopen ($filename, "r");
	$contents = fread ($fd, filesize ($filename));
	fclose ($fd);
	// parse xml file and get survey language
	preg_match("/(<lang>)(.*)(<\/lang>)/i", $contents, $matches);
	$surveylang = $matches[2];
}
else
{
	$surveylang = $_SESSION["sessionUserLanguageFile"];
}

for ($i=0;$i<count($installedLanguages);$i++)
{
	$tpl->setCurrentBlock( "panellanglist" );
	if ($surveylang==$installedLanguages[$i][LANGUAGE_FILE])
		$tpl->setVariable( "panellang_selected", "selected" );
	else	
		$tpl->setVariable( "panellang_selected", "" );
	$tpl->setVariable( "panellang_value", $installedLanguages[$i][LANGUAGE_FILE] );
	$tpl->setVariable( "panellang_name",  ucfirst($installedLanguages[$i][LANGUAGE_FILE]) );
	$tpl->parseCurrentBlock();
	
}

// parse template
$tpl->parse();

// get the parsed template and print it
$tpl->get();
$tpl->show();
?>
