<?php
// +----------------------------------------------------------------------+
// | survey pilot                                                         |
// +----------------------------------------------------------------------+
// | Copyright (c) 2002 serie a - Digitale Medien und Systeme GmbH        |
// +----------------------------------------------------------------------+
// | Authors: 	Jrn Allert <allert@serie-a.de>                           |
// |          	Rene Renk   <renk@serie-a.de>                             |
// +----------------------------------------------------------------------+
//
// $Id: survey.delete.php,v 1.1.1.1 2004/07/15 13:31:52 opensurveypilot Exp $

// start session
@session_start();

// require all configuration files and libraries
require_once("./../config/config.inc.php"); // common config file
require_once("HTML/Template/IT.php"); // PEAR::HTML_TEMPLATE_IT
require_once("Validate.php"); // PEAR::Validate
require_once($cfgPathToConf."/file.inc.php"); // project files
require_once($cfgPathToLib."/common.inc.php"); // common functions
require_once($cfgPathToSurveyFiles."/config/survey.config.inc.php"); // survey files
require_once($cfgPathToSurveyFiles."/config/survey.file.inc.php"); // survey files
require_once($cfgPathToSurveyFiles."/lib/survey.inc.php"); // survey functions
require_once($cfgPathToAuthFiles."/lib/user.inc.php"); // auth user functions
require_once($cfgPathToAuthFiles."/config/auth.file.inc.php"); // auth user functions
require_once($cfgPathToAuthFiles."/lib/permission.inc.php"); // auth user functions

// create new userFunctions object
$client = &new userFunctions;

//login check
if ($client->getAuthentication($_SESSION["sessionId"], session_id()) ==  false)
{
    //redirect to login page
    ?>
    <script type="text/javascript">
    <!--
    window.location.href="<?php echo $cfgUrlToProject."/".$fileAuthLogin; ?>";
    -->
    </script>
    <?php
    exit;
}

// userpermission
$fileUserPermissionMode		=	$permUserSurveyDelete;
$filePermissionMode		=	$permSurveyDelete;

// filepermission
if($_SESSION["sessionUserStatusId"] < $filePermissionMode)
{
    ?>
    <script type="text/javascript">
    <!--
    window.location.href="<?php echo $cfgUrlToProject."/".$fileNoPermission."?messageCode=".$filePermissionMode."&messageType=file"; ?>";
    -->
    </script>
    <?php
    exit;
}
// get projectId
$projectId = (isset($_GET["projectId"])) ? $_GET["projectId"] : $_POST["projectId"];

// create new permissionFunctions object
$permission = &new permissionFunctions;

// get Permission
$permissionMode = $permission->getPermissionMode($_SESSION["sessionUserId"], $projectId, 1);
if($permission->errorMessage)
{
    echo $permission->errorMessage;
}
// userpermission
if($permissionMode < $fileUserPermissionMode)
{
    ?>
    <script type="text/javascript">
    <!--
    window.location.href="<?php echo $cfgUrlToProject."/".$fileNoPermission."?messageCode=".$fileUserPermissionMode."&messageType=user"; ?>";
    -->
    </script>
    <?php
    exit;
}

// create new surveyFunctions object
$survey = &new surveyFunctions;
	
// check if form was submitted
if($_SERVER["REQUEST_METHOD"] == "POST")
{
    // delete result tables
    $deleteSurvey = $_POST["deleteSurvey"];
    $deleteSurveyResults = $_POST["deleteResults"];
    $emptySurveyResults = $_POST["emptyResults"];
    
    // nothing to do
    if(($deleteSurvey != "1") and ($deleteSurveyResults != "1") and ($emptySurveyResults != "1"))
    {
        $surveyError .=  $lang_script["survey.delete.php"]["noDeleteSelection"];
    }
    
    // delete Survey
    if($deleteSurvey == "1")
    {
        // get all survey groups
        $surveyGroupArray = $survey->getGroupsForSurvey($projectId);
        if($survey->errorMessage)
        {
            $surveyError .=  $survey->errorMessage;
        }
        for($k=0;$k<count($surveyGroupArray);$k++)
        {
            $groupId = $surveyGroupArray[$k]["FORM_ID_PK"];
            
            // get parent id
            $parentId = $survey->getParent($groupId);
            if($survey->errorMessage)
            {
                $surveyError .=  $survey->errorMessage;
            }
            
            // delete group with all content
            $survey->deleteSurveyGroup($projectId, $parentId, $groupId);
            if($survey->errorMessage)
            {
               $surveyError .=  $survey->errorMessage;
            }
        }
        
        // delete permissions
        $survey->deleteSurveyPermissions(1, $projectId);
        if($survey->errorMessage)
        {
            $surveyError .=  $survey->errorMessage;
        }
        
        // delete css styles
        $survey->deleteSurveyStyles($projectId);
        if($survey->errorMessage)
        {
            $surveyError .=  $survey->errorMessage;
        }
        
        // delete customized errormessages
        $survey->deleteSurveyErrorTable($projectId);
        if($survey->errorMessage)
        {
            $surveyError .=  $survey->errorMessage;
        }
		
        // delete tan tables
        $survey->deleteSurveyTanTables($projectId);
        if($survey->errorMessage)
        {
            $surveyError .=  $survey->errorMessage;
        }
        
        // delete output folder
        $survey->deleteSurveyFolder($_POST["outputDir"]);
        if($survey->errorMessage)
        {
            $surveyError .=  $survey->errorMessage;
        }
        
        // delete survey
        $result	= $survey->deleteSurvey($projectId);
        if($survey->errorMessage)
        {
            $surveyError .=  $survey->errorMessage;
        }
		
		// delete survey
        $result	= $survey->deleteSurveyTemplateTables($projectId);
        if($survey->errorMessage)
        {
            $surveyError .=  $survey->errorMessage;
        }
    }
    
    // empty result tables
    if($emptySurveyResults == "1")
    {
        $survey->emptyResultTables($projectId);
        if($survey->errorMessage)
        {
            $surveyError .=  $survey->errorMessage;
        }
    }
    
    // delete result tables
    if($deleteSurveyResults == "1")
    {
        $survey->deleteResultTables($projectId);
        if($survey->errorMessage)
        {
            $surveyError .=  $survey->errorMessage;
        }
    }
    
    if(!$surveyError)
    {
         	?>
			<script type="text/javascript">
			<!--
			opener.parent.content.location.reload();
			opener.parent.projecttree.location.reload();
			window.close();
			-->
			</script>
		  	<?php
    }
}

// get survey data
$surveyData = $survey->getSurveyForGroup($projectId);

/*
// activecheck
if (($surveyData[0]["PROJECT_ACTIVE"]=="yes") AND (!$_GET["warningChecked"]) AND ($_SERVER["REQUEST_METHOD"] != "POST"))
{
    // create Template IT object
    $tpl = new HTML_Template_IT($cfgPathToSurveyTemplates);
    
    // load template
    $tpl->loadTemplatefile($templateSurveyActiveWarning, true, true);
    
	// set title
	$tpl->setVariable( "applicationtitle", $cfgApplicationType.$cfgApplicationVersion);
	
	$tpl->setVariable( "projectId", "$projectId" );
    $tpl->get();
    $tpl->show();
    exit;
}
*/
// create Template IT object
$tpl = new HTML_Template_IT($cfgPathToSurveyTemplates);

// load template
$tpl->loadTemplatefile($templateSurveyDelete, true, true);

// set title
$tpl->setVariable( "applicationtitle", $cfgApplicationType.$cfgApplicationVersion);

//set the links
$tpl->setVariable( "lnk_settings", $fileSurveyEdit."?projectId=".$projectId."&warningChecked=yes" );
$tpl->setVariable( "lnk_preview", $fileSurveyAdminPreview."?projectId=".$projectId );
$tpl->setVariable( "lnk_clearing", $fileSurveyMake."?projectId=".$projectId );
$tpl->setVariable( "lnk_delete", $fileSurveyDelete."?projectId=".$projectId );

$tpl->setVariable( "formaction", $fileSurveyDelete );
$tpl->setVariable( "errors", $surveyError );

$tpl->setVariable( "surveyname", $surveyData[0]["PROJECT_NAME"] );
$tpl->setVariable( "surveycreatedate", $surveyData[0]["PROJECT_TIMESTAMP"] );

$tpl->setVariable( "projectid",  $projectId);
$tpl->setVariable( "outputdir",  $surveyData[0]["PROJECT_OUTPUTDIR"]);

// parse template
$tpl->parse();

// get the parsed template and print it
$tpl->get();
$tpl->show();
?>
