<?php
// +----------------------------------------------------------------------+
// | survey pilot                                                         |
// +----------------------------------------------------------------------+
// | Copyright (c) 2002 serie a - Digitale Medien und Systeme GmbH        |
// +----------------------------------------------------------------------+
// | Authors: 	Jrn Allert <allert@serie-a.de>                           |
// |          	Rene Renk   <renk@serie-a.de>                             |
// +----------------------------------------------------------------------+
//
// $Id: survey.design.css.copy.php,v 1.1.1.1 2004/07/15 13:31:54 opensurveypilot Exp $

// start session
@session_start();

// require all configuration files and libraries
require_once("./../config/config.inc.php"); // common config file
require_once($cfgPathToConf."/file.inc.php"); // project files
require_once($cfgPathToLib."/common.inc.php"); // common functions
require_once($cfgPathToSurveyFiles."/config/survey.config.inc.php"); // survey confuguration
require_once($cfgPathToSurveyFiles."/config/survey.file.inc.php"); // survey files
require_once($cfgPathToSurveyFiles."/lib/survey.inc.php"); // survey functions
require_once($cfgPathToSurveyFiles."/lib/".$fileSrvyCreateCssStyles); // design css functions
require_once($cfgPathToAuthFiles."/lib/user.inc.php"); // auth functions
require_once($cfgPathToAuthFiles."/config/auth.file.inc.php"); // auth files
require_once($cfgPathToAuthFiles."/lib/permission.inc.php"); // permission functions
require_once("HTML/Template/IT.php"); // PEAR::HTML_TEMPLATE_IT

// create new userFunctions object
$client = &new userFunctions;

//login check
if ($client->getAuthentication($_SESSION["sessionId"], session_id()) ==  false)
{
    //redirect to login page
    ?>
    <script type="text/javascript">
    <!--
    window.location.href="<?php echo $cfgUrlToProject."/".$fileAuthLogin; ?>";
    -->
    </script>
    <?php
    exit;
}

// function permission check
if($_SESSION["sessionUserStatusId"] < $permSurveyDesignCssCopy)
{
    ?>
    <script type="text/javascript">
    <!--
    window.location.href="<?php echo $cfgUrlToProject."/".$fileNoPermission."?messageCode=2"; ?>";
    -->
    </script>
    <?php
    exit;
}

// get projectId
$projectId = (isset($_GET["projectId"])) ? $_GET["projectId"] : $_POST["projectId"];

// create new permissionFunctions object
$permission = &new permissionFunctions;
// get Permission
$permissionMode = $permission->getPermissionMode($_SESSION["sessionUserId"], $projectId, 1);
if($permission->errorMessage)
{
    echo $permission->errorMessage;
}
// permission must be 2 (write)
if($permissionMode < 2)
{
    ?>
    <script type="text/javascript">
    <!--
    window.location.href="<?php echo $cfgUrlToProject."/".$fileNoPermission."?messageCode=1"; ?>";
    -->
    </script>
    <?php
    exit;
}

// check if form was submitted
if($_SERVER["REQUEST_METHOD"] == "POST")
{ 
    $copyFrom = $_POST["surveyToCopy"];
    // create new data
	$cssClass = &new createCSS;
	if($projectId != 0)
	{
		$status = $cssClass->deleteCssDataToDefault($projectId);
	}
	$status = $cssClass->copyCssFromDatabase($projectId,$copyFrom);
	$status = $cssClass->createCssFileFromDatabase($projectId);
	if($status != "error")
	{
		?>
		<script type="text/javascript">
		<!--
		opener.parent.content.location.reload();
		opener.parent.projecttree.location.reload();
		window.location.href="<?php echo $fileSurveyDesignCssEdit."?projectId=".$_POST["projectId"]; ?>";
		-->
		</script>
		<?php
	}
}

// create new surveyunctions object
$survey = new surveyFunctions();

$numRows = $survey->getSurveysNum(0);
$allSurveys = $survey->getSurveys(0,0,$numRows,"PROJECT_ID_PK","ASC");

$tpl = new HTML_Template_IT($cfgPathToSurveyTemplates);
$tpl->loadTemplatefile($templateSurveyDesignCssCopy, true, true);

// set title
$tpl->setVariable( "applicationtitle", $cfgApplicationType.$cfgApplicationVersion);

$tpl->setVariable("lnk_css", $fileSurveyDesignCssEdit."?projectId=".$projectId);
$tpl->setVariable("lnk_tmpl", $fileSurveyDesignTmplEdit."?projectId=".$projectId);
$tpl->setVariable("lnk_rule", $fileSurveyDesignRulesEdit."?projectId=".$projectId);
$tpl->setVariable("lnk_preview", $fileSurveyDesignPreview."?projectId=".$projectId);
$tpl->setVariable("lnk_copy", $fileSurveyDesignCssCopy."?projectId=".$projectId);

$tpl->setVariable("save_css", $fileSurveyDesignCssSave);

for($i=0; $i < count($allSurveys); ++$i)
{
    $tpl->setCurrentBlock("select");
    $tpl->setVariable("sel_survey", $allSurveys[$i]["PROJECT_NAME"]);
    $tpl->setVariable("toCopyId", $allSurveys[$i]["PROJECT_ID_PK"]);
    $tpl->parseCurrentBlock("select");
}

$tpl->setVariable("projectid", $projectId);

$tpl->parse();
$tpl->get();
$tpl->show();
?>
