<?php
// +----------------------------------------------------------------------+
// | survey pilot                                                         |
// +----------------------------------------------------------------------+
// | Copyright (c) 2002 serie a - Digitale Medien und Systeme GmbH        |
// +----------------------------------------------------------------------+
// | Authors: 	Jrn Allert <allert@serie-a.de>                           |
// |          	Rene Renk   <renk@serie-a.de>                             |
// +----------------------------------------------------------------------+
//
// $Id: survey.design.css.edit.php,v 1.1.1.1 2004/07/15 13:31:54 opensurveypilot Exp $

require_once("./lib/survey.question.inc.php"); // survey question create functions

// start session
@session_start();

// delete unfinished questuions in session
unset($_SESSION["newQuestion"]);

// require all configuration files and libraries
require_once("./../config/config.inc.php"); // common config file
require_once($cfgPathToConf."/file.inc.php"); // project files
require_once($cfgPathToLib."/common.inc.php"); // common functions
require_once($cfgPathToSurveyFiles."/config/survey.config.inc.php"); // survey configuration
require_once($cfgPathToSurveyFiles."/config/survey.file.inc.php"); // survey files
require_once($cfgPathToSurveyFiles."/lib/survey.inc.php"); // survey functions
require_once($cfgPathToAuthFiles."/lib/user.inc.php"); // auth functions
require_once($cfgPathToAuthFiles."/config/auth.file.inc.php"); // auth files
require_once($cfgPathToSurveyFiles."/lib/".$fileSrvyCreateCssStyles); // design css functions
require_once($cfgPathToAuthFiles."/lib/permission.inc.php"); // permission functions
require_once("HTML/Template/IT.php"); // PEAR::HTML_TEMPLATE_IT
 
// create new userFunctions object
$client = &new userFunctions;
 
//login check
if ($client->getAuthentication($_SESSION["sessionId"], session_id()) ==  false)
{
    //redirect to login page
    ?>
    <script type="text/javascript">
    <!--
    window.location.href="<?php echo $cfgUrlToProject."/".$fileAuthLogin; ?>";
    -->
    </script>
    <?php
    exit;
}  

// function permission check
if($_SESSION["sessionUserStatusId"] < $permSurveyDesignCssEdit)
{
    ?>
    <script type="text/javascript">
    <!--
    window.location.href="<?php echo $cfgUrlToProject."/".$fileNoPermission."?messageCode=2"; ?>";
    -->
    </script>
    <?php
    exit;
}

// get surveyId id as get variable
if(isset($_GET["projectId"]))
{
    $projectId = $_GET["projectId"];
}
else
{
	$projectId = 0;
}

// create new permissionFunctions object
$permission = &new permissionFunctions;
// get Permission
$permissionMode = $permission->getPermissionMode($_SESSION["sessionUserId"], $projectId, 1);
if($permission->errorMessage)
{
    echo $permission->errorMessage;
}
// permission must be 2 (write)
if($permissionMode < 2)
{
    ?>
    <script type="text/javascript">
    <!--
    window.location.href="<?php echo $cfgUrlToProject."/".$fileNoPermission."?messageCode=1"; ?>";
    -->
    </script>
    <?php
    exit;
}

// create css class
$cssClass = &new createCSS;
// get css data
$cssData = $cssClass->getCssDataFromDatabase($projectId);
if($cssData == "error")
{
	exit;
}

$tpl = new HTML_Template_IT($cfgPathToSurveyTemplates);

$tpl->loadTemplatefile($templateSurveyDesignCssEdit, true, false); // dont remove untouched blocks

// set title
$tpl->setVariable( "applicationtitle", $cfgApplicationType.$cfgApplicationVersion);

$tpl->setVariable("css_save_link", $fileSurveyDesignCssSave);
$tpl->setVariable("css_projectId", $projectId);

$tpl->setVariable("lnk_css", $fileSurveyDesignCssEdit."?projectId=".$projectId);
$tpl->setVariable("lnk_tmpl", $fileSurveyDesignTmplEdit."?projectId=".$projectId);
$tpl->setVariable("lnk_rule", $fileSurveyDesignRulesEdit."?projectId=".$projectId);
$tpl->setVariable("lnk_preview", $fileSurveyDesignPreview."?projectId=".$projectId);
$tpl->setVariable("lnk_copy", $fileSurveyDesignCssCopy."?projectId=".$projectId);

// give selected defaults
foreach($cssData as $key => $value)
{	
	if(($key!="CSSSTYLE_ID_PK")AND($key!="CSSSTYLE_PROJECT_ID"))
	{
		// value for select
		$selectVariable = $key.$value;
		$tpl->setVariable($selectVariable, "selected" );
		// value for input
		$tpl->setVariable($key, "$value");
	}
}

$tpl->parse();
$tpl->show();
?>
