<?php
// +----------------------------------------------------------------------+
// | survey     pilot                                                     |
// +----------------------------------------------------------------------+
// | Copyright (c) 2002 serie a - Digitale Medien und Systeme GmbH        |
// +----------------------------------------------------------------------+
// | Authors: 	Jrn Allert <allert@serie-a.de>                           |
// |          	Rene Renk   <renk@serie-a.de>                             |
// +----------------------------------------------------------------------+
//
// $Id: survey.design.css.save.php,v 1.1.1.1 2004/07/15 13:31:54 opensurveypilot Exp $

require_once("./lib/survey.question.inc.php"); // survey question create functions

// start session
@session_start();

// delete unfinished questuions in session
unset($_SESSION["newQuestion"]);

// require all configuration files and libraries
require_once("./../config/config.inc.php"); // common config file
require_once($cfgPathToConf."/file.inc.php"); // project files
require_once($cfgPathToLib."/common.inc.php"); // common functions
require_once($cfgPathToSurveyFiles."/config/survey.config.inc.php"); // survey configuration
require_once($cfgPathToSurveyFiles."/config/survey.file.inc.php"); // survey files
require_once($cfgPathToSurveyFiles."/lib/survey.inc.php"); // survey functions
require_once($cfgPathToAuthFiles."/lib/user.inc.php"); // auth user functions
require_once($cfgPathToAuthFiles."/config/auth.file.inc.php"); // auth user files
require_once($cfgPathToAuthFiles."/lib/permission.inc.php"); // permission functions
require_once($cfgPathToSurveyFiles."/lib/".$fileSrvyCreateCssStyles); // design css functions
require_once("HTML/Template/IT.php"); // PEAR::HTML_TEMPLATE_IT

// create new userFunctions object
$client = &new userFunctions;

//login check
if ($client->getAuthentication($_SESSION["sessionId"], session_id()) ==  false)
{
    //redirect to login page
    ?>
    <script type="text/javascript">
    <!--
    window.location.href="<?php echo $cfgUrlToProject."/".$fileAuthLogin; ?>";
    -->
    </script>
    <?php
    exit;
}

// function permission check
if($_SESSION["sessionUserStatusId"] < $permSurveyDesignCssSave)
{
    ?>
    <script type="text/javascript">
    <!--
    window.location.href="<?php echo $cfgUrlToProject."/".$fileNoPermission."?messageCode=2"; ?>";
    -->
    </script>
    <?php
    exit;
}

// get projectId
$projectId = (isset($_GET["projectId"])) ? $_GET["projectId"] : $_POST["projectId"];

// create new permissionFunctions object
$permission = &new permissionFunctions;
// get Permission
$permissionMode = $permission->getPermissionMode($_SESSION["sessionUserId"], $projectId, 1);
if($permission->errorMessage)
{
    echo $permission->errorMessage;
}
// permission must be 4 (execute)
if($permissionMode < 4)
{
    ?>
    <script type="text/javascript">
    <!--
    window.location.href="<?php echo $cfgUrlToProject."/".$fileNoPermission."?messageCode=1"; ?>";
    -->
    </script>
    <?php
    exit;
}

// create Template IT object
$tpl = new HTML_Template_IT($cfgPathToSurveyTemplates);

// load template
$tpl->loadTemplatefile($templateCommonSuccessMessage, true, true);

// set title
$tpl->setVariable( "applicationtitle", $cfgApplicationType.$cfgApplicationVersion);

$cssClass = &new createCSS;
// set design css values to default
if($_POST["defaultCheck"]==1)
{
	$cssClass->setCssDataToDefault($_POST["projectId"]);
	$cssClass->createCssFileFromDatabase($_POST["projectId"]);

         	?>
			<script type="text/javascript">
			<!--
			opener.parent.content.location.reload();
			opener.parent.projecttree.location.reload();
			window.location.href="<?php echo $fileSurveyDesignCssEdit."?projectId=".$_POST["projectId"]; ?>";
			-->
			</script>
		  	<?php

}
else {
// put postvalues to array
$formValues = $_POST;
// cicle values for manual-hexa-entries
foreach($formValues as $key => $value)
{
	// skip index if manual-hexa-entry or valuebackup
	if (	(ereg("_MANHEX",$key)) OR (ereg("_BEFORE",$key))	)
	{
		continue;
	}
	// check if different from preselect and valid hexavalue and different from stored value
	if (	($formValues[$key."_MANHEX"] != $value) AND (isset($formValues[$key."_MANHEX"])) AND (ereg("[a-fA-F0-9]{6,6}",$formValues[$key."_MANHEX"])) AND ($formValues[$key."_MANHEX"] != $formValues[$key."_BEFORE"])	)
	{
		$formValues[$key] = $formValues[$key."_MANHEX"];
	}

}
// create update arguments
$myArgumentsToUpdate = array("CSSSTYLE_FONTTYPE" => $formValues["CSSSTYLE_FONTTYPE"],
				"CSSSTYLE_FONTSIZE" => $formValues["CSSSTYLE_FONTSIZE"],
				"CSSSTYLE_FONTCOLOR" => $formValues["CSSSTYLE_FONTCOLOR"],
				"CSSSTYLE_FONTCOLORHEADER" => $formValues["CSSSTYLE_FONTCOLORHEADER"],
				"CSSSTYLE_BGFORM" => $formValues["CSSSTYLE_BGFORM"],
				"CSSSTYLE_BGHEADER" => $formValues["CSSSTYLE_BGHEADER"],
				"CSSSTYLE_BGINPUT" => $formValues["CSSSTYLE_BGINPUT"],
				"CSSSTYLE_HEADERHEIGHT" => $formValues["CSSSTYLE_HEADERHEIGHT"],
				"CSSSTYLE_FIELDWIDTH" => $formValues["CSSSTYLE_FIELDWIDTH"],
				"CSSSTYLE_AREAHEIGHT" => $formValues["CSSSTYLE_AREAHEIGHT"],
				"CSSSTYLE_LINECOLOR" => $formValues["CSSSTYLE_LINECOLOR"]
				);

$cssClass->insertCssDataIntoDatabase($myArgumentsToUpdate,$_POST["projectId"]);
$status = $cssClass->createCssFileFromDatabase($_POST["projectId"]);
}
?>
<script type="text/javascript">
<!--
opener.parent.content.location.reload();
opener.parent.projecttree.location.reload();
window.location.href="<?php echo $fileSurveyDesignCssEdit."?projectId=".$_POST["projectId"]; ?>";
-->
</script>
