<?php
// +----------------------------------------------------------------------+
// | survey pilot                                                         |
// +----------------------------------------------------------------------+
// | Copyright (c) 2002 serie a - Digitale Medien und Systeme GmbH        |
// +----------------------------------------------------------------------+
// | Authors: 	Jrn Allert <allert@serie-a.de>                           |
// |          	Rene Renk   <renk@serie-a.de>                             |
// +----------------------------------------------------------------------+
//
// $Id: survey.design.php,v 1.1.1.1 2004/07/15 13:31:54 opensurveypilot Exp $

// start session
@session_start();

// require all configuration files and libraries
require_once("./../config/config.inc.php"); // common config file
require_once($cfgPathToConf."/file.inc.php"); // project files
require_once($cfgPathToLib."/common.inc.php"); // common functions
require_once($cfgPathToSurveyFiles."/config/survey.config.inc.php"); // survey configuration
require_once($cfgPathToSurveyFiles."/config/survey.file.inc.php"); // survey files
require_once($cfgPathToSurveyFiles."/lib/survey.inc.php"); // survey functions
require_once($cfgPathToAuthFiles."/lib/user.inc.php"); // auth user functions
require_once($cfgPathToAuthFiles."/config/auth.file.inc.php"); // auth user files
require_once("HTML/Template/IT.php"); // PEAR::HTML_TEMPLATE_IT
 
 // create new userFunctions object
 $client = &new userFunctions;
 
 //login check
 if ($client->getAuthentication($_SESSION["sessionId"], session_id()) ==  false)
 {
     //redirect to login page
     ?>
     <script type="text/javascript">
     <!--
     window.location.href="<?php echo $cfgUrlToProject."/".$fileAuthLogin; ?>";
     -->
     </script>
     <?php
     exit;
 }  
 
 // Start of checking the permissions 
$fileUserPermissionMode	=	$permUserSurveyDesign;
$filePermissionMode		=	$permSurveyDesign;

// filepermission
if($_SESSION["sessionUserStatusId"] < $filePermissionMode)
{
    ?>
    <script type="text/javascript">
    <!--
    window.location.href="<?php echo $cfgUrlToProject."/".$fileNoPermission."?messageCode=".$filePermissionMode."&messageType=file"; ?>";
    -->
    </script>
    <?php
    exit;
}
// get projectId
$projectId = (isset($_GET["projectId"])) ? $_GET["projectId"] : $_POST["projectId"];

// create new permissionFunctions object
$permission = &new permissionFunctions;

// get Permission
$permissionMode = $permission->getPermissionMode($_SESSION["sessionUserId"], $projectId, 1);
if($permission->errorMessage)
{
    echo $permission->errorMessage;
}
// userpermission
if($permissionMode < $fileUserPermissionMode)
{
    ?>
    <script type="text/javascript">
    <!--
    window.location.href="<?php echo $cfgUrlToProject."/".$fileNoPermission."?messageCode=".$fileUserPermissionMode."&messageType=user"; ?>";
    -->
    </script>
    <?php
    exit;
}
// End of checking the permissions

 
$surveyOverview = &new surveyFunctions; 

// create Template IT object
$tpl = new HTML_Template_IT($cfgPathToSurveyTemplates);
$templateSurveyDesign = "survey.design.tpl";
// load template
$tpl->loadTemplatefile($templateSurveyDesign, true, true);

// set title
$tpl->setVariable( "applicationtitle", $cfgApplicationType.$cfgApplicationVersion);

// get surveyId id as get variable
if(isset($_GET["projectId"]))
{
    $projectId = $_GET["projectId"];
}
elseif(isset($_GET["projectId"]))
{
    $projectId = $_GET["projectId"];
}
else
{
	$projectId = 0;
}


// get headline
$surveyArray =  $surveyOverview->getSurveys($projectId,0,0,0,0);
if($surveyOverview->errorMessage)
{
    echo $surveyOverview->errorMessage;
}
$tpl->setCurrentBlock( "headline" );
$tpl->setVariable( "headline", $surveyArray[0]["PROJECT_NAME"] );
$tpl->parseCurrentBlock();	

// get design
$tpl->setCurrentBlock( "survey_group_overview" );

// split string at 35 signs
$surveyArray[0]["name"] = substr($surveyArray[0]["PROJECT_NAME"],0,35);
$tpl->setVariable( "name", $surveyArray[0]["PROJECT_NAME"] );

// split string at 35 signs
$surveyArray[0]["PROJECT_DESCRIPTION"] = substr($surveyArray[0]["PROJECT_DESCRIPTION"],0,35);
$tpl->setVariable( "description", $surveyArray[0]["PROJECT_DESCRIPTION"]);

$outputLink = $cfgUrlToOutput."/".$surveyArray[0]["PROJECT_OUTPUTDIR"]."/";
$tpl->setVariable( "preview_link", $outputLink.$fileSurveyPreview."?projectId=".$surveyArray[0]["PROJECT_ID_PK"] );
$tpl->setVariable( "edit_link", $fileSurveyDesignCssEdit."?projectId=".$surveyArray[0]["PROJECT_ID_PK"] );
$tpl->setVariable( "copy_link", $fileSurveyDesignCopy."?projectId=".$surveyArray[0]["PROJECT_ID_PK"] );
$tpl->setVariable( "id", $surveyArray[0]["PROJECT_ID_PK"] );
$tpl->parseCurrentBlock();	

// get the parsed template and print it
$tpl->get();
$tpl->show();
?>


