<?php
// +----------------------------------------------------------------------+
// | survey pilot                                                     |
// +----------------------------------------------------------------------+
// | Copyright (c) 2002 serie a - Digitale Medien und Systeme GmbH        |
// +----------------------------------------------------------------------+
// | Authors: 	Jrn Allert <allert@serie-a.de>                           |
// |          	Rene Renk   <renk@serie-a.de>                             |
// +----------------------------------------------------------------------+
//
// $Id: survey.design.tmpl.edit.php,v 1.1.1.1 2004/07/15 13:31:58 opensurveypilot Exp $

// start session
@session_start();

// require all configuration files and libraries
require_once("./../config/config.inc.php"); // common config file
require_once($cfgPathToConf."/file.inc.php"); // project files
require_once($cfgPathToLib."/common.inc.php"); // common functions
require_once($cfgPathToAuthFiles."/config/auth.file.inc.php"); // auth files
require_once($cfgPathToAuthFiles."/lib/user.inc.php"); // auth user functions
require_once($cfgPathToSurveyFiles."/config/survey.config.inc.php"); // survey config
require_once($cfgPathToSurveyFiles."/config/survey.file.inc.php"); // survey files
require_once($cfgPathToSurveyFiles."/lib/survey.inc.php"); // survey functions
require_once($cfgPathToAuthFiles."/lib/permission.inc.php"); // auth user functions
require_once($cfgPathToSurveyFiles."/lib/design/tmpl2project.inc.php"); // template upload functions
require_once("HTML/Template/IT.php"); // PEAR::HTML_TEMPLATE_IT
 
// create new userFunctions object
$client = &new userFunctions;
 
//login check
if ($client->getAuthentication($_SESSION["sessionId"], session_id()) ==  false)
{
    //redirect to login page
    ?>
    <script type="text/javascript">
    <!--
    window.location.href="<?php echo $cfgUrlToProject."/".$fileAuthLogin; ?>";
    -->
    </script>
    <?php
    exit;
}

// function permission check
if($_SESSION["sessionUserStatusId"] < $permSurveyDesignTmplEdit)
{
    ?>
    <script type="text/javascript">
    <!--
    window.location.href="<?php echo $cfgUrlToProject."/".$fileNoPermission."?messageCode=2"; ?>";
    -->
    </script>
    <?php
    exit;
}

// get projectId
$projectId = (isset($_GET["projectId"])) ? $_GET["projectId"] : $_POST["projectId"];

// create new permissionFunctions object
$permission = &new permissionFunctions;
 
// get Permission
$permissionMode = $permission->getPermissionMode($_SESSION["sessionUserId"], $projectId, 1);
if($permission->errorMessage)
{
    echo $permission->errorMessage;
}
// permission must be 4 (execute)
if($permissionMode < 4 )
{
    ?>
    <script type="text/javascript">
    <!--
    window.location.href="<?php echo $cfgUrlToProject."/".$fileNoPermission."?messageCode=1"; ?>";
    -->
    </script>
    <?php
    exit;
}

// create new surveyFunctions object
$tmplFunct = &new tmplFileCreate;

if($_SERVER["REQUEST_METHOD"] == "POST")
{
	//checkfor projectId
	if(!$projectId = $_POST["projectId"])
	{
		$tmplFunct->setErrorMessage($lang_script["survey.design.tmpl.edit.php"]["paramError"]."<br>".$lang_script["survey.design.tmpl.edit.php"]["checkEntry"]);
	}
	// check action
	$type = $_POST["category"];
	//get/check post variables
	if(!$tmplPath = $_POST["path"])
	{
		$tmplFunct->setErrorMessage($lang_script["survey.design.tmpl.edit.php"]["noTmplPathSelected"]."<br>".$lang_script["survey.design.tmpl.edit.php"]["checkEntry"]);
	}
	elseif(!$type)
	{
		$tmplFunct->setErrorMessage($lang_script["survey.design.tmpl.edit.php"]["paramError"]."<br>".$lang_script["survey.design.tmpl.edit.php"]["checkEntry"]);
	}
	elseif(!$fileId = $_POST["file"])
	{
		$tmplFunct->setErrorMessage($lang_script["survey.design.tmpl.edit.php"]["noFileSelected"]."<br>".$lang_script["survey.design.tmpl.edit.php"]["checkEntry"]);
	}
	// save file
	else
	{
		if($tmplFunct->saveFileforProject($projectId, $type, $tmplPath, $fileId))
		{
         	?>
			<script type="text/javascript">
			<!--
			opener.parent.content.location.reload();
			opener.parent.projecttree.location.reload();
			window.location.href="<?php echo $fileSurveyDesignTmplEdit."?projectId=".$projectId; ?>";
			-->
			</script>
		  	<?php
		}
	}
}


// create javascript array 
$javascriptArray = "var questions = new Array(\n";

$categoryArray = $tmplFunct->getAllTemplatePathes();

//
if(is_array($categoryArray))
{
	$categoryArraySize = count($categoryArray);
	for($i=0;$i<count($categoryArray);$i++)
	{
	    $maxRow = $tmplFunct->getContentNum($categoryArray[$i]["catId"]);
		$contentArray = $tmplFunct->getContentForOverview($categoryArray[$i]["catId"], $actualNum = 0, $maxRow, "CONTENT_NAME", "ASC");
		//
		$javascriptArray .= "new Array(\n";
        //print_r($answerArray );
        $contentArraySize = count($contentArray);
        if(is_array($contentArray))
        {
            for($k=0;$k<count($contentArray);$k++)
            {
                $javascriptArray .= "new Array(\"".addslashes($contentArray[$k]["CONTENT_NAME"])."\", ".$contentArray[$k]["CONTENT_ID_PK"].")";
                if($k+1 < $contentArraySize)
                {
                    $javascriptArray .= ", \n";
                }
            }
            $javascriptArray .= ")\n";
        }
        else
        {
            $javascriptArray .= "null";
			$javascriptArray .= ")";
        }
	    if($i+1 < $categoryArraySize)
	    {
	        $javascriptArray .= ", \n";
	    }
	}
}
else
{
    $javascriptArray .= "null";
}
$javascriptArray .= ")";

// create Template IT object
$tpl = new HTML_Template_IT($cfgPathToSurveyTemplates);

// load template
$tpl->loadTemplatefile($templateSurveyDesignTmplEdit, true, true);

$tpl->setVariable("lnk_css", $fileSurveyDesignCssEdit."?projectId=".$projectId);
$tpl->setVariable("lnk_tmpl", $fileSurveyDesignTmplEdit."?projectId=".$projectId);
$tpl->setVariable("lnk_rule", $fileSurveyDesignRulesEdit."?projectId=".$projectId);
$tpl->setVariable("lnk_preview", $fileSurveyDesignPreview."?projectId=".$projectId);
$tpl->setVariable("lnk_copy", $fileSurveyDesignCssCopy."?projectId=".$projectId);

// set title
$tpl->setVariable( "applicationtitle", $cfgApplicationType.$cfgApplicationVersion);

// check for errors
if($tmplFunct->errorMessage)
{
	$tpl->setCurrentBlock( "error_message" );
	$tpl->setVariable( "errors", $tmplFunct->errorMessage);
	$tpl->parseCurrentBlock();
}
// set template names
$templateNames = $tmplFunct->getTemplateNames($projectId);

$templateNames["TMPL_TO_PRJCT_FORM_ID"] != "" ? ($tpl->setVariable( "formtemplate", $templateNames["TMPL_TO_PRJCT_FORM_ID"])) : "default";
$templateNames["TMPL_TO_PRJCT_LOGIN_ID"] != "" ? ($tpl->setVariable( "logintemplate", $templateNames["TMPL_TO_PRJCT_LOGIN_ID"])) : "default";
$templateNames["TMPL_TO_PRJCT_CONFIRM_ID"] != "" ? ($tpl->setVariable( "confirmtemplate", $templateNames["TMPL_TO_PRJCT_CONFIRM_ID"])) : "default";
$templateNames["TMPL_TO_PRJCT_DEACTIVATED_ID"] != "" ? ($tpl->setVariable( "inactivetemplate", $templateNames["TMPL_TO_PRJCT_DEACTIVATED_ID"])) : "default";

// set javascriptarray
$tpl->setVariable( "questionarray", $javascriptArray);
// set pathes
$categoryArray = $tmplFunct->getAllTemplatePathes();
for($i=0;$i<count($categoryArray);$i++)
{
	$tpl->setCurrentBlock( "categories" );
	$tpl->setVariable( "categoryvalue", $categoryArray[$i]["catPath"] );
	$tpl->setVariable( "categorypath",  $categoryArray[$i]["catPath"] );
	$tpl->parseCurrentBlock();
}

$tpl->setVariable( "projectId", $projectId );

// parse template
$tpl->parse();

// get the parsed template and print it
$tpl->get();
$tpl->show();
?>
