<?php
// +----------------------------------------------------------------------+
// | survey pilot                                                         |
// +----------------------------------------------------------------------+
// | Copyright (c) 2002 serie a - Digitale Medien und Systeme GmbH        |
// +----------------------------------------------------------------------+
// | Authors: 	Jrn Allert <allert@serie-a.de>                           |
// |          	Rene Renk <renk@serie-a.de>                               |
// +----------------------------------------------------------------------+
//
// $Id: survey.detailview.php,v 1.1.1.1 2004/07/15 13:31:58 opensurveypilot Exp $

// start session
@session_start();

// require all configuration files and libraries
require_once("./../config/config.inc.php"); // common config file
require_once($cfgPathToConf."/file.inc.php"); // project files
require_once($cfgPathToLib."/common.inc.php"); // common functions
require_once($cfgPathToAuthFiles."/lib/user.inc.php"); // auth user functions
require_once($cfgPathToSurveyFiles."/config/survey.config.inc.php"); // survey configuration
require_once($cfgPathToSurveyFiles."/config/survey.file.inc.php"); // survey files
require_once($cfgPathToSurveyFiles."/lib/database/dbfunctions.inc.php"); // survey functions
require_once($cfgPathToAuthFiles."/lib/permission.inc.php"); // auth permission functions
require_once("HTML/Template/IT.php"); // PEAR::HTML_TEMPLATE_IT

// create new userFunctions object
$client = &new userFunctions;
 
//login check
if ($client->getAuthentication($_SESSION["sessionId"], session_id()) ==  false)
{
    //redirect to login page
    ?>
    <script type="text/javascript">
    <!--
    window.location.href="<?php echo $cfgUrlToProject."/".$fileAuthLogin; ?>";
    -->
    </script>
    <?php
    exit;
} 

$fileUserPermissionMode	=	$permUserSurveyDetailview;
$filePermissionMode		=	$permSurveyDetailview;

// filepermission
if($_SESSION["sessionUserStatusId"] < $filePermissionMode)
{
    ?>
    <script type="text/javascript">
    <!--
    window.location.href="<?php echo $cfgUrlToProject."/".$fileNoPermission."?messageCode=".$filePermissionMode."&messageType=file"; ?>";
    -->
    </script>
    <?php
    exit;
}
// get projectId
$projectId = (isset($_GET["projectId"])) ? $_GET["projectId"] : $_POST["projectId"];

// create new permissionFunctions object
$permission = &new permissionFunctions;

// get Permission
$permissionMode = $permission->getPermissionMode($_SESSION["sessionUserId"], $projectId, 1);
if($permission->errorMessage)
{
    echo $permission->errorMessage;
}
// userpermission
if($permissionMode < $fileUserPermissionMode)
{
    ?>
    <script type="text/javascript">
    <!--
    window.location.href="<?php echo $cfgUrlToProject."/".$fileNoPermission."?messageCode=".$fileUserPermissionMode."&messageType=user"; ?>";
    -->
    </script>
    <?php
    exit;
}

// init dbFunctions
$dbFunctions = &new dbFunctions;

// get survey data
$surveyData = $dbFunctions->tabToArrayWhithArg($cfgSrvyTabSurvey,array("PROJECT_ID_PK"=>"$projectId"));

// create Template IT object
$tpl = new HTML_Template_IT($cfgPathToSurveyTemplates);

// load template
$tpl->loadTemplatefile($templateSurveyDetailView, true, true);

// set title
$tpl->setVariable( "applicationtitle", $cfgApplicationType.$cfgApplicationVersion);

//set the links
$tpl->setVariable( "lnk_detail", $fileSurveyDetailview."?projectId=".$projectId );
$tpl->setVariable( "lnk_settings", $fileSurveyEdit."?projectId=".$projectId );
$tpl->setVariable( "lnk_preview", $fileSurveyAdminPreview."?projectId=".$projectId );
$tpl->setVariable( "lnk_clearing", $fileSurveyMake."?projectId=".$projectId );
$tpl->setVariable( "lnk_delete", $fileSurveyDelete."?projectId=".$projectId );

$tpl->setVariable( "errors", $userError );

$tpl->setVariable( "surveyname", $surveyData[0]["PROJECT_NAME"] );
$tpl->setVariable( "surveyauthor", $surveyData[0]["PROJECT_AUTHOR"] );
$tpl->setVariable( "surveydescription", $surveyData[0]["PROJECT_DESCRIPTION"] );
$outputLink = $cfgUrlToOutput;
if($surveyData[0]["PROJECT_ACTIVE"] == "yes")
{
	$outputPath  =  $surveyData[0]["PROJECT_OUTPUTDIR"];
	$outputLink .= "/".$surveyData[0]["PROJECT_OUTPUTDIR"]."/";
}
else
{
	$outputPath = $surveyData[0]["PROJECT_OUTPUTDIR"];
	$outputLink .= "/".$surveyData[0]["PROJECT_OUTPUTDIR"]."/deactivated.php";
}
$tpl->setVariable( "outputpath", $outputPath );
$tpl->setVariable( "outputlink", $outputLink );
if($surveyData[0]["PROJECT_ACTIVE"] == "yes")
{
    $surveyActive = "checked";
}
$tpl->setVariable( "activechecked", $surveyActive );

if($surveyExpirationDate == "")
{
	$tpl->setVariable( "surveyexpirationdate" , $lang_script["survey.detailview.php"]["noExpirationDate"]);
}
else
{
	$tpl->setVariable( "surveyexpirationdate" , $surveyExpirationDate );
}
$enddateArray 		= explode("-",$surveyData[0]["PROJECT_TIMESTAMP"]);
$enddateArray[2]	= strtok($enddateArray[2]," ");
$tpl->setVariable( "getinsertdate", $enddateArray[2]."-".$enddateArray[1]."-".$enddateArray[0] );


// parse template
$tpl->parse();

// get the parsed template and print it
$tpl->get();
$tpl->show();
?>
