<?php
// +----------------------------------------------------------------------+
// | survey pilot                                                         |
// +----------------------------------------------------------------------+
// | Copyright (c) 2002 serie a - Digitale Medien und Systeme GmbH        |
// +----------------------------------------------------------------------+
// | Authors: 	Jrn Allert <allert@serie-a.de>                           |
// |          	Rene Renk   <renk@serie-a.de>                             |
// +----------------------------------------------------------------------+
//
// $Id: survey.edit.php,v 1.1.1.1 2004/07/15 13:31:58 opensurveypilot Exp $

// start session
@session_start();

// require all configuration files and libraries
require_once("./../config/config.inc.php"); // common config file
require_once("Validate.php"); // PEAR::Validate
require_once($cfgPathToConf."/file.inc.php"); // project files
require_once($cfgPathToLib."/common.inc.php"); // common functions
require_once($cfgPathToSurveyFiles."/config/survey.config.inc.php"); // survey configuration
require_once($cfgPathToSurveyFiles."/config/survey.file.inc.php"); // survey files
require_once($cfgPathToSurveyFiles."/lib/survey.inc.php"); // survey functions
require_once($cfgPathToAuthFiles."/lib/user.inc.php"); // auth user functions
require_once($cfgPathToAuthFiles."/config/auth.file.inc.php"); // auth user files
require_once($cfgPathToAuthFiles."/lib/permission.inc.php"); // auth permission functions
require_once("HTML/Template/IT.php"); // PEAR::HTML_TEMPLATE_IT

// create new userFunctions object
$client = &new userFunctions;

//login check
if ($client->getAuthentication($_SESSION["sessionId"], session_id()) ==  false)
{
    //redirect to login page
    ?>
    <script type="text/javascript">
    <!--
    window.location.href="<?php echo $cfgUrlToProject."/".$fileAuthLogin; ?>";
    -->
    </script>
    <?php
    exit;
}

// Start of checking the permissions 
$fileUserPermissionMode	=	$permUserSurveyEdit;
$filePermissionMode		=	$permSurveyEdit;

// filepermission
if($_SESSION["sessionUserStatusId"] < $filePermissionMode)
{
    ?>
    <script type="text/javascript">
    <!--
    window.location.href="<?php echo $cfgUrlToProject."/".$fileNoPermission."?messageCode=".$filePermissionMode."&messageType=file"; ?>";
    -->
    </script>
    <?php
    exit;
}
// get projectId
$projectId = (isset($_GET["projectId"])) ? $_GET["projectId"] : $_POST["projectId"];

// create new permissionFunctions object
$permission = &new permissionFunctions;

// get Permission
$permissionMode = $permission->getPermissionMode($_SESSION["sessionUserId"], $projectId, 1);
if($permission->errorMessage)
{
    echo $permission->errorMessage;
}
// userpermission
if($permissionMode < $fileUserPermissionMode)
{
    ?>
    <script type="text/javascript">
    <!--
    window.location.href="<?php echo $cfgUrlToProject."/".$fileNoPermission."?messageCode=".$fileUserPermissionMode."&messageType=user"; ?>";
    -->
    </script>
    <?php
    exit;
}
// End of checking the permissions


// create new userFunctions object
$survey = &new surveyFunctions;
		
// check if form was submitted
if($_SERVER["REQUEST_METHOD"] == "POST")
{
    $surveyName = cleanHtml($_POST["surveyName"]);
    if($surveyName != "")
    {
        // check format
        if(!validate::string($surveyName, VAL_DENAME, 1, 50))
        {
            $errors["surveyName"] = $lang_script["survey.edit.php"]["surveyNameUnvalidChars1"]." ".$surveyName." ".$lang_script["survey.edit.php"]["surveyNameUnvalidChars2"];
        }
    }
    else
    {
        $errors["surveyName"] = $lang_script["survey.edit.php"]["surveyNameFillIn"];
    }
	
	$surveyDescription = cleanHtml($_POST["surveyDescription"]);
    if($surveyDescription != "")
    {
        // check format
        if(!validate::string($surveyDescription, VAL_DENAME_PUNCTUATION, 1, 500))
        {
            $errors["surveyDescription"] = $lang_script["survey.edit.php"]["surveyDescriptionLength1"]." ".$surveyDescription." ".$lang_script["survey.edit.php"]["surveyDescriptionLength2"];
        }
    }
    else
    {
        $errors["surveyDescription"] = $lang_script["survey.edit.php"]["surveyDescriptionFillIn"];
    }
    
    $surveyActive = $_POST["surveyActive"];
    if($surveyActive == "1")
    {
        $surveyActiveChecked = "checked";
    }
	
	$surveyOutputDir = cleanHtml($_POST["surveyOutputDir"]);
    if($surveyOutputDir != "")
    {
        // check format
        if(!validate::string($surveyOutputDir, VAL_ALPHA_NUM_, 1, 50))
        {
            $errors["surveyOutputDir"] = $lang_script["survey.edit.php"]["surveyOutputDirUnvalidChars"];
        }
    }
    else
    {
        $errors["surveyOutputDir"] = $lang_script["survey.edit.php"]["surveyOutputDirFillIn"];
    }
    
    $surveyStartDateYear = $_POST["surveyStartDateYear"];
    $surveyStartDateMonth = $_POST["surveyStartDateMonth"];
    $surveyStartDateDay = $_POST["surveyStartDateDay"];
    if($surveyStartDateYear !=  "" and $surveyStartDateMonth !=  "" and $surveyStartDateDay != "")
    {
        // validate date
        if(!validate::date($surveyStartDateDay.$surveyStartDateMonth.$surveyStartDateYear,'%d%m%Y'))
        {
            $errors["surveyStartDate"] = $lang_script["survey.edit.php"]["surveyStartDateInvalid"];
        }
        else
        {
            $surveyStartDate = $surveyStartDateYear."-".$surveyStartDateMonth."-".$surveyStartDateDay;
        }
    }
    
    $surveyEndDateYear = $_POST["surveyEndDateYear"];
    $surveyEndDateMonth = $_POST["surveyEndDateMonth"];
    $surveyEndDateDay = $_POST["surveyEndDateDay"];
    if($surveyEndDateYear !=  "" and $surveyEndDateMonth !=  "" and $surveyEndDateDay != "")
    {
        // validate date
        if(!Validate::date($surveyEndDateDay.$surveyEndDateMonth.$surveyEndDateYear,'%d%m%Y'))
        {
            $errors["surveyEndDate"] = $lang_script["survey.edit.php"]["surveyEndDateInvalid"];
        }
        else
        {
            $surveyEndDate = $surveyEndDateYear."-".$surveyEndDateMonth."-".$surveyEndDateDay;
        }
    }
    
    // put error Array in String
    if($errors)
    {
        foreach($errors as $error)
        {
            $surveyError .= "$error<br>";
            
            // create Template IT object
            $tpl = new HTML_Template_IT($cfgPathToSurveyTemplates);
            
            // load template
            $tpl->loadTemplatefile($templateSurveyEdit, true, true);
            
			// set title
			$tpl->setVariable( "applicationtitle", $cfgApplicationType.$cfgApplicationVersion);

            $tpl->setVariable( "formaction", $fileSurveyEdit );
            
            $tpl->setVariable( "errors", $surveyError );
            
            $tpl->setVariable( "surveyname", $surveyName );
            $tpl->setVariable( "surveyauthor", $surveyData[0]["PROJECT_AUTHOR"] );
            $tpl->setVariable( "surveydescription", $surveyDescription );
            $tpl->setVariable( "surveyoutputpath", $surveyOutputDir );
            
            // put startdate in array
            $startdateArray = explode("-",$surveyStartDate);
            
            // select right startday
            for($i=1;$i<32;$i++)
            {
                if($startdateArray[2] == $i)
                {
                    $startdate = "startdateday".$i;
                    $tpl->setVariable( "startdateday".$i, "selected" );
                }
            }
            // select right startmonth
            for($j=1;$j<13;$j++)
            {
                if($startdateArray[1] == $j)
                {
                    $tpl->setVariable( "startdatemonth".$j, "selected" );
                }
            }
            // select right startyear
            for($k=2;$k<5;$k++)
            {
                if($startdateArray[0] == "200".$k)
                {
                    $tpl->setVariable( "startdateyear".$k, "selected" );
                }
            }
            
            // put enddate in array
            $enddateArray = explode("-",$surveyEndDate);
            
            // select right endday
            for($i=1;$i<32;$i++)
            {
                if($enddateArray[2] == $i)
                {
                    $tpl->setVariable( "enddateday".$i, "selected" );
                }
            }
            // select right endmonth
            for($j=1;$j<13;$j++)
            {
                if($enddateArray[1] == $j)
                {
                    $tpl->setVariable( "enddatemonth".$j, "selected" );
                }
            }
            // select right endyear
            for($k=2;$k<5;$k++)
            {
                if($enddateArray[0] == "200".$k)
                {
                    $tpl->setVariable( "enddateyear".$k, "selected" );
                }
            }
            
            $tpl->setVariable( "surveyid",  $projectId);
            
            // parse template
            $tpl->parse();
            
            // get the parsed template and print it
            $tpl->get();
            $tpl->show();
        }
    }
    // no errors, so we can insert new user    
    else
    {
	
        $surveyArray["surveyId"]     		= $projectId;
	$surveyArray["surveyName"] 		= $surveyName;
        $surveyArray["surveyDescription"] 	= $surveyDescription;
	$surveyArray["surveyOutputDir"] 	= $surveyOutputDir;
        $surveyArray["surveyStartDate"] 	= $surveyStartDate;
	$surveyArray["surveyEndDate"] 		= $surveyEndDate;
		
        $result	=	$survey->editSurvey($surveyArray);
        if($survey->errorMessage)
        {
            $surveyError .=  $survey->errorMessage;
            
            // create Template IT object
            $tpl = new HTML_Template_IT($cfgPathToSurveyTemplates);
            
            // load template
            $tpl->loadTemplatefile($templateSurveyEdit, true, true);
            
			// set title
			$tpl->setVariable( "applicationtitle", $cfgApplicationType.$cfgApplicationVersion);

            $tpl->setVariable( "formaction", $fileSurveyEdit );
            
            $tpl->setVariable( "errors", $surveyError );
            
            $tpl->setVariable( "surveyname", $surveyName );
            $tpl->setVariable( "surveyauthor", $surveyData[0]["PROJECT_AUTHOR"] );
            $tpl->setVariable( "surveydescription", $surveyDescription );
            $tpl->setVariable( "surveyoutputpath", $surveyOutputDir );
            
            // put startdate in array
            $startdateArray = explode("-",$surveyStartDate);
            
            // select right startday
            for($i=1;$i<32;$i++)
            {
                if($startdateArray[2] == $i)
                {
                    $startdate = "startdateday".$i;
                    $tpl->setVariable( "startdateday".$i, "selected" );
                }
            }
            // select right startmonth
            for($j=1;$j<13;$j++)
            {
                if($startdateArray[1] == $j)
                {
                    $tpl->setVariable( "startdatemonth".$j, "selected" );
                }
            }
            // select right startyear
            for($k=2;$k<5;$k++)
            {
                if($startdateArray[0] == "200".$k)
                {
                    $tpl->setVariable( "startdateyear".$k, "selected" );
                }
            }
            
            // put enddate in array
            $enddateArray = explode("-",$surveyEndDate);
            
            // select right endday
            for($i=1;$i<32;$i++)
            {
                if($enddateArray[2] == $i)
                {
                    $tpl->setVariable( "enddateday".$i, "selected" );
                }
            }
            // select right endmonth
            for($j=1;$j<13;$j++)
            {
                if($enddateArray[1] == $j)
                {
                    $tpl->setVariable( "enddatemonth".$j, "selected" );
                }
            }
            // select right endyear
            for($k=2;$k<5;$k++)
            {
                if($enddateArray[0] == "200".$k)
                {
                    $tpl->setVariable( "enddateyear".$k, "selected" );
                }
            }
            
            $tpl->setVariable( "surveyid",  $projectId);
            
            // parse template
            $tpl->parse();
            
            // get the parsed template and print it
            $tpl->get();
            $tpl->show();
        }
        // redirect to success page
        else
        {
         	?>
			<script type="text/javascript">
			<!--
			opener.parent.content.location.reload();
			opener.parent.projecttree.location.reload();
			window.location.href="<?php echo $fileSurveyEdit."?projectId=".$projectId."&warningChecked=yes"; ?>";
			-->
			</script>
		  	<?php

        }
    }
}
else
{
	// get survey data
	$surveyData = $survey->getSurveyForGroup($projectId);
    
	// activecheck
	if (($surveyData[0]["PROJECT_ACTIVE"]=="yes")AND(!$_GET["warningChecked"]))
	{
	    // create Template IT object
	    $tpl = new HTML_Template_IT($cfgPathToSurveyTemplates);
	    
	    // load template
	    $tpl->loadTemplatefile($templateSurveyActiveWarning, true, true);
		
		// set title
		$tpl->setVariable( "applicationtitle", $cfgApplicationType.$cfgApplicationVersion);

		$tpl->setVariable( "projectId", "$projectId" );
	    $tpl->get();
	    $tpl->show();
		exit;
	}
	
    // create Template IT object
    $tpl = new HTML_Template_IT($cfgPathToSurveyTemplates);
    
    // load template
    $tpl->loadTemplatefile($templateSurveyEdit, true, true);
	
	//set the links
	$tpl->setVariable( "lnk_settings", $fileSurveyEdit."?projectId=".$projectId."&warningChecked=yes" );
	$tpl->setVariable( "lnk_preview", $fileSurveyAdminPreview."?projectId=".$projectId );
	$tpl->setVariable( "lnk_clearing", $fileSurveyMake."?projectId=".$projectId );
	$tpl->setVariable( "lnk_delete", $fileSurveyDelete."?projectId=".$projectId );
	
	// set title
	$tpl->setVariable( "applicationtitle", $cfgApplicationType.$cfgApplicationVersion);
    
    $tpl->setVariable( "formaction", $fileSurveyEdit."?projectId=".$projectId );
    
    $tpl->setVariable( "errors", $surveyError );
    
    $tpl->setVariable( "surveyname", $surveyData[0]["PROJECT_NAME"] );
    $tpl->setVariable( "surveyauthor", $surveyData[0]["PROJECT_AUTHOR"] );
    $tpl->setVariable( "surveydescription", $surveyData[0]["PROJECT_DESCRIPTION"] );
    $tpl->setVariable( "surveyoutputpath", $surveyData[0]["PROJECT_OUTPUTDIR"] );
	
	$outputLink = $cfgUrlToOutput;
if($surveyData[0]["PROJECT_ACTIVE"] == "yes")
{
	$outputPath  =  $surveyData[0]["PROJECT_OUTPUTDIR"];
	$outputLink .= "/".$surveyData[0]["PROJECT_OUTPUTDIR"]."/";
}
else
{
	$outputPath = $surveyData[0]["PROJECT_OUTPUTDIR"];
	$outputLink .= "/".$surveyData[0]["PROJECT_OUTPUTDIR"]."/deactivated.php";
}
$tpl->setVariable( "outputpath", $outputPath );
$tpl->setVariable( "outputlink", $outputLink );
if($surveyData[0]["PROJECT_ACTIVE"] == "yes")
{
	$surveyActive = '<span style="color:red;font-weight:bold;">'.$lang_script["survey.edit.php"]["enabled"].'</span>';
}
else
{
	$surveyActive = '<span style="color:blue;font-weight:bold;">'.$lang_script["survey.edit.php"]["disabled"].'</span>';
}
$tpl->setVariable( "activechecked", $surveyActive );

if($surveyExpirationDate == "")
{
	$tpl->setVariable( "surveyexpirationdate" , $lang_script["survey.edit.php"]["noExpirationDate"]);
}
else
{
	$tpl->setVariable( "surveyexpirationdate" , $surveyExpirationDate );
}
$enddateArray 		= explode("-",$surveyData[0]["PROJECT_TIMESTAMP"]);
$enddateArray[2]	= strtok($enddateArray[2]," ");
$tpl->setVariable( "getinsertdate", $enddateArray[2]."-".$enddateArray[1]."-".$enddateArray[0] );
	
    
    // put startdate in array
    $startdateArray = explode("-",$surveyData[0]["PROJECT_STARTDATE"]);
    
    // select right startday
    for($i=1;$i<32;$i++)
    {
        if($startdateArray[2] == $i)
        {
            $startdate = "startdateday".$i;
            $tpl->setVariable( "startdateday".$i, "selected" );
        }
    }
    // select right startmonth
    for($j=1;$j<13;$j++)
    {
        if($startdateArray[1] == $j)
        {
            $tpl->setVariable( "startdatemonth".$j, "selected" );
        }
    }
    // select right startyear
    for($k=2;$k<5;$k++)
    {
        if($startdateArray[0] == "200".$k)
        {
            $tpl->setVariable( "startdateyear".$k, "selected" );
        }
    }
    
    // put enddate in array
    $enddateArray = explode("-",$surveyData[0]["PROJECT_ENDDATE"]);
    
    // select right endday
    for($i=1;$i<32;$i++)
    {
        if($enddateArray[2] == $i)
        {
            $tpl->setVariable( "enddateday".$i, "selected" );
        }
    }
    // select right endmonth
    for($j=1;$j<13;$j++)
    {
        if($enddateArray[1] == $j)
        {
            $tpl->setVariable( "enddatemonth".$j, "selected" );
        }
    }
    // select right endyear
    for($k=2;$k<5;$k++)
    {
        if($enddateArray[0] == "200".$k)
        {
            $tpl->setVariable( "enddateyear".$k, "selected" );
        }
    }
    
    $tpl->setVariable( "surveyid",  $projectId);
    
    // parse template
    $tpl->parse();
    
    // get the parsed template and print it
    $tpl->get();
    $tpl->show();
}
?>
