<?php
// +----------------------------------------------------------------------+
// | surveyt pilot                                                        |
// +----------------------------------------------------------------------+
// | Copyright (c) 2002 serie a - Digitale Medien und Systeme GmbH        |
// +----------------------------------------------------------------------+
// | Authors: 	Jrn Allert <allert@serie-a.de>                           |
// |          	Rene Renk   <renk@serie-a.de>                             |
// +----------------------------------------------------------------------+
//
// $Id: survey.group.add.php,v 1.1.1.1 2004/07/15 13:31:59 opensurveypilot Exp $

// start session
@session_start();

// require all configuration files and libraries
require_once("./../config/config.inc.php"); // common config file
require_once ("Validate.php"); // PEAR::Validate
require_once($cfgPathToConf."/file.inc.php"); // project files
require_once($cfgPathToLib."/common.inc.php"); // common functions
require_once($cfgPathToSurveyFiles."/config/survey.config.inc.php"); // survey configuration
require_once($cfgPathToSurveyFiles."/config/survey.file.inc.php"); // survey files
require_once($cfgPathToSurveyFiles."/lib/survey.inc.php"); // survey functions
require_once($cfgPathToAuthFiles."/lib/user.inc.php"); // auth functions
require_once($cfgPathToAuthFiles."/config/auth.file.inc.php"); // auth files
require_once($cfgPathToAuthFiles."/lib/permission.inc.php"); // permission functions
require_once("HTML/Template/IT.php"); // PEAR::HTML_TEMPLATE_IT

// create new userFunctions object
$client = &new userFunctions;

//login check
if ($client->getAuthentication($_SESSION["sessionId"], session_id()) ==  false)
{
    //redirect to login page
    ?>
    <script type="text/javascript">
    <!--
    window.location.href="<?php echo $cfgUrlToProject."/".$fileAuthLogin; ?>";
    -->
    </script>
    <?php
    exit;
}

// function permission check
if($_SESSION["sessionUserStatusId"] < $permSurveyGroupAdd)
{
    ?>
    <script type="text/javascript">
    <!--
    window.location.href="<?php echo $cfgUrlToProject."/".$fileNoPermission."?messageCode=2"; ?>";
    -->
    </script>
    <?php
    exit;
}
 
// get projectId
$projectId = (isset($_GET["selectedProjectId"])) ? $_GET["selectedProjectId"] : $_POST["projectId"];

// create new permissionFunctions object
$permission = &new permissionFunctions;
// get Permission
$permissionMode = $permission->getPermissionMode($_SESSION["sessionUserId"], $projectId, 1);
if($permission->errorMessage)
{
    echo $permission->errorMessage;
}
// permission must be 2 (write)
if($permissionMode < 2)
{
     ?>
     <script type="text/javascript">
     <!--
     window.location.href="<?php echo $cfgUrlToProject."/".$fileNoPermission."?messageCode=1"; ?>";
     -->
     </script>
     <?php
     exit;
}

// create new surveyFunctions object
$survey = &new surveyFunctions;
        
// check if form was submitted
if($_SERVER["REQUEST_METHOD"] == "POST")
{
    // get group id
    $groupId = $_POST["groupId"];
    
    // get and check surveyname
    $surveyGroupName = cleanHtml($_POST["surveyGroupName"]);
    if($surveyGroupName == "")
    {
        $errors["surveyGroupName"] = $lang_script["survey.group.add.php"]["surveyGroupNameFillIn"];
    }
    else
    {
        // check format
        if(!validate::string($surveyGroupName, VAL_DENAME_PUNCTUATION, 1, 50))
        {
            $errors["surveyGroupName"] = $lang_script["survey.group.add.php"]["surveyGroupNameUnvalidChars"];
        }
    }
	
	$surveyGroupText = $_POST["surveyGroupText"];
    
    // put error Array in String
    if($errors)
    {
        foreach($errors as $error)
        {
            $surveyGroupError .= "$error<br>";
        }
    }
    // no errors, so we can insert new user    
    else
    {
        $surveyAddGroupArray["projectId"] 		= $projectId;
        $surveyAddGroupArray["groupId"] 		= $groupId;
        $surveyAddGroupArray["surveyGroupName"] 	= $surveyGroupName;
        $surveyAddGroupArray["surveyGroupText"] 	= $surveyGroupText;
	$result	=	$survey->addSurveyGroup($surveyAddGroupArray);
        // check for add group error
        if($survey->errorMessage)
        {
            $surveyGroupError =  $survey->errorMessage;
        }
        // redirect to success page
        else
        {
          ?>
		  <html><body>
	      <script type="text/javascript">
		  <!--
          window.location.href="<?php echo $cfgUrlToProject."/".$fileCommonSuccessMessage; ?>";
          -->
          </script>
		  <?php
		  exit;
        }
    }
}

// get group id
$groupId = $_GET["oneGroupSelectedGid"];

// get survey data
$surveyData = $survey->getSurveyForGroup($projectId);

// activecheck
if (($surveyData[0]["PROJECT_ACTIVE"]=="yes")AND(!$_GET["warningChecked"]))
{
	// create Template IT object
	$tpl = new HTML_Template_IT($cfgPathToSurveyTemplates);
	
	// load template
	$tpl->loadTemplatefile($templateSurveyActiveWarning, true, true);
	
	// set title
	$tpl->setVariable( "applicationtitle", $cfgApplicationType.$cfgApplicationVersion);

    $tpl->setVariable( "projectId", $projectId );
    $tpl->setVariable( "groupId", $groupId );
	$tpl->get();
	$tpl->show();
	exit;
}

// create Template IT object
$tpl = new HTML_Template_IT($cfgPathToSurveyTemplates);

// load template
$tpl->loadTemplatefile($templateSurveyGroupAdd, true, true);

// set title
$tpl->setVariable( "applicationtitle", $cfgApplicationType.$cfgApplicationVersion);

$tpl->setVariable( "formaction", $fileSurveyGroupAdd."?warningChecked=1" );
$tpl->setVariable( "errors", $surveyGroupError );

$tpl->setVariable( "projectId", $projectId );
$tpl->setVariable( "groupId", $groupId );
$tpl->setVariable( "surveygroupname", $surveyGroupName );
$tpl->setVariable( "surveygrouptext", $surveyGroupText );

// parse template
$tpl->parse();

// get the parsed template and print it
$tpl->get();
$tpl->show();
?>
