<?php
// +----------------------------------------------------------------------+
// | survey pilot                                                         |
// +----------------------------------------------------------------------+
// | Copyright (c) 2002 serie a - Digitale Medien und Systeme GmbH        |
// +----------------------------------------------------------------------+
// | Authors: 	Jrn Allert <allert@serie-a.de>                           |
// |          	Rene Renk   <renk@serie-a.de>                             |
// +----------------------------------------------------------------------+
//
// $Id: survey.group.detailview.php,v 1.1.1.1 2004/07/15 13:31:59 opensurveypilot Exp $

// start session
@session_start();

// require all configuration files and libraries
require_once("./../config/config.inc.php"); // common config file
require_once($cfgPathToConf."/file.inc.php"); // project files
require_once($cfgPathToLib."/common.inc.php"); // common functions
require_once($cfgPathToSurveyFiles."/config/survey.config.inc.php"); // survey configuration
require_once($cfgPathToSurveyFiles."/config/survey.file.inc.php"); // survey files
require_once($cfgPathToSurveyFiles."/lib/survey.inc.php"); // survey functions
require_once($cfgPathToAuthFiles."/lib/user.inc.php"); // auth functions
require_once($cfgPathToAuthFiles."/config/auth.file.inc.php"); // auth file functions
require_once($cfgPathToAuthFiles."/lib/permission.inc.php"); // permission functions
require_once("HTML/Template/IT.php"); // PEAR::HTML_TEMPLATE_IT
 
// create new userFunctions object
$client = &new userFunctions;
 
//login check
if ($client->getAuthentication($_SESSION["sessionId"], session_id()) ==  false)
{
    //redirect to login page
    ?>
    <script type="text/javascript">
    <!--
    window.location.href="<?php echo $cfgUrlToProject."/".$fileAuthLogin; ?>";
    -->
    </script>
    <?php
    exit;
}

$orderNum  = $_GET["orderNum"];
$preview  = $_GET["preview"];

// Start of checking the permissions 
$fileUserPermissionMode	=	$permUserSurveyGroupDetailView;
$filePermissionMode		=	$permSurveyGroupDetailView;

// filepermission
if($_SESSION["sessionUserStatusId"] < $filePermissionMode)
{
    ?>
    <script type="text/javascript">
    <!--
    window.location.href="<?php echo $cfgUrlToProject."/".$fileNoPermission."?messageCode=".$filePermissionMode."&messageType=file"; ?>";
    -->
    </script>
    <?php
    exit;
}
// get projectId
$projectId = (isset($_GET["projectId"])) ? $_GET["projectId"] : $_POST["projectId"];

// create new permissionFunctions object
$permission = &new permissionFunctions;

// get Permission
$permissionMode = $permission->getPermissionMode($_SESSION["sessionUserId"], $projectId, 1);
if($permission->errorMessage)
{
    echo $permission->errorMessage;
}
// userpermission
if($permissionMode < $fileUserPermissionMode)
{
    ?>
    <script type="text/javascript">
    <!--
    window.location.href="<?php echo $cfgUrlToProject."/".$fileNoPermission."?messageCode=".$fileUserPermissionMode."&messageType=user"; ?>";
    -->
    </script>
    <?php
    exit;
}
// End of checking the permissions

$surveyGroupDetailview = &new surveyFunctions; 

// get groupId id as get variable
$groupId = $_GET["groupId"];
$orderNum = $_GET["orderNum"];

// get survey data
$surveyData = $surveyGroupDetailview->getSurveyForGroup($projectId);

// activecheck
if (($surveyData[0]["PROJECT_ACTIVE"]=="yes")AND(!$_GET["warningChecked"]))
{
	// create Template IT object
	$tpl = new HTML_Template_IT($cfgPathToSurveyTemplates);
	
	// load template
	$tpl->loadTemplatefile($templateSurveyActiveWarning, true, true);
	
	// set title
	$tpl->setVariable( "applicationtitle", $cfgApplicationType.$cfgApplicationVersion);

    $tpl->setVariable( "projectId", $projectId );
    $tpl->setVariable( "groupId", $groupId );
	$tpl->setVariable( "orderNum", $orderNum );
	$tpl->setVariable( "preview", $preview );
	$tpl->get();
	$tpl->show();
	exit;
}

// create Template IT object
$tpl = new HTML_Template_IT($cfgPathToSurveyTemplates);

// load template
$tpl->loadTemplatefile($templateSurveyGroupDetailview, true, true);

// set title
$tpl->setVariable( "applicationtitle", $cfgApplicationType.$cfgApplicationVersion);

// fetch groupdata
$surveyGroupDetailviewArray = $surveyGroupDetailview->getSurveyGroup($groupId);

if($surveyGroupDetailview->errorMessage)
{
    $surveyError .= $surveyGroupDetailview->$errorMessage;
}

for($j=0;$j<count($surveyGroupDetailviewArray);$j++)
{
	$getQuestionsForGroup	=	$surveyGroupDetailview->getQuestionsInGroup($surveyGroupDetailviewArray[$j]["FORM_ID_PK"]);
	
	$tpl->setVariable( "surveygroupname", $surveyGroupDetailviewArray[$j]["FORM_NAME"] );
	$tpl->setVariable( "surveygrouptext", $surveyGroupDetailviewArray[$j]["FORM_HEADER"] );
	$tpl->setVariable( "surveygroupquestions", $getQuestionsForGroup );
	$tpl->setVariable( "surveygroupposition", $orderNum );
}

$tpl->setVariable( "errors", $surveyError );

$tpl->setVariable( "lnk_detail", $fileSurveyGroupDetailview."?projectId=$projectId&groupId=".$groupId."&orderNum=".$orderNum."&preview=".$preview );
$tpl->setVariable( "lnk_preview", $fileSurveyGroupPreview."?projectId=$projectId&groupId=".$groupId."&orderNum=".$orderNum."&preview=".$preview );
$tpl->setVariable( "lnk_edit", $fileSurveyGroupEdit."?projectId=$projectId&groupId=".$groupId."&orderNum=".$orderNum."&preview=".$preview );
$tpl->setVariable( "lnk_pos", $fileSurveyGroupOrder."?projectId=$projectId&groupId=".$groupId."&orderNum=".$orderNum."&preview=".$preview );
$tpl->setVariable( "lnk_delete", $fileSurveyGroupDelete."?projectId=$projectId&groupId=".$groupId."&orderNum=".$orderNum."&preview=".$preview );


// parse template
$tpl->parse();

// get the parsed template and print it
$tpl->get();
$tpl->show();
?>