<?php
// +----------------------------------------------------------------------+
// | survey pilot                                                         |
// +----------------------------------------------------------------------+
// | Copyright (c) 2002 serie a - Digitale Medien und Systeme GmbH        |
// +----------------------------------------------------------------------+
// | Authors: 	Jrn Allert <allert@serie-a.de>                           |
// |          	Rene Renk   <renk@serie-a.de>                             |
// +----------------------------------------------------------------------+
//
// $Id: survey.group.edit.php,v 1.1.1.1 2004/07/15 13:31:59 opensurveypilot Exp $

// start session
@session_start();

// require all configuration files and libraries
require_once("./../config/config.inc.php"); // common config file
require_once ("Validate.php"); // PEAR::Validate
require_once($cfgPathToConf."/file.inc.php"); // project files
require_once($cfgPathToLib."/common.inc.php"); // common functions
require_once($cfgPathToSurveyFiles."/config/survey.config.inc.php"); // survey configuration
require_once($cfgPathToSurveyFiles."/config/survey.file.inc.php"); // survey files
require_once($cfgPathToSurveyFiles."/lib/survey.inc.php"); // survey functions
require_once($cfgPathToAuthFiles."/lib/user.inc.php"); // auth functions
require_once($cfgPathToAuthFiles."/config/auth.file.inc.php"); // auth files
require_once($cfgPathToAuthFiles."/lib/permission.inc.php"); // permission functions
require_once("HTML/Template/IT.php"); // PEAR::HTML_TEMPLATE_IT

// create new userFunctions object
$client = &new userFunctions;

//login check
if ($client->getAuthentication($_SESSION["sessionId"], session_id()) ==  false)
{
    //redirect to login page
    ?>
    <script type="text/javascript">
    <!--
    window.location.href="<?php echo $cfgUrlToProject."/".$fileAuthLogin; ?>";
    -->
    </script>
    <?php
    exit;
}

// Start of checking the permissions 
$fileUserPermissionMode	=	$permUserSurveyGroupEdit;
$filePermissionMode		=	$permSurveyGroupEdit;

// filepermission
if($_SESSION["sessionUserStatusId"] < $filePermissionMode)
{
    ?>
    <script type="text/javascript">
    <!--
    window.location.href="<?php echo $cfgUrlToProject."/".$fileNoPermission."?messageCode=".$filePermissionMode."&messageType=file"; ?>";
    -->
    </script>
    <?php
    exit;
}
// get projectId
$projectId = (isset($_GET["projectId"])) ? $_GET["projectId"] : $_POST["projectId"];

// create new permissionFunctions object
$permission = &new permissionFunctions;

// get Permission
$permissionMode = $permission->getPermissionMode($_SESSION["sessionUserId"], $projectId, 1);
if($permission->errorMessage)
{
    echo $permission->errorMessage;
}
// userpermission
if($permissionMode < $fileUserPermissionMode)
{
    ?>
    <script type="text/javascript">
    <!--
    window.location.href="<?php echo $cfgUrlToProject."/".$fileNoPermission."?messageCode=".$fileUserPermissionMode."&messageType=user"; ?>";
    -->
    </script>
    <?php
    exit;
}
// End of checking the permissions

// create new surveyFunctions object
$surveyGroupEdit = &new surveyFunctions; 

// get groupId id as get variable
$groupId = $_GET["groupId"];
$orderNum = $_GET["orderNum"];
$preview  = $_GET["preview"];


// get old survey groupname
$SurveyGroupNameOld = isset($_GET["SurveyGroupNameOld"]) ? $_GET["SurveyGroupNameOld"] : $_POST["SurveyGroupNameOld"];

// check if form was submitted
if($_SERVER["REQUEST_METHOD"] == "POST")
{
    $groupId = $_POST["groupId"];
    
    // get and check surveyname
    $surveyGroupName = cleanHtml($_POST["surveyGroupName"]);
    if($surveyGroupName == "")
    {
        $errors["surveyGroupName"] = $lang_script["survey.group.edit.php"]["surveyGroupNameFillIn"];
    }
    else
    {
        // check format
        if(!validate::string($surveyGroupName, VAL_DENAME_PUNCTUATION, 1, 50))
        {
            $errors["surveyGroupName"] = $lang_script["survey.group.edit.php"]["surveyGroupNameUnvalidChars"];
        }
    }
    	
	$surveyGroupText 	= $_POST["surveyGroupText"];
	$surveyGroupNameOld = $_POST["surveyGroupNameOld"];
    
    // put error Array in String
    if($errors)
    {
        foreach($errors as $error)
        {
            $surveyError .= "$error<br>";
        }
    }
    // no errors, so we can insert new user    
    else
    {
	$surveyGroupEditArray["groupId"] 		= $_POST["groupId"];
	$surveyGroupEditArray["projectId"] 		= $_POST["projectId"];
        $surveyGroupEditArray["surveyGroupName"] 	= $surveyGroupName;
	$surveyGroupEditArray["surveyGroupNameOld"] 	= $surveyGroupNameOld;
        $surveyGroupEditArray["surveyGroupText"] 	= $surveyGroupText;
		
        $result	=	$surveyGroupEdit->editSurveyGroup($surveyGroupEditArray);
 
        // check for add group error
        if($surveyGroupEdit->errorMessage)
        {
            $surveyError .=  $surveyGroupEdit->errorMessage;
        }
        // redirect to success page
        else
        {
	      	?>
	   		<script type="text/javascript">
			<!--
	      	opener.parent.content.location.reload();
			opener.parent.projecttree.location.reload();
			window.location.href="<?php echo $fileSurveyGroupEdit."?projectId=$projectId&groupId=".$groupId."&orderNum=".$orderNum; ?>";
	      	-->
	      	</script>
		  	<?php
        }
		
    }
}
// fetch groupdata
$surveyGroupEditArray 	= $surveyGroupEdit->getSurveyGroup($groupId);
$surveyData		= $surveyGroupEdit->getSurveyForGroup($surveyGroupEditArray[0]["FORM_PROJECT_ID_FK"]);

/*
// activecheck
if (($surveyData[0]["PROJECT_ACTIVE"]=="yes")AND(!$_GET["warningChecked"]))
{
	// create Template IT object
	$tpl = new HTML_Template_IT($cfgPathToSurveyTemplates);
	
	// load template
	$tpl->loadTemplatefile($templateSurveyActiveWarning, true, true);

	// set title
	$tpl->setVariable( "applicationtitle", $cfgApplicationType.$cfgApplicationVersion);
	
	$tpl->setVariable( "projectId", $surveyGroupEditArray[0]["FORM_PROJECT_ID_FK"] );
	$tpl->setVariable( "groupId", "$groupId" );
	$tpl->get();
	$tpl->show();
	exit;
}
*/

// create Template IT object
$tpl = new HTML_Template_IT($cfgPathToSurveyTemplates);

// load template
$tpl->loadTemplatefile($templateSurveyGroupEdit, true, true);

// set title
$tpl->setVariable( "applicationtitle", $cfgApplicationType.$cfgApplicationVersion);

if($surveyGroupEdit->errorMessage)
{
    $surveyError .= $surveyGroupEdit->$errorMessage;
}

$tpl->setVariable( "formaction", $fileSurveyGroupEdit );
$tpl->setVariable( "groupId", $groupId );
$tpl->setVariable( "projectId", $projectId );

$tpl->setVariable( "errors", $surveyError );

for($j=0;$j<count($surveyGroupEditArray);$j++)
{
	$tpl->setVariable( "projectId", $surveyGroupEditArray[$j]["FORM_PROJECT_ID_FK"] );
	$tpl->setVariable( "surveygroupname", $surveyGroupEditArray[$j]["FORM_NAME"] );
	$tpl->setVariable( "surveygrouptext", $surveyGroupEditArray[$j]["FORM_HEADER"] );
	$tpl->setVariable( "surveygroupnameold", $surveyGroupEditArray[$j]["FORM_NAME"] );
}

$tpl->setVariable( "lnk_detail", $fileSurveyGroupDetailview."?projectId=$projectId&groupId=".$groupId."&orderNum=".$orderNum."&preview=".$preview );
$tpl->setVariable( "lnk_preview", $fileSurveyGroupPreview."?projectId=$projectId&groupId=".$groupId."&orderNum=".$orderNum."&preview=".$preview );
$tpl->setVariable( "lnk_edit", $fileSurveyGroupEdit."?projectId=$projectId&groupId=".$groupId."&orderNum=".$orderNum."&preview=".$preview );
$tpl->setVariable( "lnk_pos", $fileSurveyGroupOrder."?projectId=$projectId&groupId=".$groupId."&orderNum=".$orderNum."&preview=".$preview );
$tpl->setVariable( "lnk_delete", $fileSurveyGroupDelete."?projectId=$projectId&groupId=".$groupId."&orderNum=".$orderNum."&preview=".$preview );

// parse template
$tpl->parse();

// get the parsed template and print it
$tpl->get();
$tpl->show();
?>
