<?php
// +----------------------------------------------------------------------+
// | survey pilot                                                         |
// +----------------------------------------------------------------------+
// | Copyright (c) 2002 serie a - Digitale Medien und Systeme GmbH        |
// +----------------------------------------------------------------------+
// | Authors: 	Jrn Allert <allert@serie-a.de>                           |
// |          	Rene Renk   <renk@serie-a.de>                             |
// +----------------------------------------------------------------------+
//
// $Id: survey.group.order.php,v 1.1.1.1 2004/07/15 13:31:59 opensurveypilot Exp $

// start session
@session_start();

// require all configuration files and libraries
require_once("./../config/config.inc.php"); // common config file
require_once($cfgPathToConf."/file.inc.php"); // project files
require_once($cfgPathToLib."/common.inc.php"); // common functions
require_once($cfgPathToSurveyFiles."/config/survey.config.inc.php"); // survey configuration
require_once($cfgPathToSurveyFiles."/config/survey.file.inc.php"); // survey files
require_once($cfgPathToSurveyFiles."/lib/survey.inc.php"); // survey functions
require_once($cfgPathToAuthFiles."/lib/user.inc.php"); // auth functions
require_once($cfgPathToAuthFiles."/config/auth.file.inc.php"); // auth functions
require_once($cfgPathToAuthFiles."/lib/permission.inc.php"); // permission functions
require_once("HTML/Template/IT.php"); // PEAR::HTML_TEMPLATE_IT

// create new userFunctions object
$client = &new userFunctions;

//login check
if ($client->getAuthentication($_SESSION["sessionId"], session_id()) ==  false)
{
    //redirect to login page
    ?>
    <script type="text/javascript">
    <!--
    window.location.href="<?php echo $cfgUrlToProject."/".$fileAuthLogin; ?>";
    -->
    </script>
    <?php
    exit;
}

// function permission check
if($_SESSION["sessionUserStatusId"] < $permSurveyGroupOrder)
{
    ?>
    <script type="text/javascript">
    <!--
    window.location.href="<?php echo $cfgUrlToProject."/".$fileNoPermission."?messageCode=2"; ?>";
    -->
    </script>
    <?php
    exit;
}

// Start of checking the permissions 
$fileUserPermissionMode	=	$permUserSurveyGroupOrder;
$filePermissionMode		=	$permSurveyGroupOrder;

// filepermission
if($_SESSION["sessionUserStatusId"] < $filePermissionMode)
{
    ?>
    <script type="text/javascript">
    <!--
    window.location.href="<?php echo $cfgUrlToProject."/".$fileNoPermission."?messageCode=".$filePermissionMode."&messageType=file"; ?>";
    -->
    </script>
    <?php
    exit;
}
// get projectId
$projectId = (isset($_GET["projectId"])) ? $_GET["projectId"] : $_POST["projectId"];

$groupId = $_GET["groupId"];
$orderNum = $_GET["orderNum"];


// create new permissionFunctions object
$permission = &new permissionFunctions;

// get Permission
$permissionMode = $permission->getPermissionMode($_SESSION["sessionUserId"], $projectId, 1);
if($permission->errorMessage)
{
    echo $permission->errorMessage;
}
// userpermission
if($permissionMode < $fileUserPermissionMode)
{
    ?>
    <script type="text/javascript">
    <!--
    window.location.href="<?php echo $cfgUrlToProject."/".$fileNoPermission."?messageCode=".$fileUserPermissionMode."&messageType=user"; ?>";
    -->
    </script>
    <?php
    exit;
}
// End of checking the permissions

// create new surveyunctions object
$survey = new surveyFunctions();

// check if form was submitted
if($_SERVER["REQUEST_METHOD"] == "POST")
{
    $groupId = $_POST["groupId"];
    $parentId = $survey->getParent($groupId);
    if($_POST["moveToOrder"] < 0)
    { 
        // negative values: move to last position	
        $survey->moveGroupToEnd($projectId, $parentId, $groupId);
        if($survey->errorMessage)
        {
            $surveyError =  $survey->errorMessage;
        }
	}
	else
    {
        $survey->moveGroupToOrder($projectId, $parentId, $groupId, $_POST["moveToOrder"]);
        if($survey->errorMessage)
        {
            $surveyError .=  $survey->errorMessage;
        }
	}
    
    if($surveyError)
    {
        echo $surveyError;
		exit;
    }
    else
    {
	?>
		<script type="text/javascript">
		<!--
		opener.parent.content.location.reload();
		opener.parent.projecttree.location.reload();
		window.location.href="<?php echo $fileSurveyGroupOrder."?projectId=$projectId&groupId=".$groupId."&orderNum=".$orderNum; ?>";
		-->
		</script>
	<?php
    }
}

if(($_GET["groupId"])AND(!$_GET["warningChecked"]))
{
	// fetch groupdata
	$surveyGroupEditArray = $survey->getSurveyGroup($_GET["groupId"]);
	$surveyData			  = $survey->getSurveyForGroup($surveyGroupEditArray[0]["FORM_PROJECT_ID_FK"]);
	
	/*
	
	// activecheck
	if ($surveyData[0]["PROJECT_ACTIVE"]=="yes")
	{
		// create Template IT object
		$tpl = new HTML_Template_IT($cfgPathToSurveyTemplates);
		
		// load template
		$tpl->loadTemplatefile($templateSurveyActiveWarning, true, true);
		
		// set title
		$tpl->setVariable( "applicationtitle", $cfgApplicationType.$cfgApplicationVersion);
		
		$tpl->setVariable( "groupId", $_GET["groupId"] );
        $tpl->setVariable( "projectId", $_GET["projectId"] );
		$tpl->get();
		$tpl->show();
		exit;
	}*/
}


// display form
$projectId = $_GET["projectId"];  
$groupId = $_GET["groupId"];

// get node information
$group = $survey->getSurveyGroup($groupId);
    
// get parent id
$parentId = $survey->getParent($groupId);
    
// get start node, if FORM_NODEGROUP is not 0
if($group[0]["FORM_NODEGROUP"] != 0)
{
    $startFolders = $survey->getStartSubfolderNodes($projectId, $parentId);
    for($k=0;$k<count($startFolders);$k++)
    {
        // check which is the start folder for this subfolder
        if($group[0]["FORM_NODEGROUP"] == $startFolders[$k]["FORM_ID_PK"])
        {
            $startNodeId = $startFolders[$k]["FORM_ID_PK"];
        }
    }
}
else
{
    $startNodeId = $groupId;
}

// get number of groups in this subfolder
$num = $survey->getSurveyGroupsNum($group[0]["FORM_PROJECT_ID_FK"], $startNodeId, $parentId );
   
$allGroups =  $survey->getSurveyGroupsForOverview($projectId, $startNodeId, $parentId, 0, $num, "FORM_ORDER", "ASC");
if($survey->errorMessage)
{
    echo $survey->errorMessage;
}
//print_r($allGroups);   
$tpl = new HTML_Template_IT($cfgPathToSurveyTemplates);
$tpl->loadTemplatefile($templateSurveyGroupOrder, true, true);

// set title
$tpl->setVariable( "applicationtitle", $cfgApplicationType.$cfgApplicationVersion);

$tpl->setVariable("formaction", $fileSurveyGroupOrder);

for($i=0; $i < count($allGroups); $i++)
{
    $tpl->setCurrentBlock("select");
    $tpl->setVariable("sel_question", $allGroups[$i]["FORM_NAME"]);
    $tpl->setVariable("sel_order", $allGroups[$i]["FORM_ORDER"]);
    $tpl->parseCurrentBlock("select");
}

$tpl->setVariable("question", $group[0]["FORM_NAME"]);
$tpl->setVariable("groupid", $groupId);
$tpl->setVariable("projectid", $projectId);


$tpl->setVariable( "lnk_detail", $fileSurveyGroupDetailview."?projectId=$projectId&groupId=".$groupId."&orderNum=".$orderNum );
$tpl->setVariable( "lnk_preview", $fileSurveyGroupPreview."?projectId=$projectId&groupId=".$groupId."&orderNum=".$orderNum );
$tpl->setVariable( "lnk_edit", $fileSurveyGroupEdit."?projectId=$projectId&groupId=".$groupId."&orderNum=".$orderNum );
$tpl->setVariable( "lnk_pos", $fileSurveyGroupOrder."?projectId=$projectId&groupId=".$groupId."&orderNum=".$orderNum );
$tpl->setVariable( "lnk_delete", $fileSurveyGroupDelete."?projectId=$projectId&groupId=".$groupId."&orderNum=".$orderNum );

$tpl->parse();
$tpl->get();
$tpl->show();
?>
