<?php
// +----------------------------------------------------------------------+
// | survey pilot                                                         |
// +----------------------------------------------------------------------+
// | Copyright (c) 2002 serie a - Digitale Medien und Systeme GmbH        |
// +----------------------------------------------------------------------+
// | Authors: 	Jrn Allert <allert@serie-a.de>                           |
// |          	Rene Renk   <renk@serie-a.de>                             |
// +----------------------------------------------------------------------+
//
// $Id: survey.group.overview.php,v 1.1.1.1 2004/07/15 13:32:00 opensurveypilot Exp $

// start session
@session_start();

// require all configuration files and libraries
require_once("./../config/config.inc.php"); // common config file
require_once($cfgPathToConf."/file.inc.php"); // project files
require_once($cfgPathToLib."/common.inc.php"); // common functions
require_once($cfgPathToSurveyFiles."/config/survey.config.inc.php"); // survey files
require_once($cfgPathToSurveyFiles."/config/survey.file.inc.php"); // survey files
require_once($cfgPathToSurveyFiles."/lib/survey.inc.php"); // survey functions
require_once($cfgPathToAuthFiles."/lib/user.inc.php"); // auth user functions
require_once($cfgPathToAuthFiles."/config/auth.file.inc.php"); // auth user functions
require_once($cfgPathToAuthFiles."/lib/permission.inc.php"); // permission functions
require_once("HTML/Template/IT.php"); // PEAR::HTML_TEMPLATE_IT

// create new userFunctions object
$client = &new userFunctions;

//login check
if ($client->getAuthentication($_SESSION["sessionId"], session_id()) ==  false)
{
    //redirect to login page
    ?>
    <script type="text/javascript">
    <!--
    window.location.href="<?php echo $cfgUrlToProject."/".$fileAuthLogin; ?>";
    -->
    </script>
    <?php
    exit;
}  

// Start of checking the permissions 
$fileUserPermissionMode	=	$permUserSurveyGroupOverview;
$filePermissionMode		=	$permSurveyGroupOverview;

// filepermission
if($_SESSION["sessionUserStatusId"] < $filePermissionMode)
{
    ?>
    <script type="text/javascript">
    <!--
    window.location.href="<?php echo $cfgUrlToProject."/".$fileNoPermission."?messageCode=".$filePermissionMode."&messageType=file"; ?>";
    -->
    </script>
    <?php
    exit;
}
// get projectId
$projectId = (isset($_GET["projectId"])) ? $_GET["projectId"] : $_POST["projectId"];

// create new permissionFunctions object
$permission = &new permissionFunctions;

// get Permission
$permissionMode = $permission->getPermissionMode($_SESSION["sessionUserId"], $projectId, 1);
if($permission->errorMessage)
{
    echo $permission->errorMessage;
}
// userpermission
if($permissionMode < $fileUserPermissionMode)
{
    ?>
    <script type="text/javascript">
    <!--
    window.location.href="<?php echo $cfgUrlToProject."/".$fileNoPermission."?messageCode=".$fileUserPermissionMode."&messageType=user"; ?>";
    -->
    </script>
    <?php
    exit;
}
// End of checking the permissions

// get groupId id as get variable
if(isset($_GET["groupId"]))
{
    $groupId = $_GET["groupId"];
}
else
{
	$groupId = 0;
}

// create new surveyFunctions object
$survey = &new surveyFunctions; 

// create Template IT object
$tpl = new HTML_Template_IT($cfgPathToSurveyTemplates);

// load template
if($groupId)
{
	$tpl->loadTemplatefile($templateSurveyGroupOverview, true, true);
	// set title
	$tpl->setVariable( "applicationtitle", $cfgApplicationType.$cfgApplicationVersion);
}
else
{
	$tpl->loadTemplatefile($templateSurveyGroupMainOverview, true, true);
	
	// set title
	$tpl->setVariable( "applicationtitle", $cfgApplicationType.$cfgApplicationVersion);
}

// get actual num as get variable
if(isset($_GET["actualNum"]))
{
    $actualNum = $_GET["actualNum"];
}
// get orderBy as get variable
if(isset($_GET["orderBy"]))
{
    $orderBy = $_GET["orderBy"];
}
else
{
    $orderBy = "FORM_ORDER";
}
// get direction as get variable
if(isset($_GET["direction"]))
{
    $direction = $_GET["direction"];
}

// maximum rows
$maxRow = $cfgMaxRowInOverviews;

//total rows  
$totalNum =  $survey->getSurveyGroupsNum($projectId, "", $groupId);

// actual rows
if (!isset($actualNum))
{
    $actualNum = 0;
}
// get the Number of pages
$numPages = intval($totalNum/$maxRow);
if ($numPages < ($totalNum/$maxRow))
{ 
    $numPages++;
}

// prev button
if ($actualNum > 0) 
{
    $y = $actualNum - $maxRow;
    
    $tpl->setVariable( "prev_button", "<a class=\"navigation\" href=\"$fileSurveyGroupOverview?projectId=$projectId&groupId=$groupId&actualNum=$y&orderBy=$orderBy&direction=$direction\">&laquo;</a>" );
}
// display pages
for ($i = 1; $i <= $numPages; $i++)
{
    $y = ($i * $maxRow) - $maxRow;
    
    $tpl->setCurrentBlock( "num_buttons" );
    $tpl->setVariable( "num_button", "[<a class=\"navigation\" href=\"$fileSurveyGroupOverview?projectId=$projectId&groupId=$groupId&actualNum=$y&orderBy=$orderBy&direction=$direction\">$i</a>]" );
    $tpl->parseCurrentBlock();
}
//  next button
if ($actualNum < ($totalNum - $maxRow)) 
{
    $y = $actualNum  + $maxRow;
    
    $tpl->setVariable( "next_button", "<a class=\"navigation\" href=\"$fileSurveyGroupOverview?projectId=$projectId&groupId=$groupId&actualNum=$y&orderBy=$orderBy&direction=$direction\">&raquo;</a>" );
}

// entry to
$entryTo = ($actualNum + $maxRow) < $totalNum ? $actualNum + $maxRow : $totalNum;
// entry from
$entryFrom = $entryTo < 1 ? "0" : $actualNum +1;

$tpl->setVariable( "entry_from", $entryFrom );
$tpl->setVariable( "entry_to", $entryTo );
$tpl->setVariable( "entry_total", $totalNum );

// question/ group switch
$tpl->setVariable( "grouplink", $fileSurveyQuestionOverview."?projectId=$projectId&groupId=$groupId" );
$tpl->setVariable( "grouptarget", $fileFrameContentName );
$tpl->setVariable( "groupoptionlink", $fileSurveyToplevel."?projectId=$projectId&oneGroupSelectedGid=$groupId" );
$tpl->setVariable( "groupoptiontarget", $fileFrameToplevelName );

// get headline
$headlineArray =  $survey->getSurveyForGroupInQuestions($groupId,$projectId);
if($surveyQuestionsGroup->errorMessage)
{
    echo $surveyQuestionsGroup->errorMessage;
}
$tpl->setCurrentBlock( "headline" );
$tpl->setVariable( "survey_Id", $headlineArray[0]["FORM_PROJECT_ID_FK"] );
$tpl->setVariable( "headline_survey", $headlineArray[0]["PROJECT_NAME"] );
if($groupId != 0)
{
    $tpl->setVariable( "headline_group", " --> ".$headlineArray[0]["FORM_NAME"] );
}
$tpl->parseCurrentBlock();	

// orderby butons
$tpl->setVariable( "order_link_nr_up", "$fileSurveyGroupOverview?projectId=$projectId&groupId=$groupId&actualNum=$actualNum&orderBy=FORM_ORDER&direction=ASC" );
$tpl->setVariable( "order_link_nr_down", "$fileSurveyGroupOverview?projectId=$projectId&groupId=$groupId&actualNum=$actualNum&orderBy=FORM_ORDER&direction=DESC" );
$tpl->setVariable( "order_link_name_up", "$fileSurveyGroupOverview?projectId=$projectId&groupId=$groupId&actualNum=$actualNum&orderBy=FORM_NAME&direction=ASC" );
$tpl->setVariable( "order_link_name_down", "$fileSurveyGroupOverview?projectId=$projectId&groupId=$groupId&actualNum=$actualNum&orderBy=FORM_NAME&direction=DESC" );
$tpl->setVariable( "order_link_insert_date_up", "$fileSurveyGroupOverview?projectId=$projectId&groupId=$groupId&actualNum=$actualNum&orderBy=FORM_INSERTDATE&direction=ASC" );
$tpl->setVariable( "order_link_insert_date_down", "$fileSurveyGroupOverview?projectId=$projectId&groupId=$groupId&actualNum=$actualNum&orderBy=FORM_INSERTDATE&direction=DESC" );

// get start sub folder nodes
$startSubFolder = $survey->getStartSubfolderNodes($projectId, $groupId);
for($l=0;$l<count($startSubFolder);$l++)
{
    // get groups
    $surveyGroupOverviewArray = $survey->getSurveyGroupsForOverview($projectId, $startSubFolder[$l]["FORM_ID_PK"], $groupId, $actualNum, $maxRow, $orderBy, $direction);
    if($survey->errorMessage)
    {
        echo $survey->errorMessage;
    }
    for($j=0;$j<count($surveyGroupOverviewArray);$j++)
    {
    	// split string at 35 signs
    	$surveyGroupOverviewArray[$j]["FORM_HEADER"] = substr($surveyGroupOverviewArray[$j]["FORM_HEADER"],0,35);
    	$surveyGroupOverviewArray[$j]["FORM_HEADER"] = $surveyGroupOverviewArray[$j]["FORM_HEADER"]."...";
    	
    	// get count questions for group
    	$getQuestionsForGroup =	$survey->getQuestionsInGroup($surveyGroupOverviewArray[$j]["FORM_ID_PK"]);
    	
        $tpl->setCurrentBlock( "survey_group_overview" );
        $tpl->setVariable( "id", $surveyGroupOverviewArray[$j]["FORM_ID_PK"] );
    	$tpl->setVariable( "name", $surveyGroupOverviewArray[$j]["FORM_NAME"] );
        $tpl->setVariable( "form_header", $surveyGroupOverviewArray[$j]["FORM_HEADER"] );
        $tpl->setVariable( "form_order", ($surveyGroupOverviewArray[$j]["REL_ORDER_NUM"] + $actualNum));
    	$tpl->setVariable( "questions_in_group", $getQuestionsForGroup );
        $tpl->setVariable( "insertdate", $surveyGroupOverviewArray[$j]["FORM_INSERTDATE"] );

        $outputLink = $cfgUrlToOutput."/".$headlineArray[0]["PROJECT_OUTPUTDIR"];
		// check for concurring nodegroups
		if($surveyGroupOverviewArray[$j]["FORM_PARENT_ID"])
		{
			$formIndexToProcess = $survey->checkForConcurringNodes($surveyGroupOverviewArray,$j);
		}
		else
		{
			$formIndexToProcess = $surveyGroupOverviewArray[$j]["REL_ORDER_NUM"]+ $actualNum -1;
		}
		//
		$tpl->setVariable( "preview_link", $outputLink."/".$fileGroupPreview."?projectId=".$projectId."&currentProcessedForm=".$formIndexToProcess."&surveyPath=".$surveyGroupOverviewArray[$j]["FORM_PARENT_ID"] );
		
		$preview=base64_encode ($outputLink."/".$fileGroupPreview."?projectId=".$projectId."&currentProcessedForm=".$formIndexToProcess."&surveyPath=".$surveyGroupOverviewArray[$j]["FORM_PARENT_ID"]);
		$tpl->setVariable( "detailview_link", $fileSurveyGroupDetailview."?projectId=$projectId&groupId=".$surveyGroupOverviewArray[$j]["FORM_ID_PK"]."&orderNum=".$surveyGroupOverviewArray[$j]["REL_ORDER_NUM"]."&preview=".$preview );
		
		$tpl->setVariable( "edit_link", $fileSurveyGroupEdit."?projectId=$projectId&groupId=".$surveyGroupOverviewArray[$j]["FORM_ID_PK"] );
    	$tpl->setVariable( "order_link", $fileSurveyGroupOrder."?projectId=$projectId&groupId=".$surveyGroupOverviewArray[$j]["FORM_ID_PK"] );
        $tpl->setVariable( "delete_link", $fileSurveyGroupDelete."?projectId=$projectId&groupId=".$surveyGroupOverviewArray[$j]["FORM_ID_PK"] );
        $tpl->setVariable( "print_link", "#" );
		
        $tpl->parseCurrentBlock();	
    }
}

// get the parsed template and print it
$tpl->get();
$tpl->show();
?>
