<?php
// +----------------------------------------------------------------------+
// | survey pilot                                                         |
// +----------------------------------------------------------------------+
// | Copyright (c) 2002 serie a - Digitale Medien und Systeme GmbH        |
// +----------------------------------------------------------------------+
// | Authors: 	Jrn Allert <allert@serie-a.de>                           |
// |          	Rene Renk   <renk@serie-a.de>                             |
// +----------------------------------------------------------------------+
//
// $Id: survey.overview.php,v 1.1.1.1 2004/07/15 13:32:01 opensurveypilot Exp $

// start session
@session_start();

// require all configuration files and libraries
require_once("./../config/config.inc.php"); // common config file
require_once($cfgPathToConf."/file.inc.php"); // project files
require_once($cfgPathToLib."/common.inc.php"); // common functions
require_once($cfgPathToAuthFiles."/lib/user.inc.php"); // auth user functions
require_once($cfgPathToSurveyFiles."/config/survey.config.inc.php"); // survey config file
require_once($cfgPathToSurveyFiles."/config/survey.file.inc.php"); // survey files
require_once($cfgPathToSurveyFiles."/lib/survey.inc.php"); // survey functions
require_once($cfgPathToAuthFiles."/config/auth.file.inc.php"); // auth user functions
require_once("HTML/Template/IT.php"); // PEAR::HTML_TEMPLATE_IT
 
// create new userFunctions object
$client = &new userFunctions;

//login check
if ($client->getAuthentication($_SESSION["sessionId"], session_id()) ==  false)
{
    //redirect to login page
    ?>
    <script type="text/javascript">
    <!--
    window.location.href="<?php echo $cfgUrlToProject."/".$fileAuthLogin; ?>";
    -->
    </script>
    <?php
    exit;
} 

$surveyOverview = &new surveyFunctions; 

if($_SERVER["REQUEST_METHOD"] == "POST")
{
	$surveyIdArray=$_POST[markedSurveyId];

	if ($_POST["selectAction"]==1) //delete
	{
		for ($i=0;$i<count($surveyIdArray);$i++)
		{
			// get all survey groups
			$surveyGroupArray = $surveyOverview->getGroupsForSurvey($surveyIdArray[$i]);
			if($surveyOverview->errorMessage)
			{
			    $surveyError .=  $surveyOverview->errorMessage;
			}
			for($k=0;$k<count($surveyGroupArray);$k++)
			{
			    $groupId = $surveyGroupArray[$k]["FORM_ID_PK"];
			    
			    // get parent id
			    $parentId = $surveyOverview->getParent($groupId);
			    if($surveyOverview->errorMessage)
			    {
			        $surveyError .=  $surveyOverview->errorMessage;
			    }
			    
			    // delete group with all content
			    $surveyOverview->deleteSurveyGroup($surveyIdArray[$i], $parentId, $groupId);
			    if($surveyOverview->errorMessage)
			    {
			       $surveyError .=  $surveyOverview->errorMessage;
			    }
			}
			
			// delete permissions
			$surveyOverview->deleteSurveyPermissions(1, $surveyIdArray[$i]);
			if($surveyOverview->errorMessage)
			{
			    $surveyError .=  $surveyOverview->errorMessage;
			}
			
			// delete css styles
			$surveyOverview->deleteSurveyStyles($surveyIdArray[$i]);
			if($surveyOverview->errorMessage)
			{
			    $surveyError .=  $surveyOverview->errorMessage;
			}
			
			// delete customized errormessages
			$surveyOverview->deleteSurveyErrorTable($surveyIdArray[$i]);
			if($surveyOverview->errorMessage)
			{
			    $surveyError .=  $surveyOverview->errorMessage;
			}
			
			// delete tan tables
			$surveyOverview->deleteSurveyTanTables($surveyIdArray[$i]);
			if($surveyOverview->errorMessage)
			{
			    $surveyError .=  $surveyOverview->errorMessage;
			}
			
			$surveyDataDelArray=$surveyOverview->getSurvey($surveyIdArray[$i]);
			
			// delete output folder
			$surveyOverview->deleteSurveyFolder($surveyDataDelArray[0]["PROJECT_OUTPUTDIR"]);
			if($surveyOverview->errorMessage)
			{
			    $surveyError .=  $surveyOverview->errorMessage;
			}
			
			// delete survey
			$result	= $surveyOverview->deleteSurvey($surveyIdArray[$i]);
			if($surveyOverview->errorMessage)
			{
			    $surveyError .=  $surveyOverview->errorMessage;
			}
			
			// delete survey
			$result	= $surveyOverview->deleteSurveyTemplateTables($surveyIdArray[$i]);
			if($surveyOverview->errorMessage)
			{
			    $surveyError .=  $surveyOverview->errorMessage;
			}
			
			
			// empty result tables
			$surveyOverview->emptyResultTables($surveyIdArray[$i]);
			if($surveyOverview->errorMessage)
			{
			  $surveyError .=  $surveyOverview->errorMessage;
			}
			
			// delete result tables
			$surveyOverview->deleteResultTables($surveyIdArray[$i]);
			if($surveyOverview->errorMessage)
			{
			  $surveyError .=  $surveyOverview->errorMessage;
			}
		}
		?>
		<script type="text/javascript">
		<!--
		parent.projecttree.location.reload();
		window.location.href="<?=$fileSurveyOverview?>";
		-->
		</script>
		<?php
	}
	
		if ($_POST["selectAction"]==2) //aktivieren
		{
			for ($i=0;$i<count($surveyIdArray);$i++)
			{
				$surveyOverview->setSurveyStatus($surveyIdArray[$i], "yes");
				if($surveyOverview->errorMessage)
				{
				    $surveyError .=  $surveyOverview->errorMessage;
				}
			}
		}
		
		if ($_POST["selectAction"]==3) //deaktivieren
		{
			for ($i=0;$i<count($surveyIdArray);$i++)
			{
				$surveyOverview->setSurveyStatus($surveyIdArray[$i], "no");
				if($surveyOverview->errorMessage)
				{
				    $surveyError .=  $surveyOverview->errorMessage;
				}
			}
		}
	
	
	if ($surveyError) 
	{
		echo $surveyError;
		
	}

}



// create Template IT object
$tpl = $tpl = new HTML_Template_IT($cfgPathToSurveyTemplates);

// load template
$tpl->loadTemplatefile($templateSurveyOverview, true, true);

// set title
$tpl->setVariable( "applicationtitle", $cfgApplicationType.$cfgApplicationVersion);

$tpl->setVariable( "formaction", $fileSurveyOverview);

// get surveyId id as get variable
if(isset($_GET["projectId"]))
{
    $projectId = $_GET["projectId"];
}
elseif(isset($_GET["projectId"]))
{
    $projectId = $_GET["projectId"];
}
else
{
	$projectId = 0;
}

// get actual num as get variable
if(isset($_GET["actualNum"]))
{
    $actualNum = $_GET["actualNum"];
}
// get orderBy as get variable
if(isset($_GET["orderBy"]))
{
    $orderBy = $_GET["orderBy"];
}
else
{
    $orderBy = "PROJECT_NAME";
}
// get direction as get variable
if(isset($_GET["direction"]))
{
    $direction = $_GET["direction"];
}

// maximum rows
$maxRow = $cfgMaxRowInOverviews;
//total rows   

$totalNum =  $surveyOverview->getSurveysNum($projectId);

// actual rows
if (!isset($actualNum))
{
    $actualNum = 0;
}
// get the Number of pages
$numPages = intval($totalNum/$maxRow);
if ($numPages < ($totalNum/$maxRow))
{ 
    $numPages++;
}

// prev button
if ($actualNum > 0) 
{
    $y = $actualNum - $maxRow;
    
    $tpl->setVariable( "prev_button", "<a class=\"navigation\" href=\"$fileSurveyOverview?projectId=$projectId&actualNum=$y&orderBy=$orderBy&direction=$direction\">&laquo;</a>" );
}
// display pages
for ($i = 1; $i <= $numPages; $i++)
{
    $y = ($i * $maxRow) - $maxRow;
    
    $tpl->setCurrentBlock( "num_buttons" );
    $tpl->setVariable( "num_button", "[<a class=\"navigation\" href=\"$fileSurveyOverview?projectId=$projectId&actualNum=$y&orderBy=$orderBy&direction=$direction\">$i</a>]" );
    $tpl->parseCurrentBlock();
}
//  next button
if ($actualNum < ($totalNum - $maxRow)) 
{
    $y = $actualNum  + $maxRow;
    
    $tpl->setVariable( "next_button", "<a class=\"navigation\" href=\"$fileSurveyOverview?projectId=$projectId&actualNum=$y&orderBy=$orderBy&direction=$direction\">&raquo;</a>" );
}

if(($actualNum + $maxRow) < $totalNum)
{
    $entryTo = $actualNum + $maxRow;
}
else
{
    $entryTo = $totalNum;
    
}

// entry from
$entryFrom = $entryTo < 1 ? "0" : $actualNum +1;

$tpl->setVariable( "entry_from", $entryFrom );
$tpl->setVariable( "entry_to", $entryTo );
$tpl->setVariable( "entry_total", $totalNum );

// orderby butons
$tpl->setVariable( "order_link_name_up", "$fileSurveyOverview?projectId=$projectId&actualNum=$actualNum&orderBy=PROJECT_NAME&direction=ASC" );
$tpl->setVariable( "order_link_name_down", "$fileSurveyOverview?projectId=$projectId&actualNum=$actualNum&orderBy=PROJECT_NAME&direction=DESC" );
$tpl->setVariable( "order_link_author_up", "$fileSurveyOverview?projectId=$projectId&actualNum=$actualNum&orderBy=PROJECT_AUTHOR&direction=ASC" );
$tpl->setVariable( "order_link_author_down", "$fileSurveyOverview?projectId=$projectId&actualNum=$actualNum&orderBy=PROJECT_AUTHOR&direction=DESC" );
$tpl->setVariable( "order_link_security_up", "$fileSurveyOverview?projectId=$projectId&actualNum=$actualNum&orderBy=PROJECT_SECURITY&direction=ASC" );
$tpl->setVariable( "order_link_security_down", "$fileSurveyOverview?projectId=$projectId&actualNum=$actualNum&orderBy=PROJECT_SECURITY&direction=DESC" );
$tpl->setVariable( "order_link_active_up", "$fileSurveyOverview?projectId=$projectId&actualNum=$actualNum&orderBy=PROJECT_ACTIVE&direction=ASC" );
$tpl->setVariable( "order_link_active_down", "$fileSurveyOverview?projectId=$projectId&actualNum=$actualNum&orderBy=PROJECT_ACTIVE&direction=DESC" );
$tpl->setVariable( "order_link_insert_date_up", "$fileSurveyOverview?projectId=$projectId&actualNum=$actualNum&orderBy=PROJECT_TIMESTAMP&direction=ASC" );
$tpl->setVariable( "order_link_insert_date_down", "$fileSurveyOverview?projectId=$projectId&actualNum=$actualNum&orderBy=PROJECT_TIMESTAMP&direction=DESC" );

// get questions
$surveyOverviewArray = $surveyOverview->getSurveys($projectId, $actualNum, $maxRow, $orderBy, $direction);
if($surveyOverview->errorMessage)
{
    echo $surveyOverview->errorMessage;
}
for($j=0;$j<count($surveyOverviewArray);$j++)
{
    switch ($surveyOverviewArray[$j]["PROJECT_SECURITY"])
    {
        case "tan":
        $surveySecurity = $lang_script["survey.overview.php"]["surveySecurityTan"];
        break;
        
        case "cookie":
        $surveySecurity = $lang_script["survey.overview.php"]["surveySecurityCookie"];
        break;
        
        default:
        $surveySecurity = $lang_script["survey.overview.php"]["surveySecuritydefault"];
        break;
    }
    
    $tpl->setCurrentBlock( "survey_overview" );
    $tpl->setVariable( "id", $surveyOverviewArray[$j]["PROJECT_ID_PK"] );
    $tpl->setVariable( "markedSurveyId", $surveyOverviewArray[$j]["PROJECT_ID_PK"] );
    $tpl->setVariable( "name", $surveyOverviewArray[$j]["PROJECT_NAME"] );
    $tpl->setVariable( "author", $surveyOverviewArray[$j]["PROJECT_AUTHOR"] );

    $tpl->setVariable( "security", $surveySecurity );
	if($surveyOverviewArray[$j]["PROJECT_ACTIVE"] == "yes")
	{
	    $surveyActive = $lang_script["survey.overview.php"]["surveyActiveEnabled"];
	}
	else
	{
	    $surveyActive = $lang_script["survey.overview.php"]["surveyActiveDisabled"];
	}
    $tpl->setVariable( "active",$surveyActive );
    $tpl->setVariable( "insertdate", $surveyOverviewArray[$j]["PROJECT_TIMESTAMP"] );
    $tpl->setVariable( "link", $fileSurveyEdit."?projectId=".$surveyOverviewArray[$j]["PROJECT_ID_PK"] );
    $tpl->parseCurrentBlock();	
}

// headline
$tpl->setCurrentBlock( "headline" );
if($totalNum == 1)
{
    $tpl->setVariable( "headline", $lang_script["survey.overview.php"]["headlineProjectDetail"]);
}
else
{
    $tpl->setVariable( "headline", $lang_script["survey.overview.php"]["headlineProjectAll"]);
}
$tpl->parseCurrentBlock();

// get the parsed template and print it
$tpl->get();
$tpl->show();
?>
