<?php
// +----------------------------------------------------------------------+
// | survey pilot                                                         |
// +----------------------------------------------------------------------+
// | Copyright (c) 2002 serie a - Digitale Medien und Systeme GmbH        |
// +----------------------------------------------------------------------+
// | Authors: 	Jrn Allert <allert@serie-a.de>                           |
// |          	Rene Renk   <renk@serie-a.de>                             |
// +----------------------------------------------------------------------+
//
// $Id: survey.preview.php,v 1.1.1.1 2004/07/15 13:32:01 opensurveypilot Exp $

// start session
@session_start();

// require all configuration files and libraries
require_once("./../config/config.inc.php"); // common config file
require_once("Validate.php"); // PEAR::Validate
require_once($cfgPathToConf."/file.inc.php"); // project files
require_once($cfgPathToLib."/common.inc.php"); // common functions
require_once($cfgPathToSurveyFiles."/config/survey.config.inc.php"); // survey configuration
require_once($cfgPathToSurveyFiles."/config/survey.file.inc.php"); // survey files
require_once($cfgPathToSurveyFiles."/lib/survey.inc.php"); // survey functions
require_once($cfgPathToAuthFiles."/lib/user.inc.php"); // auth user functions
require_once($cfgPathToAuthFiles."/config/auth.file.inc.php"); // auth user files
require_once($cfgPathToAuthFiles."/lib/permission.inc.php"); // auth permission functions
require_once($cfgPathToSurveyFiles."/lib/database/dbfunctions.inc.php"); // survey functions
require_once("HTML/Template/IT.php"); // PEAR::HTML_TEMPLATE_IT

// create new userFunctions object
$client = &new userFunctions;

//login check
if ($client->getAuthentication($_SESSION["sessionId"], session_id()) ==  false)
{
    //redirect to login page
    ?>
    <script type="text/javascript">
    <!--
    window.location.href="<?php echo $cfgUrlToProject."/".$fileAuthLogin; ?>";
    -->
    </script>
    <?php
    exit;
}

// Start of checking the permissions 
$fileUserPermissionMode	=	$permUserSurveyEdit;
$filePermissionMode		=	$permSurveyEdit;

// filepermission
if($_SESSION["sessionUserStatusId"] < $filePermissionMode)
{
    ?>
    <script type="text/javascript">
    <!--
    window.location.href="<?php echo $cfgUrlToProject."/".$fileNoPermission."?messageCode=".$filePermissionMode."&messageType=file"; ?>";
    -->
    </script>
    <?php
    exit;
}
// get projectId
$projectId = (isset($_GET["projectId"])) ? $_GET["projectId"] : $_POST["projectId"];

// create new permissionFunctions object
$permission = &new permissionFunctions;

// get Permission
$permissionMode = $permission->getPermissionMode($_SESSION["sessionUserId"], $projectId, 1);
if($permission->errorMessage)
{
    echo $permission->errorMessage;
}
// userpermission
if($permissionMode < $fileUserPermissionMode)
{
    ?>
    <script type="text/javascript">
    <!--
    window.location.href="<?php echo $cfgUrlToProject."/".$fileNoPermission."?messageCode=".$fileUserPermissionMode."&messageType=user"; ?>";
    -->
    </script>
    <?php
    exit;
}
// End of checking the permissions


// create new userFunctions object
$survey = &new surveyFunctions;

// create Template IT object
$tpl = new HTML_Template_IT($cfgPathToSurveyTemplates);

// load template
$tpl->loadTemplatefile($templateSurveyAdminPreview, true, true);

//set the links
$tpl->setVariable( "lnk_settings", $fileSurveyEdit."?projectId=".$projectId."&warningChecked=yes" );
$tpl->setVariable( "lnk_preview", $fileSurveyAdminPreview."?projectId=".$projectId );
$tpl->setVariable( "lnk_clearing", $fileSurveyMake."?projectId=".$projectId );
$tpl->setVariable( "lnk_delete", $fileSurveyDelete."?projectId=".$projectId );

// set title
$tpl->setVariable( "applicationtitle", $cfgApplicationType.$cfgApplicationVersion);

// init dbFunctions
$dbFunctions = &new dbFunctions;

// get survey data
$surveyData = $dbFunctions->tabToArrayWhithArg($cfgSrvyTabSurvey,array("PROJECT_ID_PK"=>"$projectId"));

$outputLink = $cfgUrlToOutput."/".$surveyData[0]["PROJECT_OUTPUTDIR"]."/";

if (!$surveyData[0][PROJECT_ACTIVE])
$tpl->setVariable( "url","about:blanc");
else
$tpl->setVariable( "url", $outputLink.$fileSurveyPreview."?projectId=".$surveyData[0]["PROJECT_ID_PK"] );


// parse template
$tpl->parse();

// get the parsed template and print it
$tpl->get();
$tpl->show();

?>