<?php
// +----------------------------------------------------------------------+
// | survey pilot                                                         |
// +----------------------------------------------------------------------+
// | Copyright (c) 2002 serie a - Digitale Medien und Systeme GmbH        |
// +----------------------------------------------------------------------+
// | Authors: 	Jrn Allert <allert@serie-a.de>                           |
// |          	Rene Renk   <renk@serie-a.de>                             |
// +----------------------------------------------------------------------+
//
// $Id: survey.question.add.php,v 1.1.1.1 2004/07/15 13:32:05 opensurveypilot Exp $

require_once("./lib/survey.question.inc.php"); // survey question create functions

// start session
@session_start();

// delete unfinished questuions in session
unset($_SESSION["newQuestion"]);

// require all configuration files and libraries
require_once("./../config/config.inc.php"); // common config file
require_once($cfgPathToConf."/file.inc.php"); // project files
require_once($cfgPathToLib."/common.inc.php"); // common functions
require_once($cfgPathToSurveyFiles."/config/survey.config.inc.php"); // survey files
require_once($cfgPathToSurveyFiles."/config/survey.file.inc.php"); // survey files
require_once($cfgPathToSurveyFiles."/lib/survey.inc.php"); // survey functions
require_once($cfgPathToAuthFiles."/lib/user.inc.php"); // auth user functions
require_once($cfgPathToAuthFiles."/config/auth.file.inc.php"); // auth user functions
require_once($cfgPathToAuthFiles."/lib/permission.inc.php"); // auth permission functions
require_once("HTML/Template/IT.php"); // PEAR::HTML_TEMPLATE_IT
 
// create new userFunctions object
$client = &new userFunctions;

//login check
if ($client->getAuthentication($_SESSION["sessionId"], session_id()) ==  false)
{
    //redirect to login page
    ?>
    <script type="text/javascript">
    <!--
    window.location.href="<?php echo $cfgUrlToProject."/".$fileAuthLogin; ?>";
    -->
    </script>
    <?php
    exit;
}

// function permission check
if($_SESSION["sessionUserStatusId"] < $permSurveyQuestionAdd)
{
    ?>
    <script type="text/javascript">
    <!--
    window.location.href="<?php echo $cfgUrlToProject."/".$fileNoPermission."?messageCode=2"; ?>";
    -->
    </script>
    <?php
    exit;
}

// get projectId
$projectId = $_GET["projectId"];

// create new permissionFunctions object
$permission = &new permissionFunctions;
// get Permission
$permissionMode = $permission->getPermissionMode($_SESSION["sessionUserId"], $projectId, 1);
if($permission->errorMessage)
{
    echo $permission->errorMessage;
}
// permission must be 2 (write)
if($permissionMode < 2)
{
    ?>
    <script type="text/javascript">
    <!--
    window.location.href="<?php echo $cfgUrlToProject."/".$fileNoPermission."?messageCode=1"; ?>";
    -->
    </script>
    <?php
    exit;
}

// init survey functions
$survey = &new surveyFunctions();

if(!$_GET["warningChecked"])
{	
	// fetch groupdata
	$surveyGroupEditArray = $survey->getSurveyGroup($_GET["selectedGroupId"]);
	$surveyData			  = $survey->getSurveyForGroup($surveyGroupEditArray[0]["FORM_PROJECT_ID_FK"]);
	
	// activecheck
	if ($surveyData[0]["PROJECT_ACTIVE"]=="yes")
	{
		// create Template IT object
		$tpl = new HTML_Template_IT($cfgPathToSurveyTemplates);
		
		// load template
		$tpl->loadTemplatefile($templateSurveyActiveWarning, true, true);
		
		// set title
		$tpl->setVariable("applicationtitle", $cfgApplicationType.$cfgApplicationVersion);
		
		$tpl->setVariable( "groupId", $_GET["selectedGroupId"]);
		$tpl->setVariable( "projectId", $_GET["projectId"]);
		$tpl->get();
		$tpl->show();
		exit;
	}
}

if(!$_GET["selectedGroupId"])
{
    $groupId = $_GET["groupId"];
}
else
{
    $groupId = $_GET["selectedGroupId"];
}
$myQuestion = new Question($projectId);
$myQuestion->setProjectId($projectId);
$myQuestion->setGroupId($groupId);
$_SESSION["newQuestion"] = $myQuestion;

$tpl = new HTML_Template_IT($cfgPathToSurveyTemplates);
$tpl->loadTemplatefile($templateSurveyQuestionAdd, true, false); // dont remove untouched blocks

// set title
$tpl->setVariable("applicationtitle", $cfgApplicationType.$cfgApplicationVersion);

$tpl->setVariable("imageuploadlink", $fileSurveyQuestionInsertImage."?imageuse=imageuse&imagename=imagename&formname=addquestion");
$tpl->setVariable("imageuploadtarget", "imageupload");

$tpl->setVariable("question", $_POST["question"]);
$tpl->setVariable("errors", $_GET["errors"]);
$tpl->setVariable("groupId", $groupId);
$tpl->parse();
$tpl->show();
?>
