<?php
// +----------------------------------------------------------------------+
// | survey pilot                                                         |
// +----------------------------------------------------------------------+
// | Copyright (c) 2002 serie a - Digitale Medien und Systeme GmbH        |
// +----------------------------------------------------------------------+
// | Authors: 	Jrn Allert <allert@serie-a.de>                           |
// |          	Rene Renk <renk@serie-a.de>                               |
// +----------------------------------------------------------------------+
//
// $Id: survey.question.delete.php,v 1.1.1.1 2004/07/15 13:32:11 opensurveypilot Exp $

// start session
@session_start();

// require all configuration files and libraries
require_once("./../config/config.inc.php"); // common config file
require_once($cfgPathToConf."/file.inc.php"); // project files
require_once($cfgPathToLib."/common.inc.php"); // common functions
require_once($cfgPathToSurveyFiles."/config/survey.config.inc.php"); // survey configuration
require_once($cfgPathToSurveyFiles."/config/survey.file.inc.php"); // survey files
require_once($cfgPathToSurveyFiles."/lib/survey.inc.php"); // survey functions
require_once($cfgPathToAuthFiles."/lib/user.inc.php"); // auth user functions
require_once($cfgPathToAuthFiles."/config/auth.file.inc.php"); // auth user files
require_once($cfgPathToAuthFiles."/lib/permission.inc.php"); // permission functions
require_once("HTML/Template/IT.php"); // PEAR::HTML_TEMPLATE_IT

// create new userFunctions object
$client = &new userFunctions;

//login check
if ($client->getAuthentication($_SESSION["sessionId"], session_id()) == false)
{
    //redirect to login page
    ?>
    <script type="text/javascript">
    <!--
    window.location.href="<?php echo $cfgUrlToProject."/".$fileAuthLogin; ?>";
    -->
    </script>
    <?php
    exit;
}

// Start of checking the permissions 
$fileUserPermissionMode	=	$permUserSurveyQuestionDelete;
$filePermissionMode		=	$permSurveyQuestionDelete;

// filepermission
if($_SESSION["sessionUserStatusId"] < $filePermissionMode)
{
    ?>
    <script type="text/javascript">
    <!--
    window.location.href="<?php echo $cfgUrlToProject."/".$fileNoPermission."?messageCode=".$filePermissionMode."&messageType=file"; ?>";
    -->
    </script>
    <?php
    exit;
}
// get projectId
$projectId = (isset($_GET["projectId"])) ? $_GET["projectId"] : $_POST["projectId"];

// create new permissionFunctions object
$permission = &new permissionFunctions;

// get Permission
$permissionMode = $permission->getPermissionMode($_SESSION["sessionUserId"], $projectId, 1);
if($permission->errorMessage)
{
    echo $permission->errorMessage;
}
// userpermission
if($permissionMode < $fileUserPermissionMode)
{
    ?>
    <script type="text/javascript">
    <!--
    window.location.href="<?php echo $cfgUrlToProject."/".$fileNoPermission."?messageCode=".$fileUserPermissionMode."&messageType=user"; ?>";
    -->
    </script>
    <?php
    exit;
}
// End of checking the permissions

// get questionId
if(isset($_GET["questionId"]))
{
    $questionId = $_GET["questionId"];
}

// create new groupFunctions object
$surveyQuestionDelete = &new surveyFunctions;

// check if form was submitted
if($_SERVER["REQUEST_METHOD"] == "POST")
{
    $questionId = $_POST["questionId"];
	
    // delete group
    $surveyQuestionDelete->deleteSurveyQuestion($questionId);
    if($surveyQuestionDelete->errorMessage)
    {
        $surveyError .=  $surveyQuestionDelete->$errorMessage;
    }
    
    // redirect to success page
    if(!isset($surveyError))
    {
	    ?>	
        <script type="text/javascript">
        <!--
        opener.parent.content.location.reload();
		opener.parent.projecttree.location.reload();
		self.close();
        -->
		</script>
	    <?php
    }
}

// fetch groupdata
$surveyQuestionDeleteArray = $surveyQuestionDelete->getQuestionDetail($questionId);


/*
if(!$_GET["warningChecked"])
{	
	// fetch groupdata
	$surveyGroupEditArray = $surveyQuestionDelete->getSurveyGroup($surveyQuestionDeleteArray[0]["FORMTYPE_FORM_ID_FK"]);
	$surveyData			  = $surveyQuestionDelete->getSurveyForGroup($surveyGroupEditArray[0]["FORM_PROJECT_ID_FK"]);
	
	// activecheck
	if ($surveyData[0]["PROJECT_ACTIVE"]=="yes")
	{
		// create Template IT object
		$tpl = new HTML_Template_IT($cfgPathToSurveyTemplates);
		
		// load template
		$tpl->loadTemplatefile($templateSurveyActiveWarning, true, true);
		
		// set title
		$tpl->setVariable( "applicationtitle", $cfgApplicationType.$cfgApplicationVersion);

		$tpl->setVariable( "questionId", $questionId);
        $tpl->setVariable( "projectId", $projectId );
		$tpl->get();
		$tpl->show();
		exit;
	}
}
*/

// create Template IT object
$tpl = new HTML_Template_IT($cfgPathToSurveyTemplates);

// load template
$tpl->loadTemplatefile($templateSurveyQuestionDelete, true, false);

// set title
$tpl->setVariable( "applicationtitle", $cfgApplicationType.$cfgApplicationVersion);

if($surveyQuestionDelete->errorMessage)
{
    $surveyError .= $surveyQuestionDelete->$errorMessage;
}

for($j=0;$j<count($surveyQuestionDeleteArray);$j++)
{
	$tpl->setVariable( "name", $surveyQuestionDeleteArray[$j]["FORMTYPE_QUESTION"] ); //otto: FORMELEMENT_HEADER
}

$tpl->setVariable( "formaction", $fileSurveyQuestionDelete );
$tpl->setVariable( "errors", $surveyError );
$tpl->setVariable( "questionId", $questionId );
$tpl->setVariable( "projectId", $projectId );

$tpl->setVariable( "lnk_detail", $fileSurveyQuestionDetailview."?projectId=$projectId&groupId=$groupId&questionId=".$questionId."&orderId=".$orderId );
$tpl->setVariable( "lnk_edit", $fileSurveyQuestionEdit."?projectId=$projectId&groupId=$groupId&questionId=".$questionId."&orderId=".$orderId );
$tpl->setVariable( "lnk_properties", $fileSurveyQuestionProperties."?projectId=$projectId&groupId=$groupId&questionId=".$questionId."&orderId=".$orderId );
$tpl->setVariable( "lnk_position", $fileSurveyQuestionOrder."?projectId=$projectId&groupId=$groupId&questionId=".$questionId."&orderId=".$orderId );
$tpl->setVariable( "lnk_delete", $fileSurveyQuestionDelete."?projectId=$projectId&groupId=$groupId&questionId=".$questionId."&orderId=".$orderId );

// parse template
$tpl->parse();

// get the parsed template and print it
$tpl->get();
$tpl->show();   
?>