<?php
// +----------------------------------------------------------------------+
// | survey pilot                                                         |
// +----------------------------------------------------------------------+
// | Copyright (c) 2002 serie a - Digitale Medien und Systeme GmbH        |
// +----------------------------------------------------------------------+
// | Authors: 	Jrn Allert <allert@serie-a.de>                           |
// |          	Rene Renk   <renk@serie-a.de>                             |
// +----------------------------------------------------------------------+
//
// $Id: survey.question.detailview.php,v 1.1.1.1 2004/07/15 13:32:13 opensurveypilot Exp $


// start session
@session_start();

// require all configuration files and libraries
require_once("./../config/config.inc.php"); // common config file
require_once("./lib/survey.question.inc.php"); // survey question create functions
require_once($cfgPathToConf."/file.inc.php"); // project files
require_once($cfgPathToLib."/common.inc.php"); // common functions
require_once($cfgPathToSurveyFiles."/config/survey.config.inc.php"); // survey configuration
require_once($cfgPathToSurveyFiles."/config/survey.file.inc.php"); // survey files
require_once($cfgPathToSurveyFiles."/lib/survey.inc.php"); // survey functions
require_once($cfgPathToAuthFiles."/lib/user.inc.php"); // auth user functions
require_once($cfgPathToAuthFiles."/config/auth.file.inc.php"); // auth user files
require_once($cfgPathToAuthFiles."/lib/permission.inc.php"); // permission functions
require_once("HTML/Template/IT.php"); // PEAR::HTML_TEMPLATE_IT

// create new userFunctions object
$client = &new userFunctions;

//login check
if ($client->getAuthentication($_SESSION["sessionId"], session_id()) ==  false)
{
    //redirect to login page
    ?>
    <script type="text/javascript">
    <!--
    window.location.href="<?php echo $cfgUrlToProject."/".$fileAuthLogin; ?>";
    -->
    </script>
    <?php
    exit;
}

// Start of checking the permissions 
$fileUserPermissionMode	=	$permUserSurveyQuestionDetail;
$filePermissionMode		=	$permSurveyQuestionDetail;

// filepermission
if($_SESSION["sessionUserStatusId"] < $filePermissionMode)
{
    ?>
    <script type="text/javascript">
    <!--
    window.location.href="<?php echo $cfgUrlToProject."/".$fileNoPermission."?messageCode=".$filePermissionMode."&messageType=file"; ?>";
    -->
    </script>
    <?php
    exit;
}



// get projectId
$projectId = (isset($_GET["projectId"])) ? $_GET["projectId"] : $_POST["projectId"];

$groupId = (isset($_GET["groupId"])) ? $_GET["groupId"] : $_POST["groupId"];

$questionId = (isset($_GET["questionId"])) ? $_GET["questionId"] : $_POST["questionId"];

$orderId = (isset($_GET["orderId"])) ? $_GET["orderId"] : $_POST["orderId"];

// create new permissionFunctions object
$permission = &new permissionFunctions;

// get Permission
$permissionMode = $permission->getPermissionMode($_SESSION["sessionUserId"], $projectId, 1);
if($permission->errorMessage)
{
    echo $permission->errorMessage;
}
// userpermission
if($permissionMode < $fileUserPermissionMode)
{
    ?>
    <script type="text/javascript">
    <!--
    window.location.href="<?php echo $cfgUrlToProject."/".$fileNoPermission."?messageCode=".$fileUserPermissionMode."&messageType=user"; ?>";
    -->
    </script>
    <?php
    exit;
}
// End of checking the permissions
 
if(isset($_GET["questionId"]))
{
    $questionId = $_GET["questionId"];
}

if(!$_GET["warningChecked"])
{	
	$survey = &new surveyFunctions();
	// fetch groupdata
	$surveyGroupEditArray = $survey->getSurveyGroup($groupId);
	$surveyData			  = $survey->getSurveyForGroup($surveyGroupEditArray[0]["FORM_PROJECT_ID_FK"]);
	
	// activecheck
	if ($surveyData[0]["PROJECT_ACTIVE"]=="yes")
	{
		// create Template IT object
		$tpl = new HTML_Template_IT($cfgPathToSurveyTemplates);
		
		// load template
		$tpl->loadTemplatefile($templateSurveyActiveWarning, true, true);
		$tpl->setVariable("applicationtitle", $cfgApplicationType.$cfgApplicationVersion);
		
		$tpl->setVariable("questionId", $questionId);
        $tpl->setVariable("projectId", $projectId);
		$tpl->get();
		$tpl->show();
		exit;
	}
}

$myQuestion = &Question::QuestionWithId($questionId,true);

$tpl = new HTML_Template_IT($cfgPathToSurveyTemplates);
$tpl->loadTemplatefile($templateSurveyQuestionDetailview, true, true);

$tpl->setVariable( "lnk_detail", $fileSurveyQuestionDetailview."?projectId=$projectId&groupId=$groupId&questionId=".$questionId."&orderId=".$orderId );
$tpl->setVariable( "lnk_edit", $fileSurveyQuestionEdit."?projectId=$projectId&groupId=$groupId&questionId=".$questionId."&orderId=".$orderId );
$tpl->setVariable( "lnk_properties", $fileSurveyQuestionProperties."?projectId=$projectId&groupId=$groupId&questionId=".$questionId."&orderId=".$orderId );
$tpl->setVariable( "lnk_position", $fileSurveyQuestionOrder."?projectId=$projectId&groupId=$groupId&questionId=".$questionId."&orderId=".$orderId );
$tpl->setVariable( "lnk_delete", $fileSurveyQuestionDelete."?projectId=$projectId&groupId=$groupId&questionId=".$questionId."&orderId=".$orderId );

// set title
$tpl->setVariable( "applicationtitle", $cfgApplicationType.$cfgApplicationVersion);

$tpl->setVariable( "questiontype" , $myQuestion->type );
$tpl->setVariable( "question" , $myQuestion->question );

// display according to types
if (($myQuestion->type == "textarea") || ($myQuestion->type == "text") || ($myQuestion->type == "switchtext"))
{
	;// do nothing
}
elseif (($myQuestion->type != "texttable") && ($myQuestion->type != "radiotable") && ($myQuestion->type != "checkboxtable"))
{
	$tpl->setCurrentBlock("nomatrixheader");
	
	$tpl->setVariable( "optionname" , $lang_script["survey.question.detailview.php"]["optionname"]);
	$tpl->setVariable( "valuename" , $lang_script["survey.question.detailview.php"]["valuename"]);
	$tpl->setVariable( "switchname" , $lang_script["survey.question.detailview.php"]["switchname"]);
	
	$tpl->parseCurrentBlock();
	
	// option data
	$optNumber = count($myQuestion->optionHeader);
	for ($i=0;$i<$optNumber;++$i)
	{
		$tpl->setCurrentBlock("nomatrixvalues");
		
		$tpl->setVariable( "option" , $myQuestion->optionHeader[$i] );
		$tpl->setVariable( "value" , $myQuestion->optionMultipleValue[$i] );
		$tpl->setVariable( "switch" , $myQuestion->toSwitchGroupName[$i] );
		
		$tpl->parseCurrentBlock();
	}
}
else
{
	$tpl->setCurrentBlock("matrixheader");
	
	$tpl->setVariable( "matrixcolumnname" , $lang_script["survey.question.detailview.php"]["matrixcolumnname"]);
	$tpl->setVariable( "matrixrowname" , $lang_script["survey.question.detailview.php"]["matrixrowname"]);
	$tpl->setVariable( "matrixvaluename" , $lang_script["survey.question.detailview.php"]["matrixvaluename"]);
	$tpl->setVariable( "matrixswitchname" , $lang_script["survey.question.detailview.php"]["matrixswitchname"]);
		
	$tpl->parseCurrentBlock();
	
	// option data
	$optNumber = count($myQuestion->optionHeader);
	for ($i=0;$i<$optNumber;++$i)
	{
		$tpl->setCurrentBlock("matrixvalues");
		
		$tpl->setVariable( "matrixcolumn" , $myQuestion->optionHeader[$i] );
		$tpl->setVariable( "matrixrow" , $myQuestion->optionAddHeader[$i] );
		$tpl->setVariable( "matrixvalue" , $myQuestion->optionMultipleValue[$i] );
		$tpl->setVariable( "matrixswitch" , $myQuestion->toSwitchGroupName[$i] );
		
		$tpl->parseCurrentBlock();
	}
}
// required
if ($myQuestion->questionRules["required"] && $myQuestion->questionRules["required"] != '##tobedeleted##')
{
	$tpl->setCurrentBlock("required");
	
	$tpl->setVariable( "required" , $lang_script["survey.question.detailview.php"]["yes"]);
	
	$tpl->parseCurrentBlock();
}
// numeric
if ($myQuestion->questionRules["numeric"] && $myQuestion->questionRules["numeric"] != '##tobedeleted##')
{
	$tpl->setCurrentBlock("numeric");
	
	$tpl->setVariable( "numeric" , $lang_script["survey.question.detailview.php"]["yes"]);
	
	$tpl->parseCurrentBlock();
}
// align
if ($myQuestion->align)
{
	$tpl->setCurrentBlock("align");
	
	$tpl->setVariable( "alignment" , (($myQuestion->align == "ver") ? $lang_script["survey.question.detailview.php"]["vertical"] : $lang_script["survey.question.detailview.php"]["horizontal"] ) );
	
	$tpl->parseCurrentBlock();
}
// checkallowed
if ($myQuestion->ruleCheckAllow)
{
	$tpl->setCurrentBlock("checkallowed");
	
	$tpl->setVariable( "checkallowed" , "$myQuestion->ruleCheckAllow" );
	
	$tpl->parseCurrentBlock();
}

$tpl->parse();
$tpl->get();
$tpl->show();
?>
