<?php
// +----------------------------------------------------------------------+
// | survey pilot                                                         |
// +----------------------------------------------------------------------+
// | Copyright (c) 2002 serie a - Digitale Medien und Systeme GmbH        |
// +----------------------------------------------------------------------+
// | Authors: 	Jrn Allert <allert@serie-a.de>                           |
// |          	Rene Renk   <renk@serie-a.de>                             |
// +----------------------------------------------------------------------+
//
// $Id: survey.question.edit.php,v 1.1.1.1 2004/07/15 13:32:15 opensurveypilot Exp $

require_once("./lib/survey.question.inc.php"); // survey question create functions

// start session
@session_start();

// delete unfinished questuions in session
unset($_SESSION["newQuestion"]);

// require all configuration files and libraries
require_once("./../config/config.inc.php"); // common config file
require_once($cfgPathToConf."/file.inc.php"); // project files
require_once($cfgPathToLib."/common.inc.php"); // common functions
require_once($cfgPathToSurveyFiles."/config/survey.config.inc.php"); // survey files
require_once($cfgPathToSurveyFiles."/config/survey.file.inc.php"); // survey files
require_once($cfgPathToSurveyFiles."/lib/survey.inc.php"); // survey functions
require_once($cfgPathToAuthFiles."/lib/user.inc.php"); // auth user functions
require_once($cfgPathToAuthFiles."/config/auth.file.inc.php"); // auth user files
require_once($cfgPathToAuthFiles."/lib/permission.inc.php"); // permission functions
require_once("HTML/Template/IT.php"); // PEAR::HTML_TEMPLATE_IT

// create new userFunctions object
$client = &new userFunctions; 

//login check
if ($client->getAuthentication($_SESSION["sessionId"], session_id()) ==  false)
 
{
    //redirect to login page
    ?>   <script type="text/javascript">
    <!--
    window.location.href="<?php echo $cfgUrlToProject."/".$fileAuthLogin; ?>";
    -->
    </script>
    <?php
    exit;
}

// Start of checking the permissions 
$fileUserPermissionMode	=	$permUserSurveyQuestionEdit;
$filePermissionMode		=	$permSurveyQuestionEdit;

// filepermission
if($_SESSION["sessionUserStatusId"] < $filePermissionMode)
{
    ?>
    <script type="text/javascript">
    <!--
    window.location.href="<?php echo $cfgUrlToProject."/".$fileNoPermission."?messageCode=".$filePermissionMode."&messageType=file"; ?>";
    -->
    </script>
    <?php
    exit;
}

// get projectId
$projectId = (isset($_GET["projectId"])) ? $_GET["projectId"] : $_POST["projectId"];

$groupId = (isset($_GET["groupId"])) ? $_GET["groupId"] : $_POST["groupId"];

$questionId = (isset($_GET["questionId"])) ? $_GET["questionId"] : $_POST["questionId"];

$orderId = (isset($_GET["orderId"])) ? $_GET["orderId"] : $_POST["orderId"];

// create new permissionFunctions object
$permission = &new permissionFunctions;

// get Permission
$permissionMode = $permission->getPermissionMode($_SESSION["sessionUserId"], $projectId, 1);
if($permission->errorMessage)
{
    echo $permission->errorMessage;
}
// userpermission
if($permissionMode < $fileUserPermissionMode)
{
    ?>
    <script type="text/javascript">
    <!--
    window.location.href="<?php echo $cfgUrlToProject."/".$fileNoPermission."?messageCode=".$fileUserPermissionMode."&messageType=user"; ?>";
    -->
    </script>
    <?php
    exit;
}
// End of checking the permissions

$myQuestion = &Question::QuestionWithId($questionId);

/*
if(!$_GET["warningChecked"])
{	
	$survey = &new surveyFunctions();
	// fetch groupdata
	$surveyGroupEditArray = $survey->getSurveyGroup($myQuestion->groupId);
	$surveyData			  = $survey->getSurveyForGroup($surveyGroupEditArray[0]["FORM_PROJECT_ID_FK"]);
	
	// activecheck
	if ($surveyData[0]["PROJECT_ACTIVE"]=="yes")
	{
		// create Template IT object
		$tpl = new HTML_Template_IT($cfgPathToSurveyTemplates);
		
		// load template
		$tpl->loadTemplatefile($templateSurveyActiveWarning, true, true);
		$tpl->setVariable("applicationtitle", $cfgApplicationType.$cfgApplicationVersion);
		
		$tpl->setVariable("questionId", $questionId);
        $tpl->setVariable("projectId", $projectId);
		$tpl->get();
		$tpl->show();
		exit;
	}
}
*/

$_SESSION["newQuestion"] = $myQuestion;

$tpl = new HTML_Template_IT($cfgPathToSurveyTemplates);

$tpl->loadTemplatefile($templateSurveyQuestionEdit, true, true); // dont remove untouched blocks
$tpl->setVariable("applicationtitle", $cfgApplicationType.$cfgApplicationVersion);
$tpl->setVariable("errors", ($_GET["errors"]) ? $_GET["errors"] : " ");

$tpl->setVariable("question", $myQuestion->question);
$tpl->setVariable("projectId", $projectId);
$tpl->setVariable("questionId", $questionId);

$tpl->setVariable( "lnk_detail", $fileSurveyQuestionDetailview."?projectId=$projectId&groupId=$groupId&questionId=".$questionId."&orderId=".$orderId );
$tpl->setVariable( "lnk_edit", $fileSurveyQuestionEdit."?projectId=$projectId&groupId=$groupId&questionId=".$questionId."&orderId=".$orderId );
$tpl->setVariable( "lnk_properties", $fileSurveyQuestionProperties."?projectId=$projectId&groupId=$groupId&questionId=".$questionId."&orderId=".$orderId );
$tpl->setVariable( "lnk_position", $fileSurveyQuestionOrder."?projectId=$projectId&groupId=$groupId&questionId=".$questionId."&orderId=".$orderId );
$tpl->setVariable( "lnk_delete", $fileSurveyQuestionDelete."?projectId=$projectId&groupId=$groupId&questionId=".$questionId."&orderId=".$orderId );

// get imagename
$imgNameFromTag	=	explode("\"", $myQuestion->questionImage);

$tpl->setVariable("imageuploadlink", $fileSurveyQuestionInsertImage."?currentImage=".urlencode($imgNameFromTag[1])."&imageuse=imageuse&imagename=imagename&formname=addquestion");
$tpl->setVariable("imageuploadtarget", "imageupload");

$tpl->setVariable("imageuse", ($myQuestion->questionImage) ? " checked" : "");
$tpl->setVariable("imagename", ($myQuestion->questionImage) ? addslashes($myQuestion->questionImage) : ""); // if changes also change js in tpl 030410-rr

$tpl->setVariable("selectSelected", ($myQuestion->type == "select") ? " selected" : "");
$tpl->setVariable("radioSelected", ($myQuestion->type == "radio") ? " selected" : "");
$tpl->setVariable("switchtextSelected", ($myQuestion->type == "switchtext") ? " selected" : "");
$tpl->setVariable("groupedtextSelected", ($myQuestion->type == "groupedtext") ? " selected" : "");
$tpl->setVariable("tablegroupSelected", (($myQuestion->type == "texttable")||($myQuestion->type == "radiotable")||($myQuestion->type == "checkboxtable")) ? " selected" : "");
$tpl->setVariable("checkboxSelected", ($myQuestion->type == "checkbox") ? " selected" : "");
$tpl->setVariable("textSelected", ($myQuestion->type == "text") ? " selected" : "");
$tpl->setVariable("textareaSelected", ($myQuestion->type == "textarea") ? " selected" : "");

$tpl->parse();
$tpl->show();
?>
