<?php
// +----------------------------------------------------------------------+
// | survey pilot                                        	          |
// +----------------------------------------------------------------------+
// | Copyright (c) 2002 serie a - Digitale Medien und Systeme GmbH        |
// +----------------------------------------------------------------------+
// | Authors: 	Jrn Allert <allert@serie-a.de>                           |
// |          	Rene Renk   <renk@serie-a.de>                             |
// +----------------------------------------------------------------------+
//
// $Id: survey.question.edit.radio.php,v 1.1.1.1 2004/07/15 13:32:17 opensurveypilot Exp $

require_once("./lib/survey.question.inc.php"); // survey question create functions

// start session
@session_start();

// require all configuration files and libraries
require_once("./../config/config.inc.php"); // common config file
require_once($cfgPathToConf."/file.inc.php"); // project files
require_once($cfgPathToLib."/common.inc.php"); // common functions
require_once($cfgPathToSurveyFiles."/config/survey.config.inc.php"); // survey configuration
require_once($cfgPathToSurveyFiles."/config/survey.file.inc.php"); // survey files
require_once($cfgPathToSurveyFiles."/lib/survey.inc.php"); // survey functions
require_once($cfgPathToAuthFiles."/lib/user.inc.php"); // auth user functions
require_once($cfgPathToAuthFiles."/config/auth.file.inc.php"); // auth user files
require_once($cfgPathToAuthFiles."/lib/permission.inc.php"); // permission functions
require_once("HTML/Template/IT.php"); // PEAR::HTML_TEMPLATE_IT


// create new userFunctions object
$client = &new userFunctions;

//login check
if ($client->getAuthentication($_SESSION["sessionId"], session_id()) ==  false)
{
    //redirect to login page
    ?>
    <script type="text/javascript">
    <!--
    window.location.href="<?php echo $cfgUrlToProject."/".$fileAuthLogin; ?>";
    -->
    </script>
    <?php
    exit;
}  

// function permission check
if($_SESSION["sessionUserStatusId"] < $permSurveyQuestionEditRadio)
{
    ?>
    <script type="text/javascript">
    <!--
    window.location.href="<?php echo $cfgUrlToProject."/".$fileNoPermission."?messageCode=2"; ?>";
    -->
    </script>
    <?php
    exit;
}

// get projectId
$projectId = (isset($_GET["projectId"])) ? $_GET["projectId"] : $_SESSION["newQuestion"]->projectId;

$groupId = (isset($_GET["groupId"])) ? $_GET["groupId"] : $_POST["groupId"];

$questionId = (isset($_GET["questionId"])) ? $_GET["questionId"] : $_POST["questionId"];

$orderId = (isset($_GET["orderId"])) ? $_GET["orderId"] : $_POST["orderId"];

// create new permissionFunctions object
$permission = &new permissionFunctions;
// get Permission
$permissionMode = $permission->getPermissionMode($_SESSION["sessionUserId"], $projectId, 1);
if($permission->errorMessage)
{
    echo $permission->errorMessage;
}
// permission must be 2 (write)
if($permissionMode < 2)
{
    ?>
    <script type="text/javascript">
    <!--
    window.location.href="<?php echo $cfgUrlToProject."/".$fileNoPermission."?messageCode=1"; ?>";
    -->
    </script>
    <?php
    exit;
}
 
if($_SERVER["REQUEST_METHOD"] == "POST")
{
	// get step
	$step = $_POST["step"];
	
	// save question, type // get rules
	//
	if($step == 2)
    {	 
		// save values to question object
		$myQuestion = $_SESSION["newQuestion"];
		$myQuestion->setType($_POST["type"]);
		$myQuestion->setQuestion($_POST["question"]);
		($_POST["imageuse"]) ? $myQuestion->setQuestionImage(trim($_POST["imagename"])) : $myQuestion->setQuestionImage("");
		$_SESSION["newQuestion"] = $myQuestion;
		
		// invalid back to step 1
		if(!$myQuestion->isValid(2)) // back to step 1
		{
			$tpl = new HTML_Template_IT($cfgPathToSurveyTemplates);
			$tpl->loadTemplatefile($templateSurveyQuestionAdd, true, false); // dont remove untouched blocks
			$tpl->setVariable("applicationtitle", $cfgApplicationType.$cfgApplicationVersion);
			$tpl->setVariable("errors", $myQuestion->errorMessage);
			
			$tpl->setVariable("question", $myQuestion->question);
			$tpl->setVariable("radioSelected", " selected" );
			$tpl->setVariable("groupId", $myQuestion->groupId);
			
			$tpl->setVariable( "lnk_detail", $fileSurveyQuestionDetailview."?projectId=$projectId&groupId=$groupId&questionId=".$questionId."&orderId=".$orderId );
			$tpl->setVariable( "lnk_edit", $fileSurveyQuestionEdit."?projectId=$projectId&groupId=$groupId&questionId=".$questionId."&orderId=".$orderId );
			$tpl->setVariable( "lnk_properties", $fileSurveyQuestionProperties."?projectId=$projectId&groupId=$groupId&questionId=".$questionId."&orderId=".$orderId );
			$tpl->setVariable( "lnk_position", $fileSurveyQuestionOrder."?projectId=$projectId&groupId=$groupId&questionId=".$questionId."&orderId=".$orderId );
			$tpl->setVariable( "lnk_delete", $fileSurveyQuestionDelete."?projectId=$projectId&groupId=$groupId&questionId=".$questionId."&orderId=".$orderId );


			$tpl->parse();
			$tpl->show();
			exit;
		}
		else
		{
		  
			$tpl = new HTML_Template_IT($cfgPathToSurveyTemplates);
			$tpl->loadTemplatefile($templateSurveyQuestionEditCheckbox, true, true); // do remove untouched blocks
			$tpl->touchBlock("Header");
			$tpl->setVariable("applicationtitle", $cfgApplicationType.$cfgApplicationVersion);
			
			$tpl->touchBlock("Step2");
			$tpl->setVariable("step", "3");
			$tpl->setVariable("current", 2);
			if(intval($myQuestion->size) < 1)
			{
				$value = 1;
			}
			else
			{
				$value = intval($myQuestion->size);
			}
			$tpl->setVariable("value", $value);
			$tpl->setVariable("alignselected".(($myQuestion->align == "ver") ? "ver" : ""), " checked" );
			$tpl->touchBlock("Footer");
			
			$tpl->setVariable( "lnk_detail", $fileSurveyQuestionDetailview."?projectId=$projectId&groupId=$groupId&questionId=".$questionId."&orderId=".$orderId );
			$tpl->setVariable( "lnk_edit", $fileSurveyQuestionEdit."?projectId=$projectId&groupId=$groupId&questionId=".$questionId."&orderId=".$orderId );
			$tpl->setVariable( "lnk_properties", $fileSurveyQuestionProperties."?projectId=$projectId&groupId=$groupId&questionId=".$questionId."&orderId=".$orderId );
			$tpl->setVariable( "lnk_position", $fileSurveyQuestionOrder."?projectId=$projectId&groupId=$groupId&questionId=".$questionId."&orderId=".$orderId );
			$tpl->setVariable( "lnk_delete", $fileSurveyQuestionDelete."?projectId=$projectId&groupId=$groupId&questionId=".$questionId."&orderId=".$orderId );

			$tpl->parse();
			$tpl->show();
			exit;
		}
	
	}
	// save size, align // get headers, get headerimages
	//
	elseif($step == 3)
    {	
		// save values to question object
		$myQuestion = $_SESSION["newQuestion"]; 
		$size = intval($_POST["size"]);
		$myQuestion->setSize($size);
		$myQuestion->setAlign($_POST["align"]);
		$_SESSION["newQuestion"] = $myQuestion;
		
		// check if valid size
		if(!$myQuestion->isValid(3)) // back to step 1
		{
			$tpl = new HTML_Template_IT($cfgPathToSurveyTemplates);
			$tpl->loadTemplatefile($templateSurveyQuestionEditCheckbox, true, true); // do remove untouched blocks
			$tpl->touchBlock("Header");
			$tpl->setVariable("applicationtitle", $cfgApplicationType.$cfgApplicationVersion);
			$tpl->setVariable("errors", $myQuestion->errorMessage);
			
			$tpl->touchBlock("Step2");
			$tpl->setVariable("step", "3");
			$tpl->setVariable("current", 2);
			if(intval($myQuestion->size) < 1)
			{
				$value = 1;
			}
			else
			{
				$value = intval($myQuestion->size);
			}
			$tpl->setVariable("value", $value);
			$tpl->setVariable("alignselected".(($myQuestion->align == "ver") ? "ver" : ""), " checked" );
			$tpl->touchBlock("Footer");
			
			$tpl->setVariable( "lnk_detail", $fileSurveyQuestionDetailview."?projectId=$projectId&groupId=$groupId&questionId=".$questionId."&orderId=".$orderId );
			$tpl->setVariable( "lnk_edit", $fileSurveyQuestionEdit."?projectId=$projectId&groupId=$groupId&questionId=".$questionId."&orderId=".$orderId );
			$tpl->setVariable( "lnk_properties", $fileSurveyQuestionProperties."?projectId=$projectId&groupId=$groupId&questionId=".$questionId."&orderId=".$orderId );
			$tpl->setVariable( "lnk_position", $fileSurveyQuestionOrder."?projectId=$projectId&groupId=$groupId&questionId=".$questionId."&orderId=".$orderId );
			$tpl->setVariable( "lnk_delete", $fileSurveyQuestionDelete."?projectId=$projectId&groupId=$groupId&questionId=".$questionId."&orderId=".$orderId );

			$tpl->parse();
			$tpl->show();
			exit;
		}
		// display form
		$tpl = new HTML_Template_IT($cfgPathToSurveyTemplates);
		$tpl->loadTemplatefile($templateSurveyQuestionEditCheckbox, true, true); // do remove untouched blocks
		$tpl->touchBlock("Header");
		$tpl->setVariable("applicationtitle", $cfgApplicationType.$cfgApplicationVersion);
		
		$tpl->touchBlock("Step3a");
		for($i=0; $i < $myQuestion->size; $i++)
        {
			$tpl->setCurrentBlock("Step3b");
			$tpl->setVariable("label", "label$i");
			$tpl->setVariable("number", ($i + 1));
			$tpl->setVariable("labelCont", $myQuestion->getOptionHeader($i));
			$tpl->setVariable("labeluseinput", "labeluse$i");
			$tpl->setVariable("labeluse", ($myQuestion->getOptionHideHeader($i) == "no")? "" : "checked" );
			
			// imageuploaddata
			$currentImageTag = $myQuestion->getOptionHeaderImage($i);
			$imgNameFromTag	=	explode("\"", $currentImageTag);
			$tpl->setVariable("imageuploadlink", $fileSurveyQuestionInsertImage."?currentImage=".urlencode($imgNameFromTag[1])."&imageuse=imageuse$i&imagename=imagename$i&formname=theform");
			$tpl->setVariable("imageuploadtarget", "imageupload");
			$tpl->setVariable("imageuseinput", "imageuse$i");
			$tpl->setVariable("imageuse", ($currentImageTag) ? " checked" : "");
			$tpl->setVariable("imagenameinput", "imagename$i");
			$tpl->setVariable("imagename", ($currentImageTag) ? addslashes($currentImageTag) : ""); // if changes also change js in tpl 030410-rr
			
			$javascript .= "this.document.theform.elements['imagename".$i."'].value = '".addslashes($currentImageTag)."';\n";
			
			$tpl->parseCurrentBlock("Step3b");
		}
		$tpl->touchBlock("Step3c");
		$tpl->setVariable("step", "35");
		$tpl->setVariable("useValuesChecked", ($myQuestion->getOptionMultipleValue(0)) ? " checked" : "");
		$tpl->setVariable("current", 3);
		$tpl->touchBlock("Footer");
		
		// javascript to show tags
		$tpl->setCurrentBlock("javascript_insert");
		$tpl->setVariable("javascriptinsert", $javascript);
		$tpl->parseCurrentBlock("javascript_insert");
		
		$tpl->setVariable( "lnk_detail", $fileSurveyQuestionDetailview."?projectId=$projectId&groupId=$groupId&questionId=".$questionId."&orderId=".$orderId );
		$tpl->setVariable( "lnk_edit", $fileSurveyQuestionEdit."?projectId=$projectId&groupId=$groupId&questionId=".$questionId."&orderId=".$orderId );
		$tpl->setVariable( "lnk_properties", $fileSurveyQuestionProperties."?projectId=$projectId&groupId=$groupId&questionId=".$questionId."&orderId=".$orderId );
		$tpl->setVariable( "lnk_position", $fileSurveyQuestionOrder."?projectId=$projectId&groupId=$groupId&questionId=".$questionId."&orderId=".$orderId );
		$tpl->setVariable( "lnk_delete", $fileSurveyQuestionDelete."?projectId=$projectId&groupId=$groupId&questionId=".$questionId."&orderId=".$orderId );

		
		$tpl->parse();
		$tpl->show();
		exit;
	}
	// save headers, headerimages // get multiple values
	//
	elseif($step == 35)
    {
		// save values to question object
		$myQuestion = $_SESSION["newQuestion"]; 
		for($i=0; $i < $myQuestion->size; $i++)
        {
			$myQuestion->setOptionHeader($i, $_POST["label$i"]);
			$myQuestion->setOptionHideHeader($i, ($_POST["labeluse$i"])? "" : "no");
			($_POST["imageuse$i"]) ? $myQuestion->setOptionHeaderImage($i, trim($_POST["imagename$i"])) : $myQuestion->setOptionHeaderImage($i, "");
		}	
		$_SESSION["newQuestion"] = $myQuestion;
		
		// back to step 3
		if(!$myQuestion->isValid(35))
        { 
			$tpl = new HTML_Template_IT($cfgPathToSurveyTemplates);
			$tpl->loadTemplatefile($templateSurveyQuestionEditCheckbox, true, true); // do remove untouched blocks
			$tpl->touchBlock("Header");
			$tpl->setVariable("applicationtitle", $cfgApplicationType.$cfgApplicationVersion);
			$tpl->setVariable("errors", $myQuestion->errorMessage);
			
			$tpl->touchBlock("Step3a");
			for($i=0; $i < $myQuestion->size; $i++)
	        {
				$tpl->setCurrentBlock("Step3b");
				$tpl->setVariable("label", "label$i");
				$tpl->setVariable("number", ($i + 1));
				$tpl->setVariable("labelCont", $myQuestion->getOptionHeader($i));
				$tpl->setVariable("labeluseinput", "labeluse$i");
				$tpl->setVariable("labeluse", ($myQuestion->getOptionHideHeader($i) == "no")? "" : "checked" );
				
				// imageuploaddata
				$currentImageTag = $myQuestion->getOptionHeaderImage($i);
				$imgNameFromTag	=	explode("\"", $currentImageTag);
				$tpl->setVariable("imageuploadlink", $fileSurveyQuestionInsertImage."?currentImage=".urlencode($imgNameFromTag[1])."&imageuse=imageuse$i&imagename=imagename$i&formname=theform");
				$tpl->setVariable("imageuploadtarget", "imageupload");
				$tpl->setVariable("imageuseinput", "imageuse$i");
				$tpl->setVariable("imageuse", ($currentImageTag) ? " checked" : "");
				$tpl->setVariable("imagenameinput", "imagename$i");
				$tpl->setVariable("imagename", ($currentImageTag) ? addslashes($currentImageTag) : ""); // if changes also change js in tpl 030410-rr
				
				$javascript .= "this.document.theform.elements['imagename".$i."'].value = '".addslashes($currentImageTag)."';\n";
				
				$tpl->parseCurrentBlock("Step3b");
			}
			$tpl->touchBlock("Step3c");
			$tpl->setVariable("step", "35");
			$tpl->setVariable("useValuesChecked", ($myQuestion->getOptionMultipleValue(0)) ? " checked" : "");
			$tpl->setVariable("current", 3);
			$tpl->touchBlock("Footer");
			
			// javascript to show tags
			$tpl->setCurrentBlock("javascript_insert");
			$tpl->setVariable("javascriptinsert", $javascript);
			$tpl->parseCurrentBlock("javascript_insert");
			
			$tpl->setVariable( "lnk_detail", $fileSurveyQuestionDetailview."?projectId=$projectId&groupId=$groupId&questionId=".$questionId."&orderId=".$orderId );
			$tpl->setVariable( "lnk_edit", $fileSurveyQuestionEdit."?projectId=$projectId&groupId=$groupId&questionId=".$questionId."&orderId=".$orderId );
			$tpl->setVariable( "lnk_properties", $fileSurveyQuestionProperties."?projectId=$projectId&groupId=$groupId&questionId=".$questionId."&orderId=".$orderId );
			$tpl->setVariable( "lnk_position", $fileSurveyQuestionOrder."?projectId=$projectId&groupId=$groupId&questionId=".$questionId."&orderId=".$orderId );
			$tpl->setVariable( "lnk_delete", $fileSurveyQuestionDelete."?projectId=$projectId&groupId=$groupId&questionId=".$questionId."&orderId=".$orderId );

			$tpl->parse();
			$tpl->show();
			exit;
		}
		elseif($_POST["useValues"])
        {
			// display form
			$tpl = new HTML_Template_IT($cfgPathToSurveyTemplates);
			$tpl->loadTemplatefile($templateSurveyQuestionEditCheckbox, true, true); // do remove untouched blocks
			$tpl->touchBlock("Header");
			$tpl->setVariable("applicationtitle", $cfgApplicationType.$cfgApplicationVersion);
			
			$tpl->touchBlock("Step35a");
			for($i=0; $i < $myQuestion->size; $i++)
               {
				$tpl->setCurrentBlock("Step35b");
				$tpl->setVariable("labelCont", $myQuestion->getOptionHeader($i));
				$tpl->setVariable("value", "value$i");
				$tpl->setVariable("valueCont", $myQuestion->getOptionMultipleValue($i));
				$tpl->parseCurrentBlock("Step35b");
			}
			$tpl->setVariable("step", "5");
			$tpl->setVariable("current", 4);
			$tpl->touchBlock("Footer");
			
			$tpl->setVariable( "lnk_detail", $fileSurveyQuestionDetailview."?projectId=$projectId&groupId=$groupId&questionId=".$questionId."&orderId=".$orderId );
			$tpl->setVariable( "lnk_edit", $fileSurveyQuestionEdit."?projectId=$projectId&groupId=$groupId&questionId=".$questionId."&orderId=".$orderId );
			$tpl->setVariable( "lnk_properties", $fileSurveyQuestionProperties."?projectId=$projectId&groupId=$groupId&questionId=".$questionId."&orderId=".$orderId );
			$tpl->setVariable( "lnk_position", $fileSurveyQuestionOrder."?projectId=$projectId&groupId=$groupId&questionId=".$questionId."&orderId=".$orderId );
			$tpl->setVariable( "lnk_delete", $fileSurveyQuestionDelete."?projectId=$projectId&groupId=$groupId&questionId=".$questionId."&orderId=".$orderId );

			$tpl->parse();
			$tpl->show();
			exit;
		}
		else
           {
			unset($_POST);
			$step = 5;
		}
	}
	// save multiple values // get rules
	//
	if($step == 5)
	{
		// save values to question object
		$myQuestion = $_SESSION["newQuestion"]; 
		for($i=0; $i < $myQuestion->size; $i++)
        {
			$myQuestion->setOptionMultipleValue($i, ($_POST["value$i"]));
			// delete addHeaders
			$myQuestion->setOptionAddHeader($i, false);
			$myQuestion->setOptionHideAddHeader($i, "");
			$myQuestion->setOptionAddHeaderImage($i, false);
		}
		$_SESSION["newQuestion"] = $myQuestion;
		
		// init survey functions
		$survey = &new surveyFunctions();
		// get default messages
		$defaultRuleMessages	=	$survey->checkForDefaultRuleMessages($projectId);
		
		// display form
		$tpl = new HTML_Template_IT($cfgPathToSurveyTemplates);
		$tpl->loadTemplatefile($templateSurveyQuestionEditCheckbox, true, true); // do remove untouched blocks
		$tpl->touchBlock("Header");
		$tpl->setVariable("applicationtitle", $cfgApplicationType.$cfgApplicationVersion);
		
		// required
		$tpl->setCurrentBlock("required");
		$tpl->setVariable("required", ($myQuestion->questionRules["required"]) ? " checked" : "");
		if (isset($myQuestion->questionRules) && ($myQuestion->questionRules["required"] == ''))
		{
			$myQuestion->questionRules["required"] = $myQuestion->questionDefaultRules[$_SESSION["sessionUserLanguageType"]]["required"];
		}
		$tpl->setVariable("requiredError", ($myQuestion->questionRules["required"]) ? $myQuestion->questionRules['required'] : $myQuestion->questionDefaultRules[$_SESSION["sessionUserLanguageType"]]['required']);
		$tpl->parseCurrentBlock();
		
		$tpl->setVariable("step", "6");
		$tpl->setVariable("current", "5");
		$tpl->touchBlock("Footer");
		
		$tpl->setVariable( "lnk_detail", $fileSurveyQuestionDetailview."?projectId=$projectId&groupId=$groupId&questionId=".$questionId."&orderId=".$orderId );
		$tpl->setVariable( "lnk_edit", $fileSurveyQuestionEdit."?projectId=$projectId&groupId=$groupId&questionId=".$questionId."&orderId=".$orderId );
		$tpl->setVariable( "lnk_properties", $fileSurveyQuestionProperties."?projectId=$projectId&groupId=$groupId&questionId=".$questionId."&orderId=".$orderId );
		$tpl->setVariable( "lnk_position", $fileSurveyQuestionOrder."?projectId=$projectId&groupId=$groupId&questionId=".$questionId."&orderId=".$orderId );
		$tpl->setVariable( "lnk_delete", $fileSurveyQuestionDelete."?projectId=$projectId&groupId=$groupId&questionId=".$questionId."&orderId=".$orderId );

		$tpl->parse();
		$tpl->show();
		exit;
	}
	// save rules // show summary
	//
	if($step == 6)
    {	
		// save values to question object
		$myQuestion = $_SESSION["newQuestion"]; 
		($_POST["required"])? $myQuestion->setQuestionRules('required', $_POST["requirederror"]) : $myQuestion->setQuestionRules('required', '##tobedeleted##');
		($_POST["numeric"])? $myQuestion->setQuestionRules('numeric', $_POST["numericerror"]) : $myQuestion->setQuestionRules('numeric', '##tobedeleted##');
		$_SESSION["newQuestion"] = $myQuestion;

		// get switchvalues
		$myDbQuestion = $myQuestion->QuestionWithId($myQuestion->id,1);
		
		// fill in summary template
		$tpl = new HTML_Template_IT($cfgPathToSurveyTemplates);
		$tpl->loadTemplatefile($templateSurveyQuestionEditDetailview, true, true); // do remove untouched blocks
		$tpl->setVariable("applicationtitle", $cfgApplicationType.$cfgApplicationVersion);
		
		$tpl->setVariable( "questiontype" , $myQuestion->type );
		$tpl->setVariable( "question" , $myQuestion->question );
		
		// display according to types
		if (($myQuestion->type == "textarea") || ($myQuestion->type == "text") || ($myQuestion->type == "switchtext"))
		{
			;// do nothing
		}
		elseif (($myQuestion->type != "texttable") && ($myQuestion->type != "radiotable") && ($myQuestion->type != "checkboxtable"))
		{
			$tpl->setCurrentBlock("nomatrixheader");
			
			$tpl->setVariable( "optionname" , $lang_script["survey.question.edit.radio.php"]["optionname"]);
			$tpl->setVariable( "valuename" , $lang_script["survey.question.edit.radio.php"]["valuename"]);
			$tpl->setVariable( "switchname" , $lang_script["survey.question.edit.radio.php"]["switchname"]);
			
			$tpl->parseCurrentBlock();
			
			// option data
			$optNumber = count($myQuestion->optionHeader);
			for ($i=0;$i<$optNumber;++$i)
			{
				$tpl->setCurrentBlock("nomatrixvalues");
				
				$tpl->setVariable( "option" , $myQuestion->optionHeader[$i] );
				$tpl->setVariable( "value" , $myQuestion->optionMultipleValue[$i] );
				$tpl->setVariable( "switch" , $myDbQuestion->toSwitchGroupName[$i] );
				
				$tpl->parseCurrentBlock();
			}
		}
		else
		{
			$tpl->setCurrentBlock("matrixheader");
			
			$tpl->setVariable( "matrixcolumnname" , $lang_script["survey.question.edit.radio.php"]["matrixcolumnname"]);
			$tpl->setVariable( "matrixrowname" , $lang_script["survey.question.edit.radio.php"]["matrixrowname"]);
			$tpl->setVariable( "matrixvaluename" , $lang_script["survey.question.edit.radio.php"]["matrixvaluename"]);
			$tpl->setVariable( "matrixswitchname" , $lang_script["survey.question.edit.radio.php"]["matrixswitchname"]);
				
			$tpl->parseCurrentBlock();
			
			// option data
			$optNumber = count($myQuestion->optionHeader);
			for ($i=0;$i<$optNumber;++$i)
			{
				$tpl->setCurrentBlock("matrixvalues");
				
				$tpl->setVariable( "matrixcolumn" , $myQuestion->optionHeader[$i] );
				$tpl->setVariable( "matrixrow" , $myQuestion->optionAddHeader[$i] );
				$tpl->setVariable( "matrixvalues" , $myQuestion->optionMultipleValue[$i] );
				$tpl->setVariable( "matrixswitch" , $myDbQuestion->toSwitchGroupName[$i] );
				
				$tpl->parseCurrentBlock();
			}
		}
		// required
		if ($myQuestion->questionRules["required"] && $myQuestion->questionRules["required"] != '##tobedeleted##')
		{
			$tpl->setCurrentBlock("required");
			
			$tpl->setVariable( "required" , $lang_script["survey.question.edit.radio.php"]["yes"]);
			
			$tpl->parseCurrentBlock();
		}
		// align
		$tpl->setCurrentBlock("align");
		
		$tpl->setVariable( "alignment" , (($myQuestion->align == "ver") ? $lang_script["survey.question.edit.radio.php"]["vertical"] : $lang_script["survey.question.edit.radio.php"]["horizontal"] ) );
		
		$tpl->parseCurrentBlock();

		// insert submit button
		$tpl->touchBlock("submit");
		
		// set value for step
		$tpl->setVariable( "step" , "7" );
		
		
		$tpl->setVariable( "lnk_detail", $fileSurveyQuestionDetailview."?projectId=$projectId&groupId=$groupId&questionId=".$questionId."&orderId=".$orderId );
		$tpl->setVariable( "lnk_edit", $fileSurveyQuestionEdit."?projectId=$projectId&groupId=$groupId&questionId=".$questionId."&orderId=".$orderId );
		$tpl->setVariable( "lnk_properties", $fileSurveyQuestionProperties."?projectId=$projectId&groupId=$groupId&questionId=".$questionId."&orderId=".$orderId );
		$tpl->setVariable( "lnk_position", $fileSurveyQuestionOrder."?projectId=$projectId&groupId=$groupId&questionId=".$questionId."&orderId=".$orderId );
		$tpl->setVariable( "lnk_delete", $fileSurveyQuestionDelete."?projectId=$projectId&groupId=$groupId&questionId=".$questionId."&orderId=".$orderId );

		
		$tpl->parse();
		$tpl->get();
		$tpl->show();
		exit;
	}
	elseif($step == 7)
    {	
		$myQuestion = $_SESSION["newQuestion"]; 
		$myQuestion->saveToDB();
		?>
   		<script type="text/javascript">
		<!--
      	opener.parent.content.location.reload();
		opener.parent.projecttree.location.reload();
		self.close();
      	-->
      	</script>
	  	<?php
		exit;
	}
	else
    { //
		echo '<html><b>'.$lang_script["survey.question.edit.radio.php"]["stepError1"].' '."\"$step\"".' '.$lang_script["survey.question.edit.radio.php"]["stepError2"];
	}
}
?>
