<?php
// +----------------------------------------------------------------------+
// | survey pilot                                                         |
// +----------------------------------------------------------------------+
// | Copyright (c) 2002 serie a - Digitale Medien und Systeme GmbH        |
// +----------------------------------------------------------------------+
// | Authors: 	Jrn Allert <allert@serie-a.de>                           |
// |          	Rene Renk   <renk@serie-a.de>                             |
// +----------------------------------------------------------------------+
//
// $Id: survey.question.edit.switchtext.php,v 1.1.1.1 2004/07/15 13:32:20 opensurveypilot Exp $

require_once("./lib/survey.question.inc.php"); // survey question create functions

// start session
@session_start();

// require all configuration files and libraries
require_once("./../config/config.inc.php"); // common config file
require_once($cfgPathToConf."/file.inc.php"); // project files
require_once($cfgPathToLib."/common.inc.php"); // common functions
require_once($cfgPathToSurveyFiles."/config/survey.config.inc.php"); // survey configuration
require_once($cfgPathToSurveyFiles."/config/survey.file.inc.php"); // survey files
require_once($cfgPathToSurveyFiles."/lib/survey.inc.php"); // survey functions
require_once($cfgPathToAuthFiles."/lib/user.inc.php"); // auth user functions
require_once($cfgPathToAuthFiles."/config/auth.file.inc.php"); // auth user files
require_once($cfgPathToAuthFiles."/lib/permission.inc.php"); // permission functions
require_once("HTML/Template/IT.php"); // PEAR::HTML_TEMPLATE_IT


// create new userFunctions object
$client = &new userFunctions;

//login check
if ($client->getAuthentication($_SESSION["sessionId"], session_id()) ==  false)
{
    //redirect to login page
    ?>
    <script type="text/javascript">
    <!--
    window.location.href="<?php echo $cfgUrlToProject."/".$fileAuthLogin; ?>";
    -->
    </script>
    <?php
    exit;
}  

// function permission check
if($_SESSION["sessionUserStatusId"] < $permSurveyQuestionEditSwitchtext)
{
    ?>
    <script type="text/javascript">
    <!--
    window.location.href="<?php echo $cfgUrlToProject."/".$fileNoPermission."?messageCode=2"; ?>";
    -->
    </script>
    <?php
    exit;
}

// get projectId
$projectId = (isset($_GET["projectId"])) ? $_GET["projectId"] : $_SESSION["newQuestion"]->projectId;

// create new permissionFunctions object
$permission = &new permissionFunctions;
// get Permission
$permissionMode = $permission->getPermissionMode($_SESSION["sessionUserId"], $projectId, 1);
if($permission->errorMessage)
{
    echo $permission->errorMessage;
}
// permission must be 2 (write)
if($permissionMode < 2)
{
    ?>
    <script type="text/javascript">
    <!--
    window.location.href="<?php echo $cfgUrlToProject."/".$fileNoPermission."?messageCode=1"; ?>";
    -->
    </script>
    <?php
    exit;
}
 
if($_SERVER["REQUEST_METHOD"] == "POST")
{
	// get step
	$step = $_POST["step"];
	
	// save question, type // get rules
	//
	if($step == 2)
    {	
		// save values to question object
		$myQuestion = $_SESSION["newQuestion"];
		$myQuestion->setType($_POST["type"]);
		$myQuestion->setQuestion($_POST["question"]);
		($_POST["imageuse"]) ? $myQuestion->setQuestionImage(trim($_POST["imagename"])) : $myQuestion->setQuestionImage("");
		$_SESSION["newQuestion"] = $myQuestion;
		
		// invalid back to step 1
		if(!$myQuestion->isValid(2))
		{
			$tpl = new HTML_Template_IT($cfgPathToSurveyTemplates);
			$tpl->loadTemplatefile($templateSurveyQuestionAdd, true, false); // dont remove untouched blocks
			$tpl->setVariable("applicationtitle", $cfgApplicationType.$cfgApplicationVersion);
			$tpl->setVariable("errors", $myQuestion->errorMessage);
			
			$tpl->setVariable("question", $myQuestion->question);
			$tpl->setVariable("switchtextSelected", " selected" );
			$tpl->setVariable("groupId", $myQuestion->groupId);
			$tpl->parse();
			$tpl->show();
			exit;
		}
		// init survey functions
		$survey = &new surveyFunctions();
		// get default messages
		$defaultRuleMessages	=	$survey->checkForDefaultRuleMessages($projectId);
		
		// display form
		$tpl = new HTML_Template_IT($cfgPathToSurveyTemplates);
		$tpl->loadTemplatefile($templateSurveyQuestionEditText, true, true); // dont remove untouched blocks
		$tpl->touchBlock("Header");
		$tpl->setVariable("applicationtitle", $cfgApplicationType.$cfgApplicationVersion);
		
		$tpl->setVariable("numeric", ($myQuestion->numeric) ? " checked" : "");
		$tpl->setVariable("numericError", $defaultRuleMessages[$_SESSION["sessionUserLanguageType"]]['numeric']);
		$tpl->setVariable("groupId", $myQuestion->groupId);
		$tpl->setVariable("current", 2);
		$tpl->setVariable("step", 3);
		$tpl->parse();
		$tpl->show();
		exit;
	}
	// save rules // show summary
	//
    elseif ($step == 3) 
    {	
		// save values to question object
		$myQuestion = $_SESSION["newQuestion"];
		$myQuestion->setQuestionRules('required', '##tobedeleted##');
		($_POST["numeric"])? $myQuestion->setQuestionRules('numeric', $_POST["numericerror"]) : $myQuestion->setQuestionRules('numeric', '##tobedeleted##');
		// set defaults for size because grouped element technique
		$size = 1;
		$myQuestion->setSize($size);
        // reset element values
		for($i=0; $i < $myQuestion->size; $i++)
        {
			$myQuestion->setOptionMultipleValue($i, false);
			$myQuestion->setOptionAddHeader($i, false);
			$myQuestion->setOptionHideAddHeader($i, "");
			$myQuestion->setOptionAddHeaderImage($i, false);
			$myQuestion->setOptionHeader($i, false);
			$myQuestion->setOptionHideHeader($i, "");
			$myQuestion->setOptionHeaderImage($i, false);
			
		}
		$_SESSION["newQuestion"] = $myQuestion;
		
		// get switchvalues
		$myDbQuestion = $myQuestion->QuestionWithId($myQuestion->id,1);
		
		// fill in summary template
		$tpl = new HTML_Template_IT($cfgPathToSurveyTemplates);
		$tpl->loadTemplatefile($templateSurveyQuestionEditDetailview, true, true); // do remove untouched blocks
		$tpl->setVariable("applicationtitle", $cfgApplicationType.$cfgApplicationVersion);
		
		$tpl->setVariable( "questiontype" , $myQuestion->type );
		$tpl->setVariable( "question" , $myQuestion->question );
		
		// display according to types
		if (($myQuestion->type == "textarea") || ($myQuestion->type == "text"))
		{
			;// do nothing
		}
		elseif (($myQuestion->type != "texttable") && ($myQuestion->type != "radiotable") && ($myQuestion->type != "checkboxtable"))
		{
			$tpl->setCurrentBlock("nomatrixheader");
			
			$tpl->setVariable( "optionname" , $lang_script["survey.question.edit.switchtext.php"]["optionname"]);
			$tpl->setVariable( "valuename" , $lang_script["survey.question.edit.switchtext.php"]["valuename"]);
			$tpl->setVariable( "switchname" , $lang_script["survey.question.edit.switchtext.php"]["switchname"]);
			
			$tpl->parseCurrentBlock();
			
			// option data
			$optNumber = count($myQuestion->optionHeader);
			for ($i=0;$i<$optNumber;++$i)
			{
				$tpl->setCurrentBlock("nomatrixvalues");
				
				$tpl->setVariable( "option" , $myQuestion->optionHeader[$i] );
				$tpl->setVariable( "value" , $myQuestion->optionMultipleValue[$i] );
				$tpl->setVariable( "switch" , $myDbQuestion->toSwitchGroupName[$i] );
				
				$tpl->parseCurrentBlock();
			}
		}
		else
		{
			$tpl->setCurrentBlock("matrixheader");
			
			$tpl->setVariable( "matrixcolumnname" , $lang_script["survey.question.edit.switchtext.php"]["matrixcolumnname"]);
			$tpl->setVariable( "matrixrowname" , $lang_script["survey.question.edit.switchtext.php"]["matrixrowname"]);
			$tpl->setVariable( "matrixvaluename" , $lang_script["survey.question.edit.switchtext.php"]["matrixvaluename"]);
			$tpl->setVariable( "matrixswitchname" , $lang_script["survey.question.edit.switchtext.php"]["matrixswitchname"]);
				
			$tpl->parseCurrentBlock();
			
			// option data
			$optNumber = count($myQuestion->optionHeader);
			for ($i=0;$i<$optNumber;++$i)
			{
				$tpl->setCurrentBlock("matrixvalues");
				
				$tpl->setVariable( "matrixcolumn" , $myQuestion->optionHeader[$i] );
				$tpl->setVariable( "matrixrow" , $myQuestion->optionAddHeader[$i] );
				$tpl->setVariable( "matrixvalues" , $myQuestion->optionMultipleValue[$i] );
				$tpl->setVariable( "matrixswitch" , $myDbQuestion->toSwitchGroupName[$i] );
				
				$tpl->parseCurrentBlock();
			}
		}
		// required
		if ($myQuestion->questionRules["required"] && $myQuestion->questionRules["required"] != '##tobedeleted##')
		{
			$tpl->setCurrentBlock("required");
			
			$tpl->setVariable( "required" , $lang_script["survey.question.edit.switchtext.php"]["yes"]);
			
			$tpl->parseCurrentBlock();
		}
		// numeric
		if ($myQuestion->questionRules["numeric"] && $myQuestion->questionRules["numeric"] != '##tobedeleted##')
		{
			$tpl->setCurrentBlock("numeric");
			
			$tpl->setVariable( "numeric" , $lang_script["survey.question.edit.switchtext.php"]["yes"]);
			
			$tpl->parseCurrentBlock();
		}
		// insert submit button
		$tpl->touchBlock("submit");
		
		// set value for step
		$tpl->setVariable( "step" , "6" );
		
		$tpl->parse();
		$tpl->get();
		$tpl->show();
		exit;
	}
	// save to db
	elseif($step == 6)
    {	
		$myQuestion = $_SESSION["newQuestion"]; 
		$myQuestion->saveToDB();
		
		?>
		<html><body>
		<script type="text/javascript">
		<!--
			      	opener.parent.content.location.reload();
					opener.parent.projecttree.location.reload();
					self.close();
		-->
		</script>
		<?php
		exit;
	}
	else
    {
		echo '<html><b>'.$lang_script["survey.question.edit.switchtext.php"]["stepError1"].' '."\"$step\"".' '.$lang_script["survey.question.edit.switchtext.php"]["stepError2"];
	}
}
?>
