<?php
// +----------------------------------------------------------------------+
// | survey pilot                                                         |
// +----------------------------------------------------------------------+
// | Copyright (c) 2002 serie a - Digitale Medien und Systeme GmbH        |
// +----------------------------------------------------------------------+
// | Authors: 	Jrn Allert <allert@serie-a.de>                           |
// |          	Rene Renk   <renk@serie-a.de>                             |
// +----------------------------------------------------------------------+
//
// $Id: survey.question.edit.tablegroup.php,v 1.1.1.1 2004/07/15 13:32:20 opensurveypilot Exp $

require_once("./lib/survey.question.inc.php"); // survey question create functions

// start session
@session_start();

// require all configuration files and libraries
require_once("./../config/config.inc.php"); // common config file
require_once($cfgPathToConf."/file.inc.php"); // project files
require_once($cfgPathToLib."/common.inc.php"); // common functions
require_once($cfgPathToSurveyFiles."/config/survey.config.inc.php"); // survey configuration
require_once($cfgPathToSurveyFiles."/config/survey.file.inc.php"); // survey files
require_once($cfgPathToSurveyFiles."/lib/survey.inc.php"); // survey functions
require_once($cfgPathToAuthFiles."/lib/user.inc.php"); // auth user functions
require_once($cfgPathToAuthFiles."/config/auth.file.inc.php"); // auth user files
require_once($cfgPathToAuthFiles."/lib/permission.inc.php"); // permission functions
require_once("HTML/Template/IT.php"); // PEAR::HTML_TEMPLATE_IT

// create new userFunctions object
$client = &new userFunctions;

//login check
if ($client->getAuthentication($_SESSION["sessionId"], session_id()) ==  false)
{
    //redirect to login page
    ?>
    <script type="text/javascript">
    <!--
    window.location.href="<?php echo $cfgUrlToProject."/".$fileAuthLogin; ?>";
    -->
    </script>
    <?php
    exit;
}  

// function permission check
if($_SESSION["sessionUserStatusId"] < $permSurveyQuestionEditTablegroup)
{
    ?>
    <script type="text/javascript">
    <!--
    window.location.href="<?php echo $cfgUrlToProject."/".$fileNoPermission."?messageCode=2"; ?>";
    -->
    </script>
    <?php
    exit;
}

// get projectId
$projectId = (isset($_GET["projectId"])) ? $_GET["projectId"] : $_SESSION["newQuestion"]->projectId;

// create new permissionFunctions object
$permission = &new permissionFunctions;
// get Permission
$permissionMode = $permission->getPermissionMode($_SESSION["sessionUserId"], $projectId, 1);
if($permission->errorMessage)
{
    echo $permission->errorMessage;
}
// permission must be 2 (write)
if($permissionMode < 2)
{
    ?>
    <script type="text/javascript">
    <!--
    window.location.href="<?php echo $cfgUrlToProject."/".$fileNoPermission."?messageCode=1"; ?>";
    -->
    </script>
    <?php
    exit;
}
 
if($_SERVER["REQUEST_METHOD"] == "POST")
{
	// set step
	$step = $_POST["step"];
	
	// save question // get size, tablespan, type
	//
	if($step == 2)
    {	
		// save values to question object
		$myQuestion = $_SESSION["newQuestion"];
		$myQuestion->setQuestion($_POST["question"]);
		($_POST["imageuse"]) ? $myQuestion->setQuestionImage(trim($_POST["imagename"])) : $myQuestion->setQuestionImage("");
		if($myQuestion->tableSpan)
		{
			$myQuestion->setTempSizeCounter( intval($myQuestion->size / $myQuestion->tableSpan) );
		}
		$_SESSION["newQuestion"] = $myQuestion;
		
		// invalid back to step 1
		if(!$myQuestion->isValid(2)) 
		{
			$tpl = new HTML_Template_IT($cfgPathToSurveyTemplates);
			$tpl->loadTemplatefile($templateSurveyQuestionAdd, true, false); // dont remove untouched blocks
			$tpl->setVariable("applicationtitle", $cfgApplicationType.$cfgApplicationVersion);
			$tpl->setVariable("errors", $myQuestion->errorMessage);
			
			$tpl->setVariable("question", $myQuestion->question);
			$tpl->setVariable("tablegroupSelected", " selected" );
			$tpl->setVariable("groupId", $myQuestion->groupId);
			$tpl->parse();
			$tpl->show();
			exit;
		}
		else
		{
			// display form
			$tpl = new HTML_Template_IT($cfgPathToSurveyTemplates);
			$tpl->loadTemplatefile($templateSurveyQuestionEditTableGroup, true, true); // do remove untouched blocks
			$tpl->touchBlock("Header");
			$tpl->setVariable("applicationtitle", $cfgApplicationType.$cfgApplicationVersion);
			
			$tpl->touchBlock("Step2");
			$tpl->setVariable("step", "3");
			$tpl->setVariable("current", "2");
			// columns
			if (($myQuestion->type == "texttable")||($myQuestion->type == "radiotable")||($myQuestion->type == "checkboxtable"))
			{
				$tempType = $myQuestion->type;
			}
			else
			{
				$tempType = "texttable";
			}
			$tpl->setVariable($tempType."checked", "checked='true'");
			if(intval($myQuestion->tempSizeCounter) < 1)
			{
				$sizeValue = 1;
			}
			else
			{
				$sizeValue = $myQuestion->tempSizeCounter;
			}
			$tpl->setVariable("tabsize", $sizeValue);
			// rows
			if(intval($myQuestion->tableSpan) < 1)
			{
				$rowValue = 1;
			}
			else
			{
				$rowValue = intval($myQuestion->tableSpan);
			}
			$tpl->setVariable("rows", $rowValue);
			// textwidth
			if(intval($myQuestion->inputWidth) < 20)
			{
				$inputWidth = 20;
			}
			else
			{
				$inputWidth = intval($myQuestion->inputWidth);
			}
			$tpl->setVariable("width", $inputWidth);
			$tpl->touchBlock("Footer");
			$tpl->parse();
			$tpl->show();
			exit;
		}
	}
	// save size, tablespan, type // get header, headerimage
	//
	elseif($step == 3) 
    {	
		// save values to question object
		$myQuestion = $_SESSION["newQuestion"];
		
		$size = intval($_POST["size"]);
		$rows = intval($_POST["rows"]);
		$inputWidth = intval($_POST["inputWidth"]);
		
		$myQuestion->setTableSpan($rows);
		$myQuestion->setInputWidth($inputWidth);
		$myQuestion->setSize($size*$rows);
		$myQuestion->setType($_POST["type"]);
		$myQuestion->setTempSizeCounter($size);
		
		$_SESSION["newQuestion"] = $myQuestion;
		
		// invalid back one step
		if(!$myQuestion->isValid(3)) // back to step 1
		{
			$tpl = new HTML_Template_IT($cfgPathToSurveyTemplates);
			$tpl->loadTemplatefile($templateSurveyQuestionEditTableGroup, true, true); // do remove untouched blocks
			$tpl->touchBlock("Header");
			$tpl->setVariable("applicationtitle", $cfgApplicationType.$cfgApplicationVersion);
			$tpl->setVariable("errors", $myQuestion->errorMessage);
			
			$tpl->touchBlock("Step2");
			$tpl->setVariable("step", "3");
			$tpl->setVariable("current", "2");
			// columns
			if (($myQuestion->type == "texttable")||($myQuestion->type == "radiotable")||($myQuestion->type == "checkboxtable"))
			{
				$tempType = $myQuestion->type;
			}
			else
			{
				$tempType = "texttable";
			}
			$tpl->setVariable($tempType."checked", "checked='true'");
			if(intval($myQuestion->tempSizeCounter) < 2)
			{
				$sizeValue = 2;
			}
			else
			{
				$sizeValue = $myQuestion->tempSizeCounter;
			}
			$tpl->setVariable("tabsize", $sizeValue);
			// rows
			if(intval($myQuestion->tableSpan) < 1)
			{
				$rowValue = 1;
			}
			else
			{
				$rowValue = intval($myQuestion->tableSpan);
			}
			$tpl->setVariable("rows", $rowValue);
			// textwidth
			if(intval($myQuestion->inputWidth) < 20)
			{
				$inputWidth = 20;
			}
			else
			{
				$inputWidth = intval($myQuestion->inputWidth);
			}
			$tpl->setVariable("width", $inputWidth);
			$tpl->touchBlock("Footer");
			$tpl->parse();
			$tpl->show();
			exit;
		}
		
		// display form
		$tpl = new HTML_Template_IT($cfgPathToSurveyTemplates);
		$tpl->loadTemplatefile($templateSurveyQuestionEditTableGroup, true, true); // do remove untouched blocks
		$tpl->touchBlock("Header");
		$tpl->setVariable("applicationtitle", $cfgApplicationType.$cfgApplicationVersion);
		
		$tpl->touchBlock("Step3a");
		for($i=0; $i < $myQuestion->tempSizeCounter; $i++)
        {
			$tpl->setCurrentBlock("Step3b");
			$tpl->setVariable("label", "label$i");
			$tpl->setVariable("number", ($i + 1));
			$tpl->setVariable("labelCont", $myQuestion->getOptionHeader($i));
			$tpl->setVariable("labeluseinput", "labeluse$i");
			$tpl->setVariable("labeluse", ($myQuestion->getOptionHideHeader($i) == "no")? "" : "checked" );
			
			// imageuploaddata
			$currentImageTag = $myQuestion->getOptionHeaderImage($i);
			$imgNameFromTag	=	explode("\"", $currentImageTag);
			$tpl->setVariable("imageuploadlink", $fileSurveyQuestionInsertImage."?currentImage=".urlencode($imgNameFromTag[1])."&imageuse=imageuse$i&imagename=imagename$i&formname=theform");
			$tpl->setVariable("imageuploadtarget", "imageupload");
			$tpl->setVariable("imageuseinput", "imageuse$i");
			$tpl->setVariable("imageuse", ($currentImageTag) ? " checked" : "");
			$tpl->setVariable("imagenameinput", "imagename$i");
			$tpl->setVariable("imagename", ($currentImageTag) ? addslashes($currentImageTag) : ""); // if changes also change js in tpl 030410-rr
			
			$javascript .= "this.document.theform.elements['imagename".$i."'].value = '".addslashes($currentImageTag)."';\n";
			
			$tpl->parseCurrentBlock("Step3b");
		}
		
		$tpl->setVariable("step", "4");
		$tpl->setVariable("current", "3");
		$tpl->touchBlock("Footer");
		
		// javascript to show tags
		$tpl->setCurrentBlock("javascript_insert");
		$tpl->setVariable("javascriptinsert", $javascript);
		$tpl->parseCurrentBlock("javascript_insert");
		
		$tpl->parse();
		$tpl->show();
		exit;
	}
	// save header, headerimage // get addheader, addheaderimage multiplevalues ?
	//
	elseif($step == 4)
    {	
		// save values to question object
		$myQuestion = $_SESSION["newQuestion"]; 
		// set header values for every row		
		for($i=0; $i < $myQuestion->tempSizeCounter; $i++)
        {
			$myQuestion->setOptionHeader($i, $_POST["label$i"]);
			$myQuestion->setOptionHideHeader($i, ($_POST["labeluse$i"])? "" : "no");
			($_POST["imageuse$i"]) ? $myQuestion->setOptionHeaderImage($i, trim($_POST["imagename$i"])) : $myQuestion->setOptionHeaderImage($i, "");
			for ($k = 1; $k < $myQuestion->tableSpan; $k++)
			{
				$myQuestion->setOptionHeader($i + ($myQuestion->tempSizeCounter*$k), $_POST["label$i"]);
				$myQuestion->setOptionHideHeader($i + ($myQuestion->tempSizeCounter*$k), ($_POST["labeluse$i"])? "" : "no");
				($_POST["imageuse$i"]) ? $myQuestion->setOptionHeaderImage($i + ($myQuestion->tempSizeCounter*$k), trim($_POST["imagename$i"])) : $myQuestion->setOptionHeaderImage($i + ($myQuestion->tempSizeCounter*$k), "");
			}
		}
		$_SESSION["newQuestion"] = $myQuestion;
		
		// back to step 3
		if(!$myQuestion->isValid(4))
        { 
			// display form
			$tpl = new HTML_Template_IT($cfgPathToSurveyTemplates);
			$tpl->loadTemplatefile($templateSurveyQuestionEditTableGroup, true, true); // do remove untouched blocks
			$tpl->touchBlock("Header");
			$tpl->setVariable("applicationtitle", $cfgApplicationType.$cfgApplicationVersion);
			$tpl->setVariable("errors", $myQuestion->errorMessage);
			
			$tpl->touchBlock("Step3a");
			for($i=0; $i < $myQuestion->tempSizeCounter; $i++)
	        {
				$tpl->setCurrentBlock("Step3b");
				$tpl->setVariable("label", "label$i");
				$tpl->setVariable("number", ($i + 1));
				$tpl->setVariable("labelCont", $myQuestion->getOptionHeader($i));
				$tpl->setVariable("labeluseinput", "labeluse$i");
				$tpl->setVariable("labeluse", ($myQuestion->getOptionHideHeader($i) == "no")? "" : "checked" );
				
				// imageuploaddata
				$currentImageTag = $myQuestion->getOptionHeaderImage($i);
				$imgNameFromTag	=	explode("\"", $currentImageTag);
				$tpl->setVariable("imageuploadlink", $fileSurveyQuestionInsertImage."?currentImage=".urlencode($imgNameFromTag[1])."&imageuse=imageuse$i&imagename=imagename$i&formname=theform");
				$tpl->setVariable("imageuploadtarget", "imageupload");
				$tpl->setVariable("imageuseinput", "imageuse$i");
				$tpl->setVariable("imageuse", ($currentImageTag) ? " checked" : "");
				$tpl->setVariable("imagenameinput", "imagename$i");
				$tpl->setVariable("imagename", ($currentImageTag) ? addslashes($currentImageTag) : ""); // if changes also change js in tpl 030410-rr
				
				$javascript .= "this.document.theform.elements['imagename".$i."'].value = '".addslashes($currentImageTag)."';\n";
				
				$tpl->parseCurrentBlock("Step3b");
			}
			
			$tpl->setVariable("step", "4");
			$tpl->setVariable("current", "3");
			$tpl->touchBlock("Footer");
			
			// javascript to show tags
			$tpl->setCurrentBlock("javascript_insert");
			$tpl->setVariable("javascriptinsert", $javascript);
			$tpl->parseCurrentBlock("javascript_insert");
			
			$tpl->parse();
			$tpl->show();
			exit;
		}
		else
        {
			// display form
			$tpl = new HTML_Template_IT($cfgPathToSurveyTemplates);
			$tpl->loadTemplatefile($templateSurveyQuestionEditTableGroup, true, true); // do remove untouched blocks
			$tpl->touchBlock("Header");
			$tpl->setVariable("applicationtitle", $cfgApplicationType.$cfgApplicationVersion);
						
			$tpl->touchBlock("Step4a");
			for($i=0; $i < $myQuestion->tableSpan; $i++)
            {
				$tpl->setCurrentBlock("Step4b");
				$tpl->setVariable("rowHeader", "<b>".($i+1)."</b>");
				$tpl->setVariable("value", "value$i");
				$tpl->setVariable("addHeader", $myQuestion->getOptionAddHeader(((($i+1) *$myQuestion->tempSizeCounter)-1))  );
				$tpl->setVariable("rowheaderuseinput", "rowheaderuse$i");
				$tpl->setVariable("rowheaderuse", ($myQuestion->getOptionHideAddHeader((((($i+1) *$myQuestion->tempSizeCounter)-1))) == "no")? "" : "checked" );
				
				// imageuploaddata
				$currentImageTag = $myQuestion->getOptionAddHeaderImage($i);
				$imgNameFromTag	=	explode("\"", $currentImageTag);
				$tpl->setVariable("imageuploadlink", $fileSurveyQuestionInsertImage."?currentImage=".urlencode($imgNameFromTag[1])."&imageuse=imageuse$i&imagename=imagename$i&formname=theform");
				$tpl->setVariable("imageuploadtarget", "imageupload");
				$tpl->setVariable("imageuseinput", "imageuse$i");
				$tpl->setVariable("imageuse", ($currentImageTag) ? " checked" : "");
				$tpl->setVariable("imagenameinput", "imagename$i");
				$tpl->setVariable("imagename", ($currentImageTag) ? addslashes($currentImageTag) : ""); // if changes also change js in tpl 030410-rr
				
				$javascript .= "this.document.theform.elements['imagename".$i."'].value = '".addslashes($currentImageTag)."';\n";
				
				$tpl->parseCurrentBlock("Step4b");
			}
			if($myQuestion->type != "texttable")
			{
				$tpl->setCurrentBlock("Step4c");
				$tpl->setVariable("useValuesChecked", ($myQuestion->getOptionMultipleValue(0)) ? " checked" : "");
				$tpl->parseCurrentBlock("Step4c");
			}
			$tpl->setVariable("step", "5");
			$tpl->setVariable("current", "4");
			$tpl->touchBlock("Footer");
			
			// javascript to show tags
			$tpl->setCurrentBlock("javascript_insert");
			$tpl->setVariable("javascriptinsert", $javascript);
			$tpl->parseCurrentBlock("javascript_insert");
			
			$tpl->parse();
			$tpl->show();
			exit;
		}
	}
	// save addheader, addheaderimage // get multiplevalues (optional)
	//
	elseif($step == 5){	
		
		// save values to question object
		$myQuestion = $_SESSION["newQuestion"]; 
		// set row header for every column
		$j = -1;
		for($i=0; $i < $myQuestion->tableSpan; $i++)
        {
			for($k = 0; $k < $myQuestion->tempSizeCounter; $k++)
			{
				$j ++;
				$myQuestion->setOptionAddHeader($j, $_POST["value$i"]);
				$myQuestion->setOptionHideAddHeader($j, ($_POST["rowheaderuse$i"])? "" : "no");
				($_POST["imageuse$i"]) ? $myQuestion->setOptionAddHeaderImage($j, trim($_POST["imagename$i"])) : $myQuestion->setOptionAddHeaderImage($j, "");
			}
		}
		$_SESSION["newQuestion"] = $myQuestion;
		
		// if not valid back to step 4		// rowheaders are optional // 030408-rr
		if(!$myQuestion->isValid(5))
        {
			// display form
			$tpl = new HTML_Template_IT($cfgPathToSurveyTemplates);
			$tpl->loadTemplatefile($templateSurveyQuestionEditTableGroup, true, true); // do remove untouched blocks
			$tpl->touchBlock("Header");
			$tpl->setVariable("applicationtitle", $cfgApplicationType.$cfgApplicationVersion);
			$tpl->setVariable("errors", $myQuestion->errorMessage);
			
			$tpl->touchBlock("Step4a");
			for($i=0; $i < $myQuestion->tableSpan; $i++)
            {
				$tpl->setCurrentBlock("Step4b");
				$tpl->setVariable("rowHeader", "<b>".($i+1)."</b>");
				$tpl->setVariable("value", "value$i");
				$tpl->setVariable("addHeader", $myQuestion->getOptionAddHeader(((($i+1) *$myQuestion->tempSizeCounter)-1))  );
				$tpl->setVariable("rowheaderuseinput", "rowheaderuse$i");
				$tpl->setVariable("rowheaderuse", ($myQuestion->getOptionHideAddHeader((((($i+1) *$myQuestion->tempSizeCounter)-1))) == "no")? "" : "checked" );
				
				// imageuploaddata
				$currentImageTag = $myQuestion->getOptionAddHeaderImage($i);
				$imgNameFromTag	=	explode("\"", $currentImageTag);
				$tpl->setVariable("imageuploadlink", $fileSurveyQuestionInsertImage."?currentImage=".urlencode($imgNameFromTag[1])."&imageuse=imageuse$i&imagename=imagename$i&formname=theform");
				$tpl->setVariable("imageuploadtarget", "imageupload");
				$tpl->setVariable("imageuseinput", "imageuse$i");
				$tpl->setVariable("imageuse", ($currentImageTag) ? " checked" : "");
				$tpl->setVariable("imagenameinput", "imagename$i");
				$tpl->setVariable("imagename", ($currentImageTag) ? addslashes($currentImageTag) : ""); // if changes also change js in tpl 030410-rr
				
				$javascript .= "this.document.theform.elements['imagename".$i."'].value = '".addslashes($currentImageTag)."';\n";
				
				$tpl->parseCurrentBlock("Step4b");
			}
			if($myQuestion->type != "texttable")
			{
				$tpl->setCurrentBlock("Step4c");
				$tpl->setVariable("useValuesChecked", ($myQuestion->getOptionMultipleValue(0)) ? " checked" : "");
				$tpl->parseCurrentBlock("Step4c");
			}
			$tpl->setVariable("step", "5");
			$tpl->setVariable("current", "4");
			$tpl->touchBlock("Footer");
			
			// javascript to show tags
			$tpl->setCurrentBlock("javascript_insert");
			$tpl->setVariable("javascriptinsert", $javascript);
			$tpl->parseCurrentBlock("javascript_insert");
			
			$tpl->parse();
			$tpl->show();
			exit;
		}
		// get multiplevalues if wanted
		if($_POST["useValues"])
		{
			// display form
			$tpl = new HTML_Template_IT($cfgPathToSurveyTemplates);
			$tpl->loadTemplatefile($templateSurveyQuestionEditTableGroup, true, true); // do remove untouched blocks
			$tpl->touchBlock("Header");
			$tpl->setVariable("applicationtitle", $cfgApplicationType.$cfgApplicationVersion);
			
			$tpl->touchBlock("Step5a");
			for($i=0; $i < (count($myQuestion->optionHeader)); $i++)
            {
				$tpl->setCurrentBlock("Step5b");
				$tpl->setVariable("field", ("<b>".($i+1)."</b>&nbsp;&nbsp;&nbsp;".$myQuestion->getOptionHeader($i)."/".$myQuestion->getOptionAddHeader($i)));
				$tpl->setVariable("value", "value$i");
				$tpl->setVariable("fieldValue", $myQuestion->getOptionMultipleValue($i));
				$tpl->parseCurrentBlock("Step5b");
			}
			$tpl->setVariable("step", "55");
			$tpl->setVariable("current", "5");
			$tpl->touchBlock("Footer");
			$tpl->parse();
			$tpl->show();
			exit;
		}
		else
		{
			$_SESSION["newQuestion"] = $myQuestion;
			unset($_POST);
			$step = 55;
		}
	}
	// save multiplevalues // get rules
	//
	if($step == 55)
	{
		// get question
		$myQuestion = $_SESSION["newQuestion"]; 
		
		// set row header for every column
		for($i=0; $i < (count($myQuestion->optionHeader)); $i++)
        {
			$myQuestion->setOptionMultipleValue($i, $_POST["value$i"]);
		}
		$_SESSION["newQuestion"] = $myQuestion; 
		
		// init survey functions
		$survey = &new surveyFunctions();
		// get default messages
		$defaultRuleMessages	=	$survey->checkForDefaultRuleMessages($projectId);
		
		// display form
		$tpl = new HTML_Template_IT($cfgPathToSurveyTemplates);
		$tpl->loadTemplatefile($templateSurveyQuestionEditTableGroup, true, true); // do remove untouched blocks
		$tpl->touchBlock("Header");
		$tpl->setVariable("applicationtitle", $cfgApplicationType.$cfgApplicationVersion);
		
		// limit allowed checks only for checkboxtable with one row or one column
		if($myQuestion->type == "checkboxtable")
		{
			$tpl->touchBlock("Step3d");
			for($i=0; $i < (($myQuestion->size)-1); $i++)
			{
				$tpl->setCurrentBlock("Step3e");
				$tpl->setVariable("numcheckallowed", ($i + 1));
				$tpl->setVariable("checknumselected", ($myQuestion->ruleCheckAllow == $i+1)? "selected" : "");
				$tpl->parseCurrentBlock("Step3e");
			}
			$tpl->touchBlock("Step3f");
		}
		
		// required
		$tpl->setCurrentBlock("required");
		$tpl->setVariable("required", ($myQuestion->questionRules["required"]) ? " checked" : "");
		if (isset($myQuestion->questionRules) && ($myQuestion->questionRules["required"] == ''))
		{
			$myQuestion->questionRules["required"] = $myQuestion->questionDefaultRules[$_SESSION["sessionUserLanguageType"]]["required"];
		}
		$tpl->setVariable("requiredError", ($myQuestion->questionRules["required"]) ? $myQuestion->questionRules['required'] : $myQuestion->questionDefaultRules[$_SESSION["sessionUserLanguageType"]]['required']);
		$tpl->parseCurrentBlock();
		
		// numeric
		if($myQuestion->type == "texttable")
		{
			$tpl->setCurrentBlock("numeric");
			$tpl->setVariable("numeric", ($myQuestion->questionRules["numeric"]) ? " checked" : "");
			if (isset($myQuestion->questionRules) && ($myQuestion->questionRules["numeric"] == ''))
			{
				$myQuestion->questionRules["numeric"] = $myQuestion->questionDefaultRules[$_SESSION["sessionUserLanguageType"]]["numeric"];
			}
			$tpl->setVariable("numericError", ($myQuestion->questionRules["numeric"]) ? $myQuestion->questionRules['numeric'] : $myQuestion->questionDefaultRules[$_SESSION["sessionUserLanguageType"]]['numeric']);
			$tpl->parseCurrentBlock();
		}
		
		$tpl->setVariable("step", "6");
		$tpl->setVariable("current", "6");
		$tpl->touchBlock("Footer");
		$tpl->parse();
		$tpl->show();
		exit;
	}
	// save rules // show summary
	//
	if($step == 6)
	{
		// save values to question object
		$myQuestion = $_SESSION["newQuestion"];
		($_POST["required"])? $myQuestion->setQuestionRules('required', $_POST["requirederror"]) : $myQuestion->setQuestionRules('required', '##tobedeleted##');
		($_POST["numeric"])? $myQuestion->setQuestionRules('numeric', $_POST["numericerror"]) : $myQuestion->setQuestionRules('numeric', '##tobedeleted##');
		($_POST["checkallowed"])? $myQuestion->setQuestionRules('maxCheck', "limitierte Auswahl") : $myQuestion->setQuestionRules('maxCheck', '##tobedeleted##');
		($_POST["checkallowed"])? $myQuestion->setRuleCheckAllow($_POST["checkallowed"]) : $myQuestion->setRuleCheckAllow('0');
		$_SESSION["newQuestion"] = $myQuestion; 
		
		// get switchvalues
		$myDbQuestion = $myQuestion->QuestionWithId($myQuestion->id,1);
		
		// fill in summary template
		$tpl = new HTML_Template_IT($cfgPathToSurveyTemplates);
		$tpl->loadTemplatefile($templateSurveyQuestionEditDetailview, true, true); // do remove untouched blocks
		$tpl->setVariable("applicationtitle", $cfgApplicationType.$cfgApplicationVersion);
		
		$tpl->setVariable( "questiontype" , $myQuestion->type );
		$tpl->setVariable( "question" , $myQuestion->question );
		
		// display according to types
		if (($myQuestion->type == "textarea") || ($myQuestion->type == "text") || ($myQuestion->type == "switchtext"))
		{
			;// do nothing
		}
		elseif (($myQuestion->type != "texttable") && ($myQuestion->type != "radiotable") && ($myQuestion->type != "checkboxtable"))
		{
			$tpl->setCurrentBlock("nomatrixheader");
			
			$tpl->setVariable( "optionname" , $lang_script["survey.question.edit.tablegroup.php"]["optionname"]);
			$tpl->setVariable( "valuename" , $lang_script["survey.question.edit.tablegroup.php"]["valuename"]);
			$tpl->setVariable( "switchname" , $lang_script["survey.question.edit.tablegroup.php"]["switchname"]);
			
			$tpl->parseCurrentBlock();
			
			// option data
			$optNumber = count($myQuestion->optionHeader);
			for ($i=0;$i<$optNumber;++$i)
			{
				$tpl->setCurrentBlock("nomatrixvalues");
				
				$tpl->setVariable( "option" , $myQuestion->optionHeader[$i] );
				$tpl->setVariable( "value" , $myQuestion->optionMultipleValue[$i] );
				$tpl->setVariable( "switch" , $myDbQuestion->toSwitchGroupName[$i] );
				
				$tpl->parseCurrentBlock();
			}
		}
		else
		{
			$tpl->setCurrentBlock("matrixheader");
			
			$tpl->setVariable( "matrixcolumnname" , $lang_script["survey.question.edit.tablegroup.php"]["matrixcolumnname"]);
			$tpl->setVariable( "matrixrowname" , $lang_script["survey.question.edit.tablegroup.php"]["matrixrowname"]);
			$tpl->setVariable( "matrixvaluename" , $lang_script["survey.question.edit.tablegroup.php"]["matrixvaluename"]);
			$tpl->setVariable( "matrixswitchname" , $lang_script["survey.question.edit.tablegroup.php"]["matrixswitchname"]);
				
			$tpl->parseCurrentBlock();
			
			// option data
			$optNumber = count($myQuestion->optionHeader);
			for ($i=0;$i<$optNumber;++$i)
			{
				$tpl->setCurrentBlock("matrixvalues");
				
				$tpl->setVariable( "matrixcolumn" , $myQuestion->optionHeader[$i] );
				$tpl->setVariable( "matrixrow" , 	$myQuestion->optionAddHeader[$i] );
				$tpl->setVariable( "matrixvalue" ,  $myQuestion->optionMultipleValue[$i] );
				$tpl->setVariable( "matrixswitch" , $myDbQuestion->toSwitchGroupName[$i] );
				
				$tpl->parseCurrentBlock();
			}
		}
		// required
		if ($myQuestion->questionRules["required"] && $myQuestion->questionRules["required"] != '##tobedeleted##')
		{
			$tpl->setCurrentBlock("required");
			
			$tpl->setVariable( "required" , $lang_script["survey.question.edit.tablegroup.php"]["yes"]);
			
			$tpl->parseCurrentBlock();
		}
		// numeric
		if ($myQuestion->questionRules["numeric"] && $myQuestion->questionRules["numeric"] != '##tobedeleted##')
		{
			$tpl->setCurrentBlock("numeric");
			
			$tpl->setVariable( "numeric" , $lang_script["survey.question.edit.tablegroup.php"]["yes"]);
			
			$tpl->parseCurrentBlock();
		}
		// insert submit button
		$tpl->touchBlock("submit");
		
		// set value for step
		$tpl->setVariable("step" , "7");
		
		$tpl->parse();
		$tpl->get();
		$tpl->show();
		exit;
	}
	// save to db
	elseif($step == 7)
    {	
		$myQuestion = $_SESSION["newQuestion"];
		$myQuestion->saveToDB();
		?>
		<html><body>
		<script type="text/javascript">
		<!--
			opener.parent.content.location.reload();
			opener.parent.projecttree.location.reload();
			self.close();
		-->
		</script>
		<?php
		exit;
	}
	else
    {
		echo '<html><b>'.$lang_script["survey.question.edit.tablegroup.php"]["stepError1"].' '."\"$step\"".' '.$lang_script["survey.question.edit.tablegroup.php"]["stepError2"];
	}
}
?>
