<?php
// +----------------------------------------------------------------------+
// | survey pilot                                                     |
// +----------------------------------------------------------------------+
// | Copyright (c) 2002 serie a - Digitale Medien und Systeme GmbH        |
// +----------------------------------------------------------------------+
// | Authors: 	Jrn Allert <allert@serie-a.de>                           |
// |          	Rene Renk   <renk@serie-a.de>                             |
// +----------------------------------------------------------------------+
//
// $Id: survey.question.insert.image.php,v 1.1.1.1 2004/07/15 13:32:22 opensurveypilot Exp $

require_once("./lib/survey.question.inc.php"); // survey question create functions

// start session
@session_start();

// require all configuration files and libraries
require_once("./../config/config.inc.php"); // common config file
require_once($cfgPathToConf."/file.inc.php"); // project files
require_once($cfgPathToLib."/common.inc.php"); // common functions
require_once($cfgPathToAuthFiles."/config/auth.file.inc.php"); // auth files
require_once($cfgPathToAuthFiles."/lib/user.inc.php"); // auth user functions
require_once($cfgPathToSurveyFiles."/config/survey.config.inc.php"); // survey config
require_once($cfgPathToSurveyFiles."/config/survey.file.inc.php"); // survey files
require_once($cfgPathToSurveyFiles."/lib/survey.inc.php"); // survey functions
require_once($cfgPathToAuthFiles."/lib/permission.inc.php"); // auth user functions
require_once($cfgPathToSurveyFiles."/lib/design/survey.question.image.inc.php"); // image insert functions
require_once("HTML/Template/IT.php"); // PEAR::HTML_TEMPLATE_IT
 
// create new userFunctions object
$client = &new userFunctions;
 
//login check
if ($client->getAuthentication($_SESSION["sessionId"], session_id()) ==  false)
{
    //redirect to login page
    ?>
    <script type="text/javascript">
    <!--
    window.location.href="<?php echo $cfgUrlToProject."/".$fileAuthLogin; ?>";
    -->
    </script>
    <?php
    exit;
}

// function permission check
if($_SESSION["sessionUserStatusId"] < $permSurveyDesignTmplEdit)
{
    ?>
    <script type="text/javascript">
    <!--
    window.location.href="<?php echo $cfgUrlToProject."/".$fileNoPermission."?messageCode=2"; ?>";
    -->
    </script>
    <?php
    exit;
}

// get projectId
$projectId = (isset($_GET["projectId"])) ? $_GET["projectId"] : $_POST["projectId"];

// create new permissionFunctions object
$permission = &new permissionFunctions;
 
// get Permission
$permissionMode = $permission->getPermissionMode($_SESSION["sessionUserId"], $projectId, 1);
if($permission->errorMessage)
{
    echo $permission->errorMessage;
}
// permission must be 4 (execute)
if($permissionMode < 4 )
{
    ?>
    <script type="text/javascript">
    <!--
    window.location.href="<?php echo $cfgUrlToProject."/".$fileNoPermission."?messageCode=1"; ?>";
    -->
    </script>
    <?php
    exit;
}

// create new surveyFunctions object
$imgFunct = &new imageFileClass;

if($_SERVER["REQUEST_METHOD"] == "POST")
{
	//check for path
	if(!$tmplPath = $_POST["path"])
	{
		$imgFunct->setErrorMessage($lang_script["survey.question.insert.image.php"]["noTmplPathSelected"]."<br>".$lang_script["survey.question.insert.image.php"]["checkEntry"]);
	}
	elseif(!$fileId = $_POST["file"])
	{
		$imgFunct->setErrorMessage($lang_script["survey.question.insert.image.php"]["noFileSelected"]."<br>".$lang_script["survey.question.insert.image.php"]["checkEntry"]);
	}
	// else if no error in imagetag creating function
	elseif($imgTagData	=	$imgFunct->getImageTag($_POST["file"]))
	{
		// give file to opening script and close
		?>
		<html><body>
		<script type="text/javascript">
		<!--
		opener.document.<?php echo $_POST["formname"] ?>.elements['<?php echo $_POST["imagename"] ?>'].value = "<?php echo $imgTagData; ?>";
		opener.document.<?php echo $_POST["formname"] ?>.elements['<?php echo $_POST["imageuse"] ?>'].checked = true;
		self.close();
		-->
		</script>
		<?php
		exit;
	}
}


// create javascript array 
$javascriptArray = "var questions = new Array(\n";

$categoryArray = $imgFunct->getAllImagePathes();

//
if(is_array($categoryArray))
{
	$categoryArraySize = count($categoryArray);
	for($i=0;$i<count($categoryArray);$i++)
	{
	    $maxRow = $imgFunct->getContentNum($categoryArray[$i]["catId"]);
		$contentArray = $imgFunct->getContentForOverview($categoryArray[$i]["catId"], $actualNum = 0, $maxRow, "CONTENT_NAME", "ASC");
		//
		$javascriptArray .= "new Array(\n";
        //print_r($answerArray );
        $contentArraySize = count($contentArray);
        if(is_array($contentArray))
        {
            for($k=0;$k<count($contentArray);$k++)
            {
                $javascriptArray .= "new Array(\"".addslashes($contentArray[$k]["CONTENT_NAME"])."\", ".$contentArray[$k]["CONTENT_ID_PK"].")";
                if($k+1 < $contentArraySize)
                {
                    $javascriptArray .= ", \n";
                }
            }
            $javascriptArray .= ")\n";
        }
        else
        {
            $javascriptArray .= "null";
			$javascriptArray .= ")";
        }
	    if($i+1 < $categoryArraySize)
	    {
	        $javascriptArray .= ", \n";
	    }
	}
}
else
{
    $javascriptArray .= "null";
}
$javascriptArray .= ");";

// create Template IT object
$tpl = new HTML_Template_IT($cfgPathToSurveyTemplates);

// load template
$tpl->loadTemplatefile($templateSurveyQuestionInsertImage, true, true);

// set title
$tpl->setVariable("applicationtitle", $cfgApplicationType.$cfgApplicationVersion);

// check for errors
if($imgFunct->errorMessage)
{
	$tpl->setCurrentBlock( "error_message" );
	$tpl->setVariable( "errors", $imgFunct->errorMessage);
	$tpl->parseCurrentBlock();
}
if($_GET["currentImage"])
{
	$tpl->setCurrentBlock("image_view");
	// set current image
	$imagePath = urldecode(stripslashes($_GET["currentImage"]));
	$imageData = @getimagesize($imagePath);
	if($imageData[0] < 200)
	{
		$imagePreviewWidth	=	$imageData[0];
		$imagePreviewHeight	=	$imageData[1];
	}
	else
	{
		$imagePreviewWidth	= 200;
		$imagePreviewHeight = (200 / $imageData[0])*$imageData[1];
	}
	$tpl->setVariable( "currentimagepreviewwidth", $imagePreviewWidth);
	$tpl->setVariable( "currentimagepreviewheight", $imagePreviewHeight);
	$tpl->setVariable( "currentimagepath", $imagePath);
	$tpl->setVariable( "currentimagewidth", $imageData[0]);
	$tpl->setVariable( "currentimageheight", $imageData[1]);
	$tpl->parseCurrentBlock();
}
// set javascriptarrays
$tpl->setVariable( "questionarray", $javascriptArray);
$tpl->setVariable( "previewfile", $fileSurveyQuestionImagePreview);

// set pathes
for($i=0;$i<count($categoryArray);$i++)
{
	$tpl->setCurrentBlock( "categories" );
	$tpl->setVariable( "categoryvalue", $categoryArray[$i]["catPath"] );
	$tpl->setVariable( "categorypath",  $categoryArray[$i]["catPath"] );
	$tpl->parseCurrentBlock();
}

$tpl->setVariable( "projectId", $projectId );
$tpl->setVariable( "formname", $_GET["formname"]);
$tpl->setVariable( "imageuse", $_GET["imageuse"]);
$tpl->setVariable( "imagename", $_GET["imagename"]);

// parse template
$tpl->parse();

// get the parsed template and print it
$tpl->get();
$tpl->show();
?>
