<?php
// +----------------------------------------------------------------------+
// | survey pilot                                                         |
// +----------------------------------------------------------------------+
// | Copyright (c) 2002 serie a - Digitale Medien und Systeme GmbH        |
// +----------------------------------------------------------------------+
// | Authors: 	Jrn Allert <allert@serie-a.de>                           |
// |          	Rene Renk   <renk@serie-a.de>                             |
// +----------------------------------------------------------------------+
//
// $Id: survey.question.order.php,v 1.1.1.1 2004/07/15 13:32:23 opensurveypilot Exp $

require_once("./lib/survey.question.inc.php"); // survey question create functions

// start session
@session_start();

// require all configuration files and libraries
require_once("./../config/config.inc.php"); // common config file
require_once($cfgPathToConf."/file.inc.php"); // project files
require_once($cfgPathToLib."/common.inc.php"); // common functions
require_once($cfgPathToSurveyFiles."/config/survey.config.inc.php"); // survey configuration
require_once($cfgPathToSurveyFiles."/config/survey.file.inc.php"); // survey files
require_once($cfgPathToSurveyFiles."/lib/survey.inc.php"); // survey functions
require_once($cfgPathToAuthFiles."/lib/user.inc.php"); // auth user functions
require_once($cfgPathToAuthFiles."/config/auth.file.inc.php"); // auth user files
require_once($cfgPathToAuthFiles."/lib/permission.inc.php"); // permission functions
require_once("HTML/Template/IT.php"); // PEAR::HTML_TEMPLATE_IT

// create new userFunctions object
$client = &new userFunctions;

//login check
if ($client->getAuthentication($_SESSION["sessionId"], session_id()) ==  false)
{
    //redirect to login page
    ?>
    <script type="text/javascript">
    <!--
    window.location.href="<?php echo $cfgUrlToProject."/".$fileAuthLogin; ?>";
    -->
    </script>
    <?php
    exit;
} 

// Start of checking the permissions 
$fileUserPermissionMode	=	$permUserSurveyQuestionOrder;
$filePermissionMode		=	$permSurveyQuestionOrder;

// filepermission
if($_SESSION["sessionUserStatusId"] < $filePermissionMode)
{
    ?>
    <script type="text/javascript">
    <!--
    window.location.href="<?php echo $cfgUrlToProject."/".$fileNoPermission."?messageCode=".$filePermissionMode."&messageType=file"; ?>";
    -->
    </script>
    <?php
    exit;
}
// get projectId
$projectId = (isset($_GET["projectId"])) ? $_GET["projectId"] : $_POST["projectId"];
$groupId = (isset($_GET["groupId"])) ? $_GET["groupId"] : $_POST["groupId"];
$questionId = (isset($_GET["questionId"])) ? $_GET["questionId"] : $_POST["questionId"];
$orderId = (isset($_GET["orderId"])) ? $_GET["orderId"] : $_POST["orderId"];

// create new permissionFunctions object
$permission = &new permissionFunctions;

// get Permission
$permissionMode = $permission->getPermissionMode($_SESSION["sessionUserId"], $projectId, 1);
if($permission->errorMessage)
{
    echo $permission->errorMessage;
}
// userpermission
if($permissionMode < $fileUserPermissionMode)
{
    ?>
    <script type="text/javascript">
    <!--
    window.location.href="<?php echo $cfgUrlToProject."/".$fileNoPermission."?messageCode=".$fileUserPermissionMode."&messageType=user"; ?>";
    -->
    </script>
    <?php
    exit;
}
// End of checking the permissions

// create new question object
$myQuestion = &Question::QuestionWithId($_GET["questionId"]);

if($_POST["moveToOrder"])
{
    // negative values: move to last position
    if($_POST["moveToOrder"] < 0)
    { 
		$myQuestion->moveToEnd();
	}
	elseif($myQuestion->order != $_POST["moveToOrder"])
    {
		$myQuestion->moveToOrder($_POST["moveToOrder"]);
	}
	
	?>
	<html><body>
	<script type="text/javascript">
	<!--
		opener.parent.content.location.reload();
	opener.parent.projecttree.location.reload();
		window.location.href="<?php echo $fileSurveyQuestionOrder."?projectId=$projectId&groupId=$groupId&questionId=".$questionId."&orderId=".$orderId; ?>";
	-->
	</script>
	<?php
	exit;

}
// display form
elseif($_GET["questionId"])
{ 
	$allQuestions = &Question::QuestionsInGroup($myQuestion->groupId);
	
	$tpl = new HTML_Template_IT($cfgPathToSurveyTemplates);
	$tpl->loadTemplatefile($templateSurveyQuestionOrder, true, true);
	
	// set title
	$tpl->setVariable( "applicationtitle", $cfgApplicationType.$cfgApplicationVersion);

	for($i=0; $i < count($allQuestions); $i++)
    {
		$tpl->setCurrentBlock("select");
		$tpl->setVariable("sel_question", $allQuestions[$i]->question);
		$tpl->setVariable("sel_order", $allQuestions[$i]->order);
		$tpl->parseCurrentBlock("select");
	}
    
    $tpl->setVariable("question", $myQuestion->question);
    $tpl->setVariable( "projectId", "$projectId" );
	
	$tpl->setVariable( "lnk_detail", $fileSurveyQuestionDetailview."?projectId=$projectId&groupId=$groupId&questionId=".$questionId."&orderId=".$orderId );
	$tpl->setVariable( "lnk_edit", $fileSurveyQuestionEdit."?projectId=$projectId&groupId=$groupId&questionId=".$questionId."&orderId=".$orderId );
	$tpl->setVariable( "lnk_properties", $fileSurveyQuestionProperties."?projectId=$projectId&groupId=$groupId&questionId=".$questionId."&orderId=".$orderId );
	$tpl->setVariable( "lnk_position", $fileSurveyQuestionOrder."?projectId=$projectId&groupId=$groupId&questionId=".$questionId."&orderId=".$orderId );
	$tpl->setVariable( "lnk_delete", $fileSurveyQuestionDelete."?projectId=$projectId&groupId=$groupId&questionId=".$questionId."&orderId=".$orderId );

	
	$tpl->parse();
	$tpl->get();
	$tpl->show();
}
else
{
	echo "ERROR...";
}
?>