<?php
// +----------------------------------------------------------------------+
// | survey pilot                                                         |
// +----------------------------------------------------------------------+
// | Copyright (c) 2002 serie a - Digitale Medien und Systeme GmbH        |
// +----------------------------------------------------------------------+
// | Authors: 	Jrn Allert <allert@serie-a.de>                           |
// |          	Rene Renk   <renk@serie-a.de>                             |
// +----------------------------------------------------------------------+
//
// $Id: survey.question.overview.php,v 1.1.1.1 2004/07/15 13:32:23 opensurveypilot Exp $

// start session
@session_start();

// require all configuration files and libraries
require_once("./../config/config.inc.php"); // common config file
require_once($cfgPathToConf."/file.inc.php"); // project files
require_once($cfgPathToLib."/common.inc.php"); // common functions
require_once($cfgPathToSurveyFiles."/config/survey.config.inc.php"); // survey configuration
require_once($cfgPathToSurveyFiles."/config/survey.file.inc.php"); // survey files
require_once($cfgPathToSurveyFiles."/lib/survey.inc.php"); // survey functions
require_once($cfgPathToAuthFiles."/lib/user.inc.php"); // auth user functions
require_once($cfgPathToAuthFiles."/config/auth.file.inc.php"); // auth user files
require_once($cfgPathToAuthFiles."/lib/permission.inc.php"); // permission functions
require_once("HTML/Template/IT.php"); // PEAR::HTML_TEMPLATE_IT

// create new userFunctions object
$client = &new userFunctions;

//login check
if ($client->getAuthentication($_SESSION["sessionId"], session_id()) ==  false)
{
    //redirect to login page
    ?>
    <script type="text/javascript">
    <!--
    window.location.href="<?php echo $cfgUrlToProject."/".$fileAuthLogin; ?>";
    -->
    </script>
    <?php
    exit;
} 


// Start of checking the permissions 
$fileUserPermissionMode	=	$permUserSurveyQuestionOverview;
$filePermissionMode		=	$permSurveyQuestionOverview;

// filepermission
if($_SESSION["sessionUserStatusId"] < $filePermissionMode)
{
    ?>
    <script type="text/javascript">
    <!--
    window.location.href="<?php echo $cfgUrlToProject."/".$fileNoPermission."?messageCode=".$filePermissionMode."&messageType=file"; ?>";
    -->
    </script>
    <?php
    exit;
}

// get projectId
$projectId = (isset($_GET["projectId"])) ? $_GET["projectId"] : $_POST["projectId"];
$groupId = (isset($_GET["groupId"])) ? $_GET["groupId"] : $_POST["groupId"];

if($_SERVER["REQUEST_METHOD"] == "POST")
{
	// create new groupFunctions object
	$surveyQuestionDelete = &new surveyFunctions;

	$questionIdArray=$_POST["questionId"];
	
	for ($i=0;$i<count($questionIdArray);$i++)
	{
		if ($_POST["selectAction"]==1) //user lschen
		{
			//echo $questionIdArray[$i]."<br>";
			// delete group
		    $surveyQuestionDelete->deleteSurveyQuestion($questionIdArray[$i]);
		    if($surveyQuestionDelete->errorMessage)
		    {
		        echo $surveyQuestionDelete->$errorMessage;
		    }
		    else
		    {
			?>
			<script type="text/javascript">
			<!--
			parent.projecttree.location.reload();
			window.location.href="<?=$fileSurveyQuestionOverview."?projectId=".$projectId."&groupId=".$groupId?>";
			-->
			</script>
			<?php
		    }
		}
	}
}

// create new permissionFunctions object
$permission = &new permissionFunctions;

// get Permission
$permissionMode = $permission->getPermissionMode($_SESSION["sessionUserId"], $projectId, 1);
if($permission->errorMessage)
{
    echo $permission->errorMessage;
}
// userpermission
if($permissionMode < $fileUserPermissionMode)
{
    ?>
    <script type="text/javascript">
    <!--
    window.location.href="<?php echo $cfgUrlToProject."/".$fileNoPermission."?messageCode=".$fileUserPermissionMode."&messageType=user"; ?>";
    -->
    </script>
    <?php
    exit;
}
// End of checking the permissions

// create new permissionFunctions object
$permission = &new permissionFunctions;
// get Permission
$permissionMode = $permission->getPermissionMode($_SESSION["sessionUserId"], $projectId, 1);
if($permission->errorMessage)
{
    echo $permission->errorMessage;
}
// permission must be 1 (read)
if($permissionMode < 1)
{
    ?>
    <script type="text/javascript">
    <!--
    window.location.href="<?php echo $cfgUrlToProject."/".$fileNoPermission."?messageCode=1"; ?>";
    -->
    </script>
    <?php
    exit;
} 

// get group id as get variable
if(isset($_GET["id"]))
{
    $groupId = $_GET["id"];
}

// get actual num as get variable
if(isset($_GET["actualNum"]))
{
    $actualNum = $_GET["actualNum"];
}
// get orderBy as get variable
if(isset($_GET["orderBy"]))
{
    $orderBy = $_GET["orderBy"];
}
else
{
    $orderBy = "FORMTYPE_ORDER";
}
// get direction as get variable
if(isset($_GET["direction"]))
{
    $direction = $_GET["direction"];
}

// create new survey object
$surveyQuestionsGroup = &new surveyFunctions; 

// create Template IT object
$tpl = new HTML_Template_IT($cfgPathToSurveyTemplates);

// load template
$tpl->loadTemplatefile($templateSurveyQuestionOverview, true, true);

// set title
$tpl->setVariable( "applicationtitle", $cfgApplicationType.$cfgApplicationVersion);

// maximum rows
$maxRow = $cfgMaxRowInOverviews;
//total rows   

$totalNum =  $surveyQuestionsGroup->getGroupQuestionsNum($groupId);

// actual rows
if (!isset($actualNum))
{
    $actualNum = 0;
}
// get the Number of pages
$numPages = intval($totalNum/$maxRow);
if ($numPages < ($totalNum/$maxRow))
{ 
    $numPages++;
}

// prev button
if ($actualNum > 0) 
{
    $y = $actualNum - $maxRow;
    
    $tpl->setVariable( "prev_button", "<a class=\"navigation\" href=\"$fileSurveyQuestionsOverview?projectId=$projectId&groupId=$groupId&actualNum=$y&orderBy=$orderBy&direction=$direction\">&laquo;</a>" );
}
// display pages
for ($i = 1; $i <= $numPages; $i++)
{
    $y = ($i * $maxRow) - $maxRow;
    
    $tpl->setCurrentBlock( "num_buttons" );
    $tpl->setVariable( "num_button", "[<a class=\"navigation\" href=\"$fileSurveyQuestionsOverview?projectId=$projectId&groupId=$groupId&actualNum=$y&orderBy=$orderBy&direction=$direction\">$i</a>]" );
    $tpl->parseCurrentBlock();
}
//  next button
if ($actualNum < ($totalNum - $maxRow)) 
{
    $y = $actualNum  + $maxRow;
    
    $tpl->setVariable( "next_button", "<a class=\"navigation\" href=\"$fileSurveyQuestionsOverview?projectId=$projectId&groupId=$groupId&actualNum=$y&orderBy=$orderBy&direction=$direction\">&raquo;</a>" );
}

if(($actualNum + $maxRow) < $totalNum)
{
    $entryTo = $actualNum + $maxRow;
}
else
{
    $entryTo = $totalNum;
}

// get headline
$headlineArray =  $surveyQuestionsGroup->getSurveyForGroupInQuestions($groupId,$projectId);
if($surveyQuestionsGroup->errorMessage)
{
    echo $surveyQuestionsGroup->errorMessage;
}
$tpl->setCurrentBlock( "headline" );
$tpl->setVariable( "survey_Id", $headlineArray[0]["FORM_PROJECT_ID_FK"] );
$tpl->setVariable( "headline_survey", $headlineArray[0]["PROJECT_NAME"] );
$tpl->setVariable( "headline_group", $headlineArray[0]["FORM_NAME"] );
$tpl->parseCurrentBlock();	

// entry from
$entryFrom = $entryTo < 1 ? "0" : $actualNum +1;

$tpl->setVariable( "entry_from", $entryFrom );
$tpl->setVariable( "entry_to", $entryTo );
$tpl->setVariable( "entry_total", $totalNum );

// question/ group switch
$tpl->setVariable( "grouplink", $fileSurveyGroupOverview."?projectId=$projectId&groupId=$groupId" );
$tpl->setVariable( "grouptarget", $fileFrameContentName );
$tpl->setVariable( "groupoptionlink", $fileSurveySubgroupToplevel."?projectId=$projectId&selectedGroupId=$groupId" );
$tpl->setVariable( "groupoptiontarget", $fileFrameToplevelName );

// orderby butons
$tpl->setVariable( "order_link_nr_up", "$fileSurveyQuestionOverview?projectId=$projectId&groupId=$groupId&actualNum=$actualNum&orderBy=FORMTYPE_ORDER&direction=ASC" );
$tpl->setVariable( "order_link_nr_down", "$fileSurveyQuestionOverview?projectId=$projectId&groupId=$groupId&actualNum=$actualNum&orderBy=FORMTYPE_ORDER&direction=DESC" );
$tpl->setVariable( "order_link_question_up", "$fileSurveyQuestionOverview?projectId=$projectId&groupId=$groupId&actualNum=$actualNum&orderBy=FORMTYPE_QUESTION&direction=ASC" );//otto: used to be FORMELEMENT_HEADER
$tpl->setVariable( "order_link_question_down", "$fileSurveyQuestionOverview?projectId=$projectId&groupId=$groupId&actualNum=$actualNum&orderBy=FORMTYPE_QUESTION&direction=DESC" );//otto: used to be FORMELEMENT_HEADER
$tpl->setVariable( "order_link_questiontyp_up", "$fileSurveyQuestionOverview?projectId=$projectId&groupId=$groupId&actualNum=$actualNum&orderBy=FORMTYPE_TYPE&direction=ASC" );
$tpl->setVariable( "order_link_questiontyp_down", "$fileSurveyQuestionOverview?projectId=$projectId&groupId=$groupId&actualNum=$actualNum&orderBy=FORMTYPE_TYPE&direction=DESC" );
$tpl->setVariable( "order_link_insert_date_up", "$fileSurveyQuestionOverview?projectId=$projectId&groupId=$groupId&actualNum=$actualNum&orderBy=FORMTYPE_TIMESTAMP&direction=ASC" );//otto: used to be ele_timestamp
$tpl->setVariable( "order_link_insert_date_down", "$fileSurveyQuestionOverview?projectId=$projectId&groupId=$groupId&actualNum=$actualNum&orderBy=FORMTYPE_TIMESTAMP&direction=DESC" );//otto: used to be ele_timestamp

$tpl->setVariable( "formaction", $fileSurveyQuestionOverview );

// get questions
$surveyQuestionsArray = $surveyQuestionsGroup->getSurveyQuestionsForGroup($groupId, $actualNum, $maxRow, $orderBy, $direction);
for($j=0;$j<count($surveyQuestionsArray);$j++)
{
    $tpl->setCurrentBlock( "survey_question_overview" );
    $tpl->setVariable( "id", $surveyQuestionsArray[$j]["FORMTYPE_ID_PK"] );
    $tpl->setVariable( "questionId", $surveyQuestionsArray[$j]["FORMTYPE_ID_PK"] );
    $tpl->setVariable( "formtype", $surveyQuestionsArray[$j]["FORMTYPE_ID_PK"] );
    $tpl->setVariable( "formtype_order", ($surveyQuestionsArray[$j]["REL_ORDER_NUM"] + $actualNum));
    $tpl->setVariable( "element_header", $surveyQuestionsArray[$j]["FORMTYPE_QUESTION"] ); // otto: used to be FORMELEMENT_HEADER
    // check Formtype
	switch ($surveyQuestionsArray[$j]["FORMTYPE_TYPE"])
	{
		case "select":
		{
			$displayType = $lang_script["survey.question.overview.php"]["displayTypeSelect"];
			break;
		}
		case "radio":
		{
			$displayType = $lang_script["survey.question.overview.php"]["displayTypeRadio"];
			break;
		}
		case "checkbox":
		{
			$displayType = $lang_script["survey.question.overview.php"]["displayTypeCheckbox"];
			break;
		}
		case "radiotable":
		{
			$displayType = $lang_script["survey.question.overview.php"]["displayTypeRadiotable"];
			break;
		}
		case "texttable":
		{
			$displayType = $lang_script["survey.question.overview.php"]["displayTypeTexttable"];
			break;
		}
		case "checkboxtable":
		{
			$displayType = $lang_script["survey.question.overview.php"]["displayTypeCheckboxtable"];
			break;
		}
		case "groupedtext":
		{
			$displayType = $lang_script["survey.question.overview.php"]["displayTypeGroupedtext"];
			break;
		}
		case "switchtext":
		{
			$displayType = $lang_script["survey.question.overview.php"]["displayTypeSwitchtext"];
			break;
		}
		case "textarea":
		{
			$displayType = $lang_script["survey.question.overview.php"]["displayTypeTextarea"];
			break;
		}
		case "text":
		{
			$displayType = $lang_script["survey.question.overview.php"]["displayTypeText"];
			break;
		}
		default:
		{
			$displayType = $lang_script["survey.question.overview.php"]["displayTypeDefault"];
			break;
		}
	}
    $tpl->setVariable( "typ_formtype", $displayType);
    $tpl->setVariable( "insertdate", $surveyQuestionsArray[$j]["FORMTYPE_TIMESTAMP"] );//otto: used to be ele_timestamp
    $tpl->setVariable( "detailview_link", $fileSurveyQuestionDetailview."?projectId=$projectId&groupId=$groupId&questionId=".$surveyQuestionsArray[$j]["FORMTYPE_ID_PK"] );
    $tpl->setVariable( "edit_link", $fileSurveyQuestionEdit."?projectId=$projectId&groupId=$groupId&questionId=".$surveyQuestionsArray[$j]["FORMTYPE_ID_PK"] );
    $tpl->setVariable( "properties_link", $fileSurveyQuestionProperties."?projectId=$projectId&groupId=$groupId&questionId=".$surveyQuestionsArray[$j]["FORMTYPE_ID_PK"]."&orderId=".$surveyQuestionsArray[$j]["FORMTYPE_ORDER"] );
    $tpl->setVariable( "edit_order_link", $fileSurveyQuestionOrder."?projectId=$projectId&groupId=$groupId&questionId=".$surveyQuestionsArray[$j]["FORMTYPE_ID_PK"]."&orderId=".$surveyQuestionsArray[$j]["FORMTYPE_ORDER"] );
    $tpl->setVariable( "delete_link", $fileSurveyQuestionDelete."?projectId=$projectId&groupId=$groupId&questionId=".$surveyQuestionsArray[$j]["FORMTYPE_ID_PK"] );
    $tpl->setVariable( "print_link", "#" );
    $tpl->parseCurrentBlock();
}

$tpl->setVariable( "projectId", $projectId);
$tpl->setVariable( "groupId", $groupId);

// get the parsed template and print it
$tpl->get();
$tpl->show();
?>
