<?php
// +----------------------------------------------------------------------+
// | survey pilot                                                         |
// +----------------------------------------------------------------------+
// | Copyright (c) 2002 serie a - Digitale Medien und Systeme GmbH        |
// +----------------------------------------------------------------------+
// | Authors: 	Jrn Allert <allert@serie-a.de>                           |
// |          	Rene Renk   <renk@serie-a.de>                             |
// +----------------------------------------------------------------------+
//
// $Id: survey.question.properties.php,v 1.1.1.1 2004/07/15 13:32:25 opensurveypilot Exp $

require_once("./lib/survey.question.inc.php"); // survey question create functions

// start session
@session_start();

// require all configuration files and libraries
require_once("./../config/config.inc.php"); // common config file
require_once($cfgPathToConf."/file.inc.php"); // project files
require_once($cfgPathToLib."/common.inc.php"); // common functions
require_once($cfgPathToSurveyFiles."/config/survey.config.inc.php"); // survey configuration
require_once($cfgPathToSurveyFiles."/config/survey.file.inc.php"); // survey files
require_once($cfgPathToSurveyFiles."/lib/survey.inc.php"); // survey functions
require_once($cfgPathToAuthFiles."/lib/user.inc.php"); // auth user functions
require_once($cfgPathToAuthFiles."/config/auth.file.inc.php"); // auth user files
require_once($cfgPathToAuthFiles."/lib/permission.inc.php"); // permission functions
require_once("HTML/Template/IT.php"); // PEAR::HTML_TEMPLATE_IT

// create new userFunctions object
$client = &new userFunctions;

//login check
if ($client->getAuthentication($_SESSION["sessionId"], session_id()) ==  false)
{
    //redirect to login page
    ?>
    <script type="text/javascript">
    <!--
    window.location.href="<?php echo $cfgUrlToProject."/".$fileAuthLogin; ?>";
    -->
    </script>
    <?php
    exit;
} 

// Start of checking the permissions 
$fileUserPermissionMode	=	$permUserSurveyQuestionProps;
$filePermissionMode		=	$permSurveyQuestionProps;

// filepermission
if($_SESSION["sessionUserStatusId"] < $filePermissionMode)
{
    ?>
    <script type="text/javascript">
    <!--
    window.location.href="<?php echo $cfgUrlToProject."/".$fileNoPermission."?messageCode=".$filePermissionMode."&messageType=file"; ?>";
    -->
    </script>
    <?php
    exit;
}
// get projectId
$projectId = (isset($_GET["projectId"])) ? $_GET["projectId"] : $_POST["projectId"];
$groupId = (isset($_GET["groupId"])) ? $_GET["groupId"] : $_POST["groupId"];
$questionId = (isset($_GET["questionId"])) ? $_GET["questionId"] : $_POST["questionId"];
$orderId = (isset($_GET["orderId"])) ? $_GET["orderId"] : $_POST["orderId"];

// create new permissionFunctions object
$permission = &new permissionFunctions;

// get Permission
$permissionMode = $permission->getPermissionMode($_SESSION["sessionUserId"], $projectId, 1);
if($permission->errorMessage)
{
    echo $permission->errorMessage;
}
// userpermission
if($permissionMode < $fileUserPermissionMode)
{
    ?>
    <script type="text/javascript">
    <!--
    window.location.href="<?php echo $cfgUrlToProject."/".$fileNoPermission."?messageCode=".$fileUserPermissionMode."&messageType=user"; ?>";
    -->
    </script>
    <?php
    exit;
}
// End of checking the permissions

if($_POST["questionId"])
{ 
	$myQuestion = $_SESSION["newQuestion"];

	for($i=0; $i < $myQuestion->size; $i++)
    {
		$myQuestion->setSwitch($i, $_POST["option".$i]);
        $checkboxValue = $_POST["checkbox".$i] != "" ? $_POST["checkbox".$i]: "0";
        // if switch is unchecked
		if(!$_POST["option".$i])
		{
			$checkboxValue = '0';
		}
		$myQuestion->setFormsEnd($i, $checkboxValue);
	}
	$myQuestion->saveToDB();
	?>
	<html><body>
	<script type="text/javascript">
	<!--
	opener.parent.content.location.reload();
	opener.parent.projecttree.location.reload();
	window.location.href="<?php echo $fileSurveyQuestionProperties."?projectId=$projectId&groupId=$groupId&questionId=".$questionId."&orderId=".$orderId ?>";
	--> 
	</script>
	<?php
	exit;
}
// display form
elseif($_GET["questionId"])
{
    $projectId =  $_GET["projectId"];
    $groupId =  $_GET["groupId"];
    $questionId = $_GET["questionId"];
    
	$myQuestion = &Question::QuestionWithId($questionId);
    $_SESSION["newQuestion"] = $myQuestion;
    
    // create Template IT object
	$tpl = new HTML_Template_IT($cfgPathToSurveyTemplates);
	
	// check if switch allowed
	if(($myQuestion->type=="text")OR($myQuestion->type=="textarea"))
	{
		// check if textinput
		$tpl->loadTemplatefile($templateSurveyQuestionPropertiesError, true, true);
		
		// set title
		$tpl->setVariable( "applicationtitle", $cfgApplicationType.$cfgApplicationVersion);

		$tpl->setVariable( "lnk_detail", $fileSurveyQuestionDetailview."?projectId=$projectId&groupId=$groupId&questionId=".$questionId."&orderId=".$orderId );
		$tpl->setVariable( "lnk_edit", $fileSurveyQuestionEdit."?projectId=$projectId&groupId=$groupId&questionId=".$questionId."&orderId=".$orderId );
		$tpl->setVariable( "lnk_properties", $fileSurveyQuestionProperties."?projectId=$projectId&groupId=$groupId&questionId=".$questionId."&orderId=".$orderId );
		$tpl->setVariable( "lnk_position", $fileSurveyQuestionOrder."?projectId=$projectId&groupId=$groupId&questionId=".$questionId."&orderId=".$orderId );
		$tpl->setVariable( "lnk_delete", $fileSurveyQuestionDelete."?projectId=$projectId&groupId=$groupId&questionId=".$questionId."&orderId=".$orderId );

		$tpl->setVariable("question", $myQuestion->question);
		$tpl->parse();
		$tpl->show();
		exit;
	}
    
	/*
	if(!$_GET["warningChecked"])
	{
		$survey = &new surveyFunctions();
		// fetch groupdata
		$surveyGroupEditArray = $survey->getSurveyGroup($myQuestion->groupId);
		$surveyData			  = $survey->getSurveyForGroup($surveyGroupEditArray[0]["FORM_PROJECT_ID_FK"]);
		// activecheck
		if ($surveyData[0]["PROJECT_ACTIVE"]=="yes")
		{
			// load template
			$tpl->loadTemplatefile($templateSurveyActiveWarning, true, true);
			
			// set title
			$tpl->setVariable( "applicationtitle", $cfgApplicationType.$cfgApplicationVersion);

            $tpl->setVariable( "groupId", $_GET["groupId"]);
            $tpl->setVariable( "projectId", $_GET["projectId"]);
			$tpl->setVariable( "questionId", $_GET["questionId"]);
			$tpl->get();
			$tpl->show();
			exit;
		}
	}
    */
	
    $groups = Question::groupsAfterGroupId($projectId, $myQuestion->groupId);
    
	$tpl->loadTemplatefile($templateSurveyQuestionProperties, true, true);
	
	// set title
	$tpl->setVariable( "applicationtitle", $cfgApplicationType.$cfgApplicationVersion);

	$tpl->setVariable("question", $myQuestion->question);
	$tpl->setVariable("questionId", $_GET["questionId"]);
    
    if($myQuestion->type != "switchtext")
	{
		for($i=0; $i < $myQuestion->size; $i++)
	    {
			for($j=0; $j < count($groups); $j++)
	        {
				$tpl->setCurrentBlock("select");
				$tpl->setVariable("groupId", $groups[$j]["FORM_ID_PK"]);
				$tpl->setVariable("groupSelected", ($myQuestion->getSwitch($i) == $groups[$j]["FORM_ID_PK"]) ? " selected" : "" );
				$tpl->setVariable("groupName", $groups[$j]["FORM_NAME"]);
				$tpl->parseCurrentBlock("select");
			}
            
            $tpl->setCurrentBlock("checkbox");
            $tpl->setVariable("checkboxName", "checkbox$i" );
            $tpl->setVariable("checkboxChecked", ($myQuestion->getFormsEnd($i) == "1") ? " checked" : "" );
            $tpl->parseCurrentBlock("checkbox");
            	
			$tpl->setCurrentBlock("option");
			$tpl->setVariable("optionNumber", $i);
			if (($myQuestion->type == "radiotable") || ($myQuestion->type == "checkboxtable") || ($myQuestion->type == "texttable"))
			{
				$showOption = $myQuestion->getOptionHeader($i)." --> ".$myQuestion->getOptionAddHeader($i);
			}
			else
			{
				$showOption = $myQuestion->getOptionHeader($i);
			}
			$tpl->setVariable("option", $showOption);
			$tpl->setVariable("selectName", "option$i");
            $tpl->parseCurrentBlock("option");
		}
	}
	else
	{
		for($j=0; $j < count($groups); $j++)
        {
			$tpl->setCurrentBlock("select");
			$tpl->setVariable("groupId", $groups[$j]["FORM_ID_PK"]);
			$tpl->setVariable("groupSelected", ($myQuestion->getSwitch(0) == $groups[$j]["FORM_ID_PK"]) ? " selected" : "" );
			$tpl->setVariable("groupName", $groups[$j]["FORM_NAME"]);
			$tpl->parseCurrentBlock("select");
		}
        
        $tpl->setCurrentBlock("checkbox");
        $tpl->setVariable("checkboxName", "checkbox$i" );
        $tpl->setVariable("checkboxChecked", ($myQuestion->getFormsEnd($i) == "1") ? " checked" : "" );
        $tpl->parseCurrentBlock("checkbox");
        	
		$tpl->setCurrentBlock("switchtext");
		$tpl->setVariable("selectName", "option0");
		$tpl->parseCurrentBlock("switchtext");
	}
	
	$tpl->setVariable( "lnk_detail", $fileSurveyQuestionDetailview."?projectId=$projectId&groupId=$groupId&questionId=".$questionId."&orderId=".$orderId );
	$tpl->setVariable( "lnk_edit", $fileSurveyQuestionEdit."?projectId=$projectId&groupId=$groupId&questionId=".$questionId."&orderId=".$orderId );
	$tpl->setVariable( "lnk_properties", $fileSurveyQuestionProperties."?projectId=$projectId&groupId=$groupId&questionId=".$questionId."&orderId=".$orderId );
	$tpl->setVariable( "lnk_position", $fileSurveyQuestionOrder."?projectId=$projectId&groupId=$groupId&questionId=".$questionId."&orderId=".$orderId );
	$tpl->setVariable( "lnk_delete", $fileSurveyQuestionDelete."?projectId=$projectId&groupId=$groupId&questionId=".$questionId."&orderId=".$orderId );


	$tpl->parse();
	$tpl->get();
	$tpl->show();
}
else
{
	echo "ERROR...";
}
?>
