<?php 
// +----------------------------------------------------------------------+
// | survey pilot                                                         |
// +----------------------------------------------------------------------+
// | Copyright (c) 2002 serie a - Digitale Medien und Systeme GmbH        |
// +----------------------------------------------------------------------+
// | Authors: Jrn Allert <allert@serie-a.de>                             |
// |          Rene Renk <renk@serie-a.de>                                 |
// +----------------------------------------------------------------------+
//
// $Id: survey.security.administration.cookie.php,v 1.1.1.1 2004/07/15 13:32:25 opensurveypilot Exp $

// start session
@session_start();

// require all configuration files and libraries
require_once("./../config/config.inc.php"); // common config file
require_once ("Validate.php"); // PEAR::Validate
require_once($cfgPathToConf."/file.inc.php"); // project files
require_once($cfgPathToLib."/common.inc.php"); // common functions
require_once($cfgPathToSurveyFiles."/config/survey.config.inc.php"); // survey config file
require_once($cfgPathToSurveyFiles."/config/survey.file.inc.php"); // survey files
require_once($cfgPathToSurveyFiles."/lib/database/dbfunctions.inc.php"); // survey db functions
require_once($cfgPathToSurveyFiles."/lib/survey.inc.php"); // survey functions
require_once($cfgPathToSurveyFiles."/lib/security/security.inc.php"); // security functions
require_once($cfgPathToAuthFiles."/lib/user.inc.php"); // auth functions
require_once($cfgPathToAuthFiles."/config/auth.file.inc.php"); // auth files
require_once($cfgPathToAuthFiles."/lib/permission.inc.php"); // permission functions
require_once("HTML/Template/IT.php"); // PEAR::HTML_TEMPLATE_IT


// create new userFunctions object
$client = &new userFunctions;

//login check
if ($client->getAuthentication($_SESSION["sessionId"], session_id()) ==  false)
{
    //redirect to login page
    ?>
    <script type="text/javascript">
    <!--
    window.location.href="<?php echo $cfgUrlToProject."/".$fileAuthLogin; ?>";
    -->
    </script>
    <?php
    exit;
}

// function permission check
if($_SESSION["sessionUserStatusId"] < $permSurveySecurityAdministrationTanCreate)
{
    ?>
    <script type="text/javascript">
    <!--
    window.location.href="<?php echo $cfgUrlToProject."/".$fileNoPermission."?messageCode=2"; ?>";
    -->
    </script>
    <?php
    exit;
} 

// get projectId
$projectId = (isset($_GET["projectId"])) ? $_GET["projectId"] : $_POST["projectId"];

// create new permissionFunctions object
$permission = &new permissionFunctions;
// get Permission
$permissionMode = $permission->getPermissionMode($_SESSION["sessionUserId"], $projectId, 1);
if($permission->errorMessage)
{
    echo $permission->errorMessage;
}
// permission must be 4 (execute)
if($permissionMode < 4)
{
    ?>
    <script type="text/javascript">
    <!--
    window.location.href="<?php echo $cfgUrlToProject."/".$fileNoPermission."?messageCode=1"; ?>";
    -->
    </script>
    <?php
    exit;
}

$errors = array();

//create new security object
$security = &new securityFunctions;

// check if form was submitted
if($_SERVER["REQUEST_METHOD"] == "POST")
{
	// cookie time
	$cookieTime["dayTo"]	= $_POST["limitCookieDayTo"];
	$cookieTime["monthTo"]	= $_POST["limitCookieMonthTo"];
	$cookieTime["yearTo"]	= $_POST["limitCookieYearTo"];
	if($cookieTime["dayTo"] && $cookieTime["monthTo"] && $cookieTime["yearTo"])
	{
		$cookieTimeForDb = $cookieTime["yearTo"].".".$cookieTime["monthTo"].".".$cookieTime["dayTo"];
		$cookieTimeToCheck = getTimestamp($cookieTime["dayTo"].".".$cookieTime["monthTo"].".".$cookieTime["yearTo"]);
		if(!is_array($cookieTimeToCheck))
		{
			$errors[] = $cookieTimeToCheck;
		}
		if($cookieTimeToCheck["timestamp"] < time())
		{
			$errors[] = $lang_script["survey.security.administration.cookie.php"]["cookieExpire"];
		}
	}
	if(($cookieTime["dayTo"] || $cookieTime["monthTo"] || $cookieTime["yearTo"]) && (!$cookieTime["dayTo"] || !$cookieTime["monthTo"] || !$cookieTime["yearTo"]))
	{
		$errors[] = $lang_script["survey.security.administration.cookie.php"]["cookieDate"];
	}
	// cookieName
	$cookieName = cleanHtml($_POST["cookieName"]);
    if(!validate::string($cookieName, VAL_ALPHA_NUM_, 1, 50))
    {
        $errors[] = $lang_script["survey.security.administration.cookie.php"]["cookieInValid"];
		$cookieName = "";
    }
    // set project id
    $security->setProjectId($projectId);
	
	if(!$errors)
	{
		$result = $security->setSecurityCookieParams($cookieName, $cookieTimeForDb);
	    if(PEAR::isError($result))
	    {
	        $errors[] = $result->getMessage();
	    }
	    if(!$result)
		{
			$errors[] = $lang_script["survey.security.administration.cookie.php"]["noSuccess"];
		}
	}
	//
    if(!$errors)
    {
        ?>
        <html><body>
        <script type="text/javascript">
        <!--
        window.location.href="<?php echo $fileSurveySecurityEdit."?projectId=".$projectId."&warningChecked=yes" ?>";
        -->
        </script>
        <?php
        exit;
    }
}

// set project id
$security->setProjectId($projectId);

// create Template IT object
$tpl = new HTML_Template_IT($cfgPathToSurveyTemplates);

// load template
$tpl->loadTemplatefile($templateSurveySecurityAdministrationCookie, true, true);

// set title
$tpl->setVariable( "applicationtitle", $cfgApplicationType.$cfgApplicationVersion);

$tpl->setVariable( "formaction", $fileSurveySecurityAdministrationCookie);
$tpl->setVariable( "projectid", $projectId);

$tpl->setVariable( "lnk_method", $fileSurveySecurityEdit."?projectId=".$projectId."&warningChecked=yes");
$tpl->setVariable( "lnk_settings", $fileSurveySecurityAdministration."?projectId=".$projectId."&warningChecked=yes");

// get cookie data
$result = $security->getSecurityCookieParams();
if(PEAR::isError($result))
{
    $errors[] = $result->getMessage();
}
elseif($result)
{
	$expireTime = getTimestamp($result["T_SURVEY_COOKIE_EXPIRES"]);
	$cookieTime["dayTo"]	= $expireTime["day"];
	$cookieTime["monthTo"]	= $expireTime["month"];
	$cookieTime["yearTo"]	= $expireTime["year"];
	$cookieName = $result["T_SURVEY_COOKIE_NAME"];
	$tpl->touchBlock("has_cookie");
}

// time
//

// get last 6 weeks
$defaultTimeFromWeeks = 4; 
$dateArray = getdate();
$fourWeekAheadTimestamp = $dateArray[0] + ($defaultTimeFromWeeks * 604800);
$fourWeekAheadDate = date("j.m.Y", $fourWeekAheadTimestamp);
$defaultTimeFromData = explode(".",$fourWeekAheadDate);


// set day to
for($d=1;$d<=31;$d++)
{
	$dd = (strlen((string)$d) == 1) ? "0".$d : $d;
    $tpl->setCurrentBlock( "limit_cookie_day_to" );
    $tpl->setVariable( "limit_cookie_day_to_value", $d );
	$tpl->setVariable( "limit_cookie_day_to_content", $dd );
    if($cookieTime["dayTo"] == $d)
    {
        $tpl->setVariable( "limit_cookie_day_to_selected", "selected" );
    }
    $tpl->parseCurrentBlock();
}

//
//

// set month to
for($m=1;$m<12;$m++)
{
	$mm = (strlen((string)$m) == 1) ? "0".$m : $m;
	$tpl->setCurrentBlock( "limit_cookie_month_to" );
    $tpl->setVariable( "limit_cookie_month_to_value", $m );
    $tpl->setVariable( "limit_cookie_month_to_content", $mm );
	if($cookieTime["monthTo"] == $m )
    {
        $tpl->setVariable( "limit_cookie_month_to_selected", "selected" );
    }
    $tpl->parseCurrentBlock();
}

//
//

// set year to
for($y=2003;$y<=2020;$y++)
{
	$tpl->setCurrentBlock( "limit_cookie_year_to" );
    $tpl->setVariable( "limit_cookie_year_to_value", $y );
	$tpl->setVariable( "limit_cookie_year_to_content", $y );
    if($cookieTime["yearTo"] == $y)
    {
        $tpl->setVariable( "limit_cookie_year_to_selected", "selected" );
    }
    $tpl->parseCurrentBlock();
}

if(!$cookieName)
{
	$cookieName = "osp_cookie";
}
$tpl->setVariable( "id_for_cookie", $projectId );

$tpl->setVariable( "cookie_name", $cookieName);

$tpl->setVariable( "back_link", $cfgUrlToProject."/survey/".$fileSurveySecurityAdministration."?projectId=".$projectId );
$tpl->setVariable( "errors", join("<br>", $errors) );

// parse template
$tpl->parse();

// get the parsed template and print it
$tpl->get();
$tpl->show();
?>
