<?php 
// +----------------------------------------------------------------------+
// | survey pilot                                                         |
// +----------------------------------------------------------------------+
// | Copyright (c) 2002 serie a - Digitale Medien und Systeme GmbH        |
// +----------------------------------------------------------------------+
// | Authors: Jrn Allert <allert@serie-a.de>                             |
// |          Rene Renk <renk@serie-a.de>                                 |
// +----------------------------------------------------------------------+
//
// $Id: survey.security.administration.php,v 1.1.1.1 2004/07/15 13:32:25 opensurveypilot Exp $

// start session
@session_start();

// require all configuration files and libraries
require_once("./../config/config.inc.php"); // common config file
require_once($cfgPathToConf."/file.inc.php"); // project files
require_once($cfgPathToLib."/common.inc.php"); // common functions
require_once($cfgPathToSurveyFiles."/config/survey.config.inc.php"); // survey config file
require_once($cfgPathToSurveyFiles."/config/survey.file.inc.php"); // survey files
require_once($cfgPathToSurveyFiles."/lib/database/dbfunctions.inc.php"); // survey db functions
require_once($cfgPathToSurveyFiles."/lib/survey.inc.php"); // survey functions
require_once($cfgPathToSurveyFiles."/lib/security/security.inc.php"); // security functions
require_once($cfgPathToAuthFiles."/lib/user.inc.php"); // auth functions
require_once($cfgPathToAuthFiles."/config/auth.file.inc.php"); // auth files
require_once($cfgPathToAuthFiles."/lib/permission.inc.php"); // permission functions
require_once("HTML/Template/IT.php"); // PEAR::HTML_TEMPLATE_IT

// create new userFunctions object
$client = &new userFunctions;

//login check
if ($client->getAuthentication($_SESSION["sessionId"], session_id()) ==  false)
{
    //redirect to login page
    ?>
    <script type="text/javascript">
    <!--
    window.location.href="<?php echo $cfgUrlToProject."/".$fileAuthLogin; ?>";
    -->
    </script>
    <?php
    exit;
}

// function permission check
if($_SESSION["sessionUserStatusId"] < $permSurveySecurityAdministration)
{
    ?>
    <script type="text/javascript">
    <!--
    window.location.href="<?php echo $cfgUrlToProject."/".$fileNoPermission."?messageCode=2"; ?>";
    -->
    </script>
    <?php
    exit;
}  

// get projectId
$projectId = (isset($_GET["projectId"])) ? $_GET["projectId"] : $_POST["projectId"];

// create new permissionFunctions object
$permission = &new permissionFunctions;
// get Permission
$permissionMode = $permission->getPermissionMode($_SESSION["sessionUserId"], $projectId, 1);
if($permission->errorMessage)
{
    echo $permission->errorMessage;
}
// permission must be 4 (execute)
if($permissionMode < 4)
{
    ?>
    <script type="text/javascript">
    <!--
    window.location.href="<?php echo $cfgUrlToProject."/".$fileNoPermission."?messageCode=1"; ?>";
    -->
    </script>
    <?php
    exit;
}

// activecheck
if (($surveyData[0]["PROJECT_ACTIVE"]=="yes")AND(!$_GET["warningChecked"]))
{
	// create Template IT object
	$tpl = new HTML_Template_IT($cfgPathToSurveyTemplates);
	
	// load template
	$tpl->loadTemplatefile($templateSurveyActiveWarning, true, true);
	
	// set title
	$tpl->setVariable( "applicationtitle", $cfgApplicationType.$cfgApplicationVersion);

	$tpl->setVariable( "projectId", "$projectId" );
	$tpl->get();
	$tpl->show();
	exit;
}

//create new security object
$security = &new securityFunctions;

// set project id
$security->setProjectId($projectId);

// get securityMethod
$securityMethod = $security->getSecurityMethod();
if($security->errorMessage)
{
    $errors .= $lang_script["survey.security.administration.php"]["error"]."<br>".$security->errorMessage."<br>";
}
else
{
	// check which method
	switch ($securityMethod)
	{
		case "cookie":
		{
			?>
		    <script type="text/javascript">
		    <!--
		    window.location.href="<?php echo $cfgUrlToProject."/survey/".$fileSurveySecurityAdministrationCookie."?projectId=".$projectId; ?>";
		    -->
		    </script>
		    <?php
		    exit;
		}
		case "tan":
		{
		    ?>
		    <script type="text/javascript">
		    <!--
		    window.location.href="<?php echo $cfgUrlToProject."/survey/".$fileSurveySecurityAdministrationTan."?projectId=".$projectId; ?>";
		    -->
		    </script>
		    <?php
		    exit;
		}
		default:
		{
			$message  = "<br>".$lang_script["survey.security.administration.php"]["selectMethod"];break;
		}
	}
}
// create Template IT object
$tpl = new HTML_Template_IT($cfgPathToSurveyTemplates);

// load template
$tpl->loadTemplatefile($templateSurveySecurityAdministration, true, true);

// set title
$tpl->setVariable( "applicationtitle", $cfgApplicationType.$cfgApplicationVersion);

$tpl->setVariable( "lnk_method", $fileSurveySecurityEdit."?projectId=".$projectId."&warningChecked=yes");
$tpl->setVariable( "lnk_settings", $fileSurveySecurityAdministration."?projectId=".$projectId."&warningChecked=yes");

$tpl->setVariable( "message", $message );
$tpl->setVariable( "errors", $errors );

// parse template
$tpl->parse();

// get the parsed template and print it
$tpl->get();
$tpl->show();
?>
