<?php 
// +----------------------------------------------------------------------+
// | survey pilot                                                         |
// +----------------------------------------------------------------------+
// | Copyright (c) 2002 serie a - Digitale Medien und Systeme GmbH        |
// +----------------------------------------------------------------------+
// | Authors: Jrn Allert <allert@serie-a.de>                             |
// |          Rene Renk <renk@serie-a.de>                                 |
// +----------------------------------------------------------------------+
//
// $Id: survey.security.administration.tan.create.php,v 1.2 2007/01/06 12:40:25 easy_israel Exp $

require("./../config/config.inc.php"); // common config file
require_once ("Validate.php"); // PEAR::Validate (must be included before common config file)
require_once("./lib/security/security.inc.php"); // security functions

// start session
@session_start();
require("./../config/config.inc.php"); // common config file
// require all configuration files and libraries
require_once($cfgPathToConf."/file.inc.php"); // project files
require_once($cfgPathToLib."/common.inc.php"); // common functions
require_once($cfgPathToSurveyFiles."/config/survey.config.inc.php"); // survey config file
require_once($cfgPathToSurveyFiles."/config/survey.file.inc.php"); // survey files
require_once($cfgPathToSurveyFiles."/lib/database/dbfunctions.inc.php"); // survey db functions
require_once($cfgPathToSurveyFiles."/lib/survey.inc.php"); // survey functions
require_once($cfgPathToSurveyFiles."/lib/security/security.inc.php"); // security functions
require_once($cfgPathToAuthFiles."/lib/user.inc.php"); // auth functions
require_once($cfgPathToAuthFiles."/config/auth.file.inc.php"); // auth files
require_once($cfgPathToAuthFiles."/lib/permission.inc.php"); // permission functions
require_once("HTML/Template/IT.php"); // PEAR::HTML_TEMPLATE_IT

// create new userFunctions object
$client = &new userFunctions;

//login check
if ($client->getAuthentication($_SESSION["sessionId"], session_id()) ==  false)
{
    //redirect to login page
    ?>
    <script type="text/javascript">
    <!--
    window.location.href="<?php echo $cfgUrlToProject."/".$fileAuthLogin; ?>";
    -->
    </script>
    <?php
    exit;
}

// function permission check
if($_SESSION["sessionUserStatusId"] < $permSurveySecurityAdministrationTanCreate)
{
    ?>
    <script type="text/javascript">
    <!--
    window.location.href="<?php echo $cfgUrlToProject."/".$fileNoPermission."?messageCode=2"; ?>";
    -->
    </script>
    <?php
    exit;
} 

// get projectId
$projectId = (isset($_GET["projectId"])) ? $_GET["projectId"] : $_POST["projectId"];

// create new permissionFunctions object
$permission = &new permissionFunctions;
// get Permission
$permissionMode = $permission->getPermissionMode($_SESSION["sessionUserId"], $projectId, 1);
if($permission->errorMessage)
{
    echo $permission->errorMessage;
}
// permission must be 4 (execute)
if($permissionMode < 4)
{
    ?>
    <script type="text/javascript">
    <!--
    window.location.href="<?php echo $cfgUrlToProject."/".$fileNoPermission."?messageCode=1"; ?>";
    -->
    </script>
    <?php
    exit;
}

// activecheck
if (($surveyData[0]["PROJECT_ACTIVE"]=="yes")AND(!$_GET["warningChecked"]))
{
	// create Template IT object
	$tpl = new HTML_Template_IT($cfgPathToSurveyTemplates);
	
	// load template
	$tpl->loadTemplatefile($templateSurveyActiveWarning, true, true);
	// set title
	$tpl->setVariable( "applicationtitle", $cfgApplicationType.$cfgApplicationVersion);

	$tpl->setVariable( "projectId", "$projectId" );
	$tpl->get();
	$tpl->show();
	exit;
}
$error = "";

//get security object from session
$security = $_SESSION["securityObject"];

// set project id
$security->setProjectId($projectId);

// create Template IT object
$tpl = new HTML_Template_IT($cfgPathToSurveyTemplates);

#echo $cfgPathToSurveyTemplates;
// load template
$tpl->loadTemplatefile($templateSurveySecurityAdministrationTanCreate, true, true);

$tpl->setVariable( "lnk_method", $fileSurveySecurityEdit."?projectId=".$projectId."&warningChecked=yes");
$tpl->setVariable( "create_tan_link", $cfgUrlToProject."/survey/".$fileSurveySecurityAdministrationTanCreate."?projectId=".$projectId );
$tpl->setVariable( "show_tan_link", $cfgUrlToProject."/survey/".$fileSurveySecurityAdministrationTanShow."?projectId=".$projectId );
$tpl->setVariable( "delete_tan_link", $cfgUrlToProject."/survey/".$fileSurveySecurityAdministrationTanDelete."?projectId=".$projectId );
$tpl->setVariable( "export_tan_link", $cfgUrlToProject."/survey/".$fileSurveySecurityAdministrationTanExport."?projectId=".$projectId );
$tpl->setVariable( "delete_group_link", $cfgUrlToProject."/survey/".$fileSurveySecurityAdministrationGroupDelete."?projectId=".$projectId );


// set title
$tpl->setVariable( "applicationtitle", $cfgApplicationType.$cfgApplicationVersion);

$tpl->setVariable( "formaction", $fileSurveySecurityAdministrationTanCreate);
$tpl->setVariable( "projectid", $projectId);

// check if form was submitted
if($_SERVER["REQUEST_METHOD"] == "POST")
{
#echo "Step:".$step."<br>";
	if($step == 1)
	{
		$newGroup  = $_POST["newGroup"];
		$tanGroups = $_POST["tanGroups"]; 
		// empty possible entries
		$security->emptyGroupsToTans();
		
		// invalid entry step 1
		if($newGroup != '' && strlen($newGroup)<4)
		{
			$error = $lang_script["survey.security.administration.tan.create.php"]["groupNameError"]."<br>".$lang_script["survey.security.administration.tan.create.php"]["groupNameLenght"];
			
			// get groups
			$tanGroups	=	$security->getTanGroups();
			
			$tpl->touchBlock( "choose_group_block");
			
			for($i=0;$i<count($tanGroups);$i++)
			{
				$tpl->setCurrentBlock( "tan_group_list");
				$tpl->setVariable( "tan_group_id", $tanGroups[$i]->getTanGroupValue("TANGROUP_ID_PK") );
				$tpl->setVariable( "tan_group_name", $tanGroups[$i]->getTanGroupValue("TANGROUP_NAME") );
				$tpl->parseCurrentBlock();
			}
			
			// common settings
			$tpl->setVariable( "step", 2 );
			$tpl->setVariable( "headlinetext", $lang_script["survey.security.administration.tan.create.php"]["selectTanGroup"]);
			$tpl->setVariable( "errors", $error );
			$tpl->setVariable( "submittext", $lang_script["survey.security.administration.tan.create.php"]["select"]);
			
			// store object to session
			$_SESSION["securityObject"] = $security;
			
			// display template
			$tpl->parse();
			$tpl->get();
			$tpl->show();
			exit;
		}
		elseif($newGroup && $security->tanGroupExists(addslashes($newGroup)))
		{ 
			$error = $lang_script["survey.security.administration.tan.create.php"]["errorGroup"]." <b>".stripslashes($newGroup)."</b>, ".$lang_script["survey.security.administration.tan.create.php"]["errorExists"];
			
			// get groups
			$tanGroups	=	$security->getTanGroups();
			
			$tpl->touchBlock( "choose_group_block");
			
			for($i=0;$i<count($tanGroups);$i++)
			{
				$tpl->setCurrentBlock( "tan_group_list");
				$tpl->setVariable( "tan_group_id", $tanGroups[$i]->getTanGroupValue("TANGROUP_ID_PK") );
				$tpl->setVariable( "tan_group_name", $tanGroups[$i]->getTanGroupValue("TANGROUP_NAME") );
				$tpl->parseCurrentBlock();
			}
			
			// common settings
			$tpl->setVariable( "step", 1 );
			$tpl->setVariable( "headlinetext", $lang_script["survey.security.administration.tan.create.php"]["selectTanGroup"]);
			$tpl->setVariable( "errors", $error );
			$tpl->setVariable( "submittext", $lang_script["survey.security.administration.tan.create.php"]["select"]);
			
			// store object to session
			$_SESSION["securityObject"] = $security;
			
			// display template
			$tpl->parse();
			$tpl->get();
			$tpl->show();
			exit;
		}
		elseif($newGroup)
		{
			$security->setNewGroupToCreate(addslashes($newGroup));
			// tantext
			$tpl->setVariable( "tan_text", $lang_script["survey.security.administration.tan.create.php"]["newGroup"]." <b>".stripslashes($newGroup)."</b><br>".$lang_script["survey.security.administration.tan.create.php"]["wantToCreate"]);
		}
		elseif($tanGroups > 0)
		{
			$security->setGroupsToTans($tanGroups);
				
			// get names of choosen groups
			$groupsToTans = $security->getGroupsToTans();
			
			// tantext
			$tpl->setVariable( "tan_text", $lang_script["survey.security.administration.tan.create.php"]["group"]." <b>".$groupsToTans[0]->getTanGroupValue("TANGROUP_NAME")."</b><br>".$lang_script["survey.security.administration.tan.create.php"]["wantToCreateNew"]);
			// get tan num 
			$tanNum = $security->getTanNum();
			$tanNum = ($tanNum > 0)? $tanNum : "0";
			$tpl->setVariable( "tan_num_text", $lang_script["survey.security.administration.tan.create.php"]["alreadyCreated"]." <b>$tanNum</b>" );
			// get used tan
			$usedTanNum = $security->getUsedTanNum();
			$usedTanNum = ($usedTanNum > 0)? $usedTanNum : "0";
			$tpl->setVariable( "used_num_text", $lang_script["survey.security.administration.tan.create.php"]["alreadyUsed"]." <b>$usedTanNum</b>" );
		}
		else
		{
			$security->setGroupsToTans('all');
			
			// tantext
			$tpl->setVariable( "tan_text", $lang_script["survey.security.administration.tan.create.php"]["TansNotGrouped"]);
			// get tan num 
			$tanNum = $security->getTanNum();
			$tanNum = ($tanNum > 0)? $tanNum : "0";
			$tpl->setVariable( "tan_num_text", $lang_script["survey.security.administration.tan.create.php"]["alreadyCreated"]." <b>$tanNum</b> ".$lang_script["survey.security.administration.tan.create.php"]["TansCreated"]);
			// get used tan
			$usedTanNum = $security->getUsedTanNum();
			$usedTanNum = ($usedTanNum > 0)? $usedTanNum : "0";
			$tpl->setVariable( "used_num_text", $lang_script["survey.security.administration.tan.create.php"]["alreadyUsed"]." <b>$usedTanNum</b> ".$lang_script["survey.security.administration.tan.create.php"]["TansUsed"] );
		}
		// common settings
		$tpl->setVariable( "headlinetext", $lang_script["survey.security.administration.tan.create.php"]["TansNumber"]);
		$tpl->setVariable( "errors", $error );
		$tpl->setVariable( "step", 2 );
		$step = 2;
		$tpl->setVariable( "submittext", $lang_script["survey.security.administration.tan.create.php"]["TansNew"]);
		
		// store object to session
		$_SESSION["securityObject"] = $security;
		// parse template
		$tpl->parse();
		$tpl->get();
		$tpl->show();
		exit;
	}
	if($step == 2)
	{
	    // create tan table
	    $security->createTanAndGroupTable();
	    if($security->errorMessage)
	    {
	        $error .= $security->errorMessage;
	    }
	    
	    // get tan parameters
	    //$tanLength = $_POST["tanLength"];
	    $tanNum = $_POST["tanNum"];
	    
	    $tanArray = $security->createTan(10000000, 99999999, $tanNum);
	    if($security->errorMessage)
	    {
	        $error .= $security->errorMessage;
	    }
	       
	    if(!$error)
	    {
	       ?>
	        <html><body>
	        <script type="text/javascript">
	        <!--
	        window.location.href="<?php echo $fileSurveySecurityEdit."?projectId=".$projectId."&warningChecked=yes" ?>";
	        -->
	        </script>
	        <?php
	        exit;
	    }
	}
}
// set tan table name
$security->setTanTableName();
// set group table name
$security->setTanGroupTableName();
// get groups
$tanGroups	=	$security->getTanGroups();

$tpl->touchBlock( "choose_group_block");

for($i=0;$i<count($tanGroups);$i++)
{
	$tpl->setCurrentBlock( "tan_group_list");
	$tpl->setVariable( "tan_group_id", $tanGroups[$i]->getTanGroupValue("TANGROUP_ID_PK") );
	$tpl->setVariable( "tan_group_name", $tanGroups[$i]->getTanGroupValue("TANGROUP_NAME") );
	$tpl->parseCurrentBlock();
}

// common settings
$tpl->setVariable( "step", 1 );
$tpl->setVariable( "headlinetext", $lang_script["survey.security.administration.tan.create.php"]["selectTanGroup"]);
$tpl->setVariable( "errors", $error );
$tpl->setVariable( "submittext", $lang_script["survey.security.administration.tan.create.php"]["select"]);

// store object to session
$_SESSION["securityObject"] = $security;

// display template
$tpl->parse();
$tpl->get();
$tpl->show();
?>
