<?php 
// +----------------------------------------------------------------------+
// | survey pilot                                                         |
// +----------------------------------------------------------------------+
// | Copyright (c) 2002 serie a - Digitale Medien und Systeme GmbH        |
// +----------------------------------------------------------------------+
// | Authors: Jrn Allert <allert@serie-a.de>                             |
// |          Rene Renk <renk@serie-a.de>                                 |
// +----------------------------------------------------------------------+
//
// $Id: survey.security.administration.tan.group.delete.php,v 1.1.1.1 2004/07/15 13:32:27 opensurveypilot Exp $

require_once("./lib/security/security.inc.php"); // security functions

// start session
@session_start();

// require all configuration files and libraries
require_once("./../config/config.inc.php"); // common config file
require_once($cfgPathToConf."/file.inc.php"); // project files
require_once($cfgPathToLib."/common.inc.php"); // common functions
require_once($cfgPathToSurveyFiles."/config/survey.config.inc.php"); // survey config file
require_once($cfgPathToSurveyFiles."/config/survey.file.inc.php"); // survey files
require_once($cfgPathToSurveyFiles."/lib/database/dbfunctions.inc.php"); // survey db functions
require_once($cfgPathToSurveyFiles."/lib/survey.inc.php"); // survey functions
require_once($cfgPathToAuthFiles."/lib/user.inc.php"); // auth functions
require_once($cfgPathToAuthFiles."/config/auth.file.inc.php"); // auth files
require_once($cfgPathToAuthFiles."/lib/permission.inc.php"); // permission functions
require_once("HTML/Template/IT.php"); // PEAR::HTML_TEMPLATE_IT

// create new userFunctions object
$client = &new userFunctions;

//login check
if ($client->getAuthentication($_SESSION["sessionId"], session_id()) ==  false)
{
    //redirect to login page
    ?>
    <script type="text/javascript">
    <!--
    window.location.href="<?php echo $cfgUrlToProject."/".$fileAuthLogin; ?>";
    -->
    </script>
    <?php
    exit;
}

// function permission check
if($_SESSION["sessionUserStatusId"] < $permSurveySecurityAdministrationTanDelete)
{
    ?>
    <script type="text/javascript">
    <!--
    window.location.href="<?php echo $cfgUrlToProject."/".$fileNoPermission."?messageCode=2"; ?>";
    -->
    </script>
    <?php
    exit;
} 

// get projectId
$projectId = (isset($_GET["projectId"])) ? $_GET["projectId"] : $_POST["projectId"];

// create new permissionFunctions object
$permission = &new permissionFunctions;
// get Permission
$permissionMode = $permission->getPermissionMode($_SESSION["sessionUserId"], $projectId, 1);
if($permission->errorMessage)
{
    echo $permission->errorMessage;
}
// permission must be 4 (execute)
if($permissionMode < 4)
{
    ?>
    <script type="text/javascript">
    <!--
    window.location.href="<?php echo $cfgUrlToProject."/".$fileNoPermission."?messageCode=1"; ?>";
    -->
    </script>
    <?php
    exit;
}

// activecheck
if (($surveyData[0]["PROJECT_ACTIVE"]=="yes")AND(!$_GET["warningChecked"]))
{
	// create Template IT object
	$tpl = new HTML_Template_IT($cfgPathToSurveyTemplates);
	
	// load template
	$tpl->loadTemplatefile($templateSurveyActiveWarning, true, true);
	
	// set title
	$tpl->setVariable( "applicationtitle", $cfgApplicationType.$cfgApplicationVersion);

	$tpl->setVariable( "projectId", "$projectId" );
	$tpl->get();
	$tpl->show();
	exit;
}

//get security object from session
$security = $_SESSION["securityObject"];

// set project id
$security->setProjectId($projectId);

// create Template IT object
$tpl = new HTML_Template_IT($cfgPathToSurveyTemplates);

// load template
$tpl->loadTemplatefile($templateSurveySecurityAdministrationGroupDelete, true, true);

// set title and id
$tpl->setVariable( "applicationtitle", $cfgApplicationType.$cfgApplicationVersion);
$tpl->setVariable( "projectid", $projectId);

$tpl->setVariable( "lnk_method", $fileSurveySecurityEdit."?projectId=".$projectId."&warningChecked=yes");
$tpl->setVariable( "create_tan_link", $cfgUrlToProject."/survey/".$fileSurveySecurityAdministrationTanCreate."?projectId=".$projectId );
$tpl->setVariable( "show_tan_link", $cfgUrlToProject."/survey/".$fileSurveySecurityAdministrationTanShow."?projectId=".$projectId );
$tpl->setVariable( "delete_tan_link", $cfgUrlToProject."/survey/".$fileSurveySecurityAdministrationTanDelete."?projectId=".$projectId );
$tpl->setVariable( "export_tan_link", $cfgUrlToProject."/survey/".$fileSurveySecurityAdministrationTanExport."?projectId=".$projectId );
$tpl->setVariable( "delete_group_link", $cfgUrlToProject."/survey/".$fileSurveySecurityAdministrationGroupDelete."?projectId=".$projectId );


// check if group form was submitted
if($_SERVER["REQUEST_METHOD"] == "POST")
{
	//get step
	$step = $_POST["step"];
	
	// confirm
	if($step == 1)
	{
		$tanGroups = $_POST["tanGroups"];
		
		if(!$tanGroups)
		{
			// set error and show groupselect again
			$error = $lang_script["survey.security.administration.tan.group.delete.php"]["noGroupSelect"];
			
			// get groups
			$tanGroups	=	$security->getTanGroups();
			
			$tpl->touchBlock( "choose_group_block");
			
			for($i=0;$i<count($tanGroups);$i++)
			{
				$tpl->setCurrentBlock( "tan_group_list");
				$tpl->setVariable( "tan_group_id", $tanGroups[$i]->getTanGroupValue("TANGROUP_ID_PK") );
				$tpl->setVariable( "tan_group_name", $tanGroups[$i]->getTanGroupValue("TANGROUP_NAME") );
				$tpl->parseCurrentBlock();
			}
			
			// common settings
			$tpl->setVariable( "step", 1 );
			$tpl->setVariable( "headlinetext", $lang_script["survey.security.administration.tan.group.delete.php"]["selectTanGroup"]);
			$tpl->setVariable( "errors", $error );
			$tpl->setVariable( "submittext", $lang_script["survey.security.administration.tan.group.delete.php"]["select"]);
			
			// store object to session
			$_SESSION["securityObject"] = $security;
			
			// display template
			$tpl->parse();
			$tpl->get();
			$tpl->show();
			exit;
		}
		// empty possible entries
		$security->emptyGroupsToTans();
		// store groups to delete to session
		for ($i=0;$i<count($tanGroups);$i++)
		{
			switch ($tanGroups[$i])
			{
				case -2:
					$security->setGroupsToTans("all");
					break 2;
				case -1:
					$security->setGroupsToTans("allUngrouped");
					break 2;
				default:
					$security->setGroupsToTans($tanGroups[$i]);
			}
		}
		
		$tpl->touchBlock( "group_delete_block");
		
		// get names of choosen groups
		$groupsToTans = $security->getGroupsToTans();
		
		for($i=0;$i<count($groupsToTans);$i++)
		{
			$groupsToTansNames[] = $groupsToTans[$i]->getTanGroupValue("TANGROUP_NAME");
		}
		// get used tan
		$usedTanNum = $security->getUsedTanNum();
		$tpl->setVariable( "used_num", $usedTanNum );
		
		// get tan num 
		$tanNum = $security->getTanNum();
		$tpl->setVariable( "total_num", $tanNum);
		$tpl->setVariable( "free_num", $tanNum-$usedTanNum);
		$tpl->setVariable( "tan_groups", join(", ",$groupsToTansNames));
		
		// common settings
		$tpl->setVariable( "step", 2 );
		$tpl->setVariable( "headlinetext", $lang_script["survey.security.administration.tan.group.delete.php"]["deleteValidate"]);
		$tpl->setVariable( "errors", $error );
		$tpl->setVariable( "submittext", $lang_script["survey.security.administration.tan.group.delete.php"]["delete"]);
		
		// store object to session
		$_SESSION["securityObject"] = $security;
		
		// display template
		$tpl->parse();
		$tpl->get();
		$tpl->show();
		exit;
	}
	if($step == 2)
	{
		// put to group all
	    $security->setGroupToMoveTansTo('all');
		// empty tan table
	    $security->deleteTanGroups();
        if (PEAR::isError($result)) 
        {    
			$error .= $result->getMessage();
        }
	    if(!$error)
	    {
	        ?>
	        <html><body>
	        <script type="text/javascript">
	        <!--
	        window.location.href="<?php echo $fileSurveySecurityEdit."?projectId=".$projectId."&warningChecked=yes" ?>";
	        -->
	        </script>
	        <?php
	        exit;
	    }
	}
}
// set tan table name
$security->setTanTableName();
// set group table name
$security->setTanGroupTableName();
// get groups
$tanGroups	=	$security->getTanGroups();

$tpl->touchBlock( "choose_group_block");

for($i=0;$i<count($tanGroups);$i++)
{
	$tpl->setCurrentBlock( "tan_group_list");
	$tpl->setVariable( "tan_group_id", $tanGroups[$i]->getTanGroupValue("TANGROUP_ID_PK") );
	$tpl->setVariable( "tan_group_name", $tanGroups[$i]->getTanGroupValue("TANGROUP_NAME") );
	$tpl->parseCurrentBlock();
}

// common settings
$tpl->setVariable( "step", 1 );
$tpl->setVariable( "headlinetext", $lang_script["survey.security.administration.tan.group.delete.php"]["selectTanGroup"]);
$tpl->setVariable( "errors", $error );
$tpl->setVariable( "submittext", $lang_script["survey.security.administration.tan.group.delete.php"]["select"]);

// store object to session
$_SESSION["securityObject"] = $security;

// display template
$tpl->parse();
$tpl->get();
$tpl->show();


?>
