<?php 
// +----------------------------------------------------------------------+
// | survey pilot                                                         |
// +----------------------------------------------------------------------+
// | Copyright (c) 2002 serie a - Digitale Medien und Systeme GmbH        |
// +----------------------------------------------------------------------+
// | Authors: Jrn Allert <allert@serie-a.de>                             |
// |          Rene Renk <renk@serie-a.de>                                 |
// +----------------------------------------------------------------------+
//
// $Id: survey.security.administration.tan.show.php,v 1.1.1.1 2004/07/15 13:32:29 opensurveypilot Exp $

require_once("./lib/security/security.inc.php"); // security functions

// start session
@session_start();

// require all configuration files and libraries
require_once("./../config/config.inc.php"); // common config file
require_once($cfgPathToConf."/file.inc.php"); // project files
require_once($cfgPathToLib."/common.inc.php"); // common functions
require_once($cfgPathToSurveyFiles."/config/survey.config.inc.php"); // survey config file
require_once($cfgPathToSurveyFiles."/config/survey.file.inc.php"); // survey files
require_once($cfgPathToSurveyFiles."/lib/database/dbfunctions.inc.php"); // survey db functions
require_once($cfgPathToSurveyFiles."/lib/survey.inc.php"); // survey functions
require_once($cfgPathToAuthFiles."/lib/user.inc.php"); // auth functions
require_once($cfgPathToAuthFiles."/config/auth.file.inc.php"); // auth files
require_once($cfgPathToAuthFiles."/lib/permission.inc.php"); // permission functions
require_once("HTML/Template/IT.php"); // PEAR::HTML_TEMPLATE_IT

// create new userFunctions object
$client = &new userFunctions;

//login check
if ($client->getAuthentication($_SESSION["sessionId"], session_id()) ==  false)
{
    //redirect to login page
    ?>
    <script type="text/javascript">
    <!--
    window.location.href="<?php echo $cfgUrlToProject."/".$fileAuthLogin; ?>";
    -->
    </script>
    <?php
    exit;
} 

// function permission check
if($_SESSION["sessionUserStatusId"] < $permSurveySecurityAdministrationTanShow)
{
    ?>
    <script type="text/javascript">
    <!--
    window.location.href="<?php echo $cfgUrlToProject."/".$fileNoPermission."?messageCode=2"; ?>";
    -->
    </script>
    <?php
    exit;
} 

// get projectId
$projectId = (isset($_GET["projectId"])) ? $_GET["projectId"] : $_POST["projectId"];

// create new permissionFunctions object
$permission = &new permissionFunctions;
// get Permission
$permissionMode = $permission->getPermissionMode($_SESSION["sessionUserId"], $projectId, 1);
if($permission->errorMessage)
{
    echo $permission->errorMessage;
}
// permission must be 4 (execute)
if($permissionMode < 4)
{
    ?>
    <script type="text/javascript">
    <!--
    window.location.href="<?php echo $cfgUrlToProject."/".$fileNoPermission."?messageCode=1"; ?>";
    -->
    </script>
    <?php
    exit;
}

//create new security object
$security = $_SESSION["securityObject"];

// set project id
$security->setProjectId($projectId);

// activecheck
if (($surveyData[0]["PROJECT_ACTIVE"]=="yes")AND(!$_GET["warningChecked"]))
{
	// create Template IT object
	$tpl = new HTML_Template_IT($cfgPathToSurveyTemplates);
	
	// load template
	$tpl->loadTemplatefile($templateSurveyActiveWarning, true, true);
	
	// set title
	$tpl->setVariable( "applicationtitle", $cfgApplicationType.$cfgApplicationVersion);

	$tpl->setVariable( "projectId", "$projectId" );
	$tpl->get();
	$tpl->show();
	exit;
}
$error = "";

// create Template IT object
$tpl = new HTML_Template_IT($cfgPathToSurveyTemplates);

// load template
$tpl->loadTemplatefile($templateSurveySecurityAdministrationTanShow, true, true);

// set title
$tpl->setVariable( "applicationtitle", $cfgApplicationType.$cfgApplicationVersion);

$tpl->setVariable( "lnk_method", $fileSurveySecurityEdit."?projectId=".$projectId."&warningChecked=yes");
$tpl->setVariable( "create_tan_link", $cfgUrlToProject."/survey/".$fileSurveySecurityAdministrationTanCreate."?projectId=".$projectId );
$tpl->setVariable( "show_tan_link", $cfgUrlToProject."/survey/".$fileSurveySecurityAdministrationTanShow."?projectId=".$projectId );
$tpl->setVariable( "delete_tan_link", $cfgUrlToProject."/survey/".$fileSurveySecurityAdministrationTanDelete."?projectId=".$projectId );
$tpl->setVariable( "export_tan_link", $cfgUrlToProject."/survey/".$fileSurveySecurityAdministrationTanExport."?projectId=".$projectId );
$tpl->setVariable( "delete_group_link", $cfgUrlToProject."/survey/".$fileSurveySecurityAdministrationGroupDelete."?projectId=".$projectId );

$tpl->setVariable( "projectid", $projectId);
$tpl->setVariable( "errors", $error );

// check if group form was submitted
if($_SERVER["REQUEST_METHOD"] == "POST")
{
	$tanGroups = $_POST["tanGroups"];
	
	if(!$tanGroups)
	{
		// show all
		$tanGroups[]	=	-2;
	}
	// empty possible entries
	$security->emptyGroupsToTans();
	// store groups to delete to session
	for ($i=0;$i<count($tanGroups);$i++)
	{
		switch ($tanGroups[$i])
		{
			case -2:
				$security->setGroupsToTans("all");
				break 2;
			case -1:
				$security->setGroupsToTans("allUngrouped");
				break 2;
			default:
				$security->setGroupsToTans($tanGroups[$i]);
		}
	}

	$tpl->touchBlock( "show_tan_list");
	// get names of choosen groups
	$groupsToTans = $security->getGroupsToTans();
	
	for($i=0;$i<count($groupsToTans);$i++)
	{
		$groupsToTansNames[] = $groupsToTans[$i]->getTanGroupValue("TANGROUP_NAME");
	}
	$tpl->setVariable( "tan_groups", join(", ",$groupsToTansNames));
	 
	$tanArray = $security->getTanList();
	if(is_array($tanArray))
	{
	    for($j=0;$j<count($tanArray);$j++)
	    {
	        $tpl->setCurrentBlock( "tan_list" );
	        $tpl->setVariable( "tan_nr", $j+1);
	        $tpl->setVariable( "tan", $tanArray[$j]["SECURITYTAN_TAN"]);
	        $tpl->setVariable( "tan_used", $tanArray[$j]["SECURITYTAN_TAN_USED"]);
	        $tpl->setVariable( "tan_user", $tanArray[$j]["SECURITYTAN_USER"]);
		$tangroup = ($tanArray[$j]["TANGROUP_NAME"] != '')? stripslashes($tanArray[$j]["TANGROUP_NAME"]) : $lang_script["survey.security.administration.tan.show.php"]["noGroup"];
		$tpl->setVariable( "tan_group", $tangroup);
	        $tpl->setVariable( "tan_time", $tanArray[$j]["SECURITYTAN_USED_TIME"]);
	        $tpl->parseCurrentBlock();
	    }
	    $tpl->setVariable( "total_num", count($tanArray));
	}
	else
	{
	    $tpl->setVariable( "total_num", "0");
	}
	
	// get used tan
	$usedTanNum = $security->getUsedTanNum();
	$tpl->setVariable( "used_num", $usedTanNum );
	
	// common settings
	$tpl->setVariable( "headlinetext", $lang_script["survey.security.administration.tan.show.php"]["listSelect"]);
	$tpl->setVariable( "errors", $error );
	$tpl->setVariable( "submittext", $lang_script["survey.security.administration.tan.show.php"]["showAll"]);
	
	// store object to session
	$_SESSION["securityObject"] = $security;
	
	// parse template
	$tpl->parse();
	$tpl->get();
	$tpl->show();
	exit;
}


// set tan table name
$security->setTanTableName();
// set group table name
$security->setTanGroupTableName();
// get groups
$tanGroups	=	$security->getTanGroups();

$tpl->touchBlock( "choose_group_block");

for($i=0;$i<count($tanGroups);$i++)
{
	$tpl->setCurrentBlock( "tan_group_list");
	$tpl->setVariable( "tan_group_id", $tanGroups[$i]->getTanGroupValue("TANGROUP_ID_PK") );
	$tpl->setVariable( "tan_group_name", $tanGroups[$i]->getTanGroupValue("TANGROUP_NAME") );
	$tpl->parseCurrentBlock();
}

// common settings
$tpl->setVariable( "step", 1 );
$tpl->setVariable( "headlinetext", $lang_script["survey.security.administration.tan.show.php"]["selectTanGroup"]);
$tpl->setVariable( "errors", $error );
$tpl->setVariable( "submittext", $lang_script["survey.security.administration.tan.show.php"]["select"]);

// store object to session
$_SESSION["securityObject"] = $security;

// display template
$tpl->parse();
$tpl->get();
$tpl->show();
?>
