<?php 
// +----------------------------------------------------------------------+
// | survey pilot                                                         |
// +----------------------------------------------------------------------+
// | Copyright (c) 2002 serie a - Digitale Medien und Systeme GmbH        |
// +----------------------------------------------------------------------+
// | Authors: J?rn Allert <allert@serie-a.de>                             |
// |          Rene Renk <renk@serie-a.de>                                 |
// +----------------------------------------------------------------------+
//
// $Id: survey.security.edit.php,v 1.1.1.1 2004/07/15 13:32:29 opensurveypilot Exp $

// start session
@session_start();

// require all configuration files and libraries
require_once("./../config/config.inc.php"); // common config file
require_once($cfgPathToConf."/file.inc.php"); // project files
require_once($cfgPathToLib."/common.inc.php"); // common functions
require_once($cfgPathToSurveyFiles."/config/survey.config.inc.php"); // survey config file
require_once($cfgPathToSurveyFiles."/config/survey.file.inc.php"); // survey files
require_once($cfgPathToSurveyFiles."/lib/database/dbfunctions.inc.php"); // survey db functions
require_once($cfgPathToSurveyFiles."/lib/survey.inc.php"); // survey functions
require_once($cfgPathToSurveyFiles."/lib/security/security.inc.php"); // security functions
require_once($cfgPathToAuthFiles."/lib/user.inc.php"); // auth functions
require_once($cfgPathToAuthFiles."/config/auth.file.inc.php"); // auth files
require_once($cfgPathToAuthFiles."/lib/permission.inc.php"); // permission functions
require_once("HTML/Template/IT.php"); // PEAR::HTML_TEMPLATE_IT

// create new userFunctions object
$client = &new userFunctions;

//login check
if ($client->getAuthentication($_SESSION["sessionId"], session_id()) ==  false)
{
    //redirect to login page
    ?>
    <script type="text/javascript">
    <!--
    window.location.href="<?php echo $cfgUrlToProject."/".$fileAuthLogin; ?>";
    -->
    </script>
    <?php
    exit;
} 

// function permission check
if($_SESSION["sessionUserStatusId"] < $permSurveySecurityEdit)
{
    ?>
    <script type="text/javascript">
    <!--
    window.location.href="<?php echo $cfgUrlToProject."/".$fileNoPermission."?messageCode=2"; ?>";
    -->
    </script>
    <?php
    exit;
} 

// get projectId
$projectId = (isset($_GET["projectId"])) ? $_GET["projectId"] : $_POST["projectId"];

// create new permissionFunctions object
$permission = &new permissionFunctions;
// get Permission
$permissionMode = $permission->getPermissionMode($_SESSION["sessionUserId"], $projectId, 1);
if($permission->errorMessage)
{
    echo $permission->errorMessage;
}
// permission must be 4 (execute)
if($permissionMode < 4)
{
    ?>
    <script type="text/javascript">
    <!--
    window.location.href="<?php echo $cfgUrlToProject."/".$fileNoPermission."?messageCode=1"; ?>";
    -->
    </script>
    <?php
    exit;
}

//create new security object
$security = &new securityFunctions;

// set project id
$security->setProjectId($projectId);

// init dbFunctions
$dbFunctions = &new dbFunctions;

// get survey data
$surveyData = $dbFunctions->tabToArrayWhithArg($cfgSrvyTabSurvey,array("PROJECT_ID_PK"=>"$projectId"));

// activecheck
if (($surveyData[0]["PROJECT_ACTIVE"]=="yes")AND(!$_GET["warningChecked"]))
{
	// create Template IT object
	$tpl = new HTML_Template_IT($cfgPathToSurveyTemplates);
	
	// load template
	$tpl->loadTemplatefile($templateSurveyActiveWarning, true, true);
	
	// set title
	$tpl->setVariable( "applicationtitle", $cfgApplicationType.$cfgApplicationVersion);

	$tpl->setVariable( "projectId", "$projectId" );
	$tpl->get();
	$tpl->show();
	exit;
}

// check if form was submitted
if($_SERVER["REQUEST_METHOD"] == "POST")
{
    $surveySecurityMethod = $_POST["securityMethod"];
    
    // set security mode
    $security->setSecurityMethod($surveySecurityMethod);
    
    // save security settings
    $security->saveSecuritySettings();
    if($security->errorMessage)
    {
        $error .= $security->errorMessage;
    }
    
    if (!$error)
    {
	?>
	<script type="text/javascript">
	<!--
	opener.parent.content.location.reload();
	-->
	</script>
	<?php
    }
    
}

// get securityMethod
$securityMethod = $security->getSecurityMethod();

// create Template IT object
$tpl = new HTML_Template_IT($cfgPathToSurveyTemplates);

// load template
$tpl->loadTemplatefile($templateSurveySecurityEdit, true, true);

$tpl->setVariable( "lnk_method", $fileSurveySecurityEdit."?projectId=".$projectId."&warningChecked=yes");
$tpl->setVariable( "lnk_settings", $fileSurveySecurityAdministration."?projectId=".$projectId."&warningChecked=yes");

// set title
$tpl->setVariable( "applicationtitle", $cfgApplicationType.$cfgApplicationVersion);

switch($securityMethod)
{
    case "0":
    $tpl->setVariable( "securitystatus0", "selected" );
    break;
    
    case "cookie":
    $tpl->setVariable( "securitystatuscookie", "selected" );
    break;
    
    case "tan":
    $tpl->setVariable( "securitystatustan", "selected" );
    break;
}
    
$tpl->setVariable( "projectid", $projectId );
$tpl->setVariable( "errors", $error );

// parse template
$tpl->parse();
// get the parsed template and print it
$tpl->get();
$tpl->show();
?>
