<?php
// +----------------------------------------------------------------------+
// | sm survey module -	createformparts									  |
// +----------------------------------------------------------------------+
// | Copyright (c) 2002 serie a - Digitale Medien und Systeme GmbH        |
// +----------------------------------------------------------------------+
// | Authors: Jrn Allert <allert@serie-a.de>                             |
// |          Rene Renk <renk@serie-a.de>                                 |
// +----------------------------------------------------------------------+
// | Description: Basic functions to pass data to html_Quickform/Pearclass|
// |         								                              |
// +----------------------------------------------------------------------+
//
// $Id: createformparts.assess.inc.php,v 1.1.1.1 2004/07/15 13:34:23 opensurveypilot Exp $

//session_Start
@session_start();

// require all configuration files and libraries
require_once($cfgPathToProjectAdmin."/config/config.inc.php"); // common config file // common config file
require_once($cfgPathToConf."/file.inc.php"); // project files
require_once($cfgPathToProbFiles."/config/prob.config.inc.php"); // auth config file
require_once($cfgPathToProbFiles."/config/prob.file.inc.php"); // modules files
require_once($cfgPathToProbFiles."/lib/dbfunctions.assess.inc.php"); // dbFunctions
require_once($cfgPathToProbFiles."/lib/quickform.extended.assess.inc.php"); //Quickformextension

/**
* createFormParts class
*
* extended by createQuickFormFunctions class 
*
* formelement creating class
*
* @author  Jrn Allert <allert@serie-a.de>
* @author  Rene Renk <renk@serie-a.de>
* @access  public
*/
class createFormParts
{	
	/**
	*	creates Hiddenfield
	*
    *	@access	public
    *	@param	array	$formPartTagData 			Array containing Elementdata surrogat from $this->qffTypeArray
	*/
	function qffCreateHidden($myHiddenName,$myHiddenValue,$hiddenNew=1)
    {
		//set new value for hidden if wanted
		if($hiddenNew==1)
		{
			$constants[$myHiddenName] = $myHiddenValue;
			$this->processedForm->setConstants($constants);
		}
		//create Hidden 	-------   $form->addElement('hidden', 'ihidTest', 'hiddenField');
		$this->processedForm->addElement('hidden', 
										$myHiddenName,
										$myHiddenValue);
	}
	
	/**
	*	creates Headerfield
	*
    *	@access	public
    *	@param	array	$formPartTagData 			Array containing Elementdata surrogat from $this->qffTypeArray
	*/
	function qffAddHeader($header)
    {
		//add Header
		$this->processedForm->addHeader($header);
	}
	
	/**
	*	replaces non required aliasses
	*
    *	@access	public
    *	@param	string		$html 			String containing to be cleared aliasses
	*/
	function qffClearObsoleteAliasses($html)
    {
		// replace alias
		$html		= 	str_replace('{require}', "", $html);
		// replace alias
		$html 		= 	str_replace('{label}', "", $html);
		// replace alias
		$html		=	str_replace('{addimage}', "", $html);
		// replace alias
		$html 		= 	str_replace('{validationerror}', "&nbsp;", $html);
		// replace alias{rowheadertdwidth}
		$html 		= 	str_replace('{rowheader}', "&nbsp;", $html);
		// replace alias{rowheadertdwidth}
		$html 		= 	str_replace('{rowheadertdwidth}', "", $html);
		// replace alias{rowheadertdwidth}
		$html 		= 	str_replace('{optionlabels}', "", $html);
		// replace alias{rowheadertdwidth}
		$html 		= 	str_replace('{optiontdwidth}', "", $html);
		// replace alias{rowheadertdwidth}
		$html 		= 	str_replace('{optiontdwidth}', "", $html);
		// return cleared string
		return $html;
	}
	
	/**
	*	function to replace dynamic variables like date...
	*
    *	@access	public
    *	@param	string	$haystack 
    */
	function variableReplace($haystack)
	{
		//date
		$dateToShow = date("d.m.y");
		$newString = str_replace("###DATE###", $dateToShow, $haystack);
		// Tangroup
		$newString = str_replace("###TANGROUP###", $_SESSION["tanGroupName"], $newString);
		return $newString;
	}
	
	/**
	*	applies additional rules for conventional elemnets
	*
    *	@access	public
    *	@param	array	$RulesData 
    */
	function qffProcessRules($processRulesData)
	{	
		// no rules
		if(count($processRulesData) == 0)
		{
			return;
		}
		// process rules
		for($k = 0; $k < count($processRulesData) ; ++$k)
		{
			// add rule  addRule($element, $message='', $type='', $format='', $validation='server', $reset = false, $force = false)
			$this->processedForm->addRule($processRulesData[$k]["ELEMENTRULE_FORMTYPE_ID_FK"],$processRulesData[$k]["ELEMENTRULE_ALERT"],$processRulesData[$k]["ELEMENTRULE_ATTRIBUTE"],$processRulesData[$k]["ELEMENTRULE_VALUE"],$processRulesData[$k]["ELEMENTRULE_VALIDATION_TYPE"],false,'','','',$processRulesData[$k]["ELEMENTRULE_CHECKALLOW"]);  
		}
	}
	
	
	/**
	*	checks if has rule
	*
    *	@access	public
    *	@param	array	$RulesData 
    */
	function qffhasRule($processRulesData)
	{
		// search rules for required
		for($i = 0; $i < count($processRulesData) ; ++$i)
		{
			if($rule = $processRulesData[$i]["ELEMENTRULE_ATTRIBUTE"])
			{
				$displayRules[$i]["type"] = $processRulesData[$i]["ELEMENTRULE_ATTRIBUTE"];
				$displayRules[$i]["alert"] = $processRulesData[$i]["ELEMENTRULE_ALERT"];
				// set footer note if needed
				switch($displayRules[$i]["type"])
				{
					case "required":
						$this->declaredRules["required"] = str_replace("{errorfooter}", $this->defaultRules[$this->srvyLang]["requirednote"], $this->srvyDisplayErrorFooter["required"]);
						break;
					case "numeric":
						$this->declaredRules["numeric"] = str_replace("{errorfooter}", $this->defaultRules[$this->srvyLang]["numericnote"], $this->srvyDisplayErrorFooter["numeric"]);
				}
			}
		}
		return $displayRules;
	}
	
	/**
	*	creates Textfield
	*
    *	@access	public
    *	@param	array	$formPartTagData 			Array containing Elementdata surrogat from $this->qffTypeArray
    */
	function qffCreateText($formPartTagData)
    {
		// add question breaks
		$question	=	$this->variableReplace(nl2br($formPartTagData[0]["FORMTYPE_QUESTION"]));
		// check breaks
		if($formPartTagData[0]["FORMTYPE_IMAGE"])
		{
			
			// get number of breaks in question
			$pieces = explode("<br", $question);
			for($i=-2;$i<count($pieces);$i++)
			{
				$additionalBreaks .= "<br>";
			}
		}
		// check for rules
		$myProcessRulesData = $formPartTagData[0]["FORMTYPE_RULE"];
		// replace alias
		if($displayRules = $this->qffhasRule($myProcessRulesData))
		{
			for($i = 0; $i < count($displayRules) ; ++$i)
			{
				$displayRulesAlert 	.= str_replace("{thisError}", $displayRules[$i]["alert"], $this->srvyElementErrorWrappers[$displayRules[$i]["type"]]);
				$displayRulesHtml	.= $this->srvyDisplayError[$displayRules[$i]["type"]];
			}
			$head 		= 	str_replace('{require}', $displayRulesHtml, $this->srvyElementHeadHtml);
			// if error has occured
			if($_SESSION["qffControlPool"]["validationErrors"][$formPartTagData[0]["FORMTYPE_ID_PK"]])
			{
				$head 		= 	str_replace('{validationerror}', $displayRulesAlert.$additionalBreaks, $head);
			}
			else
			{
				$head 		= 	str_replace('{validationerror}', "&nbsp;".$additionalBreaks, $head);
			}
			// reset errors
			$displayRulesHtml = "";
			$displayRulesAlert = "";
		}
		else
		{
			$head 		= 	str_replace('{require}', "&nbsp;", $this->srvyElementHeadHtml);
			$head 		= 	str_replace('{validationerror}', "&nbsp;".$additionalBreaks, $head);
		}
		// check for additional imagetag
		($formPartTagData[0]["FORMTYPE_IMAGE"])? ($addImageTag = "<br><br>".$formPartTagData[0]["FORMTYPE_IMAGE"]) : ($addImageTag = "");
		// replace alias
		$head 		= 	str_replace('{label}', $question, $head);
		$head		=	str_replace('{addimage}', $addImageTag, $head);
		// not needed aliasses
		$head = $this->qffClearObsoleteAliasses($head);
		// set head wrapper
		$this->processedForm->addData($head);
		// check for post // workaround for buggy validation // 030324-rr
		$formDefaults[$formPartTagData[0]["FORMTYPE_ID_PK"]]  = ($_POST[$formPartTagData[0]["FORMTYPE_ID_PK"]])? $_POST[$formPartTagData[0]["FORMTYPE_ID_PK"]] : "";
		$this->processedForm->setDefaults($formDefaults);
		//create Textfield 	-------   $form->addElement('text', 'itxtTest', 'Test Text:');
		$this->processedForm->addElement('text', 
										$formPartTagData[0]["FORMTYPE_ID_PK"],
										$question,
										array('size'=>'20',
											  'class'=>'basic'));// defaultclass to be extended function);
		// set foot wrapper
		$this->processedForm->addData($this->srvyElementFootHtml);
		//add borderline
		$this->processedForm->addLine('');
		// process rules data
		if(is_array($myProcessRulesData))
		{
			$this->qffProcessRules($myProcessRulesData);
		}
		// return data
		return $formPartTagData;
	}
	

	/**
	*	creates Passwordfield
	*
    *	@access	public
    *	@param	array	$formPartTagData 			Array containing Elementdata surrogat from $this->qffTypeArray
    */
	function qffCreatePassword($formPartTagData)
    {
		// add question breaks
		$question	=	$this->variableReplace(nl2br($formPartTagData[0]["FORMTYPE_QUESTION"]));
		// check breaks
		if($formPartTagData[0]["FORMTYPE_IMAGE"])
		{
			// get number of breaks in question
			$pieces = explode("<br", $question);
			for($i=-2;$i<count($pieces);$i++)
			{
				$additionalBreaks .= "<br>";
			}
		}
		// check for rules
		$myProcessRulesData = $formPartTagData[0]["FORMTYPE_RULE"];
		// replace alias
		if($displayRules = $this->qffhasRule($myProcessRulesData))
		{
			for($i = 0; $i < count($displayRules) ; ++$i)
			{
				$displayRulesAlert 	.= str_replace("{thisError}", $displayRules[$i]["alert"], $this->srvyElementErrorWrappers[$displayRules[$i]["type"]]);
				$displayRulesHtml	.= $this->srvyDisplayError[$displayRules[$i]["type"]];
			}
			$head 		= 	str_replace('{require}', $displayRulesHtml, $this->srvyElementHeadHtml);
			// if error has occured
			if($this->validateStatus == 1)
			{
				$head 		= 	str_replace('{validationerror}', $displayRulesAlert.$additionalBreaks, $head);
			}
			else
			{
				$head 		= 	str_replace('{validationerror}', "&nbsp;".$additionalBreaks, $head);
			}
			// reset errors
			$displayRulesHtml = "";
			$displayRulesAlert = "";
		}
		else
		{
			$head 		= 	str_replace('{require}', "&nbsp;", $this->srvyElementHeadHtml);
			$head 		= 	str_replace('{validationerror}', "&nbsp;".$additionalBreaks, $head);
		}
		// check for additional imagetag
		($formPartTagData[0]["FORMTYPE_IMAGE"])? ($addImageTag = "<br><br>".$formPartTagData[0]["FORMTYPE_IMAGE"]) : ($addImageTag = "");
		// replace alias
		$head 		= 	str_replace('{label}', $question, $head);
		$head		=	str_replace('{addimage}', $addImageTag, $head);
		// not needed aliasses
		$head = $this->qffClearObsoleteAliasses($head);
		// set head wrapper
		$this->processedForm->addData($head);
		//create Password 	-------   $form->addElement('password', 'ipwdTest', 'Test Password:');
		$this->processedForm->addElement('password', 
										$formPartTagData[0]["FORMTYPE_ID_PK"],
										$question,
										array('class'=>'basic'));// defaultclass to be extended function);
		// set foot wrapper
		$this->processedForm->addData($this->srvyElementFootHtml);
		//add borderline
		$this->processedForm->addLine('');
		// process rules data
		if(is_array($myProcessRulesData))
		{
			$this->qffProcessRules($myProcessRulesData);
		}
		// return data
		return $formPartTagData;
	}
	
	
    /**
	*	creates Textarea
	*
    *	@access	public
    *	@param	array	$formPartTagData 			Array containing Elementdata surrogat from $this->qffTypeArray
    */
	function qffCreateTextarea($formPartTagData)
    {
		// add question breaks
		$question	=	$this->variableReplace(nl2br($formPartTagData[0]["FORMTYPE_QUESTION"]));
		// check breaks
		if($formPartTagData[0]["FORMTYPE_IMAGE"])
		{
			// get number of breaks in question
			$pieces = explode("<br", $question);
			for($i=-2;$i<count($pieces);$i++)
			{
				$additionalBreaks .= "<br>";
			}
		}
		// check for rules
		$myProcessRulesData = $formPartTagData[0]["FORMTYPE_RULE"];
		// replace alias
		if($displayRules = $this->qffhasRule($myProcessRulesData))
		{
			for($i = 0; $i < count($displayRules) ; ++$i)
			{
				$displayRulesAlert 	.= str_replace("{thisError}", $displayRules[$i]["alert"], $this->srvyElementErrorWrappers[$displayRules[$i]["type"]]);
				$displayRulesHtml	.= $this->srvyDisplayError[$displayRules[$i]["type"]];
			}
			$head 		= 	str_replace('{require}', $displayRulesHtml, $this->srvyElementHeadHtml);
			// if error has occured
			if($_SESSION["qffControlPool"]["validationErrors"][$formPartTagData[0]["FORMTYPE_ID_PK"]])
			{
				$head 		= 	str_replace('{validationerror}', $displayRulesAlert.$additionalBreaks, $head);
			}
			else
			{
				$head 		= 	str_replace('{validationerror}', "&nbsp;".$additionalBreaks, $head);
			}
			// reset errors
			$displayRulesHtml = "";
			$displayRulesAlert = "";
		}
		else
		{
			$head 		= 	str_replace('{require}', "&nbsp;", $this->srvyElementHeadHtml);
			$head 		= 	str_replace('{validationerror}', "&nbsp;".$additionalBreaks, $head);
		}
		// check for additional imagetag
		($formPartTagData[0]["FORMTYPE_IMAGE"])? ($addImageTag = "<br><br>".$formPartTagData[0]["FORMTYPE_IMAGE"]) : ($addImageTag = "");
		// replace alias
		$head 		= 	str_replace('{label}', $question, $head);
		$head		=	str_replace('{addimage}', $addImageTag, $head);
		// not needed aliasses
		$head = $this->qffClearObsoleteAliasses($head);
		// set head wrapper
		$this->processedForm->addData($head);
		// check for post // workaround for buggy validation // 030324-rr
		$formDefaults[$formPartTagData[0]["FORMTYPE_ID_PK"]]  = ($_POST[$formPartTagData[0]["FORMTYPE_ID_PK"]])? $_POST[$formPartTagData[0]["FORMTYPE_ID_PK"]] : "";
		$this->processedForm->setDefaults($formDefaults);
		//create Textarea 	-------   $form->addElement('textarea', 'itxaTest', 'Test TextArea:',array('additional'=>'arguments'));
		$this->processedForm->addElement('textarea', 
										$formPartTagData[0]["FORMTYPE_ID_PK"],
										$question,
										array('class'=>'basic'));// defaultclass to be extended function
		// set foot wrapper
		$this->processedForm->addData($this->srvyElementFootHtml);
		//add borderline
		$this->processedForm->addLine('');
		// process rules data
		if(is_array($myProcessRulesData))
		{
			$this->qffProcessRules($myProcessRulesData);
		}
		// return data
		return $formPartTagData;
	}
	
	
	/**
	*	creates Selectfield
	*
    *	@access	public
    *	@param	array	$formPartTagData 			Array containing Elementdata surrogat from $this->qffTypeArray
    */
	function qffCreateSelect($formPartTagData)
    {
		// add question breaks
		$question	=	$this->variableReplace(nl2br($formPartTagData[0]["FORMTYPE_QUESTION"]));
		// check for rules
		$myProcessRulesData = $formPartTagData[0]["FORMTYPE_RULE"];
		// replace alias
		if($displayRules = $this->qffhasRule($myProcessRulesData))
		{
			for($i = 0; $i < count($displayRules) ; ++$i)
			{
				$displayRulesAlert 	.= str_replace("{thisError}", $displayRules[$i]["alert"], $this->srvyElementErrorWrappers[$displayRules[$i]["type"]]);
				$displayRulesHtml	.= $this->srvyDisplayError[$displayRules[$i]["type"]];
			}
			$head 		= 	str_replace('{require}', $displayRulesHtml, $this->srvyElementHeadHtml);
			// if error has occured
			if($_SESSION["qffControlPool"]["validationErrors"][$formPartTagData[0]["FORMTYPE_ID_PK"]])
			{
				$head 		= 	str_replace('{validationerror}', $displayRulesAlert.$additionalBreaks, $head);
			}
			else
			{
				$head 		= 	str_replace('{validationerror}', "&nbsp;".$additionalBreaks, $head);
			}
			// reset errors
			$displayRulesHtml = "";
			$displayRulesAlert = "";
		}
		else
		{
			$head 		= 	str_replace('{require}', "&nbsp;", $this->srvyElementHeadHtml);
			$head 		= 	str_replace('{validationerror}', "&nbsp;".$additionalBreaks, $head);
		}
		// check for additional imagetag
		($formPartTagData[0]["FORMTYPE_IMAGE"])? ($addImageTag = "<br><br>".$formPartTagData[0]["FORMTYPE_IMAGE"]) : ($addImageTag = "");
		// replace alias
		$head 		= 	str_replace('{label}', $question, $head);
		$head		=	str_replace('{addimage}', $addImageTag, $head);
		// not needed aliasses
		$head = $this->qffClearObsoleteAliasses($head);
		// set head wrapper
		$this->processedForm->addData($head);
		//create options array and check for defaults
		$lastOption = (count($formPartTagData));
		for ($i=0;$i<$lastOption;$i++)
			{	
				//create options
				$options[$formPartTagData[$i]["FORMELEMENT_ID_PK"]] = $formPartTagData[$i]["FORMELEMENT_HEADER"];
				//check for post // workaround for buggy validation // 030324-rr
				if ($_POST[$formPartTagData[0]["FORMTYPE_ID_PK"]] == $formPartTagData[$i]["FORMELEMENT_ID_PK"])
				{
					$formDefaults[$formPartTagData[0]["FORMTYPE_ID_PK"]][]  = $formPartTagData[$i]["FORMELEMENT_ID_PK"];
				}
			}
		// additional Arguments   -------------   defaultValues['iselTest']  = array('B', 'C');
		$this->processedForm->setDefaults($formDefaults);

		//create Select
		//$form->addElement('select', 'iselTest', 'Test Select:', array('A'=>'A', 'B'=>'B','C'=>'C','D'=>'D'));
		//quickformSmExtended_select($elementName=null, $elementLabel=null, $options=null, $attributes=null)
		$this->processedForm->addElement('select',
										$formPartTagData[0]["FORMTYPE_ID_PK"],
										$question,
										$options,
										array('class'=>'basic'));
		// set foot wrapper
		$this->processedForm->addData($this->srvyElementFootHtml);
		//add borderline
		$this->processedForm->addLine('');
		// get element and add options
		$select = &$this->processedForm->getElement($formPartTagData[0]["FORMTYPE_ID_PK"]);
		// set size
		$select->setSize($formPartTagData[0]["FORMTYPE_SIZE"]);
		// process rules data
		if(is_array($myProcessRulesData))
		{
			$this->qffProcessRules($myProcessRulesData);
		}
		// return data
		return $formPartTagData;
	}
	
	
	/**
	*	creates Radiobuttons
	*
    *	@access	public
    *	@param	array	$formPartTagData 			Array containing Elementdata surrogat from $this->qffTypeArray
    */
	function qffCreateRadio($formPartTagData)
    {
		// add question breaks
		$question	=	$this->variableReplace(nl2br($formPartTagData[0]["FORMTYPE_QUESTION"]));
		// check for rules
		$myProcessRulesData = $formPartTagData[0]["FORMTYPE_RULE"];
		// replace alias
		if($displayRules = $this->qffhasRule($myProcessRulesData))
		{
			for($i = 0; $i < count($displayRules) ; ++$i)
			{
				$displayRulesAlert 	.= str_replace("{thisError}", $displayRules[$i]["alert"], $this->srvyElementErrorWrappers[$displayRules[$i]["type"]]);
				$displayRulesHtml	.= $this->srvyDisplayError[$displayRules[$i]["type"]];
			}
			$head 		= 	str_replace('{require}', $displayRulesHtml, $this->srvyElementHeadHtml);
			// if error has occured
			if($_SESSION["qffControlPool"]["validationErrors"][$formPartTagData[0]["FORMTYPE_ID_PK"]])
			{
				$head 		= 	str_replace('{validationerror}', $displayRulesAlert.$additionalBreaks, $head);
			}
			else
			{
				$head 		= 	str_replace('{validationerror}', "&nbsp;".$additionalBreaks, $head);
			}
			// reset errors
			$displayRulesHtml = "";
			$displayRulesAlert = "";
		}
		else
		{
			$head 		= 	str_replace('{require}', "&nbsp;", $this->srvyElementHeadHtml);
			$head 		= 	str_replace('{validationerror}', "&nbsp;".$additionalBreaks, $head);
		}
		// check for additional imagetag
		($formPartTagData[0]["FORMTYPE_IMAGE"])? ($addImageTag = "<br><br>".$formPartTagData[0]["FORMTYPE_IMAGE"]) : ($addImageTag = "");
		// replace alias
		$head 		= 	str_replace('{label}', $question, $head);
		$head		=	str_replace('{addimage}', $addImageTag, $head);
		// not needed aliasses
		$head = $this->qffClearObsoleteAliasses($head);
		// set head wrapper
		$this->processedForm->addData($head);
		//create options array and check for defaults
		$lastOption = (count($formPartTagData));
		for ($i=0;$i<$lastOption;$i++)
			{	
				// insert additional image if present
				if($formPartTagData[$i]["FORMELEMENT_HEADERIMAGE"])
				{
					$imageTag =  str_replace('border="0"', 'border="0" align="middle"', stripslashes($formPartTagData[$i]["FORMELEMENT_HEADERIMAGE"])).(($formPartTagData[$i]["FORMELEMENT_HEADER"])? "&nbsp;" : "");
				}
				else
				{
					$imageTag = "";
				}
				// check if header should be displayed
				($formPartTagData[$i]["FORMELEMENT_HIDEHEADER"])? ($headerTag = "") : ($headerTag = $formPartTagData[$i]["FORMELEMENT_HEADER"]);
				$Radios[] = &quickformSmExtended::createElement('radio', null, null, "&nbsp;".$imageTag.$headerTag,$formPartTagData[$i]["FORMELEMENT_ID_PK"],array("class" => "radio"));
				//check for post // workaround for buggy validation // 030324-rr
				if ($_POST[$formPartTagData[0]["FORMTYPE_ID_PK"]] == $formPartTagData[$i]["FORMELEMENT_ID_PK"])
				{
					$formDefaults[$formPartTagData[0]["FORMTYPE_ID_PK"]] = $formPartTagData[$i]["FORMELEMENT_ID_PK"];
				}
			}
		// set defaults
		$this->processedForm->setDefaults($formDefaults);
		// check alignment
		if ( $formPartTagData[0]["FORMTYPE_ALIGN"] == 'ver' )
		{
			$separateElements = "<br>";
		}
		else
		{
			$separateElements = "&nbsp;";
		}
		// create radio  quickformSmExtended_radio($elementName=null, $elementLabel=null, $text=null, $value=null, $attributes=null)
		$this->processedForm->addElementGroup($Radios,
											$question,
											$formPartTagData[0]["FORMTYPE_ID_PK"],
											$separateElements);
		// set foot wrapper
		$this->processedForm->addData($this->srvyElementFootHtml);
		//add borderline
		$this->processedForm->addLine('');
		// process rules data
		if(is_array($myProcessRulesData))
		{
			$this->qffProcessRules($myProcessRulesData);
		}
		// return data
		return $formPartTagData;
	}
	
}
?>
