<?php
// +----------------------------------------------------------------------+
// | assessment pilot                                                     |
// +----------------------------------------------------------------------+
// | Copyright (c) 2002 serie a - Digitale Medien und Systeme GmbH        |
// +----------------------------------------------------------------------+
// | Authors: Daniel Peer <peer@serie-a.de>                               |
// +----------------------------------------------------------------------+
// | Description:                                                         |
// +----------------------------------------------------------------------+
//
// $Id: testgroup.inc.php,v 1.1.1.1 2004/07/15 13:34:28 opensurveypilot Exp $


// start session
@session_start();

require_once($cfgPathToProjectAdmin."/config/config.inc.php"); // common config file // common config file
require_once ("DB.php"); // PEAR::DB
require_once ("Validate.php"); // PEAR::Validate (must be included before common config file)
require_once($cfgPathToTestgroupFiles."/config/testgroup.config.inc.php"); // testgroup config file
require_once($cfgPathToTestgroupFiles."/config/testgroup.file.inc.php"); // testgroup files
require_once($cfgPathToProbFiles."/config/prob.config.inc.php"); // prob config file
require_once($cfgPathToProbFiles."/config/prob.file.inc.php"); // prob files
require_once($cfgPathToTestgroupFiles."/lib/createcss.inc.php"); // css functions


/**
* Testgroup Class
*
* @author  Daniel Peer <peer@serie-a.de>
* @access  public
*/

class Testgroup
{
	// declare variables
	var $testgroupId;
	var $testgroupName;
	var $testgroupCreated;
	var $testgroupCreator;
	var $testgroupDescription;
	
	var $errorMessage;
	var $db = "";
	
	/**
    *	Class Constructor
    *	@access	private
    */	
	function Testgroup()
    {
		$this->errorMessage = "";
        // connect to db
        $this->db = DB::connect(DSN, true);
        if (DB::isError($this->db)) 
        {    
		   $this->errorMessage = $this->db->getMessage();
        }		
	}
	
    /**
    *	sets error message
    *
    *	@access	private
    *	@param	string	$err
    */
    function setErrorMessage($err)
    {
        $this->errorMessage = $err;
    }
	
	/**
    *	gets error message
    *
    *	@access	private
    *	@param	string	$err
    */
	function getErrorMessage()
    {
       return $this->errorMessage;
    }	
	
    /**
    *	checks for valid inputs
    *
    *	@access	private
    *	@param	int	$step
    *   @return boolean true/false
    */
	function isValid()
    {
		$valid = true;
		return $valid;
	}

	/**
    *	get all Testgroups for overview
    *
    *	@access	public
    *	@param	
    *   @return string true/false
    */
   	function getTestgroupsForOverview ($actualNum = 0, $maxRow, $orderBy, $direction)
    {
        global $cfgTabContentgroup;
        
      	// select all raw Data
       	$sql = "select * 
				from $cfgTabContentgroup
			    order by $orderBy $direction 
                limit $actualNum, $maxRow";

		$result = $this->db->query($sql);
       	if (DB::isError($result)) 
       	{
          	    $this->setErrorMessage(new PEAR_Error("DB ERROR in getTestgroupsForOverview(): ".$result->getMessage()."in".__FILE__." on line ".__LINE__."with-------------$sql------------- "));
          	    return new PEAR_Error("DB ERROR in getTestgroupsForOverview(): ".$result->getMessage()."in".__FILE__." on line ".__LINE__."with-------------$sql------------- ");
      	}
		// get rows
       	while ($row = $result->fetchRow(DB_FETCHMODE_ASSOC))
        {
               $getRawData[] = $row;
        }
        
		return $getRawData;
    }
	
	/**
    *	gets sum of Testgroups
    *
    *	@access	public
    *	@param	
    *   @return int
    */
	function getTestgroupNum()
	{
		global $cfgTabContentgroup;
        $numRows = "0";
     
       	// fetch selected survey
       	$sql = "select 1 
				from $cfgTabContentgroup ";

       	$result = $this->db->query($sql);
       	if (DB::isError($result)) 
       	{
               return new PEAR_Error("DB ERROR in getTestgroupNum(): ".$result->getMessage()."in".__FILE__." on line ".__LINE__."with-------------$sql------------- ");
       	}
      
        $numRows = $result->numRows();

        return $numRows;
	}
	
	/**
    *	updates Testgroup Table
    *
    *	@access	public
    *	@param	
    *   @return true/false
    */
	function updateTestgroup ($groupId, $name, $desc, $status)
    {
        global $cfgTabContentgroup;
        
      	// select all raw Data
       	$sql = "update $cfgTabContentgroup set 
					CONTENTGROUP_NAME='$name',
					CONTENTGROUP_ACTIVE='$status',
					CONTENTGROUP_DESCRIPTION='$desc' 
				where CONTENTGROUP_ID_PK='$groupId'";
       	//
		$result = $this->db->query($sql);
       	if (DB::isError($result)) 
       	{
          	    $this->setErrorMessage(new PEAR_Error("DB ERROR in updateTestgroup(): ".$result->getMessage()."in".__FILE__." on line ".__LINE__."with-------------$sql------------- "));
          	    return new PEAR_Error("DB ERROR in updateTestgroup(): ".$result->getMessage()."in".__FILE__." on line ".__LINE__."with-------------$sql------------- ");
      	}
       
		return true;
    }
	
		
	/**
    *	deletes Folders
    *
    *	@access	public
    *	@param	String dir
    *   @return true/false
	**/
	
	function deldir($dir)
	{
  		$current_dir = opendir($dir);
  		while($entryname = readdir($current_dir))
		{
     		if(is_dir("$dir/$entryname") and ($entryname != "." and $entryname!=".."))
			{
       			$this->deldir("${dir}/${entryname}");
     		}
			elseif($entryname != "." and $entryname!="..")
			{
       			unlink("${dir}/${entryname}");
     		}
  		}
  		closedir($current_dir);
  		rmdir(${dir});
	} 
	
	/**
    *	deletes Row width givven GroupId from Testgroup Table
    *
    *	@access	public
    *	@param	
    *   @return true/false
    */
	function deleteTestgroup($groupId)
    {
        global $cfgTabCss;
		global $cfgTabContentgroup;
		global $cfgTabContentgroupToUsergroup;
		global $cfgTabContentgroupToContent;
		global $cfgPathToAssessmentOutput;
	
		$sql = "SELECT * FROM $cfgTabContentgroup WHERE CONTENTGROUP_ID_PK =$groupId";
		$result = $this->db->query($sql);
		
		while ($row = $result->fetchRow(DB_FETCHMODE_ASSOC))
	    {
			$outputdir = $row["CONTENTGROUP_OUTPUT_DIR"];
			$css_id = $row["CONTENTGROUP_CSS_ID_FK"];
	    }
          
	  	$sql = "delete from $cfgTabContentgroup 
				where CONTENTGROUP_ID_PK=$groupId ";

		$result = $this->db->query($sql);
       	if (DB::isError($result)) 
       	{
          	    $this->setErrorMessage(new PEAR_Error("DB ERROR in deleteTestgroup(): ".$result->getMessage()."in".__FILE__." on line ".__LINE__."with-------------$sql------------- "));
          	    return new PEAR_Error("DB ERROR in deleteTestgroup(): ".$result->getMessage()."in".__FILE__." on line ".__LINE__."with-------------$sql------------- ");
      	}
		
	  	$sql = "delete from $cfgTabContentgroupToUsergroup 
				where CGROUP_TO_UGROUP_CGROUP_ID_FK=$groupId ";

		$result = $this->db->query($sql);
       	if (DB::isError($result)) 
       	{
          	    $this->setErrorMessage(new PEAR_Error("DB ERROR in deleteTestgroup(): ".$result->getMessage()."in".__FILE__." on line ".__LINE__."with-------------$sql------------- "));
          	    return new PEAR_Error("DB ERROR in deleteTestgroup(): ".$result->getMessage()."in".__FILE__." on line ".__LINE__."with-------------$sql------------- ");
      	}
		
		$sql = "delete from $cfgTabContentgroupToContent 
				where CONTENT_TO_CGROUP_CGROUP_ID_FK=$groupId ";

		$result = $this->db->query($sql);
       	if (DB::isError($result)) 
       	{
          	    $this->setErrorMessage(new PEAR_Error("DB ERROR in deleteTestgroup(): ".$result->getMessage()."in".__FILE__." on line ".__LINE__."with-------------$sql------------- "));
          	    return new PEAR_Error("DB ERROR in deleteTestgroup(): ".$result->getMessage()."in".__FILE__." on line ".__LINE__."with-------------$sql------------- ");
      	}
		
		$sql = "delete from $cfgTabCss 
				where CSSSTYLE_ID_PK=$css_id ";

		$result = $this->db->query($sql);
       	if (DB::isError($result)) 
       	{
          	    $this->setErrorMessage(new PEAR_Error("DB ERROR in deleteTestgroup(): ".$result->getMessage()."in".__FILE__." on line ".__LINE__."with-------------$sql------------- "));
          	    return new PEAR_Error("DB ERROR in deleteTestgroup(): ".$result->getMessage()."in".__FILE__." on line ".__LINE__."with-------------$sql------------- ");
      	}

		if ($cfgPathToAssessmentOutput)
		{
			$deldir = $cfgPathToAssessmentOutput."/".$outputdir;
			if ($deldir && $deldir!="/")
			{
				
				$this->deldir($deldir);
				//system ("rm -r ".$deldir);
			}
		}
		return true;
    }
	


	
	/**
    *	insert into Testgroup Table
    *
    *	@access	public
    *	@param	
    *   @return true/false
    */
	function insertTestgroup($groupname, $desc, $dir, $maskId, $lang)
    {
		global $lang_script;
	    	global $cfgTabContentgroup;
		global $cfgTabCss;
		global $cfgPathToAssessmentOutput;
		
		$user_name = $_SESSION["sessionUserFirstname"]." ".$_SESSION["sessionUserLastname"];
		
		$datum=date ("y-m-d H:i:s");
		
		$nextId = $this->db->nextId($cfgTabContentgroup);
		$nextId_Css = $this->db->nextId($cfgTabCss);
		
		//delete raw Data with the incoming ID
	  	$sql = "insert into $cfgTabContentgroup
				(
				CONTENTGROUP_ID_PK,
				CONTENTGROUP_CSS_ID_FK,
				CONTENTGROUP_USERMASK_ID_FK,
				CONTENTGROUP_NAME, 
				CONTENTGROUP_CREATED, 
				CONTENTGROUP_CREATOR, 
				CONTENTGROUP_DESCRIPTION,
				CONTENTGROUP_OUTPUT_DIR,
				CONTENTGROUP_SPLASH,
				CONTENTGROUP_REG_TEXT_HEAD,
				CONTENTGROUP_REG_TEXT_BEGIN,
				CONTENTGROUP_REG_TEXT_MESSAGE,
				CONTENTGROUP_REG2_TEXT_HEAD,
				CONTENTGROUP_REG2_TEXT_BEGIN,
				CONTENTGROUP_REG2_TEXT_MESSAGE,
				CONTENTGROUP_OVERVIEW_HEADLINE,
				CONTENTGROUP_OVERVIEW_TEXT,
				CONTENTGROUP_LOGIN_MSG_HEAD,
				CONTENTGROUP_LOGIN_MSG_MESSAGE,
				CONTENTGROUP_LOGIN_MSG_BACK,
				CONTENTGROUP_LOGIN_MSG_EMAIL,
				CONTENTGROUP_LOGIN_MSG_PW,
				CONTENTGROUP_LOGIN_MSG_REGISTER,
				CONTENTGROUP_SPLASH_HEAD,
				CONTENTGROUP_SPLASH_TXT,
				CONTENTGROUP_SPLASH_LINK,
				CONTENTGROUP_DEACTIVATED_TXT,
				CONTENTGROUP_OVERVIEW_OVERVIEW,
				CONTENTGROUP_OVERVIEW_LOGOUT,
				CONTENTGROUP_OVERVIEW_PROFILE,
				CONTENTGROUP_OVERVIEW_STATUS_1,
				CONTENTGROUP_OVERVIEW_STATUS_2,
				CONTENTGROUP_OVERVIEW_STATUS_3,
				CONTENTGROUP_OVERVIEW_STATUS_4,
				CONTENTGROUP_OVERVIEW_STATUS_5,
				CONTENTGROUP_OVERVIEW_REPORT_1,
				CONTENTGROUP_OVERVIEW_REPORT_2,
				CONTENTGROUP_OVERVIEW_REPORT_3,
				CONTENTGROUP_OVERVIEW_REPORT_4,
				CONTENTGROUP_OVERVIEW_LNK_1,
				CONTENTGROUP_OVERVIEW_LNK_2,
				CONTENTGROUP_OVERVIEW_TESTS_FREE,
				CONTENTGROUP_FORM_JS_ALERT,
				CONTENTGROUP_FORM_JS_CONFIRM_1,
				CONTENTGROUP_FORM_JS_CONFIRM_2,
				CONTENTGROUP_FORM_LEGEND_REG,
				CONTENTGROUP_FORM_LEGEND,
				CONTENTGROUP_FORM_LEGEND_ADR,
				CONTENTGROUP_FORM_LEGEND_BANK,
				CONTENTGROUP_FORM_LEGEND_SCHOOL,
				CONTENTGROUP_FORM_LEGEND_EDU,
				CONTENTGROUP_FORM_LEGEND_COURSE,
				CONTENTGROUP_FORM_LABEL_PASSWORDNOTICE,
				CONTENTGROUP_FORM_LABEL_FIRSTNAME,
				CONTENTGROUP_FORM_LABEL_LASTNAME,
				CONTENTGROUP_FORM_LABEL_GEBDAT,
				CONTENTGROUP_FORM_LABEL_SEX,
				CONTENTGROUP_FORM_LABEL_NATION,
				CONTENTGROUP_FORM_LABEL_STREET,
				CONTENTGROUP_FORM_LABEL_POSTALCODE,
				CONTENTGROUP_FORM_LABEL_CITY,
				CONTENTGROUP_FORM_LABEL_PHONE,
				CONTENTGROUP_FORM_LABEL_EMAIL,
				CONTENTGROUP_FORM_LABEL_PASSWORD,
				CONTENTGROUP_BANK_OWNER_LABEL,
				CONTENTGROUP_BANK_NAME_LABEL,
				CONTENTGROUP_BANK_BLZ_LABEL,
				CONTENTGROUP_BANK_KTONR_LABEL,
				CONTENTGROUP_FORM_DEGREE,
				CONTENTGROUP_FORM_DEGREE_DATE,
				CONTENTGROUP_FORM_CHOOSE,
				CONTENTGROUP_FORM_CHOOSE_SELF,
				CONTENTGROUP_FORM_DESC,
				CONTENTGROUP_FORM_DATE,
				CONTENTGROUP_FORM_POSDEL,
				CONTENTGROUP_FORM_EDU_MSG1,
				CONTENTGROUP_FORM_EDU_MSG2,
				CONTENTGROUP_FORM_EDU_MSG3,
				CONTENTGROUP_FORM_COURSE_MSG1,
				CONTENTGROUP_FORM_COURSE_MSG2,
				CONTENTGROUP_FORM_COURSE_MSG3,
				CONTENTGROUP_FORM_SUBMIT,
				CONTENTGROUP_FORM_SEX_M,
				CONTENTGROUP_FORM_SEX_W,
				CONTENTGROUP_THANKS_MSG_HEAD,
				CONTENTGROUP_REG2_TEXT_EDIT,
				CONTENTGROUP_SUCCESS_BACK
				)
				values
				(
				$nextId,
				$nextId_Css,
				$maskId,
				'$groupname',
				'$datum',
				'$user_name',
				'$desc',
				'$dir',
				0,
				'".$lang_script["testgroup.inc.php"]["registrationHeader"]."',
				'".$lang_script["testgroup.inc.php"]["fillInData"]."',
				'".$lang_script["testgroup.inc.php"]["commitData"]."',
				'".$lang_script["testgroup.inc.php"]["editDataHeader"]."',
				'".$lang_script["testgroup.inc.php"]["editDataChanges"]."',
				'".$lang_script["testgroup.inc.php"]["testsFinished"]."',
				'".$lang_script["testgroup.inc.php"]["hello"]."',
				'".$lang_script["testgroup.inc.php"]["welcomeMessage"]."',
				'".$lang_script["testgroup.inc.php"]["loginMsgHead"]."',
				'".$lang_script["testgroup.inc.php"]["loginMsgMessage"]."',
				'".$lang_script["testgroup.inc.php"]["loginMsgBack"]."',
				'".$lang_script["testgroup.inc.php"]["loginMsgEmail"]."',
				'".$lang_script["testgroup.inc.php"]["loginMsgPw"]."',
				'".$lang_script["testgroup.inc.php"]["loginMsgRegister"]."',
				'".$lang_script["testgroup.inc.php"]["splashHead"]."',
				'".$lang_script["testgroup.inc.php"]["splashTxt"]."',
				'".$lang_script["testgroup.inc.php"]["splashLink"]."',
				'".$lang_script["testgroup.inc.php"]["deactivatedTxt"]."',
				'".$lang_script["testgroup.inc.php"]["overviewOverview"]."',
				'".$lang_script["testgroup.inc.php"]["overviewLogout"]."',
				'".$lang_script["testgroup.inc.php"]["overviewProfile"]."',
				'".$lang_script["testgroup.inc.php"]["overviewStatus1"]."',
				'".$lang_script["testgroup.inc.php"]["overviewStatus2"]."',
				'".$lang_script["testgroup.inc.php"]["overviewStatus3"]."',
				'".$lang_script["testgroup.inc.php"]["overviewStatus4"]."',
				'".$lang_script["testgroup.inc.php"]["overviewStatus5"]."',
				'".$lang_script["testgroup.inc.php"]["overviewReport1"]."',
				'".$lang_script["testgroup.inc.php"]["overviewReport2"]."',
				'".$lang_script["testgroup.inc.php"]["overviewReport3"]."',
				'".$lang_script["testgroup.inc.php"]["overviewReport4"]."',
				'".$lang_script["testgroup.inc.php"]["overviewLink1"]."', 
				'".$lang_script["testgroup.inc.php"]["overviewLink2"]."',
				'".$lang_script["testgroup.inc.php"]["overviewTestsFree"]."',
				'".$lang_script["testgroup.inc.php"]["alertMessage"]."',
				'".$lang_script["testgroup.inc.php"]["deleteProfEduQuestion"]."',
				'".$lang_script["testgroup.inc.php"]["deleteAdvancedEduQuestion"]."',
				'".$lang_script["testgroup.inc.php"]["headlineRegistration"]."',
				'".$lang_script["testgroup.inc.php"]["headlinePersonalData"]."',
				'".$lang_script["testgroup.inc.php"]["headlinetxtAddressData"]."',
				'".$lang_script["testgroup.inc.php"]["headlinetxtBankAccount"]."',
				'".$lang_script["testgroup.inc.php"]["headlinetxtSchoolEducation"]."',
				'".$lang_script["testgroup.inc.php"]["headlinetxtProfEducation"]."',
				'".$lang_script["testgroup.inc.php"]["headlinetxtAdvancedEducation"]."',
				'".$lang_script["testgroup.inc.php"]["leaveEmptyToSavePass"]."',
				'".$lang_script["testgroup.inc.php"]["firstName"]."',
				'".$lang_script["testgroup.inc.php"]["lastName"]."',
				'".$lang_script["testgroup.inc.php"]["dateOfBirth"]."',
				'".$lang_script["testgroup.inc.php"]["gender"]."',
				'".$lang_script["testgroup.inc.php"]["nationality"]."',
				'".$lang_script["testgroup.inc.php"]["street"]."',
				'".$lang_script["testgroup.inc.php"]["postCode"]."',
				'".$lang_script["testgroup.inc.php"]["city"]."',
				'".$lang_script["testgroup.inc.php"]["phone"]."',
				'".$lang_script["testgroup.inc.php"]["email"]."',
				'".$lang_script["testgroup.inc.php"]["password"]."',
				'".$lang_script["testgroup.inc.php"]["accountOwner"]."',
				'".$lang_script["testgroup.inc.php"]["bank"]."',
				'".$lang_script["testgroup.inc.php"]["bankAccountNumber"]."',
				'".$lang_script["testgroup.inc.php"]["accountNumber"]."',
				'".$lang_script["testgroup.inc.php"]["degree"]."',
				'".$lang_script["testgroup.inc.php"]["dateOfFinish"]."',
				'".$lang_script["testgroup.inc.php"]["pleaseSelect"]."',
				'".$lang_script["testgroup.inc.php"]["orSelectSelf"]."',
				'".$lang_script["testgroup.inc.php"]["appellation"]."',
				'".$lang_script["testgroup.inc.php"]["date"]."',
				'".$lang_script["testgroup.inc.php"]["submitValueDelete"]."',
				'".$lang_script["testgroup.inc.php"]["moreProfEduQuestion"]."',
				'".$lang_script["testgroup.inc.php"]["submitValueMoreProfEdu"]."',
				'".$lang_script["testgroup.inc.php"]["alreadySpecifiedProfEdu"]."',
				'".$lang_script["testgroup.inc.php"]["moreAdvancedEduQuestion"]."',
				'".$lang_script["testgroup.inc.php"]["submitValueMoreAdvancedEdu"]."',
				'".$lang_script["testgroup.inc.php"]["alreadySpecifiedAdvancedEdu"]."',
				'".$lang_script["testgroup.inc.php"]["submitValueContinue"]."',
				'".$lang_script["testgroup.inc.php"]["male"]."',
				'".$lang_script["testgroup.inc.php"]["female"]."',
				'".$lang_script["testgroup.inc.php"]["thankYou"]."',
				'".$lang_script["testgroup.inc.php"]["commitEditDataMessage"]."',
				'".$lang_script["testgroup.inc.php"]["outputSuccessBack"]."'
				)";
				
		$result = $this->db->query($sql);
       	if (DB::isError($result)) 
       	{
          	    $this->setErrorMessage(new PEAR_Error("DB ERROR in insertTestgroup(): ".$result->getMessage()."in".__FILE__." on line ".__LINE__."with-------------$sql------------- "));
          	    return new PEAR_Error("DB ERROR in insertTestgroup(): ".$result->getMessage()."in".__FILE__." on line ".__LINE__."with-------------$sql------------- ");
      	}
		
		// create css class
		$cssClass = &new createCSS;	
		$cssClass->insertDefaultCss ($nextId_Css);
		
		if (!mkdir ($cfgPathToAssessmentOutput."/".$dir, 0777))
		{
			$this->errorMessage = "failed to create directory...<br>\n";
			return false;
		}
		
		if (!mkdir ($cfgPathToAssessmentOutput."/".$dir."/templates", 0777))
		{
			$this->errorMessage = "failed to create directory...<br>\n";
			return false;
		}
		
		if (!$this->copyAssessmentAddFiles($dir, $lang, $nextId))
			return false;
		else
			return true;
			
    }
	
	/**
    *	Delete all files from one dir
    *
    *	@access	public
    *	@param	
    *   @return true/false
    */
	function deleteAllFromPath ($dir)
	{
		global $cfgPathToAssessmentOutput;
		
		if($handle = @opendir($cfgPathToAssessmentOutput."/".$dir)) 
		{
			while(($file = readdir($handle)) != false) 
			{
				if($file == "." || $file == "..")
				{
					continue;
				}
				if(is_dir($dir."/".$file))
				{
					// call self for this directory
					echo "recursive call for: ".$dir."/".$file."<br><br>";
					deleteAllFromPath($dir."/".$file);
					
					
					chmod($dir."/".$file,0777);
					rmdir($dir."/".$file); //remove this directory
				}
				else   
				{
					chmod($cfgPathToAssessmentOutput."/".$dir."/".$file,0777) or die ("failed to chmod ".$cfgPathToAssessmentOutput."/".$dir."/".$file."<br>");
					unlink($cfgPathToAssessmentOutput."/".$dir."/".$file)or die ("failed to delete ".$cfgPathToAssessmentOutput."/".$dir."/".$file."<br>");// remove this file
				}
			}
		}
	}	
	
	/**
    *	copy the files
    *
    *	@access	public
    *	@param	
    *   @return true/false
    */
	function copyAssessmentAddFiles($outputDir, $lang, $testgroupId)
	{
	    global $cfgPathToAssessmentOutput;
	    
		if(!copy($cfgPathToAssessmentOutput."/default.overview.php", $cfgPathToAssessmentOutput."/".$outputDir."/overview.php"))
	    {   
	        echo "copyAssessmentAddFiles(): can't create overview.php";
	        return false;
	    }
	
	    if(!copy($cfgPathToAssessmentOutput."/basic.css", $cfgPathToAssessmentOutput."/".$outputDir."/basic.css"))
	    {   
	        echo "copyAssessmentAddFiles(): can't create basic.css";
	        return false;
	    }
	
	    if(!copy($cfgPathToAssessmentOutput."/default.deactivated.php", $cfgPathToAssessmentOutput."/".$outputDir."/deactivated.php"))
	    {   
	        echo "copyAssessmentAddFiles(): can't create deactivated.php";
	        return false;
	    }
	
		// copy default index template
	    if(!copy($cfgPathToAssessmentOutput."/default.index.php", $cfgPathToAssessmentOutput."/".$outputDir."/index.php"))
	    {   
	        echo "copyAssessmentAddFiles(): can't create index.php";
	        return false;
	    }
	
	    // copy default login template
	    if(!copy($cfgPathToAssessmentOutput."/default.login.php", $cfgPathToAssessmentOutput."/".$outputDir."/login.php"))
	    {   
	        echo "copyAssessmentAddFiles(): can't create login.php";
	        return false;
	    }
	
		// copy default form template
	    if(!copy($cfgPathToAssessmentOutput."/default.form.php", $cfgPathToAssessmentOutput."/".$outputDir."/form.php"))
	    {   
	        echo "copyAssessmentAddFiles(): can't create form.php";
	        return false;
	    }
		
		// copy default dynamicform template
	    if(!copy($cfgPathToAssessmentOutput."/default.dynamicform.php", $cfgPathToAssessmentOutput."/".$outputDir."/dynamicform.php"))
	    {   
	        echo "copyAssessmentAddFiles(): can't create dynamicform.php";
	        return false;
	    }
	
		// copy default splash template
	    if(!copy($cfgPathToAssessmentOutput."/default.splash.php", $cfgPathToAssessmentOutput."/".$outputDir."/splash.php"))
	    {   
	        echo "copyAssessmentAddFiles(): can't create splash.php";
	        return false;
	    }
		
		// copy default message template
	    if(!copy($cfgPathToAssessmentOutput."/default.message.php", $cfgPathToAssessmentOutput."/".$outputDir."/message.php"))
	    {   
	        echo "copyAssessmentAddFiles(): can't create message.php";
	        return false;
	    }

		// copy template
	    if(!copy($cfgPathToAssessmentOutput."/templates/default.dynamicform.tpl", $cfgPathToAssessmentOutput."/".$outputDir."/templates/default.dynamicform.tpl"))
	    {   
	        echo "copyAssessmentAddFiles(): can't create default.dynamicform.tpl";
	        return false;
	    }
		
		// copy template
	    if(!copy($cfgPathToAssessmentOutput."/templates/default.form.tpl", $cfgPathToAssessmentOutput."/".$outputDir."/templates/default.form.tpl"))
	    {   
	        echo "copyAssessmentAddFiles(): can't create default.form.tpl";
	        return false;
	    }
		
		// copy template
	    if(!copy($cfgPathToAssessmentOutput."/templates/default.message.tpl", $cfgPathToAssessmentOutput."/".$outputDir."/templates/default.message.tpl"))
	    {   
	        echo "copyAssessmentAddFiles(): can't create default.message.tpl";
	        return false;
	    }
	
		$xmlString = "<?xml version='1.0' ?><project><id>$testgroupId</id><lang>$lang</lang></project>";
	    $fp = fopen ($cfgPathToAssessmentOutput."/".$outputDir."/survey.xml", "w");
	    if(!$fp)
	    {   
	        echo "copyAssessmentCreateFiles(): can't create survey.xml";
	        return false;
	    }
	    if(!fwrite($fp, $xmlString))
	    {   
	        echo "copyAssessmentCreateFiles(): can't write into survey.xml";
	        return false;
	    }
	    fclose($fp);
	
	    return true;
	}
	
	/**
    *	gets one Testgroup
    *
    *	@access	public
    *	@param	
    *   @return string[]
    */
	function getTestgroupRow($groupId)
	{
		global $cfgTabContentgroup;
		
		$sql = "select * 
           		from ".$cfgTabContentgroup."
           		where CONTENTGROUP_ID_PK = $groupId";
	
        $result = $this->db->query($sql);
		if (DB::isError($result)) 
        {
             $this->setErrorMessage(new PEAR_Error("DB ERROR in insertTestgroup(): ".$result->getMessage()."in".__FILE__." on line ".__LINE__."with-------------$sql------------- "));
          	 return new PEAR_Error("DB ERROR in insertTestgroup(): ".$result->getMessage()."in".__FILE__." on line ".__LINE__."with-------------$sql------------- ");
      	}
		while ($row = $result->fetchRow(DB_FETCHMODE_ASSOC))
        {
            $rawData[] = $row;
        }
		return $rawData;
	}
	
	/**
    *	add Usergroups to Testgroup
    *
    *	@access	public
    *	@param	
    *   @return string true/false
    */
   	function Usergroups_to_Testgroup ($testgroupId, $usergroupArray)
    {
        global $cfgTabContentgroupToUsergroup;
		
		$sql = "delete from $cfgTabContentgroupToUsergroup where CGROUP_TO_UGROUP_CGROUP_ID_FK=$testgroupId ";
		$result = $this->db->query($sql);
		
		if (DB::isError($result)) 
       	{
        	$this->setErrorMessage(new PEAR_Error("DB ERROR in Usergroups_to_Testgroup(): ".$result->getMessage()."in".__FILE__." on line ".__LINE__."with-------------$sql------------- "));
          	return new PEAR_Error("DB ERROR in Usergroups_to_Testgroup(): ".$result->getMessage()."in".__FILE__." on line ".__LINE__."with-------------$sql------------- ");
      	}

		for ($i=0;$i < count($usergroupArray);$i++)
		{
			$sql = "insert into $cfgTabContentgroupToUsergroup (CGROUP_TO_UGROUP_UGROUP_ID_FK, CGROUP_TO_UGROUP_CGROUP_ID_FK) values (".$usergroupArray[$i].", $testgroupId)";
			$result = $this->db->query($sql);
			
			if (DB::isError($result)) 
	       	{
	        	$this->setErrorMessage(new PEAR_Error("DB ERROR in Usergroups_to_Testgroup(): ".$result->getMessage()."in".__FILE__." on line ".__LINE__."with-------------$sql------------- "));
          	 	return new PEAR_Error("DB ERROR in Usergroups_to_Testgroup(): ".$result->getMessage()."in".__FILE__." on line ".__LINE__."with-------------$sql------------- ");
	      	}
		}
   		return true;
    }
	
	/**
    *	get Usergroups of Testgroup
    *
    *	@access	public
    *	@param	
    *   @return string true/false
    */
   	function get_Usergroups_of_Testgroup ($testgroupId)
    {
        global $cfgTabContentgroupToUsergroup;
		
		$sql = "Select * from $cfgTabContentgroupToUsergroup where CGROUP_TO_UGROUP_CGROUP_ID_FK=$testgroupId ";
		$result = $this->db->query($sql);
		
		if (DB::isError($result)) 
       	{
        	$this->setErrorMessage(new PEAR_Error("DB ERROR in get_Usergroups_of_Testgroup(): ".$result->getMessage()."in".__FILE__." on line ".__LINE__."with-------------$sql------------- "));
          	return new PEAR_Error("DB ERROR in get_Usergroups_of_Testgroup(): ".$result->getMessage()."in".__FILE__." on line ".__LINE__."with-------------$sql------------- ");
      	}
		
		while ($row = $result->fetchRow(DB_FETCHMODE_ASSOC))
        {
            $data[] = $row["CGROUP_TO_UGROUP_UGROUP_ID_FK"];
        }
		
		return $data;
    }
	
	
	/**
    *	get User of Testgroup
    *
    *	@access	public
    *	@param	
    *   @return string true/false
    */
   	function get_User_of_Testgroup ($testgroupId)
    {
        global $cfgTabContentgroupToUsergroup;
		global $cfgTabContentgroupToContent;
		global $cfgTabContentgroup;
		global $cfgTabUserData;
		global $cfgTabGroups;
		global $cfgTabUserToGroup;
		
		$sql = "SELECT 
				USERDATA_ID_PK, USERDATA_VNAME,  USERDATA_NNAME
				FROM 
				$cfgTabContentgroup , $cfgTabContentgroupToUsergroup, $cfgTabGroups, $cfgTabUserToGroup, $cfgTabUserData
				WHERE
				CONTENTGROUP_ID_PK  = CGROUP_TO_UGROUP_CGROUP_ID_FK
				AND
				GROUPS_ID_PK = CGROUP_TO_UGROUP_UGROUP_ID_FK
				AND
				GROUPS_ID_PK = GROUP_ID_FK
				AND
				USER_ID_FK = USERDATA_ID_PK
				AND
				CONTENTGROUP_ID_PK = $testgroupId 
				GROUP BY USER_ID_FK";
				
		$result = $this->db->query($sql);
		
		if (DB::isError($result)) 
       	{
        	$this->setErrorMessage(new PEAR_Error("DB ERROR in get_Usergroups_of_Testgroup(): ".$result->getMessage()."in".__FILE__." on line ".__LINE__."with-------------$sql------------- "));
          	return new PEAR_Error("DB ERROR in get_Usergroups_of_Testgroup(): ".$result->getMessage()."in".__FILE__." on line ".__LINE__."with-------------$sql------------- ");
      	}
		
		while ($row = $result->fetchRow(DB_FETCHMODE_ASSOC))
        {
            $data[] = $row;
        }
		
		return $data;
    }
	
	
	
	/**
    *	delete all Tests to Testgroup
    *
    *	@access	public
    *	@param	
    *   @return string true/false
    */
   	function Delete_all_Content_to_Testgroup ($testgroupId)
    {
        global $cfgTabContentgroupToContent;
		global $cfgTabContentgroup;
		global $cfgPathToAssessmentOutput;
		global $cfgPathToOutput;
		
		//delete all data with the givven id
		$sql = "delete from $cfgTabContentgroupToContent where CONTENT_TO_CGROUP_CGROUP_ID_FK=$testgroupId ";
		$result = $this->db->query($sql);
		
		if (DB::isError($result)) 
       	{
        	$this->setErrorMessage(new PEAR_Error("DB ERROR in Content_to_Testgroup(): ".$result->getMessage()."in".__FILE__." on line ".__LINE__."with-------------$sql------------- "));
          	return new PEAR_Error("DB ERROR in Content_to_Testgroup(): ".$result->getMessage()."in".__FILE__." on line ".__LINE__."with-------------$sql------------- ");
      	}

		//get Output Dir of this testgroup
		$sql = "SELECT * FROM $cfgTabContentgroup WHERE CONTENTGROUP_ID_PK =$testgroupId";
		$result = $this->db->query($sql);
		
		if (DB::isError($result)) 
       	{
        	$this->setErrorMessage(new PEAR_Error("DB ERROR in Content_to_Testgroup(): ".$result->getMessage()."in".__FILE__." on line ".__LINE__."with-------------$sql------------- "));
         	 return new PEAR_Error("DB ERROR in Content_to_Testgroup(): ".$result->getMessage()."in".__FILE__." on line ".__LINE__."with-------------$sql------------- ");
      	}
		
		while ($row = $result->fetchRow(DB_FETCHMODE_ASSOC))
	    {
			$outputdir = $row["CONTENTGROUP_OUTPUT_DIR"];
	    }
		
		$deldir =$cfgPathToAssessmentOutput."/".$outputdir;
		
		if($handle = @opendir($deldir)) 
		{
			$anz=0;
			
			while(($file = readdir($handle)) != false) 
			{
				if (is_dir ($deldir."/".$file) && $file!="." && $file!="..")
				{
					$surveydir=$file;
					$deletedir = $cfgPathToAssessmentOutput."/".$outputdir."/".$surveydir;
					system ("rm -r ".$deletedir);
				}
			}
		}

		return true;
	}

	/**
    *	add Tests to Testgroup
    *
    *	@access	public
    *	@param	
    *   @return string true/false
    */
   	function Content_to_Testgroup ($testgroupId, $testArray)
    {
        global $cfgTabContentgroupToContent;
		global $cfgTabContentgroup;
		global $cfgPathToAssessmentOutput;
		global $cfgPathToOutput;
		
		//get ontent Ids
		$sql = "SELECT CONTENT_TO_CGROUP_CONTENT_ID_FK FROM $cfgTabContentgroupToContent WHERE CONTENT_TO_CGROUP_CGROUP_ID_FK=$testgroupId";
		$result = $this->db->query($sql);
		
		if (DB::isError($result)) 
       	{
        	$this->setErrorMessage(new PEAR_Error("DB ERROR in Content_to_Testgroup(): ".$result->getMessage()."in".__FILE__." on line ".__LINE__."with-------------$sql------------- "));
         	 return new PEAR_Error("DB ERROR in Content_to_Testgroup(): ".$result->getMessage()."in".__FILE__." on line ".__LINE__."with-------------$sql------------- ");
      	}
		
		while ($row = $result->fetchRow(DB_FETCHMODE_ASSOC))
	    {
			$contentArray[] = $row["CONTENT_TO_CGROUP_CONTENT_ID_FK"];
	    }
		
		//delete all data with the givven id
		$sql = "delete from $cfgTabContentgroupToContent where CONTENT_TO_CGROUP_CGROUP_ID_FK=$testgroupId ";
		$result = $this->db->query($sql);
		
		if (DB::isError($result)) 
       	{
        	$this->setErrorMessage(new PEAR_Error("DB ERROR in Content_to_Testgroup(): ".$result->getMessage()."in".__FILE__." on line ".__LINE__."with-------------$sql------------- "));
          	return new PEAR_Error("DB ERROR in Content_to_Testgroup(): ".$result->getMessage()."in".__FILE__." on line ".__LINE__."with-------------$sql------------- ");
      	}

		for ($i=0;$i < count($testArray);$i++)
		{
			$sql = "insert into $cfgTabContentgroupToContent (CONTENT_TO_CGROUP_CONTENT_ID_FK, CONTENT_TO_CGROUP_CGROUP_ID_FK) values (".$testArray[$i].", $testgroupId)";
			$result = $this->db->query($sql);
			
			if (DB::isError($result)) 
	       	{
	        	$this->setErrorMessage(new PEAR_Error("DB ERROR in Content_to_Testgroup(): ".$result->getMessage()."in".__FILE__." on line ".__LINE__."with-------------$sql------------- "));
          	 	return new PEAR_Error("DB ERROR in Content_to_Testgroup(): ".$result->getMessage()."in".__FILE__." on line ".__LINE__."with-------------$sql------------- ");
	      	}
		}
		
		
		//get Output Dir of this testgroup
		$sql = "SELECT * FROM $cfgTabContentgroup WHERE CONTENTGROUP_ID_PK =$testgroupId";
		$result = $this->db->query($sql);
		
		if (DB::isError($result)) 
       	{
        	$this->setErrorMessage(new PEAR_Error("DB ERROR in Content_to_Testgroup(): ".$result->getMessage()."in".__FILE__." on line ".__LINE__."with-------------$sql------------- "));
         	 return new PEAR_Error("DB ERROR in Content_to_Testgroup(): ".$result->getMessage()."in".__FILE__." on line ".__LINE__."with-------------$sql------------- ");
      	}
		
		while ($row = $result->fetchRow(DB_FETCHMODE_ASSOC))
	    {
			$outputdir = $row["CONTENTGROUP_OUTPUT_DIR"];
	    }

		for ($i=0;$i<count($testArray);$i++)
		{
			if (!@in_array($testArray[$i],$contentArray))
			{
				$surveyDataArray = $this->get_one_survey ($testArray[$i]);
				//print_r($surveyDataArray );
				$surveydir = $cfgPathToOutput."/".$surveyDataArray[0]["PROJECT_OUTPUTDIR"];
				
				if (!file_exists($cfgPathToAssessmentOutput."/".$outputdir."/".$surveyDataArray[0]["PROJECT_OUTPUTDIR"]))
				{
					if (!mkdir ($cfgPathToAssessmentOutput."/".$outputdir."/".$surveyDataArray[0]["PROJECT_OUTPUTDIR"], 0777))
					{
						$this->errorMessage = "failed to create directory...<br>\n";
					}
				}
				
				if($handle = @opendir($surveydir)) 
				{
					$anz=0;
					while(($file = readdir($handle)) != false) 
					{
						if ($anz<1)
						{
							if (!copy($cfgPathToAssessmentOutput."/".$outputdir."/basic.css", $cfgPathToAssessmentOutput."/".$outputdir."/".$surveyDataArray[0]["PROJECT_OUTPUTDIR"]."/basic.css")) 
							{
							    $this->errorMessage .= "failed to copy css file...<br>\n";
							}
							else
							{
								 $this->errorMessage .= "copied css file...<br>\n";
							}
							
							$anz++;
						}
						
						if($file == "." || $file == ".."|| $file == "basic.css")
						{
							continue;
						}
						
						if (!copy($surveydir."/".$file, $cfgPathToAssessmentOutput."/".$outputdir."/".$surveyDataArray[0]["PROJECT_OUTPUTDIR"]."/".$file)) 
						{
						     $this->errorMessage .= "failed to copy $file...<br>\n";
						}
						else
						{
							 $this->errorMessage .= "copied $file...<br>\n";
						}
						
					}
				}
			}
		}
			
		for ($i=0;$i<count($contentArray);$i++)
		{
			if (!in_array($contentArray[$i],$testArray))
			{
				$surveyDataArray = $this->get_one_survey ($contentArray[$i]);
				$surveydir = $surveyDataArray[0]["PROJECT_OUTPUTDIR"];
				
				$deldir = $outputdir."/".$surveydir;
				$this->deleteAllFromPath ($deldir);	
				rmdir($cfgPathToAssessmentOutput."/".$deldir);
			}
		}
		
   		return true;
    }
	
	/**
    *	get Content of Testgroup
    *
    *	@access	public
    *	@param	
    *   @return string true/false
    */
   	function get_Content_of_Testgroup ($testgroupId)
    {
        global $cfgTabContentgroupToContent;
		
		$sql = "Select * from $cfgTabContentgroupToContent where CONTENT_TO_CGROUP_CGROUP_ID_FK=$testgroupId ";
		$result = $this->db->query($sql);
		
		if (DB::isError($result)) 
       	{
        	$this->setErrorMessage(new PEAR_Error("DB ERROR in get_Content_of_Testgroup(): ".$result->getMessage()."in".__FILE__." on line ".__LINE__."with-------------$sql------------- "));
          	return new PEAR_Error("DB ERROR in get_Content_of_Testgroup(): ".$result->getMessage()."in".__FILE__." on line ".__LINE__."with-------------$sql------------- ");
      	}
		
		while ($row = $result->fetchRow(DB_FETCHMODE_ASSOC))
        {
            $data[] = $row["CONTENT_TO_CGROUP_CONTENT_ID_FK"];
        }
		
		return $data;
    }
	
	/**
    *	get Content of Testgroup for overview
    *
    *	@access	public
    *	@param	
    *   @return string true/false
    */
   	function Content_of_Testgroup_Overview ($testgroupId, $actualNum = 0, $maxRow, $orderBy, $direction)
    {
        global $cfgTabContentgroupToContent;
		global $cfgTabSurveys;
		
		$sql = "Select * from 
					$cfgTabContentgroupToContent 
				where 
					CONTENT_TO_CGROUP_CGROUP_ID_FK=$testgroupId ";
				
		$result = $this->db->query($sql);
		
		if (DB::isError($result)) 
       	{
        	$this->setErrorMessage(new PEAR_Error("DB ERROR in Content_of_Testgroup_Overview(): ".$result->getMessage()."in".__FILE__." on line ".__LINE__."with-------------$sql------------- "));
          	return new PEAR_Error("DB ERROR in Content_of_Testgroup_Overview(): ".$result->getMessage()."in".__FILE__." on line ".__LINE__."with-------------$sql------------- ");
      	}
		
		$numRows = $result->numRows();
		
		if ($numRows<1)
		return null;
		
		$i=0;
		while ($row = $result->fetchRow(DB_FETCHMODE_ASSOC))
        {
            if ($i<1)
			{
				$where="where PROJECT_ID_PK=".$row["CONTENT_TO_CGROUP_CONTENT_ID_FK"];
			}
			else
			{
				$where.=" or PROJECT_ID_PK=".$row["CONTENT_TO_CGROUP_CONTENT_ID_FK"];
			}
			
			$i++;
        }		
		
		$sql = "Select * from $cfgTabSurveys ".$where." order by $orderBy $direction limit $actualNum, $maxRow";

		$result = $this->db->query($sql);
		
		if (DB::isError($result)) 
       	{
        	$this->setErrorMessage(new PEAR_Error("DB ERROR in Content_of_Testgroup_Overview(): ".$result->getMessage()."in".__FILE__." on line ".__LINE__."with-------------$sql------------- "));
          	return new PEAR_Error("DB ERROR in Content_of_Testgroup_Overview(): ".$result->getMessage()."in".__FILE__." on line ".__LINE__."with-------------$sql------------- ");
      	}
		
		while ($row = $result->fetchRow(DB_FETCHMODE_ASSOC))
        {
            $data[] = $row;
        }
		
		return $data;
    }
	
	/**
    *	get Usergroups of Testgroup for overview
    *
    *	@access	public
    *	@param	
    *   @return string true/false
    */
   	function Usergroups_of_Testgroup_Overview ($testgroupId, $actualNum = 0, $maxRow, $orderBy, $direction)
    {
		global $cfgTabContentgroupToUsergroup;
		global $cfgTabGroups;
		
		$sql = "Select * from 
					$cfgTabContentgroupToUsergroup, 
					$cfgTabGroups 
				where 
					$cfgTabContentgroupToUsergroup.CGROUP_TO_UGROUP_UGROUP_ID_FK = $cfgTabGroups.GROUPS_ID_PK 
				and 
					$cfgTabContentgroupToUsergroup.CGROUP_TO_UGROUP_CGROUP_ID_FK=$testgroupId 
				order by $orderBy $direction 
				limit $actualNum, $maxRow";

		$result = $this->db->query($sql);
		
		if (DB::isError($result)) 
       	{
        	$this->setErrorMessage(new PEAR_Error("DB ERROR in Content_of_Testgroup_Overview(): ".$result->getMessage()."in".__FILE__." on line ".__LINE__."with-------------$sql------------- "));
          	return new PEAR_Error("DB ERROR in Content_of_Testgroup_Overview(): ".$result->getMessage()."in".__FILE__." on line ".__LINE__."with-------------$sql------------- ");
      	}

		while ($row = $result->fetchRow(DB_FETCHMODE_ASSOC))
        {
            $data[] = $row;
        }
		
		return $data;
    }
	
	/**
    *	get Number of Usergroups of Testgroup for overview
    *
    *	@access	public
    *	@param	
    *   @return string true/false
    */
   	function Usergroups_of_Testgroup_Overview_Num ($testgroupId)
    {
		global $cfgTabContentgroupToUsergroup;
		global $cfgTabGroups;
		
		$sql = "Select * from 
					$cfgTabContentgroupToUsergroup, 
					$cfgTabGroups 
				where 
					$cfgTabContentgroupToUsergroup.CGROUP_TO_UGROUP_UGROUP_ID_FK = $cfgTabGroups.GROUPS_ID_PK 
				and 
					$cfgTabContentgroupToUsergroup.CGROUP_TO_UGROUP_CGROUP_ID_FK=$testgroupId ";
				
		$result = $this->db->query($sql);
		
		if (DB::isError($result)) 
       	{
        	$this->setErrorMessage(new PEAR_Error("DB ERROR in Usergroups_of_Testgroup_Overview_Num(): ".$result->getMessage()."in".__FILE__." on line ".__LINE__."with-------------$sql------------- "));
          	return new PEAR_Error("DB ERROR in Usergroups_of_Testgroup_Overview_Num(): ".$result->getMessage()."in".__FILE__." on line ".__LINE__."with-------------$sql------------- ");
      	}
	
		$numRows = $result->numRows();
		
		if ($numRows<1)
			return 0;
		else
			return $numRows;
    }
	
	/**
    *	get Number of Content of Testgroup for overview
    *
    *	@access	public
    *	@param	
    *   @return string true/false
    */
   	function Content_of_Testgroup_Overview_Num ($testgroupId)
    {
        global $cfgTabContentgroupToContent;
		global $cfgTabSurveys;
		
		$sql = "Select * from 
					$cfgTabContentgroupToContent 
				where 
					CONTENT_TO_CGROUP_CGROUP_ID_FK=$testgroupId ";
				
		$result = $this->db->query($sql);
		
		if (DB::isError($result)) 
       	{
        	$this->setErrorMessage(new PEAR_Error("DB ERROR in Content_of_Testgroup_Overview(): ".$result->getMessage()."in".__FILE__." on line ".__LINE__."with-------------$sql------------- "));
          	return new PEAR_Error("DB ERROR in Content_of_Testgroup_Overview(): ".$result->getMessage()."in".__FILE__." on line ".__LINE__."with-------------$sql------------- ");
      	}
		
		$i=0;
		while ($row = $result->fetchRow(DB_FETCHMODE_ASSOC))
        {
            if ($i<1)
			{
				$where="where PROJECT_ID_PK=".$row["CONTENT_TO_CGROUP_CONTENT_ID_FK"];
			}
			else
			{
				$where.=" or PROJECT_ID_PK=".$row["CONTENT_TO_CGROUP_CONTENT_ID_FK"];
			}
			
			$i++;
        }
		
		$numRows = $result->numRows();
		
		if ($numRows<1)
		return 0;		
		
		$sql = "Select * from $cfgTabSurveys ".$where;
		$result = $this->db->query($sql);
		
		if (DB::isError($result)) 
       	{
        	$this->setErrorMessage(new PEAR_Error("DB ERROR in Content_of_Testgroup_Overview(): ".$result->getMessage()."in".__FILE__." on line ".__LINE__."with-------------$sql------------- "));
          	return new PEAR_Error("DB ERROR in Content_of_Testgroup_Overview(): ".$result->getMessage()."in".__FILE__." on line ".__LINE__."with-------------$sql------------- ");
      	}
		
		$numRows = $result->numRows();
		
		return $numRows;
    }

	
	/**
    *	get all Surveys
    *
    *	@access	public
    *	@param	
    *   @return string true/false
    */
   	function get_all_surveys ($activeflag)
    {
        global $cfgTabSurveys;
		
		if ($activeflag)
			$sql = "Select * from $cfgTabSurveys WHERE PROJECT_ACTIVE = 'yes' AND PROJECT_SECURITY IS  NULL  OR PROJECT_SECURITY =  '0' ";
		else
			$sql = "Select * from $cfgTabSurveys WHERE PROJECT_SECURITY IS  NULL  OR PROJECT_SECURITY =  '0'";
			
			
		$result = $this->db->query($sql);
		
		if (DB::isError($result)) 
       	{
        	$this->setErrorMessage(new PEAR_Error("DB ERROR in get_all_surveys(): ".$result->getMessage()."in".__FILE__." on line ".__LINE__."with-------------$sql------------- "));
          	return new PEAR_Error("DB ERROR in get_all_surveys(): ".$result->getMessage()."in".__FILE__." on line ".__LINE__."with-------------$sql------------- ");
      	}
		
		while ($row = $result->fetchRow(DB_FETCHMODE_ASSOC))
        {
            $data[] = $row;
        }
		
		return $data;
    }
	
	
	/**
    *	get one Survey
    *
    *	@access	public
    *	@param	
    *   @return string true/false
    */
   	function get_one_survey ($surveyId)
    {
        global $cfgTabSurveys;
		
		$sql = "Select * from $cfgTabSurveys where PROJECT_ID_PK=$surveyId ";
		$result = $this->db->query($sql);
		
		if (DB::isError($result)) 
       	{
        	$this->setErrorMessage(new PEAR_Error("DB ERROR in get_one_survey(): ".$result->getMessage()." in".__FILE__." on line ".__LINE__."with-------------$sql------------- "));
          	return new PEAR_Error("DB ERROR in get_one_survey(): ".$result->getMessage()." in".__FILE__." on line ".__LINE__."with-------------$sql------------- ");
      	}
		
		while ($row = $result->fetchRow(DB_FETCHMODE_ASSOC))
        {
            $data[] = $row;
        }
		
		return $data;
    }
	
	/**
    *	get Testgroups of Usergroup
    *
    *	@access	public
    *	@param	
    *   @return string true/false
    */
   	function get_Testgroups_of_Usergroup ($usergroupId)
    {
        global $cfgTabContentgroupToUsergroup;
		
		$sql = "Select * from $cfgTabContentgroupToUsergroup where CGROUP_TO_UGROUP_UGROUP_ID_FK=$usergroupId ";
		$result = $this->db->query($sql);
		
		if (DB::isError($result)) 
       	{
        	$this->setErrorMessage(new PEAR_Error("DB ERROR in get_Testgroups_of_Usergroup(): ".$result->getMessage()."in".__FILE__." on line ".__LINE__."with-------------$sql------------- "));
          	return new PEAR_Error("DB ERROR in get_Testgroups_of_Usergroup(): ".$result->getMessage()."in".__FILE__." on line ".__LINE__."with-------------$sql------------- ");
      	}
		
		while ($row = $result->fetchRow(DB_FETCHMODE_ASSOC))
        {
            $data[] = $row["CGROUP_TO_UGROUP_CGROUP_ID_FK"];
        }
		
		return $data;
    }
	
	/**
    *	save formoptions
    *
    *	@access	public
    *	@param	
    *   @return string true/false
    */
	function saveFormOptions($testgroupId, $optionDdata, $usermaskId)
	{
	    global $cfgTabContentgroup;
	
	   	$sql = "update $cfgTabContentgroup set
					CONTENTGROUP_SPLASH = '".$optionDdata[0]."',	
					CONTENTGROUP_REG_TEXT_HEAD = '".$optionDdata[1]."',
					CONTENTGROUP_REG_TEXT_BEGIN = '".$optionDdata[2]."',
					CONTENTGROUP_REG_TEXT_MESSAGE = '".$optionDdata[3]."',
					CONTENTGROUP_REG2_TEXT_HEAD = '".$optionDdata[4]."',
					CONTENTGROUP_REG2_TEXT_BEGIN = '".$optionDdata[5]."',
					CONTENTGROUP_REG2_TEXT_MESSAGE = '".$optionDdata[6]."',
					CONTENTGROUP_OVERVIEW_HEADLINE = '".$optionDdata[7]."',
					CONTENTGROUP_OVERVIEW_TEXT = '".$optionDdata[8]."',
					CONTENTGROUP_LOGIN_MSG_MESSAGE = '".$optionDdata[9]."',
					CONTENTGROUP_LOGIN_MSG_REGISTER = '".$optionDdata[10]."',
					CONTENTGROUP_SPLASH_HEAD = '".$optionDdata[11]."',
					CONTENTGROUP_SPLASH_TXT = '".$optionDdata[12]."',
					CONTENTGROUP_DEACTIVATED_TXT = '".$optionDdata[13]."',
					CONTENTGROUP_OVERVIEW_STATUS_1 = '".$optionDdata[14]."',
					CONTENTGROUP_OVERVIEW_STATUS_2 = '".$optionDdata[15]."',
					CONTENTGROUP_REG2_TEXT_EDIT = '".$optionDdata[16]."',
					CONTENTGROUP_USERMASK_ID_FK = $usermaskId
				where CONTENTGROUP_ID_PK = $testgroupId";
	
		$result = $this->db->query($sql);
		
		if (DB::isError($result)) 
       	{
        	$this->setErrorMessage(new PEAR_Error("DB ERROR in saveFormOptions(): ".$result->getMessage()."in".__FILE__." on line ".__LINE__."with-------------$sql------------- "));
          	return new PEAR_Error("DB ERROR in saveFormOptions(): ".$result->getMessage()."in".__FILE__." on line ".__LINE__."with-------------$sql------------- ");
      	}
		
		return true;
	}
	
	function setActive ($IdArray)
	{
		global $cfgTabContentgroup;

		for ($i=0;$i<count($IdArray);$i++)
		{
			$sql = "UPDATE $cfgTabContentgroup SET CONTENTGROUP_ACTIVE=1 where CONTENTGROUP_ID_PK = ".$IdArray[$i];
			$result = $this->db->query($sql);
			
			if (DB::isError($result)) 
	       	{
	        	$this->setErrorMessage(new PEAR_Error("DB ERROR in setActiveMasks(): ".$result->getMessage()."in".__FILE__." on line ".__LINE__."with-------------$sql------------- "));
	          	return new PEAR_Error("DB ERROR in setActiveMasks(): ".$result->getMessage()."in".__FILE__." on line ".__LINE__."with-------------$sql------------- ");
	      	}
		}
		
		return true;
	}
	
	function setDeactive ($IdArray)
	{
		global $cfgTabContentgroup;

		for ($i=0;$i<count($IdArray);$i++)
		{
			$sql = "UPDATE $cfgTabContentgroup SET CONTENTGROUP_ACTIVE=0 where CONTENTGROUP_ID_PK = ".$IdArray[$i];
			$result = $this->db->query($sql);
			
			if (DB::isError($result)) 
	       	{
	        	$this->setErrorMessage(new PEAR_Error("DB ERROR in setActiveMasks(): ".$result->getMessage()."in".__FILE__." on line ".__LINE__."with-------------$sql------------- "));
	          	return new PEAR_Error("DB ERROR in setActiveMasks(): ".$result->getMessage()."in".__FILE__." on line ".__LINE__."with-------------$sql------------- ");
	      	}
		}
		
		return true;
	}
	
}
?>

