<?php
// +----------------------------------------------------------------------+
// | sm survey module - template integration management                   |
// +----------------------------------------------------------------------+
// | Copyright (c) 2002 serie a - Digitale Medien und Systeme GmbH        |
// +----------------------------------------------------------------------+
// | Authors: Jrn Allert <allert@serie-a.de>                             |
// |          Rene Renk <renk@serie-a.de>                                 |
// +----------------------------------------------------------------------+
// | Description: Basic functions for upload management                   |
// +----------------------------------------------------------------------+
//
// $Id: tmpl2assessment.inc.php,v 1.1.1.1 2004/07/15 13:34:28 opensurveypilot Exp $

//session_Start
@session_start();

// require all configuration files and libraries
require_once($cfgPathToProjectAdmin."/config/config.inc.php"); // common config file // common config file
require_once($cfgPathToTestgroupFiles."/config/testgroup.config.inc.php"); // testgroup config file
require_once($cfgPathToTestgroupFiles."/config/testgroup.file.inc.php"); // testgroup files
require_once($cfgPathToTmplFiles."/lib/tmpl.assessment.inc.php"); // auth category functions
require_once ("DB.php"); // PEAR::DB

/**
* tmplFileCreate class
*
* extends tmplFunctions in template todule
*
* template integration class
*
* @author  Jrn Allert <allert@serie-a.de>
* @author  Rene Renk <renk@serie-a.de>
* @access  public
*/
class tmplFileCreate extends tmplFunctions
{

    /**
    *	handle for db connection
    *	@var    string  $db
    */
    var $dbSur = "";
	
    /**
    *	create new tmplFunctions object 
    *
    *	@access	public
    */
    function tmplFileCreate()
    {
		// call parent constructor
		parent::tmplFunctions();
		
		// global variables
		global $cfgTabTmplToAssessment;
		global $cfgTabContentgroup;
		
		global $cfgPathToAssessmentOutput;
		global $cfgPathToAssessmentCodebase;
		
		// set variables
		$this->tmplTabTmpl2Project		=	$cfgTabTmplToAssessment;
		$this->tmplTabTestgroup			=	$cfgTabContentgroup;
		
		$this->tmplPathToOutput		=	$cfgPathToAssessmentOutput;
		$this->tmplPathToCodebase	=	$cfgPathToAssessmentCodebase;

      	// connect to survey database
        $this->dbSur = DB::connect(DSN, true);
        if (DB::isError($db)) 
        {    
            $this->setErrorMessage($dbSur->getMessage());
            return false;
        }
	}

	/**
    *	gets content ids of templates
    *
    *	@access	private
	*
	*	$projectId			projectId
    *   @return array/false
    */
	function getContentId($testgroupId)
	{
		// select ids of files used
        $sql = "select TMPL_TO_ASSESSMENT_SPLASH_ID, TMPL_TO_ASSESSMENT_LOGIN_ID, TMPL_TO_ASSESSMENT_OVERVIEW_ID, TMPL_TO_ASSESSMENT_REPORTING_ID, TMPL_TO_ASSESSMENT_DEACTIVATED_ID, TMPL_TO_ASSESSMENT_REGISTER_ID 
			from $this->tmplTabTmpl2Project 
            where TMPL_TO_ASSESSMENT_TESTGROUP_ID_FK = '$testgroupId'";

        $result = $this->dbSur->query($sql);
        if (DB::isError($result)) 
        {
           $this->setErrorMessage($result->getMessage());
           return false;
        }
		
		while ($row = $result->fetchRow(DB_FETCHMODE_ASSOC))
        {
               $data[] = $row;
        }
		
		return $data;
       	
	}
	
	
	/**
    *	gets template names for overview
    *
    *	@access	private
	*
	*	$projectId			projectId
    *   @return array/false
    */
	function getTemplateNames($testgroupId)
	{
		// select ids of files used
        $sql = "select TMPL_TO_ASSESSMENT_SPLASH_ID, TMPL_TO_ASSESSMENT_LOGIN_ID, TMPL_TO_ASSESSMENT_OVERVIEW_ID, TMPL_TO_ASSESSMENT_REPORTING_ID, TMPL_TO_ASSESSMENT_DEACTIVATED_ID, TMPL_TO_ASSESSMENT_REGISTER_ID 
			from $this->tmplTabTmpl2Project 
            where TMPL_TO_ASSESSMENT_TESTGROUP_ID_FK = '$testgroupId'";

        $result = $this->dbSur->query($sql);
        if (DB::isError($result)) 
        {
           $this->setErrorMessage($result->getMessage());
           return false;
        }
		
		
       	$templateIds = $result->fetchRow(DB_FETCHMODE_ASSOC);
		
		if($templateIds)
		{
			foreach($templateIds as $templateKey => $templateId)
			{
				// get content data
				$templateDataForId = $this->getContentData($templateId);
				
				// build names array
				$templateNames[$templateKey] = $templateDataForId["CONTENT_NAME"];
			}
			return $templateNames;
		}
		return false;
	}
	/**
    *	saves files to specified folder
    *
    *	@access	public
	*
	*	$filePath			template path
	*	$fileName			template Name
	*	$outputPath			target directory
	*	$targetName			target file Name
    *   @return true false
    */
	function saveToDir($filePath,$fileName,$outputPath,$targetName,$topCode,$contentCode,$type, $linkCode=false, $statusCode=false)
	{
		// read filecode
		if(!$fileCode	=	$this->readFileCode($filePath,$fileName))
		{
			return false;
		}
		// check if template valid
		if(!$this->checkTemplate($type,$fileCode))
		{
			return false;
		}
		//
		// replace topcode
		if($topCode)
		{
			if(!$topCode	=	$this->readFileCode($this->tmplPathToCodebase, $topCode))
			{
				return false;
			}
			$fileCode = str_replace('{topcode}', $topCode, $fileCode);
		}
		// replace contentcode
		if($contentCode)
		{
			if(!$contentCode	=	$this->readFileCode($this->tmplPathToCodebase, $contentCode))
			{
				return false;
			}
			$fileCode = str_replace('{contentcode}', $contentCode, $fileCode);
		}
		
		// replace linkcode
		if($linkCode)
		{
			if(!$linkCode	=	$this->readFileCode($this->tmplPathToCodebase, $linkCode))
			{
				return false;
			}
			$fileCode = str_replace('{linkcode}', $linkCode, $fileCode);
		}
		
		// replace statuscode
		if($statusCode)
		{
			if(!$statusCode	=	$this->readFileCode($this->tmplPathToCodebase, $statusCode))
			{
				return false;
			}
			$fileCode = str_replace('{statuscode}', $statusCode, $fileCode);
		}
		
		//
		// write file to outputdir
		if(!fwrite((fopen($outputPath."/".$targetName,"w+")) ,$fileCode))
        {   
            $this->setErrorMessage("saveToDir(): can't create ".$targetName);
            return false;
        }
		return true;
		//
	}
	
	/**
    *	check for aliasses
    *
    *	@access	private
    *   @return true/false
    */
    function checkTemplate($type,$templFile)
    {
	    global $lang_script;
		//
		switch ($type)
		{
			case "overview":
			{
				if((!ereg('{topcode}',$templFile))||(!ereg('{contentcode}',$templFile))||(!ereg('{linkcode}',$templFile))||(!ereg('{statuscode}',$templFile)))
				{
					$this->setErrorMessage($lang_script["tmpl2assessment.inc.php"]["errorMsgNoSubsts"]);
					return false;
				}
				break;
			}
			case "message":
			{
				if(!ereg('{contentcode}',$templFile))
				{
					$this->setErrorMessage($lang_script["tmpl2assessment.inc.php"]["errorMsgNoSubsts"]);
					return false;
				}
				break;
			}
			case "login":
			{
				if( !ereg('{topcode}',$templFile) || !ereg('{contentcode}',$templFile))
				{
					$this->setErrorMessage($lang_script["tmpl2assessment.inc.php"]["errorMsgNoSubsts"]);
					return false;
				}
				break;
			}
			case "deactivated":
			{
				if( !ereg('{topcode}',$templFile) || !ereg('{contentcode}',$templFile))
				{
					$this->setErrorMessage($lang_script["tmpl2assessment.inc.php"]["errorMsgNoSubsts"]);
					return false;
				}
				break;
			}
			case "message":
			{
				if( !ereg('{topcode}',$templFile) || !ereg('{contentcode}',$templFile))
				{
					$this->setErrorMessage($lang_script["tmpl2assessment.inc.php"]["errorMsgNoSubsts"]);
					return false;
				}
				break;
			}
			case "splash":
			{
				if(!ereg('{contentcode}',$templFile))
				{
					$this->setErrorMessage($lang_script["tmpl2assessment.inc.php"]["errorMsgNoSubsts"]);
					return false;
				}
				break;
			}
		}
	return true;
	}

	/**
    *	saves all files with new template needed for preview
    *
    *	@access	private
    *   @return array path with Id as $key
    */
    function saveFileforProject($testgroupId, $type, $tmplPath, $fileId)
    {
		// global codenames
		global $lang_script;

		global $codeAssessmentDeactivatedTop;
		global $codeAssessmentDeactivatedContent;

		global $codeAssessmentMessageTop;
		global $codeAssessmentMessageContent;

		global $codeAssessmentLoginTop;
		global $codeAssessmentLoginContent;

		global $codeAssessmentOverviewTop;
		global $codeAssessmentOverviewContent;
		global $codeAssessmentOverviewLink;
		global $codeAssessmentOverviewStatus;

		global $codeAssessmentSplashContent;
		
		// get output path
        $sql = "select CONTENTGROUP_OUTPUT_DIR 
			from $this->tmplTabTestgroup 
            where CONTENTGROUP_ID_PK = '$testgroupId'";
		//
        $result = $this->dbSur->query($sql);
        if (DB::isError($result)) 
        {
           $this->setErrorMessage($result->getMessage());
           return false;
        }
        //
		$row = $result->fetchRow(DB_FETCHMODE_ASSOC); 
		$outputDir = $row["CONTENTGROUP_OUTPUT_DIR"];
		$outputPath = $this->tmplPathToOutput."/".$outputDir;
		//
		// template name
		$fileData	= $this->getContentData($fileId);
		$fileName	= $fileData["CONTENT_FILENAME"];
		$filePath	= $this->pathToOutputTmpl."/".$fileData['path'];
		// save settings to database
		//
		// check what to save
		switch ($type)
		{
			case "overview":
			{
				$toUpdateColumn 	= "TMPL_TO_ASSESSMENT_OVERVIEW_ID";
				$targetName[0]		= "overview.php";
				$topCode[0]			= $codeAssessmentOverviewTop;
				$contentCode[0]		= $codeAssessmentOverviewContent;
				$linkCode[0]		= $codeAssessmentOverviewLink;
				$statusCode[0]		= $codeAssessmentOverviewStatus;
				break;
			}
			case "message":
			{
				$toUpdateColumn 	= "TMPL_TO_ASSESSMENT_REPORTING_ID";
				$targetName[0]		= "message.php";
				$topCode[0]			= $codeAssessmentMessageTop;
				$contentCode[0]		= $codeAssessmentMessageContent;
				break;
			}
			case "login":
			{
				$toUpdateColumn 	= "TMPL_TO_ASSESSMENT_LOGIN_ID";
				$targetName[0]		= "login.php";
				$topCode[0]			= $codeAssessmentLoginTop;
				$contentCode[0]		= $codeAssessmentLoginContent;
				break;
			}
			case "deactivated":
			{
				$toUpdateColumn 	= "TMPL_TO_ASSESSMENT_DEACTIVATED_ID";
				$targetName[0]		= "deactivated.php";
				$topCode[0]			= $codeAssessmentDeactivatedTop;
				$contentCode[0]		= $codeAssessmentDeactivatedContent;
				break;
			}
			case "splash":
			{
				$toUpdateColumn 	= "TMPL_TO_ASSESSMENT_SPLASH_ID";
				$targetName[0]		= "splash.php";
				$contentCode[0]		= $codeAssessmentSplashContent;
				break;
			}
			default:
			{
				$this->setErrorMessage($lang_script["tmpl2assessment.inc.php"]["errorNoValidTmplUpd"]);
				return false;
			}
		
		}
		// check if data 
	    $sql = "select TMPL_TO_ASSESSMENT_ID_PK, TMPL_TO_ASSESSMENT_TESTGROUP_ID_FK, TMPL_TO_ASSESSMENT_SPLASH_ID, TMPL_TO_ASSESSMENT_LOGIN_ID, TMPL_TO_ASSESSMENT_OVERVIEW_ID, TMPL_TO_ASSESSMENT_REPORTING_ID, TMPL_TO_ASSESSMENT_DEACTIVATED_ID, TMPL_TO_ASSESSMENT_REGISTER_ID  
			from $this->tmplTabTmpl2Project 
            where TMPL_TO_ASSESSMENT_TESTGROUP_ID_FK = '$testgroupId'";
		//
        $result = $this->dbSur->query($sql);
        if (DB::isError($result)) 
        {
           $this->setErrorMessage($result->getMessage());
           return false;
        }
		
        // get info update or insert
		if ($row = $result->fetchRow(DB_FETCHMODE_ASSOC)) 
        {
			// get backup
			$oldTemplateId = $row["$toUpdateColumn"];
			// update
	        $sql = "update 
				$this->tmplTabTmpl2Project 
				set 
				$toUpdateColumn = '$fileId'  
				where TMPL_TO_ASSESSMENT_TESTGROUP_ID_FK = '$testgroupId'";

	        $result = $this->dbSur->query($sql);
	        if (DB::isError($result)) 
	        {
	           $this->setErrorMessage($result->getMessage());
			   return false;
	        }

		}
		else
		{
			
			//insert
			// get next free id
	        $nextId = $this->db->nextId($this->tmplTabTmpl2Project);
	        if (DB::isError($nextId)) 
	        {
	            $this->setErrorMessage($result->getMessage());
	            return false;
	        }
	        // create insert statement
	        $sql = "insert 
				into $this->tmplTabTmpl2Project 
	            (TMPL_TO_ASSESSMENT_ID_PK, TMPL_TO_ASSESSMENT_TESTGROUP_ID_FK, $toUpdateColumn) 
	            values 
	            ('$nextId', '$testgroupId', '$fileId')";
			//

	        $result = $this->dbSur->query($sql);
	        if (DB::isError($result)) 
	        {
	           $this->setErrorMessage($result->getMessage());
	           return false;
	        }
			 
		}
		// write fies
		for($i = 0; $i <count($targetName); $i++)
		{
			// save file
			if(!$this->saveToDir($filePath,$fileName,$outputPath,$targetName[$i],$topCode[$i],$contentCode[$i],$type,$linkCode[$i],$statusCode[$i]))
			{
				if($nextId)
				{
					// get output path
			        $sql = "delete 
						from $this->tmplTabTmpl2Project 
			            where TMPL_TO_ASSESSMENT_ID_PK = '$nextId'";
					//
			        $result = $this->dbSur->query($sql);
			        if (DB::isError($result)) 
			        {
			           $this->setErrorMessage($result->getMessage());
			           return false;
			        }
				}
				else if($oldTemplateId)
				{
					// update back to old template
			        $sql = "update 
						$this->tmplTabTmpl2Project 
						set 
						$toUpdateColumn = '$oldTemplateId'  
						where TMPL_TO_ASSESSMENT_TESTGROUP_ID_FK = '$testgroupId'";
					//
			        $result = $this->dbSur->query($sql);
			        if (DB::isError($result)) 
			        {
			           $this->setErrorMessage($result->getMessage());
					   return false;
			        }
				}
				return false;
			}
		}
		//
		return true;;
	}
}




?>
