<?php
// +----------------------------------------------------------------------+
// | assessment pilot testgroup module                                    |
// +----------------------------------------------------------------------+
// | Copyright (c) 2003 serie a - Digitale Medien und Systeme GmbH        |
// +----------------------------------------------------------------------+
// | Authors: Daniel Peer <peer@serie-a.de>                               |
// +----------------------------------------------------------------------+
//
// $Id: testgroup.tree.inc.php,v 1.1.1.1 2004/07/15 13:34:28 opensurveypilot Exp $

// start session
@session_start();
 
// require all configuration files and libraries
require_once("./../config/config.inc.php"); // common config file
require_once($cfgPathToConf."/file.inc.php"); // project files
require_once($cfgPathToTestgroupFiles."/config/testgroup.config.inc.php"); // configuration
require_once($cfgPathToTestgroupFiles."/config/testgroup.file.inc.php"); // files
require_once($cfgPathToTestgroupFiles."/lib/testgroup.inc.php"); // testgroup functions
require_once($cfgPathToTestgroupFiles."/config/testgroup.config.inc.php"); // testgroup config file
require_once($cfgPathToTestgroupFiles."/config/testgroup.file.inc.php"); // testgroup files
require_once ("DB.php"); // PEAR::DB

/**
*	Class to create Javascript which in turn creates the group tree	
*
*	@author Daniel Peer <peer@serie-a.de>
*	@see PEAR::DB
*/
class TestgroupTreeMenu
{
	/**
	* Name of the image used as node icon
	* @var 		string $icon
	* @access 	private
	*/
    var $icon = "folder.gif";
	
	/**
	* Name of the image used as design node icon
	* @var 		string $designIcon
	* @access 	private
	*/
    var $designIcon = "designfolder.gif";
	
	/**
	* Name of the image used as design node icon
	* @var 		string $statusIcon
	* @access 	private
	*/
    var $statusIcon = "detailfolder.gif";

	/**
	* The menu object
	* @var 		object HTML_TreeMenu $menu
	* @access 	private
	*/
    var $menu;

	/**
	* The DB handle
	* @var 		mixed $db
	* @see		DB::connect()
	* @access 	private
	*/
	var $db = "";

	/**
	* Name the DB table node elements are read from
	* @var 		string $table
	* @access 	private
	*/
    var $table;
    
	/**
	* The time when tree building is started
	* @var 		int $startTime
	* @access 	private
	*/
    var $startTime;

	/**
	* The time in seconds after which tree building is aborted
	* @var 		int $timeout
	* @access 	private
	*/
    var $timeout = 10;
	
	/**
	* The last error message
	* @var 		string $error;
	* @access 	private
	*/
    var $error;
	
	/**
	*	Constructor
	*
	*	@access public
	*	@param string $table 	Name the DB table node elements are read from
	*/
    function TestgroupTreeMenu()
    {
        $this->db= DB::connect(DSN, true);
        if (DB::isError($this->db)) 
        {    
           return false;
        }
        		
		$this->error = "";
        $this->startTime = time();
        $this->menu = new HTML_TreeMenu("menuLayer", '../media/images/treemenu', '_self');
		
        $this->buildTree();
    }
    
	/**
	*	Check for an error since last invocation of buildTree()
	*
	*	@access public
	*	@return boolean     TRUE if a timeout occurred, FALSE otherwise
	*/
    function isError()
    {
    	return ($this->error != "");
    }
    
	/**
	*	Get the error message
	*
	*	@access public
	*	@return string  Error message
	*/
    function getError()
    {
    	return $this->error;
    }
    
	/**
	*	Build the user tree
	*
	*	@access private
	*/
    function buildTree()
    {
	    global $lang_script;
		$testgroupArray = $this->getTestgroups(0, 1000, "CONTENTGROUP_NAME", "ASC");

		$rootNode = new HTML_TreeNode($lang_script["testgroup.tree.inc.php"]["rootNodePanel"], $this->getLinkForProjectId($testgroupArray[$i]["CONTENTGROUP_ID_PK"]), "rootfolder.gif");
		
		$this->menu->addItem($rootNode);
		
		if($testgroupArray)
        {
			for($i=0; $i<count($testgroupArray);$i++)
            {
				// add project
				$aktnode = &new HTML_TreeNode($testgroupArray[$i]["CONTENTGROUP_NAME"], $this->getLinkForProjectId($testgroupArray[$i]["CONTENTGROUP_ID_PK"]),"detailfolder.gif");
				$rootNode->addItem($aktnode);
				// add content node
				$this->appendContentNode($aktnode, $testgroupArray[$i]["CONTENTGROUP_ID_PK"]);
				// add group node
				$this->appendGroupNode($aktnode, $testgroupArray[$i]["CONTENTGROUP_ID_PK"]);
				// add design node
				$this->appendDesignNode($aktnode, $testgroupArray[$i]["CONTENTGROUP_ID_PK"]);
				// add status node
				$this->appendStatusNode($aktnode, $testgroupArray[$i]["CONTENTGROUP_ID_PK"]);
				// add status node
				$this->appendMailNode($aktnode, $testgroupArray[$i]["CONTENTGROUP_ID_PK"]);
			}
    	}
    }
	
	function appendDesignNode(&$node, $nodeId)
    {
	    global $lang_script;
		$node->addItem(new HTML_TreeNode($lang_script["testgroup.tree.inc.php"]["appendNodeDesign"], $this->getLinkForDesignId($nodeId), $this->designIcon)); 
	}
	
	function appendStatusNode(&$node, $nodeId)
    {
	    global $lang_script;
		$node->addItem(new HTML_TreeNode($lang_script["testgroup.tree.inc.php"]["appendNodeStatus"], $this->getLinkForStatusId($nodeId), $this->statusIcon)); 
	}
	
	function appendMailNode(&$node, $nodeId)
    {
	    global $lang_script;
		$node->addItem(new HTML_TreeNode($lang_script["testgroup.tree.inc.php"]["appendNodeMail"], $this->getLinkForMailId($nodeId), $this->icon)); 
	}
	
	function getLinkForMailId($id)
    {
    	global $fileTestgroupToplevel, $fileFrameToplevelName;
        global $fileTestgroupMailOverview, $fileFrameContentName;

    	return "javascript:changeTwoFrames(\'$fileTestgroupToplevel?action=design&testgroupId=$id\',\'$fileFrameToplevelName\',\'$fileTestgroupMailOverview?testgroupId=$id\',\'$fileFrameContentName\')";
    }
	
	function getLinkForDesignId($id)
    {
    	global $fileTestgroupToplevel, $fileFrameToplevelName;
        global $fileTestgroupDesignOverview, $fileFrameContentName;

    	return "javascript:changeTwoFrames(\'$fileTestgroupToplevel?action=design&testgroupId=$id\',\'$fileFrameToplevelName\',\'$fileTestgroupDesignOverview?testgroupId=$id\',\'$fileFrameContentName\')";
    }
	
	function getLinkForStatusId($id)
    {
    	global $fileTestgroupToplevel, $fileFrameToplevelName;
        global $fileTestgroupStatusOverview, $fileFrameContentName;

    	return "javascript:changeTwoFrames(\'$fileTestgroupToplevel?testgroupId=$id\',\'$fileFrameToplevelName\',\'$fileTestgroupStatusOverview?testgroupId=$id\',\'$fileFrameContentName\')";
    }
	
	function appendContentNode(&$node, $nodeId)
    {
	    global $lang_script;
		$node->addItem(new HTML_TreeNode($lang_script["testgroup.tree.inc.php"]["appendNodeContent"], $this->getLinkForContentId($nodeId), $this->icon)); 
	}
	
	function getLinkForContentId($id)
    {
    	global $fileTestgroupToplevel, $fileFrameToplevelName;
        global $fileTestgroupContentOverview, $fileFrameContentName;

    	return "javascript:changeTwoFrames(\'$fileTestgroupToplevel?action=content&testgroupId=$id\',\'$fileFrameToplevelName\',\'$fileTestgroupContentOverview?testgroupId=$id\',\'$fileFrameContentName\')";
    }
	
	function appendGroupNode(&$node, $nodeId)
    {
	    global $lang_script;
		$node->addItem(new HTML_TreeNode($lang_script["testgroup.tree.inc.php"]["appendNodeGroup"], $this->getLinkForGroupId($nodeId),"securityfolder.gif")); 
	}
	
	function getLinkForGroupId($id)
    {
    	global $fileTestgroupToplevel, $fileFrameToplevelName;
        global $fileTestgroupUsergroupOverview, $fileFrameContentName;

    	return "javascript:changeTwoFrames(\'$fileTestgroupToplevel?action=group&testgroupId=$id\',\'$fileFrameToplevelName\',\'$fileTestgroupUsergroupOverview?testgroupId=$id\',\'$fileFrameContentName\')";
    }
	
	function getLinkForProjectId($id)
    {
    	global $fileTestgroupToplevel, $fileFrameToplevelName;
        global $fileTestgroupOverview, $fileFrameContentName;

    	return "javascript:changeTwoFrames(\'$fileTestgroupToplevel\',\'$fileFrameToplevelName\',\'$fileTestgroupOverview\',\'$fileFrameContentName\')";
    }
	
	
	/**
	*	Echos the Javascript code to create the user tree
	*
	*	@access public
	*/
	function printMenu()
    {
		$this->menu->printMenu();
	}
	
	/**
    *	get all Testgroups
    *
    *	@access	public
    *	@param	
    *   @return string true/false
    */
   	function getTestgroups($actualNum = 0, $maxRow, $orderBy, $direction)
    {
        global $cfgTabContentgroup;
        
		$db = DB::connect(DSN, true);
        if (DB::isError($db)) 
        {    
		   $this->errorMessage = $db->getMessage();
        }		
		
      	// select all raw Data
       	$sql = "select * 
				from $cfgTabContentgroup
			    order by $orderBy $direction 
                limit $actualNum, $maxRow";

		$result = $db->query($sql);
       	if (DB::isError($result)) 
       	{
          	    $this->setErrorMessage(new PEAR_Error("DB ERROR in getTestgroupsForOverview(): ".$result->getMessage()."in".__FILE__." on line ".__LINE__."with-------------$sql------------- "));
          	    return new PEAR_Error("DB ERROR in getTestgroupsForOverview(): ".$result->getMessage()."in".__FILE__." on line ".__LINE__."with-------------$sql------------- ");
      	}
		// get rows
       	while ($row = $result->fetchRow(DB_FETCHMODE_ASSOC))
        {
               $getRawData[] = $row;
        }
        
		return $getRawData;
    }
    
}   // end of class TestgroupTreeMenu
?>
