<?php
// +----------------------------------------------------------------------+
// | Assessment pilot                                                         |
// +----------------------------------------------------------------------+
// | Copyright (c) 2002 serie a - Digitale Medien und Systeme GmbH        |
// +----------------------------------------------------------------------+
// | Authors: 	Daniel Peer <peer@serie-a.de>                             |
// |          	                                                          |
// +----------------------------------------------------------------------+
//
// $Id: testgroup.add.php,v 1.1.1.1 2004/07/15 13:34:13 opensurveypilot Exp $

// start session
@session_start();

// require all configuration files and libraries
require_once("./../config/config.inc.php"); // common config file
require_once($cfgPathToConf."/file.inc.php"); // project files
require_once($cfgPathToLib."/common.inc.php"); // common functions
require_once($cfgPathToTestgroupFiles."/config/testgroup.config.inc.php"); // testgroup config file
require_once($cfgPathToTestgroupFiles."/config/testgroup.file.inc.php"); // testgroup files
require_once($cfgPathToTestgroupFiles."/lib/testgroup.inc.php"); // testgroup functions
require_once($cfgPathToAuthFiles."/lib/permission.inc.php"); // permission functions
require_once($cfgPathToAuthFiles."/lib/user.inc.php"); // auth user functions
require_once($cfgPathToProbFiles."/config/prob.config.inc.php"); // proband config file
require_once($cfgPathToProbFiles."/lib/mask.inc.php"); // mask functions
require_once("HTML/Template/IT.php"); // PEAR::HTML_TEMPLATE_IT
require_once($cfgPathToLangFiles."/lib/languagefunctions.inc.php");


// create new userFunctions object
$client = &new userFunctions;

//login check
if ($client->getAuthentication($_SESSION["sessionId"], session_id()) == false)
{
    //redirect to login page
    ?>
    <script type="text/javascript">
    <!--
    window.location.href="<?php echo $cfgUrlToProject."/".$fileAuthLogin; ?>";
    -->
    </script>
    <?php
    exit;
}

// function permission check
if($_SESSION["sessionUserStatusId"] < $permRawDataDetailView)
{
    ?>
    <script type="text/javascript">
    <!--
    window.location.href="<?php echo $cfgUrlToProject."/".$fileNoPermission."?messageCode=2"; ?>";
    -->
    </script>
    <?php
    exit;
}


if($_SERVER["REQUEST_METHOD"] == "POST")
{
	$testgroupname = cleanHTML($_POST["testgroupname"]);
	if ($testgroupname == "") 
		$errors = $lang_script["testgroup.add.php"]["errorTestgroupName"]."<br>";
	
	$testgroupdescription = cleanHTML($_POST["testgroupdescription"]);
	if ($testgroupdescription == "") 
		$errors.= $lang_script["testgroup.add.php"]["errorTestgroupDescription"]."<br>";
		
	$testgroupoutputdir = cleanHTML(ereg_replace(" ","_",(strtolower($_POST["outputdir"]))));
	if ($testgroupoutputdir == "") 
		$errors.= $lang_script["testgroup.add.php"]["errorTestgroupOutputdir"]."<br>";
		
	$usermask = cleanHTML($_POST["usermask"]);
	if ($usermask == "") 
		$errors.= $lang_script["testgroup.add.php"]["errorUserMask"]."<br>";
	
	$testgroups = &new Testgroup;
	
	$panellang = cleanHTML($_POST["panellang"]);
	

	if (!$errors)
	{
		include ("./../config/lang/".$panellang.".script.inc.php");
		
		if ($testgroups->insertTestgroup ($testgroupname, $testgroupdescription, $testgroupoutputdir, $usermask, $panellang))
		{
		?>
		<script type="text/javascript">
		<!--
		window.location.href="<?php echo $cfgUrlToProject."/".$fileInsertSuccessMessage; ?>";
		-->
		</script>
		<?php
		}
		exit;
	}
}

$tpl = new HTML_Template_IT($cfgPathToTestgroupTemplates);
$tpl->loadTemplatefile($templateTestgroupAdd, true, true); // do remove untouched blocks

// set title
$tpl->setVariable( "applicationtitle", $cfgApplicationType.$cfgApplicationVersion);

if ($errors)
{
	$tpl->setVariable( "errors", $errors);
	$tpl->setVariable( "testgroupname", $testgroupname);
	$tpl->setVariable( "testgroupdescription", $testgroupdescription);
	$tpl->setVariable( "outputdir", $testgroupoutputdir);
}

$tpl->setVariable( "formaction", $fileTestgroupAdd);

$maskArray = getAllUsermasks();

for($i=0;$i<count($maskArray);$i++)
{
	$tpl->setCurrentBlock( "usermasklist" );
	if ($errors && $usermask == $maskArray[$i]["USERMASK_ID_PK"])
	{
		$tpl->setVariable( "usermask_selected", "selected" );
	}
	else
	{
		$tpl->setVariable( "usermask_selected", "" );
	}
	
	$tpl->setVariable( "usermask_value", $maskArray[$i]["USERMASK_ID_PK"] );
	$tpl->setVariable( "usermask_name",  $maskArray[$i]["USERMASK_NAME"] );
	$tpl->parseCurrentBlock();
}

$lf = new languageFunctions();
$installedLanguages = $lf->getInstalledLanguages();

for ($i=0;$i<count($installedLanguages);$i++)
{
	$tpl->setCurrentBlock( "panellanglist" );
	$tpl->setVariable( "panellang_selected", "" );	
	$tpl->setVariable( "panellang_value", $installedLanguages[$i][LANGUAGE_FILE] );
	$tpl->setVariable( "panellang_name",  ucfirst($installedLanguages[$i][LANGUAGE_FILE]) );
	$tpl->parseCurrentBlock();
	
}

// parse template
$tpl->parse();

// get the parsed template and print it
$tpl->get();
$tpl->show();


?>
