<?php
// +----------------------------------------------------------------------+
// | survey pilot                                                         |
// +----------------------------------------------------------------------+
// | Copyright (c) 2002 serie a - Digitale Medien und Systeme GmbH        |
// +----------------------------------------------------------------------+
// | Authors: 	Daniel Peer <peer@serie-a.de>                             |
// +----------------------------------------------------------------------+
//
// $Id: testgroup.content.overview.php,v 1.1.1.1 2004/07/15 13:34:14 opensurveypilot Exp $

// start session
@session_start();

// require all configuration files and libraries
require_once("./../config/config.inc.php"); // common config file
require_once($cfgPathToConf."/file.inc.php"); // project files
require_once($cfgPathToLib."/common.inc.php"); // common functions
require_once($cfgPathToAuthFiles."/lib/user.inc.php"); // auth user functions
require_once($cfgPathToTestgroupFiles."/config/testgroup.config.inc.php"); // proband config file
require_once($cfgPathToTestgroupFiles."/config/testgroup.file.inc.php"); // proband files
require_once($cfgPathToTestgroupFiles."/lib/testgroup.inc.php"); // mask functions
require_once("HTML/Template/IT.php"); // PEAR::HTML_TEMPLATE_IT
 
// create new userFunctions object
$client = &new userFunctions;

//login check
if ($client->getAuthentication($_SESSION["sessionId"], session_id()) ==  false)
{
    //redirect to login page
    ?>
    <script type="text/javascript">
    <!--
    window.location.href="<?php echo $cfgUrlToProject."/".$fileAuthLogin; ?>";
    -->
    </script>
    <?php
    exit;
} 
 
 
 
$testgroupId = $_GET["testgroupId"];

if (!$testgroupId)
	$testgroupId = $_POST["testgroupId"];
 
$testgroups = &new Testgroup;

if($_SERVER["REQUEST_METHOD"] == "POST")
{
	$contentIdArray=$_POST["contentId"];

	if ($_POST["selectAction"]==1)
	{
		for ($i=0;$i<count($contentIdArray);$i++)
		{
			
		}
	}
}

// create Template IT object
$tpl = new HTML_Template_IT($cfgPathToTestgroupTemplates);

// load template
$tpl->loadTemplatefile($templateTestgroupContentOverview, true, true);

// set title
$tpl->setVariable( "applicationtitle", $cfgApplicationType.$cfgApplicationVersion);

$tpl->setVariable( "formaction", $fileTestgroupContentOverview);
$tpl->setVariable( "testgroupId", $testgroupId);

// get actual num as get variable
if(isset($_GET["actualNum"]))
{
    $actualNum = $_GET["actualNum"];
}
// get orderBy as get variable
if(isset($_GET["orderBy"]))
{
    $orderBy = $_GET["orderBy"];
}
else
{
    $orderBy = "PROJECT_NAME";
}
// get direction as get variable
if(isset($_GET["direction"]))
{
    $direction = $_GET["direction"];
}

// maximum rows
$maxRow = $cfgMaxRowInOverviews;  // z.Zt. 15
// total rows

$totalNum = $testgroups->Content_of_Testgroup_Overview_Num ($testgroupId);

$contentArray = $testgroups->getTestgroupRow($testgroupId);

$testgroupoutputdir = $contentArray[0]["CONTENTGROUP_OUTPUT_DIR"];

// actual rows
if (!isset($actualNum))
{
    $actualNum = 0;
}
// get the Number of pages
$numPages = intval($totalNum/$maxRow);
if ($numPages < ($totalNum/$maxRow))
{ 
    $numPages++;
}

// prev button
if ($actualNum > 0) 
{
    $y = $actualNum - $maxRow;
    
    $tpl->setVariable( "prev_button", "<a class=\"navigation\" href=\"$fileTestgroupContentOverview?actualNum=$y&orderBy=$orderBy&direction=$direction&testgroupId=$testgroupId\">&laquo;</a>" );
}
// display pages
for ($i = 1; $i <= $numPages; $i++)
{
    $y = ($i * $maxRow) - $maxRow;
    
    $tpl->setCurrentBlock( "num_buttons" );
    $tpl->setVariable( "num_button", "[<a class=\"navigation\" href=\"$fileTestgroupContentOverview?actualNum=$y&orderBy=$orderBy&direction=$direction&testgroupId=$testgroupId\">$i</a>]" );
    $tpl->parseCurrentBlock();
}
//  next button
if ($actualNum < ($totalNum - $maxRow))
{
    $y = $actualNum  + $maxRow;
    
    $tpl->setVariable( "next_button", "<a class=\"navigation\" href=\"$fileTestgroupContentOverview?actualNum=$y&orderBy=$orderBy&direction=$direction&testgroupId=$testgroupId\">&raquo;</a>" );
}

if(($actualNum + $maxRow) < $totalNum)
{
    $entryTo = $actualNum + $maxRow;
}
else
{
    $entryTo = $totalNum;
    
}


// entry from
$entryFrom = $entryTo < 1 ? "0" : $actualNum +1;

$tpl->setVariable( "entry_from", $entryFrom );
$tpl->setVariable( "entry_to", $entryTo );
$tpl->setVariable( "entry_total", $totalNum );

// get questions
$contentArray = $testgroups->Content_of_Testgroup_Overview($testgroupId, $actualNum, $maxRow, $orderBy, $direction);

if($testgroups->errorMessage)
{
    echo $testgroups->errorMessage;
}

//eine reihe

for($j=0;$j<count($contentArray);$j++)
{   
    $tpl->setCurrentBlock( "Groups_overview" );

	$tpl->setVariable( "id", $contentArray[$j]["PROJECT_ID_PK"] );
	//$tpl->setVariable( "contentId", $contentArray[$j]["PROJECT_ID_PK"] );
	$tpl->setVariable( "desc", $contentArray[$j]["PROJECT_DESCRIPTION"] );
	$tpl->setVariable( "name", $contentArray[$j]["PROJECT_NAME"]);
	$tpl->setVariable( "creator", $contentArray[$j]["PROJECT_AUTHOR"]);
	$tpl->setVariable( "created", $contentArray[$j]["PROJECT_TIMESTAMP"]);
	$tpl->setVariable( "view_link", $cfgUrlToAssessment."/".$testgroupoutputdir."/".$contentArray[$j]["PROJECT_OUTPUTDIR"]."/preview.php?assessment=1&projectId=".$contentArray[$j]["PROJECT_ID_PK"]);
    $tpl->parseCurrentBlock();	
}

// ende eine reihe

//to get the name of this testgroup for the headline
$groupArray = $testgroups->getTestgroupRow($testgroupId);
$testgroupName = $groupArray[0]["CONTENTGROUP_NAME"];

// headline
$tpl->setCurrentBlock( "headline" );
$tpl->setVariable( "headline", $lang_script["testgroup.content.overview.php"]["contentToPanel"]." ".$testgroupName );
$tpl->parseCurrentBlock();

// get the parsed template and print it
$tpl->get();
$tpl->show();


?>
