<?php
// +----------------------------------------------------------------------+
// | Assessment pilot                                                         |
// +----------------------------------------------------------------------+
// | Copyright (c) 2002 serie a - Digitale Medien und Systeme GmbH        |
// +----------------------------------------------------------------------+
// | Authors: 	Daniel Peer <peer@serie-a.de>                             |
// |          	                                                          |
// +----------------------------------------------------------------------+
//
// $Id: testgroup.css.php,v 1.1.1.1 2004/07/15 13:34:14 opensurveypilot Exp $

// start session
@session_start();

// require all configuration files and libraries
require_once("./../config/config.inc.php"); // common config file
require_once($cfgPathToConf."/file.inc.php"); // project files
require_once($cfgPathToLib."/common.inc.php"); // common functions
require_once($cfgPathToTestgroupFiles."/config/testgroup.config.inc.php"); // proband config file
require_once($cfgPathToTestgroupFiles."/config/testgroup.file.inc.php"); // proband files
require_once($cfgPathToTestgroupFiles."/lib/testgroup.inc.php"); // mask functions
require_once($cfgPathToTestgroupFiles."/lib/createcss.inc.php"); // css functions
require_once($cfgPathToAuthFiles."/lib/user.inc.php"); // auth user functions
require_once($cfgPathToAuthFiles."/lib/permission.inc.php"); // permission functions
require_once("HTML/Template/IT.php"); // PEAR::HTML_TEMPLATE_IT


// create new userFunctions object
$client = &new userFunctions;

//login check
if ($client->getAuthentication($_SESSION["sessionId"], session_id()) == false)
{
    //redirect to login page
    ?>
    <script type="text/javascript">
    <!--
    window.location.href="<?php echo $cfgUrlToProject."/".$fileAuthLogin; ?>";
    -->
    </script>
    <?php
    exit;
}

// function permission check
if($_SESSION["sessionUserStatusId"] < $permRawDataDetailView)
{
    ?>
    <script type="text/javascript">
    <!--
    window.location.href="<?php echo $cfgUrlToProject."/".$fileNoPermission."?messageCode=2"; ?>";
    -->
    </script>
    <?php
    exit;
}

// get user id for detailview
$testgroupId = $_GET["testgroupId"];
// create css class
$cssClass = &new createCSS;


if($_SERVER["REQUEST_METHOD"] == "POST")
{
	$testgroupId = $_POST["testgroupId"];
	
	// put postvalues to array
	$formValues = $_POST;
	// cicle values for manual-hexa-entries
	foreach($formValues as $key => $value)
	{
		// skip index if manual-hexa-entry or valuebackup
		if (	(ereg("_MANHEX",$key)) OR (ereg("_BEFORE",$key))	)
		{
			continue;
		}
		// check if different from preselect and valid hexavalue and different from stored value
		if (	($formValues[$key."_MANHEX"] != $value) AND (isset($formValues[$key."_MANHEX"])) AND (ereg("[a-fA-F0-9]{6,6}",$formValues[$key."_MANHEX"])) AND ($formValues[$key."_MANHEX"] != $formValues[$key."_BEFORE"])	)
		{
			$formValues[$key] = $formValues[$key."_MANHEX"];
		}
		
	}
	// create update arguments
	$myArgumentsToUpdate	=	array("CSSSTYLE_FONTTYPE" => $formValues["CSSSTYLE_FONTTYPE"],
						"CSSSTYLE_FONTSIZE" => $formValues["CSSSTYLE_FONTSIZE"],
						"CSSSTYLE_FONTCOLOR" => $formValues["CSSSTYLE_FONTCOLOR"],
						"CSSSTYLE_FONTCOLORHEADER" => $formValues["CSSSTYLE_FONTCOLORHEADER"],
						"CSSSTYLE_BGFORM" => $formValues["CSSSTYLE_BGFORM"],
						"CSSSTYLE_BGHEADER" => $formValues["CSSSTYLE_BGHEADER"],
						"CSSSTYLE_BGINPUT" => $formValues["CSSSTYLE_BGINPUT"],
						"CSSSTYLE_HEADERHEIGHT" => $formValues["CSSSTYLE_HEADERHEIGHT"],
						"CSSSTYLE_FIELDWIDTH" => $formValues["CSSSTYLE_FIELDWIDTH"],
						"CSSSTYLE_AREAHEIGHT" => $formValues["CSSSTYLE_AREAHEIGHT"],
						"CSSSTYLE_LINECOLOR" => $formValues["CSSSTYLE_LINECOLOR"]
						);
	
	$cssClass->insertCssDataIntoDatabase($myArgumentsToUpdate,$testgroupId);
	$status = $cssClass->createCssFileFromDatabase($testgroupId);
	
}

// get css data
$cssData = $cssClass->getCssDataFromDatabase($testgroupId);

$tpl = new HTML_Template_IT($cfgPathToTestgroupTemplates);
$tpl->loadTemplatefile($templateTestgroupCss, true, true); // do remove untouched blocks

// set title
$tpl->setVariable( "applicationtitle", $cfgApplicationType.$cfgApplicationVersion);


$tpl->setVariable( "testgroupId", $testgroupId);
$tpl->setVariable( "formaction", $fileTestgroupCss);

// give selected defaults
foreach($cssData as $key => $value)
{	
	if(($key!="CSSSTYLE_ID_PK")AND($key!="CSSSTYLE_PROJECT_ID"))
	{
		// value for select
		$selectVariable = $key.$value;
		$tpl->setVariable($selectVariable, "selected");
		// value for input
		$tpl->setVariable($key, "$value");
	}
}


// parse template
$tpl->parse();

// get the parsed template and print it
$tpl->get();
$tpl->show();
?>
