<?php
// +----------------------------------------------------------------------+
// | survey pilot                                                         |
// +----------------------------------------------------------------------+
// | Copyright (c) 2002 serie a - Digitale Medien und Systeme GmbH        |
// +----------------------------------------------------------------------+
// | Authors: 	Daniel Peer <peer@serie-a.de>                             |
// +----------------------------------------------------------------------+
//
// $Id: testgroup.design.overview.php,v 1.1.1.1 2004/07/15 13:34:14 opensurveypilot Exp $

// start session
@session_start();

// require all configuration files and libraries
require_once("./../config/config.inc.php"); // common config file
require_once($cfgPathToConf."/file.inc.php"); // project files
require_once($cfgPathToLib."/common.inc.php"); // common functions
require_once($cfgPathToAuthFiles."/lib/user.inc.php"); // auth user functions
require_once($cfgPathToTestgroupFiles."/config/testgroup.config.inc.php"); // proband config file
require_once($cfgPathToTestgroupFiles."/config/testgroup.file.inc.php"); // proband files
require_once($cfgPathToTestgroupFiles."/lib/testgroup.inc.php"); // mask functions
require_once($cfgPathToTestgroupFiles."/lib/createcss.inc.php"); // css functions
require_once($cfgPathToTestgroupFiles."/lib/tmpl2assessment.inc.php"); // template upload functions
require_once($cfgPathToTmplFiles."/config/tmpl.file.inc.php"); // auth files
require_once("HTML/Template/IT.php"); // PEAR::HTML_TEMPLATE_IT
 
// create new userFunctions object
$client = &new userFunctions;

//login check
if ($client->getAuthentication($_SESSION["sessionId"], session_id()) ==  false)
{
    //redirect to login page
    ?>
    <script type="text/javascript">
    <!--
    window.location.href="<?php echo $cfgUrlToProject."/".$fileAuthLogin; ?>";
    -->
    </script>
    <?php
    exit;
} 

$testgroupId = $_GET["testgroupId"]; 

if (!$testgroupId)
	$testgroupId = $_POST["testgroupId"]; 

$testgroups = &new Testgroup; 

// create new surveyFunctions object
$tmplFunct = &new tmplFileCreate;

// create Template IT object
$tpl = new HTML_Template_IT($cfgPathToTestgroupTemplates);

// load template
$tpl->loadTemplatefile($templateTestgroupDesignOverview, true, true);

// set title
$tpl->setVariable( "applicationtitle", $cfgApplicationType.$cfgApplicationVersion);

$dataArray = $testgroups->getTestgroupRow ($testgroupId);

if ($dataArray[0]["CONTENTGROUP_SPLASH"]==1)
{
	$tpl->setVariable( "splashcheck", "<span style='color:#4B93B7;'> ".$lang_script["testgroup.design.overview.php"]["splashEnabled"]."</span>");
}
else
{
	$tpl->setVariable( "splashcheck", "<span style='color:red;'> ".$lang_script["testgroup.design.overview.php"]["splashDisabled"]."</span>");
}

$templateNames = $tmplFunct->getTemplateNames($testgroupId);
$contentIds = $tmplFunct->getContentId($testgroupId);

$templateNames["TMPL_TO_ASSESSMENT_SPLASH_ID"] != "" ? ($tpl->setVariable( "splashtemplate", "<strong><span style='color:#4B93B7;'>".$templateNames["TMPL_TO_ASSESSMENT_SPLASH_ID"]."</strong>")) : ($tpl->setVariable( "splashtemplate", $lang_script["testgroup.design.overview.php"]["splashTemplEnabled"]));
$templateNames["TMPL_TO_ASSESSMENT_LOGIN_ID"] != "" ? ($tpl->setVariable( "logintemplate", "<strong><span style='color:#4B93B7;'>".$templateNames["TMPL_TO_ASSESSMENT_LOGIN_ID"]."</span></strong>")) : ($tpl->setVariable( "logintemplate", $lang_script["testgroup.design.overview.php"]["loginTemplEnabled"]));
$templateNames["TMPL_TO_ASSESSMENT_OVERVIEW_ID"] != "" ? ($tpl->setVariable( "overviewtemplate", "<strong><span style='color:#4B93B7;'>".$templateNames["TMPL_TO_ASSESSMENT_OVERVIEW_ID"]."</span></strong>")) : ($tpl->setVariable( "overviewtemplate", $lang_script["testgroup.design.overview.php"]["overviewTemplEnabled"]));
$templateNames["TMPL_TO_ASSESSMENT_DEACTIVATED_ID"] != "" ? ($tpl->setVariable( "inactivetemplate", "<strong><span style='color:#4B93B7;'>".$templateNames["TMPL_TO_ASSESSMENT_DEACTIVATED_ID"]."</span></strong>")) : ($tpl->setVariable( "inactivetemplate", $lang_script["testgroup.design.overview.php"]["inactiveTemplEnabled"]));
$templateNames["TMPL_TO_ASSESSMENT_REPORTING_ID"] != "" ? ($tpl->setVariable( "messagetemplate", "<strong><span style='color:#4B93B7;'>".$templateNames["TMPL_TO_ASSESSMENT_REPORTING_ID"]."</span></strong>")) : ($tpl->setVariable( "messagetemplate", $lang_script["testgroup.design.overview.php"]["messageTemplEnabled"]));

$tpl->setVariable( "splashlink",$fileTestgroupTmpl."?category=splash&testgroupId=$testgroupId");
$tpl->setVariable( "loginlink",$fileTestgroupTmpl."?category=login&testgroupId=$testgroupId");
$tpl->setVariable( "overviewlink",$fileTestgroupTmpl."?category=overview&testgroupId=$testgroupId");
$tpl->setVariable( "messagelink",$fileTestgroupTmpl."?category=message&testgroupId=$testgroupId");
$tpl->setVariable( "inactivelink",$fileTestgroupTmpl."?category=deactivated&testgroupId=$testgroupId");

$tpl->setVariable( "splashview", $cfgUrlToProject."/".$cfgPathToTmplModule."/".$fileTmplDetailView."?module=ass&contentId=".$contentIds[0]["TMPL_TO_ASSESSMENT_SPLASH_ID"]);
$tpl->setVariable( "loginview", $cfgUrlToProject."/".$cfgPathToTmplModule."/".$fileTmplDetailView."?module=ass&contentId=".$contentIds[0]["TMPL_TO_ASSESSMENT_LOGIN_ID"]);
$tpl->setVariable( "overviewview", $cfgUrlToProject."/".$cfgPathToTmplModule."/".$fileTmplDetailView."?module=ass&contentId=".$contentIds[0]["TMPL_TO_ASSESSMENT_OVERVIEW_ID"]);
$tpl->setVariable( "messageview", $cfgUrlToProject."/".$cfgPathToTmplModule."/".$fileTmplDetailView."?module=ass&contentId=".$contentIds[0]["TMPL_TO_ASSESSMENT_REPORTING_ID"]);
$tpl->setVariable( "inactiveview", $cfgUrlToProject."/".$cfgPathToTmplModule."/".$fileTmplDetailView."?module=ass&contentId=".$contentIds[0]["TMPL_TO_ASSESSMENT_DEACTIVATED_ID"]);

$tpl->setVariable( "css_link", $fileTestgroupCss."?testgroupId=".$testgroupId );

//to get the name of this testgroup for the headline
$groupArray = $testgroups->getTestgroupRow($testgroupId);
$testgroupName = $groupArray[0]["CONTENTGROUP_NAME"];

// headline
$tpl->setCurrentBlock( "headline" );
$tpl->setVariable( "headline", $lang_script["testgroup.design.overview.php"]["dsignToPanel"]." ".$testgroupName );
$tpl->parseCurrentBlock();

// get the parsed template and print it
$tpl->get();
$tpl->show();


?>
