<?php
// +----------------------------------------------------------------------+
// | Assessment pilot                                                         |
// +----------------------------------------------------------------------+
// | Copyright (c) 2002 serie a - Digitale Medien und Systeme GmbH        |
// +----------------------------------------------------------------------+
// | Authors: 	Daniel Peer <peer@serie-a.de>                             |
// |          	                                                          |
// +----------------------------------------------------------------------+
//
// $Id: testgroup.edit.php,v 1.1.1.1 2004/07/15 13:34:15 opensurveypilot Exp $

// start session
@session_start();

// require all configuration files and libraries
require_once("./../config/config.inc.php"); // common config file
require_once($cfgPathToConf."/file.inc.php"); // project files
require_once($cfgPathToLib."/common.inc.php"); // common functions
require_once($cfgPathToTestgroupFiles."/config/testgroup.config.inc.php"); // testgroup config file
require_once($cfgPathToTestgroupFiles."/config/testgroup.file.inc.php"); // testgroup files
require_once($cfgPathToTestgroupFiles."/lib/testgroup.inc.php"); // testgroup functions
require_once($cfgPathToAuthFiles."/lib/user.inc.php"); // auth user functions
require_once($cfgPathToAuthFiles."/lib/permission.inc.php"); // permission functions
require_once("HTML/Template/IT.php"); // PEAR::HTML_TEMPLATE_IT


// create new userFunctions object
$client = &new userFunctions;

//login check
if ($client->getAuthentication($_SESSION["sessionId"], session_id()) == false)
{
    //redirect to login page
    ?>
    <script type="text/javascript">
    <!--
    window.location.href="<?php echo $cfgUrlToProject."/".$fileAuthLogin; ?>";
    -->
    </script>
    <?php
    exit;
}

// function permission check
if($_SESSION["sessionUserStatusId"] < $permRawDataDetailView)
{
    ?>
    <script type="text/javascript">
    <!--
    window.location.href="<?php echo $cfgUrlToProject."/".$fileNoPermission."?messageCode=2"; ?>";
    -->
    </script>
    <?php
    exit;
}

$tpl = new HTML_Template_IT($cfgPathToTestgroupTemplates);
$tpl->loadTemplatefile($templateTestgroupEdit, true, true); // do remove untouched blocks

$testgroups = &new Testgroup;

// get user id for detailview
$testgroupId = $_GET["testgroupId"];

if($_SERVER["REQUEST_METHOD"] == "POST")
{
	$testgroupId = $_POST["testgroupId"];
	$testgroupname = cleanHTML($_POST["testgroupname"]);
	$testgroupdescription = cleanHTML($_POST["testgroupdescription"]);
	$testgroupstatus = cleanHTML($_POST["testgroupStatus"]);
	
	if ($testgroupstatus == "yes")
	{
		$testgroupstatus = 1;
	}
	else
	{
		$testgroupstatus = 0;
	}

	if ($testgroups->updateTestgroup ($testgroupId, $testgroupname, $testgroupdescription, $testgroupstatus))
	{
		?>
   		<script type="text/javascript">
		<!--
      	opener.parent.content.location.reload();
      	-->
      	</script>
	  	<?php

	}
	else
	{
		$tpl->setVariable( "message", $testgroups->errorMessage);
	}
}

// set title
$tpl->setVariable( "applicationtitle", $cfgApplicationType.$cfgApplicationVersion);

$tpl->setVariable( "lnk_edit", $fileTestgroupEdit."?testgroupId=$testgroupId");
$tpl->setVariable( "lnk_form", $fileTestgroupFormoptions."?testgroupId=$testgroupId");

$tpl->setVariable( "testgroupId", $testgroupId);
$tpl->setVariable( "formaction", $fileTestgroupEdit);

$group = $testgroups->getTestgroupRow ($testgroupId);

$tpl->setVariable( "testgroupname", $group[0]["CONTENTGROUP_NAME"]);
$tpl->setVariable( "testgroupdescription", $group[0]["CONTENTGROUP_DESCRIPTION"]);
$tpl->setVariable( "creator", $group[0]["CONTENTGROUP_CREATOR"]);
$tpl->setVariable( "created", date('d.m.Y',$group[0]["CONTENTGROUP_CREATED"]));
$tpl->setVariable( "dir", $cfgPathToAssessmentOutput."/".$group[0]["CONTENTGROUP_OUTPUT_DIR"]);

if ($group[0]["CONTENTGROUP_ACTIVE"] == 1)
{
	$tpl->setVariable( "view", "<a href='".$cfgUrlToAssessment."/".$group[0]["CONTENTGROUP_OUTPUT_DIR"]."/"."' target='_preview' onClick='openWindow(720,560,this.href,this.target); return false;'>[ ".$lang_script["testgroup.edit.php"]["showPanel"]."</a> ]<br>[ <a href='".$cfgUrlToAssessment."/".$group[0]["CONTENTGROUP_OUTPUT_DIR"]."/"."' target='_preview' onClick='openWindow(720,560,this.href,this.target); return false;'>".$cfgUrlToAssessment."/".$group[0]["CONTENTGROUP_OUTPUT_DIR"]."/"."</a> ]");
	$tpl->setVariable( "testgroupstatusyes", "selected" );
}
else
{
	$tpl->setVariable( "view", $lang_script["testgroup.edit.php"]["panelDisabled"]);
 	$tpl->setVariable( "testgroupstatusno", "selected" );
}

// parse template
$tpl->parse();

// get the parsed template and print it
$tpl->get();
$tpl->show();
?>
