<?php
// +----------------------------------------------------------------------+
// | Assessment pilot                                                         |
// +----------------------------------------------------------------------+
// | Copyright (c) 2002 serie a - Digitale Medien und Systeme GmbH        |
// +----------------------------------------------------------------------+
// | Authors: 	Daniel Peer <peer@serie-a.de>                             |
// |          	                                                          |
// +----------------------------------------------------------------------+
//
// $Id: testgroup.formoptions.php,v 1.1.1.1 2004/07/15 13:34:15 opensurveypilot Exp $

// start session   
@session_start();

// require all configuration files and libraries
require_once("./../config/config.inc.php"); // common config file
require_once($cfgPathToConf."/file.inc.php"); // project files
require_once($cfgPathToLib."/common.inc.php"); // common functions
require_once($cfgPathToTestgroupFiles."/config/testgroup.config.inc.php"); // proband config file
require_once($cfgPathToTestgroupFiles."/config/testgroup.file.inc.php"); // proband files
require_once($cfgPathToTestgroupFiles."/lib/testgroup.inc.php"); // mask functions
require_once($cfgPathToTestgroupFiles."/lib/createcss.inc.php"); // css functions
require_once($cfgPathToTestgroupFiles."/lib/tmpl2assessment.inc.php"); // template upload functions
require_once($cfgPathToAuthFiles."/lib/user.inc.php"); // auth user functions
require_once($cfgPathToAuthFiles."/config/auth.file.inc.php"); // auth user files
require_once($cfgPathToAuthFiles."/lib/permission.inc.php"); // permission functions
require_once($cfgPathToProbFiles."/config/prob.config.inc.php"); // proband config file
require_once($cfgPathToProbFiles."/lib/mask.inc.php"); // mask functions
require_once("HTML/Template/IT.php"); // PEAR::HTML_TEMPLATE_IT


// create new userFunctions object
$client = &new userFunctions;

//login check
if ($client->getAuthentication($_SESSION["sessionId"], session_id()) == false)
{
    //redirect to login page
    ?>
    <script type="text/javascript">
    <!--
    window.location.href="<?php echo $cfgUrlToProject."/".$fileAuthLogin; ?>";
    -->
    </script>
    <?php
    exit;
}

// function permission check
if($_SESSION["sessionUserStatusId"] < $permRawDataDetailView)
{
    ?>
    <script type="text/javascript">
    <!--
    window.location.href="<?php echo $cfgUrlToProject."/".$fileNoPermission."?messageCode=2"; ?>";
    -->
    </script>
    <?php
    exit;
}

// get user id for detailview
$testgroupId = $_GET["testgroupId"];

$testgroups = &new Testgroup;

$tpl = new HTML_Template_IT($cfgPathToTestgroupTemplates);
$tpl->loadTemplatefile($templateTestgroupFormoptions, true, true); // do remove untouched blocks

if($_SERVER["REQUEST_METHOD"] == "POST")
{
	$testgroupId = $_POST["testgroupId"];
	
	$usermaskId = $_POST["usermask"];
	
	if ($_POST["splash"])
	{
		$splash = $_POST["splash"];
	}
	else
	{
		$splash = 0;
	}
	
	$optionDdata[0] = $splash;
	$optionDdata[1] = $_POST["register_headline"];
	$optionDdata[2] = $_POST["register_start"];
	$optionDdata[3] = $_POST["register_finish"];
	$optionDdata[4] = $_POST["addition_headline"];
	$optionDdata[5] = $_POST["addition_start"];
	$optionDdata[6] = $_POST["addition_finish"];
	$optionDdata[7] = $_POST["overview_headline"];
	$optionDdata[8] = $_POST["overview_text"];
	$optionDdata[9] = $_POST["login_message"];
	$optionDdata[10] = $_POST["login_register"];
	$optionDdata[11] = $_POST["splash_welcome"];
	$optionDdata[12] = $_POST["splash_message"];
	$optionDdata[13] = $_POST["deactivated_message"];
	$optionDdata[14] = $_POST["overview_match_test"];
	$optionDdata[15] = $_POST["overview_profile_edit"];
	$optionDdata[16] = $_POST["edit_data_message"];
	
	if ($testgroups->saveFormOptions($testgroupId, $optionDdata, $usermaskId))
	{
		$tpl->setVariable( "message", "<span style='color:blue'>".$lang_script["testgroup.formoptions.php"]["saveSuccess"]."</span>");
	}
	else
	{
		$tpl->setVariable( "message", $lang_script["testgroup.formoptions.php"]["saveFailed"]);
	}
}

$dataArray = $testgroups->getTestgroupRow ($testgroupId);

// set title
$tpl->setVariable( "applicationtitle", $cfgApplicationType.$cfgApplicationVersion);

$tpl->setVariable( "register_headline", $dataArray[0]["CONTENTGROUP_REG_TEXT_HEAD"]);
$tpl->setVariable( "register_start", $dataArray[0]["CONTENTGROUP_REG_TEXT_BEGIN"]);
$tpl->setVariable( "register_finish", $dataArray[0]["CONTENTGROUP_REG_TEXT_MESSAGE"]);

$tpl->setVariable( "addition_headline", $dataArray[0]["CONTENTGROUP_REG2_TEXT_HEAD"]);
$tpl->setVariable( "addition_start", $dataArray[0]["CONTENTGROUP_REG2_TEXT_BEGIN"]);
$tpl->setVariable( "addition_finish", $dataArray[0]["CONTENTGROUP_REG2_TEXT_MESSAGE"]);

$tpl->setVariable( "overview_headline", $dataArray[0]["CONTENTGROUP_OVERVIEW_HEADLINE"]);
$tpl->setVariable( "overview_text", $dataArray[0]["CONTENTGROUP_OVERVIEW_TEXT"]);

$tpl->setVariable( "splash", "1");

// new editable variables from T_AUTH_CONTENTGROUP
$tpl->setVariable( "login_message", $dataArray[0]["CONTENTGROUP_LOGIN_MSG_MESSAGE"]);
$tpl->setVariable( "login_register", $dataArray[0]["CONTENTGROUP_LOGIN_MSG_REGISTER"]);

$tpl->setVariable( "splash_welcome", $dataArray[0]["CONTENTGROUP_SPLASH_HEAD"]);
$tpl->setVariable( "splash_message", $dataArray[0]["CONTENTGROUP_SPLASH_TXT"]);

$tpl->setVariable( "deactivated_message", $dataArray[0]["CONTENTGROUP_DEACTIVATED_TXT"]);

$tpl->setVariable( "overview_match_test", $dataArray[0]["CONTENTGROUP_OVERVIEW_STATUS_1"]);
$tpl->setVariable( "overview_profile_edit", $dataArray[0]["CONTENTGROUP_OVERVIEW_STATUS_2"]);

$tpl->setVariable( "edit_data_message", $dataArray[0]["CONTENTGROUP_REG2_TEXT_EDIT"]);


if ($dataArray[0]["CONTENTGROUP_SPLASH"]==1)
{
	$tpl->setVariable( "splash_checked", "checked");
}

$tpl->setVariable( "lnk_edit", $fileTestgroupEdit."?testgroupId=$testgroupId");
$tpl->setVariable( "lnk_form", $fileTestgroupFormoptions."?testgroupId=$testgroupId");

$maskArray = getAllUsermasks();

for($i=0;$i<count($maskArray);$i++)
{
	$tpl->setCurrentBlock( "usermasklist" );
	if ($dataArray[0]["CONTENTGROUP_USERMASK_ID_FK"] == $maskArray[$i]["USERMASK_ID_PK"])
	{
		$tpl->setVariable( "usermask_selected", "selected" );
	}
	else
	{
		$tpl->setVariable( "usermask_selected", "" );
	}
	
	$tpl->setVariable( "usermask_value", $maskArray[$i]["USERMASK_ID_PK"] );
	$tpl->setVariable( "usermask_name",  $maskArray[$i]["USERMASK_NAME"] );
	$tpl->parseCurrentBlock();
}


$tpl->setVariable( "testgroupId", $testgroupId);
$tpl->setVariable( "formaction", $fileTestgroupFormoptions);

// parse template
$tpl->parse();

// get the parsed template and print it
$tpl->get();
$tpl->show();
?>

