<?php
// +----------------------------------------------------------------------+
// | survey pilot                                                         |
// +----------------------------------------------------------------------+
// | Copyright (c) 2002 serie a - Digitale Medien und Systeme GmbH        |
// +----------------------------------------------------------------------+
// | Authors: 	Daniel Peer <peer@serie-a.de>                             |
// +----------------------------------------------------------------------+
//
// $Id: testgroup.mail.overview.php,v 1.1.1.1 2004/07/15 13:34:16 opensurveypilot Exp $

// start session
@session_start();

// require all configuration files and libraries
require_once("./../config/config.inc.php"); // common config file
require_once($cfgPathToConf."/file.inc.php"); // project files
require_once($cfgPathToLib."/common.inc.php"); // common functions
require_once($cfgPathToAuthFiles."/lib/user.inc.php"); // auth user functions
require_once($cfgPathToProbFiles."/lib/prob.inc.php"); // proband functions
require_once($cfgPathToProbFiles."/lib/log.inc.php"); // proband functions
require_once($cfgPathToProbFiles."/config/prob.config.inc.php"); // proband config file
require_once($cfgPathToTestgroupFiles."/config/testgroup.config.inc.php"); // proband config file
require_once($cfgPathToTestgroupFiles."/config/testgroup.file.inc.php"); // proband files
require_once($cfgPathToTestgroupFiles."/lib/testgroup.inc.php"); // mask functions
require_once("HTML/Template/IT.php"); // PEAR::HTML_TEMPLATE_IT
 
// create new userFunctions object
$client = &new userFunctions;

//login check
if ($client->getAuthentication($_SESSION["sessionId"], session_id()) ==  false)
{
    //redirect to login page
    ?>
    <script type="text/javascript">
    <!--
    window.location.href="<?php echo $cfgUrlToProject."/".$fileAuthLogin; ?>";
    -->
    </script>
    <?php
    exit;
} 
 
$_GET[testgroupId] ?  $testgroupId=$_GET[testgroupId] :  $testgroupId=$_POST[testgroupId];

$testgroups = &new Testgroup; 
$log = &new Assessmentlog; 
$proband = &new Proband; 

$tgArray = $testgroups->getTestgroupRow($testgroupId);

$probandArray = $testgroups->get_User_of_Testgroup($testgroupId);
$content = $testgroups->get_Content_of_Testgroup($testgroupId);

for ($i=0;$i < count ($content);$i++)
{
	$contentArray[$i] = $testgroups->get_one_survey($content[$i]);
}

for ($i=0;$i < count ($probandArray);$i++)
{
	$probandArray[$i][LAST_LOG] = $log->getLastLogin ($probandArray[$i][USERDATA_ID_PK], 0);
	$userdataArray = $proband->getProbandUserRow($probandArray[$i][USERDATA_ID_PK]);
	$probandArray[$i][EMAIL] = $userdataArray[0][USERDATA_EMAIL];
	$probandArray[$i][GROUP_IDS] = $proband->get_Groups_of_Proband($probandArray[$i][USERDATA_ID_PK]);
	
	for ($a=0;$a < count ($probandArray[$i][GROUP_IDS]);$a++)
	{
		$tmpArray = $proband->getProbandGroupRow($probandArray[$i][GROUP_IDS][$a]);
		$probandArray[$i][GROUP_NAMES][$a] = $tmpArray[0][GROUPS_NAME];
	}
	
	sort ($probandArray[$i][GROUP_NAMES]);	
	reset ($probandArray[$i][GROUP_NAMES]);
	
	for ($e=0;$e < count ($contentArray);$e++)
	{
		$status[$e] = $contentArray[$e][0][PROJECT_NAME]." - ";
		$status[$e] .=  $log->getStatusUserTest ($probandArray[$i][USERDATA_ID_PK], $testgroupId, $contentArray[$e][0][PROJECT_ID_PK], 0);
		
		$probandArray[$i][STATUS][$e] = $log->getStatusUserTestID ($probandArray[$i][USERDATA_ID_PK], $testgroupId, $contentArray[$e][0][PROJECT_ID_PK], 0);
	}
	
	$probandArray[$i][STATUS_STRING] = @implode("<br>", $status);
	
	if ( @in_array (2, $probandArray[$i][STATUS]) && !(@in_array (0, $probandArray[$i][STATUS])|| @in_array (1, $probandArray[$i][STATUS])) )
	{
		$probandArray[$i][STATUS_COMPLETE] = $lang_script["testgroup.mail.overview.php"]["panelCompleted"];
	}
	elseif ( @in_array (0, $probandArray[$i][STATUS]) && !(@in_array (2, $probandArray[$i][STATUS])|| @in_array (1, $probandArray[$i][STATUS])) )
	{
		$probandArray[$i][STATUS_COMPLETE] = $lang_script["testgroup.mail.overview.php"]["panelNotStarted"];
	}
	else 
	{
		$probandArray[$i][STATUS_COMPLETE] = $lang_script["testgroup.mail.overview.php"]["panelPending"];
	}
	
}

$tg_mailuser_all = array();
$tg_mailuser_panel = array();
$tg_mailuser_complete = array();
$tg_mailuser_notcomplete = array();


for($j=0;$j<count($probandArray);$j++)
{   
	if ($probandArray[$j]["STATUS_COMPLETE"] == $lang_script["testgroup.mail.overview.php"]["panelPending"])
	{
		array_push ($tg_mailuser_panel, $probandArray[$j]);
		array_push ($tg_mailuser_notcomplete, $probandArray[$j]);
    }
	
	if ($probandArray[$j]["STATUS_COMPLETE"] == $lang_script["testgroup.mail.overview.php"]["panelNotStarted"])
	{
		array_push ($tg_mailuser_panel, $probandArray[$j]);
		array_push ($tg_mailuser_notcomplete, $probandArray[$j]);
    }
	
	if ($probandArray[$j]["STATUS_COMPLETE"] == $lang_script["testgroup.mail.overview.php"]["panelCompleted"])
	{
		array_push ($tg_mailuser_panel, $probandArray[$j]);
		array_push ($tg_mailuser_complete, $probandArray[$j]);
    }
}


$allArray = $proband->getAllProbandsForMailfunction();

for ($i=0;$i < count ($allArray);$i++)
{
	$allArray[$i][LAST_LOG] = $log->getLastLogin ($allArray[$i][USERDATA_ID_PK], 0);
	$userdataArray = $proband->getProbandUserRow($allArray[$i][USERDATA_ID_PK]);
	$allArray[$i][EMAIL] = $userdataArray[0][USERDATA_EMAIL];
	$allArray[$i][GROUP_IDS] = $proband->get_Groups_of_Proband($allArray[$i][USERDATA_ID_PK]);
	
	for ($a=0;$a < count ($allArray[$i][GROUP_IDS]);$a++)
	{
		$tmpArray = $proband->getProbandGroupRow($allArray[$i][GROUP_IDS][$a]);
		$allArray[$i][GROUP_NAMES][$a] = $tmpArray[0][GROUPS_NAME];
	}
	
	//sort ($allArray[$i][GROUP_NAMES]);	
	//reset ($allArray[$i][GROUP_NAMES]);
	
	$allArray[$i][STATUS][0] = "not looked up";
	
	$allArray[$i][STATUS_STRING] = $allArray[$i][STATUS][0];
	
	$allArray[$i][STATUS_COMPLETE] = "not looked up";
	
	array_push ($tg_mailuser_all, $allArray[$i]);
}

$_SESSION ["tg_mailuser_all"] = $tg_mailuser_all;
$_SESSION ["tg_mailuser_panel"] = $tg_mailuser_panel;
$_SESSION ["tg_mailuser_complete"] = $tg_mailuser_complete;
$_SESSION ["tg_mailuser_notcomplete"] = $tg_mailuser_notcomplete;

//echo "<pre>";
//print_r($_SESSION);
//echo "</pre>";

// create Template IT object
$tpl = new HTML_Template_IT($cfgPathToTestgroupTemplates);

// load template
$tpl->loadTemplatefile($templateTestgroupMailOverview, true, true);

if($_SERVER["REQUEST_METHOD"] == "POST")
{
	if ($_POST["absenden"])
	{
		// load template
		$tpl->loadTemplatefile($templateTestgroupMailSent, true, true);
		
		switch ($_POST['selectAction'])
		{
			case 1:
						$filter = $lang_script["testgroup.mail.overview.php"]["mail2userNotComplete"];
						break;
			case 2:
						$filter = $lang_script["testgroup.mail.overview.php"]["mail2userComplete"];
						break;
			case 3:
						$filter = $lang_script["testgroup.mail.overview.php"]["mail2userPanel"];
						break;
			case 4:
						$filter = $lang_script["testgroup.mail.overview.php"]["mail2userAll"];
						break;
		}
		
		$tpl->setVariable( "subject", $_POST[subject] );
		$tpl->setVariable( "text", nl2br ($_POST[mailtext]) );
		$tpl->setVariable( "recipients", $_GET[recipients] );
		$tpl->setVariable( "filter", $filter );
		
		$body = $_POST[mailtext];
		
		if ($_POST[link])
		{
			$body="\n\nLink: ".$_POST[link]."\n\n".$body;
		}
		
		include('Mail.php');
		$recipients = explode (",", $_GET[recipients]);
		$recipients_separated = implode("; ", $recipients);	
		
		$headers['From']    = $_SESSION[sessionUserLogin];
		$headers['Subject'] = $_POST[subject];

		// Create the mail object using the Mail::factory method
		$mail_object =& Mail::factory($globalCfgMailBackend, $params);
		$valid = $mail_object->send($recipients, $headers, $body);
		
		if (is_object($valid))
		{
			$tpl->setVariable( "status", $lang_script["testgroup.mail.overview.php"]["sendStatusFailed"]." ".implode(",",$valid) );
		}
		else
		{
			$tpl->setVariable( "status", $lang_script["testgroup.mail.overview.php"]["sendStatusSuccess"] );			
			$log->log_sended_mail ($_SESSION[sessionUserLogin], $testgroupId, $_POST[subject], $body, $recipients);
		}
		
	}
	elseif ($_POST["selectAction"]==1)
	{
		$tpl->setVariable( "selected1", "selected" );
		
		$jsarray = "var marked = new Array(";
		
		for ($i=0; $i<count ($tg_mailuser_notcomplete); $i++)
		{
			if ($i < 1)
			{
				$jsarray .= "'".$tg_mailuser_notcomplete[$i][EMAIL]."'";
			}
			else
			{
				$jsarray .= ", '".$tg_mailuser_notcomplete[$i][EMAIL]."'";
			}
		}
		
		$jsarray .= ");";
		
		$tpl->setVariable( "jsarray", $jsarray );
	}	
	elseif ($_POST["selectAction"]==2) 
	{
		$tpl->setVariable( "selected2", "selected" );
		
		$jsarray = "var marked = new Array(";
		
		for ($i=0; $i<count ($tg_mailuser_complete); $i++)
		{
			if ($i < 1)
			{
				$jsarray .= "'".$tg_mailuser_complete[$i][EMAIL]."'";
			}
			else
			{
				$jsarray .= ", '".$tg_mailuser_complete[$i][EMAIL]."'";
			}
		}
		
		$jsarray .= ");";
		
		$tpl->setVariable( "jsarray", $jsarray );
	}
	elseif ($_POST["selectAction"]==3) 
	{
		$tpl->setVariable( "selected3", "selected" );
		
		$jsarray = "var marked = new Array(";
		
		for ($i=0; $i<count ($tg_mailuser_panel); $i++)
		{
			if ($i < 1)
			{
				$jsarray .= "'".$tg_mailuser_panel[$i][EMAIL]."'";
			}
			else
			{
				$jsarray .= ", '".$tg_mailuser_panel[$i][EMAIL]."'";
			}
		}
		
		$jsarray .= ");";
		
		$tpl->setVariable( "jsarray", $jsarray );
	}
	elseif ($_POST["selectAction"]==4) 
	{
		$tpl->setVariable( "selected4", "selected" );
		
		$jsarray = "var marked = new Array(";
		
		for ($i=0; $i<count ($tg_mailuser_all); $i++)
		{
			if ($i < 1)
			{
				$jsarray .= "'".$tg_mailuser_all[$i][EMAIL]."'";
			}
			else
			{
				$jsarray .= ", '".$tg_mailuser_all[$i][EMAIL]."'";
			}
		}
		
		$jsarray .= ");";
		
		$tpl->setVariable( "jsarray", $jsarray );
	}
	
}

if($_SERVER["REQUEST_METHOD"] == "GET")
{
		$tpl->setVariable( "selected3", "selected" );
		
		$jsarray = "var marked = new Array(";
		
		for ($i=0; $i<count ($tg_mailuser_panel); $i++)
		{
			if ($i < 1)
			{
				$jsarray .= "'".$tg_mailuser_panel[$i][EMAIL]."'";
			}
			else
			{
				$jsarray .= ", '".$tg_mailuser_panel[$i][EMAIL]."'";
			}
		}
		
		$jsarray .= ");";
		
		$tpl->setVariable( "jsarray", $jsarray );
}

// set title
$tpl->setVariable( "applicationtitle", $cfgApplicationType.$cfgApplicationVersion);

$tpl->setVariable( "formaction", $fileTestgroupMailOverview);

$tpl->setVariable( "backlink", $fileTestgroupMailOverview."?testgroupId=".$testgroupId);

$tpl->setVariable( "framesrc", $fileTestgroupMailRecipientOverview);

$panelName = $tgArray[0][CONTENTGROUP_NAME];
$tpl->setVariable( "panelname", $panelName);

$group = $testgroups->getTestgroupRow ($testgroupId);
$tpl->setVariable( "link", $cfgUrlToAssessment."/".$group[0]["CONTENTGROUP_OUTPUT_DIR"]."/");
$tpl->setVariable( "linkoption", $lang_script["testgroup.mail.overview.php"]["attachPanelLinkToMail"]." (<a href='".$cfgUrlToAssessment."/".$group[0]["CONTENTGROUP_OUTPUT_DIR"]."/"."' target='_preview' onClick='openWindow(720,560,this.href,this.target); return false;'>".$cfgUrlToAssessment."/".$group[0]["CONTENTGROUP_OUTPUT_DIR"]."/"."</a>)"); //  $lang_script["testgroup.mail.overview.php"]["link"]

$tpl->setVariable( "testgroupId",  $testgroupId);

$historyArray = $log->getMails($testgroupId);

for ($i=0;$i < count ($historyArray); $i++)
{
	$tpl->setCurrentBlock( "HISTORY" );
	$tpl->setVariable( "history_subject", $historyArray[$i][TESTGROUP_SUBJECT]);
	$tpl->setVariable( "history_sender", $historyArray[$i][TESTGROUP_SENDER]);
	$tpl->setVariable( "history_body", $historyArray[$i][TESTGROUP_BODY]);
	$tpl->setVariable( "history_date", $historyArray[$i][TESTGROUP_SENDED_DATE]);
	$tpl->setVariable( "history_recipients", implode(",<br>", $historyArray[$i][RECIPIENTS]));
    $tpl->parseCurrentBlock();	
}


// headline
$tpl->setCurrentBlock( "headline" );
$tpl->setVariable( "headline", $lang_script["testgroup.mail.overview.php"]["MailModul"]." ".$panelName );
$tpl->parseCurrentBlock();

// get the parsed template and print it
$tpl->get();
$tpl->show();


?>
