<?php
// +----------------------------------------------------------------------+
// | opensurveypilot                                                      |
// +----------------------------------------------------------------------+
// | Copyright (c) 2002 serie a - Digitale Medien und Systeme GmbH        |
// +----------------------------------------------------------------------+
// | Authors: 	Daniel Peer <peer@serie-a.de>                             |
// |          	                                                          |
// +----------------------------------------------------------------------+
//
// $Id: testgroup.members.php,v 1.1.1.1 2004/07/15 13:34:18 opensurveypilot Exp $

// start session
@session_start();

// require all configuration files and libraries
require_once("./../config/config.inc.php"); // common config file
require_once($cfgPathToConf."/file.inc.php"); // project files
require_once($cfgPathToLib."/common.inc.php"); // common functions
require_once($cfgPathToTestgroupFiles."/config/testgroup.config.inc.php"); // testgroup config file
require_once($cfgPathToTestgroupFiles."/config/testgroup.file.inc.php"); // testgroup files
require_once($cfgPathToTestgroupFiles."/lib/testgroup.inc.php"); // testgroup functions
require_once($cfgPathToAuthFiles."/lib/user.inc.php"); // auth user functions
require_once($cfgPathToAuthFiles."/lib/permission.inc.php"); // permission functions
require_once($cfgPathToProbFiles."/lib/prob.inc.php"); // proband functions
require_once("HTML/Template/IT.php"); // PEAR::HTML_TEMPLATE_IT


// create new userFunctions object
$client = &new userFunctions;

//login check
if ($client->getAuthentication($_SESSION["sessionId"], session_id()) == false)
{
    //redirect to login page
    ?>
    <script type="text/javascript">
    <!--
    window.location.href="<?php echo $cfgUrlToProject."/".$fileAuthLogin; ?>";
    -->
    </script>
    <?php
    exit;
}

// function permission check
if($_SESSION["sessionUserStatusId"] < $permRawDataDetailView)
{
    ?>
    <script type="text/javascript">
    <!--
    window.location.href="<?php echo $cfgUrlToProject."/".$fileNoPermission."?messageCode=2"; ?>";
    -->
    </script>
    <?php
    exit;
}

$tpl = new HTML_Template_IT($cfgPathToTestgroupTemplates);
$tpl->loadTemplatefile($templateTestgroupMembers, true, true); // do remove untouched blocks

$testgroups = &new Testgroup;
$myPerson = &new Proband;

// get user id for detailview
$testgroupId = $_GET["testgroupId"];

$usergroupArray = $myPerson->getProbandGroups ($actualNum = 0, 10000, "GROUPS_NAME", "ASC");


// set title
$tpl->setVariable( "applicationtitle", $cfgApplicationType.$cfgApplicationVersion);

$tpl->setVariable( "lnk_usergroup", $fileTestgroupToUsergroup."?testgroupId=$testgroupId");
$tpl->setVariable( "lnk_members", $fileTestgroupMembers."?testgroupId=$testgroupId");

// $tpl->setVariable( "status", $lang_script["testgroup.members.php"]["status"]);

$insertedUsergroups = $testgroups->get_Usergroups_of_Testgroup ($testgroupId);

//to get the name of this testgroup for panelname
$groupArray = $testgroups->getTestgroupRow($testgroupId);
$testgroupName = $groupArray[0]["CONTENTGROUP_NAME"];
$tpl->setVariable( "panelname", $testgroupName );


$tpl->setVariable( "testgroupId", $testgroupId);

for ($i=0;$i<count($usergroupArray);$i++)
{
	if (is_array($insertedUsergroups))
	{
		if (in_array($usergroupArray[$i]["GROUPS_ID_PK"],$insertedUsergroups))
		{
			$userIdArray = $myPerson->get_Probands_of_Group($usergroupArray[$i]["GROUPS_ID_PK"]);
			if (!empty($userIdArray))
			{
				for ($i=0; $i < count($userIdArray); $i++)
				{
					$userDataArray = $myPerson->getProbandUserRow($userIdArray[$i]);
					$tpl->setCurrentBlock("MEMBERS") ;
					$tpl->setVariable( "member_name", $userDataArray[0]["USERDATA_NNAME"].", ".$userDataArray[0]["USERDATA_VNAME"]);
					$tpl->parseCurrentBlock("MEMBERS");
				}
			}
		}
	}
}

// parse template
$tpl->parse();

// get the parsed template and print it
$tpl->get();
$tpl->show();
?>
