<?php
// +----------------------------------------------------------------------+
// | survey pilot                                                         |
// +----------------------------------------------------------------------+
// | Copyright (c) 2002 serie a - Digitale Medien und Systeme GmbH        |
// +----------------------------------------------------------------------+
// | Authors: 	Daniel Peer <peer@serie-a.de>                             |
// +----------------------------------------------------------------------+
//
// $Id: testgroup.overview.php,v 1.1.1.1 2004/07/15 13:34:18 opensurveypilot Exp $

// start session
@session_start();

// require all configuration files and libraries
require_once("./../config/config.inc.php"); // common config file
require_once($cfgPathToConf."/file.inc.php"); // project files
require_once($cfgPathToLib."/common.inc.php"); // common functions
require_once($cfgPathToAuthFiles."/lib/user.inc.php"); // auth user functions
require_once($cfgPathToTestgroupFiles."/config/testgroup.config.inc.php"); // proband config file
require_once($cfgPathToTestgroupFiles."/config/testgroup.file.inc.php"); // proband files
require_once($cfgPathToTestgroupFiles."/lib/testgroup.inc.php"); // mask functions
require_once("HTML/Template/IT.php"); // PEAR::HTML_TEMPLATE_IT
 
// create new userFunctions object
$client = &new userFunctions;

//login check
if ($client->getAuthentication($_SESSION["sessionId"], session_id()) ==  false)
{
    //redirect to login page
    ?>
    <script type="text/javascript">
    <!--
    window.location.href="<?php echo $cfgUrlToProject."/".$fileAuthLogin; ?>";
    -->
    </script>
    <?php
    exit;
} 
 
$testgroups = &new Testgroup; 

if($_SERVER["REQUEST_METHOD"] == "POST")
{
	$testgroupIdArray=$_POST[testgroupId];

	if ($_POST["selectAction"]==1)
	{
		for ($i=0;$i<count($testgroupIdArray);$i++)
		{
			$valid = $testgroups->deleteTestgroup ($testgroupIdArray[$i]);
			
			if (is_object($valid))
			{
				print_r ($valid);
			}
			else
			{
				?>
			    <script type="text/javascript">
			    <!--
			    parent.projecttree.location.reload();
			    window.location.href="<?=$fileTestgroupOverview?>";
			    -->
			    </script>
			    <?php
			}
		}
	}
	
	if ($_POST["selectAction"]==2) //aktivieren
	{
		$valid = $testgroups->setActive ($testgroupIdArray);
		
		if (is_object($valid))
		{
			print_r ($valid);
		}
	}
	
	if ($_POST["selectAction"]==3) //deaktivieren
	{
			$valid = $testgroups->setDeactive ($testgroupIdArray);
			
			if (is_object($valid))
			{
				print_r ($valid);
			}
	}
}

// create Template IT object
$tpl = new HTML_Template_IT($cfgPathToTestgroupTemplates);

// load template
$tpl->loadTemplatefile($templateTestgroupOverview, true, true);

// set title
$tpl->setVariable( "applicationtitle", $cfgApplicationType.$cfgApplicationVersion);

$tpl->setVariable( "formaction", $fileTestgroupOverview);

// get actual num as get variable
if(isset($_GET["actualNum"]))
{
    $actualNum = $_GET["actualNum"];
}
// get orderBy as get variable
if(isset($_GET["orderBy"]))
{
    $orderBy = $_GET["orderBy"];
}
else
{
    $orderBy = "CONTENTGROUP_NAME";
}
// get direction as get variable
if(isset($_GET["direction"]))
{
    $direction = $_GET["direction"];
}

// maximum rows
$maxRow = $cfgMaxRowInOverviews;
//total rows   

$totalNum =  $testgroups->getTestgroupNum(); 

// actual rows
if (!isset($actualNum))
{
    $actualNum = 0;
}
// get the Number of pages
$numPages = intval($totalNum/$maxRow);
if ($numPages < ($totalNum/$maxRow))
{ 
    $numPages++;
}

// prev button
if ($actualNum > 0) 
{
    $y = $actualNum - $maxRow;
    
    $tpl->setVariable( "prev_button", "<a class=\"navigation\" href=\"$fileTestgroupOverview?actualNum=$y&orderBy=$orderBy&direction=$direction\">&laquo;</a>" );
}
// display pages
for ($i = 1; $i <= $numPages; $i++)
{
    $y = ($i * $maxRow) - $maxRow;
    
    $tpl->setCurrentBlock( "num_buttons" );
    $tpl->setVariable( "num_button", "[<a class=\"navigation\" href=\"$fileTestgroupOverview?actualNum=$y&orderBy=$orderBy&direction=$direction\">$i</a>]" );
    $tpl->parseCurrentBlock();
}
//  next button
if ($actualNum < ($totalNum - $maxRow)) 
{
    $y = $actualNum  + $maxRow;
    
    $tpl->setVariable( "next_button", "<a class=\"navigation\" href=\"$fileTestgroupOverview?actualNum=$y&orderBy=$orderBy&direction=$direction\">&raquo;</a>" );
}

if(($actualNum + $maxRow) < $totalNum)
{
    $entryTo = $actualNum + $maxRow;
}
else
{
    $entryTo = $totalNum;
    
}

// entry from
$entryFrom = $entryTo < 1 ? "0" : $actualNum +1;

$tpl->setVariable( "entry_from", $entryFrom );
$tpl->setVariable( "entry_to", $entryTo );
$tpl->setVariable( "entry_total", $totalNum );

// get questions
$testgroupArray = $testgroups->getTestgroupsForOverview($actualNum, $maxRow, $orderBy, $direction);
if($testgroups->errorMessage)
{
    echo $testgroups->errorMessage;
}

//eine reihe

for($j=0;$j<count($testgroupArray);$j++)
{   
    $tpl->setCurrentBlock( "Groups_overview" );

	if ($testgroupArray[$j]["CONTENTGROUP_ACTIVE"]==1)
	{
		$tpl->setVariable( "active", $lang_script["testgroup.overview.php"]["enabled"] );
	}
	elseif ($testgroupArray[$j]["CONTENTGROUP_ACTIVE"]==0)
	{
		$tpl->setVariable( "active", $lang_script["testgroup.overview.php"]["disabled"] );
	}
	
	$tpl->setVariable( "id", $testgroupArray[$j]["CONTENTGROUP_ID_PK"] );
	$tpl->setVariable( "testgroupId", $testgroupArray[$j]["CONTENTGROUP_ID_PK"] );
	$tpl->setVariable( "name", $testgroupArray[$j]["CONTENTGROUP_NAME"]);
	$tpl->setVariable( "creator", $testgroupArray[$j]["CONTENTGROUP_CREATOR"]);
	$tpl->setVariable( "created", $testgroupArray[$j]["CONTENTGROUP_CREATED"]);
	
	
    $tpl->setVariable( "edit_link", $fileTestgroupEdit."?testgroupId=".$testgroupArray[$j]["CONTENTGROUP_ID_PK"] );
   
    $tpl->parseCurrentBlock();	
}

// ende eine reihe


// headline
$tpl->setCurrentBlock( "headline" );
$tpl->setVariable( "headline", $lang_script["testgroup.overview.php"]["PanelOverview"] );
$tpl->parseCurrentBlock();

// get the parsed template and print it
$tpl->get();
$tpl->show();


?>
