<?php
// +----------------------------------------------------------------------+
// | Assessment pilot                                                         |
// +----------------------------------------------------------------------+
// | Copyright (c) 2002 serie a - Digitale Medien und Systeme GmbH        |
// +----------------------------------------------------------------------+
// | Authors: 	Daniel Peer <peer@serie-a.de>                             |
// |          	                                                          |
// +----------------------------------------------------------------------+
//
// $Id: testgroup.tmpl.php,v 1.1.1.1 2004/07/15 13:34:18 opensurveypilot Exp $

// start session
@session_start();

// require all configuration files and libraries
require_once("./../config/config.inc.php"); // common config file
require_once($cfgPathToConf."/file.inc.php"); // project files
require_once($cfgPathToLib."/common.inc.php"); // common functions
require_once($cfgPathToAuthFiles."/lib/user.inc.php"); // auth user functions
require_once($cfgPathToAuthFiles."/config/auth.file.inc.php"); // auth user files
require_once($cfgPathToAuthFiles."/lib/permission.inc.php"); // permission functions
require_once($cfgPathToTestgroupFiles."/config/testgroup.config.inc.php"); // proband config file
require_once($cfgPathToTestgroupFiles."/config/testgroup.file.inc.php"); // proband files
require_once($cfgPathToTestgroupFiles."/lib/testgroup.inc.php"); // mask functions
require_once($cfgPathToTestgroupFiles."/lib/createcss.inc.php"); // css functions
require_once($cfgPathToTestgroupFiles."/lib/tmpl2assessment.inc.php"); // template upload functions
require_once($cfgPathToTmplFiles."/config/tmpl.file.inc.php"); // auth files
require_once("HTML/Template/IT.php"); // PEAR::HTML_TEMPLATE_IT


// create new userFunctions object
$client = &new userFunctions;

//login check
if ($client->getAuthentication($_SESSION["sessionId"], session_id()) == false)
{
    //redirect to login page
    ?>
    <script type="text/javascript">
    <!--
    window.location.href="<?php echo $cfgUrlToProject."/".$fileAuthLogin; ?>";
    -->
    </script>
    <?php
    exit;
}

// function permission check
if($_SESSION["sessionUserStatusId"] < $permRawDataDetailView)
{
    ?>
    <script type="text/javascript">
    <!--
    window.location.href="<?php echo $cfgUrlToProject."/".$fileNoPermission."?messageCode=2"; ?>";
    -->
    </script>
    <?php
    exit;
}

// get user id for detailview
$testgroupId = $_GET["testgroupId"];

$category = $_GET["category"];

switch ($category)
{
	case "splash":
				$templatename = $lang_script["testgroup.tmpl.php"]["splashTmpl"];
				break;
				
	case "login":
				$templatename = $lang_script["testgroup.tmpl.php"]["loginTmpl"];
				break;
				
	case "overview":
				$templatename = $lang_script["testgroup.tmpl.php"]["overviewTmpl"];
				break;
				
	case "message":
				$templatename = $lang_script["testgroup.tmpl.php"]["messageTmpl"];
				break;
				
	case "deactivated":
				$templatename = $lang_script["testgroup.tmpl.php"]["deactivatedTmpl"];
				break;
}

// create new surveyFunctions object
$tmplFunct = &new tmplFileCreate;

$testgroups = &new Testgroup; 

$tpl = new HTML_Template_IT($cfgPathToTestgroupTemplates);
$tpl->loadTemplatefile($templateTestgroupTmpl, true, true); // do remove untouched blocks

if($_SERVER["REQUEST_METHOD"] == "POST")
{
	//checkfor projectId
	if(!$testgroupId = $_POST["testgroupId"])
	{
		$tmplFunct->setErrorMessage($lang_script["testgroup.tmpl.php"]["paramError"]."<br>".$lang_script["testgroup.tmpl.php"]["checkEntry"]);
	}
	// check action
	$type = $_POST["category"];
	//get/check post variables
	if(!$tmplPath = $_POST["path"])
	{
		$tmplFunct->setErrorMessage($lang_script["testgroup.tmpl.php"]["noTmplPathSelected"]."<br>".$lang_script["testgroup.tmpl.php"]["checkEntry"]);
	}
	elseif(!$type)
	{
		$tmplFunct->setErrorMessage($lang_script["testgroup.tmpl.php"]["paramError"]."<br>".$lang_script["testgroup.tmpl.php"]["checkEntry"]);
	}
	elseif(!$fileId = $_POST["file"])
	{
		$tmplFunct->setErrorMessage($lang_script["testgroup.tmpl.php"]["noFileSelected"]."<br>".$lang_script["testgroup.tmpl.php"]["checkEntry"]);
	}
	// save file
	else
	{
		if($tmplFunct->saveFileforProject($testgroupId, $type, $tmplPath, $fileId))
		{
			$tpl->setVariable( "message", "<span style='color:blue'>".$lang_script["testgroup.tmpl.php"]["saveSuccess"]."</span>");
			?>
	        <script type="text/javascript">
	        <!--
	        window.location.href="<?php echo $cfgUrlToProject."/".$fileInsertSuccessMessage; ?>";
	        -->
	        </script>
	        <?php
		}
		else
		{
			$tpl->setVariable( "message", $tmplFunct->errorMessage);
		}
	}
}

// set template names
$templateNames = $tmplFunct->getTemplateNames($testgroupId);


// create javascript array 
$javascriptArray = "var questions = new Array(\n";

$categoryArray = $tmplFunct->getAllTemplatePathes();





//
if(is_array($categoryArray))
{
	$categoryArraySize = count($categoryArray);
	for($i=0;$i<count($categoryArray);$i++)
	{
	    $maxRow = $tmplFunct->getContentNum($categoryArray[$i]["catId"]);
		$contentArray = $tmplFunct->getContentForOverview($categoryArray[$i]["catId"], $actualNum = 0, $maxRow, "CONTENT_NAME", "ASC");

		$javascriptArray .= "new Array(\n";

        $contentArraySize = count($contentArray);
        if(is_array($contentArray))
        {
            for($k=0;$k<count($contentArray);$k++)
            {
                $javascriptArray .= "new Array(\"".addslashes($contentArray[$k]["CONTENT_NAME"])."\", ".$contentArray[$k]["CONTENT_ID_PK"].")";
                if($k+1 < $contentArraySize)
                {
                    $javascriptArray .= ", \n";
                }
            }
            $javascriptArray .= ")\n";
        }
        else
        {
            $javascriptArray .= "null";
			$javascriptArray .= ")";
        }
	    if($i+1 < $categoryArraySize)
	    {
	        $javascriptArray .= ", \n";
	    }
	}
}
else
{
    $javascriptArray .= "null";
}
$javascriptArray .= ")";

// set title
$tpl->setVariable( "applicationtitle", $cfgApplicationType.$cfgApplicationVersion);

$tpl->setVariable( "templatename",$templatename);

// check for errors
if($tmplFunct->errorMessage)
{
	$tpl->setVariable( "message", $tmplFunct->errorMessage);
}

$tpl->setVariable( "formaction", $fileProbMaskTmpl);

// set javascriptarray
$tpl->setVariable( "questionarray", $javascriptArray);
// set pathes
$categoryArray = $tmplFunct->getAllTemplatePathes();
for($i=0;$i<count($categoryArray);$i++)
{
	$tpl->setCurrentBlock( "categories" );
	$tpl->setVariable( "categoryvalue", $categoryArray[$i]["catPath"] );
	$tpl->setVariable( "categorypath",  $categoryArray[$i]["catPath"] );
	$tpl->parseCurrentBlock();
}

$tpl->setVariable( "testgroupId", $testgroupId );
$tpl->setVariable( "category", $category );

// parse template
$tpl->parse();

// get the parsed template and print it
$tpl->get();
$tpl->show();
?>
