<?php
// +----------------------------------------------------------------------+
// | Assessment pilot                                                         |
// +----------------------------------------------------------------------+
// | Copyright (c) 2002 serie a - Digitale Medien und Systeme GmbH        |
// +----------------------------------------------------------------------+
// | Authors: 	Daniel Peer <peer@serie-a.de>                             |
// |          	                                                          |
// +----------------------------------------------------------------------+
//
// $Id: testgroup.tocontent.php,v 1.1.1.1 2004/07/15 13:34:18 opensurveypilot Exp $

// start session
@session_start();

// require all configuration files and libraries
require_once("./../config/config.inc.php"); // common config file
require_once($cfgPathToConf."/file.inc.php"); // project files
require_once($cfgPathToLib."/common.inc.php"); // common functions
require_once($cfgPathToTestgroupFiles."/config/testgroup.config.inc.php"); // testgroup config file
require_once($cfgPathToTestgroupFiles."/config/testgroup.file.inc.php"); // testgroup files
require_once($cfgPathToTestgroupFiles."/lib/testgroup.inc.php"); // testgroup functions
require_once($cfgPathToAuthFiles."/lib/user.inc.php"); // auth user functions
require_once($cfgPathToAuthFiles."/lib/permission.inc.php"); // permission functions
require_once("HTML/Template/IT.php"); // PEAR::HTML_TEMPLATE_IT


// create new userFunctions object
$client = &new userFunctions;

//login check
if ($client->getAuthentication($_SESSION["sessionId"], session_id()) == false)
{
    //redirect to login page
    ?>
    <script type="text/javascript">
    <!--
    window.location.href="<?php echo $cfgUrlToProject."/".$fileAuthLogin; ?>";
    -->
    </script>
    <?php
    exit;
}

// function permission check
if($_SESSION["sessionUserStatusId"] < $permRawDataDetailView)
{
    ?>
    <script type="text/javascript">
    <!--
    window.location.href="<?php echo $cfgUrlToProject."/".$fileNoPermission."?messageCode=2"; ?>";
    -->
    </script>
    <?php
    exit;
}

$tpl = new HTML_Template_IT($cfgPathToTestgroupTemplates);
$tpl->loadTemplatefile($templateTestgroupToContent, true, true); // do remove untouched blocks

$testgroups = &new Testgroup;

// get user id for detailview
$testgroupId = $_GET["testgroupId"];

if($_SERVER["REQUEST_METHOD"] == "POST")
{
	$testArray = $_POST["tests"];
	$testgroupId = $_POST["testgroupId"];

	if (is_array($testArray))
	{
		if ($testgroups->Content_to_Testgroup ($testgroupId, $testArray))
		{
			?>
	        <script type="text/javascript">
	        <!--
	        window.location.href="<?php echo $cfgUrlToProject."/".$fileInsertSuccessMessage; ?>";
	        -->
	        </script>
	        <?php
			exit;
		}
		else
		{
			$tpl->setVariable( "message", $testgroups->errorMessage);
		}
	}
	elseif (!$testArray)
	{
		if ($testgroups->Delete_all_Content_to_Testgroup ($testgroupId))
		{
			?>
	        <script type="text/javascript">
	        <!--
	        window.location.href="<?php echo $cfgUrlToProject."/".$fileInsertSuccessMessage; ?>";
	        -->
	        </script>
	        <?php
			
		}
		else
		{
			$tpl->setVariable( "message", $testgroups->errorMessage);
		}
	}
	else
	{
		$tpl->setVariable( "message", $lang_script["testgroup.tocontent.php"]["notSavedSelectATest"] );
	}
}

// set title
$tpl->setVariable( "applicationtitle", $cfgApplicationType.$cfgApplicationVersion);

$tpl->setVariable( "lnk_edit", $fileTestgroupEdit."?testgroupId=$testgroupId");
$tpl->setVariable( "lnk_usergroup", $fileTestgroupToUsergroup."?testgroupId=$testgroupId");
$tpl->setVariable( "lnk_content", $fileTestgroupToContent."?testgroupId=$testgroupId");

$tpl->setVariable( "testgroupId", $testgroupId);
$tpl->setVariable( "formaction", $fileTestgroupToContent);


$surveyArray = $testgroups->get_all_surveys(1);

$insertedSurveys = $testgroups->get_Content_of_Testgroup ($testgroupId);

for ($i=0;$i<count($surveyArray);$i++)
{
	if (is_array($insertedSurveys))
	{
		if (in_array($surveyArray[$i]["PROJECT_ID_PK"],$insertedSurveys))
		{
			$selected="selected";
		}
		else
		{
			$selected="";
		}
	}
	
	$tpl->setCurrentBlock("testlist") ;
	$tpl->setVariable( "test_value", $surveyArray[$i]["PROJECT_ID_PK"]);
	$tpl->setVariable( "test_selected", $selected);
	$tpl->setVariable( "test_name", $surveyArray[$i]["PROJECT_NAME"]);
	$tpl->parseCurrentBlock();
}

// parse template
$tpl->parse();

// get the parsed template and print it
$tpl->get();
$tpl->show();
?>
