<?php
// +----------------------------------------------------------------------+
// | opensurveypilot                                                      |
// +----------------------------------------------------------------------+
// | Copyright (c) 2002 serie a - Digitale Medien und Systeme GmbH        |
// +----------------------------------------------------------------------+
// | Authors: 	Daniel Peer <peer@serie-a.de>                             |
// |          	                                                          |
// +----------------------------------------------------------------------+
//
// $Id: testgroup.tousergroup.php,v 1.1.1.1 2004/07/15 13:34:19 opensurveypilot Exp $

// start session
@session_start();

// require all configuration files and libraries
require_once("./../config/config.inc.php"); // common config file
require_once($cfgPathToConf."/file.inc.php"); // project files
require_once($cfgPathToLib."/common.inc.php"); // common functions
require_once($cfgPathToTestgroupFiles."/config/testgroup.config.inc.php"); // testgroup config file
require_once($cfgPathToTestgroupFiles."/config/testgroup.file.inc.php"); // testgroup files
require_once($cfgPathToTestgroupFiles."/lib/testgroup.inc.php"); // testgroup functions
require_once($cfgPathToAuthFiles."/lib/user.inc.php"); // auth user functions
require_once($cfgPathToAuthFiles."/lib/permission.inc.php"); // permission functions
require_once($cfgPathToProbFiles."/lib/prob.inc.php"); // proband functions
require_once("HTML/Template/IT.php"); // PEAR::HTML_TEMPLATE_IT


// create new userFunctions object
$client = &new userFunctions;

//login check
if ($client->getAuthentication($_SESSION["sessionId"], session_id()) == false)
{
    //redirect to login page
    ?>
    <script type="text/javascript">
    <!--
    window.location.href="<?php echo $cfgUrlToProject."/".$fileAuthLogin; ?>";
    -->
    </script>
    <?php
    exit;
}

// function permission check
if($_SESSION["sessionUserStatusId"] < $permRawDataDetailView)
{
    ?>
    <script type="text/javascript">
    <!--
    window.location.href="<?php echo $cfgUrlToProject."/".$fileNoPermission."?messageCode=2"; ?>";
    -->
    </script>
    <?php
    exit;
}

$tpl = new HTML_Template_IT($cfgPathToTestgroupTemplates);
$tpl->loadTemplatefile($templateTestgroupToUsergroup, true, true); // do remove untouched blocks

$testgroups = &new Testgroup;
$myPerson = &new Proband;

// get user id for detailview
$testgroupId = $_GET["testgroupId"];

if($_SERVER["REQUEST_METHOD"] == "POST")
{
	$usergroupArray = $_POST["usergroups"];
	$testgroupId = $_POST["testgroupId"];
	if (is_array($usergroupArray))
	{
		if ($testgroups->Usergroups_to_Testgroup ($testgroupId, $usergroupArray))
		{
			$tpl->setVariable( "message", "<span style='color:blue'>".$lang_script["testgroup.tousergroup.php"]["saveSuccess"]."</span>");
			?>
	        <script type="text/javascript">
	        <!--
	        window.location.href="<?php echo $cfgUrlToProject."/".$fileInsertSuccessMessage; ?>";
	        -->
	        </script>
	        <?php
			exit;
		}
		else
		{
			$tpl->setVariable( "message", $testgroups->errorMessage);
		}
	}
	else
	{
		$tpl->setVariable( "message", $lang_script["testgroup.tousergroup.php"]["notSavedSelectAGroup"] );
	}
	
}

$usergroupArray = $myPerson->getProbandGroups ($actualNum = 0, 10000, "GROUPS_NAME", "ASC");

// set title
$tpl->setVariable( "applicationtitle", $cfgApplicationType.$cfgApplicationVersion);

$tpl->setVariable( "lnk_usergroup", $fileTestgroupToUsergroup."?testgroupId=$testgroupId");
$tpl->setVariable( "lnk_members", $fileTestgroupMembers."?testgroupId=$testgroupId");

//to get the name of this testgroup for panelname
$groupArray = $testgroups->getTestgroupRow($testgroupId);
$testgroupName = $groupArray[0]["CONTENTGROUP_NAME"];
$tpl->setVariable( "panelname", $testgroupName );

$insertedUsergroups = $testgroups->get_Usergroups_of_Testgroup ($testgroupId);

$tpl->setVariable( "testgroupId", $testgroupId);
$tpl->setVariable( "formaction", $fileTestgroupToUsergroup);

for ($i=0;$i<count($usergroupArray);$i++)
{
	if (is_array($insertedUsergroups))
	{
		if (in_array($usergroupArray[$i]["GROUPS_ID_PK"],$insertedUsergroups))
		{
			$selected="selected";
		}
		else
		{
			$selected="";
		}
	}
	else
	{
		if ($usergroupArray[$i]["GROUPS_ID_PK"]==$insertedUsergroups)
		{
			$selected="selected";
		}
		else
		{
			$selected="";
		}
	}
	
	$tpl->setCurrentBlock("grouplist") ;
	$tpl->setVariable( "group_value", $usergroupArray[$i]["GROUPS_ID_PK"]);
	$tpl->setVariable( "group_selected", $selected);
	$tpl->setVariable( "group_name", $usergroupArray[$i]["GROUPS_NAME"]);
	$tpl->parseCurrentBlock();
}

// parse template
$tpl->parse();

// get the parsed template and print it
$tpl->get();
$tpl->show();
?>
