<?php
// +----------------------------------------------------------------------+
// | survey pilot                                                         |
// +----------------------------------------------------------------------+
// | Copyright (c) 2002 serie a - Digitale Medien und Systeme GmbH        |
// +----------------------------------------------------------------------+
// | Authors: 	Jrn Allert <allert@serie-a.de>                           |
// |          	Rene Renk <renk@serie-a.de>                               |
// +----------------------------------------------------------------------+
//
// $Id: tmpl.group.add.php,v 1.1.1.1 2004/07/15 13:34:49 opensurveypilot Exp $

// start session
session_start();

// Variable to distinguish between survey and assessment templates
// Stati: 'sur' or 'ass'
$_GET["module"] ? $module=$_GET["module"] : $module=$_POST["module"];
if (!$module)
{
	$module="sur";
}

// require all configuration files and libraries
require_once("./../config/config.inc.php"); // common config file
require_once ("Validate.php"); // PEAR::Validate (must be included before common config file)
require_once($cfgPathToConf."/file.inc.php"); // project files
require_once($cfgPathToLib."/common.inc.php"); // common functions
require_once($cfgPathToAuthFiles."/config/auth.file.inc.php"); // auth files
require_once($cfgPathToTmplFiles."/config/tmpl.file.inc.php"); // auth files
require_once($cfgPathToAuthFiles."/lib/user.inc.php"); // auth user functions


//according to the $module Variable the correct template class will be required
if ($module=="sur")
{
	require_once($cfgPathToTmplFiles."/lib/tmpl.inc.php"); // auth category functions
}
else
{
	require_once($cfgPathToTmplFiles."/lib/tmpl.assessment.inc.php"); // auth category functions
}

require_once("HTML/Template/IT.php"); // PEAR::HTML_TEMPLATE_IT

// create new userFunctions object
$client = &new userFunctions;

//login check
if ($client->getAuthentication($_SESSION["sessionId"], session_id()) == false)
{
    //redirect to login page
    ?>
    <script type="text/javascript">
    <!--
    window.location.href="<?php echo $cfgUrlToProject."/".$fileAuthLogin; ?>";
    -->
    </script>
    <?php
    exit;
}

// function permission check
if($_SESSION["sessionUserStatusId"] < $permTmplGroupAdd)
{
    ?>
    <script type="text/javascript">
    <!--
    window.location.href="<?php echo $cfgUrlToProject."/".$fileNoPermission."?messageCode=2"; ?>";
    -->
    </script>
    <?php
    exit;
}

// check for parentId
if($_GET["parentId"] != "")
{
	$parentId	=	$_GET["parentId"];
}
else
{
	$parentId	=	"0";
}

// check if form was submitted
if($_SERVER["REQUEST_METHOD"] == "POST")
{
    $parentId = $_POST["parentId"];
    
    // get and check name and make small
    $groupName 	= cleanHtml($_POST["groupName"]);
	$groupName	= strtolower($_POST["groupName"]);
    if($groupName != "")
    {
        // check format
        if(!validate::string($groupName, VAL_ALPHA_NUM_, 1, 25))
        {
            $errors["groupName"] = $lang_script["tmpl.group.add.php"]["errorsChars"];
        }
    }
    else
    {
        $errors["groupName"] = $lang_script["tmpl.group.add.php"]["errorsNameField"];
    }
    
    // put error Array in String
    if($errors)
    {
        foreach($errors as $error)
        {
            $userError .= "$error<br>";
        }
    }
    // no errors, so we can insert new group    
    else
    {
        $groupArray["name"] 	= $groupName;
        $groupArray["parentId"] = $parentId;
        
        $tmpl = &new tmplFunctions;
		
        if($tmpl->addCategory($groupArray))
		{
	        // make dir and giving the permission to write
	        $tmpl->makeTmplCategoryDir($groupArray);
		}
        // check for error
        if ($tmpl->errorMessage)
        {
            $userError = $tmpl->errorMessage;
        }
        // redirect to success page
        else
        {
            ?>
            <script type="text/javascript">
            <!--
            window.location.href="<?php echo $cfgUrlToProject."/".$fileCommonSuccessMessage; ?>";
            -->
            </script>
            <?php
        }
    }
}

// create Template IT object
$tpl = new HTML_Template_IT($cfgPathToTmplTemplates);

// load template
$tpl->loadTemplatefile($templateTmplGroupAdd, true, true);

// set title
$tpl->setVariable( "applicationtitle", $cfgApplicationType.$cfgApplicationVersion);

$tpl->setVariable( "formaction", $fileTmplGroupAdd."?module=$module" );

$tpl->setVariable( "errors", $userError );

$tpl->setVariable( "name", $groupName );
$tpl->setVariable( "parentid", $parentId );

// parse template
$tpl->parse();

// get the parsed template and print it
$tpl->get();
$tpl->show();
?>
