<?php
// +----------------------------------------------------------------------+
// | sa project pilot                                                     |
// +----------------------------------------------------------------------+
// | Copyright (c) 2002 serie a - Digitale Medien und Systeme GmbH        |
// +----------------------------------------------------------------------+
// | Authors: 	Jrn Allert <allert@serie-a.de>                           |
// |          	Rene Renk <renk@serie-a.de>                               |
// +----------------------------------------------------------------------+
//
// $Id: tmpl.main.overview.php,v 1.1.1.1 2004/07/15 13:34:50 opensurveypilot Exp $

// start session
@session_start();

// Variable to distinguish between survey and assessment templates
// Stati: 'sur' or 'ass'
$_GET["module"] ? $module=$_GET["module"] : $module=$_POST["module"];
if (!$module)
{
	$module="sur";
}

// require all configuration files and libraries
require_once("./../config/config.inc.php"); // common config file
require_once ("Validate.php"); // PEAR::Validate (must be included before common config file)
require_once($cfgPathToConf."/file.inc.php"); // project files
require_once($cfgPathToLib."/common.inc.php"); // common functions
require_once($cfgPathToAuthFiles."/config/auth.file.inc.php"); // auth files
require_once($cfgPathToTmplFiles."/config/tmpl.file.inc.php"); // auth files
require_once($cfgPathToAuthFiles."/lib/user.inc.php"); // auth user functions

//according to the $module Variable the correct template class will be required
if ($module=="sur")
{
	require_once($cfgPathToTmplFiles."/lib/tmpl.inc.php"); // auth category functions
}
else
{
	require_once($cfgPathToTmplFiles."/lib/tmpl.assessment.inc.php"); // auth category functions
}

require_once("HTML/Template/IT.php"); // PEAR::HTML_TEMPLATE_IT

// create new userFunctions object
$client = &new userFunctions;

//login check
if ($client->getAuthentication($_SESSION["sessionId"], session_id()) == false)
{
    //redirect to login page
    ?>
    <script type="text/javascript">
    <!--
    window.location.href="<?php echo $cfgUrlToProject."/".$fileAuthLogin; ?>";
    -->
    </script>
    <?php
    exit;
}

// function permission check
if($_SESSION["sessionUserStatusId"] < $permTmplOverview)
{
    ?>
    <script type="text/javascript">
    <!--
    window.location.href="<?php echo $cfgUrlToProject."/".$fileNoPermission."?messageCode=2"; ?>";
    -->
    </script>
    <?php
    exit;
}

// create Template IT object
$tpl = new HTML_Template_IT($cfgPathToTmplTemplates);

// create new categoryFunctions object
$tmpl = &new tmplFunctions;

// load template
$tpl->loadTemplatefile($templateTmplOverview, true, true);

// set title
$tpl->setVariable( "applicationtitle", $cfgApplicationType.$cfgApplicationVersion);

if ($module=="sur")
{
	$tpl->setVariable( "module", $lang_script["tmpl.main.overview.php"]["moduleSurvey"]);
}
else
{
	$tpl->setVariable( "module", $lang_script["tmpl.main.overview.php"]["moduleAssessment"]);
}

// get group id as get variable
if(isset($_GET["groupId"]))
{
    $groupId = $_GET["groupId"];
}

// get actual num as get variable
if(isset($_GET["actualNum"]))
{
    $actualNum = $_GET["actualNum"];
}
// get orderBy as get variable
if(isset($_GET["orderBy"]))
{
    $orderBy = $_GET["orderBy"];
}
else
{
    $orderBy = "CATEGORY_NAME";
}
// get direction as get variable
if(isset($_GET["direction"]))
{
    $direction = $_GET["direction"];
}

// maximum rows
$maxRow = $cfgMaxRowInOverviews;
//total rows 


$totalNum = $tmpl->getGroupsNum($groupId);

if($groupId == "")
{
	$tpl->setVariable( "groupname", $lang_script["tmpl.main.overview.php"]["mainCategories"]);
}
else
{
	$tpl->setVariable( "groupname", $lang_script["tmpl.main.overview.php"]["Category"]);
}
// actual rows
if (!isset($actualNum))
{
    $actualNum = 0;
}
// get the Number of pages
$numPages = intval($totalNum/$maxRow);
if ($numPages < ($totalNum/$maxRow))
{ 
    $numPages++;
}

// prev button
if ($actualNum > 0) 
{
    $y = $actualNum - $maxRow;
    
    $tpl->setVariable( "prev_button", "<a class=\"navigation\" href=\"$fileTmplOverview?groupId=$groupId&actualNum=$y&orderBy=$orderBy&direction=$direction&module=$module\">&laquo;</a>" );
}
// display pages
for ($i = 1; $i <= $numPages; $i++)
{
    $y = ($i * $maxRow) - $maxRow;
    
    $tpl->setCurrentBlock( "num_buttons" );
    $tpl->setVariable( "num_button", "[<a class=\"navigation\" href=\"$fileTmplOverview?groupId=$groupId&actualNum=$y&orderBy=$orderBy&direction=$direction&module=$module\">$i</a>]" );
    $tpl->parseCurrentBlock();
}
//  next button
if ($actualNum < ($totalNum - $maxRow)) 
{
    $y = $actualNum  + $maxRow;
    
    $tpl->setVariable( "next_button", "<a class=\"navigation\" href=\"$fileTmplOverview?groupId=$groupId&actualNum=$y&orderBy=$orderBy&direction=$direction&module=$module\">&raquo;</a>" );
}

if(($actualNum + $maxRow) < $totalNum)
{
    $entryTo = $actualNum + $maxRow;
}
else
{
    $entryTo = $totalNum;
    
}

// entry from
$entryFrom = $entryTo < 1 ? "0" : $actualNum +1;

$tpl->setVariable( "entry_from", $entryFrom );
$tpl->setVariable( "entry_to", $entryTo );
$tpl->setVariable( "entry_total", $totalNum );

// orderby butons
$tpl->setVariable( "order_link_name_up", "$fileTmplOverview?groupId=$groupId&actualNum=$actualNum&orderBy=CATEGORY_NAME&direction=ASC&module=$module" );
$tpl->setVariable( "order_link_name_down", "$fileTmplOverview?groupId=$groupId&actualNum=$actualNum&orderBy=CATEGORY_NAME&direction=DESC&module=$module" );
$tpl->setVariable( "order_link_insert_date_up", "$fileTmplOverview?groupId=$groupId&actualNum=$actualNum&orderBy=CATEGORY_TIME&direction=ASC&module=$module" );
$tpl->setVariable( "order_link_insert_date_down", "$fileTmplOverview?groupId=$groupId&actualNum=$actualNum&orderBy=CATEGORY_TIME&direction=DESC&module=$module" );


// get user
$groupArray = $tmpl->getGroupsForOverview($groupId, $actualNum, $maxRow, $orderBy, $direction);

if ($tmpl->errorMessage)
{
    $userError = $tmpl->errorMessage;
}

for($j=0;$j<count($groupArray);$j++)
{
    $tpl->setCurrentBlock( "group_overview" );
    $tpl->setVariable( "id", $groupArray[$j]["CATEGORY_ID_PK"]);
    $tpl->setVariable( "name", $groupArray[$j]["CATEGORY_NAME"]);
    $tpl->setVariable( "insertdate", $groupArray[$j]["CATEGORY_TIME"]);
    $tpl->setVariable( "delete_link", $fileTmplGroupDelete."?groupId=".$groupArray[$j]["CATEGORY_ID_PK"]."&module=$module");
    $tpl->parseCurrentBlock();
}

// parse template
$tpl->parse();

// get the parsed template and print it
$tpl->get();
$tpl->show();
?>
