<?php
// +----------------------------------------------------------------------+
// | survey pilot                                                         |
// +----------------------------------------------------------------------+
// | Copyright (c) 2002 serie a - Digitale Medien und Systeme GmbH        |
// +----------------------------------------------------------------------+
// | Authors: 	Jrn Allert <allert@serie-a.de>                           |
// |          	Rene Renk <renk@serie-a.de>                               |
// +----------------------------------------------------------------------+
//
// $Id: category.add.php,v 1.1.1.1 2004/07/15 13:35:03 opensurveypilot Exp $

// start session
session_start();

// require all configuration files and libraries
require_once("./../config/config.inc.php"); // common config file
require_once ("Validate.php"); // PEAR::Validate (must be included before common config file)
require_once($cfgPathToConf."/file.inc.php"); // project files
require_once($cfgPathToLib."/common.inc.php"); // common functions
require_once($cfgPathToAuthFiles."/config/auth.file.inc.php"); // auth files
require_once($cfgPathToAuthFiles."/lib/user.inc.php"); // auth user functions
require_once($cfgPathToAuthFiles."/lib/category.inc.php"); // auth category functions
require_once("HTML/Template/IT.php"); // PEAR::HTML_TEMPLATE_IT

// create new userFunctions object
$client = &new userFunctions;

//login check
if ($client->getAuthentication($_SESSION["sessionId"], session_id()) == false)
{
    //redirect to login page
    ?>
    <script type="text/javascript">
    <!--
    window.location.href="<?php echo $cfgUrlToProject."/".$fileAuthLogin; ?>";
    -->
    </script>
    <?php
    exit;
}

// function permission check
if($_SESSION["sessionUserStatusId"] < $permCategoryAdd)
{
    ?>
    <script type="text/javascript">
    <!--
    window.location.href="<?php echo $cfgUrlToProject."/".$fileNoPermission."?messageCode=2"; ?>";
    -->
    </script>
    <?php
    exit;
}
    
$parentId = $_GET["parentId"]; 

// check if form was submitted
if($_SERVER["REQUEST_METHOD"] == "POST")
{
    $parentId = $_POST["parentId"];
    
    // get and check name
    $categoryName = cleanHtml($_POST["categoryName"]);
    if($categoryName != "")
    {
        // check format
        if(!validate::string($categoryName, VAL_ALPHA_NUM_, 1, 25))
        {
            $errors["categoryName"] = $lang_script["category.add.php"]["errorsChars"];
        }
    }
    else
    {
        $errors["categoryName"] = $lang_script["category.add.php"]["errorsNameField"];
    }
    
    // put error Array in String
    if($errors)
    {
        foreach($errors as $error)
        {
            $userError .= "$error<br>";
        }
    }
    // no errors, so we can insert new group    
    else
    {
        $categoryArray["name"] = $categoryName;
        $categoryArray["parentId"] = $parentId;
        
        $category = &new categoryFunctions;
        $category->addCategory($categoryArray);
               
        // check for error
        if ($category->errorMessage)
        {
            $userError = $category->errorMessage;
        }
        // redirect to success page
        else
        {
          ?>
            <script type="text/javascript">
            <!--
            window.location.href="<?php echo $cfgUrlToProject."/".$fileCommonSuccessMessage; ?>";
            -->
            </script>
            <?php
        }
    }
}

// create Template IT object
$tpl = new HTML_Template_IT($cfgPathToAuthTemplates);

// load template
$tpl->loadTemplatefile($templateCategoryAdd, true, true);

// set title
$tpl->setVariable( "applicationtitle", $cfgApplicationType.$cfgApplicationVersion);

$tpl->setVariable( "formaction", $fileCategoryAdd );

$tpl->setVariable( "errors", $userError );

$tpl->setVariable( "name", $categoryName );
$tpl->setVariable( "parentid", $parentId );


// parse template
$tpl->parse();

// get the parsed template and print it
$tpl->get();
$tpl->show();
?>
