<?php
// +----------------------------------------------------------------------+
// | survey pilot                                                         |
// +----------------------------------------------------------------------+
// | Copyright (c) 2002 serie a - Digitale Medien und Systeme GmbH        |
// +----------------------------------------------------------------------+
// | Authors: 	Jrn Allert <allert@serie-a.de>                           |
// |          	Rene Renk <renk@serie-a.de>                               |
// +----------------------------------------------------------------------+
//
// $Id: category.addcontent.php,v 1.1.1.1 2004/07/15 13:35:03 opensurveypilot Exp $

// start session
session_start();

// require all configuration files and libraries
require_once("./../config/config.inc.php"); // common config file
require_once ("Validate.php"); // PEAR::Validate (must be included before common config file)
require_once($cfgPathToConf."/file.inc.php"); // project files
require_once($cfgPathToLib."/common.inc.php"); // common functions
require_once($cfgPathToAuthFiles."/config/auth.file.inc.php"); // auth files
require_once($cfgPathToAuthFiles."/lib/user.inc.php"); // auth user functions
require_once($cfgPathToAuthFiles."/lib/category.inc.php"); // auth category functions
require_once("HTML/Template/IT.php"); // PEAR::HTML_TEMPLATE_IT

// create new userFunctions object
$client = &new userFunctions;

//login check
if ($client->getAuthentication($_SESSION["sessionId"], session_id()) == false)
{
    //redirect to login page
    ?>
    <script type="text/javascript">
    <!--
    window.location.href="<?php echo $cfgUrlToProject."/".$fileAuthLogin; ?>";
    -->
    </script>
    <?php
    exit;
}

// function permission check
if($_SESSION["sessionUserStatusId"] < $permCategoryAddContent)
{
    ?>
    <script type="text/javascript">
    <!--
    window.location.href="<?php echo $cfgUrlToProject."/".$fileNoPermission."?messageCode=2"; ?>";
    -->
    </script>
    <?php
    exit;
}

// create new categoryFunctions object
$category = &new categoryFunctions;

// get category id
$categoryId = $_GET["categoryId"];

// check if form was submitted
if($_SERVER["REQUEST_METHOD"] == "POST")
{
    $categoryId = $_POST["categoryId"];
    
    // get and check content string
    $newContentString = $_POST["Addnewcontent"];
    if($newContentString != "")
    {
        // cut last | in $newUserString;
        $newContentStringCut = substr($newContentString, 0, strlen($newContentString)-1);
        // put values in array
        $newContentArray = explode("|", $newContentStringCut);
    }
        
    // delete all content from category
    $category->deleteContentFromCategory(1, $contentIdNameArray[0], $categoryId);
    if($category->errorMessage)
    {
        $userError .= $category->$errorMessage;
    }
    
    if(is_array($newContentArray))
    {
        // insert content in db 
        while(list($key,$val) = each($newContentArray))
        {
            $contentIdNameArray = explode("%", $val);
            $category->addContentToCategory(1, $contentIdNameArray[0], $contentIdNameArray[1], $categoryId);
        }
    }
           
    // redirect to success page
    if(!$userError)
    {
       $userError = "<span style='color:blue'>".$lang_script["category.addcontent.php"]["saveMessage"]."</span>";
    }
}

// create Template IT
$tpl = new HTML_Template_IT($cfgPathToAuthTemplates);

// load template
$tpl->loadTemplatefile($templateCategoryAddContent, true, true);

// set title
$tpl->setVariable( "applicationtitle", $cfgApplicationType.$cfgApplicationVersion);

$tpl->setVariable( "formaction", $fileCategoryAddContent );

$tpl->setVariable( "errors", $userError );

$tpl->setVariable( "contenttypename", $lang_script["category.addcontent.php"]["contenttypenameProjects"] );

$contentArray = $category->getContent("T_SURVEY_PROJECT");
if ($category->errorMessage)
{
    $userError = $category->errorMessage;
}
for($j = 0; $j < count($contentArray); $j++)
{
    $tpl->setCurrentBlock( "content" );
    $tpl->setVariable( "contentvalue", $contentArray[$j]["PROJECT_ID_PK"]."%".$contentArray[$j]["PROJECT_NAME"] );
    $tpl->setVariable( "contentname", $contentArray[$j]["PROJECT_NAME"] );
    $tpl->parseCurrentBlock();
}

$existingContentArray = $category->getContentFromCategory(1, $categoryId);
if ($category->errorMessage)
{
    $userError = $category->errorMessage;
}
for($k = 0; $k < count($existingContentArray); $k++)
{
    $tpl->setCurrentBlock( "newcontent" );
    $tpl->setVariable( "newcontentvalue", $existingContentArray[$k]["CNTNT_TO_CTGRY_CONTENT_ID"] );
    $tpl->setVariable( "newcontentname", $existingContentArray[$k]["CNTNT_TO_CTGRY_CONTENTNAME"] );
    $tpl->parseCurrentBlock();
    $containerValues .= $existingContentArray[$k]["CNTNT_TO_CTGRY_CONTENT_ID"]."%".$existingContentArray[$k]["CNTNT_TO_CTGRY_CONTENTNAME"]."|";
}
$tpl->setVariable( "addnewcontent",  $containerValues);

$tpl->setVariable( "errors", $userError );
$tpl->setVariable( "categoryid", $categoryId );

$tpl->setVariable( "lnk_add", $filePermissionAdd."?categoryId=".$categoryId );
$tpl->setVariable( "lnk_edit", $fileCategoryAddContent."?categoryId=".$categoryId );
$tpl->setVariable( "lnk_delete", $fileCategoryDelete."?categoryId=".$categoryId );

// parse template
$tpl->parse();

// get the parsed template and print it
$tpl->get();
$tpl->show();
?>
