<?php
// +----------------------------------------------------------------------+
// | survey pilot                                                         |
// +----------------------------------------------------------------------+
// | Copyright (c) 2002 serie a - Digitale Medien und Systeme GmbH        |
// +----------------------------------------------------------------------+
// | Authors: 	Jrn Allert <allert@serie-a.de>                           |
// |          	Rene Renk <renk@serie-a.de>                               |
// +----------------------------------------------------------------------+
//
// $Id: category.delete.php,v 1.1.1.1 2004/07/15 13:35:03 opensurveypilot Exp $

// start session
session_start();

// require all configuration files and libraries
require_once("./../config/config.inc.php"); // common config file
require_once($cfgPathToConf."/file.inc.php"); // project files
require_once($cfgPathToLib."/common.inc.php"); // common functions
require_once($cfgPathToAuthFiles."/config/auth.file.inc.php"); // auth files
require_once($cfgPathToAuthFiles."/lib/user.inc.php"); // auth user functions
require_once($cfgPathToAuthFiles."/lib/category.inc.php"); // auth category functions
require_once("HTML/Template/IT.php"); // PEAR::HTML_TEMPLATE_IT

// create new userFunctions object
$client = &new userFunctions;

//login check
if ($client->getAuthentication($_SESSION["sessionId"], session_id()) == false)
{
    //redirect to login page
    ?>
    <script type="text/javascript">
    <!--
    window.location.href="<?php echo $cfgUrlToProject."/".$fileAuthLogin; ?>";
    -->
    </script>
    <?php
    exit;
}

// function permission check
if($_SESSION["sessionUserStatusId"] < $permCategoryDelete)
{
    ?>
    <script type="text/javascript">
    <!--
    window.location.href="<?php echo $cfgUrlToProject."/".$fileNoPermission."?messageCode=2"; ?>";
    -->
    </script>
    <?php
    exit;
}

// get category id for detailview
if(isset($_GET["categoryId"]))
{
    $categoryId = $_GET["categoryId"];
}

// create new categoryFunctions object
$category = &new categoryFunctions;

// check if form was submitted
if($_SERVER["REQUEST_METHOD"] == "POST")
{
    $categoryId = $_POST["categoryId"];
    
    function deleteCategoryRecursive($categoryId)
    {
        global $category;
        
        // check if group has childs
        if($category->isNode($categoryId))
        {
            $childCategorys = $category->getChilds($categoryId);
            for($j=0; $j<count($childCategorys); $j++)
            {
                deleteCategoryRecursive($childCategorys[$j][0]);
            }
        }
        // delete all permissions of this category
        $category->deletePermissionsFromCategory($categoryId);
        if($category->errorMessage)
        {
            $userError .= $category->$errorMessage;
        }
        
        // delete all content from this category
        $category->deleteContentFromCategory(1, "", $categoryId);
        if($category->errorMessage)
        {
            $userError .= $category->$errorMessage;
        }
        
        // delete category
        $category->deleteCategory($categoryId);
        if($category->errorMessage)
        {
            $userError .= $category->$errorMessage;
        }
    }
    
    deleteCategoryRecursive($categoryId);
    
    // redirect to success page
    if(!isset($userError))
    {
      ?>
        <script type="text/javascript">
        <!--
        window.location.href="<?php echo $cfgUrlToProject."/".$fileDeleteSuccessMessage; ?>";
        -->
        </script>
        <?php
    }
}

// fetch categorydata
$result = $category->getCategoryInfo($categoryId);
if($category->errorMessage)
{
    $userError .= $category->$errorMessage;
}

// create Template IT object
$tpl = new HTML_Template_IT($cfgPathToAuthTemplates);

// load template
$tpl->loadTemplatefile($templateCategoryDelete, true, true);

// set title
$tpl->setVariable( "applicationtitle", $cfgApplicationType.$cfgApplicationVersion);

$tpl->setVariable( "formaction", $fileCategoryDelete );
$tpl->setVariable( "errors", $userError );
$tpl->setVariable( "categoryid", $categoryId );
$tpl->setVariable( "name", $result["CATEGORY_NAME"] );

$tpl->setVariable( "lnk_add", $filePermissionAdd."?categoryId=".$categoryId );
$tpl->setVariable( "lnk_edit", $fileCategoryAddContent."?categoryId=".$categoryId );
$tpl->setVariable( "lnk_delete", $fileCategoryDelete."?categoryId=".$categoryId );

// parse template
$tpl->parse();

// get the parsed template and print it
$tpl->get();
$tpl->show();   

?>

