<?php
// +----------------------------------------------------------------------+
// | survey pilot                                                         |
// +----------------------------------------------------------------------+
// | Copyright (c) 2002 serie a - Digitale Medien und Systeme GmbH        |
// +----------------------------------------------------------------------+
// | Authors: 	Jrn Allert <allert@serie-a.de>                           |
// |          	Rene Renk <renk@serie-a.de>                               |
// +----------------------------------------------------------------------+
//
// $Id: category.subfolder.overview.php,v 1.1.1.1 2004/07/15 13:35:04 opensurveypilot Exp $

// start session
@session_start();

// require all configuration files and libraries
require_once("./../config/config.inc.php"); // common config file
require_once($cfgPathToConf."/file.inc.php"); // project files
require_once($cfgPathToLib."/common.inc.php"); // common functions
require_once($cfgPathToAuthFiles."/config/auth.file.inc.php"); // auth files
require_once($cfgPathToAuthFiles."/lib/user.inc.php"); // auth user functions
require_once($cfgPathToAuthFiles."/lib/category.inc.php"); // auth group functions
require_once("HTML/Template/IT.php"); // PEAR::HTML_TEMPLATE_IT

// create new userFunctions object
$client = &new userFunctions;

//login check
if ($client->getAuthentication($_SESSION["sessionId"], session_id()) == false)
{
    //redirect to login page
    ?>
    <script type="text/javascript">
    <!--
    window.location.href="<?php echo $cfgUrlToProject."/".$fileAuthLogin; ?>";
    -->
    </script>
    <?php
    exit;
}

// function permission check
if($_SESSION["sessionUserStatusId"] < $permCategorySubfolderOverview)
{
    ?>
    <script type="text/javascript">
    <!--
    window.location.href="<?php echo $cfgUrlToProject."/".$fileNoPermission."?messageCode=2"; ?>";
    -->
    </script>
    <?php
    exit;
}

// create Template IT object
$tpl = new HTML_Template_IT($cfgPathToAuthTemplates);

// create new categoryFunctions object
$category = &new categoryFunctions;

// load template
$tpl->loadTemplatefile($templateCategorySubfolderOverview, true, true);

// set title
$tpl->setVariable( "applicationtitle", $cfgApplicationType.$cfgApplicationVersion);


// get group id as get variable
if(isset($_GET["id"]))
{
    $categoryId = $_GET["id"];
}
elseif(isset($_GET["categoryId"]))
{
    $categoryId = $_GET["categoryId"];
}
else
{
    //redirect to category-overview-page
    ?>
    <script type="text/javascript">
    <!--
    window.location.href="<?php echo $fileCategoryOverview; ?>";
    -->
    </script>
    <?php
    exit;
}

// set folderlinks
$tpl->setVariable( "permissionlink", $fileCategoryPermissionOverview."?id=".$categoryId);
$tpl->setVariable( "permissiontarget", $fileFrameContentName);

$tpl->setVariable( "permissiontoplevellink", $fileUserToplevelPermission."?id=".$categoryId);
$tpl->setVariable( "permissiontopleveltarget", $fileFrameToplevelName);

$tpl->setVariable( "contentlink", $fileContentOverview."?id=".$categoryId);
$tpl->setVariable( "contenttarget", $fileFrameContentName);

$tpl->setVariable( "contenttoplevellink", $fileUserToplevelContent."?id=".$categoryId);
$tpl->setVariable( "contenttopleveltarget", $fileFrameToplevelName);


// get actual num as get variable
if(isset($_GET["actualNum"]))
{
    $actualNum = $_GET["actualNum"];
}
// get orderBy as get variable
if(isset($_GET["orderBy"]))
{
    $orderBy = $_GET["orderBy"];
}
else
{
    $orderBy = "CATEGORY_NAME";
}
// get direction as get variable
if(isset($_GET["direction"]))
{
    $direction = $_GET["direction"];
}

// maximum rows
$maxRow = $cfgMaxRowInOverviews;
//total rows 

// get number of groups in this category
$categoryInfo = $category->getCategoryInfo($categoryId);
 // check for error
if ($category->errorMessage)
{
    $userError = $category->errorMessage;
}
$totalNum = $categoryInfo["catNum"];
$tpl->setVariable( "categoryname", $categoryInfo["CATEGORY_NAME"] );

// actual rows
if (!isset($actualNum))
{
    $actualNum = 0;
}
// get the Number of pages
$numPages = intval($totalNum/$maxRow);
if ($numPages < ($totalNum/$maxRow))
{ 
    $numPages++;
}

// prev button
if ($actualNum > 0) 
{
    $y = $actualNum - $maxRow;
    
    $tpl->setVariable( "prev_button", "<a class=\"navigation\" href=\"$fileCategorySubfolderOverview?categoryId=$categoryId&actualNum=$y&orderBy=$orderBy&direction=$direction\">&laquo;</a>" );
}
// display pages
for ($i = 1; $i <= $numPages; $i++)
{
    $y = ($i * $maxRow) - $maxRow;
    
    $tpl->setCurrentBlock( "num_buttons" );
    $tpl->setVariable( "num_button", "[<a class=\"navigation\" href=\"$fileCategorySubfolderOverview?categoryId=$categoryId&actualNum=$y&orderBy=$orderBy&direction=$direction\">$i</a>]" );
    $tpl->parseCurrentBlock();
}
//  next button
if ($actualNum < ($totalNum - $maxRow)) 
{
    $y = $actualNum  + $maxRow;
    
    $tpl->setVariable( "next_button", "<a class=\"navigation\" href=\"$fileCategorySubfolderOverview?categoryId=$categoryId&actualNum=$y&orderBy=$orderBy&direction=$direction\">&raquo;</a>" );
}

if(($actualNum + $maxRow) < $totalNum)
{
    $entryTo = $actualNum + $maxRow;
}
else
{
    $entryTo = $totalNum;
    
}

// entry from
$entryFrom = $entryTo < 1 ? "0" : $actualNum +1;

$tpl->setVariable( "entry_from", $entryFrom );
$tpl->setVariable( "entry_to", $entryTo );
$tpl->setVariable( "entry_total", $totalNum );

// orderby butons
$tpl->setVariable( "order_link_name_up", "$fileCategorySubfolderOverview?categoryId=$categoryId&actualNum=$actualNum&orderBy=CATEGORY_NAME&direction=ASC" );
$tpl->setVariable( "order_link_name_down", "$fileCategorySubfolderOverview?categoryId=$categoryId&actualNum=$actualNum&orderBy=CATEGORY_NAME&direction=DESC" );
$tpl->setVariable( "order_link_insert_date_up", "$fileCategorySubfolderOverview?categoryId=$categoryId&actualNum=$actualNum&orderBy=CATEGORY_CATEGORYTIME&direction=ASC" );
$tpl->setVariable( "order_link_insert_date_down", "$fileCategorySubfolderOverview?categoryId=$categoryId&actualNum=$actualNum&orderBy=CATEGORY_CATEGORYTIME&direction=DESC" );


// get user
$groupArray = $category->getCategoriesForOverview($categoryId, $actualNum, $maxRow, $orderBy, $direction);
if ($category->errorMessage)
{
    $userError = $category->errorMessage;
}

for($j=0;$j<count($groupArray);$j++)
{
    $tpl->setCurrentBlock( "group_overview" );
    $tpl->setVariable( "id", $groupArray[$j]["CATEGORY_ID_PK"] );
    $tpl->setVariable( "name", $groupArray[$j]["CATEGORY_NAME"] );
    $tpl->setVariable( "insertdate", $groupArray[$j]["CATEGORY_CATEGORYTIME"] );
    $tpl->setVariable( "permission_add_link", $filePermissionAdd."?categoryId=".$groupArray[$j]["CATEGORY_ID_PK"] );
    $tpl->parseCurrentBlock();
}

// parse template
$tpl->parse();

// get the parsed template and print it
$tpl->get();
$tpl->show();
?>
