<?php
// +----------------------------------------------------------------------+
// | survey pilot                                                         |
// +----------------------------------------------------------------------+
// | Copyright (c) 2002 serie a - Digitale Medien und Systeme GmbH        |
// +----------------------------------------------------------------------+
// | Authors: 	Jrn Allert <allert@serie-a.de>                           |
// |          	Rene Renk <renk@serie-a.de>                               |
// +----------------------------------------------------------------------+
//
// $Id: content.delete.php,v 1.1.1.1 2004/07/15 13:35:06 opensurveypilot Exp $

// start session
@session_start();

// require all configuration files and libraries
require_once("./../config/config.inc.php"); // common config file
require_once($cfgPathToConf."/file.inc.php"); // project files
require_once($cfgPathToLib."/common.inc.php"); // common functions
require_once($cfgPathToAuthFiles."/config/auth.file.inc.php"); // auth files
require_once($cfgPathToAuthFiles."/lib/user.inc.php"); // auth user functions
require_once($cfgPathToAuthFiles."/lib/category.inc.php"); // auth category functions
require_once("HTML/Template/IT.php"); // PEAR::HTML_TEMPLATE_IT

// create new userFunctions object
$client = &new userFunctions;

//login check
if ($client->getAuthentication($_SESSION["sessionId"], session_id()) == false)
{
    //redirect to login page
    ?>
    <script type="text/javascript">
    <!--
    window.location.href="<?php echo $cfgUrlToProject."/".$fileAuthLogin; ?>";
    -->
    </script>
    <?php
    exit;
}

// function permission check
if($_SESSION["sessionUserStatusId"] < $permContentDelete)
{
    ?>
    <script type="text/javascript">
    <!--
    window.location.href="<?php echo $cfgUrlToProject."/".$fileNoPermission."?messageCode=2"; ?>";
    -->
    </script>
    <?php
    exit;
}

$contentId = $_GET["contentId"];
$categoryId = $_GET["categoryId"];

// create new categoryFunctions object
$category = &new categoryFunctions;

// check if form was submitted
if($_SERVER["REQUEST_METHOD"] == "POST")
{
    $contentId = $_POST["contentId"];
    $categoryId = $_POST["categoryId"];
    
    // delete content
    $category->deleteContentFromCategory(1, $contentId, $categoryId);
    if($category->errorMessage)
    {
        $userError .= $category->$errorMessage;
    }
    
    // redirect to success page
    if(!isset($userError))
    {
      ?>
        <script type="text/javascript">
        <!--
        window.location.href="<?php echo $cfgUrlToProject."/".$fileDeleteSuccessMessage; ?>";
        -->
        </script>
        <?php
    }
}

// fetch contentdata
$result = $category->getContentInfo($contentId);
if($category->errorMessage)
{
    $userError .= $category->$errorMessage;
}

// create Template IT object
$tpl = new HTML_Template_IT($cfgPathToAuthTemplates);

// load template
$tpl->loadTemplatefile($templateContentDelete, true, true);

// set title
$tpl->setVariable( "applicationtitle", $cfgApplicationType.$cfgApplicationVersion);

$tpl->setVariable( "formaction", $fileContentDelete );
$tpl->setVariable( "errors", $userError );
$tpl->setVariable( "content_id", $result["CNTNT_TO_CTGRY_CONTENT_ID"] );
$tpl->setVariable( "content_name", $result["CNTNT_TO_CTGRY_CONTENTNAME"] );
$tpl->setVariable( "categoryid", $categoryId );
$tpl->setVariable( "contentid", $contentId );

// parse template
$tpl->parse();

// get the parsed template and print it
$tpl->get();
$tpl->show();   
?>

