<?php
// +----------------------------------------------------------------------+
// | survey pilot                                                         |
// +----------------------------------------------------------------------+
// | Copyright (c) 2002 serie a - Digitale Medien und Systeme GmbH        |
// +----------------------------------------------------------------------+
// | Authors: 	J?rn Allert <allert@serie-a.de>                           |
// |          	Rene Renk <renk@serie-a.de>                               |
// +----------------------------------------------------------------------+
//
// $Id: content.overview.php,v 1.1.1.1 2004/07/15 13:35:06 opensurveypilot Exp $

// start session
@session_start();

// require all configuration files and libraries
require_once("./../config/config.inc.php"); // common config file
require_once($cfgPathToConf."/file.inc.php"); // project files
require_once($cfgPathToLib."/common.inc.php"); // common functions
require_once($cfgPathToSurveyFiles."/config/survey.file.inc.php"); // survey files
require_once($cfgPathToAuthFiles."/config/auth.file.inc.php"); // auth files
require_once($cfgPathToAuthFiles."/lib/user.inc.php"); // auth user functions
require_once($cfgPathToAuthFiles."/lib/category.inc.php"); // auth group functions
require_once("HTML/Template/IT.php"); // PEAR::HTML_TEMPLATE_IT

// create new userFunctions object
$client = &new userFunctions;

//login check
if ($client->getAuthentication($_SESSION["sessionId"], session_id()) == false)
{
    //redirect to login page
    ?>
    <script type="text/javascript">
    <!--
    window.location.href="<?php echo $cfgUrlToProject."/".$fileAuthLogin; ?>";
    -->
    </script>
    <?php
    exit;
}

// function permission check
if($_SESSION["sessionUserStatusId"] < $permContentOverview)
{
    ?>
    <script type="text/javascript">
    <!--
    window.location.href="<?php echo $cfgUrlToProject."/".$fileNoPermission."?messageCode=2"; ?>";
    -->
    </script>
    <?php
    exit;
}

// get group id as get variable
if(isset($_GET["id"]))
{
    $categoryId = $_GET["id"];
}
elseif(isset($_GET["categoryId"]))
{
    $categoryId = $_GET["categoryId"];
}
elseif(isset($_POST["categoryId"]))
{
    $categoryId = $_POST["categoryId"];
}
else
{
    //redirect to category-overview-page
    ?>
    <script type="text/javascript">
    <!--
    window.location.href="<?php echo $fileCategoryOverview; ?>";
    -->
    </script>
    <?php
    exit;
}

// create new categoryFunctions object
$category = &new categoryFunctions;

if($_SERVER["REQUEST_METHOD"] == "POST")
{
	$contentIdArray=$_POST["contentId"];

	for ($i=0;$i<count($contentIdArray);$i++)
	{
		if ($_POST["selectAction"]==1) //template l?schen
		{
			$category->deleteContentFromCategory(1, $contentIdArray[$i], $categoryId);
		    if($category->errorMessage)
		    {
		       echo $category->$errorMessage;
		    }
		}
	}
}

// create Template IT object
$tpl = new HTML_Template_IT($cfgPathToAuthTemplates);

// load template
$tpl->loadTemplatefile($templateContentOverview, true, true);

// set title
$tpl->setVariable( "applicationtitle", $cfgApplicationType.$cfgApplicationVersion);


// set folderlinks
$tpl->setVariable( "permissionlink", $fileCategoryPermissionOverview."?id=".$categoryId);
$tpl->setVariable( "permissiontarget", $fileFrameContentName);

$tpl->setVariable( "permissiontoplevellink", $fileUserToplevelPermission."?id=".$categoryId);
$tpl->setVariable( "permissiontopleveltarget", $fileFrameToplevelName);

$tpl->setVariable( "categorylink", $fileCategorySubfolderOverview."?id=".$categoryId);
$tpl->setVariable( "categorytarget", $fileFrameContentName);

$tpl->setVariable( "categorytoplevellink", $fileUserToplevelSubCat."?id=".$categoryId);
$tpl->setVariable( "categorytopleveltarget", $fileFrameToplevelName);

// get actual num as get variable
if(isset($_GET["actualNum"]))
{
    $actualNum = $_GET["actualNum"];
}
// get orderBy as get variable
if(isset($_GET["orderBy"]))
{
    $orderBy = $_GET["orderBy"];
}
else
{
    $orderBy = "CNTNT_TO_CTGRY_CONTENTNAME";
}
// get direction as get variable
if(isset($_GET["direction"]))
{
    $direction = $_GET["direction"];
}

// maximum rows
$maxRow = $cfgMaxRowInOverviews;
//total rows 

// get number of groups in this category
$categoryInfo = $category->getCategoryInfo($categoryId);
 // check for error
if ($category->errorMessage)
{
    $userError = $category->errorMessage;
}
$totalNum = $categoryInfo["contentNum"];
$tpl->setVariable( "categoryname", $categoryInfo["CATEGORY_NAME"] );

// actual rows
if (!isset($actualNum))
{
    $actualNum = 0;
}
// get the Number of pages
$numPages = intval($totalNum/$maxRow);
if ($numPages < ($totalNum/$maxRow))
{ 
    $numPages++;
}

// prev button
if ($actualNum > 0) 
{
    $y = $actualNum - $maxRow;
    
    $tpl->setVariable( "prev_button", "<a class=\"navigation\" href=\"$fileContentOverview?categoryId=$categoryId&actualNum=$y&orderBy=$orderBy&direction=$direction\">&laquo;</a>" );
}
// display pages
for ($i = 1; $i <= $numPages; $i++)
{
    $y = ($i * $maxRow) - $maxRow;
    
    $tpl->setCurrentBlock( "num_buttons" );
    $tpl->setVariable( "num_button", "[<a class=\"navigation\" href=\"$fileContentOverview?categoryId=$categoryId&actualNum=$y&orderBy=$orderBy&direction=$direction\">$i</a>]" );
    $tpl->parseCurrentBlock();
}
//  next button
if ($actualNum < ($totalNum - $maxRow)) 
{
    $y = $actualNum  + $maxRow;
    
    $tpl->setVariable( "next_button", "<a class=\"navigation\" href=\"$fileContentOverview?categoryId=$categoryId&actualNum=$y&orderBy=$orderBy&direction=$direction\">&raquo;</a>" );
}

if(($actualNum + $maxRow) < $totalNum)
{
    $entryTo = $actualNum + $maxRow;
}
else
{
    $entryTo = $totalNum;
    
}

// entry from
$entryFrom = $entryTo < 1 ? "0" : $actualNum +1;

$tpl->setVariable( "entry_from", $entryFrom );
$tpl->setVariable( "entry_to", $entryTo );
$tpl->setVariable( "entry_total", $totalNum );

// orderby butons
$tpl->setVariable( "order_link_contentid_up", "$fileContentOverview?categoryId=$categoryId&actualNum=$actualNum&orderBy=CNTNT_TO_CTGRY_CONTENT_ID&direction=ASC" );
$tpl->setVariable( "order_link_contentid_down", "$fileContentOverview?categoryId=$categoryId&actualNum=$actualNum&orderBy=CNTNT_TO_CTGRY_CONTENT_ID&direction=DESC" );
$tpl->setVariable( "order_link_contentname_up", "$fileContentverview?categoryId=$categoryId&actualNum=$actualNum&orderBy=CNTNT_TO_CTGRY_CONTENTNAME&direction=ASC" );
$tpl->setVariable( "order_link_contentname_down", "$fileContentOverview?categoryId=$categoryId&actualNum=$actualNum&orderBy=CNTNT_TO_CTGRY_CONTENTNAME&direction=DESC" );
$tpl->setVariable( "order_link_insert_date_up", "#" );
$tpl->setVariable( "order_link_insert_date_down", "#" );


// get content
$contentArray = $category->getContentForOverview($categoryId, $actualNum, $maxRow, $orderBy, $direction);
if ($category->errorMessage)
{
    $userError = $category->errorMessage;
    echo "error: $userError";
}

/*/ debug
if ($userError)
{
    echo $userError;
}/*/

$tpl->setVariable( "formaction", $fileContentOverview );

for($j=0;$j<count($contentArray);$j++)
{
    $tpl->setCurrentBlock( "content_overview" );
    $tpl->setVariable( "id", $contentArray[$j]["CNTNT_TO_CTGRY_ID_PK"] );
	$tpl->setVariable( "contentId", $contentArray[$j]["CNTNT_TO_CTGRY_ID_PK"] );
    $tpl->setVariable( "projectid", $contentArray[$j]["CNTNT_TO_CTGRY_CONTENT_ID"] );
    $tpl->setVariable( "projectname", $contentArray[$j]["CNTNT_TO_CTGRY_CONTENTNAME"] );
    $tpl->setVariable( "insertdate", $contentArray[$j]["CNTNT_TO_CTGRY_CONTENTTIME"] );
    $tpl->setVariable( "detailview_link", ".".$cfgPathToSurveyModule."/".$fileSurveyEdit."?projectId=".$contentArray[$j]["CNTNT_TO_CTGRY_CONTENT_ID"] );
    $tpl->setVariable( "delete_link", $fileContentDelete."?categoryId=$categoryId&contentId=".$contentArray[$j]["CNTNT_TO_CTGRY_ID_PK"] );
    $tpl->parseCurrentBlock();
}

$tpl->setVariable( "categoryId", $categoryId );

// get the parsed template and print it
$tpl->get();
$tpl->show();
?>
