<?php
// +----------------------------------------------------------------------+
// | survey pilot                                                         |
// +----------------------------------------------------------------------+
// | Copyright (c) 2002 serie a - Digitale Medien und Systeme GmbH        |
// +----------------------------------------------------------------------+
// | Authors: 	Jrn Allert <allert@serie-a.de>                           |
// |          	Rene Renk <renk@serie-a.de>                               |
// +----------------------------------------------------------------------+
//
// $Id: group.adduser.php,v 1.1.1.1 2004/07/15 13:35:06 opensurveypilot Exp $

// start session
@session_start();

// require all configuration files and libraries
require_once("./../config/config.inc.php"); // common config file
require_once ("Validate.php"); // PEAR::Validate (must be included before common config file)
require_once($cfgPathToConf."/file.inc.php"); // project files
require_once($cfgPathToLib."/common.inc.php"); // common functions
require_once($cfgPathToAuthFiles."/config/auth.file.inc.php"); // auth files
require_once($cfgPathToAuthFiles."/lib/user.inc.php"); // auth user functions
require_once($cfgPathToAuthFiles."/lib/group.inc.php"); // auth group functions
require_once("HTML/Template/IT.php"); // PEAR::HTML_TEMPLATE_IT

// create new userFunctions object
$client = &new userFunctions;

//login check
if ($client->getAuthentication($_SESSION["sessionId"], session_id()) == false)
{
    //redirect to login page
    ?>
    <script type="text/javascript">
    <!--
    window.location.href="<?php echo $cfgUrlToProject."/".$fileAuthLogin; ?>";
    -->
    </script>
    <?php
    exit;
}

// function permission check
if($_SESSION["sessionUserStatusId"] < $permGroupAddUser)
{
    ?>
    <script type="text/javascript">
    <!--
    window.location.href="<?php echo $cfgUrlToProject."/".$fileNoPermission."?messageCode=2"; ?>";
    -->
    </script>
    <?php
    exit;
}

// create new groupFunctions object
$group = &new groupFunctions;

// get group id as get variable
$groupId = $_GET["groupId"];

// check if form was submitted
if($_SERVER["REQUEST_METHOD"] == "POST")
{
    // get group id as post variable
    $groupId = $_POST["groupId"];

    // get new user string
    $newUserString = $_POST["Addnewuser"];
    if($newUserString != "")
    {
        // cut last | in $newUserString;
        $newUserStringCut = substr($newUserString, 0, strlen($newUserString)-1);
        // put values in array
        $newUserArray = explode("|", $newUserStringCut);
    }
        
    // delete all users from group
    $group->deleteUsersFromGroup($groupId);
    if($group->errorMessage)
    {
        $userError .= $group->$errorMessage;
    }
    
    if(is_array($newUserArray))
    {
        // insert users in db 
        while(list($key,$val) = each($newUserArray))
        {
            $group->addUserToGroup($val, $groupId);
            if($group->errorMessage)
            {
                $userError .= $group->$errorMessage;
            }
        }
    }
    
	$userError = "<span style='color:blue'>".$lang_script["group.adduser.php"]["saveMessage"]."</span>";
}

$start = time(); 

// get Array with ordered group ids and names
$group->getOrderedGroups("0", $start);
$groupArray = $group->groupTree;
if($group->errorMessage)
{
    $userError .= $group->errorMessage;
}

// create javascript array 
$javascriptArray = "var groups = new Array(";

$arraySize = count($groupArray);
if(is_array($groupArray))
{
    while(list($key,$val) = each($groupArray))
    {
        $j++;
        if(is_array($val))
        {
            // print all users array
            if($key == "all")
            {
                // total num of users
                $userNum = $client->getUserNum();
                if($client->errorMessage)
                {
                    $userError .= $client->errorMessage;
                }
                if($userNum > 0)
                {
                    $javascriptArray .= "new Array(";
                    // get information of all users
                    $allUsers = $client->getUsersForOverview("", "0", $userNum, "USER_LASTNAME", "ASC");
                    $k = 0;
                    while(list($keyu,$valu) = each($allUsers))
                    {
                        $k++;
                        $javascriptArray .= "new Array(\"".$valu["USER_FIRSTNAME"]." ".$valu["USER_LASTNAME"]." (".$valu["USER_LOGIN"].")\", ".$valu["USER_ID_PK"].")";
                        if($k < $userNum)
                        {
                            $javascriptArray .= ", ";
                        }
                    }
                    $javascriptArray .= ")";
                }
                else
                {
                    $javascriptArray .=  "null";
                }
            }
            // print user array of each group
            else
            {
                $groupUsers = $group->getUsersInGroup($val[0]);
                if($group->errorMessage)
                {
                    $userError .= $group->errorMessage;
                }
                if(is_array($groupUsers))
                {
                    $javascriptArray .= "new Array(";
                    $m = 0;
                    $thisArraySize = count($groupUsers);
                    while(list($keyg,$valg) = each($groupUsers))
                    {
                        $m++;
                        $javascriptArray .= "new Array(";
                        $javascriptArray .=  "\"$valg[1] $valg[2] ($valg[3])\", $valg[0]";
                        $javascriptArray .= ")";
                        if($m < $thisArraySize)
                        {
                            $javascriptArray .= ", ";
                        }
                    }
                    $javascriptArray .= ")";
                }
                else
                {
                    $javascriptArray .=  "null";
                }
            }
            if($j < $arraySize)
            {
                $javascriptArray .= ", ";
            }          
        }
    }
}
$javascriptArray .= ");";

// create Template IT object
$tpl = new HTML_Template_IT($cfgPathToAuthTemplates);

// load template
$tpl->loadTemplatefile($templateGroupAddUser, true, true);

// set title
$tpl->setVariable( "applicationtitle", $cfgApplicationType.$cfgApplicationVersion);

$tpl->setVariable( "grouparray", $javascriptArray );
$tpl->setVariable( "formaction", $fileGroupAddUser );
$tpl->setVariable( "groupid", $groupId );
$tpl->setVariable( "errors", $userError );

$groupArray = $group->groupTree;
$l = 1;
while(list($key,$val) = each($groupArray))
{
    $tpl->setCurrentBlock( "groups" );
    $tpl->setVariable( "groupoptionvalue", $val[0] );
    $tpl->setVariable( "groupoptionname", $val[1] );
    $tpl->parseCurrentBlock();
    $l++;
}

$tpl->setCurrentBlock( "newgroups" );
$tpl->setVariable( "newgroupoptionvalue", "" );
$tpl->setVariable( "newgroupoptionname",  "");
$tpl->parseCurrentBlock();

// fetch all users in this group
$getGroupUsers = $group->getUsersInGroup($groupId);
if($group->errorMessage)
{
    $userError .= $group->errorMessage;
}
if(is_array($getGroupUsers))
{
    while(list($key,$val) = each($getGroupUsers))
    {
        $tpl->setCurrentBlock( "newuser" );
        $tpl->setVariable( "newuseroptionvalue", $val[0] );
        $tpl->setVariable( "newuseroptionname", $val[1]." ".$val[2]." (".$val[3].")" );
        $tpl->parseCurrentBlock();
        $containerValues .= $val[0]."|";
    }
}
$tpl->setVariable( "addnewuser",  $containerValues);

$tpl->setVariable( "lnk_edit", $fileGroupEdit."?groupId=".$groupId );
$tpl->setVariable( "lnk_manage", $fileGroupAddUser."?groupId=".$groupId );
$tpl->setVariable( "lnk_delete", $fileGroupDelete."?groupId=".$groupId );

// parse template
$tpl->parse();

// get the parsed template and print it
$tpl->get();
$tpl->show();
?>
