<?php
// +----------------------------------------------------------------------+
// | survey pilot                                                         |
// +----------------------------------------------------------------------+
// | Copyright (c) 2002 serie a - Digitale Medien und Systeme GmbH        |
// +----------------------------------------------------------------------+
// | Authors: 	Jrn Allert <allert@serie-a.de>                           |
// |          	Rene Renk <renk@serie-a.de>                               |
// +----------------------------------------------------------------------+
//
// $Id: group.delete.php,v 1.1.1.1 2004/07/15 13:35:06 opensurveypilot Exp $

// start session
@session_start();

// require all configuration files and libraries
require_once("./../config/config.inc.php"); // common config file
require_once($cfgPathToConf."/file.inc.php"); // project files
require_once($cfgPathToLib."/common.inc.php"); // common functions
require_once($cfgPathToAuthFiles."/config/auth.file.inc.php"); // auth files
require_once($cfgPathToAuthFiles."/lib/user.inc.php"); // auth user functions
require_once($cfgPathToAuthFiles."/lib/group.inc.php"); // auth group functions
require_once("HTML/Template/IT.php"); // PEAR::HTML_TEMPLATE_IT

// create new userFunctions object
$client = &new userFunctions;

//login check
if ($client->getAuthentication($_SESSION["sessionId"], session_id()) == false)
{
    //redirect to login page
    ?>
    <script type="text/javascript">
    <!--
    window.location.href="<?php echo $cfgUrlToProject."/".$fileAuthLogin; ?>";
    -->
    </script>
    <?php
    exit;
}

// function permission check
if($_SESSION["sessionUserStatusId"] < $permGroupDelete)
{
    ?>
    <script type="text/javascript">
    <!--
    window.location.href="<?php echo $cfgUrlToProject."/".$fileNoPermission."?messageCode=2"; ?>";
    -->
    </script>
    <?php
    exit;
}

// get user id for detailview
if(isset($_GET["groupId"]))
{
    $groupId = $_GET["groupId"];
}

// create new groupFunctions object
$group = &new groupFunctions;

// check if form was submitted
if($_SERVER["REQUEST_METHOD"] == "POST")
{
    $groupId = $_POST["groupId"];
    
    function deleteGroupRecursive($groupId)
    {
        global $group;
        
        // check if group has childs
        if($group->isNode($groupId))
        {
            $childGroups = $group->getChilds($groupId);
            for($j=0; $j<count($childGroups); $j++)
            {
                deleteGroupRecursive($childGroups[$j][0]);
            }
        }
        // delete all members of this group
        $group->deleteUsersFromGroup($groupId);
        if($group->errorMessage)
        {
            $userError .= $group->$errorMessage;
        }
        
        // delete all categories from this group
        $group->deleteCategoriesFromGroup($groupId);
        if($group->errorMessage)
        {
            $userError .= $group->$errorMessage;
        }
        
        // delete group
        $group->deleteGroup($groupId);
        if($group->errorMessage)
        {
            $userError .= $group->$errorMessage;
        }
    }
    
    deleteGroupRecursive($groupId);
    
    // redirect to success page
    if(!isset($userError))
    {
      ?>
        <script type="text/javascript">
        <!--
        window.location.href="<?php echo $cfgUrlToProject."/".$fileDeleteSuccessMessage; ?>";
        -->
        </script>
        <?php
    }
}

// fetch groupdata
$result = $group->getGroupInfo($groupId);

if($group->errorMessage)
{
    $userError .= $group->$errorMessage;
}

// create Template IT object
$tpl = new HTML_Template_IT($cfgPathToAuthTemplates);

// load template
$tpl->loadTemplatefile($templateGroupDelete, true, true);

// set title
$tpl->setVariable( "applicationtitle", $cfgApplicationType.$cfgApplicationVersion);

$tpl->setVariable( "formaction", $fileGroupDelete );
$tpl->setVariable( "errors", $userError );
$tpl->setVariable( "groupid", $groupId );
$tpl->setVariable( "name", $result["GROUP_NAME"] );

$tpl->setVariable( "lnk_edit", $fileGroupEdit."?groupId=".$groupId );
$tpl->setVariable( "lnk_manage", $fileGroupAddUser."?groupId=".$groupId );
$tpl->setVariable( "lnk_delete", $fileGroupDelete."?groupId=".$groupId );

// parse template
$tpl->parse();

// get the parsed template and print it
$tpl->get();
$tpl->show();   
?>

