<?php
// +----------------------------------------------------------------------+
// | survey pilot                                                         |
// +----------------------------------------------------------------------+
// | Copyright (c) 2002 serie a - Digitale Medien und Systeme GmbH        |
// +----------------------------------------------------------------------+
// | Authors: 	Jrn Allert <allert@serie-a.de>                           |
// |          	Rene Renk <renk@serie-a.de>                               |
// +----------------------------------------------------------------------+
//
// $Id: group.overview.php,v 1.1.1.1 2004/07/15 13:35:07 opensurveypilot Exp $

// start session
@session_start();

// require all configuration files and libraries
require_once("./../config/config.inc.php"); // common config file
require_once($cfgPathToConf."/file.inc.php"); // project files
require_once($cfgPathToLib."/common.inc.php"); // common functions
require_once($cfgPathToAuthFiles."/config/auth.file.inc.php"); // auth files
require_once($cfgPathToAuthFiles."/lib/user.inc.php"); // auth user functions
require_once($cfgPathToAuthFiles."/lib/group.inc.php"); // auth group functions
require_once("HTML/Template/IT.php"); // PEAR::HTML_TEMPLATE_IT

// create new userFunctions object
$client = &new userFunctions;

//login check
if ($client->getAuthentication($_SESSION["sessionId"], session_id()) == false)
{
    //redirect to login page
    ?>
    <script type="text/javascript">
    <!--
    window.location.href="<?php echo $cfgUrlToProject."/".$fileAuthLogin; ?>";
    -->
    </script>
    <?php
    exit;
}

// function permission check
if($_SESSION["sessionUserStatusId"] < $permGroupOverview)
{
    ?>
    <script type="text/javascript">
    <!--
    window.location.href="<?php echo $cfgUrlToProject."/".$fileNoPermission."?messageCode=2"; ?>";
    -->
    </script>
    <?php
    exit;
}

// create Template IT object
$tpl = new HTML_Template_IT($cfgPathToAuthTemplates);

// load template
$tpl->loadTemplatefile($templateGroupOverview, true, true);

// set title
$tpl->setVariable( "applicationtitle", $cfgApplicationType.$cfgApplicationVersion);

// get group id as get variable
if(isset($_GET["id"]))
{
    $groupId = $_GET["id"];
}
elseif(isset($_GET["groupId"]))
{
    $groupId = $_GET["groupId"];
}
// get actual num as get variable
if(isset($_GET["actualNum"]))
{
    $actualNum = $_GET["actualNum"];
}
// get orderBy as get variable
if(isset($_GET["orderBy"]))
{
    $orderBy = $_GET["orderBy"];
}
else
{
    $orderBy = "GROUP_NAME";
}
// get direction as get variable
if(isset($_GET["direction"]))
{
    $direction = $_GET["direction"];
}

// maximum rows
$maxRow = $cfgMaxRowInOverviews;
//total rows 

// create new groupFunctions object
$group = &new groupFunctions;
	
// check id get data and link pages
if($groupId != "")
{
    $groupInfo = $group->getGroupInfo($groupId);
    $totalNum = $groupInfo["groupNum"];
    $tpl->setVariable("groupname", $groupInfo["GROUP_NAME"] );
	$tpl->setVariable("userlink", $fileUserOverview."?id=".$groupId);
	$tpl->setVariable("usertarget", $fileFrameContentName);
	$tpl->setVariable("useroptionlink", $fileUserSubfolderToplevel."?id=".$groupId);
	$tpl->setVariable("useroptiontarget", $fileFrameToplevelName);
}
else
{
	$totalNum = $group->getGroupNum(0);
   	$tpl->setVariable("groupname", $lang_script["group.overview.php"]["mainGroups"]);
	$tpl->setVariable("userlink", $fileUserOverview);
	$tpl->setVariable("usertarget", $fileFrameContentName);
	$tpl->setVariable("useroptionlink", $fileUserToplevel);
	$tpl->setVariable("useroptiontarget", $fileFrameToplevelName);
}

// actual rows
if (!isset($actualNum))
{
    $actualNum = 0;
}
// get the Number of pages
$numPages = intval($totalNum/$maxRow);
if ($numPages < ($totalNum/$maxRow))
{ 
    $numPages++;
}

// prev button
if ($actualNum > 0) 
{
    $y = $actualNum - $maxRow;
    
    $tpl->setVariable( "prev_button", "<a class=\"navigation\" href=\"$fileGroupOverview?groupId=$groupId&actualNum=$y&orderBy=$orderBy&direction=$direction\">&laquo;</a>" );
}
// display pages
for ($i = 1; $i <= $numPages; $i++)
{
    $y = ($i * $maxRow) - $maxRow;
    
    $tpl->setCurrentBlock( "num_buttons" );
    $tpl->setVariable( "num_button", "[<a class=\"navigation\" href=\"$fileGroupOverview?groupId=$groupId&actualNum=$y&orderBy=$orderBy&direction=$direction\">$i</a>]" );
    $tpl->parseCurrentBlock();
}
//  next button
if ($actualNum < ($totalNum - $maxRow)) 
{
    $y = $actualNum  + $maxRow;
    
    $tpl->setVariable( "next_button", "<a class=\"navigation\" href=\"$fileGroupOverview?groupId=$groupId&actualNum=$y&orderBy=$orderBy&direction=$direction\">&raquo;</a>" );
}

if(($actualNum + $maxRow) < $totalNum)
{
    $entryTo = $actualNum + $maxRow;
}
else
{
    $entryTo = $totalNum;
}

// entry from
$entryFrom = $entryTo < 1 ? "0" : $actualNum +1;
$tpl->setVariable( "entry_from", $entryFrom );
$tpl->setVariable( "entry_to", $entryTo );
$tpl->setVariable( "entry_total", $totalNum );

// orderby butons
$tpl->setVariable( "order_link_name_up", "$fileGroupOverview?groupId=$groupId&actualNum=$actualNum&orderBy=GROUP_NAME&direction=ASC" );
$tpl->setVariable( "order_link_name_down", "$fileGroupOverview?groupId=$groupId&actualNum=$actualNum&orderBy=GROUP_NAME&direction=DESC" );
$tpl->setVariable( "order_link_insert_date_up", "$fileGroupOverview?groupId=$groupId&actualNum=$actualNum&orderBy=GROUP_GROUPTIME&direction=ASC" );
$tpl->setVariable( "order_link_insert_date_down", "$fileGroupOverview?groupId=$groupId&actualNum=$actualNum&orderBy=GROUP_GROUPTIME&direction=DESC" );

// get groups data
$groupsInGroup =  $group->getGroups($groupId, $actualNum, $maxRow, $orderBy, $direction);

// display groups
for($j=0;$j<count($groupsInGroup);$j++)
{
    $tpl->setCurrentBlock( "group_overview" );
    $tpl->setVariable( "id", $groupsInGroup[$j]["GROUP_ID_PK"] );
	$tpl->setVariable( "name", $groupsInGroup[$j]["GROUP_NAME"] );
    $tpl->setVariable( "insertdate", $groupsInGroup[$j]["GROUP_GROUPTIME"] );
    $tpl->setVariable( "edit_link", $fileGroupEdit."?groupId=".$groupsInGroup[$j]["GROUP_ID_PK"] );
	$tpl->setVariable( "manage_link", $fileGroupAddUser."?groupId=".$groupsInGroup[$j]["GROUP_ID_PK"] );
    $tpl->setVariable( "delete_link", $fileGroupDelete."?groupId=".$groupsInGroup[$j]["GROUP_ID_PK"] );
    $tpl->setVariable( "print_link", "#" );
    $tpl->parseCurrentBlock();
}

// get the parsed template and print it
$tpl->get();
$tpl->show();
?>
