<?php
// +----------------------------------------------------------------------+
// | survey pilot                                                         |
// +----------------------------------------------------------------------+
// | Copyright (c) 2002 serie a - Digitale Medien und Systeme GmbH        |
// +----------------------------------------------------------------------+
// | Authors: 	Jrn Allert <allert@serie-a.de>                           |
// |          	Rene Renk <renk@serie-a.de>                               |
// +----------------------------------------------------------------------+
//
// $Id: group.user.php,v 1.1.1.1 2004/07/15 13:35:07 opensurveypilot Exp $

// start session
@session_start();

// require all configuration files and libraries
require_once("./../config/config.inc.php"); // common config file
require_once ("Validate.php"); // PEAR::Validate (must be included before common config file)
require_once($cfgPathToConf."/file.inc.php"); // project files
require_once($cfgPathToLib."/common.inc.php"); // common functions
require_once($cfgPathToAuthFiles."/config/auth.file.inc.php"); // auth files
require_once($cfgPathToAuthFiles."/lib/user.inc.php"); // auth user functions
require_once($cfgPathToAuthFiles."/lib/group.inc.php"); // auth group functions
require_once("HTML/Template/IT.php"); // PEAR::HTML_TEMPLATE_IT

// create new userFunctions object
$client = &new userFunctions;

//login check
if ($client->getAuthentication($_SESSION["sessionId"], session_id()) == false)
{
    //redirect to login page
    ?>
    <script type="text/javascript">
    <!--
    window.location.href="<?php echo $cfgUrlToProject."/".$fileAuthLogin; ?>";
    -->
    </script>
    <?php
    exit;
}

// function permission check
if($_SESSION["sessionUserStatusId"] < $permGroupUser)
{
    ?>
    <script type="text/javascript">
    <!--
    window.location.href="<?php echo $cfgUrlToProject."/".$fileNoPermission."?messageCode=2"; ?>";
    -->
    </script>
    <?php
    exit;
}

$groupId =  $_GET["groupId"];
$permissionId = $_GET["permissionId"];

// create Template IT object
$tpl = new HTML_Template_IT($cfgPathToAuthTemplates);

// load template
$tpl->loadTemplatefile($templateGroupUser, true, true);

// set title
$tpl->setVariable( "applicationtitle", $cfgApplicationType.$cfgApplicationVersion);

// get user
$userArray = $client->getUsersForOverview($groupId, 0, 10, "USER_LASTNAME", "ASC");
for($j=0;$j<count($userArray);$j++)
{
    $tpl->setCurrentBlock( "user_overview" );
    $tpl->setVariable( "company", $userArray[$j]["USER_COMPANY"] );
    $tpl->setVariable( "detaillink", $fileUserDetailView."?userId=".$userArray[$j]["USER_ID_PK"] );
    $tpl->setVariable( "lastname", $userArray[$j]["USER_LASTNAME"] );
    $tpl->setVariable( "firstname", $userArray[$j]["USER_FIRSTNAME"] );
    $tpl->setVariable( "status", $client->getNameForStatusId($userArray[$j]["USER_USERSTATUS_ID_FK"]) );
    $tpl->setVariable( "insertdate", $userArray[$j]["USER_DATE"] );
    $tpl->parseCurrentBlock();
}
if(!is_array($userArray))
{
    $tpl->touchBlock( "user_overview" );
}

$tpl->setVariable( "errors", $groupError );

$tpl->setVariable( "lnk_show", $fileGroupUser."?groupId=".$groupId."&permissionId=".$permissionId );
$tpl->setVariable( "lnk_edit", $filePermissionEdit."?groupId=".$groupId."&permissionId=".$permissionId );
$tpl->setVariable( "lnk_delete", $filePermissionDelete."?groupId=".$groupId."&permissionId=".$permissionId );

// parse template
$tpl->parse();

// get the parsed template and print it
$tpl->get();
$tpl->show();
?>