<?php
// +----------------------------------------------------------------------+
// | sa auth module - user management xmlrpc server                       |
// +----------------------------------------------------------------------+
// | Copyright (c) 2002 serie a - Digitale Medien und Systeme GmbH        |
// +----------------------------------------------------------------------+
// | Authors: J?rn Allert <allert@serie-a.de>                             |
// |          Rene Renk <renk@serie-a.de>                                 |
// +----------------------------------------------------------------------+
//
// $Id: userfunctions.inc.php,v 1.1.1.1 2004/07/15 13:35:21 opensurveypilot Exp $

// require all configuration files and libraries
//require_once("/var/www/assessmentpilot.de/cvs/assessment/administration/config/config.inc.php"); // common config file
require_once("./../../../config/config.inc.php"); // common config file
require_once($cfgPathToConf."/file.inc.php"); // project files
require_once($cfgPathToLib."/xmlrpc/xmlrpc.inc"); // xmlrpc client library
require_once($cfgPathToLib."/xmlrpc/xmlrpcs.inc"); // xmlrpc server library
require_once ("DB.php"); // PEAR::DB

/**
*	returns error message
*
*	@access	private
*	@param	string	$err
*	@return	string  xmlrpc error response
*/
function returnErrorMessage($err)
{
    global $xmlrpcerruser;
    return new sa_xmlrpcresp(0, $xmlrpcerruser, $err); 
}

/**
*	reverse function of htmlentities()
*
*	@access	private
*	@param	string	$string
*	@return	string  string without coded special chars
*/
function unHtmlEntities($string)
{
	$trans_tbl = get_html_translation_table (HTML_ENTITIES);
	$trans_tbl = array_flip ($trans_tbl);
	return strtr ($string, $trans_tbl);
}

/**
*	returns user status
*
*	@access	public
*	@param	string	$userLogin
*	@param	string	$userPassword
*	@return	int     user status id
*/
function getUserStatus($userLogin, $userPassword)
{
    global $cfgTabAuthUserStatus;
    global $cfgTabAuthUser;
    
    // check if userLogin and userPassword is there
    if ($userLogin == "" or $userPassword == "")
    {
        return false;
    }
    
    // connect to db
    $db = DB::connect(DSN, true);
    if (DB::isError($db)) 
    {    
       return false;
    }
    
    // check user status
    $sql = "select $cfgTabAuthUserStatus.USERSTATUS_ID_PK 
		from $cfgTabAuthUserStatus, $cfgTabAuthUser 
        where $cfgTabAuthUser.USER_LOGIN = '$userLogin' 
		and $cfgTabAuthUser.USER_PASSWORD = '$userPassword' 
		and $cfgTabAuthUser.USER_USERSTATUS_ID_FK = $cfgTabAuthUserStatus.USERSTATUS_ID_PK";
    
    $result = $db->getRow($sql);
    if (DB::isError($result)) 
    {
        return false;
    }
    else
    {
        return $result[0];
    }
}

/**
*	fetch user data
*
*	@access	public
*	@param	string	$params xmlrpc string with userLogin and userPassword
*	@return	string  xmlrpc response
*/
function fetchUser($params)
{
    global $xmlrpcerruser; 
    global $cfgTabAuthUser;
    
    // receive login
    $val = $params->params[0];
    // check if userLogin is there and the correct type
    if (isset($val) && ($val->scalartyp()=="string")) 
    {
        $userLogin = $val->scalarval();
    }
    else
    {
        return returnErrorMessage("No POST value for login");
        exit;
    }
    
    // receive password
    $val = $params->params[1];
    // check if user Password is there and the correct type
    if (isset($val) && ($val->scalartyp()=="string")) 
    {
        $userPassword = $val->scalarval();
    }
    else
    {
        return returnErrorMessage("No POST value for password");
        exit;
    }
    
    // receive userId
    $val = $params->params[2];
    // check if id is there and the correct type
    if (isset($val) && ($val->scalartyp()=="string")) 
    {
        $fetchId = $val->scalarval();
    }
    else
    {
        return returnErrorMessage("No POST value for fetchId");
        exit;
    }
    
    // check if user is allowed to fetch userdata
    if(!getUserStatus($userLogin, $userPassword) >= 1)
    {
        return returnErrorMessage("No permission for fetch userdata");
        exit;
    }
        
    // connect to db
    $db = DB::connect(DSN, true);
    if (DB::isError($db)) 
    {    
        return returnErrorMessage($db->getMessage());
        exit;
    }
    
    // fetch all  main user data
    $sql = "select * 
		from $cfgTabAuthUser 
		where USER_ID_PK = '$fetchId'";
	//
    $result = $db->query($sql);
    if (DB::isError($result)) 
    {
        return returnErrorMessage($result->getMessage());
        exit;
    }
    else
    {
        // check if user is valid
        if($result->numRows() == 1)
        {
           $struct[0] = new sa_xmlrpcval(1, 'string');
        }
        else
        {
            $struct[0] = new sa_xmlrpcval(0, 'string');
        }
        // fetch userdata
        while ($row = $result->fetchRow()) 
        {
            for($k=0;$k<$result->numCols();$k++)
            {
                $struct[$k+1] = new sa_xmlrpcval(htmlentities($row[$k]), 'string');
            }
        }
    }
    
    // close conection
    $db->disconnect();
                       
    // return userdata
    return new sa_xmlrpcresp(new sa_xmlrpcval($struct, 'struct'));
}

/**
*	updates user data
*
*
*	@access	public
*	@param	string	$params xmlrpc string with userdata
*	@return	string  xmlrpc response
*/
function updateUser($params)
{
    global $xmlrpcerruser; 
    global $cfgTabAuthUser;
    
    // receive params and put them into array userArray
    $paramLen = $params->getNumParams();
    //return returnErrorMessage($paramLen);
    for($k=0; $k < $paramLen; $k++)
    {
        $val = $params->getParam($k);
        if (isset($val) && ($val->scalartyp()=="string")) 
        {
            $userArray[$k] = $val->scalarval();
        }
    }
    
    // check if userArray is there and is an array
    if(!is_array($userArray))
    {
        return returnErrorMessage("userArray is no array");
        exit;
    }
    
    // check for needed values
    $sessionLogin = $userArray[0];
    $sessionPassword = $userArray[1];
    $updateId    = $userArray[2];
    $userFirstname = $userArray[7];
    $userLastname = $userArray[8];
    $userEmail = $userArray[14];
    
   // check if user is allowed to update userdata
    if(!getUserStatus($sessionLogin, $sessionPassword) >= 4)
    {
        return returnErrorMessage("No permission for update userdata");
        exit;
    }
    
    // connect to db
    $db = DB::connect(DSN, true);
    if (DB::isError($db)) 
    {    
        return returnErrorMessage($db->getMessage());
        exit;
    }
    
    //check if user is in db and return user id
    $sql = "select USER_ID_PK 
		from $cfgTabAuthUser 
		where USER_ID_PK = '$updateId'";
    $result = $db->query($sql);
    if (DB::isError($result)) 
    {
        return returnErrorMessage($result->getMessage());
        exit;
    }
    else
    {
        // check if user is valid
        if($result->numRows() == 0)
        {
            return returnErrorMessage("User is not valid");
            exit;
        }
        else
        {
            // get userId
            while ($row = $result->fetchRow()) 
            {
                $userId = $row[0];
            }
            if($userId == "")
            {
                return returnErrorMessage("No User Id for this User");
                exit;
            }
        }
    }
    
    // updata user data (you have to change this, if you do changes on cfgTabAuthUser
    $sql = "update $cfgTabAuthUser set ";
    while(list($key, $val) = each($userArray))
    {
        $val = unHtmlEntities($val);
        if($key == 3 and $val != "{not_set}")
        {
            $sql .= "USER_LOGIN = '$val', ";
        }
        if($key == 4 and $val != "{not_set}")
        {
            $sql .= "USER_PASSWORD = '$val', ";
        } 
        if($key == 5 and $val != "{not_set}")
        {
            $sql .= "USER_USERSTATUS_ID_FK = '$val', ";
        }
        if($key == 6 and $val != "{not_set}")
        {
            $sql .= "USER_LANGUAGE_ID_FK = '$val', ";
        } 
        if($key == 7 and $val != "{not_set}")
        {
            $sql .= "USER_FIRSTNAME = '$val', ";
        }
        if($key == 8 and $val != "{not_set}")
        {
            $sql .= "USER_LASTNAME = '$val', ";
        }
        if($key == 9 and $val != "{not_set}")
        {
            $sql .= "USER_COMPANY = '$val', ";
        }
        if($key == 10 and $val != "{not_set}")
        {
            $sql .= "USER_POSITION = '$val', ";
        }
        if($key == 11 and $val != "{not_set}")
        {
            $sql .= "USER_STREET = '$val', ";
        }
        if($key == 12 and $val != "{not_set}")
        {
            $sql .= "USER_POSTALCODE = '$val', ";
        }
        if($key == 13 and $val != "{not_set}")
        {
            $sql .= "USER_CITY = '$val', ";
        }
        if($key == 14 and $val != "{not_set}")
        {
            $sql .= "USER_EMAIL = '$val', ";
        }
        if($key == 15 and $val != "{not_set}")
        {
            $sql .= "USER_PHONE = '$val', ";
        }
        if($key == 16 and $val != "{not_set}")
        {
            $sql .= "USER_FAX = '$val', ";
        }
        if($key == 17 and $val != "{not_set}")
        {
            $sql .= "USER_MOBILE = '$val', ";
        }
        if($key == 18 and $val != "{not_set}")
        {
            $sql .= "USER_HOMEPAGE = '$val', ";
        }
    }
    // insert timestamp
    $sql .= "USER_LASTCHANGE = NOW()";
    $sql .= " where USER_ID_PK = $updateId";

    $result = $db->query($sql);
    if (DB::isError($result)) 
    {
        //return returnErrorMessage($sql);
        return returnErrorMessage($result->getMessage());
        exit;
    }
        
    // return userdata
    //return new sa_xmlrpcresp(new sa_xmlrpcval($sql, 'string'));
    return new sa_xmlrpcresp(new sa_xmlrpcval(true, 'boolean'));
}

/**
*	adds user 
*
*	@access	public
*	@param	string	$params xmlrpc string with userLogin and userPassword
*	@return	string  xmlrpc response
*/
function addUser($params)
{
    global $xmlrpcerruser; 
    global $cfgTabAuthUser;
   
    // receive params and put them into array userArray
    $paramLen = $params->getNumParams();
    for($k=0; $k < $paramLen; $k++)
    {
        $val = $params->getParam($k);
        if (isset($val) && ($val->scalartyp()=="string")) 
        {
            $userArray[$k] = $val->scalarval();
        }
    }
    
    // check if userArray is there and is an array
    if(!is_array($userArray))
    {
        return returnErrorMessage("userArray is no array");
        exit;
    }
    
    // get params
    $sessionLogin = $userArray[0];
    $sessionPassword = $userArray[1];
    $userLogin = $userArray[3];
    $userPassword = $userArray[4];
    $userFkStatId = $userArray[5];
    $userFkLangId = $userArray[6];
    $userFirstname = unHtmlEntities($userArray[7]);
    $userLastname = unHtmlEntities($userArray[8]);
    $userCompany = unHtmlEntities($userArray[9]);
    $userPosition = unHtmlEntities($userArray[10]);
    $userStreet = unHtmlEntities($userArray[11]);
    $userPostalcode = unHtmlEntities($userArray[12]);
    $userCity = unHtmlEntities($userArray[13]);
    $userEmail = $userArray[14];
    $userPhone = $userArray[15];
    $userFax = $userArray[16];
    $userMobile = $userArray[17];
    $userHomepage = $userArray[18];
    
    // check for needed values
    if($userLogin == "" or $userPassword == "" or $userFirstname == "" or $userLastname == "" or $userEmail == "")
    {
        return returnErrorMessage("no Values for login, password, firstname, lastname or email posted");
        exit;
    }
    
    // check if user is allowed to add userdata
    if(!getUserStatus($sessionLogin, $sessionPassword) >= 4)
    {
        return returnErrorMessage("No permission for add userdata");
        exit;
    }
    
    // connect to db
    $db = DB::connect(DSN, true);
    if (DB::isError($db)) 
    {    
        return returnErrorMessage($db->getMessage());
        exit;
    }
    
    // check if user already exists
    $sql = "select 1 from $cfgTabAuthUser
        where 
        USER_LOGIN = '$userLogin'";
    $result = $db->query($sql);
    if($result->numRows() == 1)
    {   
        return returnErrorMessage("this user does already exist");
        exit;
    }
    
    // get next free id
    $userId = $db->nextId($cfgTabAuthUser);
    
    // insert user in table $cfgTabAuthUSer
    $sql = "insert into $cfgTabAuthUser 
            (USER_ID_PK, USER_USERSTATUS_ID_FK, USER_LANGUAGE_ID_FK, USER_LOGIN, USER_PASSWORD, USER_FIRSTNAME, USER_LASTNAME, 
            USER_COMPANY, USER_POSITION, USER_STREET, USER_POSTALCODE, USER_CITY, USER_EMAIL, 
            USER_PHONE, USER_FAX, USER_MOBILE, USER_HOMEPAGE, USER_DATE, USER_LASTCHANGE) 
            values 
            ('$userId', '$userFkStatId', '$userFkLangId', '$userLogin', '$userPassword', '$userFirstname', '$userLastname', 
            '$userCompany', '$userPosition', '$userStreet', '$userPostalcode', '$userCity', '$userEmail', 
            '$userPhone', '$userFax', '$userMobile', '$userHomepage', NOW(), NOW())
            ";
    $result = $db->query($sql);
    if (DB::isError($result)) 
    {
        return returnErrorMessage($result->getMessage());
        exit;
    }
       
    // return new userId
    return new sa_xmlrpcresp(new sa_xmlrpcval($userId, 'int'));
}

/**
*	deletes user 
*
*	@access	public
*	@param	string	$params xmlrpc string with userLogin and userPassword
*	@return	string  xmlrpc response
*/
function deleteUser($params)
{
    global $xmlrpcerruser; 
    global $cfgTabAuthUser;
    
    // receive login
    $val = $params->params[0];
    // check if userLogin is there and the correct type
    if (isset($val) && ($val->scalartyp()=="string")) 
    {
        $sessionLogin = $val->scalarval();
    }
    else
    {
        return returnErrorMessage("No POST value for login");
        exit;
    }
    
    // receive password
    $val = $params->params[1];
    // check if user Password is there and the correct type
    if (isset($val) && ($val->scalartyp()=="string")) 
    {
        $sessionPassword = $val->scalarval();
    }
    else
    {
        return returnErrorMessage("No POST value for password");
        exit;
    }
    
    // receive userId
    $val = $params->params[2];
    // check if id is there and the correct type
    if (isset($val) && ($val->scalartyp()=="string")) 
    {
        $userId = $val->scalarval();
    }
    else
    {
        return returnErrorMessage("No POST value for iserId");
        exit;
    }
    
    // check if user is allowed to add userdata
    if(!getUserStatus($sessionLogin, $sessionPassword) >= 4)
    {
        return returnErrorMessage("No permission to delete userdata");
        exit;
    }
    
    // connect to db
    $db = DB::connect(DSN, true);
    if (DB::isError($db)) 
    {    
        return returnErrorMessage($db->getMessage());
        exit;
    }
    
    // check if user exists
    $sql = "select 1 from $cfgTabAuthUser 
		where USER_ID_PK = $userId";
    $result = $db->query($sql);
    if($result->numRows() != 1)
    {
        return returnErrorMessage("User does not exist");
        exit;
    }
    
    
    // delete user from table $cfgTabAuthUser
    $sql = "delete from $cfgTabAuthUser 
		where USER_ID_PK = $userId";
    $result = $db->query($sql);
    if (DB::isError($result)) 
    {
        return returnErrorMessage($result->getMessage());
        exit;
    }
    
    // return true
    return new sa_xmlrpcresp(new sa_xmlrpcval(true, 'boolean'));
}



//register functions
$functions = array(
            "user.fetchUser" => array("function" => "fetchUser"),
            "user.updateUser" => array("function" => "updateUser"),
            "user.addUser" => array("function" => "addUser"), 
            "user.deleteUser" => array("function" => "deleteUser")
            );

// create xmlrpc server
$server = new sa_xmlrpc_server($functions); 
?>
