<?php
// +----------------------------------------------------------------------+
// | survey pilot                                                         |
// +----------------------------------------------------------------------+
// | Copyright (c) 2002 serie a - Digitale Medien und Systeme GmbH        |
// +----------------------------------------------------------------------+
// | Authors: 	Jrn Allert <allert@serie-a.de>                           |
// |          	Rene Renk <renk@serie-a.de>                               |
// +----------------------------------------------------------------------+
//
// $Id: permission.add.php,v 1.1.1.1 2004/07/15 13:35:08 opensurveypilot Exp $

// start session
@session_start();

// require all configuration files and libraries
require_once("./../config/config.inc.php"); // common config file
require_once ("Validate.php"); // PEAR::Validate (must be included before common config file)
require_once($cfgPathToConf."/file.inc.php"); // project files
require_once($cfgPathToLib."/common.inc.php"); // common functions
require_once($cfgPathToAuthFiles."/config/auth.file.inc.php"); // auth files
require_once($cfgPathToAuthFiles."/lib/user.inc.php"); // auth user functions
require_once($cfgPathToAuthFiles."/lib/group.inc.php"); // auth group functions
require_once($cfgPathToAuthFiles."/lib/permission.inc.php"); // auth category functions
require_once("HTML/Template/IT.php"); // PEAR::HTML_TEMPLATE_IT

// create new userFunctions object
$client = &new userFunctions;

//login check
if ($client->getAuthentication($_SESSION["sessionId"], session_id()) == false)
{
    //redirect to login page
    ?>
    <script type="text/javascript">
    <!--
    window.location.href="<?php echo $cfgUrlToProject."/".$fileAuthLogin; ?>";
    -->
    </script>
    <?php
    exit;
}

// function permission check
if($_SESSION["sessionUserStatusId"] < $permPermissionAdd)
{
    ?>
    <script type="text/javascript">
    <!--
    window.location.href="<?php echo $cfgUrlToProject."/".$fileNoPermission."?messageCode=2"; ?>";
    -->
    </script>
    <?php
    exit;
}

// create new permissionFunctions object
$permission = &new permissionFunctions;

$categoryId = $_GET["categoryId"]; 

// check if form was submitted
if($_SERVER["REQUEST_METHOD"] == "POST")
{
    $categoryId = $_POST["categoryId"];
    
    // get groupId
    $groupId = $_POST["groupId"];
    if($groupId == "")
    {
        $errors["groupId"] = "Bitte geben Sie eine Gruppe an.";
    }
    
    // get permissionId
    $permissionId = $_POST["permissionId"];
    if($permissionId == "")
    {
        $errors["permissionId"] = "Bitte geben Sie ein Recht.";
    }
    
    // put error Array in String
    if($errors)
    {
        foreach($errors as $error)
        {
            $userError .= "$error<br>";
        }
    }
    // no errors, so we can insert new permission    
    else
    {
        // add permission
        $permission->addpermission($groupId, $categoryId, $permissionId);
       	$userError = "<span style='color:blue'>Speichern erfolgreich</span>";
    }
}

// create Template IT object
$tpl = new HTML_Template_IT($cfgPathToAuthTemplates);

// load template
$tpl->loadTemplatefile($templatePermissionAdd, true, true);

// set title
$tpl->setVariable( "applicationtitle", $cfgApplicationType.$cfgApplicationVersion);

$tpl->setVariable( "formaction", $filePermissionAdd );

$tpl->setVariable( "errors", $userError );

// create new groupFunctions object
$group = &new groupFunctions;

// get Array with ordered group ids and names
$start = time(); 
$group->getOrderedGroups("0", $start);
$groupArray = $group->groupTree;
$l = 1;
while(list($key,$val) = each($groupArray))
{
    if($val[1] != "alle User")
    {
        $tpl->setCurrentBlock( "groups" );
        $tpl->setVariable( "groupoptionvalue", $val[0] );
        $tpl->setVariable( "groupoptionname", $val[1] );
        $tpl->parseCurrentBlock();
        $l++;
    }
}

$permissionArray = Array("1", "2", "4");
while(list($key,$val) = each($permissionArray))
{
    $tpl->setCurrentBlock( "permissions" );
    $tpl->setVariable( "permissionoptionvalue", $val );
    $tpl->setVariable( "permissionoptionname", $permission->getNameForPermissionId($val) );
    $tpl->parseCurrentBlock();
    $l++;
}

$tpl->setVariable( "categoryid", $categoryId );

$tpl->setVariable( "lnk_add", $filePermissionAdd."?categoryId=".$categoryId );
$tpl->setVariable( "lnk_edit", $fileCategoryAddContent."?categoryId=".$categoryId );
$tpl->setVariable( "lnk_delete", $fileCategoryDelete."?categoryId=".$categoryId );

// parse template
$tpl->parse();

// get the parsed template and print it
$tpl->get();
$tpl->show();
?>