<?php
// +----------------------------------------------------------------------+
// | survey pilot                                                         |
// +----------------------------------------------------------------------+
// | Copyright (c) 2002 serie a - Digitale Medien und Systeme GmbH        |
// +----------------------------------------------------------------------+
// | Authors: 	Jrn Allert <allert@serie-a.de>                           |
// |          	Rene Renk <renk@serie-a.de>                               |
// +----------------------------------------------------------------------+
//
// $Id: permission.delete.php,v 1.1.1.1 2004/07/15 13:35:08 opensurveypilot Exp $

// start session
@session_start();

// require all configuration files and libraries
require_once("./../config/config.inc.php"); // common config file
require_once($cfgPathToConf."/file.inc.php"); // project files
require_once($cfgPathToLib."/common.inc.php"); // common functions
require_once($cfgPathToAuthFiles."/config/auth.file.inc.php"); // auth files
require_once($cfgPathToAuthFiles."/lib/user.inc.php"); // auth user functions
require_once($cfgPathToAuthFiles."/lib/permission.inc.php"); // auth permission functions
require_once("HTML/Template/IT.php"); // PEAR::HTML_TEMPLATE_IT

// create new userFunctions object
$client = &new userFunctions;

//login check
if ($client->getAuthentication($_SESSION["sessionId"], session_id()) == false)
{
    //redirect to login page
    ?>
    <script type="text/javascript">
    <!--
    window.location.href="<?php echo $cfgUrlToProject."/".$fileAuthLogin; ?>";
    -->
    </script>
    <?php
    exit;
}

// function permission check
if($_SESSION["sessionUserStatusId"] < $permPermissionDelete)
{
    ?>
    <script type="text/javascript">
    <!--
    window.location.href="<?php echo $cfgUrlToProject."/".$fileNoPermission."?messageCode=2"; ?>";
    -->
    </script>
    <?php
    exit;
}

$groupId =  $_GET["groupId"];
$permissionId = $_GET["permissionId"];

// create new permissionFunctions object
$permission = &new permissionFunctions;

// check if form was submitted
if($_SERVER["REQUEST_METHOD"] == "POST")
{
    $permissionId = $_POST["permissionId"];
    
    // delete permission
    $permission->deletePermission($permissionId);
    if($permission->errorMessage)
    {
        $userError .= $permission->$errorMessage;
    }
    
    // redirect to success page
    if(!isset($userError))
    {
      ?>
        <script type="text/javascript">
        <!--
        window.location.href="<?php echo $cfgUrlToProject."/".$fileCommonSuccessMessage; ?>";
        -->
        </script>
        <?php
    }
}

// fetch permissiondata
$result = $permission->getPermissionInfo($permissionId);
if($permission->errorMessage)
{
    $userError .= $permission->$errorMessage;
}

// create Template IT object
$tpl = new HTML_Template_IT($cfgPathToAuthTemplates);

// load template
$tpl->loadTemplatefile($templatePermissionDelete, true, true);

// set title
$tpl->setVariable( "applicationtitle", $cfgApplicationType.$cfgApplicationVersion);

$tpl->setVariable( "formaction", $filePermissionDelete );
$tpl->setVariable( "errors", $userError );
$tpl->setVariable( "group", $result["GROUP_NAME"] );
$tpl->setVariable( "permissionmode", $permission->getNameForPermissionId($result["CTGRY_TO_PRMSSN_PERMSSN_ID_FK"]) );
$tpl->setVariable( "permissionid", $permissionId );

$tpl->setVariable( "lnk_show", $fileGroupUser."?groupId=".$groupId."&permissionId=".$permissionId );
$tpl->setVariable( "lnk_edit", $filePermissionEdit."?groupId=".$groupId."&permissionId=".$permissionId );
$tpl->setVariable( "lnk_delete", $filePermissionDelete."?groupId=".$groupId."&permissionId=".$permissionId );

// parse template
$tpl->parse();

// get the parsed template and print it
$tpl->get();
$tpl->show();   
?>

