<?php
// +----------------------------------------------------------------------+
// | survey pilot                                                         |
// +----------------------------------------------------------------------+
// | Copyright (c) 2002 serie a - Digitale Medien und Systeme GmbH        |
// +----------------------------------------------------------------------+
// | Authors: 	Jrn Allert <allert@serie-a.de>                           |
// |          	Rene Renk <renk@serie-a.de>                               |
// +----------------------------------------------------------------------+
//
// $Id: permission.edit.php,v 1.1.1.1 2004/07/15 13:35:08 opensurveypilot Exp $

// start session
@session_start();

// require all configuration files and libraries
require_once("./../config/config.inc.php"); // common config file
require_once ("Validate.php"); // PEAR::Validate (must be included before common config file)
require_once($cfgPathToConf."/file.inc.php"); // project files
require_once($cfgPathToLib."/common.inc.php"); // common functions
require_once($cfgPathToAuthFiles."/config/auth.file.inc.php"); // auth files
require_once($cfgPathToAuthFiles."/lib/user.inc.php"); // auth user functions
require_once($cfgPathToAuthFiles."/lib/group.inc.php"); // auth group functions
require_once($cfgPathToAuthFiles."/lib/permission.inc.php"); // auth category functions
require_once("HTML/Template/IT.php"); // PEAR::HTML_TEMPLATE_IT

// create new userFunctions object
$client = &new userFunctions;

//login check
if ($client->getAuthentication($_SESSION["sessionId"], session_id()) == false)
{
    //redirect to login page
    ?>
    <script type="text/javascript">
    <!--
    window.location.href="<?php echo $cfgUrlToProject."/".$fileAuthLogin; ?>";
    -->
    </script>
    <?php
    exit;
}

// function permission check
if($_SESSION["sessionUserStatusId"] < $permPermissionEdit)
{
    ?>
    <script type="text/javascript">
    <!--
    window.location.href="<?php echo $cfgUrlToProject."/".$fileNoPermission."?messageCode=2"; ?>";
    -->
    </script>
    <?php
    exit;
}

// create Template IT object
$tpl = new HTML_Template_IT($cfgPathToAuthTemplates);
// load template
$tpl->loadTemplatefile($templatePermissionEdit, true, true);

// set title
$tpl->setVariable( "applicationtitle", $cfgApplicationType.$cfgApplicationVersion);

// create new permissionFunctions object
$permission = &new permissionFunctions;

// create new groupFunctions object
$group = &new groupFunctions;

// get category Id
$categoryId = $_GET["categoryId"]; 
// get permissionId
$groupId =  $_GET["groupId"];
$permissionId = $_GET["permissionId"];

// check if form was submitted
if($_SERVER["REQUEST_METHOD"] == "POST")
{
    // get category Id
    $categoryId = $_POST["categoryId"]; 
    // get permissionId
    $permissionId = $_POST["permissionId"];
        
    // get groupId
    $groupId = $_POST["groupId"];
    if($groupId == "")
    {
        $errors["groupId"] = "Bitte geben Sie eine Gruppe an.";
    }
    
    // get permissionModeId
    $permissionModeId = $_POST["permissionModeId"];
    if($permissionModeId == "")
    {
        $errors["permissionModeId"] = "Bitte whlen Sie ein Recht aus..";
    }
    
    // put error Array in String
    if($errors)
    {
        foreach($errors as $error)
        {
            $userError .= "$error<br>";
        }
    }
    // no errors, so we can insert new permission    
    else
    {
        // edit permission
       $permission->editPermission($permissionId, $groupId, $permissionModeId);
         
        // check for error
        if ($permission->errorMessage)
        {
            $userError = $permission->errorMessage;
            
            $tpl->setVariable( "formaction", $filePermissionEdit );
    
            $tpl->setVariable( "errors", $userError );
            
            // get Array with ordered group ids and names
            $start = time(); 
            $group->getOrderedGroups("0", $start);
            $groupArray = $group->groupTree;
            $l = 1;
            while(list($key,$val) = each($groupArray))
            {
                if($val[1] != "alle User")
                {
                    $selected = $groupId == $val[0] ? "selected" : "";
                    $tpl->setCurrentBlock( "groups" );
                    $tpl->setVariable( "groupoptionvalue", $val[0] );
                    $tpl->setVariable( "groupoptionselected", $selected );
                    $tpl->setVariable( "groupoptionname", $val[1] );
                    $tpl->parseCurrentBlock();
                    $l++;
                }
            }
            
            // show all permissions
            $permissions = Array("1", "2", "4");
            while(list($key,$val) = each($permissions))
            {
                $selected = $permissionModeId == $val ? "selected" : "";
                $tpl->setCurrentBlock( "permissions" );
                $tpl->setVariable( "permissionoptionvalue", $val );
                $tpl->setVariable( "permissionoptionselected", $selected );
                $tpl->setVariable( "permissionoptionname", $permission->getNameForPermissionId($val) );
                $tpl->parseCurrentBlock();
                $l++;
            }
        }
        // redirect to success page
        else
        {
		
			            $userError = $permission->errorMessage;
            
            $tpl->setVariable( "formaction", $filePermissionEdit );
    
            $tpl->setVariable( "errors", $userError );
            
            // get Array with ordered group ids and names
            $start = time(); 
            $group->getOrderedGroups("0", $start);
            $groupArray = $group->groupTree;
            $l = 1;
            while(list($key,$val) = each($groupArray))
            {
                if($val[1] != "alle User")
                {
                    $selected = $groupId == $val[0] ? "selected" : "";
                    $tpl->setCurrentBlock( "groups" );
                    $tpl->setVariable( "groupoptionvalue", $val[0] );
                    $tpl->setVariable( "groupoptionselected", $selected );
                    $tpl->setVariable( "groupoptionname", $val[1] );
                    $tpl->parseCurrentBlock();
                    $l++;
                }
            }
            
            // show all permissions
            $permissions = Array("1", "2", "4");
            while(list($key,$val) = each($permissions))
            {
                $selected = $permissionModeId == $val ? "selected" : "";
                $tpl->setCurrentBlock( "permissions" );
                $tpl->setVariable( "permissionoptionvalue", $val );
                $tpl->setVariable( "permissionoptionselected", $selected );
                $tpl->setVariable( "permissionoptionname", $permission->getNameForPermissionId($val) );
                $tpl->parseCurrentBlock();
                $l++;
            }
          ?>
            <script type="text/javascript">
            <!--
           	opener.parent.content.location.reload();
			opener.parent.projecttree.location.reload();
			
            -->
            </script>
            <?php
        }
    }
}
else
{
    // fetch permission data
    $permissionArray = $permission->getPermissionInfo($permissionId);
    if ($permission->errorMessage)
    {
        $userError = $permission->errorMessage;
    }
    
    $tpl->setVariable( "formaction", $filePermissionEdit );
    
    $tpl->setVariable( "errors", $userError );
    
    // get Array with ordered group ids and names
    $start = time(); 
    $group->getOrderedGroups("0", $start);
    $groupArray = $group->groupTree;
    $l = 1;
    while(list($key,$val) = each($groupArray))
    {
        if($val[1] != "alle User")
        {
            $selected = $permissionArray["CTGRY_TO_PRMSSN_GROUP_ID_FK"] == $val[0] ? "selected" : "";
            $tpl->setCurrentBlock( "groups" );
            $tpl->setVariable( "groupoptionvalue", $val[0] );
            $tpl->setVariable( "groupoptionselected", $selected );
            $tpl->setVariable( "groupoptionname", $val[1] );
            $tpl->parseCurrentBlock();
            $l++;
        }
    }
    
    // show all permissions
    $permissions = Array("1", "2", "4");
    while(list($key,$val) = each($permissions))
    {
        $selected = $permissionArray["CTGRY_TO_PRMSSN_PERMSSN_ID_FK"] == $val ? "selected" : "";
        $tpl->setCurrentBlock( "permissions" );
        $tpl->setVariable( "permissionoptionvalue", $val );
        $tpl->setVariable( "permissionoptionselected", $selected );
        $tpl->setVariable( "permissionoptionname", $permission->getNameForPermissionId($val) );
        $tpl->parseCurrentBlock();
        $l++;
    }
}

$tpl->setVariable( "permissionid", $permissionId );

$tpl->setVariable( "lnk_show", $fileGroupUser."?groupId=".$groupId."&permissionId=".$permissionId );
$tpl->setVariable( "lnk_edit", $filePermissionEdit."?groupId=".$groupId."&permissionId=".$permissionId );
$tpl->setVariable( "lnk_delete", $filePermissionDelete."?groupId=".$groupId."&permissionId=".$permissionId );

// parse template
$tpl->parse();

// get the parsed template and print it
$tpl->get();
$tpl->show();
?>