<?php
// +----------------------------------------------------------------------+
// | survey pilot                                                         |
// +----------------------------------------------------------------------+
// | Copyright (c) 2002 serie a - Digitale Medien und Systeme GmbH        |
// +----------------------------------------------------------------------+
// | Authors: 	Jrn Allert <allert@serie-a.de>                           |
// |          	Rene Renk <renk@serie-a.de>                               |
// +----------------------------------------------------------------------+
//
// $Id: user.delete.php,v 1.1.1.1 2004/07/15 13:35:10 opensurveypilot Exp $

// start session
@session_start();

// require all configuration files and libraries
require_once("./../config/config.inc.php"); // common config file
require_once($cfgPathToConf."/file.inc.php"); // project files
require_once($cfgPathToLib."/common.inc.php"); // common functions
require_once($cfgPathToAuthFiles."/config/auth.file.inc.php"); // auth files
require_once($cfgPathToAuthFiles."/lib/user.inc.php"); // auth user functions
require_once("HTML/Template/IT.php"); // PEAR::HTML_TEMPLATE_IT

// create new userFunctions object
$client = &new userFunctions;

//login check
if ($client->getAuthentication($_SESSION["sessionId"], session_id()) == false)
{
    //redirect to login page
    ?>
    <script type="text/javascript">
    <!--
    window.location.href="<?php echo $cfgUrlToProject."/".$fileAuthLogin; ?>";
    -->
    </script>
    <?php
    exit;
}

// function permission check
if($_SESSION["sessionUserStatusId"] < $permUserDelete)
{
    ?>
    <script type="text/javascript">
    <!--
    window.location.href="<?php echo $cfgUrlToProject."/".$fileNoPermission."?messageCode=2"; ?>";
    -->
    </script>
    <?php
    exit;
}

// get sessionUserLogin
$sessionUserLogin = $_SESSION["sessionUserLogin"];

// get sessionUserPassword
$sessionUserPassword = $_SESSION["sessionUserPassword"];

// get user id for detailview
if(isset($_GET["userId"]))
{
    $userId = $_GET["userId"];
}

// check if form was submitted
if($_SERVER["REQUEST_METHOD"] == "POST")
{
    $userId = $_POST["userId"];
    
    // delete
    $client->deleteUser($sessionUserLogin, $sessionUserPassword, $userId);
    $client->sendXmlrpcMessage();
    $result = $client->receiveXmlrpcMessage();
    
    // check for xmlrpc error
    if($result[0] == "0")
    {
        $userError = $result[1].": ".$result[2];
    }
    // redirect to success page
    else
    {
      ?>
        <script type="text/javascript">
        <!--
        window.location.href="<?php echo $cfgUrlToProject."/".$fileDeleteSuccessMessage; ?>";
        -->
        </script>
        <?php
    }
}

// fetch userdata
$client->fetchUser($sessionUserLogin, $sessionUserPassword, $userId);
$client->sendXmlrpcMessage();
$result = $client->receiveXmlrpcMessage();
// check for xmlrpc error
if($result[0] == "0")
{
    $userError = $result[1].": ".$result[2];
}

// create Template IT object
$tpl = new HTML_Template_IT($cfgPathToAuthTemplates);

// load template
$tpl->loadTemplatefile($templateUserDelete, true, true);

// set title
$tpl->setVariable( "applicationtitle", $cfgApplicationType.$cfgApplicationVersion);

$tpl->setVariable( "formaction", $fileUserDelete );
$tpl->setVariable( "errors", $userError );
$tpl->setVariable( "userid", $userId );
$tpl->setVariable( "firstname", $result[6] );
$tpl->setVariable( "lastname", $result[7] );
$tpl->setVariable( "company", $result[8] );
$tpl->setVariable( "status", $client->getNameForStatusId($result[2]) );

$tpl->setVariable( "lnk_edit", $fileUserEdit."?userId=".$userId );
$tpl->setVariable( "lnk_manage", $fileUserEditPassword."?userId=".$userId );
$tpl->setVariable( "lnk_delete", $fileUserDelete."?userId=".$userId );

// parse template
$tpl->parse();

// get the parsed template and print it
$tpl->get();
$tpl->show();   
?>

