<?php
// +----------------------------------------------------------------------+
// | survey pilot                                                         |
// +----------------------------------------------------------------------+
// | Copyright (c) 2002 serie a - Digitale Medien und Systeme GmbH        |
// +----------------------------------------------------------------------+
// | Authors: 	Jrn Allert <allert@serie-a.de>                           |
// |          	Rene Renk <renk@serie-a.de>                               |
// +----------------------------------------------------------------------+
//
// $Id: user.detailview.php,v 1.1.1.1 2004/07/15 13:35:10 opensurveypilot Exp $

// start session
@session_start();

// require all configuration files and libraries
require_once("./../config/config.inc.php"); // common config file
require_once($cfgPathToConf."/file.inc.php"); // project files
require_once($cfgPathToLib."/common.inc.php"); // common functions
require_once($cfgPathToAuthFiles."/config/auth.file.inc.php"); // auth files
require_once($cfgPathToAuthFiles."/lib/user.inc.php"); // auth user functions
require_once("HTML/Template/IT.php"); // PEAR::HTML_TEMPLATE_IT

// create new userFunctions object
$client = &new userFunctions;

//login check
if ($client->getAuthentication($_SESSION["sessionId"], session_id()) == false)
{
    //redirect to login page
    ?>
    <script type="text/javascript">
    <!--
    window.location.href="<?php echo $cfgUrlToProject."/".$fileAuthLogin; ?>";
    -->
    </script>
    <?php
    exit;
}

// function permission check
if($_SESSION["sessionUserStatusId"] < $permUserDetailView)
{
    ?>
    <script type="text/javascript">
    <!--
    window.location.href="<?php echo $cfgUrlToProject."/".$fileNoPermission."?messageCode=2"; ?>";
    -->
    </script>
    <?php
    exit;
}

// get user id for detailview
$userId = $_GET["userId"];

// get sessionUserLogin
$sessionUserLogin = $_SESSION["sessionUserLogin"];

// get sessionUserPassword
$sessionUserPassword = $_SESSION["sessionUserPassword"];

// fetch userdata
$client->fetchUser($sessionUserLogin, $sessionUserPassword, $userId);
$client->sendXmlrpcMessage();
$result = $client->receiveXmlrpcMessage();

// check for xmlrpc error
if ($result[0] == "0") 
{
    $userError = $result[1].": ".$result[2];
    echo $userError;
}

// create Template IT object
$tpl = new HTML_Template_IT($cfgPathToAuthTemplates);

// load template
$tpl->loadTemplatefile($templateUserDetailView, true, true);

// set title
$tpl->setVariable( "applicationtitle", $cfgApplicationType.$cfgApplicationVersion);

$tpl->setVariable( "status", $client->getNameForStatusId($result[2]) );
$tpl->setVariable( "language", $client->getNameForLangId($result[3]) );
$tpl->setVariable( "firstname", $result[6] );
$tpl->setVariable( "lastname", $result[7] );
$tpl->setVariable( "company", $result[8] );
$tpl->setVariable( "position", $result[9] );
$tpl->setVariable( "street", $result[10] );
$tpl->setVariable( "postalcode", $result[11] );
$tpl->setVariable( "city", $result[12] );
$tpl->setVariable( "email", $result[4] );
$tpl->setVariable( "phone", $result[14] );
$tpl->setVariable( "fax", $result[15] );
$tpl->setVariable( "mobil", $result[16] );
$tpl->setVariable( "homepage", $result[17] );
$tpl->setVariable( "insert_date", $result[18] );
$tpl->setVariable( "last_change", $result[19] );

// parse template
$tpl->parse();

// get the parsed template and print it
$tpl->get();
$tpl->show();
?>

