<?php
// +----------------------------------------------------------------------+
// | survey pilot                                                         |
// +----------------------------------------------------------------------+
// | Copyright (c) 2002 serie a - Digitale Medien und Systeme GmbH        |
// +----------------------------------------------------------------------+
// | Authors: 	Jrn Allert <allert@serie-a.de>                           |
// |          	Rene Renk <renk@serie-a.de>                               |
// +----------------------------------------------------------------------+
//
// $Id: user.edit.php,v 1.1.1.1 2004/07/15 13:35:11 opensurveypilot Exp $

// start session
@session_start();

// require all configuration files and libraries
require_once("./../config/config.inc.php"); // common config file
require_once ("Validate.php"); // PEAR::Validate (must be included before common config file)
require_once($cfgPathToConf."/file.inc.php"); // project files
require_once($cfgPathToLib."/common.inc.php"); // common functions
require_once($cfgPathToAuthFiles."/config/auth.file.inc.php"); // auth files
require_once($cfgPathToAuthFiles."/lib/user.inc.php"); // auth user functions
require_once($cfgPathToLangFiles."/lib/languagefunctions.inc.php"); 
require_once("HTML/Template/IT.php"); // PEAR::HTML_TEMPLATE_IT

// create new userFunctions object
$client = &new userFunctions;

//login check
if ($client->getAuthentication($_SESSION["sessionId"], session_id()) == false)
{
    //redirect to login page
    ?>
    <script type="text/javascript">
    <!--
    window.location.href="<?php echo $cfgUrlToProject."/".$fileAuthLogin; ?>";
    -->
    </script>
    <?php
    exit;
}

// function permission check
if($_SESSION["sessionUserStatusId"] < $permUserEdit)
{
    ?>
    <script type="text/javascript">
    <!--
    window.location.href="<?php echo $cfgUrlToProject."/".$fileNoPermission."?messageCode=2"; ?>";
    -->
    </script>
    <?php
    exit;
}

// get sessionUserLogin
$sessionUserLogin = $_SESSION["sessionUserLogin"];
// get sessionUserPassword
$sessionUserPassword = $_SESSION["sessionUserPassword"];

// create Template IT object
$tpl = new HTML_Template_IT($cfgPathToAuthTemplates);

// load template
$tpl->loadTemplatefile($templateUserEdit, true, true);

// set title
$tpl->setVariable( "applicationtitle", $cfgApplicationType.$cfgApplicationVersion);

// get userId as get variable
if(isset($_GET["userId"]))
{
    $userId = $_GET["userId"];
}

// check if form was submitted
if($_SERVER["REQUEST_METHOD"] == "POST")
{
    // get user id
    $userId = $_POST["userId"];
    
    // get and check lastname
    $userLastname = cleanHtml($_POST["userLastname"]);
    if($userLastname != "")
    {
        // check format
        if(!validate::string($userLastname, VAL_DENAME, 1, 50))
        {
            $errors["userLastname"] = $lang_script["user.edit.php"]["errorsLastNameChars"];
        }
    }
    else
    {
        $errors["userLastname"] = $lang_script["user.edit.php"]["errorsLastNameField"];
    }
    
    // get and check firstname
    $userFirstname = cleanHtml($_POST["userFirstname"]);
    
    if($userFirstname != "")
    {
        // check format
        if(!validate::string($userFirstname, VAL_DENAME, 1, 50))
        {
            $errors["userFirstname"] = $lang_script["user.edit.php"]["errorsFirstNameChars"];
        }
    }
    else
    {
        $errors["userFirstname"] = $lang_script["user.edit.php"]["errorsFirstNameField"];
    }
    
    // get and check company
    $userCompany = cleanHtml($_POST["userCompany"]);
    if($useCompanyrName != "")
    {
        // check format
        if(!validate::string($userCompanyName, VAL_DENAME_PUNCTUATION, 1, 50))
        {
            $errors["userCompany"] = $lang_script["user.edit.php"]["errorsCompanyChars"];
        }
    }
        
    // get and check position
    $userPosition = cleanHtml($_POST["userPosition"]);
    if($userPosition != "")
    {
        // check format
        if(!validate::string($userPosition, VAL_DENAME_PUNCTUATION, 1, 50))
        {
            $errors["userPosition"] = $lang_script["user.edit.php"]["errorsPositionChars"];
        }
    }
    
    // get and check status
    $userStatus = cleanHtml($_POST["userStatus"]);
    if($userStatus == "")
    {
        $errors["userStatus"] = $lang_script["user.edit.php"]["errorsStatusField"];
    }
    else
    {
        switch($userStatus)
        {
            case 1:
            $userStatusSelected1 = "selected";
            break;
            
            case 2:
            $userStatusSelected2 = "selected";
            break;
            
            case 4:
            $userStatusSelected4 = "selected";
            break;
            
            case 8:
            $userStatusSelected8 = "selected";
            break;
        }
    }
    
    // get and check language
    $userLanguage = cleanHtml($_POST["userLanguage"]);
    if($userLanguage == "")
    {
        $errors["userLanguage"] = $lang_script["user.edit.php"]["errorsLanguageField"];
    }
    
    // get and check street
    $userStreet = cleanHtml($_POST["userStreet"]);
    if($userStreet != "")
    {
        // check format
        if(!validate::string($userStreet, VAL_DENAME_PUNCTUATION, 1, 50))
        {
            $errors["userStreet"] = $lang_script["user.edit.php"]["errorsStreetChars"];
        }
    }
    
    // get and check postalcode
    $userPostalcode = cleanHtml($_POST["userPostalcode"]);
    if($userPostalcode != "")
    {
        // check format
        if(!validate::string($userPostalcode, VAL_NUM, 5, 5))
        {
            $errors["userPostalcode"] = $lang_script["user.edit.php"]["errorsPostalcodeChars"];
        }
    }
    
    // get and check city
    $userCity = cleanHtml($_POST["userCity"]);
    if($userCity  != "")
    {
        // check format
        if(!validate::string($userCity , VAL_DENAME_PUNCTUATION, 1, 50))
        {
            $errors["userCity"] = $lang_script["user.edit.php"]["errorsCityChars"];
        }
    }
    
    // get and check phone
    $userPhone = cleanHtml($_POST["userPhone"]);
    if($userPhone  != "")
    {
        // check format
        if(!validate::string($userPhone , VAL_DEPHONE, 1, 50))
        {
            $errors["userPhone"] = $lang_script["user.edit.php"]["errorsPhoneChars"];
        }
    }
    
    // get and check fax
    $userFax = cleanHtml($_POST["userFax"]);
    if($userFax  != "")
    {
        // check format
        if(!validate::string($userFax , VAL_DEPHONE, 1, 50))
        {
            $errors["userFax"] = $lang_script["user.edit.php"]["errorsFaxChars"];
        }
    }
    
    // get and check mobile
    $userMobile = cleanHtml($_POST["userMobile"]);
    if($userMobile  != "")
    {
        // check format
        if(!validate::string($userMobile , VAL_DEPHONE, 1, 50))
        {
            $errors["userMobile"] = $lang_script["user.edit.php"]["errorsMobileChars"];
        }
    }
    
    // get and check email
    $userEmail = cleanHtml($_POST["userEmail"]);
    if($userEmail  != "")
    {
        // check format
        if(!validate::email($userEmail))
        {
            $errors["userEmail"] = $lang_script["user.edit.php"]["errorsEmailChars"];
        }
    }
    else
    {
        $errors["userEmail"] = $lang_script["user.edit.php"]["errorsEmailField"];
    }
    
    // get and check homepage
    $userHomepage = cleanHtml($_POST["userHomepage"]);
    if($userHomepage  != "")
    {
        // check format
        if(!validate::url($userHomepage))
        {
            $errors["userHomepage"] = $lang_script["user.edit.php"]["errorsHomepageChars"];
        }
    }
    
    // put error Array in String
    if($errors)
    {
        foreach($errors as $error)
        {
            $userError .= "$error<br>";
        }
        
        //display form with updated data
        $tpl->setVariable( "formaction", $fileUserEdit );
    
        $tpl->setVariable( "errors", $userError );
        
        $tpl->setVariable( "userid", $userId );
        $tpl->setVariable( "userStatusSelected1", $userStatusSelected1 );
        $tpl->setVariable( "userStatusSelected2", $userStatusSelected2 );
        $tpl->setVariable( "userStatusSelected4", $userStatusSelected4 );
        $tpl->setVariable( "userStatusSelected8", $userStatusSelected8 );
   
		$lf = new languageFunctions();
		$installedLanguages = $lf->getInstalledLanguages();
		for ($i=0;$i<count($installedLanguages);$i++)
		{
			$tpl->setCurrentBlock("installedlangs") ;
			
			if($_SERVER["REQUEST_METHOD"] == "POST")
			{
				if ($userLanguage == $installedLanguages[$i][LANGUAGE_ID_PK])
					$tpl->setVariable( "installedlangs_selected", "selected" );
				else
					$tpl->setVariable( "installedlangs_selected", "" );
			}
			else
			{
				if ($result[3] == $installedLanguages[$i][LANGUAGE_ID_PK])
					$tpl->setVariable( "installedlangs_selected", "selected" );
				else
					$tpl->setVariable( "installedlangs_selected", "" );
			}
				
			$tpl->setVariable( "installedlangs_name", $installedLanguages[$i][LANGUAGE_FILE]);
			$tpl->setVariable( "installedlangs_value",$installedLanguages[$i][LANGUAGE_ID_PK]);
			$tpl->parseCurrentBlock("installedlangs");
		}		
		
        $tpl->setVariable( "firstname", $userFirstname );
        $tpl->setVariable( "lastname", $userLastname );
        $tpl->setVariable( "company", $userCompany );
        $tpl->setVariable( "position", $userPosition );
        $tpl->setVariable( "street", $userStreet );
        $tpl->setVariable( "postalcode", $userPostalcode );
        $tpl->setVariable( "city", $userCity );
        $tpl->setVariable( "email", $userEmail );
        $tpl->setVariable( "phone", $userPhone );
        $tpl->setVariable( "fax", $userFax );
        $tpl->setVariable( "mobil", $userMobile );
        $tpl->setVariable( "homepage", $userHomepage );

    }
    // no errors, so we can insert new user    
    else
    {
        // login ans password to check useres right to add users
        $userArray["userLogin"] = $sessionUserLogin;
        $userArray["userPassword"] = $sessionUserPassword;
        // user data for addUser
        $userArray["USER_ID_PK"] = $userId;
        $userArray["USER_USERSTATUS_ID_FK"] = $userStatus;
        $userArray["USER_LANGUAGE_ID_FK"] = $userLanguage;
        $userArray["USER_FIRSTNAME"] = htmlentities($userFirstname);
        $userArray["USER_LASTNAME"] = htmlentities($userLastname);
        $userArray["USER_COMPANY"] = htmlentities($userCompany);
        $userArray["USER_POSITION"] = htmlentities($userPosition);
        $userArray["USER_STREET"] = htmlentities($userStreet);
        $userArray["USER_POSTALCODE"] = $userPostalcode;
        $userArray["USER_CITY"] = htmlentities($userCity);
        $userArray["USER_EMAIL"] = $userEmail;
        $userArray["USER_PHONE"] = $userPhone;
        $userArray["USER_FAX"] = $userFax;
        $userArray["USER_MOBILE"] = $userMobile;
        $userArray["USER_HOMEPAGE"] = $userHomepage;
        
        $client->updateUser($userArray);
        $client->sendXmlrpcMessage();
        $result = $client->receiveXmlrpcMessage();

        // check for xmlrpc userAdd error
        if ($result[0] == "0") 
        {
            $userError = $result[1].": ".$result[2];
            //display form with updated data
            $tpl->setVariable( "formaction", $fileUserEdit );
        
            $tpl->setVariable( "errors", $userError );
            
            $tpl->setVariable( "userid", $userId );
            $tpl->setVariable( "userStatusSelected1", $userStatusSelected1 );
            $tpl->setVariable( "userStatusSelected2", $userStatusSelected2 );
            $tpl->setVariable( "userStatusSelected4", $userStatusSelected4 );
            $tpl->setVariable( "userStatusSelected8", $userStatusSelected8 );
            
			$lf = new languageFunctions();
			$installedLanguages = $lf->getInstalledLanguages();

			for ($i=0;$i<count($installedLanguages);$i++)
			{
				$tpl->setCurrentBlock("installedlangs") ;
				
				if($_SERVER["REQUEST_METHOD"] == "POST")
				{
					if ($userLanguage == $installedLanguages[$i][LANGUAGE_ID_PK])
						$tpl->setVariable( "installedlangs_selected", "selected" );
					else
						$tpl->setVariable( "installedlangs_selected", "" );
				}
				else
				{
					if ($result[3] == $installedLanguages[$i][LANGUAGE_ID_PK])
						$tpl->setVariable( "installedlangs_selected", "selected" );
					else
						$tpl->setVariable( "installedlangs_selected", "" );
				}
					
				$tpl->setVariable( "installedlangs_name", $installedLanguages[$i][LANGUAGE_FILE]);
				$tpl->setVariable( "installedlangs_value",$installedLanguages[$i][LANGUAGE_ID_PK]);
				$tpl->parseCurrentBlock("installedlangs");
			}
						
            $tpl->setVariable( "firstname", $userFirstname );
            $tpl->setVariable( "lastname", $userLastname );
            $tpl->setVariable( "company", $userCompany );
            $tpl->setVariable( "position", $userPosition );
            $tpl->setVariable( "street", $userStreet );
            $tpl->setVariable( "postalcode", $userPostalcode );
            $tpl->setVariable( "city", $userCity );
            $tpl->setVariable( "email", $userEmail );
            $tpl->setVariable( "phone", $userPhone );
            $tpl->setVariable( "fax", $userFax );
            $tpl->setVariable( "mobil", $userMobile );
            $tpl->setVariable( "homepage", $userHomepage );
        }
        // redirect to success page
        else
        {
			$tpl->setVariable( "errors", "<span style='color:blue'>".$lang_script["user.edit.php"]["saveMessage"]."</span>");
			$tpl->setVariable( "formaction", $fileUserEdit );
			$tpl->setVariable( "userid", $userId );
            $tpl->setVariable( "userStatusSelected1", $userStatusSelected1 );
            $tpl->setVariable( "userStatusSelected2", $userStatusSelected2 );
            $tpl->setVariable( "userStatusSelected4", $userStatusSelected4 );
            $tpl->setVariable( "userStatusSelected8", $userStatusSelected8 );
            
			$lf = new languageFunctions();
			$installedLanguages = $lf->getInstalledLanguages();

			for ($i=0;$i<count($installedLanguages);$i++)
			{
				$tpl->setCurrentBlock("installedlangs") ;
				
				if($_SERVER["REQUEST_METHOD"] == "POST")
				{
					if ($userLanguage == $installedLanguages[$i][LANGUAGE_ID_PK])
						$tpl->setVariable( "installedlangs_selected", "selected" );
					else
						$tpl->setVariable( "installedlangs_selected", "" );
				}
				else
				{
					if ($result[3] == $installedLanguages[$i][LANGUAGE_ID_PK])
						$tpl->setVariable( "installedlangs_selected", "selected" );
					else
						$tpl->setVariable( "installedlangs_selected", "" );
				}
					
				$tpl->setVariable( "installedlangs_name", $installedLanguages[$i][LANGUAGE_FILE]);
				$tpl->setVariable( "installedlangs_value",$installedLanguages[$i][LANGUAGE_ID_PK]);
				$tpl->parseCurrentBlock("installedlangs");
			}
			
            $tpl->setVariable( "firstname", $userFirstname );
            $tpl->setVariable( "lastname", $userLastname );
            $tpl->setVariable( "company", $userCompany );
            $tpl->setVariable( "position", $userPosition );
            $tpl->setVariable( "street", $userStreet );
            $tpl->setVariable( "postalcode", $userPostalcode );
            $tpl->setVariable( "city", $userCity );
            $tpl->setVariable( "email", $userEmail );
            $tpl->setVariable( "phone", $userPhone );
            $tpl->setVariable( "fax", $userFax );
            $tpl->setVariable( "mobil", $userMobile );
            $tpl->setVariable( "homepage", $userHomepage );
        }
    }
}
else
{
    $client->fetchUser($sessionUserLogin, $sessionUserPassword, $userId);
    $client->sendXmlrpcMessage();
    $result = $client->receiveXmlrpcMessage();
    // check for xmlrpc error
    if ($result[0] == "0") 
    {
        $userError = $result[1].": ".$result[2];
    }
    
    $tpl->setVariable( "formaction", $fileUserEdit );
    
    // get user status and select it in form
    switch($result[2])
    {
        case 1:
        $userStatusSelected1 = "selected";
        break;
        
        case 2:
        $userStatusSelected2 = "selected";
        break;
        
        case 4:
        $userStatusSelected4 = "selected";
        break;
        
        case 8:
        $userStatusSelected8 = "selected";
        break;
    }
    
    	$lf = new languageFunctions();

	$installedLanguages = $lf->getInstalledLanguages();
	
	print_r($installedLanguages);
	
	for ($i=0;$i<count($installedLanguages);$i++)
	{
		$tpl->setCurrentBlock("installedlangs") ;
		
		if($_SERVER["REQUEST_METHOD"] == "POST")
		{
			if ($userLanguage == $installedLanguages[$i][LANGUAGE_ID_PK])
				$tpl->setVariable( "installedlangs_selected", "selected" );
			else
				$tpl->setVariable( "installedlangs_selected", "" );
		}
		else
		{
			if ($result[3] == $installedLanguages[$i][LANGUAGE_ID_PK])
				$tpl->setVariable( "installedlangs_selected", "selected" );
			else
				$tpl->setVariable( "installedlangs_selected", "" );
		}
			
		$tpl->setVariable( "installedlangs_name", $installedLanguages[$i][LANGUAGE_FILE]);
		$tpl->setVariable( "installedlangs_value",$installedLanguages[$i][LANGUAGE_ID_PK]);
		$tpl->parseCurrentBlock("installedlangs");
	}
    
    $tpl->setVariable( "errors", $userError );
    $tpl->setVariable( "userStatusSelected1", $userStatusSelected1 );
    $tpl->setVariable( "userStatusSelected2", $userStatusSelected2 );
    $tpl->setVariable( "userStatusSelected4", $userStatusSelected4 );
    $tpl->setVariable( "userStatusSelected8", $userStatusSelected8 );

    $tpl->setVariable( "userid", $result[1] );
    $tpl->setVariable( "firstname", $result[6] );
    $tpl->setVariable( "lastname", $result[7] );
    $tpl->setVariable( "login", $result[4]);
    $tpl->setVariable( "company", $result[8] );
    $tpl->setVariable( "position", $result[9] );
    $tpl->setVariable( "street", $result[10] );
    $tpl->setVariable( "postalcode", $result[11] );
    $tpl->setVariable( "city", $result[12] );
    $tpl->setVariable( "email", $result[13] );
    $tpl->setVariable( "phone", $result[14] );
    $tpl->setVariable( "fax", $result[15] );
    $tpl->setVariable( "mobil", $result[16] );
    $tpl->setVariable( "homepage", $result[17] );
}

$tpl->setVariable( "lnk_edit", $fileUserEdit."?userId=".$userId );
$tpl->setVariable( "lnk_manage", $fileUserEditPassword."?userId=".$userId );
$tpl->setVariable( "lnk_delete", $fileUserDelete."?userId=".$userId );

// parse template
$tpl->parse();

// get the parsed template and print it
$tpl->get();
$tpl->show();
?>
