<?php
// +----------------------------------------------------------------------+
// | survey     pilot                                                     |
// +----------------------------------------------------------------------+
// | Copyright (c) 2002 serie a - Digitale Medien und Systeme GmbH        |
// +----------------------------------------------------------------------+
// | Authors: 	Jrn Allert <allert@serie-a.de>                           |
// |          	Rene Renk <renk@serie-a.de>                               |
// +----------------------------------------------------------------------+
//
// $Id: user.editpassword.php,v 1.1.1.1 2004/07/15 13:35:11 opensurveypilot Exp $

// start session
@session_start();

// require all configuration files and libraries
require_once("./../config/config.inc.php"); // common config file
require_once ("Validate.php"); // PEAR::Validate (must be included before common config file)
require_once($cfgPathToConf."/file.inc.php"); // project files
require_once($cfgPathToLib."/common.inc.php"); // common functions
require_once($cfgPathToAuthFiles."/config/auth.file.inc.php"); // auth files
require_once($cfgPathToAuthFiles."/lib/user.inc.php"); // auth user functions
require_once("HTML/Template/IT.php"); // PEAR::HTML_TEMPLATE_IT

// create new userFunctions object
$client = &new userFunctions;

//login check
if ($client->getAuthentication($_SESSION["sessionId"], session_id()) == false)
{
    //redirect to login page
    ?>
    <script type="text/javascript">
    <!--
    window.location.href="<?php echo $cfgUrlToProject."/".$fileAuthLogin; ?>";
    -->
    </script>
    <?php
    exit;
}

// function permission check
if($_SESSION["sessionUserStatusId"] < $permUserEditPassword)
{
    ?>
    <script type="text/javascript">
    <!--
    window.location.href="<?php echo $cfgUrlToProject."/".$fileNoPermission."?messageCode=2"; ?>";
    -->
    </script>
    <?php
    exit;
}

// get sessionUserLogin
$sessionUserLogin = $_SESSION["sessionUserLogin"];

// get sessionUserPassword
$sessionUserPassword = $_SESSION["sessionUserPassword"];

// get userId as get variable
if(isset($_GET["userId"]))
{
    $userId = $_GET["userId"];
}

// check if form was submitted
if($_SERVER["REQUEST_METHOD"] == "POST")
{
    // get user id
    $userId = $_POST["userId"];
    
    // get and check login
    $userLogin = cleanHtml($_POST["userLogin"]);
    if($userLogin != "")
    {
        // check format
        if(!validate::email($userLogin))
        {
            $errors["userLogin"] = $lang_script["user.editpassword.php"]["errorsLoginNameChars"];
        }
    }
    else
    {
        $errors["userLogin"] = $lang_script["user.editpassword.php"]["errorsLoginNameField"];
    }
    
    // get and check password
    $userPassword = cleanHtml($_POST["userPassword"]);
    $userPassword2 = cleanHtml($_POST["userPassword2"]);
    if ($userPassword != $userPassword2)
    {
        $errors["userPassword"] = $lang_script["user.editpassword.php"]["errorsPasswordCheck"];
    }
    if($userPassword != "")
    {
        // check format
        if(!validate::string($userPassword, VAL_ALPHA_NUM_, 1, 20))
        {
            $errors["userPassword"] = $lang_script["user.editpassword.php"]["errorsPasswordChars"];
        }
		elseif (strlen($userPassword) < 4)
		{
			$errors["userPassword"] = $lang_script["user.editpassword.php"]["errorsPasswordMinChars"];
		}
    }
    else
    {
        $errors["userPassword"] = $lang_script["user.editpassword.php"]["errorsPasswordFillIn"];
    }
    
    // put error Array in String
    if($errors)
    {
        foreach($errors as $error)
        {
            $userError .= "$error<br>";
        }
    }
    // no errors, so we can insert new user    
    else
    {
        // login and password to check useres right to add users
        $userArray["userLogin"] = $sessionUserLogin;
        $userArray["userPassword"] = $sessionUserPassword;
        // user data for addUser
        $userArray["USER_ID_PK"] = $userId;
        $userArray["USER_LOGIN"] = $userLogin;
	$userArray["USER_EMAIL"] = $userLogin; // email same value as login so update both // 030307-rr
        $userArray["USER_PASSWORD"] = $client->encodePassword($userPassword);
        
        $client->updateUser($userArray);
        $client->sendXmlrpcMessage();
        $result = $client->receiveXmlrpcMessage();
        
        // check for xmlrpc userAdd error
        if ($result[0] == "0") 
        {
            $userError = $result[1].": ".$result[2];
        }
        // redirect to success page
        else
        {
			$userError = "<span style='color:blue'>".$lang_script["user.editpassword.php"]["saveMessage"]."</span>";
        }
    }
}

// create Template IT object
$tpl = new HTML_Template_IT($cfgPathToAuthTemplates);

// load template
$tpl->loadTemplatefile($templateUserEditPassword, true, true);

// set title
$tpl->setVariable( "applicationtitle", $cfgApplicationType.$cfgApplicationVersion);

$tpl->setVariable( "formaction", $fileUserEditPassword );
$tpl->setVariable( "errors", $userError );
$tpl->setVariable( "login", $userLogin );
$tpl->setVariable( "userid", $userId );

$tpl->setVariable( "lnk_edit", $fileUserEdit."?userId=".$userId );
$tpl->setVariable( "lnk_manage", $fileUserEditPassword."?userId=".$userId );
$tpl->setVariable( "lnk_delete", $fileUserDelete."?userId=".$userId );

// parse template
$tpl->parse();

// get the parsed template and print it
$tpl->get();
$tpl->show();
?>
