<?php
// +----------------------------------------------------------------------+
// | survey pilot                                                         |
// +----------------------------------------------------------------------+
// | Copyright (c) 2002 serie a - Digitale Medien und Systeme GmbH        |
// +----------------------------------------------------------------------+
// | Authors: 	Jrn Allert <allert@serie-a.de>                           |
// |          	Rene Renk <renk@serie-a.de>                               |
// +----------------------------------------------------------------------+
//
// $Id: user.overview.php,v 1.1.1.1 2004/07/15 13:35:12 opensurveypilot Exp $

// start session
@session_start();

// require all configuration files and libraries
require_once("./../config/config.inc.php"); // common config file
require_once($cfgPathToConf."/file.inc.php"); // project files
require_once($cfgPathToLib."/common.inc.php"); // common functions
require_once($cfgPathToAuthFiles."/config/auth.file.inc.php"); // auth files
require_once($cfgPathToAuthFiles."/lib/user.inc.php"); // auth user functions
require_once($cfgPathToAuthFiles."/lib/group.inc.php"); // auth group functions
require_once("HTML/Template/IT.php"); // PEAR::HTML_TEMPLATE_IT

// create new userFunctions object
$client = &new userFunctions;

//login check
if ($client->getAuthentication($_SESSION["sessionId"], session_id()) == false)
{
    //redirect to login page
    ?>
    <script type="text/javascript">
    <!--
    window.location.href="<?php echo $cfgUrlToProject."/".$fileAuthLogin; ?>";
    -->
    </script>
    <?php
    exit;
}

// function permission check
if($_SESSION["sessionUserStatusId"] < $permUserOverview)
{
    ?>
    <script type="text/javascript">
    <!--
    window.location.href="<?php echo $cfgUrlToProject."/".$fileNoPermission."?messageCode=2"; ?>";
    -->
    </script>
    <?php
    exit;
}

// create Template IT object
$tpl = new HTML_Template_IT($cfgPathToAuthTemplates);

// load template
$tpl->loadTemplatefile($templateUserOverview, true, true);

// set title
$tpl->setVariable( "applicationtitle", $cfgApplicationType.$cfgApplicationVersion);

// get group id as get variable
if(isset($_GET["id"]))
{
    $groupId = $_GET["id"];
}
elseif(isset($_GET["groupId"]))
{
    $groupId = $_GET["groupId"];
}
// get actual num as get variable
if(isset($_GET["actualNum"]))
{
    $actualNum = $_GET["actualNum"];
}
// get orderBy as get variable
if(isset($_GET["orderBy"]))
{
    $orderBy = $_GET["orderBy"];
}
else
{
    $orderBy = "USER_LASTNAME";
}
// get direction as get variable
if(isset($_GET["direction"]))
{
    $direction = $_GET["direction"];
}

// maximum rows
$maxRow = $cfgMaxRowInOverviews;
//total rows 

// check id get data and link pages
if($groupId != "")
{
    // create new groupFunctions object
    $group = &new groupFunctions;
    
    $groupInfo = $group->getGroupInfo($groupId);
    $totalNum = $groupInfo["userNum"];
    $tpl->setVariable( "groupname", $groupInfo["GROUP_NAME"] );
	$tpl->setVariable("grouplink", $fileGroupOverview."?id=".$groupId);
	$tpl->setVariable("grouptarget", $fileFrameContentName);
	$tpl->setVariable("groupoptionlink", $fileGroupSubfolderToplevel."?id=".$groupId);
	$tpl->setVariable("groupoptiontarget", $fileFrameToplevelName);
}
else
{
    $totalNum =  $client->getUserNum();
	$tpl->setVariable("groupname", $lang_script["user.overview.php"]["mainGroups"]);
	$tpl->setVariable("grouplink", $fileGroupOverview);
	$tpl->setVariable("grouptarget", $fileFrameContentName);
	$tpl->setVariable("groupoptionlink", $fileGroupToplevel);
	$tpl->setVariable("groupoptiontarget", $fileFrameToplevelName);
}


// actual rows
if (!isset($actualNum))
{
    $actualNum = 0;
}
// get the Number of pages
$numPages = intval($totalNum/$maxRow);
if ($numPages < ($totalNum/$maxRow))
{ 
    $numPages++;
}

// prev button
if ($actualNum > 0) 
{
    $y = $actualNum - $maxRow;
    
    $tpl->setVariable( "prev_button", "<a class=\"navigation\" href=\"$fileUserOverview?groupId=$groupId&actualNum=$y&orderBy=$orderBy&direction=$direction\">&laquo;</a>" );
}
// display pages
for ($i = 1; $i <= $numPages; $i++)
{
    $y = ($i * $maxRow) - $maxRow;
    
    $tpl->setCurrentBlock( "num_buttons" );
    $tpl->setVariable( "num_button", "[<a class=\"navigation\" href=\"$fileUserOverview?groupId=$groupId&actualNum=$y&orderBy=$orderBy&direction=$direction\">$i</a>]" );
    $tpl->parseCurrentBlock();
}
//  next button
if ($actualNum < ($totalNum - $maxRow)) 
{
    $y = $actualNum  + $maxRow;
    
    $tpl->setVariable( "next_button", "<a class=\"navigation\" href=\"$fileUserOverview?groupId=$groupId&actualNum=$y&orderBy=$orderBy&direction=$direction\">&raquo;</a>" );
}

if(($actualNum + $maxRow) < $totalNum)
{
    $entryTo = $actualNum + $maxRow;
}
else
{
    $entryTo = $totalNum;
    
}

// entry from
$entryFrom = $entryTo < 1 ? "0" : $actualNum +1;

$tpl->setVariable( "entry_from", $entryFrom );
$tpl->setVariable( "entry_to", $entryTo );
$tpl->setVariable( "entry_total", $totalNum );

// orderby butons
$tpl->setVariable( "order_link_company_up", "$fileUserOverview?groupId=$groupId&actualNum=$actualNum&orderBy=USER_COMPANY&direction=ASC" );
$tpl->setVariable( "order_link_company_down", "$fileUserOverview?groupId=$groupId&actualNum=$actualNum&orderBy=USER_COMPANY&direction=DESC" );
$tpl->setVariable( "order_link_lastname_up", "$fileUserOverview?groupId=$groupId&actualNum=$actualNum&orderBy=USER_LASTNAME&direction=ASC" );
$tpl->setVariable( "order_link_lastname_down", "$fileUserOverview?groupId=$groupId&actualNum=$actualNum&orderBy=USER_LASTNAME&direction=DESC" );
$tpl->setVariable( "order_link_firstname_up", "$fileUserOverview?groupId=$groupId&actualNum=$actualNum&orderBy=USER_FIRSTNAME&direction=ASC" );
$tpl->setVariable( "order_link_firstname_down", "$fileUserOverview?groupId=$groupId&actualNum=$actualNum&orderBy=USER_FIRSTNAME&direction=DESC" );
$tpl->setVariable( "order_link_fk_stat_id_up", "$fileUserOverview?groupId=$groupId&actualNum=$actualNum&orderBy=USER_USERSTATUS_ID_FK&direction=ASC" );
$tpl->setVariable( "order_link_fk_stat_id_down", "$fileUserOverview?groupId=$groupId&actualNum=$actualNum&orderBy=USER_USERSTATUS_ID_FK&direction=DESC" );
$tpl->setVariable( "order_link_insert_date_up", "$fileUserOverview?groupId=$groupId&actualNum=$actualNum&orderBy=USER_DATE&direction=ASC" );
$tpl->setVariable( "order_link_insert_date_down", "$fileUserOverview?groupId=$groupId&actualNum=$actualNum&orderBy=USER_DATE&direction=DESC" );


// get user
$userArray = $client->getUsersForOverview($groupId, $actualNum, $maxRow, $orderBy, $direction);
for($j=0;$j<count($userArray);$j++)
{
    $tpl->setCurrentBlock( "user_overview" );
    $tpl->setVariable( "id", $userArray[$j]["USER_ID_PK"] );
    $tpl->setVariable( "company", $userArray[$j]["USER_COMPANY"] );
    $tpl->setVariable( "lastname", $userArray[$j]["USER_LASTNAME"] );
    $tpl->setVariable( "firstname", $userArray[$j]["USER_FIRSTNAME"] );
    $tpl->setVariable( "status", $client->getNameForStatusId($userArray[$j]["USER_USERSTATUS_ID_FK"]) );
    $tpl->setVariable( "insertdate", $userArray[$j]["USER_DATE"] );
    $tpl->setVariable( "edit_link", $fileUserEdit."?userId=".$userArray[$j]["USER_ID_PK"] );
    $tpl->setVariable( "print_link", "#" );
    $tpl->parseCurrentBlock();
}

// get the parsed template and print it
$tpl->get();
$tpl->show();
?>
