# UPDATE OSP
# --------------------------------------------------------
DROP TABLE IF EXISTS `T_AUTH_LANGUAGE`;
CREATE TABLE `T_AUTH_LANGUAGE` (
  `LANGUAGE_ID_PK` int(11) NOT NULL auto_increment,
  `LANGUAGE_TYPE` char(3) default NULL,
  `LANGUAGE_FILE` varchar(50) default NULL,
  PRIMARY KEY  (`LANGUAGE_ID_PK`)
) TYPE=MyISAM PACK_KEYS=0 AUTO_INCREMENT=3 ;

INSERT INTO `T_AUTH_LANGUAGE` (`LANGUAGE_ID_PK`, `LANGUAGE_TYPE`, `LANGUAGE_FILE`) VALUES (1, 'de', 'deutsch');
INSERT INTO `T_AUTH_LANGUAGE` (`LANGUAGE_ID_PK`, `LANGUAGE_TYPE`, `LANGUAGE_FILE`) VALUES (2, 'en', 'english');
# --------------------------------------------------------
DROP TABLE IF EXISTS `T_PROB_COURSE`;
CREATE TABLE `T_PROB_COURSE` (
  `COURSE_NAME` varchar(255) NOT NULL default ''
) TYPE=MyISAM;

INSERT INTO `T_PROB_COURSE` (`COURSE_NAME`) VALUES ('MCSE');
# --------------------------------------------------------
DROP TABLE IF EXISTS `T_PROB_EDUCATION`;
CREATE TABLE `T_PROB_EDUCATION` (
  `EDUCATION_NAME` varchar(255) NOT NULL default ''
) TYPE=MyISAM;

INSERT INTO `T_PROB_EDUCATION` (`EDUCATION_NAME`) VALUES ('Studium');
# --------------------------------------------------------
DROP TABLE IF EXISTS `T_PROB_ELEMENTRULE`;
CREATE TABLE `T_PROB_ELEMENTRULE` (
  `ELEMENTRULE_ID_PK` int(11) NOT NULL default '0',
  `ELEMENTRULE_FORMTYPE_ID_FK` int(11) NOT NULL default '0',
  `ELEMENTRULE_FORM_ID_FK` int(11) NOT NULL default '0',
  `ELEMENTRULE_ATTRIBUTE` varchar(30) NOT NULL default 'required',
  `ELEMENTRULE_ALERT` varchar(100) NOT NULL default 'Dies ist ein Pflichtfeld',
  `ELEMENTRULE_CHECKALLOW` int(4) default NULL,
  PRIMARY KEY  (`ELEMENTRULE_ID_PK`)
) TYPE=MyISAM;
# --------------------------------------------------------
DROP TABLE IF EXISTS `T_PROB_ELEMENTRULE_seq`;
CREATE TABLE `T_PROB_ELEMENTRULE_seq` (
  `id` int(10) unsigned NOT NULL auto_increment,
  PRIMARY KEY  (`id`)
) TYPE=MyISAM AUTO_INCREMENT=4 ;

INSERT INTO `T_PROB_ELEMENTRULE_seq` (`id`) VALUES (1);
# --------------------------------------------------------
DROP TABLE IF EXISTS `T_PROB_ERROR`;
CREATE TABLE `T_PROB_ERROR` (
  `ERROR_ID_PK` int(11) NOT NULL default '0',
  `ERROR_PROJECT_ID` int(11) default '0',
  `ERROR_FORMTYPE_ID` int(11) default '0',
  `ERROR_LANG` char(2) default 'de',
  `ERROR_TYPE` varchar(30) default 'NULL',
  `ERROR_MESSAGE` varchar(100) default 'NULL',
  PRIMARY KEY  (`ERROR_ID_PK`)
) TYPE=MyISAM;

INSERT INTO `T_PROB_ERROR` (`ERROR_ID_PK`, `ERROR_PROJECT_ID`, `ERROR_FORMTYPE_ID`, `ERROR_LANG`, `ERROR_TYPE`, `ERROR_MESSAGE`) VALUES (1, 0, 0, 'de', 'numeric', 'Numerisch');
INSERT INTO `T_PROB_ERROR` (`ERROR_ID_PK`, `ERROR_PROJECT_ID`, `ERROR_FORMTYPE_ID`, `ERROR_LANG`, `ERROR_TYPE`, `ERROR_MESSAGE`) VALUES (8, 0, 0, 'en', 'requirednote', 'Required');
INSERT INTO `T_PROB_ERROR` (`ERROR_ID_PK`, `ERROR_PROJECT_ID`, `ERROR_FORMTYPE_ID`, `ERROR_LANG`, `ERROR_TYPE`, `ERROR_MESSAGE`) VALUES (3, 0, 0, 'de', 'numericnote', 'Numerisch');
INSERT INTO `T_PROB_ERROR` (`ERROR_ID_PK`, `ERROR_PROJECT_ID`, `ERROR_FORMTYPE_ID`, `ERROR_LANG`, `ERROR_TYPE`, `ERROR_MESSAGE`) VALUES (4, 0, 0, 'de', 'requirednote', 'Pflichtfeld');
INSERT INTO `T_PROB_ERROR` (`ERROR_ID_PK`, `ERROR_PROJECT_ID`, `ERROR_FORMTYPE_ID`, `ERROR_LANG`, `ERROR_TYPE`, `ERROR_MESSAGE`) VALUES (7, 0, 0, 'en', 'numericnote', 'Numeric');
INSERT INTO `T_PROB_ERROR` (`ERROR_ID_PK`, `ERROR_PROJECT_ID`, `ERROR_FORMTYPE_ID`, `ERROR_LANG`, `ERROR_TYPE`, `ERROR_MESSAGE`) VALUES (5, 0, 0, 'en', 'numeric', 'Numeric');
INSERT INTO `T_PROB_ERROR` (`ERROR_ID_PK`, `ERROR_PROJECT_ID`, `ERROR_FORMTYPE_ID`, `ERROR_LANG`, `ERROR_TYPE`, `ERROR_MESSAGE`) VALUES (2, 0, 0, 'de', 'required', 'Pflichtfeld');
INSERT INTO `T_PROB_ERROR` (`ERROR_ID_PK`, `ERROR_PROJECT_ID`, `ERROR_FORMTYPE_ID`, `ERROR_LANG`, `ERROR_TYPE`, `ERROR_MESSAGE`) VALUES (6, 0, 0, 'en', 'required', 'Required');
# --------------------------------------------------------
DROP TABLE IF EXISTS `T_PROB_FORM`;
CREATE TABLE `T_PROB_FORM` (
  `FORM_ID_PK` int(11) NOT NULL default '0',
  `FORM_PROJECT_ID_FK` int(11) NOT NULL default '0',
  `FORM_PARENT_ID` int(11) default '0',
  `FORM_NODEGROUP` int(11) default '0',
  `FORM_NAME` varchar(255) default NULL,
  `FORM_METHOD` varchar(4) NOT NULL default 'POST',
  `FORM_HEADER` text,
  `FORM_TARGET` varchar(80) default NULL,
  `FORM_ACTIVE` char(3) default '0',
  `FORM_ORDER` int(11) default NULL,
  `FORM_INSERTDATE` datetime default NULL,
  PRIMARY KEY  (`FORM_ID_PK`)
) TYPE=MyISAM;
# --------------------------------------------------------
DROP TABLE IF EXISTS `T_PROB_FORMELEMENT`;
CREATE TABLE `T_PROB_FORMELEMENT` (
  `FORMELEMENT_ID_PK` int(11) NOT NULL default '0',
  `FORMELEMENT_FORMTYPE_ID_FK` int(11) NOT NULL default '0',
  `FORMELEMENT_FORM_ID_FK` int(11) NOT NULL default '0',
  `FORMELEMENT_MULTIPLEVALUE` varchar(30) NOT NULL default '',
  `FORMELEMENT_ADDHEADER` varchar(255) default NULL,
  `FORMELEMENT_HIDEADDHEADER` char(3) default NULL,
  `FORMELEMENT_ADDHEADERIMAGE` varchar(255) default NULL,
  `FORMELEMENT_CHECKED` char(3) default NULL,
  `FORMELEMENT_HEADER` varchar(255) default NULL,
  `FORMELEMENT_HIDEHEADER` char(3) default NULL,
  `FORMELEMENT_HEADERIMAGE` varchar(255) default NULL,
  `FORMELEMENT_ORDER` int(11) default NULL,
  `FORMELEMENT_SWITCHTO` int(11) default NULL,
  `FORMELEMENT_SRVY_CNTNUE` int(11) default NULL,
  PRIMARY KEY  (`FORMELEMENT_ID_PK`)
) TYPE=MyISAM;
# --------------------------------------------------------
DROP TABLE IF EXISTS `T_PROB_FORMELEMENT_seq`;
CREATE TABLE `T_PROB_FORMELEMENT_seq` (
  `id` int(10) unsigned NOT NULL auto_increment,
  PRIMARY KEY  (`id`)
) TYPE=MyISAM AUTO_INCREMENT=15 ;

INSERT INTO `T_PROB_FORMELEMENT_seq` (`id`) VALUES (1);
# --------------------------------------------------------
DROP TABLE IF EXISTS `T_PROB_FORMTYPE`;
CREATE TABLE `T_PROB_FORMTYPE` (
  `FORMTYPE_ID_PK` int(11) NOT NULL default '0',
  `FORMTYPE_FORM_ID_FK` int(11) NOT NULL default '0',
  `FORMTYPE_TYPE` varchar(20) default NULL,
  `FORMTYPE_QUESTION` text,
  `FORMTYPE_DEFAULT` varchar(255) default NULL,
  `FORMTYPE_SIZE` int(11) default NULL,
  `FORMTYPE_ORDER` int(11) default NULL,
  `FORMTYPE_ALIGN` char(3) default '0',
  `FORMTYPE_ACTIVE` char(3) default NULL,
  `FORMTYPE_TABLESPAN` int(11) NOT NULL default '1',
  `FORMTYPE_IMAGE` varchar(254) default NULL,
  `FORMTYPE_TIMESTAMP` datetime default NULL,
  PRIMARY KEY  (`FORMTYPE_ID_PK`)
) TYPE=MyISAM;
# --------------------------------------------------------
DROP TABLE IF EXISTS `T_PROB_FORMTYPE_seq`;
CREATE TABLE `T_PROB_FORMTYPE_seq` (
  `id` int(10) unsigned NOT NULL auto_increment,
  PRIMARY KEY  (`id`)
) TYPE=MyISAM AUTO_INCREMENT=12 ;

INSERT INTO `T_PROB_FORMTYPE_seq` (`id`) VALUES (1);
# --------------------------------------------------------
DROP TABLE IF EXISTS `T_PROB_FORM_seq`;
CREATE TABLE `T_PROB_FORM_seq` (
  `id` int(10) unsigned NOT NULL auto_increment,
  PRIMARY KEY  (`id`)
) TYPE=MyISAM AUTO_INCREMENT=14 ;

INSERT INTO `T_PROB_FORM_seq` (`id`) VALUES (1);
# --------------------------------------------------------
DROP TABLE IF EXISTS `T_PROB_GROUPS`;
CREATE TABLE `T_PROB_GROUPS` (
  `GROUPS_ID_PK` int(11) NOT NULL auto_increment,
  `GROUPS_NAME` varchar(100) NOT NULL default '',
  `GROUPS_DESCRIPTION` text,
  `GROUPS_GROUPTIME` datetime default NULL,
  PRIMARY KEY  (`GROUPS_ID_PK`)
) TYPE=MyISAM AUTO_INCREMENT=36 ;
# --------------------------------------------------------
DROP TABLE IF EXISTS `T_PROB_LOG`;
CREATE TABLE `T_PROB_LOG` (
  `LOG_ID_PK` int(11) NOT NULL default '0',
  `USER_ID_FK` int(11) NOT NULL default '0',
  `GROUP_TO_CONTENT_ID_FK` int(11) NOT NULL default '0',
  PRIMARY KEY  (`LOG_ID_PK`)
) TYPE=MyISAM;
# --------------------------------------------------------
DROP TABLE IF EXISTS `T_PROB_LOG_EVENT`;
CREATE TABLE `T_PROB_LOG_EVENT` (
  `LOG_EVENT_ID_PK` int(11) NOT NULL default '0',
  `LOG_EVENT_LOG_ID_FK` int(11) NOT NULL default '0',
  `LOG_EVENT_TIME` datetime NOT NULL default '0000-00-00 00:00:00',
  `LOG_EVENT_FLAG` int(11) NOT NULL default '0',
  `LOG_EVENT_REL_ID_FK` int(11) default NULL,
  PRIMARY KEY  (`LOG_EVENT_ID_PK`)
) TYPE=MyISAM;
# --------------------------------------------------------
DROP TABLE IF EXISTS `T_PROB_LOG_EVENT_seq`;
CREATE TABLE `T_PROB_LOG_EVENT_seq` (
  `id` int(10) unsigned NOT NULL auto_increment,
  PRIMARY KEY  (`id`)
) TYPE=MyISAM AUTO_INCREMENT=1 ;
# --------------------------------------------------------
DROP TABLE IF EXISTS `T_PROB_LOG_seq`;
CREATE TABLE `T_PROB_LOG_seq` (
  `id` int(10) unsigned NOT NULL auto_increment,
  PRIMARY KEY  (`id`)
) TYPE=MyISAM AUTO_INCREMENT=1 ;
# --------------------------------------------------------
DROP TABLE IF EXISTS `T_PROB_SCHOOL`;
CREATE TABLE `T_PROB_SCHOOL` (
  `SCHOOL_NAME` varchar(255) NOT NULL default ''
) TYPE=MyISAM;

INSERT INTO `T_PROB_SCHOOL` (`SCHOOL_NAME`) VALUES ('Hochschulreife');
INSERT INTO `T_PROB_SCHOOL` (`SCHOOL_NAME`) VALUES ('Fachhochschulreife');
INSERT INTO `T_PROB_SCHOOL` (`SCHOOL_NAME`) VALUES ('Mittlere Reife');
INSERT INTO `T_PROB_SCHOOL` (`SCHOOL_NAME`) VALUES ('Hauptschule');
INSERT INTO `T_PROB_SCHOOL` (`SCHOOL_NAME`) VALUES ('Sonderschule');
INSERT INTO `T_PROB_SCHOOL` (`SCHOOL_NAME`) VALUES ('anderer Abschluss');
INSERT INTO `T_PROB_SCHOOL` (`SCHOOL_NAME`) VALUES ('kein Abschluss');
# --------------------------------------------------------
DROP TABLE IF EXISTS `T_PROB_USERDATA`;
CREATE TABLE `T_PROB_USERDATA` (
  `USERDATA_ID_PK` int(11) NOT NULL auto_increment,
  `USERDATA_MASK_ID_FK` int(11) NOT NULL default '0',
  `USERDATA_VNAME` varchar(50) default NULL,
  `USERDATA_NNAME` varchar(50) default NULL,
  `USERDATA_PW` varchar(100) default NULL,
  `USERDATA_AGE` date default NULL,
  `USERDATA_SEX` char(1) default NULL,
  `USERDATA_STREET` varchar(50) default NULL,
  `USERDATA_POSTALCODE` varchar(10) default NULL,
  `USERDATA_CITY` varchar(50) default NULL,
  `USERDATA_PHONE` varchar(50) default NULL,
  `USERDATA_EMAIL` varchar(50) default NULL,
  `USERDATA_DEGREE` varchar(100) default NULL,
  `USERDATA_DEGREE_YEAR` date default NULL,
  `USERDATA_NATION` varchar(50) default NULL,
  `USERDATA_COURSE_NAME_1` varchar(100) default NULL,
  `USERDATA_COURSE_YEAR_1` date default NULL,
  `USERDATA_COURSE_NAME_2` varchar(100) default NULL,
  `USERDATA_COURSE_YEAR_2` date default NULL,
  `USERDATA_COURSE_NAME_3` varchar(100) default NULL,
  `USERDATA_COURSE_YEAR_3` date default NULL,
  `USERDATA_COURSE_NAME_4` varchar(100) default NULL,
  `USERDATA_COURSE_YEAR_4` date default NULL,
  `USERDATA_COURSE_NAME_5` varchar(100) default NULL,
  `USERDATA_COURSE_YEAR_5` date default NULL,
  `USERDATA_EDUCATION_NAME_1` varchar(100) default NULL,
  `USERDATA_EDUCATION_YEAR_1` date default NULL,
  `USERDATA_EDUCATION_NAME_2` varchar(100) default NULL,
  `USERDATA_EDUCATION_YEAR_2` date default NULL,
  `USERDATA_EDUCATION_NAME_3` varchar(100) default NULL,
  `USERDATA_EDUCATION_YEAR_3` date default NULL,
  `USERDATA_EDUCATION_NAME_4` varchar(100) default NULL,
  `USERDATA_EDUCATION_YEAR_4` date default NULL,
  `USERDATA_EDUCATION_NAME_5` varchar(100) default NULL,
  `USERDATA_EDUCATION_YEAR_5` date default NULL,
  `USERDATA_BANK_OWNER` varchar(200) default NULL,
  `USERDATA_BANK_KTONR` varchar(15) default NULL,
  `USERDATA_BANK_BLZ` varchar(15) default NULL,
  `USERDATA_BANK_NAME` varchar(150) default NULL,
  `USERDATA_NOTES` text,
  `USERDATA_RAW` int(11) NOT NULL default '0',
  `USERDATA_INCOMPLETE` smallint(6) NOT NULL default '0',
  PRIMARY KEY  (`USERDATA_ID_PK`)
) TYPE=MyISAM AUTO_INCREMENT=70 ;
# --------------------------------------------------------
DROP TABLE IF EXISTS `T_PROB_USERDATA_seq`;
CREATE TABLE `T_PROB_USERDATA_seq` (
  `id` int(10) unsigned NOT NULL auto_increment,
  PRIMARY KEY  (`id`)
) TYPE=MyISAM AUTO_INCREMENT=70 ;

INSERT INTO `T_PROB_USERDATA_seq` (`id`) VALUES (1);
# --------------------------------------------------------
DROP TABLE IF EXISTS `T_PROB_USERMASK`;
CREATE TABLE `T_PROB_USERMASK` (
  `USERMASK_ID_PK` int(11) NOT NULL default '0',
  `USERMASK_BANK` smallint(6) NOT NULL default '1',
  `USERMASK_SCHOOL` smallint(6) default '1',
  `USERMASK_EDUCATION` smallint(6) default '1',
  `USERMASK_COURSE` smallint(6) default '1',
  `USERMASK_NAME` varchar(255) NOT NULL default '',
  `USERMASK_AUTHOR_ID` int(11) NOT NULL default '0',
  `USERMASK_AUTHOR` varchar(150) NOT NULL default '',
  `USERMASK_TIMESTAMP` varchar(100) NOT NULL default '',
  `USERMASK_DESCRIPTION` varchar(250) NOT NULL default '',
  `USERMASK_DELETED` smallint(6) NOT NULL default '0',
  PRIMARY KEY  (`USERMASK_ID_PK`)
) TYPE=MyISAM;
# --------------------------------------------------------
DROP TABLE IF EXISTS `T_PROB_USERMASK_seq`;
CREATE TABLE `T_PROB_USERMASK_seq` (
  `id` int(10) unsigned NOT NULL auto_increment,
  PRIMARY KEY  (`id`)
) TYPE=MyISAM AUTO_INCREMENT=1 ;

INSERT INTO `T_PROB_USERMASK_seq` (`id`) VALUES (1);
# --------------------------------------------------------
DROP TABLE IF EXISTS `T_PROB_USER_TO_GROUP`;
CREATE TABLE `T_PROB_USER_TO_GROUP` (
  `USER_TO_GROUP_ID_PK` int(11) NOT NULL auto_increment,
  `USER_ID_FK` int(11) NOT NULL default '0',
  `GROUP_ID_FK` int(11) NOT NULL default '0',
  PRIMARY KEY  (`USER_TO_GROUP_ID_PK`)
) TYPE=MyISAM AUTO_INCREMENT=1 ;
# --------------------------------------------------------
DROP TABLE IF EXISTS `T_TESTGROUP_CGROUP_TO_UGROUP`;
CREATE TABLE `T_TESTGROUP_CGROUP_TO_UGROUP` (
  `CGROUP_TO_UGROUP_ID_PK` int(11) NOT NULL auto_increment,
  `CGROUP_TO_UGROUP_UGROUP_ID_FK` int(11) NOT NULL default '0',
  `CGROUP_TO_UGROUP_CGROUP_ID_FK` int(11) NOT NULL default '0',
  PRIMARY KEY  (`CGROUP_TO_UGROUP_ID_PK`)
) TYPE=MyISAM AUTO_INCREMENT=1 ;
# --------------------------------------------------------
DROP TABLE IF EXISTS `T_TESTGROUP_CONTENTGROUP`;
CREATE TABLE `T_TESTGROUP_CONTENTGROUP` (
  `CONTENTGROUP_ID_PK` int(11) NOT NULL default '0',
  `CONTENTGROUP_TMPL_ID_FK` int(11) default NULL,
  `CONTENTGROUP_CSS_ID_FK` int(11) NOT NULL default '0',
  `CONTENTGROUP_USERMASK_ID_FK` int(11) default NULL,
  `CONTENTGROUP_NAME` varchar(100) NOT NULL default '',
  `CONTENTGROUP_CREATED` datetime NOT NULL default '0000-00-00 00:00:00',
  `CONTENTGROUP_CREATOR` varchar(200) NOT NULL default '',
  `CONTENTGROUP_DESCRIPTION` text,
  `CONTENTGROUP_OUTPUT_DIR` varchar(250) NOT NULL default '',
  `CONTENTGROUP_SPLASH` smallint(6) NOT NULL default '0',
  `CONTENTGROUP_ACTIVE` smallint(6) NOT NULL default '0',
  `CONTENTGROUP_REG_TEXT_HEAD` varchar(100) default NULL,
  `CONTENTGROUP_REG_TEXT_BEGIN` text,
  `CONTENTGROUP_REG_TEXT_MESSAGE` text,
  `CONTENTGROUP_REG2_TEXT_HEAD` varchar(100) default NULL,
  `CONTENTGROUP_REG2_TEXT_BEGIN` text,
  `CONTENTGROUP_REG2_TEXT_MESSAGE` text,
  `CONTENTGROUP_OVERVIEW_HEADLINE` varchar(100) default NULL,
  `CONTENTGROUP_OVERVIEW_TEXT` text,
  `CONTENTGROUP_LOGIN_MSG_HEAD` text NOT NULL,
  `CONTENTGROUP_LOGIN_MSG_MESSAGE` text,
  `CONTENTGROUP_LOGIN_MSG_BACK` text NOT NULL,
  `CONTENTGROUP_LOGIN_MSG_EMAIL` text NOT NULL,
  `CONTENTGROUP_LOGIN_MSG_PW` text NOT NULL,
  `CONTENTGROUP_LOGIN_MSG_REGISTER` text,
  `CONTENTGROUP_SPLASH_HEAD` text,
  `CONTENTGROUP_SPLASH_TXT` text,
  `CONTENTGROUP_SPLASH_LINK` text NOT NULL,
  `CONTENTGROUP_DEACTIVATED_TXT` text,
  `CONTENTGROUP_OVERVIEW_OVERVIEW` text NOT NULL,
  `CONTENTGROUP_OVERVIEW_LOGOUT` text NOT NULL,
  `CONTENTGROUP_OVERVIEW_PROFILE` text NOT NULL,
  `CONTENTGROUP_OVERVIEW_STATUS_1` text,
  `CONTENTGROUP_OVERVIEW_STATUS_2` text,
  `CONTENTGROUP_OVERVIEW_STATUS_3` text NOT NULL,
  `CONTENTGROUP_OVERVIEW_STATUS_4` text NOT NULL,
  `CONTENTGROUP_OVERVIEW_STATUS_5` text NOT NULL,
  `CONTENTGROUP_OVERVIEW_REPORT_1` text NOT NULL,
  `CONTENTGROUP_OVERVIEW_REPORT_2` text NOT NULL,
  `CONTENTGROUP_OVERVIEW_REPORT_3` text NOT NULL,
  `CONTENTGROUP_OVERVIEW_REPORT_4` text NOT NULL,
  `CONTENTGROUP_OVERVIEW_LNK_1` text NOT NULL,
  `CONTENTGROUP_OVERVIEW_LNK_2` text NOT NULL,
  `CONTENTGROUP_OVERVIEW_TESTS_FREE` text NOT NULL,
  `CONTENTGROUP_FORM_JS_ALERT` text NOT NULL,
  `CONTENTGROUP_FORM_JS_CONFIRM_1` text NOT NULL,
  `CONTENTGROUP_FORM_JS_CONFIRM_2` text NOT NULL,
  `CONTENTGROUP_FORM_LEGEND_REG` text NOT NULL,
  `CONTENTGROUP_FORM_LEGEND` text NOT NULL,
  `CONTENTGROUP_FORM_LEGEND_ADR` text NOT NULL,
  `CONTENTGROUP_FORM_LEGEND_BANK` text NOT NULL,
  `CONTENTGROUP_FORM_LEGEND_SCHOOL` text NOT NULL,
  `CONTENTGROUP_FORM_LEGEND_EDU` text NOT NULL,
  `CONTENTGROUP_FORM_LEGEND_COURSE` text NOT NULL,
  `CONTENTGROUP_FORM_LABEL_PASSWORDNOTICE` text NOT NULL,
  `CONTENTGROUP_FORM_LABEL_FIRSTNAME` text NOT NULL,
  `CONTENTGROUP_FORM_LABEL_LASTNAME` text NOT NULL,
  `CONTENTGROUP_FORM_LABEL_GEBDAT` text NOT NULL,
  `CONTENTGROUP_FORM_LABEL_SEX` text NOT NULL,
  `CONTENTGROUP_FORM_LABEL_NATION` text NOT NULL,
  `CONTENTGROUP_FORM_LABEL_STREET` text NOT NULL,
  `CONTENTGROUP_FORM_LABEL_POSTALCODE` text NOT NULL,
  `CONTENTGROUP_FORM_LABEL_CITY` text NOT NULL,
  `CONTENTGROUP_FORM_LABEL_PHONE` text NOT NULL,
  `CONTENTGROUP_FORM_LABEL_EMAIL` text NOT NULL,
  `CONTENTGROUP_FORM_LABEL_PASSWORD` text NOT NULL,
  `CONTENTGROUP_BANK_OWNER_LABEL` text NOT NULL,
  `CONTENTGROUP_BANK_NAME_LABEL` text NOT NULL,
  `CONTENTGROUP_BANK_BLZ_LABEL` text NOT NULL,
  `CONTENTGROUP_BANK_KTONR_LABEL` text NOT NULL,
  `CONTENTGROUP_FORM_DEGREE` text NOT NULL,
  `CONTENTGROUP_FORM_DEGREE_DATE` text NOT NULL,
  `CONTENTGROUP_FORM_CHOOSE` text NOT NULL,
  `CONTENTGROUP_FORM_CHOOSE_SELF` text NOT NULL,
  `CONTENTGROUP_FORM_DESC` text NOT NULL,
  `CONTENTGROUP_FORM_DATE` text NOT NULL,
  `CONTENTGROUP_FORM_POSDEL` text NOT NULL,
  `CONTENTGROUP_FORM_EDU_MSG1` text NOT NULL,
  `CONTENTGROUP_FORM_EDU_MSG2` text NOT NULL,
  `CONTENTGROUP_FORM_EDU_MSG3` text NOT NULL,
  `CONTENTGROUP_FORM_COURSE_MSG1` text NOT NULL,
  `CONTENTGROUP_FORM_COURSE_MSG2` text NOT NULL,
  `CONTENTGROUP_FORM_COURSE_MSG3` text NOT NULL,
  `CONTENTGROUP_FORM_SUBMIT` text NOT NULL,
  `CONTENTGROUP_FORM_SEX_M` text NOT NULL,
  `CONTENTGROUP_FORM_SEX_W` text NOT NULL,
  `CONTENTGROUP_THANKS_MSG_HEAD` text NOT NULL,
  `CONTENTGROUP_REG2_TEXT_EDIT` text,
  `CONTENTGROUP_SUCCESS_BACK` text NOT NULL,
  PRIMARY KEY  (`CONTENTGROUP_ID_PK`)
) TYPE=MyISAM;
# --------------------------------------------------------
DROP TABLE IF EXISTS `T_TESTGROUP_CONTENTGROUP_seq`;
CREATE TABLE `T_TESTGROUP_CONTENTGROUP_seq` (
  `id` int(10) unsigned NOT NULL auto_increment,
  PRIMARY KEY  (`id`)
) TYPE=MyISAM AUTO_INCREMENT=1 ;

INSERT INTO `T_TESTGROUP_CONTENTGROUP_seq` (`id`) VALUES (1);
# --------------------------------------------------------
DROP TABLE IF EXISTS `T_TESTGROUP_CONTENT_TO_CGROUP`;
CREATE TABLE `T_TESTGROUP_CONTENT_TO_CGROUP` (
  `CONTENT_TO_CGROUP_ID_PK` int(11) NOT NULL auto_increment,
  `CONTENT_TO_CGROUP_CONTENT_ID_FK` int(11) NOT NULL default '0',
  `CONTENT_TO_CGROUP_CGROUP_ID_FK` int(11) NOT NULL default '0',
  PRIMARY KEY  (`CONTENT_TO_CGROUP_ID_PK`)
) TYPE=MyISAM AUTO_INCREMENT=332 ;
# --------------------------------------------------------
DROP TABLE IF EXISTS `T_TESTGROUP_CSSSTYLE`;
CREATE TABLE `T_TESTGROUP_CSSSTYLE` (
  `CSSSTYLE_ID_PK` int(11) NOT NULL default '0',
  `CSSSTYLE_FONTTYPE` varchar(20) default 'arial',
  `CSSSTYLE_FONTSIZE` int(11) default '16',
  `CSSSTYLE_FONTCOLOR` varchar(6) default '000000',
  `CSSSTYLE_FONTCOLORHEADER` varchar(6) default '000000',
  `CSSSTYLE_BGFORM` varchar(6) default 'ffffff',
  `CSSSTYLE_BGHEADER` varchar(6) default 'cccccc',
  `CSSSTYLE_HEADERHEIGHT` int(11) default '50',
  `CSSSTYLE_BGINPUT` varchar(6) default 'ffffff',
  `CSSSTYLE_FIELDWIDTH` int(11) default '20',
  `CSSSTYLE_AREAHEIGHT` int(11) default '200',
  `CSSSTYLE_LINECOLOR` varchar(6) default 'cccccc',
  `CSSSTYLE_REQUIREDCOLOR` varchar(6) default 'ff0000',
  `CSSSTYLE_NUMERICCOLOR` varchar(6) default '0000ff',
  PRIMARY KEY  (`CSSSTYLE_ID_PK`)
) TYPE=MyISAM;

INSERT INTO `T_TESTGROUP_CSSSTYLE` (`CSSSTYLE_ID_PK`, `CSSSTYLE_FONTTYPE`, `CSSSTYLE_FONTSIZE`, `CSSSTYLE_FONTCOLOR`, `CSSSTYLE_FONTCOLORHEADER`, `CSSSTYLE_BGFORM`, `CSSSTYLE_BGHEADER`, `CSSSTYLE_HEADERHEIGHT`, `CSSSTYLE_BGINPUT`, `CSSSTYLE_FIELDWIDTH`, `CSSSTYLE_AREAHEIGHT`, `CSSSTYLE_LINECOLOR`, `CSSSTYLE_REQUIREDCOLOR`, `CSSSTYLE_NUMERICCOLOR`) VALUES (0, 'verdana', 16, 'ffffff', '000000', 'ffffff', 'cccccc', 50, 'ffffff', 250, 200, 'cccccc', 'ff0000', '0000ff');
# --------------------------------------------------------
DROP TABLE IF EXISTS `T_TESTGROUP_CSSSTYLE_seq`;
CREATE TABLE `T_TESTGROUP_CSSSTYLE_seq` (
  `id` int(10) unsigned NOT NULL auto_increment,
  PRIMARY KEY  (`id`)
) TYPE=MyISAM AUTO_INCREMENT=1 ;

INSERT INTO `T_TESTGROUP_CSSSTYLE_seq` (`id`) VALUES (1);
# --------------------------------------------------------
DROP TABLE IF EXISTS `T_TESTGROUP_MAILS`;
CREATE TABLE `T_TESTGROUP_MAILS` (
  `TESTGROUP_MAIL_ID_PK` int(11) NOT NULL default '0',
  `TESTGROUP_SUBJECT` text NOT NULL,
  `TESTGROUP_SENDER` text NOT NULL,
  `TESTGROUP_BODY` text NOT NULL,
  `TESTGROUP_TESTGROUP_ID_FK` int(11) NOT NULL default '0',
  `TESTGROUP_SENDED_DATE` datetime NOT NULL default '0000-00-00 00:00:00',
  PRIMARY KEY  (`TESTGROUP_MAIL_ID_PK`)
) TYPE=MyISAM;
# --------------------------------------------------------
DROP TABLE IF EXISTS `T_TESTGROUP_MAILS_seq`;
CREATE TABLE `T_TESTGROUP_MAILS_seq` (
  `id` int(10) unsigned NOT NULL auto_increment,
  PRIMARY KEY  (`id`)
) TYPE=MyISAM AUTO_INCREMENT=1 ;

INSERT INTO `T_TESTGROUP_MAILS_seq` (`id`) VALUES (1);
# --------------------------------------------------------
DROP TABLE IF EXISTS `T_TESTGROUP_MAIL_RECIPIENTS`;
CREATE TABLE `T_TESTGROUP_MAIL_RECIPIENTS` (
  `MAIL_RECIPIENTS_ID_PK` int(11) NOT NULL auto_increment,
  `MAIL_ID_FK` int(11) NOT NULL default '0',
  `MAIL_ADDRESS` text NOT NULL,
  PRIMARY KEY  (`MAIL_RECIPIENTS_ID_PK`)
) TYPE=MyISAM AUTO_INCREMENT=1 ;
# --------------------------------------------------------
DROP TABLE IF EXISTS `T_TESTGROUP_TEMPLATE_CATEGORY`;
CREATE TABLE `T_TESTGROUP_TEMPLATE_CATEGORY` (
  `CATEGORY_ID_PK` int(11) NOT NULL default '0',
  `CATEGORY_NAME` varchar(100) default NULL,
  `CATEGORY_PARENT_ID` int(11) default NULL,
  `CATEGORY_TIME` datetime default NULL,
  PRIMARY KEY  (`CATEGORY_ID_PK`)
) TYPE=MyISAM;
# --------------------------------------------------------
DROP TABLE IF EXISTS `T_TESTGROUP_TEMPLATE_CATEGORY_seq`;
CREATE TABLE `T_TESTGROUP_TEMPLATE_CATEGORY_seq` (
  `id` int(10) unsigned NOT NULL auto_increment,
  PRIMARY KEY  (`id`)
) TYPE=MyISAM AUTO_INCREMENT=1 ;

INSERT INTO `T_TESTGROUP_TEMPLATE_CATEGORY_seq` (`id`) VALUES (1);
# --------------------------------------------------------
DROP TABLE IF EXISTS `T_TESTGROUP_TEMPLATE_CONTENT`;
CREATE TABLE `T_TESTGROUP_TEMPLATE_CONTENT` (
  `CONTENT_ID_PK` int(11) NOT NULL default '0',
  `CONTENT_CATEGORY_ID_FK` int(11) NOT NULL default '0',
  `CONTENT_NAME` varchar(100) default NULL,
  `CONTENT_FILENAME` varchar(100) default NULL,
  `CONTENT_ENDING` varchar(10) default NULL,
  `CONTENT_SIZE` int(11) default NULL,
  `CONTENT_TIME` datetime default NULL,
  PRIMARY KEY  (`CONTENT_ID_PK`)
) TYPE=MyISAM;
# --------------------------------------------------------
DROP TABLE IF EXISTS `T_TESTGROUP_TEMPLATE_CONTENT_seq`;
CREATE TABLE `T_TESTGROUP_TEMPLATE_CONTENT_seq` (
  `id` int(10) unsigned NOT NULL auto_increment,
  PRIMARY KEY  (`id`)
) TYPE=MyISAM AUTO_INCREMENT=1 ;

INSERT INTO `T_TESTGROUP_TEMPLATE_CONTENT_seq` (`id`) VALUES (1);
# --------------------------------------------------------
DROP TABLE IF EXISTS `T_TESTGROUP_TMPL_TO_ASSESSMENT`;
CREATE TABLE `T_TESTGROUP_TMPL_TO_ASSESSMENT` (
  `TMPL_TO_ASSESSMENT_ID_PK` int(11) NOT NULL default '0',
  `TMPL_TO_ASSESSMENT_TESTGROUP_ID_FK` int(11) default NULL,
  `TMPL_TO_ASSESSMENT_SPLASH_ID` int(11) default NULL,
  `TMPL_TO_ASSESSMENT_LOGIN_ID` int(11) default NULL,
  `TMPL_TO_ASSESSMENT_OVERVIEW_ID` int(11) default NULL,
  `TMPL_TO_ASSESSMENT_REPORTING_ID` int(11) default NULL,
  `TMPL_TO_ASSESSMENT_DEACTIVATED_ID` int(11) default NULL,
  `TMPL_TO_ASSESSMENT_REGISTER_ID` int(11) default NULL,
  PRIMARY KEY  (`TMPL_TO_ASSESSMENT_ID_PK`)
) TYPE=MyISAM;
# --------------------------------------------------------
DROP TABLE IF EXISTS `T_TESTGROUP_TMPL_TO_ASSESSMENT_seq`;
CREATE TABLE `T_TESTGROUP_TMPL_TO_ASSESSMENT_seq` (
  `id` int(10) unsigned NOT NULL auto_increment,
  PRIMARY KEY  (`id`)
) TYPE=MyISAM AUTO_INCREMENT=1 ;

INSERT INTO `T_TESTGROUP_TMPL_TO_ASSESSMENT_seq` (`id`) VALUES (1);

#
# Table structure for table `T_SURVEY_TMPL_TO_PRJCT`
#
# -------------------------------------------------------
DROP TABLE IF EXISTS `T_SURVEY_TMPL_TO_PRJCT`;
CREATE TABLE `T_SURVEY_TMPL_TO_PRJCT` (
  `TMPL_TO_PRJCT_ID_PK` int(11) NOT NULL default '0',
  `TMPL_TO_PRJCT_PROJECT_ID` int(11) default NULL,
  `TMPL_TO_PRJCT_FORM_ID` int(11) default NULL,
  `TMPL_TO_PRJCT_LOGIN_ID` int(11) default NULL,
  `TMPL_TO_PRJCT_CONFIRM_ID` int(11) default NULL,
  `TMPL_TO_PRJCT_DEACTIVATED_ID` int(11) default NULL,
  PRIMARY KEY  (`TMPL_TO_PRJCT_ID_PK`)
) TYPE=MyISAM;
# --------------------------------------------------------

#
# Table structure for table `T_SURVEY_TMPL_TO_PRJCT_seq`
#

DROP TABLE IF EXISTS `T_SURVEY_TMPL_TO_PRJCT_seq`;
CREATE TABLE `T_SURVEY_TMPL_TO_PRJCT_seq` (
  `id` int(10) unsigned NOT NULL auto_increment,
  PRIMARY KEY  (`id`)
) TYPE=MyISAM AUTO_INCREMENT=1 ;
# --------------------------------------------------------
