<?php 
// +----------------------------------------------------------------------+
// | sm survey module - output start page                                 |
// +----------------------------------------------------------------------+
// | Copyright (c) 2002 serie a - Digitale Medien und Systeme GmbH        |
// +----------------------------------------------------------------------+
// | Authors: J?rn Allert <allert@serie-a.de>                             |
// |          Rene Renk <renk@serie-a.de>                                 |
// +----------------------------------------------------------------------+
//
// $Id: default.login.php,v 1.1.1.1 2004/07/15 13:36:52 opensurveypilot Exp $

//session_start
@session_start();

// read xml file
$filename = "survey.xml";
$fd = fopen ($filename, "r");
$contents = fread ($fd, filesize ($filename));
fclose ($fd);

preg_match("/(<lang>)(.*)(<\/lang>)/i", $contents, $matches);
$surveylang = $matches[2];

preg_match("/(<id>)(.*)(<\/id>)/i", $contents, $matches);
$projectId = $matches[2];

// require all configuration files and libraries
require_once("./../../administration/config/config.inc.php"); // common config file
require_once($cfgPathToConf."/file.inc.php"); // project files
require_once($cfgPathToSurveyFiles."/config/survey.config.inc.php"); // auth config file
require_once($cfgPathToSurveyFiles."/lib/security/security.inc.php"); // security functions
require_once($cfgPathToSurveyConfig."/survey.file.inc.php"); // modules files
require_once($cfgPathToSurveyLib."/".$fileSrvyQuickformfunctions); // modules files
require_once("./../../administration/config/lang/".$surveylang.".script.inc.php");

// login check
if ($_SESSION["surveySessionId"] != session_id())
{
    ?>
    <html><body>
    <script type="text/javascript">
    window.location.href="index.php";
    </script>
    <?php
    exit;
}

// check if form was submitted
if($_SERVER["REQUEST_METHOD"] == "POST")
{
    // get email and tan
    $email = $_POST["login"];
    $tan = $_POST["tan"];
    $projectId = $_SESSION["projectId"];
    
    //create new security object
    $security = &new securityFunctions;
    
    // set project id
    $security->setProjectId($projectId);
    
    // set tan table name
    $security->setTanTableName();
    
    // check if tan is in db
    if($security->checkTan($tan))
    {
        // insert tan user in db and set tan_used to yes
        $security->updateTan($tan, $email);
        
		// give tan to session as determination value
		$_SESSION["tanAsDeterminationValue"] = $tan;
		
        // set login cookie
        $cookieParams["projectId"] = $projectId;
        $cookieParams["surveySessionId"] = session_id();
        $cookieParams["securityMethod"] = "tan";
        $security->writeCookie($cookieParams);
        
        // redirect to form
        if(!$security->errorMessage)
        {
            ?>
            <html><body>
            <script type="text/javascript">
            window.location.href="form.php";
            </script>
            <?php
            exit;
        }
    }
    else
    {
        ?>
        <script type="text/javascript">
        var errors= "Ung?ltiger TAN";
        </script>
        <?php
    }
}
else
{
    ?>
    <script type="text/javascript">
    var errors= "";
    </script>
    <?php
}
?>
<!DOCTYPE HTML PUBLIC "-//W3C//DTD HTML 4.0 Transitional//EN">

<html>

<head>

<title><?php echo $cfgApplicationType.$cfgApplicationVersion?></title>

<meta http-equiv="content-type" content="text/php; charset=ISO-8859-1">
<meta http-equiv="content-script-type" content="text/javascript">
<meta http-equiv="content-style-type" content="text/css">
<meta name="description" content="">
<meta name="keywords" content="">
<meta http-equiv="expires" content="0">
<meta http-equiv="pragma" content="no-cache">
<meta http-equiv="cache-control" content="no-cache">

<link rel="stylesheet" type="text/css" href="./basic.css">
<script language="JavaScript" src="./../form.common.js"></script>

</head>

<body marginwidth="0" marginheight="0" leftmargin="0" topmargin="0" class="basic" onLoad="javascript:formOnLoadFunctions('login', '<?php echo $javaScriptOnLoadArray?>');">

<div align="center">

<!-- BORDER TABLE --> 

<table border="0" cellpadding="0" cellspacing="0" width="100%" height="100%">

<tr>
<td height="100%" align="center" valign="middle" width="40%">

	<!-- LOGIN -->
	
	<table width="400" cellspacing="0" cellpadding="0" border="2">

	<tr>
	<td align="center" class="basic">
    
        <table cellspacing="0" cellpadding="0" border="0" width="396" height="67">
     
		<tr>
	    <td class="head"><img src="../../administration/media/images/common/loginteaser.jpg" width="396" height="67" border="0" alt=""><br>&nbsp;</td>			       
		</tr>
		
		</table>
		
		<table width="90%" border="0" cellpadding="0" cellspacing="0">

		<tr>
		<td valign="top" align="center" class="csslogin">
        
		<form method="post" name="form" action="login.php">
        
		<fieldset><legend>Login</legend>
		
		<table cellspacing="0" cellpadding="5" border="0" width="100%" height="150">
		
		<tr> 
		<td colspan="4">&nbsp;</td>			       
		</tr> 
        
        <tr> 
	    <td colspan="2" class="csslogin"><span style="color:red;"><script type="text/javascript">this.document.write(errors)</script></span></td>
	    </tr>
		
		<tr> 
		<td colspan="4">&nbsp;</td>			       
		</tr> 
	        
		<tr>
	    <td width="35%" class="csslogin">&nbsp;E-mail</td>
		<td class="basic"><input size="15" name="login"></td>
	    </tr>
	    
		<tr>
	    <td width="35%" class="csslogin">&nbsp;Tan</td>	
	    <td class="basic"><input type="password" size="15" name="tan"></td>
	    </tr>
		
		<tr>
	    <td colspan="2" align="right" class="basic"><input type="submit" class="button" width="100" value="Login" name="Login" id="Login"></td>
	    </tr>
    
		</table>
		
		</fieldset>
		
        </form>
        
		</td>
		</tr>
		
		<tr>
		<td>&nbsp;</td>
		</tr>
		
		</table>

</td>
</tr>

</table>

	<!-- / END LOGIN -->

</td>
</tr>

</table>

<!-- / END BORDER TABLE -->

</div>

</body>

</html>
